#include "StdAfx.h"
#include ".\charvector.h"
#include "DIACharacter.h"

CCharVector::CCharVector(void)
{
	m_CharName = '0';
	m_CharType = 0;
	m_VMax = 0;
	m_HMax = 0;
	m_Width = 0;
	m_Height = 0;
	m_AspectRatio = 0.0;
	//m_VCrossing = 0;
	//m_HCrossing = 0;
//	m_ReducedImage = new int*;
	m_ReducedImage = NULL;
	m_ReducedImageSize = 0;
	m_NoComponents = 0;
	m_NoHoles = 0;
	m_isCapital = false;
	for (int i = 0; i < 25; i++)
	{
		m_Divisions[i] = 0;
	}
//	m_Divisions = new int[5];

	//m_CharImage = new CImage;
	m_CharImage = NULL;
	m_HMaxDistance = 0;
	m_VMaxDistance = 0;
}

CCharVector::CCharVector(CCharVector &Vector)
{
	
	m_CharName = Vector.GetCharName();
	m_CharType = Vector.GetCharType();
	m_VMax = Vector.GetVMax();
	m_HMax = Vector.GetHMax();
	m_Width = Vector.GetWidth();
	m_Height = Vector.GetHeight();
	m_AspectRatio = Vector.GetAspectRatio();
	m_CrossingsIndexV = Vector.GetNoCrossingV();
    m_CrossingsIndexH = Vector.GetNoCrossingH();
	//m_ReducedImage;
	m_ReducedImageSize = Vector.GetReducedImageSize();
	m_NoComponents = Vector.GetNoComponents();
	m_NoHoles = Vector.GetNoHoles();
	m_CharImage = new CImage;
	m_CharImage->CreateFromImage(Vector.GetCharImage());
	m_Weight = Vector.GetWeight();
	for (int i = 0; i < 25; i++)
	{
		m_Divisions[i] = Vector.GetDivision(i);
	}
	
	m_CrossingsV = Vector.m_CrossingsV; 
	m_CrossingsH = Vector.m_CrossingsH;
	m_isCapital = Vector.GetCapital();
	m_HMaxDistance = Vector.GetHMaxDistance();
	m_VMaxDistance = Vector.GetVMaxDistance();
}
CCharVector & CCharVector::operator =(CCharVector &Vector)
{
	m_CharName = Vector.GetCharName();
	m_CharType = Vector.GetCharType();
	m_VMax = Vector.GetVMax();
	m_HMax = Vector.GetHMax();
	m_Width = Vector.GetWidth();
	m_Height = Vector.GetHeight();
	m_AspectRatio = Vector.GetAspectRatio();
	m_CrossingsIndexV = Vector.GetNoCrossingV();
    m_CrossingsIndexH = Vector.GetNoCrossingH();
	//m_ReducedImage;
	m_ReducedImageSize = Vector.GetReducedImageSize();
	m_NoComponents = Vector.GetNoComponents();
	m_NoHoles = Vector.GetNoHoles();
	//m_CharImage = new CImage;
//	m_CharImage->CreateFromImage(Vector.GetCharImage());
	m_Weight = Vector.GetWeight();
	for (int i = 0; i < 25; i++)
	{
		m_Divisions[i] = Vector.GetDivision(i);
	}
	
	m_CrossingsV = Vector.m_CrossingsV; 
	m_CrossingsH = Vector.m_CrossingsH;
	m_isCapital = Vector.GetCapital();
	m_HMaxDistance = Vector.GetHMaxDistance();
	m_VMaxDistance = Vector.GetVMaxDistance();
	return *this;
}
CCharVector::~CCharVector(void)
{

	//delete m_ReducedImage;
	//m_ReducedImage = NULL;
	
	delete m_CharImage;
	m_CharImage = NULL;
	//delete m_Divisions;
}


//accessors // Set & Get
void CCharVector::SetHMaxDistance(int distance)
{
	m_HMaxDistance = distance;

}
int CCharVector::GetHMaxDistance()
{
	return m_HMaxDistance;

}
void CCharVector::SetVMaxDistance(int distance)
{
	m_VMaxDistance = distance;

}
int CCharVector::GetVMaxDistance()
{
	return m_VMaxDistance;

}
void CCharVector::SetCharName(char name)
{
	m_CharName = name;
	
}
void CCharVector::SetCapital(bool capital)
{
	m_isCapital = capital;
}

bool CCharVector::GetCapital()
{
	return m_isCapital;
}
char CCharVector::GetCharName()
{
	return m_CharName;
}
void CCharVector::SetCharType(int type)
{
	m_CharType = type;
}

int CCharVector::GetCharType()
{
	return m_CharType;
}
void CCharVector::SetVMax(int vmax)
{
	m_VMax = vmax;
}
int CCharVector::GetVMax()
{
	return m_VMax;
}
void CCharVector::SetHMax(int hmax)
{
	m_HMax = hmax;
}
int CCharVector::GetHMax()
{
	return m_HMax;
}
void CCharVector::SetWidth(int width)
{
	m_Width = width;
}

int CCharVector::GetWidth()
{
	return m_Width;
}
void CCharVector::SetHeight(int height)
{
	m_Height = height;
}

int CCharVector::GetHeight()
{
	return m_Height;
}
void CCharVector::SetAspectRatio(float aspRatio)
{
	m_AspectRatio = aspRatio;
}

float CCharVector::GetAspectRatio()
{
	return m_AspectRatio;
}
//void CCharVector::SetVCrossing(int vcross)
//{
//	m_VCrossing = vcross;
//}
//
//int CCharVector::GetVCrossing()
//{
//	return m_VCrossing;
//}
//void CCharVector::SetHCrossing(int hcross)
//{
//	m_HCrossing = hcross;
//}
//
//int CCharVector::GetHCrossing()
//{
//	return m_HCrossing;
//}

void CCharVector::SetReducedImageSize(CPoint size)
{
	m_ReducedImageSize = size;
}
CPoint CCharVector::GetReducedImageSize()
{
	return m_ReducedImageSize;
}
void CCharVector::SetNoComponents(int nocomp)
{
	m_NoComponents = nocomp;
}
int CCharVector::GetNoComponents()
{
	return m_NoComponents;
}
void CCharVector::SetNoHoles(int noholes)
{
	m_NoHoles = noholes;
}
int CCharVector::GetNoHoles()
{
	return m_NoHoles;
}
void CCharVector::SetReducedImage(int x,int y,int** ImageArray)
{
	if (m_ReducedImage != NULL)
	{
		m_ReducedImage = NULL;
		delete m_ReducedImage;
	}
	m_ReducedImage = new int* [x];
	for (int i = 0; i < x; i++)
	{
		m_ReducedImage[i] = new int[y];
	}
	m_ReducedImage = ImageArray;
}
int** CCharVector::GetReducedImage()
{
	return m_ReducedImage;
}
	
void CCharVector::SetDivision(int pos, int val)
{
	m_Divisions[pos] = val;
}
int CCharVector::GetDivision(int pos)
{
	return m_Divisions[pos];
}
void CCharVector::SetCharImage(CImage* charimage)
{
	if (m_CharImage == NULL)
		m_CharImage = new CImage;
	m_CharImage->CreateFromImage(charimage);
}
CImage* CCharVector::GetCharImage()
{
	return m_CharImage;
}

void CCharVector::SetWeight(int weight)
{
	m_Weight = weight;
}

int CCharVector::GetWeight()
{
	return m_Weight;
}
int CCharVector::GetNoCrossingV()
{
	return m_CrossingsIndexV;
}
void CCharVector::SetNoCrossingV(int val)
{
	m_CrossingsIndexV = val;
}
//int	CCharVector::GetCrossingsValV(int pos)
//{
//	return m_CrossingsV[pos].Crossings;
//}
//int	CCharVector::GetCrossingsPercentV(int pos)
//{
//	return m_CrossingsV[pos].NoCrossings;
//}
//void CCharVector::SetCrossingsValV(int pos, int val)
//{
//	m_CrossingsV[pos].Crossings = val;
//}
//void CCharVector::SetCrossingsPercentV(int pos, int val)
//{
//	m_CrossingsV[pos].NoCrossings = val;
//}


void CCharVector::SetCrossingsV(CROSSINGS * crossing)
{
	//m_CrossingsV = crossing;
}

//HCrossings

int CCharVector::GetNoCrossingH()
{
	return m_CrossingsIndexH;
}
void CCharVector::SetNoCrossingH(int val)
{
	m_CrossingsIndexH = val;
}
//int	CCharVector::GetCrossingsValH(int pos)
//{
////	return m_CrossingsH[pos].Crossings;
//}
//int	CCharVector::GetCrossingsPercentH(int pos)
//{
////	return m_CrossingsH[pos].NoCrossings;
//}
void CCharVector::SetCrossingsValH(int pos, int val)
{
//	m_CrossingsH[pos].Crossings = val;
}
void CCharVector::SetCrossingsPercentH(int pos, int val)
{
	//m_CrossingsH[pos].NoCrossings = val;
}


void CCharVector::SetCrossingsH(CROSSINGS * crossing)
{
//	m_CrossingsH = crossing;
}


int CCharVector::GetFeatureNumber(int number)
{
	switch (number)
	{
		case 0:
			return m_CharType;
			break;
		case 1:
			return m_VMax;
			break;
		case 2:
			return m_HMax;
			break;
		case 3:
			return m_Width;
			break;
		case 4:
			return m_Height;
			break;
		case 6:
			return m_CrossingsIndexH;
			break;
		case 7:
			return m_CrossingsIndexV;
			break;
		case 8:
			return m_Weight;
			break;
		case 11:
			return m_HMaxDistance;
			break;
		case 12:
			return m_VMaxDistance;
			break;
		default:
			return -1;
	}

}
void CCharVector::CreateVectorFromCharacter(CDIACharacter* character)
{
	m_CharName = character->m_CharName;
	m_CharType = character->m_CharFinalType;
	m_VMax = character->m_CharVMaxCount;
	m_HMax = character->m_CharHMaxCount;
	m_Width = character->m_LocatedWidth;
	m_Height = character->m_LocatedHeight;
	m_AspectRatio = (float)character->m_LocatedHeight/(float) character->m_LocatedWidth;

	//CrossingsH
	m_CrossingsIndexH = character->m_CharCrossingsIndexH;
	if (m_CrossingsIndexH > 0)
	{
		//m_CrossingsH = new CROSSINGS[m_CrossingsIndexH];
		CROSSINGS newcross;
		for (int i = 0; i < m_CrossingsIndexH; i++)
		{
			newcross.Crossings = character->m_CharCrossingsH[i].Crossings;
			newcross.NoCrossings = character->m_CharCrossingsH[i].NoCrossings;
			m_CrossingsH.push_back(newcross);
			//m_CrossingsH[i].Crossings = character->m_CharCrossingsH[i].Crossings;
			//m_CrossingsH[i].NoCrossings = character->m_CharCrossingsH[i].NoCrossings;
		}
		
	}
	//CrossingsV
	m_CrossingsIndexV = character->m_CharCrossingsIndexV;
	if (m_CrossingsIndexV > 0)
	{
	//	m_CrossingsV = new CROSSINGS[m_CrossingsIndexV];
		CROSSINGS newcross;
		for (int i = 0; i < m_CrossingsIndexV; i++)
		{
			newcross.Crossings = character->m_CharCrossingsV[i].Crossings;
			newcross.NoCrossings = character->m_CharCrossingsV[i].NoCrossings;
			m_CrossingsV.push_back(newcross);
			//m_CrossingsV[i].Crossings = character->m_CharCrossingsV[i].Crossings;
			//m_CrossingsV[i].NoCrossings = character->m_CharCrossingsV[i].NoCrossings;
		}
		
	}

	
	//
	m_NoComponents = 0;
	m_NoHoles = 0;
	m_CharImage = new CImage;
	m_CharImage->CreateFromImage(character->m_pLocatedCharImage);
	m_Weight = character->m_CharWeight;
	int pos = 0;
	for (int i = 0; i < 5; i++)
	{
		for (int j = 0; j < 5; j++)
		{
			m_Divisions[pos] = (int)character->m_CharDivisions.Normalized[i][j];
			pos++;
		}
	}
	m_HMaxDistance = character->m_VMaxDistance;
	m_VMaxDistance = character->m_HMaxDistance;
	m_isCapital = character->m_bIsCapital;
	

}
void CCharVector::CreateVectorFromVector(CCharVector &Vector)
{
	m_CharName = Vector.m_CharName;
	m_CharType = Vector.m_CharType;
	m_VMax = Vector.m_VMax;
	m_HMax = Vector.m_HMax;
	m_Width = Vector.m_Width;
	m_Height = Vector.m_Height;
	m_AspectRatio = Vector.m_AspectRatio;
	//
	m_CrossingsIndexV = Vector.m_CrossingsIndexV;
	//if (m_CrossingsIndexV > 0)
	//{
	//	CROSSINGS newcross;
	//	for (int i = 0; i < m_CrossingsIndexV; i++)
	//	{
	//		newcross.Crossings = Vector.m_CrossingsV[i].Crossings;
	//		newcross.NoCrossings = Vector.m_CrossingsV[i].NoCrossings;
	//		m_CrossingsV.push_back(newcross);
	//		//m_CrossingsV[i].Crossings = character->m_CharCrossingsV[i].Crossings;
	//		//m_CrossingsV[i].NoCrossings = character->m_CharCrossingsV[i].NoCrossings;
	//	}
	//	/*m_CrossingsV = new CROSSINGS[m_CrossingsIndexV];
	//	for (int i = 0; i < m_CrossingsIndexV; i++)
	//	{
	//		m_CrossingsV[i].Crossings = Vector.m_CrossingsV[i].Crossings;
	//		m_CrossingsV[i].NoCrossings = Vector.m_CrossingsV[i].NoCrossings;
	//	}*/
	//}
	m_CrossingsIndexH = Vector.m_CrossingsIndexH;
	//if (m_CrossingsIndexH > 0)
	//{
	//	CROSSINGS newcross;
	//	for (int i = 0; i < m_CrossingsIndexH; i++)
	//	{
	//		newcross.Crossings = Vector.m_CrossingsH[i].Crossings;
	//		newcross.NoCrossings = Vector.m_CrossingsH[i].NoCrossings;
	//		m_CrossingsH.push_back(newcross);
	//		//m_CrossingsH[i].Crossings = character->m_CharCrossingsH[i].Crossings;
	//		//m_CrossingsH[i].NoCrossings = character->m_CharCrossingsH[i].NoCrossings;
	//	}
	//	//m_CrossingsH = new CROSSINGS[m_CrossingsIndexH];
	//	/*for (int i = 0; i < m_CrossingsIndexV; i++)
	//	{
	//		m_CrossingsH[i].Crossings = Vector.m_CrossingsH[i].Crossings;
	//		m_CrossingsH[i].NoCrossings = Vector.m_CrossingsH[i].NoCrossings;
	//	}*/
	//}
	//

	m_ReducedImage = Vector.m_ReducedImage;
	m_ReducedImageSize = Vector.m_ReducedImageSize;
	m_NoComponents = Vector.m_NoComponents;
	m_NoHoles = Vector.m_NoHoles;
	
	m_CharImage = new CImage;
	m_CharImage->CreateFromImage(Vector.m_CharImage);
	m_Weight = Vector.m_Weight;
	for (int i = 0; i < 25; i++)
	{
		m_Divisions[i] = Vector.m_Divisions[i];
	}
	m_HMaxDistance = Vector.GetHMaxDistance();
	m_VMaxDistance = Vector.GetVMaxDistance();
}
CCharVector* CCharVector::CompareVectors(CCharVector* TestVector)
{
	//this fucntion will take two vectors and compare their values
	//returning a result vector
	CCharVector* ResultVector = new CCharVector;
	
	
	//compare types
	ResultVector->SetCharType(abs(m_CharType-TestVector->GetCharType()));
	//compare VMax
	ResultVector->SetVMax(abs(m_VMax-TestVector->GetVMax()));
	//compare HMax
	ResultVector->SetHMax(abs(m_HMax-TestVector->GetHMax()));
	//compare AspectRatio
//	ResultVector->SetAspectRatio(abs(m_AspectRatio-TestVector->GetAspectRatio()));
	//compare Width
	ResultVector->SetWidth(CompareWidth(m_Width,TestVector->GetWidth()));
	//compare Height
	ResultVector->SetHeight(CompareHeight(m_Height,TestVector->GetHeight()));
	//compare VCrossings
//	ResultVector->SetVCrossing(abs(m_VCrossing-TestVector->GetVCrossing()));
	//compare HCrossings
//	ResultVector->SetHCrossing(abs(m_HCrossing-TestVector->GetHCrossing()));
	//compare NoComponents
//	ResultVector->SetNoComponents(abs(m_NoComponents-TestVector->GetNoComponents()));
	//compare NoHoles
//	ResultVector->SetNoHoles(abs(m_NoHoles-TestVector->GetNoComponents()));

	return ResultVector;
}

int CCharVector::CompareWidth(int perfectWidth, int testWidth)
{
	return abs(perfectWidth-testWidth);
}
int CCharVector::CompareHeight(int perfectHeight, int testHeight)
{
	return abs(perfectHeight-testHeight);
}
int* CCharVector::CompareImageInVectorBlind(CImage* image)
{
	//given an image from another vector compare the images
	//cost = square differences /
	//given the vector overly the given image
	//int y_diff, x_diff;
	CRect rect;
	CPoint centre1;
	CPoint centre2;
	centre2.x = image->GetWidth()/2;
	centre2.y = image->GetHeight()/2;
	centre1.x = m_Width/2;
	centre1.y = m_Height/2;
	int* costs;
	//costs = new int*;
	int costIndex = 0;
	int sizeOfSearch = 10;
	const int sizeOfArray = ((centre1.x + sizeOfSearch) - (centre1.x - sizeOfSearch)+1) * ((centre1.y + sizeOfSearch) - (centre1.y - sizeOfSearch)+1);
	costs = new int[sizeOfArray];
	
	
	for (int i = centre1.x - sizeOfSearch; i < centre1.x + sizeOfSearch; i++)
	{
		for (int j = centre1.y - sizeOfSearch; j < centre1.y + sizeOfSearch; j++)
		{
			
		
			//costs = new int;
			CPoint point(i,j);
			costs[costIndex] = CompareSSDImages(m_CharImage,image,point,centre2);
			costIndex++;

		}

	}
	return costs;
	//for (int i = 0; i 
	//if ((image->GetWidth() < m_Width)&& (image->GetHeight() < m_Height))
	//{
	//	x_diff = m_Widht - image->GetWidth();
	//	y_diff = m_Height - image->GetHeight();

	//	for (int i = 0; i < x_diff; i++)
	//	{
	//		for (int j = 0; j < y_diff; j++)
	//		{
	//			//these are the number of times we will loop through
	//			//we will store a new cost for each of the looping times
	//			costs[costIndex] = new int;
	//			costs[costIndex] = 
	//		}
	//	}
	//
	//}
}

int CCharVector::CompareImageInVectorCentred(CImage* image)
{
	//int y_diff, x_diff;
	CRect rectVector;
	CRect rectImage;
	int newwidth = min(m_Width,image->GetWidth());
	int newheight = min(m_Height,image->GetHeight());
	CPoint centre1;
	CPoint centre2;
	centre2.x = image->GetWidth()/2;
	centre2.y = image->GetHeight()/2;
	centre1.x = m_Width/2;
	centre1.y = m_Height/2;
	int* costs;
	//costs = new int*;
	int costIndex = 0;
	int sizeOfSearch = 3;
	const int sizeOfArray = ((centre1.x + sizeOfSearch) - (centre1.x - sizeOfSearch)+1) * ((centre1.y + sizeOfSearch) - (centre1.y - sizeOfSearch)+1);
	costs = new int[sizeOfArray];
	
	//find the centre of both images
	//rect.left = image->GetWidth()/2;
	//rect.right = 
	for (int i = centre1.x - sizeOfSearch; i <= centre1.x + sizeOfSearch; i++)
	{
		for (int j = centre1.y - sizeOfSearch; j <= centre1.y + sizeOfSearch; j++)
		{
			////find the centre of the other image
			CPoint point(i,j);
			costs[costIndex] = CompareSSDImages(m_CharImage,image,point,centre2);
			costIndex++;

		}

	}
	/*int maxVal = costs[0];
	for (int i = 1; i < costIndex; i++)
	{
		if (costs[i] > maxVal)
			maxVal = costs[i];
	}*/
	int minVal = costs[0];
	for (int i = 1; i < costIndex; i++)
	{
		if (costs[i] <= minVal)
			minVal = costs[i];
	}
	//delete costs;
	
	delete[] costs;
	return minVal;




}
int CCharVector::CompareImageInVectorCentred(CImage* image1,CImage* image2)
{
	//int y_diff, x_diff;
	CRect rectVector;
	CRect rectImage;
	
	int newwidth = min(image2->GetWidth(),image1->GetWidth());
	int newheight = min(image2->GetHeight(),image1->GetHeight());
	CPoint centre1;
	CPoint centre2;
	centre2.x = image1->GetWidth()/2;
	centre2.y = image1->GetHeight()/2;
	centre1.x = image2->GetWidth()/2;
	centre1.y = image2->GetHeight()/2;
	int* costs;
	//costs = new int*;
	int costIndex = 0;
	int sizeOfSearch = 3;
	const int sizeOfArray = ((centre1.x + sizeOfSearch) - (centre1.x - sizeOfSearch)+1) * ((centre1.y + sizeOfSearch) - (centre1.y - sizeOfSearch)+1);
	costs = new int[sizeOfArray];
	
	//find the centre of both images
	//rect.left = image->GetWidth()/2;
	//rect.right = 
	for (int i = centre1.x - sizeOfSearch; i <= centre1.x + sizeOfSearch; i++)
	{
		for (int j = centre1.y - sizeOfSearch; j <= centre1.y + sizeOfSearch; j++)
		{
			////find the centre of the other image
			CPoint point(i,j);
			costs[costIndex] = CompareSSDImages(image2,image1,point,centre2);
			costIndex++;

		}

	}
	/*int maxVal = costs[0];
	for (int i = 1; i < costIndex; i++)
	{
		if (costs[i] > maxVal)
			maxVal = costs[i];
	}*/
	int minVal = costs[0];
	for (int i = 1; i < costIndex; i++)
	{
		if (costs[i] <= minVal)
			minVal = costs[i];
	}
	//delete costs;
	
	delete[] costs;
	return minVal;




}
float CCharVector::CompareImageInVectorCentred2(CImage* image1,CImage* image2)
{
	//int y_diff, x_diff;
	/*CRect rectVector;
	CRect rectImage;
	rectImage.SetRect(0,0,image2->GetWidth(), image2->GetHeight());
	rectVector.SetRect(0,0,image1->GetWidth(), image1->GetHeight());*/
	int newwidth = min(image2->GetWidth(),image1->GetWidth());
	int newheight = min(image2->GetHeight(),image1->GetHeight());
	CPoint centrechar;
	CPoint centrevector;
	int valx = (int) GetRValue(image1->GetRGBColor(0,0));
	centrevector.x = image1->GetWidth()/2;
	centrevector.y = image1->GetHeight()/2;
	centrechar.x = image2->GetWidth()/2;
	centrechar.y = image2->GetHeight()/2;
	float* costs;
	//costs = new int*;
	int costIndex = 0;
	int sizeOfSearch = 2;
	const int sizeOfArray = (( centrechar.x + sizeOfSearch) - (centrechar.x - sizeOfSearch)+1) * ((centrechar.y + sizeOfSearch) - (centrechar.y - sizeOfSearch)+1);
	costs = new float[sizeOfArray];
	//find the centre of both images
	//rect.left = image->GetWidth()/2;
	//rect.right = 
	for (int i = centrechar.x - sizeOfSearch; i <= centrechar.x + sizeOfSearch; i++)
	{
		for (int j = centrechar.y - sizeOfSearch; j <= centrechar.y + sizeOfSearch; j++)
		{
			////find the centre of the other image
			CPoint point(i,j);
			costs[costIndex] = CompareSSDImages2(image1,image2,centrevector,point);
			costIndex++;
		}

	}
	/*int maxVal = costs[0];
	for (int i = 1; i < costIndex; i++)
	{
		if (costs[i] > maxVal)
			maxVal = costs[i];
	}*/
	float minVal = costs[0];
	for (int i = 1; i < costIndex; i++)
	{
		if (costs[i] <= minVal)
			minVal = costs[i];
	}
	//delete costs;
	
	delete[] costs;
	return minVal;




}

int CCharVector::CompareImageInVectorTubbs1(CImage* image1,CImage* image2)
{

	CRect rectVector;
	CRect rectImage;
	
	int newwidth = min(image2->GetWidth(),image1->GetWidth());
	int newheight = min(image2->GetHeight(),image1->GetHeight());
	CPoint centre1;
	CPoint centre2;
	centre2.x = image1->GetWidth()/2;
	centre2.y = image1->GetHeight()/2;
	centre1.x = image2->GetWidth()/2;
	centre1.y = image2->GetHeight()/2;
	int* costs;
	//costs = new int*;
	int costIndex = 0;
	int sizeOfSearch = 3;
	const int sizeOfArray = ((centre1.x + sizeOfSearch) - (centre1.x - sizeOfSearch)+1) * ((centre1.y + sizeOfSearch) - (centre1.y - sizeOfSearch)+1);
	costs = new int[sizeOfArray];

	int vals11 = 0;
	int vals10 = 0;
	int vals01 = 0;

	for (int i = centre1.x - sizeOfSearch; i <= centre1.x + sizeOfSearch; i++)
	{
		for (int j = centre1.y - sizeOfSearch; j <= centre1.y + sizeOfSearch; j++)
		{
			////find the centre of the other image
			CPoint point(i,j);
			costs[costIndex] = CompareTubbs1Images(image2,image1,point,centre2);
			costIndex++;

		}

	}
	/*int maxVal = costs[0];
	for (int i = 1; i < costIndex; i++)
	{
		if (costs[i] > maxVal)
			maxVal = costs[i];
	}*/
	int minVal = costs[0];
	for (int i = 1; i < costIndex; i++)
	{
		if (costs[i] <= minVal)
			minVal = costs[i];
	}
	//delete costs;
	
	delete[] costs;
	return minVal;
}

int CCharVector::CompareImageInVectorWeight(CImage* image1,CImage* image2)
{

	CRect rectVector;
	CRect rectImage;
	
	int newwidth = min(image2->GetWidth(),image1->GetWidth());
	int newheight = min(image2->GetHeight(),image1->GetHeight());
	CPoint centre1;
	CPoint centre2;
	centre2.x = image1->GetWidth()/2;
	centre2.y = image1->GetHeight()/2;
	centre1.x = image2->GetWidth()/2;
	centre1.y = image2->GetHeight()/2;
	int* costs;
	//costs = new int*;
	int costIndex = 0;
	int sizeOfSearch = 1;
	int sizeOfSearchUp = 1;
	const int sizeOfArray = ((centre1.x + sizeOfSearch) - (centre1.x - sizeOfSearch)+1) * ((centre1.y + sizeOfSearchUp) - (centre1.y - sizeOfSearchUp)+1);
	costs = new int[sizeOfArray];

	int vals11 = 0;
	int vals10 = 0;
	int vals01 = 0;

	for (int i = centre1.x - sizeOfSearch; i <= centre1.x + sizeOfSearch; i++)
	{
		for (int j = centre1.y - sizeOfSearchUp; j <= centre1.y + sizeOfSearchUp; j++)
		{
			////find the centre of the other image
			CPoint point(i,j);
			costs[costIndex] = CompareWeightImages(image2,image1,point,centre2);
			costIndex++;

		}

	}
	/*int maxVal = costs[0];
	for (int i = 1; i < costIndex; i++)
	{
		if (costs[i] > maxVal)
			maxVal = costs[i];
	}*/
	int minVal = costs[0];
	for (int i = 1; i < costIndex; i++)
	{
		if (costs[i] <= minVal)
			minVal = costs[i];
	}
	//delete costs;
	TRACE(_T("--%i\n"),minVal);
	delete[] costs;
	return minVal;
}

int CCharVector::CompareImageInVectorTubbs2(CImage* image1,CImage* image2)
{

	CRect rectVector;
	CRect rectImage;
	
	int newwidth = min(image2->GetWidth(),image1->GetWidth());
	int newheight = min(image2->GetHeight(),image1->GetHeight());
	CPoint centre1;
	CPoint centre2;
	centre2.x = image1->GetWidth()/2;
	centre2.y = image1->GetHeight()/2;
	centre1.x = image2->GetWidth()/2;
	centre1.y = image2->GetHeight()/2;
	int* costs;
	//costs = new int*;
	int costIndex = 0;
	int sizeOfSearch = 3;
	const int sizeOfArray = ((centre1.x + sizeOfSearch) - (centre1.x - sizeOfSearch)+1) * ((centre1.y + sizeOfSearch) - (centre1.y - sizeOfSearch)+1);
	costs = new int[sizeOfArray];

	int vals11 = 0;
	int vals10 = 0;
	int vals01 = 0;

	for (int i = centre1.x - sizeOfSearch; i <= centre1.x + sizeOfSearch; i++)
	{
		for (int j = centre1.y - sizeOfSearch; j <= centre1.y + sizeOfSearch; j++)
		{
			////find the centre of the other image
			CPoint point(i,j);
			costs[costIndex] = CompareTubbs2Images(image2,image1,point,centre2);
			costIndex++;

		}

	}
	/*int maxVal = costs[0];
	for (int i = 1; i < costIndex; i++)
	{
		if (costs[i] > maxVal)
			maxVal = costs[i];
	}*/
	int minVal = costs[0];
	for (int i = 1; i < costIndex; i++)
	{
		if (costs[i] <= minVal)
			minVal = costs[i];
	}
	//delete costs;
	
	delete[] costs;
	return minVal;
}


CPoint calculateCentreOfGravity(CImage* image)
{
	int x,y;
	int acc,acc2;
	acc = 0;
	acc2 = 0;
	CDistribution <long> * pDistributionH;
	CDistribution <long> * pDistributionV;

	long * pProjV;
	long * pProjH;

	
	pProjH = new long [image->GetHeight()];
	pProjV = new long [image->GetWidth()];
	image->GetProjection(0,0,image->GetWidth(),image->GetHeight(),pProjH,pProjV,PRJ_GREY);

	pDistributionH = new CDistribution <long>;
	pDistributionH->Create(pProjV,image->GetWidth());
	pDistributionV = new CDistribution <long>;
	pDistributionV->Create(pProjH,image->GetHeight());

	//Horizontal
	bool flagx, flagy;
	flagx = false;
	flagy = false;
	for (int i = 0; i < image->GetWidth(); i++)
	{
		//go to the horizontal projection profile of the image and find gravity point
		acc += pDistributionH->GetAt(i)*i;
	}
	acc = acc/2;
	for (int i = 0; i < image->GetWidth(); i++)
	{
		if (acc2 < acc)
		{
			acc2 += pDistributionH->GetAt(i)*i;
		}
		else if (flagx == false)
		{
			flagx = true;
			x = i;
		}
	}

	//Vertical

	acc = 0;
	acc2 = 0;
	for (int i = 0; i < image->GetHeight(); i++)
	{
		//go to the horizontal projection profile of the image and find gravity point
		acc += pDistributionV->GetAt(i)*i;
	}
	acc = acc/2;
	for (int i = 0; i < image->GetHeight(); i++)
	{
		if (acc2 < acc)
		{
			acc2 += pDistributionV->GetAt(i)*i;
		}
		else if (flagy == false)
		{
			flagy = true;
			y = i;
		}
	}
	CPoint p(x,y);
	return p;
}
int CCharVector::CompareImageInVectorGravity(CImage* image)
{
	
	CRect rectVector;
	CRect rectImage;
	int newwidth = min(m_Width,image->GetWidth());
	int newheight = min(m_Height,image->GetHeight());
	CPoint centre1;
	CPoint centre2;
	centre2.x = image->GetWidth()/2;
	centre2.y = image->GetHeight()/2;
	centre1.x = m_Width/2;
	centre1.y = m_Height/2;
	int* costs;
	
	int costIndex = 0;
	int sizeOfSearch = 0;
	const int sizeOfArray = ((centre1.x + sizeOfSearch) - (centre1.x - sizeOfSearch)+1) * ((centre1.y + sizeOfSearch) - (centre1.y - sizeOfSearch)+1);
	costs = new int[sizeOfArray];
	//Find the centre of gravity of both images
	//centre1 = calculateCentreOfGravity(m_CharImage);
	//centre2 = calculateCentreOfGravity(image);
	
	int startX, endX,startY, endY;
	if ((centre1.x - sizeOfSearch) < 0)
	{
		startX = 0;
	}
	else
	{
		startX = centre1.x - sizeOfSearch;
	}
	
	if ((centre1.y - sizeOfSearch)< 0)
	{
		startY = 0;
	}
	else
	{
		startY = centre1.y - sizeOfSearch;
	}
	endX = centre1.x + sizeOfSearch;
	endY = centre1.y + sizeOfSearch;
	for (int i = startX; i <= endX; i++)
	{
		for (int j = startY; j <= endY; j++)
		{
			////find the centre of the other image
			CPoint point(i,j);
			costs[costIndex] = (int)CompareSSDImages2(m_CharImage,image,point,centre2);
			costIndex++;

		}

	}
	float minVal = costs[0];
	for (int i = 1; i < costIndex; i++)
	{
		if (costs[i] <= minVal)
			minVal = costs[i];
	}
	//delete costs;
	
	delete[] costs;
	return minVal;

}

//int CCharVector::ComprareSSDRects(CRect rect1, CRect rect2, int width, int height)
//{
//	/*int cost = 0;
//	for (int i = 0; i < width; i++)
//	{
//		for (int j = 0; j < height; j++)
//		{
//				
//		}
//	}*/
//}

int CCharVector::CompareSSDImages(CImage* image1, CImage* image2,CPoint point1,CPoint point2)
{
	//int cost = 0;
	float cost = 0.0;
	//given 2 images and a centre point: match them
	//point2 is the centre of the unknwon char
	//point1 is the possition in vectorchar, but not necessarily centered
	for (int i = 0; i < image1->GetWidth(); i++)
	{
		for (int j = 0; j < image1->GetHeight(); j++)
		{
			int posxl = point2.x - point1.x  + i;
			//int posxr = point1.x + point2.x + i;
			int posyt = point2.y - point1.y + j;
		//	int posyb = point1.y + point2.y;
			
			//if ((posxl < 0)|| (posyt < 0) ||(posxr >= image1->GetWidth()) || (posyb >= image1->GetHeight()))
			if ((posxl >= 0)&& (posxl < image1->GetWidth()) && (posyt >= 0) && ( posyt<image1->GetHeight()))
			{
				//add the cost
				
				float val = (float) abs((int) GetRValue(image1->GetRGBColor(i,j)) - (int) GetRValue(image2->GetRed(posxl,posyt)));
				//Normalize it??
				val = (float) val/255;
				cost += pow(val,2);
			}
			else
			{
				cost++;
			}
		}
	}

	return (int) cost;
}
int CCharVector::CompareWeightImages(CImage* image1, CImage* image2,CPoint point1,CPoint point2)
{
	//int cost = 0;
	float cost = 0.0;
	//given 2 images and a centre point: match them
	//point2 is the centre of the unknwon char
	//point1 is the possition in vectorchar, but not necessarily centered

	//create a new image as the union of both
	int left = max(point1.x,point2.x);
	int top = max(point1.y, point2.y);
	int right = max((image1->GetWidth()-point1.x-1),(image2->GetWidth()-point2.x-1));
	int bottom = max((image1->GetHeight()-point1.y-1),(image2->GetHeight()-point2.y-1));

	int newHeight = top + bottom + 1;
	int newWidth = left + right + 1;

	CPoint midpoint;
	midpoint.x = (newWidth/2)+1;
	midpoint.y = (newHeight/2)+1;

	int val1 = -1;
	int val2 = -1;

	int val11 = 0;
	int val10 = 0;
	int val01 = 0;
	int val00 = 0;

	//CImage * newImage;
	//newImage->Create(newWidth, newHeight,RGB(255,255,255),T_(o));
	
	int** newImage;
	newImage = new int*[newWidth];
	for (int i = 0; i < newWidth; i++)
	{
		newImage[i] = new int[newHeight];
		
	}

	for (int i = 0; i < newWidth; i++)
	{
		for (int j = 0; j < newHeight; j++)
		{
			val1 = -1;
			val2 = -1;
			newImage[i][j] = 255;
				
			//image1
			if ((i >= (midpoint.x - point1.x ))&& (i < (midpoint.x + image1->GetWidth() - point1.x)) && (j >= (midpoint.y - point1.y)) && (j < (midpoint.y + image1->GetHeight() - point1.y)))//then the pixel is inside the image1
			{
				CPoint point(point1.x - midpoint.x + i,point1.y - midpoint.y + j);
				val1 = image1->GetBlue(point.x, point.y);
				
			}
			//image2
			if ((i >= (midpoint.x - point2.x ))&& (i < (midpoint.x + image2->GetWidth() - point2.x)) && (j >= (midpoint.y - point2.y)) && (j < (midpoint.y + image2->GetHeight() - point2.y)))//then the pixel is inside the image2
			{
				CPoint point22(point2.x - midpoint.x + i ,point2.y - midpoint.y + j);
				val2 = image2->GetBlue(point22.x, point22.y);

			}

			//depending on the values of val1 and val2
			
			if ((val1 >= 0)&& (val2 >= 0) && ( val1 == val2))
			{
				newImage[i][j] = val1;
			}
			else
			{
				if ((val1 >= 0)&& (val2 >= 0) && (val1 == 0))//one is black and the other is white
				{
					newImage[i][j] = -110; 
				}
				else if ((val1 >= 0)&& (val2 >= 0) && (val2 == 0))//one is black and the other is white
				{
					newImage[i][j] = -101; 
				}
			}
			if ((val1 < 0) && (val2 == 0)) //if one image is small but the other is black
			{
				newImage[i][j] = -101;
			}
			if ((val2 < 0) && (val1 == 0))
			{
				newImage[i][j] = -110; 
			}

			
		}
			
	}

		for (int i = 0; i < newWidth; i++)
		{
			for (int j = 0; j < newHeight; j++)
			{
				if (newImage[i][j] ==    0) val11++;
				if (newImage[i][j] ==  255) val00++;
				if (newImage[i][j] == -101) val01++;
				if (newImage[i][j] == -110) val10++;


				//find how many 01 or 10 are in its neighbourhood.
				if (i - 1 >= 0) 
				{
					
					if (newImage[i-1][j] < 0) 
					{
						if (newImage[i-1][j] == -101){ val01++;}
						else val10++;
					}
					if (j - 1 >= 0)
					{
						if (newImage[i][j-1] < 0) 
						{
							if (newImage[i][j-1] == -101){ val01++;}
							else val10++;
						}
						if (newImage[i-1][j-1] <0)
						{
							if (newImage[i-1][j-1] == -101){ val01++;}
							else val10++;
						}
					}
					if (j + 1 > newHeight)
					{
						if (newImage[i-1][j+1] <0)
						{
							if (newImage[i-1][j+1] == -101){ val01++;}
							else val10++;
						}
					}
				}
				if (i + 1 < newWidth)
				{
					if (newImage[i+1][j] < 0) 
					{
						if (newImage[i+1][j] == -101){ val01++;}
						else val10++;
					} 
					if (j + 1 > newHeight)
					{
						if (newImage[i+1][j+1] <0)
						{
							if (newImage[i+1][j+1] == -101){ val01++;}
							else val10++;
						}

						if (newImage[i][j+1] <0)
						{
							if (newImage[i][j+1] == -101){ val01++;}
							else val10++;
						}
					}
					if (j - 1 <= 0)
					{
						if (newImage[i+1][j-1] <0)
						{
							if (newImage[i+1][j-1] == -101){ val01++;}
							else val10++;
						}
					}
				}
				

				
			}

		}
		//////find the distance to the closest mathching pixel
		bool found = false;
		int loop = 1;
		int distance = 0;
		for (int i = 0; i < newWidth; i++)
		{
			for (int j = 0; j < newHeight; j++)
			{	//if it is a non matching pixel
				found = false;
				loop = 1;
				if ((newImage[i][j] == -110) /*|| (newImage[i][j] == -101)*/) 
				{
					
					while (!found)
					{
						
						for (int x = -loop; x<= loop; x++)
						{
							for (int y = -loop; y <= loop; y++)
							{
								if ((i + x >=0) && (i + x < newWidth) && (j + y >= 0) && (j + y < newHeight))
								{
									if ((newImage[i+x][j+y] == 0) || (newImage[i+x][j+y] == -101))//matching pixel is found
									{	
										if (!found)
										{
											//distance = loop;
											distance = (int) sqrt(pow((double)x,2) + pow((double)y,2));
											//distance = min(abs(x),abs(y));
											found = true;
										}
									}
								}
							}
						}
					loop++;
					}
				if (newImage[i][j] == -101)  val01 = val01 + distance;
				if (newImage[i][j] == -110)	 val10 = val10 + distance;

				}
			}
		}
		cost = (float)val10+val01;	
		//cost = (float) val11/(float)(val11 + val10 + val01);



	return (int) (cost);
	delete[] newImage;
}


int CCharVector::CompareTubbs1Images(CImage* image1, CImage* image2,CPoint point1,CPoint point2)
{
	//int cost = 0;
	float cost = 0.0;

	//given 2 images and a centre point: match them
	//calculate how many pixels are there in 11, 01, 10
	//DistanceTubbs1 = 11/(11 + 10 + 01)

	//point2 is the centre of the unknwon char
	//point1 is the possition in vectorchar, but not necessarily centered
	int val11 = 0;
	int val10 = 0;
	int val01 = 0;
	int uchar;
	int vchar;
	for (int i = 0; i < image1->GetWidth(); i++)
	{
		for (int j = 0; j < image1->GetHeight(); j++)
		{
			int posxl = point2.x - point1.x  + i;
			//int posxr = point1.x + point2.x + i;
			int posyt = point2.y - point1.y + j;
		//	int posyb = point1.y + point2.y;
			
			//if ((posxl < 0)|| (posyt < 0) ||(posxr >= image1->GetWidth()) || (posyb >= image1->GetHeight()))
			if ((posxl >= 0)&& (posxl < image2->GetWidth()) && (posyt >= 0) && ( posyt <image2->GetHeight()))
			{
				uchar = (int) GetRValue(image2->GetRGBColor(posxl,posyt));
				vchar = (int) GetRValue(image1->GetRGBColor(i,j));
				//val11
				if ((uchar == vchar) && (uchar == 0))
				{
					val11++;
				}
				else if ((uchar == 255 ) && ( vchar == 0))
				{
					val01++;
				}
				else if ((vchar == 255 ) && ( uchar == 0))
				{
					val10++;
				}
			}
		
		}
	}
	cost = (float) val11/(float)(val11 + val10 + val01);

	return (int) (cost*10000);
}

int CCharVector::CompareTubbs2Images(CImage* image1, CImage* image2,CPoint point1,CPoint point2)
{
	//int cost = 0;
	float cost = 0.0;

	//given 2 images and a centre point: match them
	//calculate how many pixels are there in 11, 01, 10
	//Distance2 = (11*00 - 10*01)/(11*00 + 10*01)

	//point2 is the centre of the unknwon char
	//point1 is the possition in vectorchar, but not necessarily centered
	int val11 = 0;
	int val10 = 0;
	int val01 = 0;
	int val00 = 0;
	int uchar;
	int vchar;
	for (int i = 0; i < image1->GetWidth(); i++)
	{
		for (int j = 0; j < image1->GetHeight(); j++)
		{
			int posxl = point2.x - point1.x  + i;
			//int posxr = point1.x + point2.x + i;
			int posyt = point2.y - point1.y + j;
		//	int posyb = point1.y + point2.y;
			
			//if ((posxl < 0)|| (posyt < 0) ||(posxr >= image1->GetWidth()) || (posyb >= image1->GetHeight()))
			if ((posxl >= 0)&& (posxl < image2->GetWidth()) && (posyt >= 0) && ( posyt<image2->GetHeight()))
			{
				uchar = (int) GetRValue(image2->GetRGBColor(posxl,posyt));
				vchar = (int) GetRValue(image1->GetRGBColor(i,j));
				//val11
				if ((uchar == vchar) && (uchar == 0))
				{
					val11++;
				}
				else if ((uchar == 255 ) && ( vchar == 0))
				{
					val01++;
				}
				else if ((vchar == 255 ) && ( uchar == 0))
				{
					val10++;
				}
				else if ((uchar == vchar) && (uchar == 255))
				{
					val00++;
				}

				//add the cost
				
				//float val = (float) abs((int) GetRValue(image1->GetRGBColor(i,j)) - (int) GetRValue(image2->GetRed(posxl,posyt)));
				////Normalize it??
				//val = (float) val/255;
				//cost += pow(val,2);
			}
			/*else
			{
				cost++;
			}*/
		}
	}
	 
	cost = (float)((val11*val00) - (val10*val01))/(float)(val11*val00 + val10*val01);

	return (int) (cost*100000);
}

float CCharVector::CompareSSDImages2(CImage* image1, CImage* image2,CPoint point1,CPoint point2)
{
	//image2 and point2 are the unknown char and its center
	//image1 and point1 are the perfect image and the positioning point
	//find if the images are smaller or larger in size.
//	float percent = (float)1/(float)totPix;
//	float halfPercent = (float)1 / (float)(totPix * 2);
	float cost = 0.0;
	//find starting points
	int newWidthLeft, newWidthRight;
	newWidthLeft = max(point1.x,point2.x);
	newWidthRight = max((image1->GetWidth() - point1.x),(image2->GetWidth() - point2.x));

	int newHeightTop, newHeightBottom;
	newHeightTop = max(point1.y, point2.y);
	newHeightBottom = max((image1->GetHeight() - point1.y),(image2->GetHeight() - point2.y));

	int newWidth, newHeight;
	newWidth = newWidthRight + newWidthLeft;
	newHeight = newHeightTop + newHeightBottom;

	if ((newWidth > image1->GetWidth()) || (newWidth > image2->GetWidth()))
	{
		newWidth = max(image1->GetWidth(), image2->GetWidth());
	}
	if ((newHeight > image1->GetHeight()) || (newHeight > image2->GetHeight()))
	{
		newHeight = max(image1->GetHeight(), image2->GetHeight());
	}

	int val1, val2;
	CPoint pos1(0,0);
	CPoint pos2(0,0);
	//find their position within the array
	if (newWidthLeft != point1.x) 
	{
		pos1.x = point2.x - point1.x;
	}
	else 
	{
		pos1.x = 0;
	}
	if (newHeightTop != point1.y) 
	{
		pos1.y = point2.y - point1.y;
	}
	else 
	{
		pos1.y = 0;
	}
	if (newWidthLeft != point2.x) 
	{
		pos2.x = point1.x - point2.x;
	}
	else 
	{
		pos2.x = 0;
	}
	if (newHeightTop != point2.y) 
	{
		pos2.y = point1.y - point2.y;
	}
	else 
	{
		pos2.y = 0;
	}
	
	for (int i = 0; i < newWidth; i++)
	{
		for (int j = 0; j < newHeight; j++)
		{	
			if ((i >= pos1.x) && (i < pos1.x + image1->GetWidth())) //if it is within the x-char
			{
				if ((j >=pos1.y) && (j < (pos1.y + (image1->GetHeight()/2))))
				{
					//then get pixel
					val1 = (int) GetRValue(image1->GetRGBColor(i,j));
				}
				else
				{
					val1 = 255;	
				}
			}
			else val1 = 255;
			if ((i >= pos2.x) && (i < pos2.x + image2->GetWidth())) //if it is within the x-char
			{
				if ((j >=pos2.y) && (j < (pos2.y + (image2->GetHeight()/2))))
				{
					//then get pixel
					val2 = (int) GetRValue(image2->GetRGBColor(i,j));
				}
				else
				{
					val2 = 255;	
				}
			}
			else val2 = 255;

			/*}else 
			{
				if (pos1.y >= image1->GetHeight())
				{
					pos1.y=0;
					pos1.x++;
				}
			}
			if ((pos2.x < image2->GetWidth())&& (pos2.y < image2->GetHeight()))
			{
				if ((i == pos2.x) && (j == pos2.y))
				{
					val2 = (int) GetRValue(image2->GetRGBColor(i,j));
					pos2.y++;
				}
				else 
				{
					val2 = 255;
				}
			}else
			{
				if (pos2.y >= image2->GetHeight())
				{
					pos2.y=0;
					pos2.x++;
				}
			}*/
			float newval;
			if ((val1 < 0)||(val2 < 0))
			{
				cost += 1.0;
			}
			else
			{
				newval = (float)abs(val1 - val2);
				newval = (float) newval/255;
				cost += newval;
				
			}
		}

	}


	return cost;
}
int CCharVector::CompareImagesFlexible(CImage* image1, CImage* image2,CPoint point1,CPoint point2, int totPix)
{
	//int cost = 0;
	float cost = 0.0;
	//given 2 images and a centre point: match them
	//point2 is the centre of the image2
	//point1 is teh possition in image1, but not necessary centered
	float percent = (float)1/(float)totPix;
	float halfPercent = (float)1 / (float)(totPix * 2);
	int tot = 0;
	for (int i = 0; i < image2->GetWidth(); i++)
	{
		for (int j = 0; j < image2->GetHeight(); j++)
		{
			int posxl = point1.x - point2.x + i;
			//int posxr = point1.x + point2.x + i;
			int posyt = point1.y - point2.y + j;
		//	int posyb = point1.y + point2.y;
			//if ((posxl < 0)|| (posyt < 0) ||(posxr >= image1->GetWidth()) || (posyb >= image1->GetHeight()))
			if ((posxl >= 0)&& (posxl < image1->GetWidth()) && (posyt >= 0) && ( posyt<image1->GetHeight()))
			{
				//add the cost
				tot++;
				if (image1->GetRed(posxl,posyt) == image2->GetRed(i,j))//if they are the same
				{
						cost += percent;
				}
				else 
					if ((image2->GetRed(i,j) == 0) && (image2->GetRed(i,j)!= 255))
					{
						cost += halfPercent;
					}

			}
		}
	}

	return (int)(tot-cost);
}
int CCharVector::CompareImageInVectorFlexible(CImage* image1,CImage* image2)
{
	//int y_diff, x_diff;
	CRect rectVector;
	CRect rectImage;
	int newwidth = min(image2->GetWidth(),image1->GetWidth());
	int newheight = min(image2->GetHeight(),image1->GetHeight());
	CPoint centre1;
	CPoint centre2;
	centre2.x = image1->GetWidth()/2;
	centre2.y = image1->GetHeight()/2;
	centre1.x = image2->GetWidth()/2;
	centre1.y = image2->GetHeight()/2;
	int* costs;
	//costs = new int*;
	int costIndex = 0;
	int sizeOfSearch = 3;
	const int sizeOfArray = ((centre1.x + sizeOfSearch) - (centre1.x - sizeOfSearch)+1) * ((centre1.y + sizeOfSearch) - (centre1.y - sizeOfSearch)+1);
	costs = new int[sizeOfArray];
	
	//find the centre of both images
	//rect.left = image->GetWidth()/2;
	//rect.right = 
	for (int i = centre1.x - sizeOfSearch; i <= centre1.x + sizeOfSearch; i++)
	{
		for (int j = centre1.y - sizeOfSearch; j <= centre1.y + sizeOfSearch; j++)
		{
			////find the centre of the other image
			CPoint point(i,j);
			costs[costIndex] = CompareImagesFlexible(image2,image1,point,centre2,1);
			costIndex++;

		}

	}
	/*int maxVal = costs[0];
	for (int i = 1; i < costIndex; i++)
	{
		if (costs[i] > maxVal)
			maxVal = costs[i];
	}*/
	int maxVal = 0;
	for (int i = 1; i < costIndex; i++)
	{
		if (costs[i] >= maxVal)
			maxVal = costs[i];
	}
	//delete costs;
	
	delete[] costs;
	return maxVal;




}
//create statistics method
//CCharVector* CCharVector::ComputeProbabilityVector(CCharVector* TestVector,CCharVector* CharVector, int CharVectorIndex)
//{
//	//for each Vector in the CharVector compute differences
//	CCharVector* ResultVector;
//	ResultVector = new CCharVector [CharVectorIndex];
//	for (int i = 0; i < CharVectorIndex; i++)
//	{
//		ResultVector[i] = CompareVectors(CharVector[i],TestVector);
//	}
//	return ResultVector;
//	//probably change these methods to an external class
//
//}
//compute statistics


