#pragma once
#include "afx.h"
#include "Image.h"
#include "DIACharacter.h"
#include <vector>
using namespace std;

class CCharVector 
{
public:
	typedef struct CROSSINGS
	{
		int		Crossings;
		int		NoCrossings;
	};
	CCharVector(void);
	CCharVector(CCharVector &Vector);
	~CCharVector(void);
	CCharVector &	operator =(CCharVector &Vector);
	void			CreateVectorFromCharacter(CDIACharacter* character);
	void			CreateVectorFromVector(CCharVector &Vector);
	CCharVector*	CompareVectors(CCharVector* TestVector);
	void			CompareImageInVector(CImage* image);
	int*			CompareImageInVectorBlind(CImage* image);
	int				CompareImageInVectorCentred(CImage* image);
	int				CompareImageInVectorCentred(CImage* image1,CImage* image2);
	float			CompareImageInVectorCentred2(CImage* image1,CImage* image2);
	int				CompareImageInVectorTubbs1(CImage* image1,CImage* image2);
	int				CompareImageInVectorTubbs2(CImage* image1,CImage* image2);
	int				CompareImageInVectorFlexible(CImage* image1,CImage* image2);
	int				CompareImageInVectorGravity(CImage* image);
	int				CompareImageInVectorWeight(CImage* image1,CImage* image2);
	int				CompareSSDImages(CImage* image1, CImage* image2,CPoint point1,CPoint point2);
	float			CompareSSDImages2(CImage* image1, CImage* image2,CPoint point1,CPoint point2);
	int				CompareTubbs1Images(CImage* image1, CImage* image2,CPoint point1,CPoint point2);
	int				CompareTubbs2Images(CImage* image1, CImage* image2,CPoint point1,CPoint point2);
	int				CompareImagesFlexible(CImage* image1, CImage* image2,CPoint point1,CPoint point2, int totPix);
	int				CompareWeightImages(CImage* image1, CImage* image2,CPoint point1,CPoint point2);
	//int				ComprareSSDRects(CRect rect1, CRect rect2, int width, int height);
	//CCharVector*	ComputeProbabilityVector(CCharVector* TestVector,CCharVector* CharVector, int CharVectorIndex);
	int CompareWidth(int perfectWidth, int testWidth);
	int CompareHeight(int perfectHeight, int testHeight);


	//accessors //Set
	void	SetCharName(char name);
	void	SetCharType(int type);
	void	SetVMax(int vmax);
	void	SetHMax(int hmax);
	void	SetWidth(int width);
	void	SetHeight(int height);
	void	SetAspectRatio(float aspRatio);
	/*void	SetVCrossing(int vcross);
	void	SetHCrossing(int hcross);*/
	void	SetReducedImageSize(CPoint size);
	void	SetNoComponents(int nocomp);
	void	SetNoHoles(int noholes);
	void	SetReducedImage(int x,int y,int** ImageArray);
	void	SetCharImage(CImage* charimage);
	void	SetWeight(int weight);
	void	SetCapital(bool capital);
	
	//Get
	char	GetCharName();
	int		GetCharType();
	int		GetVMax();
	int		GetHMax();
	int		GetWidth();
	int		GetHeight();
	float	GetAspectRatio();
	/*int		GetVCrossing();
	int		GetHCrossing();*/
	CPoint	GetReducedImageSize();
	int		GetNoComponents();
	int		GetNoHoles();
	int**	GetReducedImage();
	CImage*	GetCharImage();
	int		GetWeight();
	int		GetDivision(int pos);
	void	SetDivision(int pos, int val);
	//VCrossings
	int		GetNoCrossingV();
	void	SetNoCrossingV(int val);
	//int		GetCrossingsValV(int pos);
//	int		GetCrossingsPercentV(int pos);
//	void	SetCrossingsValV(int pos, int val);
//	void	SetCrossingsPercentV(int pos, int val);
	bool	GetCapital();
	int		GetFeatureNumber(int number);

	
	void	SetCrossingsV(CROSSINGS * crossing);
	//HCrossings
	int		GetNoCrossingH();
	void	SetNoCrossingH(int val);
	int		GetCrossingsValH(int pos);
	int		GetCrossingsPercentH(int pos);
	void	SetCrossingsValH(int pos, int val);
	void	SetCrossingsPercentH(int pos, int val);


	void	SetHMaxDistance(int distance);
	int		GetHMaxDistance();

	void	SetVMaxDistance(int distance);
	int		GetVMaxDistance();

	
	void	SetCrossingsH(CROSSINGS * crossing);

private:
	

	//describe the vector
	char	m_CharName;
	int		m_CharType;
	int		m_VMax;
	int		m_HMax;
	int		m_Width;
	int		m_Height;
	float	m_AspectRatio;

	
	int		m_CrossingsIndexV;

	
	int		m_CrossingsIndexH;

	bool		m_isCapital;
	int**	m_ReducedImage;
	CPoint	m_ReducedImageSize;
	int		m_NoComponents;
	int		m_NoHoles;
	CImage*	m_CharImage;
	int		m_Weight;
	int		m_Divisions[25];
	int		m_HMaxDistance;
	int		m_VMaxDistance;
public:
	vector<CROSSINGS> m_CrossingsV;
	vector<CROSSINGS> m_CrossingsH;
	
	//CROSSINGS * m_CrossingsV; 
	//CROSSINGS * m_CrossingsH; 

};
