#include "StdAfx.h"
#include ".\classlist.h"

CClassList::CClassList(void)
{
	list = new ListNode; //create a new ListNode in memory
	list->next = NULL; //the header is the only node in the list
	prevcurrent = list; //set current to the header, since there are no nodes
	len = 0;

}	

CClassList::~CClassList(void)
{
	clear(); //delete all list nodes
	delete list; //delete the header "dummy" node

}

void CClassList::clear()
{
	ListNode *tmp; //point to the node to be deleted
	ListNode *traverse = list->next; //used to visit each node in the list. The header node is not deleted, so we start with the first actual node.
	while(traverse != NULL) //while the list is not empty
	{
		tmp = traverse; //store the current node.
		traverse = traverse->next; //visit the next node
		delete tmp; //free the memory taken up by the current node
	}
	prevcurrent = list; //set current to the header node
	len = 0;
}
void CClassList::insert(const ItemType item)
{
  // assert(!IsFull()); //abort if there is no memory to create a new node
   ListNode *NewNode = new ListNode; //create a new node in memory
   NewNode->data = item; //set the node's value
   NewNode->next = prevcurrent->next; //referenced node will follow new node in order
   prevcurrent->next = NewNode; //The node that preceded the old node now precedes the new one. The new node is now referenced.
   len++; //increment length
}

void CClassList::deleteItem()
{
   if(len != 0) //don't delete the header node
   {
      prevcurrent->next = prevcurrent->next->next; //logically remove it from the list
      delete (prevcurrent->next); //free up memory
      len--; //decrement length
   }
}

void CClassList::next()
{
   prevcurrent = prevcurrent->next;
}


void CClassList::prev()
{
   if (len > 1) //run only if there is an element behind the current
   {
      ListNode *tmp = list;
      while(tmp->next != prevcurrent)
      tmp = tmp->next;
      prevcurrent = tmp;
   }
}
void CClassList::reset()
{
   prevcurrent = list;
}

int CClassList::length()
{
   return len;
}

bool CClassList::IsEmpty()
{
   return (len == 0);
}

bool CClassList::IsFull() 
{
   ListNode *tmp = new ListNode;
   if(tmp == NULL)
      return true;
   else
   {
      delete tmp;
      return false;
   }
}
CClassList::ItemType CClassList::value() 
{
   return prevcurrent->next->data;
}

//ListNode* CClassList::Find(int level)
//{
//	 //if (len > 1) //run only if there is an element behind the current
//  // {
//  //    ListNode *tmp = list;
//  //    while ((tmp->next != NULL) && (tmp->next->data.
//	 // {
//		//tmp = tmp->next;
//		//prevcurrent = tmp;
//	 // }
//  // }
//}
//
//
