#include "stdafx.h"
#include "ImageLib.h"
#include "DIABiLevelImage.h"

IMPLEMENT_SERIAL_MI(CDIABiLevelImage, CBiLevelImage, (UINT)(VERSIONABLE_SCHEMA|1))

CDIABiLevelImage:: CDIABiLevelImage(void)
{	
	m_Type = IT_DIA_BILEVELIMAGE;
}

CDIABiLevelImage::~ CDIABiLevelImage(void)
{}
void CDIABiLevelImage::Threshold_Gatos_PostProcessing(int WindowSize, CRect& rect)
{
       //The rectangle is suposed to be already checked by Threshold_Gatos();
       int WinSize2 = (int)(0.15*WindowSize/2.0); //WindowSize supposingly is the Height of the Characters
       int x, y;
       BYTE Fore = 0x00, Back = 0xFF;

       //1st and 2nd (Combined in a single run) Post-Processing Steps
       CreateBackup();
       for (y = rect.top; y < rect.bottom; y ++)
       {
               BYTE * pDest = &(m_LineArray[y][rect.left]);
               for (x = rect.left; x < rect.right; x++)
               {
                       if (*pDest == Fore) //Center pixel is Foreground
                       {
                               long n = 0, Psh = 0;
                               for (int ty = y - WinSize2; ty <= y + WinSize2; ty++)
                               {
                                       if (ty < rect.top) continue;
                                       if (ty >= rect.bottom) break;
                                       for (int tx = x - WinSize2; tx <= x + WinSize2; tx++)
                                       {
                                               if (tx < rect.left) continue;
                                               if (tx >= rect.right) break;
                                               n++;
                                               if (m_BackupLineArray[ty][tx] == Back) Psh++;
                                       }
                               }
                               if (Psh > 0.9 * n) *pDest = Back;
                       }
                       else //if (*pDest == Back) //Center pixel is Background
                       {
                               long n = 0, nFore = 0, Psw = 0, AvgX = 0, AvgY = 0;
                               for (int ty = y - WinSize2; ty <= y + WinSize2; ty++)
                               {
                                       if (ty < rect.top) continue;
                                       if (ty >= rect.bottom) break;
                                       for (int tx = x - WinSize2; tx <= x + WinSize2; tx++)
                                       {
                                               if (tx < rect.left) continue;
                                               if (tx >= rect.right) break;
                                               n++;
                                               if (m_BackupLineArray[ty][tx] == Fore)
                                               {
                                                       Psw++;
                                                       AvgX += tx;
                                                       AvgY += ty;
                                                       nFore++;
                                               }
                                       }
                               }
                               if (nFore > 0)
                               {
                                       AvgX /= nFore;
                                       AvgY /= nFore;
                                       if ((Psw > 0.5 * n) && (abs(x-AvgX) < 0.25*n) && (abs(y-AvgY) < 0.25*n)) *pDest = Fore;
                               }
                       }
                       pDest++;
               }
       }
       DiscardBackup();

       //3rd Post-processing step
       CreateBackup();
       for (y = rect.top; y < rect.bottom; y ++)
       {
               BYTE * pDest = &(m_LineArray[y][rect.left]);
               for (x = rect.left; x < rect.right; x++)
               {
                       if (*pDest == Back) //Center pixel is Background
                       {
                               long n = 0, Psw = 0;
                               for (int ty = y - WinSize2; ty <= y + WinSize2; ty++)
                               {
                                       if (ty < rect.top) continue;
                                       if (ty >= rect.bottom) break;
                                       for (int tx = x - WinSize2; tx <= x + WinSize2; tx++)
                                       {
                                               if (tx < rect.left) continue;
                                               if (tx >= rect.right) break;
                                               n++;
                                               if (m_BackupLineArray[ty][tx] == Fore) Psw++;
                                       }
                               }
                               if (Psw > 0.5 * n) *pDest = Fore;
                       }
                       pDest++;
               }
       }
       DiscardBackup();
}