#include "StdAfx.h"
#include "diagreyscale.h"
#include ".\diacharacter.h"
#include "DocImAnDoc.h"
#include "MATH.h"
#include "DIAHistograms.h"
#include "DocImAnView.h"
#include "Distribution.h"
#include "Comp.h"
#include "ConnectedComponents.h"
#include "ConnectedComponent.h"
//#include <fuzzy_engine_h.h>


//#pragma comment(lib,"fuzzy_dll.lib")		//were the fuzzy AI engine is





IMPLEMENT_SERIAL(CDIACharacter, CObject, 1);
CDIACharacter::CDIACharacter(void)
{
	m_pCharacterProjV = NULL;
	m_pCharacterProjH = NULL;
	m_pCharacterDistributionH = NULL;
	m_pCharacterDistributionV = NULL;
	m_pCharImage = NULL;
	m_pLocatedCharImage = NULL;
	//for (int i = 0; i < 5; i++) m_Background2[i] = 0;
	for (int i = 0; i < 4; i++) m_CharType[i] = -1;
	ZeroMemory(m_histo, 256 * sizeof(unsigned long));
	
}

CDIACharacter::~CDIACharacter(void)
{
	
	delete[] m_pCharacterProjV;
	delete[] m_pCharacterProjH;
	delete[] m_pCharacterDistributionH;
	delete[] m_pCharacterDistributionV;
	delete m_pCharImage;
	//delete[] m_charUncertainAreas;
	
	delete m_pLocatedCharImage;
	m_pCharacterProjV = NULL;
	m_pCharacterProjH = NULL;
	m_pCharacterDistributionH = NULL;
	m_pCharacterDistributionV = NULL;
	m_pCharImage = NULL;
	m_pLocatedCharImage = NULL;
	

	/*delete[] m_HRuns;
	delete[] m_HNoRuns;
	delete[] m_VRuns;
	delete[] m_VNoRuns;

	m_HRuns = NULL;
	m_HNoRuns = NULL;
	m_VRuns = NULL;
	m_VNoRuns = NULL;*/
	
}


void CDIACharacter::CreateCharacter(int height,long FirstSeparator, long SecondSeparator,long Yposition, CImage * p_Image,   int Linenum, int Charnum)

{
	m_Height = height;
	m_Width = SecondSeparator - FirstSeparator;
	m_Position_Y = Yposition;
	m_Position_X = FirstSeparator;
	m_pCharacterProjH = new long [m_Height];
	m_pCharacterProjV = new long [m_Width];
	p_Image->GetProjection(m_Position_X,m_Position_Y,m_Width,m_Height,m_pCharacterProjH, m_pCharacterProjV ,PRJ_GREY);
	m_pCharacterDistributionH = new CDistribution <long>;
	m_pCharacterDistributionH->Create(m_pCharacterProjV,m_Width);
	m_pCharacterDistributionV = new CDistribution <long>;
	m_pCharacterDistributionV->Create(m_pCharacterProjH,m_Height);
	m_pCharImage = new CDIAGreyScale;
	m_pLocatedCharImage = new CDIAGreyScale;
	CreateCharImage(p_Image, true);
	//m_ImageName = p_Image->GetName();
	m_CharNum = Charnum;
	m_CharLineNum = Linenum;
	m_PossibleChars = 0;
	m_Groundtruthchar = '';
	m_FTRChar.charName = '';
	m_FTRChar.isBlue = false;
	m_FTRChar.secondCharName = '@';

	m_Refined1Char.charName = '@';
	m_Refined1Char.isBlue = false;
	m_Refined1Char.secondCharName = '@';
	
	m_Refined2Char.charName = '@';
	m_Refined2Char.isBlue = false;
	m_Refined2Char.secondCharName = '@';
	


	//m_CharShortAverage[0] = 0; // top
	//m_CharShortAverage[1] = 0; // ntop
	//m_CharShortAverage[2] = 0; // bottom
	//m_CharShortAverage[3] = 0; // nbottom
	
	
}

void CDIACharacter::CreateCharacterFromImage(CImage * CharImage)

{
	m_Height = CharImage->GetHeight();
	m_Width = CharImage->GetWidth();
	m_Position_Y = 0;
	m_Position_X = 0;
	m_pCharacterProjH = new long [m_Height];
	m_pCharacterProjV = new long [m_Width];
	CharImage->GetProjection(m_Position_X,m_Position_Y,m_Width,m_Height,m_pCharacterProjH, m_pCharacterProjV ,PRJ_GREY);
	m_pCharacterDistributionH = new CDistribution <long>;
	m_pCharacterDistributionH->Create(m_pCharacterProjV,m_Width);
	m_pCharacterDistributionV = new CDistribution <long>;
	m_pCharacterDistributionV->Create(m_pCharacterProjH,m_Height);
	m_pCharImage = new CDIAGreyScale;
	m_pLocatedCharImage = new CDIAGreyScale;
	

	m_pCharImage->CreateFromImage(CharImage,0);
	m_CharNum = 0;
	m_CharLineNum = 0;
	m_pLocatedCharImage->CreateFromImage(CharImage,0);
	m_LocatedWidth = m_Width;
	m_LocatedHeight = m_Height;

	m_CharLocation.top = 0;
	m_CharLocation.left = 0;
	m_CharLocation.bottom = m_Height;
	m_CharLocation.right = m_Width;

}

void CDIACharacter::DeleteCharacter()
{
	m_Width = NULL;
	m_Height = NULL;
	m_Position_Y = NULL;
	m_Position_X = NULL;
	m_pCharacterProjH = NULL;
	m_pCharacterProjV = NULL;
	delete m_pCharacterProjH;
	delete m_pCharacterProjV;
	m_pCharacterDistributionH = NULL;
	delete[] m_pCharacterDistributionH;
	m_pCharacterDistributionV = NULL;
	delete[] m_pCharacterDistributionV;
	m_pCharImage = NULL;
	delete m_pCharImage;
	m_pLocatedCharImage = NULL;
	delete m_pLocatedCharImage;
}

int CDIACharacter::GetWidth()
{
	return m_Width;
}
long CDIACharacter::GetHeight()
{
	return m_Height;
}
long CDIACharacter::GetPosX()
{
	return m_Position_X;
}
long CDIACharacter::GetPosY()
{
	return m_Position_Y;
}

void CDIACharacter::CreateCharImage(CImage * Image, bool flag)
{

	if (flag == true)
	{	//true means that it is the first time that CharImage is created
		m_pCharImage->Create(m_Width,m_Height,RGB(11,11,11),0);
		
	}
	for (int i = 0; i < m_Width; i++)
		{
			for (int j = 0; j < m_Height; j++)
			{
				BYTE value = Image->GetRed(m_Position_X + i,m_Position_Y + j);
				m_pCharImage->SetRGBColor(i,j,RGB(value,value,value));
			}
		}
}

void CDIACharacter::CreateLocatedCharImage(CDIAGreyScale * Image, bool flag)
{
	
	if (flag == true)
	{	//true means that it is the first time that LocatedCharImage is created
		m_pLocatedCharImage->Create(m_LocatedWidth,m_LocatedHeight,RGB(11,11,11),0);
		CString value = m_pLocatedCharImage->GetImageMap(0)->GetName();//GetPTName(0);
		m_charUncertainAreas = new int*[m_LocatedWidth];
		for (int i = 0; i < m_LocatedWidth; i++)
		{
			m_charUncertainAreas[i] = new int[m_LocatedHeight];
		}
		m_pLocatedCharImage->GetImageMap(0)->SetPixelType(1,_T("PT_STR_FOREGROUND"),0,255,0,true); //black
		m_pLocatedCharImage->GetImageMap(0)->SetPixelType(2,_T("PT_STR_FREE"),128,0,128,false); //violeta
		LPCTSTR value1 = m_pLocatedCharImage->GetImageMap(0)->GetPTName(1);
		//m_pLocatedCharImage->GetImageMap(0)->SetPTColour(0,128,0,0);
		
	}

	for (int i = 0; i < m_LocatedWidth; i++)
		{
			for (int j = 0; j < m_LocatedHeight; j++)
			{
				CPoint point;
				if ((i + m_CharLocation.left) < 0)
					point.x = 0;
				else 
					point.x = i + m_CharLocation.left;
				if ((j + m_CharLocation.top) < 0)
				{
					point.y = 0;
				}else 
					point.y = j + m_CharLocation.top;

				if (((point.x) < Image->GetWidth()) && ((point.y) < Image->GetHeight()))
				{
					BYTE value = Image->GetRed(point.x,point.y);
					m_pLocatedCharImage->SetRGBColor(i,j,RGB(value,value,value));
					if (value < 5)
					{
						//then it is foreground
						BYTE PTForeground = m_pLocatedCharImage->GetImageMap(0)->GetPTByteLabel(PT_STR_FOREGROUND);
						m_pLocatedCharImage->GetImageMap(0)->SetMapByte(i,j,PTForeground);
					}
					else if (value > 250)
					{
						//then it is background 
						BYTE PTBackground = m_pLocatedCharImage->GetImageMap(0)->GetPTByteLabel(PT_STR_BACKGROUND);
						m_pLocatedCharImage->GetImageMap(0)->SetMapByte(i,j,PTBackground);
					}else
					{
						//then is fuzzy
						BYTE PTFuzzy = m_pLocatedCharImage->GetImageMap(0)->GetPTByteLabel(PT_STR_FREE);
						m_pLocatedCharImage->GetImageMap(0)->SetMapByte(i,j,PTFuzzy);
					}
					//m_pLocatedCharImage->GetImageMap(0)->MapByteAddAttribute(point.x,point.y,
				}
			}
		}

	
	
	

	/*m_pLocatedCharImage->UpdateMap(0, 5,PTForeground);
	m_pLocatedCharImage->UpdateMap(250, 255,PTBackground);
	m_pLocatedCharImage->UpdateMap(6, 249,PTFuzzy);*/

}
void CDIACharacter::LocateChar(CDIAGreyScale * Image)
{
	int firstValT = m_Height;
	int firstValB = 0;
	int	firstValL = m_Width;
	int firstValR = 0;
	int threshval = 128;
	int BlackRun = 0;
	int BlackRunRow = -1;
	int WhiteRun = 0;
	int WhiteRunRow = -1;
	//if (clean) threshval = 64;
	int i = 0;
	int j = 0;
	
	while ((i <= m_Width-1) && ( j < m_Height-1))
	{
		if ( i == m_Width-1)
		{
			if (j != m_Height-1)
			{
				i = 0;
			}
			j++;
		}
		//CalculateForegroundPercentage(false);
		//int value =	(int) GetRValue(ApplyHistoTransformation(Image)->GetRGBColor(i,j));
		int value =	(int) GetRValue(Image->GetRGBColor(i,j));

		if (value <= threshval) 
		//if (m_foreground25 < 0)
		//	m_foreground25 = threshval;
		//if (value <= m_foreground25)
		{
			value = 0;
		}
		else
		{
			value = 255;
		}
		if (value == 0)
		{
			if (j < firstValT) 
			{
				firstValT = j;
			}
			if (j > firstValB) firstValB = j+1;
			if (i < firstValL) firstValL = i;
			if (i > firstValR) firstValR = i+1;
		}
		i++;
	}
	m_CharLocation.top = firstValT;
	m_CharLocation.bottom = firstValB;
	m_CharLocation.left = firstValL;
	m_CharLocation.right = firstValR;
	m_LocatedWidth = (m_CharLocation.right - m_CharLocation.left + 1);
	m_LocatedHeight = (m_CharLocation.bottom - m_CharLocation.top + 1);
	m_CharCenter.x = (((m_CharLocation.right) - (m_CharLocation.left))/2 )+ 1 + m_CharLocation.left;
	m_CharCenter.y = (((m_CharLocation.bottom) - (m_CharLocation.top))/2) + 1 + m_CharLocation.top;
	//m_CharCenter.SetPoint(((m_CharLocation.right - m_CharLocation.left)/2),((m_CharLocation.bottom - m_CharCenter.SetPoint)/2));


	


	//now, make sure that the locating has been perfectly done.
	//check the profiles of charimage and find out if the locators are well situated
	//if the height is large enough(if it is just as big as a short character we don't bother.

	
	if ((m_CharLocation.bottom - m_CharLocation.top) > 32)
	{
		
		long * m_pVertProj;
		long * m_pHorzProj;
		
		m_pHorzProj = new long[Image->GetWidth()];
		m_pVertProj = new long[Image->GetHeight()];
	
		CDistribution <long> * m_pVertProfileDistribution;
		m_pVertProfileDistribution = new CDistribution <long>;
		

		Image->GetProjection(0,0,Image->GetWidth(),Image->GetHeight(),m_pVertProj,m_pHorzProj ,PRJ_GREY);
		m_pVertProfileDistribution->Create(m_pVertProj,Image->GetHeight());
		int LocalMaxPos = m_pVertProfileDistribution->GetLocalMaximumPos(m_CharLocation.top,GLM_SD_RIGHT,GLM_OUTOFBOUNDS_VALUES);
		int LocalMax = m_pVertProfileDistribution->GetAt(LocalMaxPos);
		CPoint GlobalMaxPos = m_pVertProfileDistribution->GetMaximum();
		if (LocalMax < (GlobalMaxPos.x /2))
		{
			//then it is wrong localized 
			//and what do we do...
			//move locator to next Localminimum that 
			//keeps the character still big enough
			int LocalMinPos = m_pVertProfileDistribution->GetLocalMinimumPos(m_CharLocation.top,GLM_SD_RIGHT,GLM_OUTOFBOUNDS_VALUES);
			int Localmin = m_pVertProfileDistribution->GetAt(LocalMinPos);
			if ((LocalMinPos - m_CharLocation.bottom) >= 24)
			{
				//then we change m_charlocation.top tp Localminpos
				m_CharLocation.top = LocalMinPos;
			}
		}
		delete m_pVertProj;
		delete m_pHorzProj;
		delete m_pVertProfileDistribution;
	}
}
void CDIACharacter::LocateChar3(CDIAGreyScale * Image)
{
	FindConnectedComponentsInChar(Image);
}
int CDIACharacter::CloseupLocation(CDIAGreyScale * Image, int threshold, int noiseSize,int start, int end, int LoopMovement, int movementVH)
{
	int BlackRuns = 0;
	int BlackRunRow = -1;
	int movingBackwards = 2;
	int movingForward = 1;
	int vertical = 1;
	int horizontal = 2;

	int WhiteRuns = 0;
	int WhiteRunRow = -1;
	bool foundflag = false;
	bool b_IsFirstBlackComp = false;
	int a;
	int temp;
	int finalVal = 0;
	int total = 1;

	for (int x = start; x < end; x++)
	{
		if (LoopMovement == movingBackwards) 
		{
			temp = end-total;
			total++;
		}
		else if (LoopMovement == movingForward) 
		{
			temp = x;
		}
		if (movementVH == vertical)
		{
		//	inrun = IsBlackInRun(x,Image);
			a = IsBlackInRun(temp, Image, threshold, vertical);
		}
		else if (movementVH == horizontal)
		{
			//inrun = IsBlackInRun(x,Image);
			a = IsBlackInRun(temp, Image, threshold, horizontal);
		}
		//a = IsBlackInRun(x, Image,threshold,2);
		if (a > 0)
		{	
			if (a > noiseSize)
			{
				if (!b_IsFirstBlackComp)
				{
					b_IsFirstBlackComp = true;
					BlackRunRow = temp;
				}
				if (BlackRuns < noiseSize)
				{
					BlackRuns++;
				}
				else 
				{
					foundflag = true;
					if (LoopMovement == movingBackwards) 
					{
						if (BlackRunRow+1 < end)
						{
							finalVal = BlackRunRow+1;
						}
						else 
						{
							finalVal = end;
						}
					}
					else if (LoopMovement == movingForward) 
					{
						if (BlackRunRow-1 >= start)
						{
							finalVal = BlackRunRow-1;
						}
						else finalVal = start;
					}
					return finalVal;
				}
							
			
			}

		}
		else //if it is 0
		{	
			if (b_IsFirstBlackComp == true)//if there were previous black runs
			{
				
				//if we have had a BlackRun b4 and it is smaller than ~4
				if (!foundflag)
				{
					if (BlackRuns < noiseSize)
					{
						/*if (m_CharLocation.bottom - x > 30)
						{*/
							//if there is space for a character
							//then look for the last white
							b_IsFirstBlackComp = false;
						//}
					}
				}
				
			}
			else
			{
				//it is not black for the second time
				//then save this location for locator.top
				//WhiteRunRow = x;
			}
			
		}
	}
	//for (int a = start; a < end; a = a++)
	//{
	//	if (LoopMovement == movingBackwards) 
	//	{
	//		x = end-a;
	//	}
	//	else if (LoopMovement == movingForward) 
	//	{
	//		x = a;
	//	}
	//	if (movementVH == vertical)
	//	{
	//		inrun = IsBlackInRun(x,Image);
	//		i = IsBlackInRun(x, Image, threshold, vertical);
	//	}
	//	else if (movementVH == horizontal)
	//	{
	//		inrun = IsBlackInRun(x,Image);
	//		i = IsBlackInRun(x, Image, threshold, horizontal);
	//	}

	//	if (i > 0) //if there is a black value then
	//	{
	//		if (!b_IsFirstBlackComp) //then it is the first point with dark values
	//		{
	//			BlackRunRow = x;
	//			BlackRuns++;
	//			b_IsFirstBlackComp = true;
	//		}
	//		else  //then this is the start
	//		{
	//			BlackRuns++;
	//		}
	//		
	//	}
	//	else if (i == 0)
	//	{
	//		if (b_IsFirstBlackComp) //then find out how big is the blackRun
	//		{
	//			if (BlackRuns <= noiseSize)
	//			{
	//				//start over again
	//				BlackRuns = 0;
	//				BlackRunRow = -1;
	//				b_IsFirstBlackComp = false;

	//			}
	//			else return BlackRunRow;
	//		}
	//	}

	//}
	return finalVal;
}
void CDIACharacter::LocateChar4(CDIAGreyScale * Image, int threshold, int noiseSize)
{
	int firstValT = m_Height;
	int firstValB = 0;
	int	firstValL = m_Width;
	int firstValR = 0;
	int vertical, horizontal;
	int topDown, BottomUp;
	vertical = 1;
	horizontal = 2;
	topDown = 1;
	BottomUp = 2;
	//top 
	firstValT = CloseupLocation(Image,threshold,noiseSize,0,m_Height-1,topDown,horizontal);
	firstValB = CloseupLocation(Image,threshold,noiseSize,0,m_Height-1,BottomUp,horizontal);
	firstValL = CloseupLocation(Image,threshold,noiseSize,0,m_Width-1,topDown,vertical);
	firstValR = CloseupLocation(Image,threshold,noiseSize,0,m_Width-1,BottomUp,vertical);

	m_CharLocation.top = firstValT;
	m_CharLocation.bottom = firstValB;
	m_CharLocation.left = firstValL;
	m_CharLocation.right = firstValR;

	m_LocatedWidth = (m_CharLocation.right - m_CharLocation.left + 1);
	m_LocatedHeight = (m_CharLocation.bottom - m_CharLocation.top + 1);

	m_CharCenter.x = (m_LocatedWidth/2 )+ m_CharLocation.left;
	m_CharCenter.y = (m_LocatedHeight/2)+ m_CharLocation.top;
	
	
}
void CDIACharacter::LocateChar2(CDIAGreyScale * Image)
{
	int firstValT = m_Height;
	int firstValB = 0;
	int	firstValL = m_Width;
	int firstValR = 0;

	int BlackRuns = 0;
	int BlackRunRow = -1;

	int WhiteRuns = 0;
	int WhiteRunRow = -1;
	bool b_IsFirstBlackComp = false;

	int i = 0;
	int j = 0;
	
	while ((i <= m_Width-1) && ( j < m_Height-1))
	{
		if ( i == m_Width-1)
		{
			if (j != m_Height-1)
			{
				i = 0;
			}
			j++;
		}
		int value =	(int) GetRValue(Image->GetRGBColor(i,j));
		
		if (value == 0)
		{
			if (j < firstValT) 
			{
				if ((j-1)< 0)
					firstValT = 0;
				else
				firstValT = j-1;
			}
			if (j > firstValB) 
			{
				if ((j + 1) > m_Height)
					firstValB = m_Height;
				else
					firstValB = j+1;
			}
			if (i < firstValL)
			{
				if ((i - 1)< 0)
					firstValL = 0;
				else
					firstValL = i-1;
			}
			if (i > firstValR)
			{
				if ((i+1)> m_Width)
					firstValR = m_Width;
				else
					firstValR = i+1;
			}
		}
		i++;
	}
	m_CharLocation.top = firstValT;
	m_CharLocation.bottom = firstValB;
	m_CharLocation.left = firstValL;
	m_CharLocation.right = firstValR;

	m_LocatedWidth = (m_CharLocation.right - m_CharLocation.left + 1);
	m_LocatedHeight = (m_CharLocation.bottom - m_CharLocation.top + 1);

	m_CharCenter.x = (m_LocatedWidth/2 )+ m_CharLocation.left;
	m_CharCenter.y = (m_LocatedHeight/2)+ m_CharLocation.top;
	//m_CharCenter.SetPoint(((m_CharLocation.right - m_CharLocation.left)/2),((m_CharLocation.bottom - m_CharCenter.SetPoint)/2));
	//check the number of runs with black pixels
	for (int x = m_CharLocation.top; x < m_CharLocation.bottom; x++)
	{
		if (IsBlackInRun(x, Image))
		{	
			
			if (BlackRunRow == -1)
			{
				BlackRunRow = x;
				BlackRuns = 1;
				b_IsFirstBlackComp = true;
			}
			else
			{
				if (b_IsFirstBlackComp == true)
				{
					if (BlackRunRow != x)
					{
						BlackRunRow = x;
						BlackRuns++;
					}
				}
				else
				{
					//then the previous row will be the locator.top
					m_CharLocation.top = WhiteRunRow;
				}
			
			}

		}
		else
		{	
			if (b_IsFirstBlackComp == true)
			{
				
				//if we have had a BlackRun b4 and it is smaller than ~4
				if (BlackRuns < 5)
				{
					if (m_CharLocation.bottom - x > 24)
					{
						//if there is space for a character
						//then look for the last white
						b_IsFirstBlackComp = false;
					}
				}
				
			}
			else
			{
				//it is not black for the second time
				//then save this location for locator.top
				WhiteRunRow = x;
			}
			
		}
	}

}
void CDIACharacter::LocateChar5(CDIAGreyScale * Image, int threshold, int noiseSize)
{
	int firstValT = m_Height;
	int firstValB = 0;
	int	firstValL = m_Width;
	int firstValR = 0;

	

	int i = 0;
	int j = 0;
	
	while ((i <= m_Width-1) && ( j < m_Height-1))
	{
		if ( i == m_Width-1)
		{
			if (j != m_Height-1)
			{
				i = 0;
			}
			j++;
		}
		int value =	(int) GetRValue(Image->GetRGBColor(i,j));
		
		if (value <= threshold)
		{
			if (j < firstValT) 
			{
				if ((j-1)< 0)
					firstValT = 0;
				else
				firstValT = j-1;
			}
			if (j > firstValB) 
			{
				if ((j + 1) > m_Height)
					firstValB = m_Height;
				else
					firstValB = j+1;
			}
			if (i < firstValL)
			{
				if ((i - 1)< 0)
					firstValL = 0;
				else
					firstValL = i-1;
			}
			if (i > firstValR)
			{
				if ((i+1)> m_Width)
					firstValR = m_Width;
				else
					firstValR = i+1;
			}
		}
		i++;
		
	}
	m_CharLocation.top = firstValT;
	
	m_CharLocation.bottom = firstValB + 1;
	if(m_CharLocation.bottom >= m_Height) m_CharLocation.bottom = m_Height-1;
	m_CharLocation.left = firstValL;
	m_CharLocation.right = firstValR + 1;
	if(m_CharLocation.right >= m_Width) m_CharLocation.right = m_Width-1;

	
	//m_CharCenter.SetPoint(((m_CharLocation.right - m_CharLocation.left)/2),((m_CharLocation.bottom - m_CharCenter.SetPoint)/2));
	//check the number of runs with black pixels
	int BlackRuns = 0;
	int BlackRunRow = -1;

	int WhiteRuns = 0;
	int WhiteRunRow = -1;
	bool foundflag = false;
	bool b_IsFirstBlackComp = false;
	//int a;
	//tight it in all directions
	m_CharLocation.top = CloseupLocation(Image,threshold,noiseSize,m_CharLocation.top,m_CharLocation.bottom,1,2);
	m_CharLocation.bottom =CloseupLocation(Image,threshold,noiseSize,m_CharLocation.top,m_CharLocation.bottom,2,2);
	m_CharLocation.left = CloseupLocation(Image,threshold,noiseSize,m_CharLocation.left,m_CharLocation.right,1,1);
	m_CharLocation.right = CloseupLocation(Image,threshold,noiseSize,m_CharLocation.left,m_CharLocation.right,2,1);

	m_LocatedWidth = (m_CharLocation.right - m_CharLocation.left + 1);
	m_LocatedHeight = (m_CharLocation.bottom - m_CharLocation.top + 1);

	m_CharCenter.x = (m_LocatedWidth/2 )+ m_CharLocation.left;
	m_CharCenter.y = (m_LocatedHeight/2)+ m_CharLocation.top;
	//for (int x = m_CharLocation.top; x < m_CharLocation.bottom; x++)
	//{
	//	a = IsBlackInRun(x, Image,threshold,2);
	//	if (a > 0)
	//	{	
	//		if (a > noiseSize)
	//		{
	//			if (!b_IsFirstBlackComp)
	//			{
	//				b_IsFirstBlackComp = true;
	//				BlackRunRow = x;
	//			}
	//			if (BlackRuns < noiseSize)
	//			{
	//				BlackRuns++;
	//			}
	//			else 
	//			{
	//				foundflag = true;
	//				m_CharLocation.top = BlackRunRow-1;
	//			}
	//			
	//		
	//		}

	//	}
	//	else //if it is 0
	//	{	
	//		if (b_IsFirstBlackComp == true)//if there were previous black runs
	//		{
	//			
	//			//if we have had a BlackRun b4 and it is smaller than ~4
	//			if (!foundflag)
	//			{
	//				if (BlackRuns < noiseSize)
	//				{
	//					/*if (m_CharLocation.bottom - x > 30)
	//					{*/
	//						//if there is space for a character
	//						//then look for the last white
	//						b_IsFirstBlackComp = false;
	//					//}
	//				}
	//			}
	//			
	//		}
	//		else
	//		{
	//			//it is not black for the second time
	//			//then save this location for locator.top
	//			//WhiteRunRow = x;
	//		}
	//		
	//	}
	//}

}

void CDIACharacter::LocateChar6(CDIAGreyScale * Image, int threshold, int noiseSize)
{
	int firstValT = m_Height;
	int firstValB = 0;
	int	firstValL = m_Width;
	int firstValR = 0;

	

	int i = 0;
	int j = 0;
	
	while ((i+1 <= m_Width) && ( j+1 < m_Height))
	{
		if ( i+1 == m_Width)
		{
			if (j+1 != m_Height)
			{
				i = 0;
			}
			j++;
		}
		int value =	(int) GetRValue(Image->GetRGBColor(i,j));
		
		if (value <= threshold)
		{
			if (j < firstValT) 
			{
				if ((j-1)< 0)
					firstValT = 0;
				else
				firstValT = j-1;
			}
			if (j > firstValB) 
			{
				if ((j + 1) > m_Height)
					firstValB = m_Height;
				else
					firstValB = j+1;
			}
			if (i < firstValL)
			{
				if ((i - 1)< 0)
					firstValL = 0;
				else
					firstValL = i-1;
			}
			if (i > firstValR)
			{
				if ((i+1)> m_Width)
					firstValR = m_Width;
				else
					firstValR = i+1;
			}
		}
		i++;
		
	}
	m_CharLocation.top = firstValT;
	
	m_CharLocation.bottom = firstValB + 1;
	if(m_CharLocation.bottom >= m_Height) m_CharLocation.bottom = m_Height-1;
	m_CharLocation.left = firstValL;
	m_CharLocation.right = firstValR + 1;
	if(m_CharLocation.right >= m_Width) m_CharLocation.right = m_Width-1;

	
	//m_CharCenter.SetPoint(((m_CharLocation.right - m_CharLocation.left)/2),((m_CharLocation.bottom - m_CharCenter.SetPoint)/2));
	//check the number of runs with black pixels
	int BlackRuns = 0;
	int BlackRunRow = -1;

	int WhiteRuns = 0;
	int WhiteRunRow = -1;
	bool foundflag = false;
	bool b_IsFirstBlackComp = false;
	//int a;
	//tight it in all directions
	m_CharLocation.top = CloseupLocation(Image,threshold,noiseSize,m_CharLocation.top,m_CharLocation.bottom,1,2);
	m_CharLocation.bottom =CloseupLocation(Image,threshold,noiseSize,m_CharLocation.top,m_CharLocation.bottom,2,2);
	m_CharLocation.left = CloseupLocation(Image,threshold,noiseSize,m_CharLocation.left,m_CharLocation.right,1,1);
	m_CharLocation.right = CloseupLocation(Image,threshold,noiseSize,m_CharLocation.left,m_CharLocation.right,2,1);

	m_LocatedWidth = (m_CharLocation.right - m_CharLocation.left + 1);
	m_LocatedHeight = (m_CharLocation.bottom - m_CharLocation.top + 1);

	m_CharCenter.x = (m_LocatedWidth/2 )+ m_CharLocation.left;
	m_CharCenter.y = (m_LocatedHeight/2)+ m_CharLocation.top;
	//for (int x = m_CharLocation.top; x < m_CharLocation.bottom; x++)
	//{
	//	a = IsBlackInRun(x, Image,threshold,2);
	//	if (a > 0)
	//	{	
	//		if (a > noiseSize)
	//		{
	//			if (!b_IsFirstBlackComp)
	//			{
	//				b_IsFirstBlackComp = true;
	//				BlackRunRow = x;
	//			}
	//			if (BlackRuns < noiseSize)
	//			{
	//				BlackRuns++;
	//			}
	//			else 
	//			{
	//				foundflag = true;
	//				m_CharLocation.top = BlackRunRow-1;
	//			}
	//			
	//		
	//		}

	//	}
	//	else //if it is 0
	//	{	
	//		if (b_IsFirstBlackComp == true)//if there were previous black runs
	//		{
	//			
	//			//if we have had a BlackRun b4 and it is smaller than ~4
	//			if (!foundflag)
	//			{
	//				if (BlackRuns < noiseSize)
	//				{
	//					/*if (m_CharLocation.bottom - x > 30)
	//					{*/
	//						//if there is space for a character
	//						//then look for the last white
	//						b_IsFirstBlackComp = false;
	//					//}
	//				}
	//			}
	//			
	//		}
	//		else
	//		{
	//			//it is not black for the second time
	//			//then save this location for locator.top
	//			//WhiteRunRow = x;
	//		}
	//		
	//	}
	//}

}
bool CDIACharacter::IsBlackInRun(int row, CDIAGreyScale * Image)
{
	bool ReturnVal = false;
	for (int i = 0; i < Image->GetWidth(); i++)
	{
		int value =	(int) GetRValue(Image->GetRGBColor(i,row));
		if (value == 0) 
			ReturnVal = true;
	}
	return ReturnVal;
}
int CDIACharacter::IsBlackInRun(int row, CDIAGreyScale * Image, int threshold, int vorh)
{
	bool flag = false;
	int total = 0;
	int size = -1;
	int x, y;
	x = 0;
	y = 0;
	if (vorh == 1) //then checking a vertical row (left /right)
	{
		size = Image->GetHeight();
		for (int i = 0; i < size; i++)
		{
			int value =	(int) GetRValue(Image->GetRGBColor(row,i));
			if (value <= threshold) 
			{
				total++;
				flag = true;
			}
		}
	}
	else if (vorh == 2) //then checking horizontal row (top down)
	{
		size = Image->GetWidth();
		for (int i = 0; i < size; i++)
		{
			int value =	(int) GetRValue(Image->GetRGBColor(i,row));
			if (value <= threshold) 
			{
				total++;
				flag = true;
			}
		}
	}
	if (flag)
	{
		//return total;
		return total;
	}
	else return 0;
}
void CDIACharacter::ClassifyCharacterType(int CharShortAverage[])
{
	//This classify the character in short or tall
	int Width, Height;
	float val;
	
	//It has to be called after the character inner-box has been located
	if (m_CharLocation.top >= 0 )
	{
		Width = m_CharLocation.right - m_CharLocation.left + 1;
		Height = m_CharLocation.bottom - m_CharLocation.top + 1;
		//size = width * height;
		if (Width <= 35)//23 temporal testing value
		{
			if (Width == Height)
			{
				m_CharType[0] = 1;
				CharShortAverage[0] += m_CharLocation.top;
				CharShortAverage[1] ++;
				CharShortAverage[2] += m_CharLocation.bottom;
				CharShortAverage[3] = Width * Height;
			
			}
			else
			{
				if (Height > Width)
					val = ((float)(Height - Width)/ (float)(Height + Width)) * 100;
				else 
					val = ((float)(Width - Height)/ (float)(Height + Width)) * 100;
		
				if ((val > 8) || (Height > 32)) //32 testing value
				{
					m_CharType[0] = 0;
				}
				else 
				{
					m_CharType[0] = 1;
					CharShortAverage[0] += m_CharLocation.top;
					CharShortAverage[1] ++;
					CharShortAverage[2] += m_CharLocation.bottom;
					CharShortAverage[3] = Width * Height;
				}
			}
		}else  m_CharType[3] = 1;
		//if the character is too wide then is wrong segmented
	}
	

}

void CDIACharacter::ClassifyCharacterType2(int CharShortAverage[])
{
	//This classify the character in short, punctuation or tall(high and low)
	int Width, Height;
	float val;
	
	//It has to be called after the character inner-box has been located
	if (m_CharLocation.top >= 0 )
	{
		Width = m_CharLocation.right - m_CharLocation.left + 1;
		Height = m_CharLocation.bottom - m_CharLocation.top + 1;
		//size = width * height;
		if (Width <= 35)//23 temporal testing value
		{//if it is wider than 35 then is wrong segmented
			if (Width == Height)
			{
				if ((Height < 25) && (Width < 21))
				{
					//punctuation
					m_CharType[4] = 1;
				}
				else
				{
					m_CharType[0] = 1;
					CharShortAverage[0] += m_CharLocation.top;
					CharShortAverage[1] ++;
					CharShortAverage[2] += m_CharLocation.bottom;
					CharShortAverage[3] = Width * Height;
				}
			}
			else
			{
				if (Height > Width)
					val = ((float)(Height - Width)/ (float)(Height + Width)) * 100;
				else 
					val = ((float)(Width - Height)/ (float)(Height + Width)) * 100;

				if ((Height < 24) && (Width < 20))
				{
					m_CharType[4] = 1;
				}
				else
				{

					if ((val > 8) || (Height > 32)) //32 testing value
					{//it is a tall character
						if ((Height < 28) && (Width < 21)) m_CharType[4] = 1;
						else m_CharType[0] = 0;
					}
					else 
					{
						//if ((Height < 25) && (Width < 21)) //punctuation 
						//{
						//	m_CharType[4] = 1;
						//}
						//else
						//{
							m_CharType[0] = 1;
							CharShortAverage[0] += m_CharLocation.top;
							CharShortAverage[1] ++;
							CharShortAverage[2] += m_CharLocation.bottom;
							CharShortAverage[3] = Width * Height;
						//}
					}
				}
			}
		}else  m_CharType[3] = 1;
		//if the character is too wide then is wrong segmented
	}

}

void CDIACharacter::ClassifyCharacterType3(int CharShortAverage[])
{
	//This classify the character in short, punctuation or tall(high and low)
	int Width, Height;
	
	
	//It has to be called after the character has been located
	if (m_CharLocation.top >= 0 )
	{
		Width = m_LocatedWidth;
		Height = m_LocatedHeight;
		if (Height >= 33) //the is tall //old value 33
		{
			
			m_CharFinalType = 1;
		}
		else //is short or punctuation
		{
			if (Width <= 18) //punctuation//old value 22
			{
				if (Height <= 20)
				{
					m_CharFinalType = 4;
				}else 
					m_CharFinalType = 3; //error

			}
			else //18 < short < 30
			{
				m_CharFinalType = 0;
				
				CharShortAverage[0] += m_CharLocation.top;
				CharShortAverage[1] ++;
				CharShortAverage[2] += m_CharLocation.bottom;
				CharShortAverage[3] = Width * Height;
			}
		}
		if (Width > 35) 
		{
			//error
			m_CharFinalType = 3;
		}
	
	}

}
void CDIACharacter::ClassifyCharacterType32(int CharShortAverage[])
{
	//This classify the character in short, punctuation or tall(high and low)
	int Width, Height;
	
	
	//It has to be called after the character has been located
	if (m_CharLocation.top >= 0 )
	{
		Width = m_LocatedWidth;
		Height = m_LocatedHeight;
		if (Height >= 33) //the is tall //old value 33
		{
			
			m_CharFinalType = 1;
		}
		else //is short or punctuation
		{
			if (Width <= 21)
			{
				m_CharFinalType = 4;
			}
			else
			{

			//if (Width <= 18) //punctuation//old value 22
			//{
			//	if (Height <= 20)
			//	{
			//		m_CharFinalType = 4;
			//	}else 
			//		m_CharFinalType = 3; //error

			//}
			//else //18 < short < 30
			//{
				m_CharFinalType = 0;
				
				CharShortAverage[0] += m_CharLocation.top;
				CharShortAverage[1] ++;
				CharShortAverage[2] += m_CharLocation.bottom;
				CharShortAverage[3] = Width * Height;
			}
		}
		if (Width > 33) 
		{
			//error
			m_CharFinalType = 3;
		}
	
	}

}
void CDIACharacter::ClassifyCharacterType4()
{
	//This classify the character in short, punctuation or tall(high and low)
	int Width, Height;
	
	
	//It has to be called after the character has been located
//	if (m_CharLocation.top >= 0 )
	//{
		Width = m_LocatedWidth;
		Height = m_LocatedHeight;
		if (Height >= 33) //the is tall //old value 33
		{
			
			m_CharFinalType = 1;
		}
		else //is short or punctuation
		{
			if (Width <= 18) //punctuation//old value 22
			{
				if (Height <= 20)
				{
					m_CharFinalType = 4;
				}else 
					m_CharFinalType = 3; //error

			}
			else //18 < short < 30
			{
				m_CharFinalType = 0;
				
				//CharShortAverage[0] += m_CharLocation.top;
				//CharShortAverage[1] ++;
				//CharShortAverage[2] += m_CharLocation.bottom;
				//CharShortAverage[3] = Width * Height;
			}
		}
		if (Width > 35) 
		{
			//error
			m_CharFinalType = 3;
		}
	
	//}

}
void CDIACharacter::CreateCharacterHisto(CDocImAnDoc* doc)
{
	CRect rect(m_Position_X, m_Position_Y,m_Position_X + m_Width,m_Position_Y + m_Height);
	m_charHisto.m_pdoc = doc;
	for (int i = 0; i < 255;i++)
	{
		m_charHisto.m_inHistogram[i] = 0;
	}
	m_charHisto.ComputeHistogram(m_charHisto.m_inHistogram,&m_charHisto.m_maxvalueInHisto,rect,m_charHisto.m_pdoc->GetActiveImage());
	int max = 0;
	for (int i = 0; i < 255; i++)
	{
		if (m_charHisto.m_inHistogram[i] > max)

			max = m_charHisto.m_inHistogram[i];
	}
	m_charHisto.m_maxvalueInHisto = max;
}

void CDIACharacter::CreateCharacterForegrBackgrHisto(CDocImAnDoc* doc)
{
	//copy the m_charHisto into the m_charBackgrHisto
	//and initialise m_charForeHisto
	m_charBackgrHisto.m_pdoc = doc;
	m_charForegrHisto.m_pdoc = doc;
	for (int i = 0; i < 255;i++)
	{
		m_charBackgrHisto.m_inHistogram[i] = m_charHisto.m_inHistogram[i];
		m_charForegrHisto.m_inHistogram[i] = 0;
	}
	//for every pixel in the located box, add it to one and deduce it to the other

	for (int i = m_CharLocation.left; i < m_CharLocation.right; i++)
	{
		for (int j = m_CharLocation.top; j < m_CharLocation.bottom; j++)
		{
			int pixel = (int)GetRValue(doc->GetActiveImage()->GetRGBColor(m_Position_X + i,m_Position_Y + j));
			m_charBackgrHisto.m_inHistogram[pixel]--;
			m_charForegrHisto.m_inHistogram[pixel]++;
		}
	}
	
}




void CDIACharacter::ClassifyCharacterType4(int Width, int Height)
{
	//This classify the character in short, punctuation or tall(high and low)
	//int Width, Height;
	//float val;
	
	//It has to be called after the character inner-box has been located

	if (m_CharLocation.top >= 0 )
	{
		if (Height >= 33) //the is tall
		{
			m_CharFinalType = 1;
			
		}
		else //is short or punctuation
		{
			if ((Width <= 18) || (Height <= 22))//punctuation
			{
				m_CharFinalType = 4;
			}
			else //short
			{
				
				m_CharFinalType = 0;
			   // CharShortAverage[0] += m_CharLocation.top;
			//	CharShortAverage[1] ++;
				//CharShortAverage[2] += m_CharLocation.bottom;
				//CharShortAverage[3] = Width * Height;
			}
		}
		if (Width > 35) 
		{
			m_CharFinalType = 3;
			//m_CharType[3] = 1;
		}
	
	}
	/*for (int i = 0; i < 5; i++)
	{
		if (m_CharType[i] == 1) m_CharFinalType = i;
	}*/
}

//void CDIACharacter::ClassifyCharacterType5(int Width, int Height)
//{
//	
//	double TypeClass;
//	//InitFuzzyRules("C:\\Documents and Settings\\Celia.APHRODITE\\My Documents\\Memorial Images\\FuzzyClass2DPlot2.fis",0);
//	InitFuzzyRules("H:\\My Documents\\Celia\\My Soft\\February07\\matlab\\work\\FuzzyClass2DPlot2.fis",0);		
//	SetupInputOutputMemory(10);			//1000 input/output 
//
//	int nCols=0,nRows=0;
//	double **inputs = GetInputPointer(&nCols,&nRows);	//pointer to the inputs, 1000 by how many inputs the fis file defines
//
//	int oCols=0,oRows;
//	double **outputs = GetOutputPointer(&oCols,&oRows);	//pointer to the oututs, 1000 by number of outputs defined by the fis file
//
//	for(int x=0;x<10;x++)
//	{
//		inputs[x][0] = Width;
//		inputs[x][1] = Height;		//pack all the required data into the DLL
//		//inputs[y][2] = data3[x];
//	}
//	DoFuzzyLogic();		//process all the data one-by-one 
//	
//	for(int y=0;y<10;y++)		//redraw the scan line
//	{
//		TypeClass = outputs[y][0];	//need to get the results out of the DLL
//	}
//
//	m_CharFinalType = (int)ceil(TypeClass);
//
//	killMemory();			//reset all the used memory 
//	
//
//}

void CDIACharacter::ClassifyTallCharacter(int CharShortAverage[], int Tallest[2])
{
	if (m_CharFinalType == 1) //then it is a tall character
	{
		float averageTop = (float) CharShortAverage[0]/CharShortAverage[1];
		float averageBottom = (float) CharShortAverage[2]/CharShortAverage[1];
		float valBottom = (float)((max(averageBottom, m_CharLocation.bottom)-  min(averageBottom, m_CharLocation.bottom))/(m_CharLocation.bottom + averageBottom)* 100);
		float valTop = (float)((max(averageTop, m_CharLocation.top)-  min(averageTop, m_CharLocation.top))/(m_CharLocation.top + averageTop)* 100);
		//float averageSize = (float) CharShortAverage[3]/CharShortAverage[1];
		//float charsize =(m_CharLocation.top-m_CharLocation.bottom + 1)* (m_CharLocation.right - m_CharLocation.left + 1);
		//float valsize = (float) ((max(averageSize, charsize)-  min(averageSize, charsize))/(charsize + averageSize)* 100);
		
		if (valTop > 10) //is a high character
		{
			//it is a high-tall character
			//m_CharType[1] = 1;
			m_CharFinalType = 1;
			if (m_CharLocation.top + m_Position_Y > Tallest[0]) 
				Tallest[0] = m_CharLocation.top + m_Position_Y;
				
			if (valBottom > 10)
			{	
				if (valBottom > valTop)
				{
					//it is a low character
					//m_CharType[2] = 1;
					//m_CharType[1] = 0;
					m_CharFinalType = 2;
					if (m_CharLocation.bottom + m_Position_Y > Tallest[1]) 
						Tallest[1] = m_CharLocation.bottom + m_Position_Y;
				}
			}
		}else
		{
			if (valBottom > 4)
			{
				//it is a low character
				//m_CharType[2] = 1;
				m_CharFinalType = 2;
				if (m_CharLocation.bottom + m_Position_Y > Tallest[1]) Tallest[1] = m_CharLocation.bottom + m_Position_Y;
			}
		}
	}
	
}
void CDIACharacter::ClassifyTallCharacter2(int CharShortAverage[], int Tallest[2])
{
	if (m_CharFinalType == 1) //then it is a tall character
	{
		//if the bottom of the located character is closer to the bottom of the character than average.
		if ((m_LocatedHeight > 42)&& (m_LocatedWidth < 22))
		{
			//it is a j and is type 2.
			m_CharFinalType = 2;
		}
		if (m_CharLocation.top > (m_Height - m_CharLocation.bottom))
		{
		
			if ( m_Height - m_CharLocation.bottom < 4) 
			{
				if (m_CharLocation.top > 10)
				{
					m_CharFinalType = 2;
				}
			}
		}
	}
	
}
void CDIACharacter::ClassifyTallCharacter2(int CharShortAverage[], int Tallest[2], int index)
{
	bool found = false;
	if (m_CharFinalType == 1) //then it is a tall character
	{
		//find the position in line of nearest tall and short
		
		//if the bottom of the located character is closer to the bottom of the character than average.
		if ((m_LocatedHeight > 42)&& (m_LocatedWidth <= 23))
		{
			//it is a j and is type 2.
			m_CharFinalType = 2;
			found = true;
		}

		int smallCharTop = 0;
		int tallchartop = 0;
		int val;
		int i = 0;
		
		while (!found)
		{
			if (index -1 - i >= 0)
			{
				val = index - 1 - i;
			}
			else if (index + 1 + i < GetDocument()->m_pLineHolder[m_CharLineNum].m_CharacterHolderIndex)
			{
				val = index + 1 + i;
			}
			else 
			{
				//error
				val= index;
			}
				int type = GetDocument()->m_pLineHolder[m_CharLineNum].m_pCharacterHolder[val].m_CharFinalType;
				int top = GetDocument()->m_pLineHolder[m_CharLineNum].m_pCharacterHolder[val].m_CharLocation.top;
				int bottom = GetDocument()->m_pLineHolder[m_CharLineNum].m_pCharacterHolder[val].m_CharLocation.bottom;
				if (type == 1)//tall char
				{
					found = true;
					if ((top < m_CharLocation.top) && (bottom < m_CharLocation.bottom))
					{
						if ((abs(top - m_CharLocation.top) >= 4) && (abs(bottom - m_CharLocation.bottom) >= 4)/* || (abs((bottom - top) - (m_CharLocation.bottom - m_CharLocation.top ))> 5)*/ )
						{	
							m_CharFinalType = 2;
						}
					}	
				}else
				if (type == 0) //short char
				{
					found = true;
					if ((abs(top - m_CharLocation.top) < 4) && (abs(bottom - m_CharLocation.bottom) >= 4))
					{
						m_CharFinalType = 2;
					}
				}
				else //find another number
				{
					i++;
				}

		}

	}
		

		/*if (m_CharLocation.top > (m_Height - m_CharLocation.top - m_LocatedHeight))
		{
		if ( m_Height - m_CharLocation.top - m_LocatedHeight <= 4) 
		{
			if (m_CharLocation.top > 9)
			{
				m_CharFinalType = 2;
			}
		}*/
	}
	

void CDIACharacter::BackgroundAnalysis(CImage * Image)
{
	//it is called once the character inner-box has been found
	//Analyses the character outer-box, normal and smoothed version
	//finds the first value that can be used as threshold to separate fore and back
	//finds as well the highest repeated value
	
	unsigned long histo[256];
	ZeroMemory(histo, 256 * sizeof(unsigned long));
	
	for (int i = 0; i < m_Width; i++)
	{
		for (int j = 0; j < m_Height; j++)
		{
			if ((i < (m_CharLocation.left)) || ( i > (m_CharLocation.right)))
			{
				//BYTE red = GetRValue(m_pCharImage->GetRGBColor(i,j));
				//histo[red]++;
				BYTE red = Image->GetRed(m_Position_X + i, m_Position_Y + j);
				histo[red]++;
			}
			if ((i > m_CharLocation.left) && ( i < m_CharLocation.right))
			{
				if ((j < (m_CharLocation.top)) || ( j > (m_CharLocation.bottom)))
				{
					BYTE red = Image->GetRed(m_Position_X + i, m_Position_Y + j);
					histo[red]++;
				}
			}
		}
	}
	
	unsigned long highestCount, firstCount;
	int firstValue = 0;
	int highestValue = 0;
	highestCount = histo[0];
	firstCount = 0;
	double nPixelsBackground = ((m_Width - (m_CharLocation.right - m_CharLocation.left)) * (m_Height - ( m_CharLocation.bottom - m_CharLocation.top)));
	unsigned long percent =(long) ceil(nPixelsBackground * 5.0 /100.0);
	for (int x = 0; x < 256; x++)
	{
		//the minimum number of intensity pixels of the same intensity 
		//depends on the total number of pixels in the background
	
		if (histo[x] >= percent)//if there are at least 5% pixels of the total
		{
			if (firstValue == 0)
			{
				firstValue = x;
				firstCount = histo[x]; 
			}
			if (histo[x] > highestCount)
			{
				highestCount = histo[x];
				highestValue = x;
			}
		}	
	}
	m_BackgroundBegining = firstValue; 
	m_BackgroundHighest = highestValue;
	
}
void CDIACharacter::ForegroundAnalysis(CImage * Image, bool IsLocated)
{
	//creates histo of image
	ZeroMemory(m_histo, 256 * sizeof(unsigned long));
	for (int i = 0; i < m_Width; i++)
	{
		for (int j = 0; j < m_Height; j++)
		{
			if (IsLocated)
			{
				if ((i >= (m_CharLocation.left)) && ( i <= (m_CharLocation.right)))
				{
					if ((j >= (m_CharLocation.top)) && ( j <= (m_CharLocation.bottom)))
					{
						BYTE red = Image->GetRed(m_Position_X + i, m_Position_Y + j);
						m_histo[red]++;
					}
				}
			}else
			{
				int red = (int) GetRValue(Image->GetRGBColor(m_Position_X + i, m_Position_Y + j));
				m_histo[red]++;
			}
		}
	}
}

void CDIACharacter::CalculateForegroundPercentage(bool IsClean)
{
	int nPixelsForeground;
	int accumulator = 0;
	int percent;
	//Go through it and find the 40% darkest values
 	if (IsClean) //foreground40
	{
		nPixelsForeground = ((m_CharLocation.right - m_CharLocation.left+1) * ( m_CharLocation.bottom - m_CharLocation.top+1));
		/*if (m_CharType[0] == 1) percent = 45;
		else percent = 40;*/
		percent = 40;
		m_foreground40 = -1;
		//find 40% of darkest colours
		//for every value in the histo calculate when it reaches 40 percent of the total pixels
		for (int x = 0; x < 256; x ++)
		{
			accumulator += m_histo[x];
			if ((((accumulator * 100)/nPixelsForeground)>= percent) && (m_foreground40 == -1))
			{
				m_foreground40 = x;
			}
		}
	}
	else //foreground25
	{
		nPixelsForeground = m_Width* m_Height;
		percent = 20;
		m_foreground25 = -1;
		//find 25% of darkest colours
		//for every value in the histo calculate when it reaches 20 percent of the total pixels
		for (int x = 0; x < 256; x ++)
		{
			accumulator += m_histo[x];
			if ((((accumulator * 100)/nPixelsForeground)>= percent) && (m_foreground25 == -1))
			{
				m_foreground25 = x;
			}
		}
	}

}
int CDIACharacter::CalculateForegroundPercentage2(int percent, int nPixelsForeground, CImage * Image, CRect rect)
{
	int ForegroundPercent;
	int accumulator = 0;
	//calculate histogram of charImage rect
	ZeroMemory(m_histo, 256 * sizeof(unsigned long));
	for (int i = rect.left; i < rect.right; i++)
	{
		for (int j = rect.top; j < rect.bottom; j++)
		{
			int red = (int) GetRValue(Image->GetRGBColor(i,j));
			m_histo[red]++;
		}
	}

	//find out the background values
	//m_BackgroundEnd
	//m_BackgroundBegining
	m_BackgroundBegining = -1;
	ForegroundPercent = -1;
		
		//find "percent" of darkest colours
		//for every value in the histo calculate when it reaches 40 percent of the total pixels
		for (int x = 0; x < 256; x ++)
		{
			accumulator += m_histo[x];
			if ((((accumulator * 100)/nPixelsForeground)>= percent) && (ForegroundPercent == -1))
			{
				ForegroundPercent = x;
			}
			if ((m_histo[x] != 0) && (m_BackgroundBegining == -1))
			{
				m_BackgroundBegining = x;
			}
		}
		return ForegroundPercent;
	

}
void CDIACharacter::FindStrokeIntensity()
{
	//by crossing the image in two ways,
	//before smoothing and smooth the histogram afterwards
	//and smoothing image and then doing the histogram

	//pass image to array and export array to file
	
	
	
}
void CDIACharacter::ExportCharacterProjectionV()
{
	//export Vertical character Projection
	FILE * pFile;
	char Values[] = "Values";
	char c = '\n';

	CString VarName;
	VarName.Format(_T("%sCharacterProjectionV%d-%d.csv"),m_ImageName,m_CharLineNum,m_CharNum); 
	TRACE(VarName);
	pFile = _tfopen(VarName, _T("w"));

	fprintf(pFile, "%c",Values);
	fprintf(pFile, "%c",c);
	

	delete m_pCharacterProjH;
	
	delete m_pCharacterDistributionV;
	//create them again to fit the localized character
	m_pCharacterProjH = new long [(m_CharLocation.bottom - m_CharLocation.top + 1)];

	m_pCharImage->GetProjection(m_CharLocation.left,m_CharLocation.top,(m_CharLocation.right - m_CharLocation.left +1),(m_CharLocation.bottom - m_CharLocation.top + 1),m_pCharacterProjH, 0 ,PRJ_GREY);
	//p_Image->GetProjection(m_Position_X,m_Position_Y,m_Width,m_Height,m_pCharacterProjH, m_pCharacterProjV ,PRJ_GREY);
	/*m_pCharacterDistributionH = new CDistribution <long>;
	m_pCharacterDistributionH->Create(m_pCharacterProjV,(m_CharLocation.right - m_CharLocation.left +1));
	*/m_pCharacterDistributionV = new CDistribution <long>;
	m_pCharacterDistributionV->Create(m_pCharacterProjH,(m_CharLocation.bottom - m_CharLocation.top + 1));

	for (int i = 0; i < m_pCharacterDistributionV->GetCount(); i++)
	{
		fprintf(pFile,"%d,%c",m_pCharacterDistributionV->GetAt(i),c);
	}
	/*for (int i = m_CharLocation.top; i <=m_CharLocation.bottom; i++)
	{
		fprintf(pFile,"%d,%c",m_pCharacterDistributionV->GetAt(i),c);
	}*/
	//fprintf(pFile,",c);
	
	fclose(pFile);
	delete m_pCharacterProjH;
	
	delete m_pCharacterDistributionV;

}

void CDIACharacter::ExportCharacterProjectionH()
{
	//export Vertical character Projection
	FILE * pFile;
	char Values[] = "Values";
	char c = '\n';

	CString VarName;
	VarName.Format(_T("%sCharacterProjectionH%d-%d.csv"),m_ImageName,m_CharLineNum,m_CharNum); 
	TRACE(VarName);
	pFile = _tfopen(VarName, _T("w"));

	fprintf(pFile, "%c",Values);
	fprintf(pFile, "%c",c);


	//re-do m_pCharacterDistributionH
	//first delete old projectin and distribution
	
	delete m_pCharacterProjV;
	delete m_pCharacterDistributionH;
	
	//create them again to fit the localized character
	
	m_pCharacterProjV = new long [(m_CharLocation.right - m_CharLocation.left +1)];
	m_pCharImage->GetProjection(m_CharLocation.left,m_CharLocation.top,(m_CharLocation.right - m_CharLocation.left +1),(m_CharLocation.bottom - m_CharLocation.top + 1),0, m_pCharacterProjV ,PRJ_GREY);
	//p_Image->GetProjection(m_Position_X,m_Position_Y,m_Width,m_Height,m_pCharacterProjH, m_pCharacterProjV ,PRJ_GREY);
	m_pCharacterDistributionH = new CDistribution <long>;
	m_pCharacterDistributionH->Create(m_pCharacterProjV,(m_CharLocation.right - m_CharLocation.left +1));
	/*m_pCharacterDistributionV = new CDistribution <long>;
	m_pCharacterDistributionV->Create(m_pCharacterProjH,(m_CharLocation.bottom - m_CharLocation.top + 1));*/

	for (int i = 0; i < m_pCharacterDistributionH->GetCount(); i++)
	{
		fprintf(pFile,"%d,%c",m_pCharacterDistributionH->GetAt(i),c);
	}
	/*for (int i = m_CharLocation.left; i <= m_CharLocation.right; i++)
	{
		fprintf(pFile,"%d,%c",m_pCharacterDistributionH->GetAt(i),c);
	}*/
	//fprintf(pFile,",c);
	
	fclose(pFile);
	delete m_pCharacterProjV;
	delete m_pCharacterDistributionH;

}
void CDIACharacter::ExportCharacter()
{

	int **ImageArray;
	ImageArray = new int* [(m_CharLocation.bottom-m_CharLocation.top + 1)];
	for (int x = 0; x < (m_CharLocation.bottom-m_CharLocation.top + 1); x++)
	{
		ImageArray[x] = new int [(m_CharLocation.right- m_CharLocation.left +1)];
	}
	//for every value in the inner character
	
	for (int j = 0; j < (m_CharLocation.bottom - m_CharLocation.top +1); j++)
	{
		for (int i = 0; i < (m_CharLocation.right - m_CharLocation.left +1); i++)
		{
		
			int value = (int) GetRValue(m_pCharImage->GetRGBColor((m_CharLocation.left+ i),(m_CharLocation.top +j)));
			//TRACE(_T("%d"),m_pCharImage->GetRed((m_CharLocation.left + i),(m_CharLocation.top + j)));
			//TRACE(_T("%d"),m_pCharImage->GetRed(2,2));
			ImageArray[j][i] = value;
		}
	}

	//export all characters
	FILE * pFile;
	CString Column;
	char Row[] = "Row";
	char c = '\n';
//	long Cl,Rw;
	int num2 = 1;

	CString VarName;
	//CString NumChar;
	//CString m_name = m_ImageName;	
			
	//VarName = m_name ;//+ ".csv";
	//VarName += "Character"; 
	//NumChar = num;
	//VarName += NumChar;
	VarName.Format(_T("%sCharacter%d-%d.csv"),m_ImageName,m_CharLineNum,m_CharNum); 
	TRACE(VarName);
	pFile = _tfopen(VarName, _T("w"));
	for (int i = 0; i < (m_CharLocation.right - m_CharLocation.left +1);i++)
	{
		//Column.Format(_T("Column%d"), num2);
		fprintf(pFile,"Column%d,",num2);
		num2++;
	}
	fprintf(pFile, "%c",c);
	for (int i = 0; i < (m_CharLocation.right - m_CharLocation.left +1); i++)
	{
		for (int j = 0; j < (m_CharLocation.bottom - m_CharLocation.top +1); j++)
		{
			fprintf(pFile,"%d,",255-ImageArray[j][i]);
		}
		fprintf(pFile,"%c",c);
	}
	fclose(pFile);

	for (int x = 0; x < (m_CharLocation.bottom-m_CharLocation.top + 1); x++)
	{
		delete ImageArray[x];
	}
	delete []ImageArray;
}


void CDIACharacter::ApplyThreshold40(CImage * Image, int percent)
{

	//go through the character and change the pixels to black or white 
	//depending on Threshold value
	//in this case the values come from background analysis of outer box 
	//and foregroung analysis 40

	//we only apply this threshold if the Bt and Ft estimated don't overlap
	if ((m_BackgroundBegining - percent) < 15)
	{
		m_BackgroundBegining +=15;
	}

	BYTE red;
	for (int i = 0; i < m_Width; i++)
	{
		for (int j = 0; j < m_Height; j++)
		{
			BYTE white = 255;
			red = Image->GetRed(m_Position_X + i, m_Position_Y + j);
			if (red >= m_BackgroundBegining)
			{
				Image->SetRGBColor(m_Position_X + i, m_Position_Y + j, RGB(white,white,white));
			}
			red = Image->GetRed(m_Position_X + i, m_Position_Y + j);
			if (red <= percent)
			{
				Image->SetRGBColor(m_Position_X + i, m_Position_Y + j, RGB(0,0,0));
			}	
			
		}
	}

	for (int i = 0; i < m_Width; i++)
	{
		for (int j = 0; j < m_Height; j++)
		{
			red = Image->GetRed(m_Position_X + i, m_Position_Y + j);
			if ((red < m_BackgroundBegining) && ( red > percent))
			{
				//compare red value to it's neighbourhood's mean
				//if under m_foreground40 turn it to black
				//if over m_BackgroundBeguining turn it to white
				CPoint point(m_Position_X + i, m_Position_Y + j);
				double mean1 = CDocImAnView::CalculateMean(point,3,Image,Image->GetWidth(),Image->GetHeight());
				//double mean1 = CDocImAnView::CalculateMean(point,5,Image,Image->GetWidth(),Image->GetHeight());
				if (mean1 <= (percent/2)) 
					Image->SetRGBColor(m_Position_X + i, m_Position_Y + j, RGB(0,0,0));
				if (mean1 >= ((255 - m_BackgroundBegining)/2) + m_BackgroundBegining) 
					Image->SetRGBColor(m_Position_X + i, m_Position_Y + j, RGB(255,255,255));
			}
		}
	}
}
void CDIACharacter::ApplyThreshold402(CImage * Image, int PercentFore, int PercentBackg,CRect rect)
{

	
	//go through the character and change the pixels to black or white 
	//depending on Threshold value
	//in this case the values come from background analysis of outer box 
	//and foregroung analysis 40
	
	int width = rect.right - rect.right;
	int height = rect.bottom - rect.top;
	m_BackgroundBegining = PercentBackg;
	BYTE red;
	for (int i = rect.left; i < rect.right; i++)
	{
		for (int j = rect.top; j < rect.bottom; j++)
		{
			BYTE white = 255;
			red = (int) Image->GetRed(i,j);
			if (red >= m_BackgroundBegining)
			{
				Image->SetRGBColor(i,j, RGB(white,white,white));
			}
			red = (int )Image->GetRed(i,j);
			if (red <= PercentFore)
			{
				Image->SetRGBColor(i,j, RGB(0,0,0));
			}	
			
		}
	}
	
	for (int i = rect.left; i < rect.right; i++)
	{
		for (int j = rect.top; j < rect.bottom; j++)
		{
			red =(int) Image->GetRed(i,j);
			if ((red < m_BackgroundBegining) && ( red > PercentFore))
			{
				//compare red value to it's neighbourhood's mean
				//if under m_foreground40 turn it to black
				//if over m_BackgroundBeguining turn it to white
				CPoint point(i,j);
				double mean1 = CDocImAnView::CalculateMean(point,3,Image,Image->GetWidth(),Image->GetHeight());
				//double mean1 = CDocImAnView::CalculateMean(point,5,Image,Image->GetWidth(),Image->GetHeight());
				/*int median = CDocImAnView::CalculateMedian(point,15,Image,Image->GetWidth(),Image->GetHeight());
				if (median <= (PercentFore)- (PercentFore/2))
					Image->SetRGBColor(i,j, RGB(0,0,0));
				if (median >= (m_BackgroundBegining/2) + m_BackgroundBegining) 
					Image->SetRGBColor(i, j, RGB(255,255,255));*/
				if (mean1 <= (PercentFore)- (PercentFore/2))
					Image->SetRGBColor(i,j, RGB(0,0,0));
				if (mean1 >= (m_BackgroundBegining/2) + m_BackgroundBegining) 
					Image->SetRGBColor(i, j, RGB(255,255,255));
			}
		}
	}
	//for (int i = 0; i < (rect.right-rect.left); i++)
	//{
	//	for (int j = 0; j < (rect.bottom-rect.top); j++)
	//	{
	//		red = Image->GetRed(rect.left + i, rect.top + j);
	//		if ((red < m_BackgroundBegining) && ( red > percent))
	//		{
	//			//compare red value to it's neighbourhood's mean
	//			//if under m_foreground40 turn it to black
	//			//if over m_BackgroundBeguining turn it to white
	//			CPoint point(rect.left + i, rect.top + j);
	//			double mean1 = CDocImAnView::CalculateMean(point,3,Image,Image->GetWidth(),Image->GetHeight());
	//			//double mean1 = CDocImAnView::CalculateMean(point,5,Image,Image->GetWidth(),Image->GetHeight());
	//			if (mean1 <= (percent/2)) 
	//				Image->SetRGBColor(rect.left + i, rect.top + j, RGB(0,0,0));
	//			if (mean1 >= ((255 - m_BackgroundBegining)/2) + m_BackgroundBegining) 
	//				Image->SetRGBColor(rect.left + i, rect.top + j, RGB(255,255,255));
	//		}
	//	}
	//}
}
void CDIACharacter::ApplyThreshold(CImage * Image, int threshold)
{

	

	//go through the character and change the pixels to black or white 
	//depending on Threshold value
	

	//we only apply this threshold if the Bt and Ft estimated don't overlap
	for (int i = 0; i < Image->GetWidth(); i++)
	{
		for (int j = 0; j < Image->GetHeight(); j++)
		{
			BYTE white = 255;
			BYTE red = Image->GetRed(m_Position_X + i, m_Position_Y + j);
			if (red >= m_BackgroundBegining)
			{
				Image->SetRGBColor(m_Position_X + i, m_Position_Y + j, RGB(white,white,white));
			}
			red = Image->GetRed(m_Position_X + i, m_Position_Y + j);
			if (red <= threshold)
			{
				Image->SetRGBColor(m_Position_X + i, m_Position_Y + j, RGB(0,0,0));
			}	
		}
	}
}
void CDIACharacter::ApplyThreshold(CImage * Image,CRect rect, int threshold)
{

	

	//go through the character and change the pixels to black or white 
	//depending on Threshold value
	

	//we only apply this threshold if the Bt and Ft estimated don't overlap
	for (int i = 0; i < rect.Width(); i++)
	{
		for (int j = 0; j < rect.Height(); j++)
		{
			BYTE white = 255;
			BYTE red = Image->GetRed(rect.left + i, rect.top + j);
			if (red >= m_BackgroundBegining)
			{
				Image->SetRGBColor(rect.left + i, rect.top + j, RGB(white,white,white));
			}
			red = Image->GetRed(rect.left + i, rect.top + j);
			if (red <= threshold)
			{
				Image->SetRGBColor(rect.left + i, rect.top + j, RGB(0,0,0));
			}	
		}
	}
}
void CDIACharacter::ApplyThreshold(CImage * Image,CRect rect, int begin,int end, int colour)
{

	

	//go through the character and change the pixels between the range to the colour 
	//depending on Threshold value
	

	//we only apply this threshold if the Bt and Ft estimated don't overlap
	for (int i = rect.left; i < rect.right; i++)
	{
		for (int j = rect.top; j < rect.bottom; j++)
		{
			
			BYTE red = (int) Image->GetRed(i,j);
			if ((red >= begin) && (red <= end))
			{
				Image->SetRGBColor(i, j, RGB(colour, colour, colour));
			}
			
		}
	}
}
CDIAGreyScale* CDIACharacter::ApplyHistoTransformation(CDIAGreyScale * Image)
{
	CDIAGreyScale * ImageReturn;
	ImageReturn = new CDIAGreyScale;
	ImageReturn->CreateDuplicate(Image, 0);
	CDIAHistograms histo;
	int AB = 50;
	int BC = 200;
	histo.ComputeHistogram(histo.m_inHistogram,&histo.m_maxvalueInHisto,Image);
	histo.CalculateFunctionContrast(histo.m_inHistogram,AB,BC,true);
	histo.ComputeTransformation(ImageReturn,Image);
	return ImageReturn;
	//delete ImageReturn;
}
void CDIACharacter::ApplyHistoTransformation(CDIAGreyScale * Image,CDIAGreyScale* &ImageReturn)
{
	//CDIAGreyScale * ImageReturn;
	//ImageReturn = new CDIAGreyScale;
	ImageReturn->CreateDuplicate(Image, 0);
	CDIAHistograms histo;
	int AB = 50;
	int BC = 200;
	histo.ComputeHistogram(histo.m_inHistogram,&histo.m_maxvalueInHisto,Image);
	histo.CalculateFunctionContrast(histo.m_inHistogram,AB,BC,true);
	histo.ComputeTransformation(ImageReturn,Image);
	//return ImageReturn;

}

void CDIACharacter::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{	
		
		ar << m_Width << m_Height << m_Position_X << m_Position_Y << m_BackgroundBegining;
		ar << m_BackgroundEnd << m_BackgroundHighest << m_foreground40;
		ar << m_foreground25 << m_CharNum << m_CharLineNum;
		ar << m_pCharImage;
		
		ar.Write(&m_pCharacterProjH, sizeof(long)*m_Height);
		ar.Write(&m_pCharacterProjV, sizeof(long)*m_Width);
		for (int i = 0; i < 5; i++)
		{
			ar << m_CharType[i];
		}
		ar.Write(&m_CharLocation, sizeof(CRect));
		ar.Write(&m_CharCenter, sizeof(POINT));
	}
	else
	{	
		ar >> m_Width >> m_Height >> m_Position_X >> m_Position_Y >> m_BackgroundBegining;
		ar >> m_BackgroundEnd >> m_BackgroundHighest >> m_foreground40;
		ar >> m_foreground25 >> m_CharNum >> m_CharLineNum;
		ar >> m_pCharImage;
		ar.Read(&m_pCharacterProjH, sizeof(long)*m_Height);
		ar.Read(&m_pCharacterProjV, sizeof(long)*m_Width);
		for (int i = 0; i < 5; i++)
		{
			ar >> m_CharType[i];
		}
		ar.Read(&m_CharLocation, sizeof(CRect));
		ar.Read(&m_CharCenter, sizeof(POINT));
		m_pCharacterDistributionH = new CDistribution <long>;
		m_pCharacterDistributionH->Create(m_pCharacterProjV,m_Width);
		m_pCharacterDistributionV = new CDistribution <long>;
		m_pCharacterDistributionV->Create(m_pCharacterProjH,m_Height);
	}
}


void CDIACharacter::FindConnectedComponentsInChar(CDIAGreyScale * image)
{
	
	image->CCAnalysis(1);
	//int nocomp = image->GetMaxComponent();
	int Maxcomp = image->GetMaxComponent();
	CComp *comp = new CComp;
	comp = image->GetComponent(Maxcomp);
	CRect rect = comp->GetBoundingRect();
	m_CharLocation.operator =(rect);

}

int** CDIACharacter::ComputeCharDivisionBynPixels(int size)
{
	int valuew = GetWidth()/size;
	int remw = GetWidth()%size;
	//if (remw > 5) size++;
	
	int valueh =  GetHeight()/size;
	int remh = GetHeight()%size;
	//if (remh >= 5) valueh++;
	int acc, total;
	acc = 0;
	total = 0;
	int ** result;
	int indexi = 0;
	int indexj = 0;
	result = new int* [valuew];
	for (int i = 0; i < GetWidth(); i +=size)
	{
		result[indexi] = new int [valueh];
		indexj = 0;
		for (int j = 0; j < GetHeight(); j +=size)
		{
			acc = 0;
			total = 0;
			int tempvalw,tempvalh;
			if ((i + size) > GetWidth())
			{
				tempvalw = GetWidth() - i;
			}
			else
				tempvalw = size;
			for (int x= 0; x < tempvalw; x++)
			{
				if ((j + size) > GetHeight())
				{
					tempvalh = GetHeight() - j;
				}
				else 
					tempvalh = size;
				for (int y = 0; y < tempvalh; y++)
				{		
					acc += (int) GetRValue(m_pCharImage->GetRGBColor(i+x,j+y));
					total ++;
						
				}
			}
			/*int valx = div(i,size).quot;
			int valy = div(j,size).quot;*/
			result[indexi][indexj] = acc/total;
			indexj++;
		}
		indexi++;
	}
return result;
	


}
int** CDIACharacter::ComputeCharDivisionBynBoxes(CPoint size)
{

	int ** result;
	int indexi = 0;
	int indexj = 0;

	//create
	int ** total;
	total = new int* [size.x];
	result = new int* [size.x];
	for (int s = 0; s < size.x; s++)
	{
		result[s] = new int [size.y];
		total[s] = new int [size.y];
		
	}
	//initialize them
	for (int s = 0; s < size.x; s++)
	{
		for (int t = 0; t < size.y; t++)
		{
			result[s][t] = 0;
			total[s][t] = 0;
		}
	}
	//create pointer to character Location
	int width = m_LocatedWidth;
	int height = m_LocatedHeight;


	float numx,numy;
	for (int i = 0; i < width-1; i++)
	{
		for (int j = 0; j < height-1; j++)
		{
			
			numx = (float)(i*size.x)/(float)(width-1);
			//if (numx >=size.x) numx = size.x-1;
			numy = (float)(j*size.y)/(float)(height-1);
			//if (numy >= size.y) numy = size.y-1;
	
			//int posx = m_CharLocation.
			int inumx, inumy;
			inumx = (int) numx;
			inumy = (int) numy;
			result[inumx][inumy] += (int) GetRValue(m_pLocatedCharImage->GetRGBColor(i,j));
			total[inumx][inumy]++;
			
		}
	}

	for (int i = 0; i < size.x; i++)
	{
		for (int j = 0; j < size.y; j++)
		{
			if (total[i][j] != 0)
			{
				result[i][j] = (int)(result[i][j]/total[i][j]);
			}
			else 
			{
				result[i][j] = 0;
			}
		}
	}
	

	

	return result;
	

}
void CDIACharacter::CalculateStrongMaxInProjs()
{
	////
	delete m_pCharacterProjV;
	delete m_pCharacterDistributionH;
	
	//create them again to fit the localized character
	
	m_pCharacterProjV = new long [m_LocatedWidth];
	m_pCharImage->GetProjection(m_CharLocation.left,m_CharLocation.top,m_LocatedWidth,m_LocatedHeight,0, m_pCharacterProjV ,PRJ_GREY);
	m_pCharacterDistributionH = new CDistribution <long>;
	m_pCharacterDistributionH->Create(m_pCharacterProjV,m_LocatedWidth);

	delete m_pCharacterProjH;
	delete m_pCharacterDistributionV;

	//create them again to fit the localized character
	m_pCharacterProjH = new long [m_LocatedHeight];
	m_pCharImage->GetProjection(m_CharLocation.left,m_CharLocation.top,m_LocatedWidth,m_LocatedHeight,m_pCharacterProjH, 0 ,PRJ_GREY);
	m_pCharacterDistributionV = new CDistribution <long>;
	m_pCharacterDistributionV->Create(m_pCharacterProjH,m_LocatedHeight);

	//
	//vertical Distribution
	//m_pCharacterDistributionV->MovingAverage(5);
	m_pCharacterDistributionV->MovingAverage(1);
//	m_pCharacterDistributionV->AAPeakSmoothing(1.000000,0.110000,0.110000);
	m_CharVMaxCount = m_pCharacterDistributionV->GetMaximaCount();
    m_CharVMax = m_pCharacterDistributionV->GetMaximaPositions();

	//for each max go to the sides and find the minima on the sides.
	//if the minima are low enough, then it is a strong max
	int * newPos;
	int newPosCount = 0;

	newPos = new int[m_CharVMaxCount];
	int LeftMin, RightMin, LValue,RValue,MaxPos;
	for (int i = 0; i < m_CharVMaxCount;i++)
	{
		RightMin = m_pCharacterDistributionV->GetLocalMinimumPos(m_CharVMax[i],1,1);
		LeftMin = m_pCharacterDistributionV->GetLocalMinimumPos(m_CharVMax[i],0,1);
		RValue = m_pCharacterDistributionV->GetAt(RightMin);
		MaxPos = m_pCharacterDistributionV->GetAt(m_CharVMax[i]);
		LValue = m_pCharacterDistributionV->GetAt(LeftMin);
		int minLR = min(RValue,LValue);
		/*if (((RightMin - LeftMin) >= 5) && (minLR < (MaxPos - (MaxPos*15 / 100))))*/
		if (((RightMin - LeftMin) >= 5) && ((RValue < (MaxPos - (MaxPos*20 / 100))) || (LValue < (MaxPos - (MaxPos*20 / 100)))))
		{
			//if this max is very close the the previous one,
			//then just choose the highest one
			if (( m_CharVMax[i] - newPos[newPosCount-1]) < 6)
			{
				newPos[newPosCount-1] = max(m_CharVMax[i],newPos[newPosCount-1]);
			}
			else 
			{
				newPos[newPosCount] = m_CharVMax[i];
				newPosCount++;
			}
		}
	}
	//delete m_CharVMax;
	m_CharVMaxCount = newPosCount;
	//m_CharVMax = new int [m_CharVMaxCount];
	for (int i = 0; i < m_CharVMaxCount; i++)
	{
		m_CharVMax[i] = newPos[i];
	}
	
	newPos = NULL;
	delete newPos;
	

	//Horizontal Distribution
	//m_pCharacterDistributionH->MovingAverage(5);
	m_pCharacterDistributionH->MovingAverage(1);
//	m_pCharacterDistributionH->AAPeakSmoothing(1.000000,0.110000,0.110000);
	m_CharHMaxCount = m_pCharacterDistributionH->GetMaximaCount();
	m_CharHMax = m_pCharacterDistributionH->GetMaximaPositions();


	newPosCount = 0;
	newPos = new int[m_CharHMaxCount];
	//int LeftMin, RightMin, LValue,RValue,MaxPos;
	for (int i = 0; i < m_CharHMaxCount;i++)
	{
		RightMin = m_pCharacterDistributionH->GetLocalMinimumPos(m_CharHMax[i],1,1);
		LeftMin = m_pCharacterDistributionH->GetLocalMinimumPos(m_CharHMax[i],0,1);
		RValue = m_pCharacterDistributionH->GetAt(RightMin);
		MaxPos = m_pCharacterDistributionH->GetAt(m_CharHMax[i]);
		LValue = m_pCharacterDistributionH->GetAt(LeftMin);
			int minLR = min(RValue,LValue);
		/*if (((RightMin - LeftMin) > 5)&& (minLR < (MaxPos - (MaxPos*15 / 100))))*/
			if (((RightMin - LeftMin) >= 5) && ((RValue < (MaxPos - (MaxPos*20 / 100))) || (LValue < (MaxPos - (MaxPos*20 / 100)))))
			{
				if (( m_CharHMax[i] - newPos[newPosCount-1]) < 6)
			{
				newPos[newPosCount-1] = max(m_CharHMax[i],newPos[newPosCount-1]);
			}
			else 
			{
				newPos[newPosCount] = m_CharHMax[i];
				newPosCount++;
			}
				/*newPos[newPosCount] = m_CharHMax[i];
				newPosCount++;*/
			}
	}
	//delete m_CharHMax;
	m_CharHMaxCount = newPosCount;
	//m_CharHMax = new int [m_CharHMaxCount];
	for (int i = 0; i < m_CharHMaxCount; i++)
	{
		m_CharHMax[i] = newPos[i];
	}
	newPos = NULL;
	delete newPos;
	//test swithc around Hmax and Vmax.
	int test;
	test = m_CharHMaxCount;
	m_CharHMaxCount = m_CharVMaxCount;
	m_CharVMaxCount = test;

	
	
}
void CDIACharacter::CalculateMaxsDistances()
{
	//Horizontal
	if (m_CharHMaxCount >= 2)
	{
		m_HMaxDistance = abs(m_CharHMax[0]- m_CharHMax[1]);
	}else
		if (m_CharHMaxCount == 1)
		{
			m_HMaxDistance = m_CharHMax[0];
		}else m_HMaxDistance = 0;

	//Vertical
	if (m_CharVMaxCount >= 2)
	{
		m_VMaxDistance = abs(m_CharVMax[0]- m_CharVMax[1]);
	}else
		if (m_CharVMaxCount == 1)
		{
			m_VMaxDistance = m_CharVMax[0];
		}else m_VMaxDistance = 0;
}

void CDIACharacter::CalculateCrossings()
{

	m_CharCrossingsH = new CROSSINGS [m_pLocatedCharImage->GetWidth()];
	m_CharCrossingsV = new CROSSINGS [m_pLocatedCharImage->GetHeight()];
	
	int noRuns = 0;
	for (int i = 0; i < m_pLocatedCharImage->GetWidth(); i++)
	{
		m_CharCrossingsH[i].Crossings = 0;
		m_CharCrossingsH[i].NoCrossings = 0;	
	}

	for (int i = 0; i < m_pLocatedCharImage->GetHeight(); i++)
	{
		m_CharCrossingsV[i].Crossings = 0;
		m_CharCrossingsV[i].NoCrossings = 0;	
	}
	
	//calculate number of runs and add it to the crossings
	//horizontal
	int HRunIndex = 0;
	int currentRun = m_HNoRuns[0];
	int noCurrentRun = 1;
	for (int i = 1; i < m_pLocatedCharImage->GetWidth(); i++)
	{
		if (m_HNoRuns[i] == currentRun)
		{
			noCurrentRun++;
		}
		else
		{
			if (noCurrentRun > 1)
			{
				m_CharCrossingsH[HRunIndex].Crossings = currentRun;
				m_CharCrossingsH[HRunIndex].NoCrossings = noCurrentRun;
				HRunIndex++;
			}
			currentRun = m_HNoRuns[i];
			noCurrentRun = 1;
		}

	}
	m_CharCrossingsIndexH = HRunIndex;
	//m_HNoRuns2 = HRunIndex;

	//vertical
	int VRunIndex = 0;
	currentRun = m_VNoRuns[0];
	noCurrentRun = 1;

	for (int i = 1; i < m_pLocatedCharImage->GetHeight(); i++)
	{
		if (m_VNoRuns[i] == currentRun)
		{
			noCurrentRun++;
		}
		else
		{
			if (noCurrentRun > 1)
			{
				m_CharCrossingsV[VRunIndex].Crossings = currentRun;
				m_CharCrossingsV[VRunIndex].NoCrossings = noCurrentRun;
				VRunIndex++;
			}
			currentRun = m_VNoRuns[i];
			noCurrentRun = 1;
		}

	}
	//m_VNoRuns2 = VRunIndex;
	m_CharCrossingsIndexV = VRunIndex;

}

void CDIACharacter::CalculateWeight()
{
	if (m_CharFinalType == 0) //is short
	{
		m_CharWeight = 3; //small charweight or equal left and right
	}
	else //tall or low char
	{
		//find if max fall in the partition
		int partitionCentre = (m_LocatedWidth*60)/100;
		int partitionLeft = (m_LocatedWidth*40)/100;//40% of width
	
		int max = 0;
		int maxpos = 0;
		//get maxs and find in what partition are
		for (int i = 0; i < m_CharHMaxCount; i++)
		{
			//find the max of all
			//and find the partition
			if (m_pCharacterDistributionH->GetAt(m_CharHMax[i])> max)
			{
				max = m_pCharacterDistributionH->GetAt(m_CharHMax[i]);
				maxpos = m_CharHMax[i];
			}
		}
		if (maxpos < partitionLeft) m_CharWeight = 0;
		else if (maxpos < (partitionCentre)) m_CharWeight = 1;
		else m_CharWeight = 2;
	
	}
}


void CDIACharacter::FindCharacterEdges(CImage * Image, CImageMap * Map)
{
	/*CImageMap * Map;
	Map = new CImageMap;
	Map->Create(m_pCharImage,_T("EDGES"),PDM_MEMORIAL);
	BYTE ByteMap = Map->GetMapByte(0,0);*/
	
	//Map-
	//do vertical and horizontal runs 
	//and flag the pixels that are touching the white pixels
	bool whiteflag;
	
	//this is the vertical run

	for (int i = 0; i < m_pCharImage->GetWidth(); i++)
	{
		int value = (int) GetRValue(m_pCharImage->GetRGBColor(i,0));
		if (value == 255)
		{
			whiteflag = true;
		}
		else whiteflag = false;
		for (int j = 0; j < m_pCharImage->GetHeight(); j++)
		{
			value = (int) GetRValue(m_pCharImage->GetRGBColor(i,j));
			if ((int) GetRValue(m_pCharImage->GetRGBColor(i,j)) == 255) 
			{
				if (whiteflag == false)
				{
					//set pixel to edge
					Map->MapByteAddAttribute(i+m_Position_X, j + m_Position_Y,8);
					Image->SetRGBColor(i+ m_Position_X,j + m_Position_Y,RGB(128,128,128));
					//m_pCharImage->SetRGBColor(i,j,RGB(128,128,128));
					whiteflag = true;
					//or set it into the imageMap, Find Out!!
				}
				else whiteflag = true;
				
			}
			else 
			{
				if ((int) GetRValue(m_pCharImage->GetRGBColor(i,j)) == 0)
				{
					if  (whiteflag == true)
					{
						//set it to edge
						Map->MapByteAddAttribute(i+m_Position_X, j + m_Position_Y-1,8);
						//Map->SetMapByte(i+m_Position_X, j + m_Position_Y - 1,3);
						Image->SetRGBColor(i + m_Position_X ,j + m_Position_Y -1,RGB(128,128,128));
						//m_pCharImage->SetRGBColor(i,j,RGB(128,128,128));
						whiteflag = false;
					}
					else whiteflag = false;
				}
			}
		}
	}

	//horizontal run now
	for (int j = 0; j < m_pCharImage->GetHeight(); j++)
	{
		int value = (int) GetRValue(m_pCharImage->GetRGBColor(j,0));
		if (value == 255)
		{
			whiteflag = true;
		}
		else whiteflag = false;
		for (int i = 0; i < m_pCharImage->GetWidth(); i++)
		{
			//(int) GetRGBColor(m_Position_X + i,m_Position_Y + j)
			if ((int) GetRValue(m_pCharImage->GetRGBColor(i,j)) == 255) 
			{
				if (whiteflag == false)
				{
					//set pixel to edge
					Map->MapByteAddAttribute(i+m_Position_X, j + m_Position_Y,8);
					//Map->SetMapByte(i+m_Position_X, j + m_Position_Y,3);
					Image->SetRGBColor(i + m_Position_X,j + m_Position_Y,RGB(128,128,128));
					//m_pCharImage->SetRGBColor(i,j,RGB(128,128,128));
					whiteflag = true;
					//or set it into the imageMap, Find Out!!
				}
				else whiteflag = true;
				
			}
			else 
			{
				if ((int) GetRValue(m_pCharImage->GetRGBColor(i,j)) == 0)
				{
					if  (whiteflag == true)
					{
						//set it to edge
						Map->MapByteAddAttribute(i+m_Position_X -1 , j + m_Position_Y,8);
						//Map->SetMapByte(i + m_Position_X - 1, j + m_Position_Y,3);
						Image->SetRGBColor(i + m_Position_X - 1,j + m_Position_Y ,RGB(128,128,128));
						//m_pCharImage->SetRGBColor(i,j,RGB(128,128,128));
						whiteflag = false;
					}
					else whiteflag = false;
				}
				else
					if ((int) GetRValue(m_pCharImage->GetRGBColor(i,j)) == 128) //&& ((int) GetRValue(m_pCharImage->GetRGBColor(i,j)) != 0) )
					{
						if (whiteflag == true) whiteflag = false;
						if (whiteflag == false) whiteflag = true;

					}
			}
		}
	}

}
void CDIACharacter::FindCC(CImage * CharImage, int Type)
{
	//WORD COMPTYPE_BIMODAL = 00;
	//int pixType = (int)pow(2,Type);
//	CharImage->CCAnalysisFromMap(0,pixType,COMPTYPE_BACKGROUND,0,1);
	CharImage->CCAnalysisFromMap(0, Type, COMPTYPE_CONTENT,0,1);
	int nComp = 0;
	for (int x = 0; x <= 10; x++)
	{
		CComp * Comp = new CComp; 
		Comp = m_pLocatedCharImage->GetComponent(x);
		if (Comp != NULL)
		{
			nComp++;
		}
	}
	if (Type == 0)
	{
		m_nComponents = nComp;	
	}else
		m_nHoles = nComp;
}

//void CDIACharacter::FindCC(CDIAGreyScale * CharImage, BYTE Type)
//{
//	//WORD COMPTYPE_BIMODAL = 00;
//	//int pixType = (int)pow(2,Type);
//	CharImage->CCAnalysisFromMap(0, Type, COMPTYPE_CONTENT,0,1);
//	//CharImage->CCAnalysisFromMap(0,Type,COMPTYPE_BACKGROUND,0,1);
//	int nComp = 0;
//	for (int x = 0; x <= 10; x++)
//	{
//		CComp * Comp = CharImage->GetComponent(x);
//		if (Comp != NULL)
//		{
//			nComp++;
//		}
//	}
//	if (Type == 0)
//	{
//		m_nComponents = nComp;	
//	}else if (Type == 1)
//		m_nHoles = nComp;
//}
void CDIACharacter::UpdateBWMap(CImageMap * map, CImage * image, CRect rect)
{
	//this map will contain only the BW version of the image
	//On it we will find connected components in background and foreground
	for (int i = rect.left; i < rect.right; i++)
	{
		for (int j = rect.top; j < rect.bottom; j++)
		{
			if (GetRValue(image->GetRGBColor(i,j)) == 0)
			{
				//set to foreground
				map->MapByteAddAttribute(i,j,2);
			}
			else 
				//set to background
				map->MapByteAddAttribute(i,j,1);
		}
	}
}
void CDIACharacter::UpdateBWMap(CImageMap * map, CImage * image, CRect rect,int threshold)
{
	//this map will contain only the BW version of the image
	//On it we will find connected components in background and foreground
	for (int i = rect.left; i < rect.right; i++)
	{
		for (int j = rect.top; j < rect.bottom; j++)
		{
			if (GetRValue(image->GetRGBColor(i,j)) <= threshold)
			{
				//set to foreground
				map->MapByteAddAttribute(i,j,2);
			}
			else 
				//set to background
				map->MapByteAddAttribute(i,j,1);
		}
	}
}
//void CDIACharacter::FindCC(CImage * CharImage, int Type)
//{
//	////WORD COMPTYPE_BIMODAL = 00;
//	//int pixType = (int)pow(2,Type);
//	//CharImage->CCAnalysisFromMap(1,pixType,COMPTYPE_BACKGROUND,0,1);
//	//int nComp = 0;
//	//for (int x = 0; x <= 10; x++)
//	//{
//	//	CComp * Comp = m_pBiLevelCharImage->GetComponent(x);
//	//	if (Comp != NULL)
//	//	{
//	//		nComp++;
//	//	}
//	//}
//	//if (Type == 0)
//	//{
//	//	m_nComponents = nComp;	
//	//}else
//	//	m_nHoles = nComp;
//}
//
//void CDIACharacter::UpdateBWMap(CImageMap * map, CImage * image, CRect rect)
//{
//	//this map will contain only the BW version of the image
//	//On it we will find connected components in background and foreground
//	for (int i = rect.left; i < rect.right; i++)
//	{
//		for (int j = rect.top; j < rect.bottom; j++)
//		{
//			if (GetRValue(image->GetRGBColor(i,j)) == 0)
//			{
//				//set to foreground
//				map->MapByteAddAttribute(i,j,2);
//			}
//			else 
//				//set to background
//				map->MapByteAddAttribute(i,j,1);
//		}
//	}
//}


void CDIACharacter::ExtractFeatures()
{
	
	//Clear();
	CalculateWeight();
	//CalculateCrossings(bool HoV, int Pos, bool IncGrey);
	CalculateStrongMaxInProjs();
	//FindCC(CDIAGreyScale * CharImage, BYTE Type);
	//GetRuns();
//	ExportRuns();
	GetDivisions();
	CalculateMaxsDistances();
	GetAngles();
	GetContours();
	
}
void CDIACharacter::ExtractFeatures(int sizeDivisionX, int sizeDivisionY)
{
	
	//Clear();
	CalculateWeight();
	//CalculateCrossings(bool HoV, int Pos, bool IncGrey);
	CalculateStrongMaxInProjs();
	//FindCC(CDIAGreyScale * CharImage, BYTE Type);
	//GetRuns();
//	ExportRuns();
	GetDivisions(sizeDivisionX,sizeDivisionY);
	CalculateMaxsDistances();
	GetAngles();
	GetContours();
	
}
void CDIACharacter::Clear()
{
	delete m_pCharacterProjV;
	delete m_pCharacterDistributionH;
	
	//create them again to fit the localized character
	
	m_pCharacterProjV = new long [m_LocatedWidth];
	m_pCharImage->GetProjection(m_CharLocation.left,m_CharLocation.top,m_LocatedWidth,m_LocatedHeight,0, m_pCharacterProjV ,PRJ_GREY);
	m_pCharacterDistributionH = new CDistribution <long>;
	m_pCharacterDistributionH->Create(m_pCharacterProjV,m_LocatedWidth);
	m_pCharacterDistributionH->RemoveSubbase();
	m_pCharacterDistributionH->MovingAverage(1);
	//m_pCharacterDistributionH->AAPeakSmoothing(2.000000,0.110000,0.110000);
	

	delete m_pCharacterProjH;
	delete m_pCharacterDistributionV;

	//create them again to fit the localized character
	m_pCharacterProjH = new long [m_LocatedHeight];
	m_pCharImage->GetProjection(m_CharLocation.left,m_CharLocation.top,m_LocatedWidth,m_LocatedHeight,m_pCharacterProjH, 0 ,PRJ_GREY);
	m_pCharacterDistributionV = new CDistribution <long>;
	m_pCharacterDistributionV->Create(m_pCharacterProjH,m_LocatedHeight);
	m_pCharacterDistributionH->RemoveSubbase();
	m_pCharacterDistributionH->MovingAverage(1);
	//m_pCharacterDistributionH->AAPeakSmoothing(2.000000,0.110000,0.110000);
}

void CDIACharacter::GetContours()
{
	
	m_pCharContourR = new long [m_LocatedHeight];
	m_pCharContourL = new long [m_LocatedHeight];
	m_pLocatedCharImage->GetContour(m_CharLocation.left,m_CharLocation.top,m_LocatedWidth,m_LocatedHeight,m_pCharContourL,m_pCharContourR);
	
	m_pContourDistributionL = new CDistribution <long>;
	m_pContourDistributionR = new CDistribution <long>;
	m_pContourDistributionL->Create(m_pCharContourL,m_LocatedHeight);
	//m_pContourDistributionL->MovingAverage(1);
	m_pContourDistributionR->Create(m_pCharContourR,m_LocatedHeight);
	
}
void CDIACharacter::GetRuns()
{
	//given the locatedImage find runs in the horiz and vertical
	//horizontal
	int direction = 0;
	m_HRuns = new int[m_pLocatedCharImage->GetWidth()*2];
	m_VRuns = new int[m_pLocatedCharImage->GetWidth()*2];
	m_VNoRuns = new int[m_pLocatedCharImage->GetHeight()];
	m_HNoRuns = new int[m_pLocatedCharImage->GetWidth()];
	int runH = 0;
	int runV = 0;
	int noRuns = 0;
	for (int i = 0; i < m_pLocatedCharImage->GetWidth()*2; i++)
	{
		m_HRuns[i] = 0;
		m_VRuns[i] = 0;
		
	}
	for (int i = 0; i < m_pLocatedCharImage->GetHeight(); i++)
	{
		
		m_VNoRuns[i] = 0;
	}
	for (int i = 0; i < m_pLocatedCharImage->GetWidth(); i++)
	{
		
		m_HNoRuns[i] = 0;
	}
	bool flag = false;
	int pixel = 255;
	/*int x = 0; 
	int y = 0;
	
	while ((x < GetWidth()) && (y < GetHeight()))*/
	for (int y = 0; y < m_pLocatedCharImage->GetHeight(); y++)
	{
		noRuns = 0;
		for (int x = 0; x < m_pLocatedCharImage->GetWidth(); x++)
		{
				pixel = (int) GetRValue(m_pLocatedCharImage->GetRGBColor(x,y));

				if (pixel == 0) //black pixel
				{
					if (flag) //if it was already in the black run
					{	//just increase the size of the run
						runH++;
					}
					else //if it is the first pixel of the run
					{
						runH = 1; //initialize the size of the run
						flag = true; //set the flag to true to indicate that it is a black run
						noRuns++; //increase the no of runs in the row
					}
					//point = m_pLocatedCharImage->MoveinDirection(direction,size,point);

				}
				else //if it is not black(grey or white)
				{
					if (flag) //change from black to white
					{
						if (runH > 0) //end of run
						{
							m_HRuns[runH]++;
							runH = 0;
							flag = false;
						}
					}//otherwise do nothing
					
					
				}
		
		}
		m_VNoRuns[y] = noRuns;
	}



	////vertical
	flag = false;
	noRuns = 0;
	for (int x = 0; x < m_pLocatedCharImage->GetWidth(); x++)
	{
		noRuns = 0;
		for (int y = 0; y < m_pLocatedCharImage->GetHeight(); y++)
		{
			
		
				pixel = (int) GetRValue(m_pLocatedCharImage->GetRGBColor(x,y));

				if (pixel == 0) //black pixel
				{
					if (flag) //if it was already in the black run
					{	//just increase the size of the run
						runV++;
					}
					else //if it is the first pixel of the run
					{
						runV = 1; //initialize the size of the run
						flag = true; //set the flag to true to indicate that it is a black run
						noRuns++; //increase the no of runs in the row
					}
					//point = m_pLocatedCharImage->MoveinDirection(direction,size,point);

				}
				else //if it is not black(grey or white)
				{
					if (flag) //change from black to white
					{
						if (runV > 0) //end of run
						{
							m_VRuns[runV]++;
							runV = 0;
							flag = false;
						}
					}//otherwise do nothing
					
					
				}

		}
		m_HNoRuns[x] = noRuns;
	}

//copy of calculate crossings

	m_CharCrossingsH = new CROSSINGS [m_pLocatedCharImage->GetWidth()];
	m_CharCrossingsV = new CROSSINGS [m_pLocatedCharImage->GetHeight()];
	
	
	for (int i = 0; i < m_pLocatedCharImage->GetWidth(); i++)
	{
		m_CharCrossingsH[i].Crossings = 0;
		m_CharCrossingsH[i].NoCrossings = 0;	
	}

	for (int i = 0; i < m_pLocatedCharImage->GetHeight(); i++)
	{
		m_CharCrossingsV[i].Crossings = 0;
		m_CharCrossingsV[i].NoCrossings = 0;	
	}
	
	//calculate number of runs and add it to the crossings
	//horizontal
	int HRunIndex = 0;
	int currentRun = m_HNoRuns[0];
	int noCurrentRun = 1;
	for (int i = 1; i < m_pLocatedCharImage->GetWidth(); i++)
	{
		if (m_HNoRuns[i] == currentRun)
		{
			noCurrentRun++;
		}
		else
		{
			if (noCurrentRun > 1)
			{
				m_CharCrossingsH[HRunIndex].Crossings = currentRun;
				m_CharCrossingsH[HRunIndex].NoCrossings = noCurrentRun;
				HRunIndex++;
			}
			currentRun = m_HNoRuns[i];
			noCurrentRun = 1;
		}

	}
	m_CharCrossingsIndexH = HRunIndex;

	//vertical
	int VRunIndex = 0;
	currentRun = m_VNoRuns[0];
	noCurrentRun = 1;

	for (int i = 1; i < m_pLocatedCharImage->GetHeight(); i++)
	{
		if (m_VNoRuns[i] == currentRun)
		{
			noCurrentRun++;
		}
		else
		{
			if (noCurrentRun > 1)
			{
				m_CharCrossingsV[VRunIndex].Crossings = currentRun;
				m_CharCrossingsV[VRunIndex].NoCrossings = noCurrentRun;
				VRunIndex++;
			}
			currentRun = m_VNoRuns[i];
			noCurrentRun = 1;
		}

	}
	//m_VNoRuns2 = VRunIndex;
	m_CharCrossingsIndexV = VRunIndex;
//

}
void CDIACharacter::GetRuns2()
{
	//given the locatedImage find runs in the horiz and vertical
	//horizontal
	int direction = 0;
	m_HRuns = new int[m_pLocatedCharImage->GetWidth()*2];
	m_VRuns = new int[m_pLocatedCharImage->GetWidth()*2];
	m_VNoRuns = new int[m_pLocatedCharImage->GetHeight()];
	m_HNoRuns = new int[m_pLocatedCharImage->GetWidth()];
	int runH = 0;
	int runV = 0;
	int noRuns = 0;
	for (int i = 0; i < m_pLocatedCharImage->GetWidth()*2; i++)
	{
		m_HRuns[i] = 0;
		m_VRuns[i] = 0;
		
	}
	for (int i = 0; i < m_pLocatedCharImage->GetHeight(); i++)
	{
		
		m_VNoRuns[i] = 0;
	}
	for (int i = 0; i < m_pLocatedCharImage->GetWidth(); i++)
	{
		
		m_HNoRuns[i] = 0;
	}
	bool flag = false;
	int pixel = 255;
	/*int x = 0; 
	int y = 0;
	
	while ((x < GetWidth()) && (y < GetHeight()))*/
	for (int y = 0; y < m_pLocatedCharImage->GetHeight(); y++)
	{
		noRuns = 0;
		for (int x = 0; x < m_pLocatedCharImage->GetWidth(); x++)
		{
				pixel = (int) GetRValue(m_pLocatedCharImage->GetRGBColor(x,y));

				if (pixel < 255) //black or grey pixel
				{
					if (flag) //if it was already in the black run
					{	//just increase the size of the run
						runH++;
					}
					else //if it is the first pixel of the run
					{
						runH = 1; //initialize the size of the run
						flag = true; //set the flag to true to indicate that it is a black run
						noRuns++; //increase the no of runs in the row
					}
					//point = m_pLocatedCharImage->MoveinDirection(direction,size,point);

				}
				else //if it is white
				{
					if (flag) //change from black to white
					{
						if (runH > 0) //end of run
						{
							m_HRuns[runH]++;
							runH = 0;
							flag = false;
						}
					}//otherwise do nothing
					
					
				}
		
		}
		m_VNoRuns[y] = noRuns;
	}



	////vertical
	flag = false;
	noRuns = 0;
	for (int x = 0; x < m_pLocatedCharImage->GetWidth(); x++)
	{
		noRuns = 0;
		for (int y = 0; y < m_pLocatedCharImage->GetHeight(); y++)
		{
			
		
				pixel = (int) GetRValue(m_pLocatedCharImage->GetRGBColor(x,y));

				if (pixel == 0) //black pixel
				{
					if (flag) //if it was already in the black run
					{	//just increase the size of the run
						runV++;
					}
					else //if it is the first pixel of the run
					{
						runV = 1; //initialize the size of the run
						flag = true; //set the flag to true to indicate that it is a black run
						noRuns++; //increase the no of runs in the row
					}
					//point = m_pLocatedCharImage->MoveinDirection(direction,size,point);

				}
				else //if it is not black(grey or white)
				{
					if (flag) //change from black to white
					{
						if (runV > 0) //end of run
						{
							m_VRuns[runV]++;
							runV = 0;
							flag = false;
						}
					}//otherwise do nothing
					
					
				}

		}
		m_HNoRuns[x] = noRuns;
	}

//copy of calculate crossings

	m_CharCrossingsH = new CROSSINGS [m_pLocatedCharImage->GetWidth()];
	m_CharCrossingsV = new CROSSINGS [m_pLocatedCharImage->GetHeight()];
	
	
	for (int i = 0; i < m_pLocatedCharImage->GetWidth(); i++)
	{
		m_CharCrossingsH[i].Crossings = 0;
		m_CharCrossingsH[i].NoCrossings = 0;	
	}

	for (int i = 0; i < m_pLocatedCharImage->GetHeight(); i++)
	{
		m_CharCrossingsV[i].Crossings = 0;
		m_CharCrossingsV[i].NoCrossings = 0;	
	}
	
	//calculate number of runs and add it to the crossings
	//horizontal
	int HRunIndex = 0;
	int currentRun = m_HNoRuns[0];
	int noCurrentRun = 1;
	for (int i = 1; i < m_pLocatedCharImage->GetWidth(); i++)
	{
		if (m_HNoRuns[i] == currentRun)
		{
			noCurrentRun++;
		}
		else
		{
			if (noCurrentRun > 1)
			{
				m_CharCrossingsH[HRunIndex].Crossings = currentRun;
				m_CharCrossingsH[HRunIndex].NoCrossings = noCurrentRun;
				HRunIndex++;
			}
			currentRun = m_HNoRuns[i];
			noCurrentRun = 1;
		}

	}
	m_CharCrossingsIndexH = HRunIndex;

	//vertical
	int VRunIndex = 0;
	currentRun = m_VNoRuns[0];
	noCurrentRun = 1;

	for (int i = 1; i < m_pLocatedCharImage->GetHeight(); i++)
	{
		if (m_VNoRuns[i] == currentRun)
		{
			noCurrentRun++;
		}
		else
		{
			if (noCurrentRun > 1)
			{
				m_CharCrossingsV[VRunIndex].Crossings = currentRun;
				m_CharCrossingsV[VRunIndex].NoCrossings = noCurrentRun;
				VRunIndex++;
			}
			currentRun = m_VNoRuns[i];
			noCurrentRun = 1;
		}

	}
	//m_VNoRuns2 = VRunIndex;
	m_CharCrossingsIndexV = VRunIndex;
//
}


void CDIACharacter::ExportRuns()
{
	//export Vertical character Projection
	FILE * pFile;
	char * HRun = "H Run";
	char * VRun = "V Run";
	
	char c = '\n';

	CString VarName;
	VarName.Format(_T("%sCharacterRunsH.csv"),m_ImageName); 
	TRACE(VarName);
	pFile = _tfopen(VarName, _T("a"));
	
	if (m_CharFinalType == 0)
	{
		fprintf(pFile,"CharacterRuns%d-%d,",m_CharLineNum,m_CharNum);
		for (int i = 0; i < m_pLocatedCharImage->GetWidth(); i++)
		{
			//fprintf(pFile,"CharacterRuns%d-%d.csv\n",m_ImageName,m_CharLineNum);
			
			fprintf(pFile,"%d,",m_HRuns[i]);
		}
		fprintf(pFile, "%c",c);
		for (int i = 0; i < m_pLocatedCharImage->GetHeight(); i++)
		{
			//fprintf(pFile,"CharacterRuns%d-%d.csv\n",m_ImageName,m_CharLineNum);
			
			fprintf(pFile,"%d,",m_HNoRuns[i]);
		}
		fprintf(pFile, "%c",c);
	}
	

	/*fprintf(pFile, "%c\n",VRun);
	fprintf(pFile, "%c",c);

	for (int i = 0; i < m_pLocatedCharImage->GetHeight(); i++)
	{
		fprintf(pFile,"%d,",m_VRuns[i]);
	}
	fprintf(pFile, "%c",c);*/


	fclose(pFile);
	

}
void CDIACharacter::GetDivisions()
{
	int val1, val2, val3, val4;
	val1 = (int)256/5;
	val2 = val1*2;
	val3 = val1*3;
	val4 = val1*4;
	
	CPoint size(5,5);
	m_CharDivisions.size = size;
	m_CharDivisions.Value = ComputeCharDivisionBynBoxes(size);
	//Normalize Divisions values
	m_CharDivisions.Normalized = new float*[m_CharDivisions.size.x];
	for (int i = 0; i < m_CharDivisions.size.y; i++)
	{
		m_CharDivisions.Normalized[i] = new float[5];
	}
	for (int i = 0; i < size.x; i++)
	{
		for (int j = 0; j < size.y; j++)
		{
			if (m_CharDivisions.Value[i][j] <= val1) m_CharDivisions.Normalized[i][j] = 1;
			else if (m_CharDivisions.Value[i][j] <= val2) m_CharDivisions.Normalized[i][j] = 2;
			else if (m_CharDivisions.Value[i][j] <= val3) m_CharDivisions.Normalized[i][j] = 3;
			else if (m_CharDivisions.Value[i][j] <= val4) m_CharDivisions.Normalized[i][j] = 4;
			else m_CharDivisions.Normalized[i][j] = 5;

		}
		
	}
}
void CDIACharacter::GetDivisions(int sizeDivisionX, int sizeDivisionY)
{
	int val1, val2, val3, val4;
	val1 = (int)256/5;
	val2 = val1*2;
	val3 = val1*3;
	val4 = val1*4;
	
	CPoint size(sizeDivisionX, sizeDivisionY);
	m_CharDivisions.size = size;
	m_CharDivisions.Value = ComputeCharDivisionBynBoxes(size);
	//Normalize Divisions values
	m_CharDivisions.Normalized = new float*[m_CharDivisions.size.x];
	for (int i = 0; i < m_CharDivisions.size.y; i++)
	{
		m_CharDivisions.Normalized[i] = new float[5];
	}
	for (int i = 0; i < size.x; i++)
	{
		for (int j = 0; j < size.y; j++)
		{
			if (m_CharDivisions.Value[i][j] <= val1) m_CharDivisions.Normalized[i][j] = 1;
			else if (m_CharDivisions.Value[i][j] <= val2) m_CharDivisions.Normalized[i][j] = 2;
			else if (m_CharDivisions.Value[i][j] <= val3) m_CharDivisions.Normalized[i][j] = 3;
			else if (m_CharDivisions.Value[i][j] <= val4) m_CharDivisions.Normalized[i][j] = 4;
			else m_CharDivisions.Normalized[i][j] = 5;

		}
		
	}
}
CDocImAnDoc* CDIACharacter::GetDocument()
{
	return m_pdoc;
}
void CDIACharacter::SetDocument(CDocImAnDoc *pDoc)
{
	m_pdoc = pDoc;
}
void CDIACharacter::FindUncertValuablePoints()
{
	//If character is FTR
	//The points are selected by finding if they 
	//have black on either top and bottom or left and right
	//and the other value the ohter way.

	//initialise
	for (int i = 0; i < m_LocatedWidth; i++)
	{
		for (int j = 0; j < m_LocatedHeight; j++)
		{
			m_charUncertainAreas[i][j] = 0;
		}
	}
	//storage class array of points
	CPoint point;
	for (int i = 0; i < m_LocatedWidth; i++)
	{
		for (int j = 0 ; j < m_LocatedHeight; j++)
		{
			int val = (int) GetRValue(m_pLocatedCharImage->GetRGBColor(i, j));
			if (( val > 0) && (val < 255)) //if val is an uncertain pixel
			{
				point.x = i;
				point.y = j;
				bool HB = IsPixelBetweenBW(point,0,'H');
				bool VW = IsPixelBetweenBW(point,255,'V');

				bool HW = IsPixelBetweenBW(point,255,'H');
				bool VB = IsPixelBetweenBW(point,0,'V');
				
				if ((HB == true) && (VW == true))
				{
					m_charUncertainAreas[i][j] = 1;
				}else
				if ((HW == true) && (VB == true))
				{
					m_charUncertainAreas[i][j] = 1; //orange
				}
				else
					if (IsPixelBetweenBW(point,0,'H') || IsPixelBetweenBW(point,0,'V'))
					{
						m_charUncertainAreas[i][j] = 10; //pink
					}
					else if (IsPixelBetweenBW(point,255,'H') || IsPixelBetweenBW(point,255,'V'))
					{
						m_charUncertainAreas[i][j] = 100; //green
					}
					else m_charUncertainAreas[i][j] = -1; //grey
						
					
			}
		}
	}
}
bool CDIACharacter::IsPixelBetweenBW(CPoint point, int colour, char move)
{
	bool movement1 = false;
	bool movement2 = false;
	bool found1, found2;
	found1 = false;
	found2 = false;
	int start, end, mypoint;
	if (move == 'H')					//moving horizontally
	{
		mypoint = point.x;
		start = 0;
		end = m_LocatedWidth;
	}
	else if (move == 'V')
	{
		mypoint = point.y;
		start = 0;
		end = m_LocatedHeight;
	}

		//movement1
		for (int i = mypoint; i >= start; i--)
		{
			int val;
			if (move == 'H')	
			{
				val = (int) GetRValue(m_pLocatedCharImage->GetRGBColor(i, point.y));
			}else if (move == 'V')
			{
				val = (int) GetRValue(m_pLocatedCharImage->GetRGBColor(point.x, i));
			}
			//find first value non grey and compare it to the given colour
			if (!found1)
			{
				if (( val > 0) && (val < 255))//if it is still grey
				{
					//do nothing
				}
				else if (val == colour)
				{
					movement1 = true;
					found1 = true;
				}
				else
				{
					movement1 = false;
					found1 = true;
				}
			}
		}
		if (!found1)
		{
			if (colour == 255)
			{
				movement1 = true;
			}
		}
		//movement2
		for (int i = mypoint+1; i < end; i++)
		{
			int val;
			if (move == 'H')	
			{
				val = (int) GetRValue(m_pLocatedCharImage->GetRGBColor(i, point.y));
			}else if (move == 'V')
			{
				val = (int) GetRValue(m_pLocatedCharImage->GetRGBColor(point.x, i));
			}
			
			if (!found2)
			{
				if (( val > 0) && (val < 255))//if it is still grey
				{
				}
				else
				if (val == colour)
				{
					movement2 = true;
					found2 = true;
				}
				else
					{
						movement2 = false;
						found2 = true;
					}
				
			}
		}
		if (!found2)
		{
			if (colour == 255)
			{
				movement2 = true;
			}
		}
		if (movement1 && movement2)
		{
			movement1 = movement1;
		}
	return (movement1 && movement2);
}

void CDIACharacter::FindNeighbToOrangeUncertainAreas()
{
	//create new array of uncertain areas.
	int ** uncertainareas2;
	uncertainareas2 = new int*[m_LocatedWidth];
		for (int i = 0; i < m_LocatedWidth; i++)
		{
			uncertainareas2[i] = new int[m_LocatedHeight];
		}
	for (int i = 0; i < m_LocatedWidth; i++)
	{
		for (int j = 0; j < m_LocatedHeight; j++)
		{
			uncertainareas2[i][j] = m_charUncertainAreas[i][j];
		}
	}
	for (int i = 0; i < m_LocatedWidth; i++)
	{
		for (int j = 0 ; j < m_LocatedHeight; j++)
		{
			
			if (uncertainareas2[i][j] == 1) //if the pixel is orange
			{
				//if that position is orange in the uncertain array then look at its neighg
				for (int x = -1; x < 2; x++)
				{
					for (int y = -1; y < 2; y++)
					{
						//if it is within boundaries
						if (((i + x) >= 0) && ((i + x) < m_LocatedWidth) && ((j+y) >=0) && ((j + y) < m_LocatedHeight))
						{
							CPoint point;
							point.x = i + x;
							point.y = j + y;
							//find if neighb is grey
							if (IsNeighbourGrey(point))
							{
								m_charUncertainAreas[point.x][point.y] = 1;
							}
						}
					}
				}
			}
		}
	}
	delete[] uncertainareas2;
	
}
void CDIACharacter::FindGreyNeighbToUncertainAreas(int color)
{
	//create new array of uncertain areas.
	int ** uncertainareas2;
	uncertainareas2 = new int*[m_LocatedWidth];
		for (int i = 0; i < m_LocatedWidth; i++)
		{
			uncertainareas2[i] = new int[m_LocatedHeight];
		}
	for (int i = 0; i < m_LocatedWidth; i++)
	{
		for (int j = 0; j < m_LocatedHeight; j++)
		{
			uncertainareas2[i][j] = m_charUncertainAreas[i][j];
		}
	}
	for (int i = 0; i < m_LocatedWidth; i++)
	{
		for (int j = 0 ; j < m_LocatedHeight; j++)
		{
			
			if (uncertainareas2[i][j] == color) //if the pixel is of the right color
			{
				//if that position is color in the uncertain array then look at its neighg
				for (int x = -1; x < 2; x++)
				{
					for (int y = -1; y < 2; y++)
					{
						//if it is within boundaries
						if (((i + x) >= 0) && ((i + x) < m_LocatedWidth) && ((j+y) >=0) && ((j + y) < m_LocatedHeight))
						{
							CPoint point;
							point.x = i + x;
							point.y = j + y;
							//find if neighb is grey
							if (color == 1)//the it is orange and we take any other color next to it
							{
								if (IsNeighbourColor(point, 10)) m_charUncertainAreas[point.x][point.y] = color;
								if (IsNeighbourColor(point, 100)) m_charUncertainAreas[point.x][point.y] = color;
								if (IsNeighbourColor(point, -1)) m_charUncertainAreas[point.x][point.y] = color;


							}else
							{
								if (IsNeighbourGrey(point))
								{
									m_charUncertainAreas[point.x][point.y] = color;
								}
							}
						}
					}
				}
			}
		}
	}
//	delete[] uncertainareas2;
	
}
bool CDIACharacter::IsNeighbourGrey(CPoint point)
{
	int val = m_charUncertainAreas[point.x][point.y];
	//int val = (int) GetRValue(m_pLocatedCharImage->GetRGBColor(point.x, point.y));
	if (val == -1)
	{
		return true;
	}
	else return false;
}
bool CDIACharacter::IsNeighbourColor(CPoint point, int color)
{
	int val = m_charUncertainAreas[point.x][point.y];
	//int val = (int) GetRValue(m_pLocatedCharImage->GetRGBColor(point.x, point.y));
	if (val == color)
	{
		return true;
	}
	else return false;
}

bool CDIACharacter::FindUncertainCC(int INcolour, int OUTcolourSmall, int OUTcolourBig)
{	

	if (m_CharUncertainCC.CreateFromMap(m_charUncertainAreas, m_LocatedWidth, m_LocatedHeight, true, INcolour))
	{
		for (int i = 0; i < m_CharUncertainCC.GetNoCCs(); i++)
		{
			//if the CC is larger than a certain threshold
			if (((m_CharUncertainCC.GetCC(i)->GetX2() - m_CharUncertainCC.GetCC(i)->GetX1()) >= 2) && ((m_CharUncertainCC.GetCC(i)->GetY2() - m_CharUncertainCC.GetCC(i)->GetY1()) >= 2))
			{		
				//larger than 2 x 2 = OUTcolourBig
				SetUncertainCCPixels(INcolour, OUTcolourBig, m_CharUncertainCC.GetCC(i));
			}else
			{
				//it is smaller than 2 x 2	= OUTcolourSmall
				SetUncertainCCPixels(INcolour, OUTcolourSmall, m_CharUncertainCC.GetCC(i));
			}
		}
		return true;
	}
	return false;
}
void CDIACharacter::SetUncertainCCPixels(int LookForColour, int SetToColour,CConnectedComponent * CC)
{
	for (int i = 0; i < m_LocatedWidth; i++)
	{
		for (int j = 0; j < m_LocatedHeight; j++)
		{
			if (CC->IsIn(i,j))
			{
				if (m_charUncertainAreas[i][j]!= LookForColour)
				{
					//error
				}else 
					m_charUncertainAreas[i][j] = SetToColour;

			}
		}
	}
}


void CDIACharacter::SetUncertainChanges(int LookForColour, int SetToColour)
{
	//the new character image should be created earlier
	//for each Lookforcolour found, update the character image to the new ouput
	for (int i = 0; i < m_LocatedWidth; i++)
	{
		for (int j = 0; j < m_LocatedHeight; j++)
		{
			if (m_charUncertainAreas[i][j]== LookForColour)
			{
				m_pLocatedCharImage->SetRGBColor(i,j,RGB(SetToColour,SetToColour,SetToColour));
			}
		}
	}
}

void CDIACharacter::SetUncertainChanges(CImage * image,int LookForColour, int SetToColour)
{
	//the new character image should be created earlier
	//for each Lookforcolour found, update the character image to the new ouput
	for (int i = 0; i < image->GetWidth(); i++)
	{
		for (int j = 0; j < image->GetHeight(); j++)
		{
			if (m_charUncertainAreas[i][j]== LookForColour)
			{
				image->SetRGBColor(i,j,RGB(SetToColour,SetToColour,SetToColour));
			}
		}
	}
}
void CDIACharacter::SetUncertainChangesCC(CImage * image,int LookForColour, int SetToColour, int CC)
{
	//the new character image should be created earlier
	//for each Lookforcolour found, update the character image to the new ouput
	for (int i = 0; i < image->GetWidth(); i++)
	{
		for (int j = 0; j < image->GetHeight(); j++)
		{
			if (m_CharUncertainCC.GetCC(CC)->IsIn(i,j))
			{
				if (m_charUncertainAreas[i][j]== LookForColour)
				{
					image->SetRGBColor(i,j,RGB(SetToColour,SetToColour,SetToColour));
				}
			}
		}
	}
}
void CDIACharacter::GetAngles()
{
	int **ImageArray;
	bool **BoolArray;
	CImage* newImage;
	newImage = new CImage;

	GetEdge();
	
	m_horizontal = 0;
	m_vertical = 0;
	m_diagonalUp = 0;
	m_diagonalDown = 0;
	m_TotalEdge = 0;
	
	int val = 0;
	ImageArray = new int* [m_EdgeImage->GetWidth()];
	BoolArray = new bool*[m_EdgeImage->GetWidth()];
	for (int x = 0; x < m_EdgeImage->GetWidth(); x++)
	{
		BoolArray[x] = new bool [m_EdgeImage->GetHeight()];
		ImageArray[x] = new int [m_EdgeImage->GetHeight()];
	}
	//for every value in the inner character
	for (int i = 0; i < m_EdgeImage->GetWidth(); i++)
		{
		for (int j = 0; j < m_EdgeImage->GetHeight(); j++)
		{
		
			int value = (int) GetRValue(m_EdgeImage->GetRGBColor(i,j));
			//TRACE(_T("%d"),m_pCharImage->GetRed((m_CharLocation.left + i),(m_CharLocation.top + j)));
			//TRACE(_T("%d"),m_pCharImage->GetRed(2,2));
			ImageArray[i][j] = value;
			BoolArray[i][j] = false;
		}
	}
		//for each value in the edge array that is 'on' and false
        //find its right neighbour facing the white
		for (int i = 0; i < m_EdgeImage->GetWidth(); i++)
		{
			for (int j = 0; j < m_EdgeImage->GetHeight(); j++)
			{
				val = (int) GetRValue(m_EdgeImage->GetRGBColor(i,j));
				if (val == 0)//then it is edge
				{
					m_TotalEdge++;
					//find the angle for its neigbours
					if (j+1 < m_EdgeImage->GetHeight())
					{
						val = (int) GetRValue(m_EdgeImage->GetRGBColor(i,j+1));
						if (val == 0)//add angle vertical
						{
							m_vertical++;
						}
						if (i+1 < m_EdgeImage->GetWidth()) 
						{
							val = (int) GetRValue(m_EdgeImage->GetRGBColor(i+1,j+1));
							if (val == 0)//add angle diagonalDown
							{
								m_diagonalDown++;
							}
						}
					}
					if (i+1 < m_EdgeImage->GetWidth()) 
					{
						if (j-1 >=0)
						{
							val = (int) GetRValue(m_EdgeImage->GetRGBColor(i+1,j-1));
							if (val == 0)//add angle diagonalUp
							{
								m_diagonalUp++;
							}
						}
						val = (int) GetRValue(m_EdgeImage->GetRGBColor(i+1,j));
						if (val == 0)//add angle horizontal
							{
								m_horizontal++;
							}
					}
							
				}
			}

		}




}
void CDIACharacter::GetEdge()
{
	//for every non white pixel check if it has any white neighb
	//CImage* newImage;
	m_EdgeImage = new CImage;
	m_EdgeImage->CreateFromImage(m_pLocatedCharImage,0);

	//int testpix = -1;
	bool isEdge = false;
	for (int i = 0; i < m_LocatedWidth;i++)
	{
		for (int j = 0; j < m_LocatedHeight; j++)
		{
			isEdge = false;
			m_EdgeImage->SetRGBColor(i,j,RGB(255,255,255));
			int pixel = (int) GetRValue(m_pLocatedCharImage->GetRGBColor(i,j));
			int val;
			if (pixel != 255)
			{
				//find if neighbours are white
				if ((i-1 >=0) && (!isEdge))
				{
					val = (int) GetRValue(m_pLocatedCharImage->GetRGBColor(i-1,j));
					if( val == 255)
					{
						isEdge = true;
					}
					/*if ((j-1 >= 0) && (!isEdge))
					{
						if(m_pLocatedCharImage->GetBlue(i-1,j-1) == 255)
						{
							isEdge = true;
						}
					}*/
					/*if ((j+1 < m_LocatedHeight) && (!isEdge))
					{
						if(m_pLocatedCharImage->GetBlue(i-1,j+1) == 255)
						{
							isEdge = true;
						}
					}*/
				}else
				{
					if ((i-1 < 0) && (!isEdge))
					{
					
							isEdge = true;
					}
				}
				if ((j+1 < m_LocatedHeight) && (!isEdge))
				{
					val = (int) GetRValue(m_pLocatedCharImage->GetRGBColor(i,j+1));
					if (val == 255)
						{
							isEdge = true;
						}
				}
				else if ((j+1 == m_LocatedHeight) && (!isEdge))
				{
					isEdge = true;
				}
				if (((i + 1) < m_LocatedWidth) && (!isEdge))
				{
					val = (int) GetRValue(m_pLocatedCharImage->GetRGBColor(i+1,j));
					if(val == 255)
					{
						isEdge = true;
					}
					/*if ((j-1 >=0) && (!isEdge))
					{
						if(m_pLocatedCharImage->GetBlue(i+1,j-1) == 255)
						{
							isEdge = true;
						}
					}*/
					/*if ((j+1 < m_LocatedHeight) && (!isEdge))
					{
						if(m_pLocatedCharImage->GetBlue(i+1,j+1) == 255)
						{
							isEdge = true;
						}
					}*/
					
					
				}
				else if (((i + 1) == m_LocatedWidth) && (!isEdge))
				{
					isEdge = true;
				}
				if ((j-1 >= 0) && (!isEdge))
				{
					val = (int) GetRValue(m_pLocatedCharImage->GetRGBColor(i,j-1));
					if(val == 255)
					{
						isEdge = true;
					}
				}
				else{
					if ((j-1 < 0) && (!isEdge))
					{
						isEdge = true;
					}
				}

			}
			if (pixel != 255)
			{
				if (isEdge) //we have found a white pixel in the neighbourhood
				{
					m_EdgeImage->SetRGBColor(i,j,RGB(0,0,0));
					//m_pLocatedCharImage->SetBlue(i,j,0);
				}
				else // the pixel is not white but is inside of the character
				{
					m_EdgeImage->SetRGBColor(i,j,RGB(128,128,128));
					//m_pLocatedCharImage->SetBlue(i,j,128);
				}
			}
			
		}
	}
	//Exportimage(CImage * image, CString name, CString path)
//	CString ExportedCharsPath;
//	ExportedCharsPath.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Original Characters\\Perfect Set\\Exported Images\\"));
//	CString name;
//	name.Format(_T("charsEdges"));
	//GetDocument()->Exportimage(m_EdgeImage, name,ExportedCharsPath);
	//return m_EdgeImage;
	//delete newImage;

}