#pragma once
#include "afxwin.h"
#include "DIACharacter.h"
#include "Image.h"
#include "DocImAnDoc.h"



// CDIADlgFindDivisions dialog

class CDIADlgFindDivisions : public CDialog
{
	DECLARE_DYNAMIC(CDIADlgFindDivisions)

public:
	typedef struct Divisions
	{
		CPoint size;
		int** Value;
		float** Normalized;
	
	};
	
	CDIADlgFindDivisions(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDIADlgFindDivisions();
	void		SetDocument(CDocImAnDoc *pDoc);
	CDocImAnDoc* GetDocument();
	CImage*		GetImage();
	int**		ComputeStatistics(CPoint Size,int SizeIndex);
	int**		ComputeDifferences(Divisions first, Divisions second);
	float**		NormalizeValues(int ** InValues, CPoint size,int TopVal);
	void		DisplayBitmap(CStatic &box,float** values, CPoint size);
	void		DisplayBitmap(CStatic &box,int** values, CPoint size);
	void		ClearAll();

// Dialog Data
	enum { IDD = IDD_DLG_FIND_BEST_DIV };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedChoosemorechars();
	CEdit m_EdCharLine;
	CEdit m_EdCharNum;
	CEdit m_EdSize;
	CListBox m_ListResults;
	
	//int m_ResultsIndex;
	int m_NumChars;
	int m_NumSizes;
	CDIACharacter * m_pCharHolder;
	CPoint * m_pSizeHolder;
	int m_CharHolderIndex;
	int m_SizeHolderIndex;
	CDocImAnDoc * m_pDoc;
	bool m_bDisplayBitmaps;
	bool m_bDisplayStatistics;
	bool m_bDisplayDifferences;
	int iLine,iNum;
	

	
	Divisions* m_Statistics;
	Divisions* m_Differences;
	Divisions ** m_pResults;
	afx_msg void OnBnClickedChoosemoresizes();
	afx_msg void OnBnClickedGetresults();
	CEdit m_EdSize2;
	CStatic m_Bitmap1;
	CStatic m_Bitmap2;
	CStatic m_Bitmap3;
	CStatic m_Bitmap4;
	CEdit m_ShownSize;
	afx_msg void OnBnClickedNextSize();
	afx_msg void OnBnClickedDisplayBitmaps();
	afx_msg void OnPaint();
	CEdit m_EdResults;
	afx_msg void OnBnClickedGetDifference();
	afx_msg void OnBnClickedCleanAll();
	afx_msg void OnBnClickedAddPerfectChar();
	virtual BOOL OnInitDialog();
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedCancel();
};
