// DIADlgHistogramTransformation.cpp : implementation file
//

#include "stdafx.h"
#include "DocImAn.h"
#include "DIADlgHistogramTransformation.h"
#include "DIAGreyScale.h"
#include "Image.h"
#include "stdlib.h"
#include ".\diadlghistogramtransformation.h"
#include "DIAHistograms.h"


// CDIADlgHistogramTransformation dialog

IMPLEMENT_DYNAMIC(CDIADlgHistogramTransformation, CDialog)
CDIADlgHistogramTransformation::CDIADlgHistogramTransformation(CWnd* pParent /*=NULL*/)
	: CDialog(CDIADlgHistogramTransformation::IDD, pParent)
{

	//Initialization of inHistogram 
	//for (int x = 0; x <= 255; x++) m_inHistogram[x] = 0;
	//this is faster than the for...
//	ZeroMemory(m_histo.m_inHistogram, 256 * sizeof(unsigned long));

	//Initialization of inHistogram 
//	ZeroMemory(m_histo.m_outHistogram, 256 * sizeof(unsigned long));
	
	//Initialization of transformation 
//	ZeroMemory(m_histo.m_transformation, 256 * sizeof(unsigned long));

	//Initialization of LUT
//	ZeroMemory(m_histo.m_LUT, 256 * sizeof(unsigned long));
	
	//m_histo.m_maxvalueInHisto = 0;
	//m_histo.m_maxvalueOutHisto = 0;
	//m_histo.m_maxvalueLUT = 0;
	m_showsigma = FALSE;
	m_showouthisto = FALSE;
	m_showoutimage = FALSE;

	//m_histo.m_pdoc = NULL;
}

CDIADlgHistogramTransformation::~CDIADlgHistogramTransformation()
{
}

void CDIADlgHistogramTransformation::SetDocument(CDocImAnDoc *pDoc)
{
	m_histo.m_pdoc = pDoc;
	//Change Histograms and displays
	 OnImageChange();
}

CImage * CDIADlgHistogramTransformation::GetImage()
{
	if (m_histo.m_pdoc != NULL)	return m_histo.m_pdoc->GetActiveImage();
	else return NULL;
}

CImage * CDIADlgHistogramTransformation::GetUndoImage(int index)
{
	if (m_histo.m_pdoc != NULL) return m_histo.m_pdoc->GetUndoImage(index);
	else return NULL;
}

void CDIADlgHistogramTransformation::OnImageChange()
{
	if (GetImage() == NULL)
		for (int x = 0; x <= 255; x++) m_histo.m_inHistogram[x] = 0; //Initialization of inHistogram
	else
	{
	}
}


void CDIADlgHistogramTransformation::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SLIDER1, m_SliderTop);
	DDX_Control(pDX, IDC_SLIDER2, m_SliderBottom);
	DDX_Control(pDX, IDC_IN_IMAGE, m_InImageBox);
	DDX_Control(pDX, IDC_OUT_IMAGE, m_OutImageBox);
	DDX_Control(pDX, IDC_IN_HISTO_BOX, m_InHistoBox);
	DDX_Control(pDX, IDC_OUT_HISTO_BOX, m_OutHistoBox);
	DDX_Control(pDX, IDC_TRANSFORMATION_FUNCTION_BOX, m_TransformationBox);
	DDX_Control(pDX, IDC_ARROW_BITMAP, m_Arrow);
	DDX_Control(pDX, IDC_COMBO_FUNCTION, m_ComboFunction);
	DDX_Control(pDX, IDC_HORIZ_SCALE, m_HorizScale);
	DDX_Control(pDX, IDC_Foreg, m_ForegroundVal);
	DDX_Control(pDX, IDC_Backg, m_BackgroundVal);
}


//void CDIADlgHistogramTransformation::ComputeHistogram(unsigned long *inHisto,unsigned long *maxval, CImage *image)
//{
//	//This computes the inHistogram from the original image 
//
//	int width = image->GetWidth();
//	int height = image->GetHeight();
//	
//	//creation of inHistogram
//	for (int y = 0; y < height; y++)
//	{
//		for (int x = 0; x < width; x++)
//		{
//			BYTE red = GetRValue(image->GetRGBColor(x,y));
//			
//			inHisto[red]++;
//			if(inHisto[red]> *maxval) *maxval = inHisto[red];
//		}
//	}	
//}
//
//void CDIADlgHistogramTransformation::ComputeHistogram(unsigned long *inHisto,unsigned long *maxval, CGreyScaleImage *image)
//{
//	//This computes the inHistogram from the original image 
//
//	int width = image->GetWidth();
//	int height = image->GetHeight();
//	
//	//creation of inHistogram
//	for (int y = 0; y < height; y++)
//	{
//		for (int x = 0; x < width; x++)
//		{
//			BYTE red = GetRValue(image->GetRGBColor(x,y));
//			
//			inHisto[red]++;
//			if(inHisto[red]> *maxval) *maxval = inHisto[red];
//		}
//	}	
//}

void CDIADlgHistogramTransformation::DisplayTransformation(CStatic &box, unsigned long * Transformation)
{

	CDC * pDC;
	CRect rect;

	unsigned long maxval = 255;
	pDC = box.GetDC();
	box.GetClientRect(&rect);

	CRgn ClipRgn;
	ClipRgn.CreateRectRgn(rect.left, rect.top, rect.right, rect.bottom);
	pDC->SelectClipRgn(&ClipRgn);

	int bpp = pDC->GetDeviceCaps(BITSPIXEL);
	int planes = pDC->GetDeviceCaps(PLANES);

	CBitmap bmp;
	
	if (0 == bmp.CreateBitmap(256, maxval,planes,bpp,NULL))
	{
		return;
	}
	else
	{
		CDC dc;
		dc.CreateCompatibleDC(NULL);
		dc.SelectObject(&bmp);
		CBrush brush;
		brush.CreateSolidBrush(RGB(158,164,246));
		dc.SelectObject(brush);
		dc.FillRect(CRect(0, 0, 256, maxval), &brush);

		CPen pen(PS_SOLID,0, RGB(78,2,204));
		dc.SelectObject(pen);

		for (int i = 0; i < 256; i++ )
		{
			dc.MoveTo(i,maxval);
			dc.LineTo(i, maxval-Transformation[i]);
		}
		pDC->SetStretchBltMode(COLORONCOLOR);
		pDC->StretchBlt(0,0,rect.Width(), rect.Height(), &dc, 0, 0,maxval,maxval,SRCCOPY);
		
	}
}

void CDIADlgHistogramTransformation::DisplayHistogram(CStatic &box,unsigned long * Histo, unsigned long maxval)
{
	CDC * pDC;
	CRect rect;

	pDC = box.GetDC();
	box.GetClientRect(&rect);

	CRgn ClipRgn;
	ClipRgn.CreateRectRgn(rect.left, rect.top, rect.right, rect.bottom);
	pDC->SelectClipRgn(&ClipRgn);

	int bpp = pDC->GetDeviceCaps(BITSPIXEL);
	int planes = pDC->GetDeviceCaps(PLANES);

	CBitmap bmp;
	
	if (0 == bmp.CreateBitmap(256, maxval,planes,bpp,NULL))
	{
		return;
	}
	else
	{
		CDC dc;
		dc.CreateCompatibleDC(NULL);
		dc.SelectObject(&bmp);
		CBrush brush;
		brush.CreateSolidBrush(RGB(158,164,246));
		dc.SelectObject(brush);
		dc.FillRect(CRect(0, 0, 258, maxval), &brush);

		CPen pen(PS_SOLID,0, RGB(78,2,204));
		dc.SelectObject(pen);
		
		
		for (int i = 0; i < 256; i++ )
		{
			dc.MoveTo(i,maxval);
			dc.LineTo(i, maxval-Histo[i]);
		}
		//pDC->BitBlt(0,0,rect.Width(), rect.Height(), &dc, 0, 0, SRCCOPY);

		pDC->SetStretchBltMode(COLORONCOLOR);
		
		pDC->StretchBlt(0,0,rect.Width(), rect.Height(),&dc,0,0,256,maxval,SRCCOPY);
		
	
	}
}
void CDIADlgHistogramTransformation::DisplayImage(CStatic &Wind,CImage* Image)

{
	//
	CDC * pDC = Wind.GetDC();
	CRect rect;
	Wind.GetClientRect(&rect);
	CRgn ClipRgn;
	ClipRgn.CreateRectRgn(rect.left, rect.top, rect.right, rect.bottom);
	pDC->SelectClipRgn(&ClipRgn);
	

	CBitmap bmp;
	CDC dc;
	
	dc.CreateCompatibleDC(NULL);
	Image->GetBitmap(&bmp);
	int m_HistoWidth = Image->GetWidth();
	int m_HistoHeight = Image->GetHeight();
	dc.SelectObject(&bmp);
	pDC->SetStretchBltMode(COLORONCOLOR);
	pDC->StretchBlt(0,0,rect.Width(), rect.Height(),&dc,0,0,m_HistoWidth,m_HistoHeight,SRCCOPY);
	
	
	
}


void CDIADlgHistogramTransformation::DisplayIcon(CStatic &control,int IDBitmap)
{
	CDC * pDC = control.GetDC();

	CRect rect;
	control.GetClientRect(&rect);

	CRgn ClipRgn;
	ClipRgn.CreateRectRgn(rect.left, rect.top, rect.right, rect.bottom);
	pDC->SelectClipRgn(&ClipRgn);

	
	CDC dc;
	BITMAP bitmap;
	CBitmap bmp;
	

	dc.CreateCompatibleDC(NULL);
	bmp.LoadBitmap(IDBitmap);
	if (bmp.GetBitmap(&bitmap) == 0) 
		return;
	else
	{
		dc.SelectObject(&bmp);
		pDC->SetStretchBltMode(COLORONCOLOR);
		pDC->StretchBlt(0,0,rect.Width(), rect.Height(),&dc,0,0,bitmap.bmWidth,bitmap.bmHeight,SRCCOPY);
	}
}

//void CDIADlgHistogramTransformation::ComputeTransformation()
//{
//	if (m_pdoc == NULL) return;
//	CImage * pOrigImage = m_pdoc->GetUndoImage(m_pdoc->m_index-2);
//	CImage * pImage = GetImage();
//	int width = pImage->GetWidth();
//	int height = pImage->GetHeight();
//
//	for (int y = 0; y < height; y++)
//	{
//		for (int x = 0; x < width; x++)
//		{
//			//any R,G,B for a greyscale
//			
//			BYTE red = GetRValue(pOrigImage->GetRGBColor(x,y));
//			BYTE grey = (BYTE)m_transformation[red];
//			pImage->SetRGBColor(x,y,RGB(grey,grey,grey));
//			
//		}
//	}
//	pImage->SetDirty();
//}

//void CDIADlgHistogramTransformation::ComputeEqualization()
//{
//	if (m_pdoc == NULL) return;
//	CImage * pOrigImage = m_pdoc->GetUndoImage(m_pdoc->m_index-2);
//	CImage * pImage = GetImage();
//
//	int width = pImage->GetWidth();
//	int height = pImage->GetHeight();
//
//	//m_transformation.Create(width, height, RGB(255,255,255), _T("Output Image")); 
//
//	// Calculate the lookup table. 
//	m_LUT[0] = m_inHistogram[0];
//
//	// accumulate 
//	for (int x = 1; x < 256; x++)
//	{
//		m_LUT[x] = m_LUT[x-1] + m_inHistogram[x];
//	}
//
//	// Normalize. 
//    for (x = 0; x < 256; x++)
//	{
//		m_LUT[x] = (long)((m_LUT[x] * 255.0) / (double)(height * width));
//		if(m_LUT[x]> m_maxvalueLUT) m_maxvalueLUT = m_LUT[x];
//	}
//
//	m_maxvalueOutHisto=0;
//
//
//	// Output the equalized frame. 
//	for (int y = 0; y < height; y++)
//	{
//		for (x = 0; x < width; x++)
//		{
//			//any R,G,B for a greyscale
//			
//			BYTE red = GetRValue(pImage->GetRGBColor(x,y));
//			BYTE grey = (BYTE)m_LUT[red];
//			pImage->SetRGBColor(x,y,RGB(grey,grey,grey));
//			m_outHistogram[grey]++;
//			if (m_outHistogram[grey] > m_maxvalueOutHisto) m_maxvalueOutHisto = m_outHistogram[grey];
//		}
//	}
//	pImage->SetDirty();
//}
void CDIADlgHistogramTransformation::CalculateFunction()
{
	int x;
	int top, down;
	float solution;

	down = m_SliderBottom.GetPos();
	top = m_SliderTop.GetPos();
	
	CString Selection;
	m_ComboFunction.GetLBText(m_ComboFunction.GetCurSel(), Selection);
	m_histo.m_sigma = (float)_wtof(Selection);
	
	for (x = 0; x < down; x++) m_histo.m_transformation[x] = 0;
	for (x = top+1; x<=255; x++) m_histo.m_transformation[x] = 255;
	for (x = down; x <= top; x++) 
	{
		solution = float(x-down)/float(top - down);
		m_histo.m_transformation[x] = (unsigned long) (Sigma(solution,m_histo.m_sigma)* 255) ;
	}
}

BEGIN_MESSAGE_MAP(CDIADlgHistogramTransformation, CDialog)
	ON_CBN_SELCHANGE(IDC_COMBO_FUNCTION, OnCbnSelchangeComboFunction)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_RECALCULATE_FUNCTION, OnBnClickedRecalculateFunction)
	ON_BN_CLICKED(IDC_CALCULATE_TRANSFORMATION2, OnBnClickedCalculateTransformation)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(IDC_CALCULATE_EQUALIZATION, OnBnClickedCalculateEqualization)
	ON_BN_CLICKED(IDC_ExpHisto, OnBnClickedExphisto)
	ON_BN_CLICKED(IDC_CalculateLevels, OnBnClickedCalculatelevels)
	ON_BN_CLICKED(IDC_CALCULATE_TRANSFORMATION_LEVELS, OnBnClickedCalculateTransformationLevels)
	ON_BN_CLICKED(IDC_CALCULATE_TRANSFORMATION_LEVELS_IN_SEG, OnBnClickedCalculateTransformationLevelsInSeg)
END_MESSAGE_MAP()


// CDIADlgHistogramTransformation message handlers

BOOL CDIADlgHistogramTransformation::OnInitDialog()
{
	CDialog::OnInitDialog();

	
	m_ComboFunction.AddString(_T("-0.9"));
	m_ComboFunction.AddString(_T("-1.0"));
	m_ComboFunction.AddString(_T("-1.1"));
	m_ComboFunction.AddString(_T("-1.2"));
	m_ComboFunction.AddString(_T("-1.3"));
	m_ComboFunction.AddString(_T("-1.4"));
	m_ComboFunction.AddString(_T("-1.5"));
	m_ComboFunction.AddString(_T("-1.6"));
	m_ComboFunction.AddString(_T("-1.7"));
	m_ComboFunction.AddString(_T("-1.8"));
	m_ComboFunction.AddString(_T("-1.9"));
	m_ComboFunction.AddString(_T("-2.0"));
	m_ComboFunction.AddString(_T("0"));
	m_ComboFunction.SetCurSel(12);

	

	//Sliders
	m_SliderTop.SetRange(0,255);
	m_SliderTop.SetTicFreq(1);
	m_SliderTop.SetPos(255);
	m_SliderBottom.SetRange(0,255);
	m_SliderBottom.SetTicFreq(1);
	m_SliderBottom.SetPos(0);

	if (m_histo.m_pdoc != NULL)
	{
		m_histo.ComputeHistogram(m_histo.m_inHistogram,&m_histo.m_maxvalueInHisto,m_histo.m_pdoc->GetActiveImage());
		m_histo.m_pdoc->CreateNewUndoImage(IT_GREYSCALE);
	}
//text.Format(_T("Cost for character %c = %d"),GetDocument()->m_pCharCapitalVector[i]->GetCharName(),cost);
//m_DetailsList.SetWindowText((LPCTSRT)text);
	CString sval, sval2;
	sval.Format(_T("%d"),m_histo.GetMaximum());
	m_BackgroundVal.SetWindowText((LPCTSTR)sval);
	sval2.Format(_T("%d"),m_histo.GetMinimum());
	m_ForegroundVal.SetWindowText((LPCTSTR)sval2);
	return TRUE; // return TRUE  unless you set the focus to a control
}


void CDIADlgHistogramTransformation::OnCbnSelchangeComboFunction()
{
	CString Selection;
	m_ComboFunction.GetLBText(m_ComboFunction.GetCurSel(), Selection);
	m_histo.m_sigma = (float)_wtof(Selection);//(float)m_SigmaCombo.GetCurSel();
}

void CDIADlgHistogramTransformation::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	DisplayImage(m_InImageBox,GetUndoImage(m_histo.m_pdoc->m_index-2) ); //TEMPORARY
	DisplayHistogram(m_InHistoBox,m_histo.m_inHistogram, m_histo.m_maxvalueInHisto);

	DisplayIcon(m_Arrow,IDB_Arrow);
	DisplayIcon(m_HorizScale, IDB_HorizontalScale);
	if (m_showsigma) DisplayTransformation(m_TransformationBox, m_histo.m_transformation);
	if (m_showoutimage) DisplayImage(m_OutImageBox,GetImage());
	if (m_showouthisto) DisplayHistogram(m_OutHistoBox,m_histo.m_outHistogram,m_histo.m_maxvalueOutHisto);
	if (m_equalizing) {
		DisplayImage(m_OutImageBox, GetImage());
		DisplayHistogram(m_OutHistoBox,m_histo.m_outHistogram,m_histo.m_maxvalueOutHisto);
	}
}

void CDIADlgHistogramTransformation::OnBnClickedRecalculateFunction()
{
	m_histo.CalculateFunction(m_SliderTop.GetPos(), m_SliderBottom.GetPos());
	DisplayTransformation(m_TransformationBox, m_histo.m_transformation);
	m_showsigma = TRUE;
}



void CDIADlgHistogramTransformation::OnBnClickedCalculateTransformation()
{
	m_histo.ComputeTransformation(GetImage(),m_histo.m_pdoc->GetUndoImage(m_histo.m_pdoc->m_index-2));
	DisplayImage(m_OutImageBox, GetImage());
	m_histo.ComputeHistogram(m_histo.m_outHistogram,&m_histo.m_maxvalueOutHisto,GetImage());
	DisplayHistogram(m_OutHistoBox,m_histo.m_outHistogram,m_histo.m_maxvalueOutHisto);
	m_showoutimage = TRUE;
	m_showouthisto = TRUE;
}



void CDIADlgHistogramTransformation::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	OnOK();
}

void CDIADlgHistogramTransformation::OnBnClickedCancel()
{
	m_histo.m_pdoc->OnEditUndo();
	OnCancel();
}

void CDIADlgHistogramTransformation::OnBnClickedCalculateEqualization()
{
	m_histo.ComputeEqualization(GetImage(),m_histo.m_pdoc->GetUndoImage(m_histo.m_pdoc->m_index-2));
	DisplayImage(m_OutImageBox, GetImage());
	m_histo.ComputeHistogram(m_histo.m_outHistogram,&m_histo.m_maxvalueOutHisto,GetImage());
	DisplayHistogram(m_OutHistoBox,m_histo.m_outHistogram,m_histo.m_maxvalueOutHisto);
	m_equalizing = TRUE;
	
}

void CDIADlgHistogramTransformation::OnBnClickedExphisto()
{
	FILE * pFile;
	static char BASED_CODE szFilter[]=
		"Comma Separated Values(*.csv)|All Files (*.*)|*.*||";

	char Values[] = "Values";
	
	char   c = '\n';
	long val;

	CString m_name = GetImage()->GetName();	
	CFileDialog m_FileDialog(FALSE,NULL,m_name,OFN_FILEMUSTEXIST|OFN_HIDEREADONLY
		,NULL, 0);
	if (m_FileDialog.DoModal() == IDOK)
		{	
			CString m_pathName = m_FileDialog.GetPathName();
			pFile = _tfopen(m_pathName, _T("w"));
			fprintf(pFile,"%s%c",Values,c);
					
					for (int i = 0; i <= 255;i++)
					{
						val = m_histo.m_inHistogram[i];
						fprintf(pFile,"%i %c",val,c);
					}
			fclose(pFile);
		}
		

}


void CDIADlgHistogramTransformation::OnBnClickedCalculatelevels()
{
	CString Num;
	m_BackgroundVal.GetWindowText(Num);
	int BackgNum = _ttoi(Num);
	m_ForegroundVal.GetWindowText(Num);
	int ForegNum = _ttoi(Num);
	BYTE white = 255;
	BYTE black = 0;
	if ((ForegNum >=0) && (ForegNum <= 255) && (BackgNum >= ForegNum) && (BackgNum <= 255))
	{
		for (int i = 0; i < GetImage()->GetWidth(); i++)
		{
			for (int j = 0; j < GetImage()->GetHeight(); j++)
			{
				int val = (int)(GetRValue(GetImage()->GetRGBColor(i,j)));
				if (val <= ForegNum)
				{
					GetImage()->SetRGBColor(i,j,RGB(0,0,0));
				}
				if(val >= BackgNum)
				{
					GetImage()->SetRGBColor(i,j,RGB(255,255,255));
				}
			}
		}
	}
	
	m_showoutimage = TRUE;
}

void CDIADlgHistogramTransformation::OnBnClickedCalculateTransformationLevels()
{
	m_histo.ComputeHistogram(m_histo.m_inHistogram,&m_histo.m_maxvalueInHisto,GetImage());
	m_histo.CalculateFunction(m_histo.GetMaximum(),m_histo.GetMinimum());
	DisplayTransformation(m_TransformationBox, m_histo.m_transformation);
	m_showsigma = TRUE;
	//m_histo.CalculateFunctionContrast(m_histo.m_inHistogram,m_histo.GetMinimum(),m_histo.GetMaximum(),false);
	//Histogram transformation
	m_histo.ComputeTransformation(GetImage(),m_histo.m_pdoc->GetUndoImage(m_histo.m_pdoc->m_index-2));
	DisplayImage(m_OutImageBox, GetImage());
	m_histo.ComputeHistogram(m_histo.m_outHistogram,&m_histo.m_maxvalueOutHisto,GetImage());
	DisplayHistogram(m_OutHistoBox,m_histo.m_outHistogram,m_histo.m_maxvalueOutHisto);
	m_showoutimage = TRUE;
	m_showouthisto = TRUE;	
}

void CDIADlgHistogramTransformation::OnBnClickedCalculateTransformationLevelsInSeg()
{
	if (m_histo.m_pdoc->m_IsCharSegmented)
	{
		for (int i = 0; i < m_histo.m_pdoc->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < m_histo.m_pdoc->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				CDIAHistograms histo;
				CRect rect;
				rect.left = m_histo.m_pdoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X;
				rect.right = m_histo.m_pdoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + m_histo.m_pdoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Width-1;
				rect.top = m_histo.m_pdoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y;
				rect.bottom = m_histo.m_pdoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + m_histo.m_pdoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Height-1;

				histo.ComputeHistogram(histo.m_inHistogram,&histo.m_maxvalueInHisto,rect,GetImage());
				histo.CalculateFunction(histo.GetMaximum(),histo.GetMinimum());
				histo.ComputeTransformation(GetImage(),m_histo.m_pdoc->GetUndoImage(m_histo.m_pdoc->m_index-2),rect);
			}
		}
	}
}
