#pragma once
#include "afxcmn.h"
#include "afxwin.h"
#include "DocImAnDoc.h"
#include "Image.h"
#include "DIAGreyScale.h"
#include "DIAHistograms.h"


// CDIADlgHistogramTransformation dialog

class CDIADlgHistogramTransformation : public CDialog
{
	DECLARE_DYNAMIC(CDIADlgHistogramTransformation)

public:
	CDIADlgHistogramTransformation(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDIADlgHistogramTransformation();

// Dialog Data
	enum { IDD = IDD_HistogramTransformation };


public:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	void SetDocument(CDocImAnDoc * pDoc);
	CImage * GetImage();
	CImage * GetUndoImage(int index);
	void OnImageChange();
	void CalculateFunction();
	//void ComputeTransformation();
	//void ComputeEqualization();
	//void ComputeHistogram(unsigned long *inHisto,unsigned long *maxval, CImage *image);
	//void ComputeHistogram(unsigned long *inHisto,unsigned long *maxval, CGreyScaleImage *image);
	static void DisplayImage(CStatic &Wind,CImage* Image);
	static void DisplayIcon(CStatic &control,int IDBitmap);
	void DisplayHistogram(CStatic &box,unsigned long * Histo, unsigned long maxval);
	void DisplayTransformation(CStatic &box, unsigned long * Tranformation);
	inline float CDIADlgHistogramTransformation::Sigma(float f,float sigma)
		{ 
		f = f*2 - 1; //range [-1,1]
		return (float)(0.5+(f>0?1:-1)*0.5*pow( (f>0?1:-1)*f, exp(sigma) ));//(m_Sigma==0?1:(m_Sigma>0?m_Sigma:1.0/(-m_Sigma))) ));
		}


	DECLARE_MESSAGE_MAP()
public:
	CSliderCtrl m_SliderTop;
	CSliderCtrl m_SliderBottom;
	CStatic m_InImageBox;
	CStatic m_OutImageBox;
	CStatic m_InHistoBox;
	CStatic m_OutHistoBox;
	CStatic m_TransformationBox;
	CStatic m_Arrow;
	CEdit m_BackgroundVal;
	CEdit m_ForegroundVal;
	CComboBox m_ComboFunction;
	CStatic m_HorizScale;

	CDIAHistograms m_histo;
	//unsigned long   m_inHistogram[256];		// Input histogram
	//unsigned long   m_outHistogram[256];	
	//unsigned long   m_transformation[256];
	//unsigned long	m_LUT[256];
	//unsigned long   m_maxvalueLUT;
	//unsigned long	m_maxvalueInHisto;
	//unsigned long	m_maxvalueOutHisto;
	//unsigned long	m_maxvalueTransformation;

	float m_sigma;
	BOOL m_showsigma;
	BOOL m_showouthisto;
	BOOL m_showoutimage;
	BOOL m_equalizing;
	//CDocImAnDoc * m_pdoc;
	afx_msg void OnCbnSelchangeComboFunction();
	afx_msg void OnPaint();
	afx_msg void OnBnClickedRecalculateFunction();
	afx_msg void OnBnClickedCalculateTransformation();
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedCancel();
	afx_msg void OnBnClickedCalculateEqualization();
	afx_msg void OnBnClickedExphisto();
	afx_msg void OnBnClickedCalculatelevels();
	afx_msg void OnBnClickedCalculateTransformationLevels();
	afx_msg void OnBnClickedCalculateTransformationLevelsInSeg();
};
