// DIADlgProjectionsDialog.cpp : implementation file
//

#include "stdafx.h"
#include "DocImAn.h"
#include "DIADlgProjectionsDialog.h"
#include "DocImAnView.h"
#include "Distribution.h"
#include ".\diadlgprojectionsdialog.h"
#include "TextLine.h"
#include "DIASegmentation.h"
#include "DIAImage.h"


// CDIADlgProjectionsDialog dialog

IMPLEMENT_DYNAMIC(CDIADlgProjectionsDialog, CDialog)
CDIADlgProjectionsDialog::CDIADlgProjectionsDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CDIADlgProjectionsDialog::IDD, pParent)
{
	m_vert = false;
	m_horz = false;
	m_sepaV = false;
	m_sepaH = false;
	m_complete = false;
	m_pSeg = new DIASegmentation;
}

CDIADlgProjectionsDialog::~CDIADlgProjectionsDialog()
{
	delete m_pSeg;
}

void CDIADlgProjectionsDialog::SetDocument(CDocImAnDoc *pDoc)
{
	m_pSeg->m_pdoc = pDoc;
}

CImage * CDIADlgProjectionsDialog::GetImage()
{
	if (m_pSeg->m_pdoc != NULL)	return m_pSeg->m_pdoc->GetActiveImage();
	else return NULL;
}

CImage * CDIADlgProjectionsDialog::GetUndoImage(int index)
{
	if (m_pSeg->m_pdoc != NULL) return m_pSeg->m_pdoc->GetUndoImage(index);
	else return NULL;
}

void CDIADlgProjectionsDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PROJECTIONBOX, m_ProjectionBox);
	DDX_Control(pDX, IDC_VERTICAL_PROJECTION, m_VerticalProjButton);
	DDX_Control(pDX, IDC_HORIZONTAL_PROJECTION, m_HorizontalProjButton);
}

BEGIN_MESSAGE_MAP(CDIADlgProjectionsDialog, CDialog)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_VERTICAL_PROJECTION, OnBnClickedVerticalProjection)
	ON_BN_CLICKED(IDC_HORIZONTAL_PROJECTION, OnBnClickedHorizontalProjection)
	//ON_BN_CLICKED(IDC_SMOOTH, OnBnClickedSmooth)
	ON_BN_CLICKED(IDC_FIND_SEPARATORS, OnBnClickedFindSeparators)
//	ON_BN_CLICKED(IDC_ApplySeparators, OnBnClickedApplyseparators)
	ON_BN_CLICKED(IDC_EXPORT_V, OnBnClickedExportV)
	ON_BN_CLICKED(IDC_EXPORT_H, OnBnClickedExportH)
	ON_BN_CLICKED(IDC_COMPLETE_SEGMENTATION, OnBnClickedCompleteSegmentation)
	ON_BN_CLICKED(IDC_EXPORT_ALL, OnBnClickedExportAll)
	ON_BN_CLICKED(IDC_FIX_SEG, OnBnClickedFixSeg)
	ON_BN_CLICKED(IDC_LOCATECHAR2, OnBnClickedLocatechar2)
END_MESSAGE_MAP()

// CDIADlgProjectionsDialog message handlers

BOOL CDIADlgProjectionsDialog::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	if (m_pSeg->m_pdoc != NULL)
	{
		CImage * pOrigImage;
		
		m_pSeg->m_pdoc->CreateNewUndoImage(IT_GREYSCALE);
		pOrigImage = m_pSeg->m_pdoc->GetUndoImage(m_pSeg->m_pdoc->m_index-1);

		m_pSeg->m_pHorzProj = new long[pOrigImage->GetHeight()];
		m_pSeg->m_pVertProj = new long[pOrigImage->GetWidth()];

		pOrigImage->GetProjection(0,0,pOrigImage->GetWidth(),pOrigImage->GetHeight(),m_pSeg->m_pHorzProj ,m_pSeg->m_pVertProj ,PRJ_GREY);

		m_pSeg->m_maxvalVert = CalculateMaxVal(m_pSeg->m_pVertProj,pOrigImage->GetWidth());
		m_pSeg->m_maxvalHorz = CalculateMaxVal(m_pSeg->m_pHorzProj,pOrigImage->GetHeight());		

		m_pSeg->m_pHorzProfileDistribution = new CDistribution <long>;
		m_pSeg->m_pHorzProfileDistribution->Create(m_pSeg->m_pVertProj,pOrigImage->GetWidth());
		m_pSeg->m_pVertProfileDistribution = new CDistribution <long>;
		m_pSeg->m_pVertProfileDistribution->Create(m_pSeg->m_pHorzProj,pOrigImage->GetHeight());
		m_pSeg->m_separatorIndexV = 0;
		m_pSeg->m_separatorIndexH = 0;
		m_pSeg->m_SeparatorsComputedH = false;
		m_pSeg->m_SeparatorsComputedV = false;
		m_pSeg->m_pSeparatorsH = new CTextLine::SEPARATOR[m_pSeg->m_pHorzProfileDistribution->GetMinimaCount()];
		m_pSeg->m_pSeparatorsV = new CTextLine::SEPARATOR[m_pSeg->m_pVertProfileDistribution->GetMinimaCount()];
		for (int i = 0; i < m_pSeg->m_pVertProfileDistribution->GetMinimaCount(); i++)
		{
			m_pSeg->m_pSeparatorsV[i].Strong = false;
		}

		for (int i = 0; i < m_pSeg->m_pHorzProfileDistribution->GetMinimaCount(); i++)
		{
			m_pSeg->m_pSeparatorsH[i].Strong = false;
		}
		m_pSeg->m_pdoc->m_LineHolderIndex = 0;
		m_pSeg->m_pdoc->m_pLineHolder = NULL;
	}
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CDIADlgProjectionsDialog::DisplayProjection(CStatic &box,CDistribution <long> * HistoD)
{

	CDC * pDC;
	CRect rect;

	pDC = box.GetDC();
	box.GetClientRect(&rect);

	CRgn ClipRgn;
	ClipRgn.CreateRectRgn(rect.left, rect.top, rect.right, rect.bottom);
	pDC->SelectClipRgn(&ClipRgn);

	int bpp = pDC->GetDeviceCaps(BITSPIXEL);
	int planes = pDC->GetDeviceCaps(PLANES);

	CBitmap bmp;

	//if (0 == bmp.CreateBitmap(rect.right, maxval,planes,bpp,NULL))
	if (0 == bmp.CreateBitmap(rect.Width(), rect.Height(),planes,bpp,NULL))
	{
		return;
	}
	else
	{
		CDC dc;
		dc.CreateCompatibleDC(NULL);
		dc.SelectObject(&bmp);
		CBrush brush;
		brush.CreateSolidBrush(RGB(158,164,246));
		dc.SelectObject(brush);
		dc.FillRect(CRect(0, 0, rect.Width(), rect.Height()), &brush);

		CPen pen(PS_SOLID,0, RGB(78,2,204));
		dc.SelectObject(pen);
		dc.MoveTo(0,HistoD->GetMaximum());

		long * pArray = HistoD->GetPointArray();
		for (int i = 0; i <= HistoD->GetCount(); i++)
		{
			int x, y;
			x = i*rect.Width()/HistoD->GetCount();
			y = pArray[i]* rect.Height()/HistoD->GetMaximum();
			dc.LineTo(x,rect.Height() - y);
		}
		pDC->BitBlt(0,0,rect.Width(), rect.Height(),&dc,0,0,SRCCOPY);
	}
}
void CDIADlgProjectionsDialog::DisplayProjection(CStatic &box,long * Histo,long maxval, int length)
{
	CDC * pDC;
	CRect rect;

	pDC = box.GetDC();
	box.GetClientRect(&rect);

	CRgn ClipRgn;
	ClipRgn.CreateRectRgn(rect.left, rect.top, rect.right, rect.bottom);
	pDC->SelectClipRgn(&ClipRgn);

	int bpp = pDC->GetDeviceCaps(BITSPIXEL);
	int planes = pDC->GetDeviceCaps(PLANES);

	CBitmap bmp;


	if (0 == bmp.CreateBitmap(rect.Width(), rect.Height(),planes,bpp,NULL))
	{
		return;
	}
	else
	{
		CDC dc;
		dc.CreateCompatibleDC(NULL);
		dc.SelectObject(&bmp);
		CBrush brush;
		brush.CreateSolidBrush(RGB(158,164,246));
		dc.SelectObject(brush);
		dc.FillRect(CRect(0, 0, rect.Width(), rect.Height()), &brush);

		CPen pen(PS_SOLID,0, RGB(78,2,204));
		dc.SelectObject(pen);
		dc.MoveTo(0,maxval);
		for (int i = 0; i <= length; i++)
		{
			int x, y;
			x = i*rect.Width()/length;
			y = Histo[i]* rect.Height()/maxval;
			dc.LineTo(x,rect.Height() - y);
		}
		pDC->BitBlt(0,0,rect.Width(), rect.Height(),&dc,0,0,SRCCOPY);
	}
}

void CDIADlgProjectionsDialog::DisplayProjectionSeparators(CStatic &box,long * Histo,CTextLine::SEPARATOR * Separators, int separatorCount,long maxval, int length)
{
	CDC * pDC;
	CRect rect;

	pDC = box.GetDC();
	box.GetClientRect(&rect);

	CRgn ClipRgn;
	ClipRgn.CreateRectRgn(rect.left, rect.top, rect.right, rect.bottom);
	pDC->SelectClipRgn(&ClipRgn);

	int bpp = pDC->GetDeviceCaps(BITSPIXEL);
	int planes = pDC->GetDeviceCaps(PLANES);

	CBitmap bmp;

	if (0 == bmp.CreateBitmap(rect.Width(), rect.Height(),planes,bpp,NULL))
	{
		return;
	}
	else
	{
		CDC dc;
		dc.CreateCompatibleDC(NULL);
		dc.SelectObject(&bmp);
		CBrush brush;
		brush.CreateSolidBrush(RGB(158,164,246));
		dc.SelectObject(brush);
		dc.FillRect(CRect(0, 0, rect.Width(), rect.Height()), &brush);
		CPen pen(PS_SOLID,0, RGB(78,2,204));
		CPen penSeparator(PS_SOLID,0,RGB(0,255,0));
		CPen penStrongSeparator(PS_SOLID, 0, RGB(255,0,0));
		dc.SelectObject(pen);
		dc.MoveTo(0,rect.bottom);
		int j = 0;
		int x, y;
		for (int i = 0; i <= length; i++)
		{
			x = i*rect.Width()/length;
			y = Histo[i]* rect.Height()/maxval;
			dc.LineTo(x,rect.Height() - y);
		}
		
		
		for (int i = 0; i<= length; i++)
		{
			dc.SelectObject(penSeparator);
			x = i*rect.Width()/length;
			y = Histo[i]* rect.Height()/maxval;
			if ((j<= separatorCount) && (Separators[j].Value == i))
			{
				if (Separators[j].Strong == TRUE) dc.SelectObject(penStrongSeparator);
				dc.MoveTo(x,rect.bottom);
				dc.LineTo(x,rect.top);
				j++;
			}
		}
		pDC->BitBlt(0,0,rect.Width(), rect.Height(),&dc,0,0,SRCCOPY);
	}
	
}

long CDIADlgProjectionsDialog::CalculateMaxVal(long * Histo, int length)
{
	long x = 0;

	for (int i = 0; i < length; i++)
	{
		if (Histo[i]>x) x= Histo[i];
	}
	return x;
}
void CDIADlgProjectionsDialog::OnPaint()
{
	CPaintDC dc(this);// device context for painting
	//DisplayProjection(m_ProjectionBox,m_pVertProj,m_maxvalVert,m_pdoc->GetUndoImage(m_pdoc->m_index-2)->GetHeight());
	if (m_vert) DisplayProjection(m_ProjectionBox,m_pSeg->m_pHorzProj,m_pSeg->m_maxvalHorz,m_pSeg->m_pdoc->GetUndoImage(m_pSeg->m_pdoc->m_index-2)->GetHeight());
	if (m_horz) DisplayProjection(m_ProjectionBox,m_pSeg->m_pVertProj,m_pSeg->m_maxvalVert,m_pSeg->m_pdoc->GetUndoImage(m_pSeg->m_pdoc->m_index-2)->GetWidth());
	if ((m_sepaV) && (m_vert)) DisplayProjectionSeparators(m_ProjectionBox,m_pSeg->m_pHorzProj,m_pSeg->m_pSeparatorsV,m_pSeg->m_separatorIndexV,m_pSeg->m_maxvalHorz,m_pSeg->m_pdoc->GetUndoImage(m_pSeg->m_pdoc->m_index-2)->GetHeight());
	if ((m_sepaH) && (m_horz)) DisplayProjectionSeparators(m_ProjectionBox,m_pSeg->m_pVertProj,m_pSeg->m_pSeparatorsH,m_pSeg->m_separatorIndexH,m_pSeg->m_maxvalVert,m_pSeg->m_pdoc->GetUndoImage(m_pSeg->m_pdoc->m_index-2)->GetWidth());
	//if (m_horz) DisplayProjection(m_ProjectionBox,m_pHorzDistribution);
}

void CDIADlgProjectionsDialog::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	OnOK();
	m_pSeg->m_pdoc->OnEditUndo();
}

void CDIADlgProjectionsDialog::OnBnClickedVerticalProjection()
{
	
	m_horz = FALSE;
	m_vert = TRUE;
	m_sepaV = FALSE;
	m_sepaH = FALSE;
	SetWindowText(_T("Vertical Projection Profile"));
	Invalidate();
}

void CDIADlgProjectionsDialog::OnBnClickedHorizontalProjection()
{
	m_vert = FALSE;
	m_horz = TRUE;
	m_sepaV = FALSE;
	m_sepaH = FALSE;
	SetWindowText(_T("Horizontal Projection Profile"));
	Invalidate();
}

void CDIADlgProjectionsDialog::OnBnClickedSmooth()
{
	if (m_horz == FALSE)
	{

	}
}


void CDIADlgProjectionsDialog::OnBnClickedFindSeparators()
{
	CImage * pOrigImage;
	pOrigImage = m_pSeg->m_pdoc->GetUndoImage(m_pSeg->m_pdoc->m_index-2);
	//if (m_sepa = TRUE) return;

	//Creation of Distribution for Horz and vert
	if (m_horz) 
	{
		m_sepaH = TRUE;
		m_sepaV = FALSE;
		if (!m_pSeg->m_SeparatorsComputedH)
		{

			m_pSeg->m_SeparatorsComputedH = TRUE;
			m_pSeg->m_pHorzProfileDistribution->RemoveSubbase();
			m_pSeg->m_pHorzProfileDistribution->ComputeExtrema();

			int * p_minArray;
	
			p_minArray = m_pSeg->m_pHorzProfileDistribution->GetMinimaPositions();
			for (int i=0; i < m_pSeg->m_pHorzProfileDistribution->GetMinimaCount(); i++)
			{
				m_pSeg->m_pSeparatorsH[m_pSeg->m_separatorIndexH].Value = p_minArray[i];
				m_pSeg->m_separatorIndexH++;
			}
			m_pSeg->SelectionateStrongSeparators7H(m_pSeg->m_pSeparatorsH,m_pSeg->m_separatorIndexH, m_pSeg->m_pHorzProfileDistribution);
		}
	}
	if (m_vert)
	{
		m_sepaV = TRUE;
		m_sepaH = FALSE;
		if (!m_pSeg->m_SeparatorsComputedV)
		{
			m_pSeg->m_SeparatorsComputedV = TRUE;

			m_pSeg->m_pVertProfileDistribution->RemoveSubbase();
			m_pSeg->m_pVertProfileDistribution->ComputeExtrema();
	
			int * p_minArray;

			p_minArray = m_pSeg->m_pVertProfileDistribution->GetMinimaPositions();
			long valueR,valueL;
			int posR, posL;
			long heightDistance;
			int widthDistance;

			//widthDistance and heightDistance are the thresholds
			//may vary from horz to vert profiles
			widthDistance = 5;
			heightDistance = 4500;


			for (int i=0; i < m_pSeg->m_pVertProfileDistribution->GetMinimaCount(); i++)
			{
				posR = m_pSeg->m_pVertProfileDistribution->GetLocalMaximumPos(p_minArray[i],GLM_SD_RIGHT,GLM_OUTOFBOUNDS_VALUES);
				valueR = m_pSeg->m_pVertProfileDistribution->GetAt(posR);
				posL = m_pSeg->m_pVertProfileDistribution->GetLocalMaximumPos(p_minArray[i],GLM_SD_LEFT,GLM_OUTOFBOUNDS_VALUES);
				valueL = m_pSeg->m_pVertProfileDistribution->GetAt(posL);
				if ((abs(p_minArray[i]-posR)>= widthDistance) || (abs(m_pSeg->m_pVertProfileDistribution->GetAt(p_minArray[i])-valueR)>= heightDistance) || (abs(p_minArray[i]-posL)>= widthDistance) || (abs(m_pSeg->m_pVertProfileDistribution->GetAt(p_minArray[i])-valueL)>= heightDistance))
					{
						m_pSeg->m_pSeparatorsV[m_pSeg->m_separatorIndexV].Value = p_minArray[i];
						m_pSeg->m_separatorIndexV++;
					}
			}
			m_pSeg->SelectionateStrongSeparators7V(m_pSeg->m_pSeparatorsV,m_pSeg->m_separatorIndexV, m_pSeg->m_pVertProfileDistribution);
		}
	}
Invalidate();
}




void CDIADlgProjectionsDialog::OnBnClickedExportV()
{
	FILE * pFile;
	static char BASED_CODE szFilter[]=
		"Comma Separated Values(*.csv)|All Files (*.*)|*.*||";


	char Values[] = "Values";
	char Minima[] = "Minima";
	char Maxima[] = "Maxima";
	char Separators[] = "Separators";
	char SSeparators[] = "Strong Separators";
	char   c = '\n';
	long Val,Min,Max,Sep,SS;
	int cur_ValueMin = 0;
	int cur_ValueMax = 0;
	int cur_ValueSep = 0;
	int * MinimaArray;
	int * MaximaArray;

	CString m_name = GetImage()->GetName();	
	CFileDialog m_FileDialog(FALSE,NULL,m_name,OFN_FILEMUSTEXIST|OFN_HIDEREADONLY
		,NULL, 0);
	if (m_FileDialog.DoModal() == IDOK)
		{	
			CString m_pathName = m_FileDialog.GetPathName();
			pFile = _tfopen(m_pathName, _T("w"));

			if (m_vert)
			{
				if (m_pSeg->m_pVertProfileDistribution != NULL)
				{
					 MinimaArray = m_pSeg->m_pVertProfileDistribution->GetMinimaPositions();
					 MaximaArray = m_pSeg->m_pVertProfileDistribution->GetMaximaPositions();
					if (m_pSeg->m_pSeparatorsV != NULL)
					{
						fprintf(pFile,"%s,%s,%s,%s,%s%c",Values,Minima,Maxima,Separators,SSeparators,c);
					}
					for (int i = 0; i <= m_pSeg->m_pVertProfileDistribution->GetCount();i++)
					{
						Val = m_pSeg->m_pVertProfileDistribution->GetAt(i);
						if (MinimaArray[cur_ValueMin] == i)
						{
							Min = m_pSeg->m_pVertProfileDistribution->GetAt(i);
							cur_ValueMin++;
						}
						else Min = 0;
						
						if (MaximaArray[cur_ValueMax] == i)
						{
							Max = m_pSeg->m_pVertProfileDistribution->GetAt(i);
							cur_ValueMax++;
						}
						else Max = 0;
						
						if (m_pSeg->m_pSeparatorsV[cur_ValueSep].Value == i)
						{
							Sep = m_pSeg->m_pVertProfileDistribution->GetAt(i);
							if (m_pSeg->m_pSeparatorsV[cur_ValueSep].Strong)
							{
								SS = Sep;
							}
							else
							{SS = 0;}
							cur_ValueSep++;
						}
						else 
						{
							Sep = 0;
							SS = 0;
						}
						//write on file
						fprintf(pFile,"%i,%i,%i,%i,%i %c",Val,Min,Max,Sep,SS,c);
						
					}
				}
			}
			fclose(pFile);
		}
}

void CDIADlgProjectionsDialog::OnBnClickedExportH()
{
	FILE * pFile;
	static char BASED_CODE szFilter[]=
		"Comma Separated Values(*.csv)|All Files (*.*)|*.*||";

	char Values[] = "Values";
	char Minima[] = "Minima";
	char Maxima[] = "Maxima";
	char Separators[] = "Separators";
	char SSeparators[] = "Strong Separators";
	char   c = '\n';
	long Val,Min,Max,Sep,SS;
	int cur_ValueMin = 0;
	int cur_ValueMax = 0;
	int cur_ValueSep = 0;
	int * MinimaArray;
	int * MaximaArray;

	CString m_name = GetImage()->GetName();	
	CFileDialog m_FileDialog(FALSE,NULL,m_name,OFN_FILEMUSTEXIST|OFN_HIDEREADONLY
		,NULL, 0);
	if (m_FileDialog.DoModal() == IDOK)
		{	
			CString m_pathName = m_FileDialog.GetPathName();
			pFile = _tfopen(m_pathName, _T("w"));

			if (m_horz)
			{
				if (m_pSeg->m_pHorzProfileDistribution != NULL)
				{
					 MinimaArray = m_pSeg->m_pHorzProfileDistribution->GetMinimaPositions();
					 MaximaArray = m_pSeg->m_pHorzProfileDistribution->GetMaximaPositions();
					if (m_pSeg->m_pSeparatorsH != NULL)
					{
						fprintf(pFile,"%s,%s,%s,%s,%s%c",Values,Minima,Maxima,Separators,SSeparators,c);
					}
					for (int i = 0; i <= m_pSeg->m_pHorzProfileDistribution->GetCount();i++)
					{
						Val = m_pSeg->m_pHorzProfileDistribution->GetAt(i);
						if (MinimaArray[cur_ValueMin] == i)
						{
							Min = m_pSeg->m_pHorzProfileDistribution->GetAt(i);
							cur_ValueMin++;
						}
						else Min = 0;
						
						if (MaximaArray[cur_ValueMax] == i)
						{
							Max = m_pSeg->m_pHorzProfileDistribution->GetAt(i);
							cur_ValueMax++;
						}
						else Max = 0;
						
						if (m_pSeg->m_pSeparatorsH[cur_ValueSep].Value == i)
						{
							Sep = m_pSeg->m_pHorzProfileDistribution->GetAt(i);
							if (m_pSeg->m_pSeparatorsH[cur_ValueSep].Strong)
							{
								SS = Sep;
							}
							else
							{SS = 0;}
							cur_ValueSep++;
						}
						else 
						{
							Sep = 0;
							SS = 0;
						}
						//write on file
						fprintf(pFile,"%i,%i,%i,%i,%i %c",Val,Min,Max,Sep,SS,c);
						
					}
				}
			}
			fclose(pFile);
		}
}



void CDIADlgProjectionsDialog::OnBnClickedCompleteSegmentation()
{
	m_pSeg->FindVerticalSeparators();
	m_pSeg->CreateHorizontalLines();
	m_pSeg->FindHorizontalSeparatorsFromLines2();
	m_pSeg->CreateCharacters();
//	m_pSeg->ComputeCharacterStatistics();
	
	m_complete = true;
	m_sepaV = true;
	m_sepaH = false;
}


void CDIADlgProjectionsDialog::OnBnClickedExportAll()
{
	FILE * pFile;
	char Line[] = "Line";
	char Values[] = "Values";
	char Minima[] = "Minima";
	char Maxima[] = "Maxima";
	char Separators[] = "Separators";
	//char SSeparators[] = "Strong Separators";
	char Mean[] = "Mean";
	char ChartMax[] = "ChartMax";
	char ChartMax2[] = "ChartMax2";

	char   c = '\n';
	long Ln,Val,Sep,Mn,CM,CM2;
	int cur_ValueSep = 0;

	CString m_name = GetImage()->GetName();	
			 //VarName ("C:\\Documents and Settings\\celia\\My Documents\\Projects\\Memorial\\Big Original Images\\");
			CString VarName;
			VarName = m_name ;//+ ".csv";
			VarName += ".csv";
			TRACE(VarName);
			pFile = _tfopen(VarName, _T("w"));

			if (m_complete)
			{
				if (m_pSeg->m_pdoc->m_LineHolderIndex != NULL)
				{
					fprintf(pFile,"%s,%s,%s,%s,%s,%s%c",Line,Values,Separators,Mean,ChartMax,ChartMax2,c);
					for (int i = 0; i < m_pSeg->m_pdoc->m_LineHolderIndex;i++)
					{
						Ln = i;
						cur_ValueSep = 0;
						for (int j = 0; j <= m_pSeg->m_pdoc->m_pLineHolder[i].m_pTextLineDistribution->GetCount(); j++)
						{
							Val = m_pSeg->m_pdoc->m_pLineHolder[i].m_pTextLineDistribution->GetAt(j);
							if (m_pSeg->m_pdoc->m_pLineHolder[i].m_pCharacterHolder[cur_ValueSep].m_Position_X == j)
							{
								Sep = Val;
								cur_ValueSep++;
							}
							else
							{
								Sep = 0;
							}
							Mn = m_pSeg->m_pdoc->m_pLineHolder[i].m_mean;
							CM = m_pSeg->m_pdoc->m_pLineHolder[i].m_ChartMax;
							if (m_pSeg->m_pdoc->m_pLineHolder[i].m_ChartMax2 >= 0)
							{
								CM2 = m_pSeg->m_pdoc->m_pLineHolder[i].m_ChartMax2;
							}
							else
							{
								CM2 = 0;
							}
							//last case display the position_Y for the last separator
							if (m_pSeg->m_pdoc->m_pLineHolder[i].m_CharacterHolderIndex == cur_ValueSep)
							{
								if (m_pSeg->m_pdoc->m_pLineHolder[i].m_pCharacterHolder[cur_ValueSep-1].m_Position_X +m_pSeg->m_pdoc->m_pLineHolder[i].m_pCharacterHolder[cur_ValueSep-1].m_Width  == j)
									{
										Sep = Val;
										cur_ValueSep++;
									}
							}
							//write on file
							fprintf(pFile,"%i,%i,%i,%i,%i,%i %c",Ln,Val,Sep,Mn,CM,CM2,c);
						}
					}
				}
			}
			fclose(pFile);
}

void CDIADlgProjectionsDialog::OnBnClickedFixSeg()
{
	
	m_pSeg->ComputeFixedWidthSegmentation3(50,30);
}

void CDIADlgProjectionsDialog::OnBnClickedLocatechar2()
{
//CDIAImage * Image;
	
	//find character box for each character
	for (int i = 0; i < m_pSeg->m_pdoc->m_LineHolderIndex; i++)
	{
		for (int j = 0; j < m_pSeg->m_pdoc->m_pLineHolder[i].m_CharacterHolderIndex; j++)
		{
			//Image = new CDIAImage;
			//Image->Create(m_pSeg->m_pdoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Width,m_pSeg->m_pdoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Height,RGB(0,0,0),(LPCTSTR) "BWImage");
		
			//m_pSeg->m_pdoc->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage->Threshold(128,CRect(0,0,m_pSeg->m_pdoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Width,(int)m_pSeg->m_pdoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Height),Image);
			//m_pCharEnh->LocateChar((CDIABiLevelImage*) Image);
			m_pSeg->m_pdoc->m_pLineHolder[i].m_pCharacterHolder[j].LocateChar(m_pSeg->m_pdoc->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage);
			//delete Image;
		}
	}
	m_pSeg->m_pdoc->m_ShowInBox = true;
}
