#pragma once
#include "resource.h"
#include "Image.h"
#include "DocImAnDoc.h"
#include "DIAGreyScale.h"
#include "afxwin.h"
#include "Distribution.h"
#include "TextLine.h"
#include "DIASegmentation.h"

class CTextLine;
class CDocImAnDoc;


// CDIADlgProjectionsDialog dialog

class CDIADlgProjectionsDialog : public CDialog
{
	DECLARE_DYNAMIC(CDIADlgProjectionsDialog)

public:
	CDIADlgProjectionsDialog(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDIADlgProjectionsDialog();
// Dialog Data
	enum { IDD = IDD_PROJECTIONS };
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
	void DisplayProjection(CStatic &box,long * Histo, long maxval,int length);
	void DisplayProjection(CStatic &box,CDistribution <long> * HistoD);
	void DisplayProjectionSeparators(CStatic &box,long * Histo,CTextLine::SEPARATOR * Separators, int separatorCount,long maxval, int length);
	long CalculateMaxVal(long * Histo, int length);
	void SetDocument(CDocImAnDoc *pDoc);
	CImage * GetUndoImage(int index);
	CImage * GetImage();

	DIASegmentation * m_pSeg;
	BOOL m_vert, m_horz, m_sepaV, m_sepaH, m_complete;
	BOOL apply_separatorsV,apply_separatorsH;
	long m_threshold;
	afx_msg void OnPaint();
	CStatic m_ProjectionBox;
	afx_msg void OnBnClickedOk();
	
	CButton m_VerticalProjButton;
	CButton m_HorizontalProjButton;
	afx_msg void OnBnClickedVerticalProjection();
	afx_msg void OnBnClickedHorizontalProjection();
	afx_msg void OnBnClickedSmooth();
	afx_msg void OnBnClickedFindSeparators();
	afx_msg void OnBnClickedApplyseparators();
	afx_msg void OnBnClickedExportV();
	afx_msg void OnBnClickedExportH();
	afx_msg void OnBnClickedCompleteSegmentation();
	afx_msg void OnBnClickedExportAll();
	afx_msg void OnBnClickedFixSeg();
	afx_msg void OnBnClickedLocatechar2();
};
