#pragma once
#include "ImageLib.h"

//Define the Image Type for this class
#define IT_DIA_GREYSCALE	IT_USERAPP1 | IT_GREYSCALE

class CDIAGreyScale : public CGreyScaleImage
{	
	DECLARE_SERIAL(CDIAGreyScale);
	public:	CDIAGreyScale(void);	
	virtual ~ CDIAGreyScale(void);	
	CPoint MoveinDirection(int direction, CPoint size, CPoint Location);
	public:
		//Thresholding Flags
		#define THR_GATOS_PP	0x10

	void	Threshold_Gatos(int WindowSize = 40, CRect& rect = CRect(-1,-1,-1,-1), CImage * pOutputImage = NULL, BYTE Flags = THR_OUTPUT_MAP|THR_OUTPUT_IMAGE|THR_GATOS_PP);
	void	UpdateMap(int T1, int T2,BYTE PixelType);
	void	GetContour(int Left,int Top, int Width, int Height, long * LContour, long *RContour);
	int		GetRun(int &lineNo, int &columnNo, int direction);
	void	Threshold_Bernsen(int WindowSize, CRect& rect, CImage * pOutputImage, BYTE Flags);


private:
//	void		ApplyAdvancedTreshold(RANGE_VALS* range, int size);
    void		Threshold_Gatos_PostProcessing(int WindowSize, CRect& rect);
    double		Threshold_Gatos_D(double AvgDifference, double AvgBackground, BYTE val);
	
};