#pragma once
#include "afxcmn.h"
#include "afxwin.h"
#include "math.h"
//#include "DocImAnDoc.h"
#include "Image.h"
//#include "DIAGreyScale.h"
//#include "DIACharacter.h"

class CDIACharacter;
class CDocImAnDoc;
class CDIAGreyScale;
class CDIAHistograms
{
public:
	CDIAHistograms(void);
	~CDIAHistograms(void);

	void CalculateFunction(int TopPos, int DownPos);
	void ComputeTransformation(CImage * pImage, CImage * pOrigImage);
	void ComputeTransformation(CImage * pImage, CImage * pOrigImage, CRect rect);
	void ComputeAdaptiveTransformation(CImage * pImage, CImage * pOrigImage, CRect rect);
	void ComputeEqualization(CImage * pImage, CImage * pOrigImage);
	void ComputeHistogram(unsigned long *inHisto,unsigned long *maxval, CImage *image);
	void ComputeHistogram(unsigned long *inHisto,unsigned long *maxval, CDIAGreyScale *image);
	void ComputeHistogram(unsigned long *inHisto,unsigned long *maxval, CRect rect, CImage *Image);
	void CalculateFunctionContrast(unsigned long * Histo,int AB, int BC, bool init);
	void AdaptiveStretchHisto(CImage * image, CRect rect, CImage * outImage);
	void StretchHisto(CImage * image, CRect rect, CImage * outImage);
	inline float CDIAHistograms::Sigma(float f,float sigma)
		{ 
		f = f*2 - 1; //range [-1,1]
		return (float)(0.5+(f>0?1:-1)*0.5*pow( (f>0?1:-1)*f, exp(sigma) ));//(m_Sigma==0?1:(m_Sigma>0?m_Sigma:1.0/(-m_Sigma))) ));
		}

	int GetMinimum();
	int GetMaximum();
	
	CDocImAnDoc * m_pdoc;
	unsigned long*   m_inHistogram;		// Input histogram
	unsigned long*   m_outHistogram;	
	unsigned long*   m_transformation;
	unsigned long*	m_LUT;
	unsigned long   m_maxvalueLUT;
	unsigned long	m_maxvalueInHisto;
	unsigned long	m_maxvalueOutHisto;
	unsigned long	m_maxvalueTransformation;

	float m_sigma;
};
