#pragma once
#include "Image.h"
#include "DocImAnDoc.h"
#include "DIAGreyScale.h"
#include "afxwin.h"
#include "Distribution.h"
#include "TextLine.h"

class DIASegmentation
{
public:
	DIASegmentation(void);
	~DIASegmentation(void);
	long CalculateMaxVal(long * Histo, int length);
	void SelectionateStrongSeparators1(CTextLine::SEPARATOR * p_separator,int separatorIndex, CDistribution <long> * p_ProfileDistribution);
	void SelectionateStrongSeparators2(CTextLine::SEPARATOR * p_separator,int separatorIndex, CDistribution <long> * p_ProfileDistribution);
	void SelectionateStrongSeparators2(CTextLine::SEPARATOR * p_separator,int separatorIndex, CDistribution <long> * p_ProfileDistribution,long threshold);
	void SelectionateStrongSeparators3(CTextLine::SEPARATOR * p_separator,int separatorIndex, CDistribution <long> * p_ProfileDistribution);
	void SelectionateStrongSeparators4(CTextLine::SEPARATOR * p_separator,int separatorIndex, CDistribution <long> * p_ProfileDistribution);
	void SelectionateStrongSeparators5(CTextLine::SEPARATOR * p_separator,int separatorIndex, CDistribution <long> * p_ProfileDistribution);
	void SelectionateStrongSeparators6(CTextLine::SEPARATOR * p_separator,int separatorIndex, CDistribution <long> * p_ProfileDistribution);
	void SelectionateStrongSeparators7H(CTextLine::SEPARATOR * p_separator,int separatorIndex, CDistribution <long> * p_ProfileDistribution);
	void SelectionateStrongSeparators7H2(CTextLine::SEPARATOR * p_separator,int separatorIndex, CDistribution <long> * p_ProfileDistribution);
	void SelectionateStrongSeparators7V(CTextLine::SEPARATOR * p_separator,int separatorIndex, CDistribution <long> * p_ProfileDistribution);
	void SelectionateStrongSeparators8V(CTextLine::SEPARATOR * p_separator,int separatorIndex, CDistribution <long> * p_ProfileDistribution);
	void GetStrongSeparators(CTextLine::SEPARATOR * p_separator,int separatorIndex);
	void GetStrongSeparators(CTextLine::SEPARATOR * p_separator,int separatorIndex,long * &p_StrongSeparators, int &StrongSeparatorsIndex);
	void CreateHorizontalLines();
	void CreateCharacters();
	bool CreateFixedWidthCharacters(int FirstSeparator, int NextSeparator, CTextLine * Line,CImage * pOrigImage, int LineNum,int CharNum);
	bool CreateFixedWidthCharacters2(int FirstSeparator, int NextSeparator, CTextLine * Line,CImage * pOrigImage, int LineNum,int CharNum);
	bool CreateFixedWidthLines(int FirstSeparator, int NextSeparator,CImage * pOrigImage,CDistribution <long> * ImageDistribution);
	void FindVerticalSeparators();
	void FindHorizontalSeparatorsFromLines();
	void FindHorizontalSeparatorsFromLines2();
	void ComputeCharacterStatistics();
	void ComputeFixedWidthSegmentation();
	void ComputeFixedWidthSegmentation2(int FixedWidth);
	void ComputeFixedWidthSegmentation3(int FixedWidthLines, int FixedWidthChars);
	void ComputeFixedWidthSegmentation4(int FixedWidth);

	void ComputeFixedWidthLineSegmentation(int FixedWidth);
	long FindMinMaxBetweenTwo(int firstpos, int secondpos,CDistribution <long> * Distri,bool Mm,bool PosVal);
	int FindIfValueIsInRange(int first,CTextLine::SEPARATOR * separators,int nseparators,int minrange,int maxrange, int percent,double lomin, double himin);
	//long FindMinMaxBetweenTwo(int firstpos, int secondpos,int linepos, bool Mm);
	CTextLine::FIXINFO CalculateMinimumCostFixedSegmentation(int FixedWidth, CDistribution <long> *profile);
	void FixedWidthLinesSeg(int FixedWidth);
	void FixedWidthCharsSeg(int FixedWidth);
	CImage * GetUndoImage(int index);

	CImage * GetImage();

	
	CDistribution <long> * m_pHorzProfileDistribution;
	CDistribution <long> * m_pVertProfileDistribution;

	typedef struct INFO
	{
		long Value;
		int Count;
	};

	
	
	CDocImAnDoc * m_pdoc;
	long * m_pVertProj;
	long * m_pHorzProj;
	CTextLine::SEPARATOR * m_pSeparatorsH;
	CTextLine::SEPARATOR * m_pSeparatorsV;
	BOOL m_SeparatorsComputedH, m_SeparatorsComputedV;
	int m_StrongSeparatorIndex;
	long * m_pStrongSeparators;
	INFO * m_pChart;
	int m_separatorIndexV;
	int m_separatorIndexH;
	long m_maxvalVert;
	long m_maxvalHorz;
	BOOL m_vert, m_horz, m_sepaV, m_sepaH, m_complete;
	BOOL apply_separatorsV,apply_separatorsH;
	long m_threshold;
	long m_mean;
	int m_ChartMax;
	
};
