#include "StdAfx.h"
#include <iostream>
#include <fstream>
#include ".\diaxmldoc.h"
#include "DocImAnDoc.h"
#include "XMLDocument.h"
#include "XMLElement.h"
#include "XMLAttribute.h"
#include "XMLDefinition.h"
using namespace std;

CDIAXmlDoc::CDIAXmlDoc(void)
{
}

CDIAXmlDoc::~CDIAXmlDoc(void)
{
}
char * CStringToCharArray(CString  s)
{
	int Length = s.GetLength() + 1;
	char * c;
	int i;

	c = new char[Length];
	if(c == NULL)
		return NULL;

	for(i = 0; i < Length - 1; i++)
		c[i] = s.GetAt(i);
	c[Length - 1] = '\0';

	return c;
}

void CDIAXmlDoc::CreateXmlDoc2(CDocImAnDoc* pDoc)
{
	
	CXMLDocument document;
	//create file and open it
	FILE * pFile;
	CString FileName;
	FileName.Format(_T("%s.xml"),pDoc->GetActiveImage()->GetName());
	
	pFile = _tfopen(FileName, _T("w"));

	//Create Definition
	CXMLDefinition * definition = new CXMLDefinition("1.0","UTF-8");
	document.SetDefinition(definition);

	//create image elemet as baseElement
	CXMLElement * image = new CXMLElement("Image");

	if (pDoc->GetActiveImage() != NULL)
	{

		//attributes for image
		CXMLAttribute * height = new CXMLAttribute("Height",pDoc->GetActiveImage()->GetHeight());
		image->AddAttribute(height);

		CXMLAttribute * width = new CXMLAttribute("Width",pDoc->GetActiveImage()->GetWidth());
		image->AddAttribute(width);

		//char * cname = CStringToCharArray(pDoc->GetActiveImage()->GetName());
		CXMLAttribute * name = new CXMLAttribute("Name",CStringToCharArray(pDoc->GetActiveImage()->GetName()));
		//delete cname;
		image->AddAttribute(name);
		
		CXMLAttribute * type = new CXMLAttribute("Type","tif");
		image->AddAttribute(type);

		
		//creation of lines
		
		if (pDoc->m_IsCharLocalized == true)
		{
			for (int i = 0; i < pDoc->m_LineHolderIndex;i++)
			{
				CXMLElement * line = new CXMLElement("Line");
				//create line attributes

				CXMLAttribute * line_no = new CXMLAttribute("Line_Number",i);
				line->AddAttribute(line_no);

				CXMLAttribute * line_pos_Y = new CXMLAttribute("Line_Position_Y",pDoc->m_pLineHolder[i].m_Position_Y);
				line->AddAttribute(line_pos_Y);

				CXMLAttribute * line_height = new CXMLAttribute("Line_Height",pDoc->m_pLineHolder[i].m_Height);
				line->AddAttribute(line_height);

				CXMLAttribute * line_width = new CXMLAttribute("Line_Width",pDoc->m_pLineHolder[i].m_Width);
				line->AddAttribute(line_width);
				
				CXMLAttribute * line_NoChars = new CXMLAttribute("Line_No_Characters",pDoc->m_pLineHolder[i].m_CharacterHolderIndex);
				line->AddAttribute(line_NoChars);

				//create chars
				for (int j = 0; j < pDoc->m_pLineHolder[i].m_CharacterHolderIndex; j++)
				{
					CXMLElement * character = new CXMLElement("Character");
					//create char attributes
					CXMLAttribute * char_no = new CXMLAttribute("Character_No",j);
					character->AddAttribute(char_no);

					CXMLAttribute * char_Pos_X = new CXMLAttribute("Character_Position_X",pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X);
					character->AddAttribute(char_Pos_X);

					CXMLAttribute * char_Pos_Y = new CXMLAttribute("Character_Position_Y",pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y);
					character->AddAttribute(char_Pos_Y);

					CXMLAttribute * char_Height = new CXMLAttribute("Character_Height",pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Height);
					character->AddAttribute(char_Height);

					CXMLAttribute * char_Width = new CXMLAttribute("Character_Width",pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Width);
					character->AddAttribute(char_Width);
					
						CXMLElement * localized_Char = new CXMLElement("Localized_Character");

						CXMLAttribute * loc_charX = new CXMLAttribute("PosX",pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left);
						localized_Char->AddAttribute(loc_charX);
						
						CXMLAttribute * loc_charY = new CXMLAttribute("PosY",pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top);
						localized_Char->AddAttribute(loc_charY);

						CXMLAttribute * loc_width = new CXMLAttribute("Localized_Width",pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_LocatedWidth);
						localized_Char->AddAttribute(loc_width);

						CXMLAttribute * loc_height = new CXMLAttribute("Localized_Height",pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_LocatedHeight);
						localized_Char->AddAttribute(loc_height);

						/*CXMLAttribute * loc_1stMatch = new CXMLAttribute("1st Match",pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[0].charname);
						localized_Char->AddAttribute(loc_1stMatch);

						CXMLAttribute * loc_2ndMatch = new CXMLAttribute("2nd Match",pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[1].charname);
						localized_Char->AddAttribute(loc_2ndMatch);
						
						CXMLAttribute * loc_3rdMatch = new CXMLAttribute("3rd Match",pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[2].charname);
						localized_Char->AddAttribute(loc_3rdMatch);*/

						character->AddChild(localized_Char);

					//char recognition 3
					if (pDoc->m_bIsImageRecognized == true)
					{
						for (int i = 0; i < 3; i++)
						{
							CXMLElement * Recognized_character = new CXMLElement("Recognized_Character");
						
							//attributes
							CXMLAttribute * rchar_no = new CXMLAttribute("Character_no",i+1);
							Recognized_character->AddAttribute(rchar_no);

							CXMLAttribute * rchar_name = new CXMLAttribute("Character_Name",pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[i].charname);
							Recognized_character->AddAttribute(rchar_name);
	
							char * capital;
							if (pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[i].isCapital)
							{
								capital = "yes";
							}
							else
							{
								capital = "no";
							}
							CXMLAttribute * rchar_capital = new CXMLAttribute("Character_Capital",capital);
							Recognized_character->AddAttribute(rchar_capital);

							CString path;
							path.Format(_T("%s%c"),pDoc->m_PerfectImagePath,pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[i].charname);
							char * cpath = CStringToCharArray(path);
							CXMLAttribute * rchar_path = new CXMLAttribute("Character_Path",cpath);
							delete cpath;
							Recognized_character->AddAttribute(rchar_path);

							CXMLAttribute * rchar_rate = new CXMLAttribute("Character_Rate",pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[i].rate);
							Recognized_character->AddAttribute(rchar_rate);

							character->AddChild(Recognized_character);
						}
					}
					line->AddChild(character);
				}
				image->AddChild(line);

			}
		
		}
	}
		

	


	document.SetBaseElement(image);
	document.WriteToFile(pFile);

	fclose(pFile);

}

void CDIAXmlDoc::CreateXmlDoc(CDocImAnDoc* pDoc)
{
	FILE * pFile;
	CString FileName;

	CString t1, t2, t3, t4, t5, t6;
	t1 = "\t";
	t2 = "\t\t";
	t3 = "\t\t\t";
	t4 = "\t\t\t\t";
	t5 = "\t\t\t\t\t";
	t6 = "\t\t\t\t\t\t";
	//format standards
	otImage.Format(_T("<<Image>>"));
	ctImage.Format(_T("<</Image>>"));
	otLine.Format(_T("<Line>"));
	ctLine.Format(_T("</Line>"));
	otImage_Contents.Format(_T("<Image_Contents>"));
	ctImage_Contents.Format(_T("</Image_Contents>"));
	otLine_Contents.Format(_T("<Line_Contents>"));
	ctLine_Contents.Format(_T("</Line_Contents>"));

	FileName.Format(_T("%s.xml"),pDoc->GetActiveImage()->GetName()); 
	pFile = _tfopen(FileName, _T("w"));
	//write in the file
	CString header;
	header = "<<?xml version=\"1.0\" encoding=\"UTF-8\"?>>\n";
	fprintf(pFile,"%s",header);
	
	//image
	//print open tag of Image
	fprintf(pFile,"%s",otImage);
		//descrption
		Image_Height.Format(_T("<Image_Height>%d</Image_Height>\n"),pDoc->GetActiveImage()->GetHeight());
		Image_Width.Format(_T("<Image_Width>%d</Image_Width>\n"),pDoc->GetActiveImage()->GetWidth());
		Image_Size.Format(_T("<Image_Size>%s%s</Image_Size>\n"),Image_Width,Image_Height);

		Image_Name.Format(_T("<Image_Name>%s</Image_Name>\n"),pDoc->GetActiveImage()->GetName());
		Image_Type.Format(_T("<Image_Type>tif</Image_Type>\n"));
		Image_Description.Format(_T("<Image_Description>%s%s</Image_Description>\n"),Image_Name,Image_Size);
		//print Image Description
		fprintf(pFile,"%s",Image_Description);
		//contents
			
		//print open tag of Image_Contents
		fprintf(pFile,"%s",otImage_Contents);
			
				//lines
				for (int i = 0; i < pDoc->m_LineHolderIndex;i++)
				{
					//print open tag of Line
					fprintf(pFile,"%s\n",otLine);
					//description
					LineNo.Format(_T("<<LineNo>%d</LineNo>\n"),i);
					Line_Position_Y.Format(_T("<Line_Position_Y>%d</Line_Position_Y>\n"),pDoc->m_pLineHolder[i].m_Position_Y);

					Line_Height.Format(_T("<Line_Height>%d</Line_Height>\n"),pDoc->m_pLineHolder[i].m_Height);
					Line_Widht.Format(_T("<Line_Width>%d</Line_Width>\n"),pDoc->m_pLineHolder[i].m_Width);
					Line_Size.Format(_T("%s%s\n"),Line_Widht,Line_Height);

					Line_NoCharacters.Format(_T("<Line_NoCharacters>%d</Line_NoCharacters>\n"),pDoc->m_pLineHolder[i].m_CharacterHolderIndex);
					Line_Description.Format(_T("%s%s%s%s\n"),LineNo,Line_Position_Y,Line_Size,Line_NoCharacters);

					//print Line_Description
					char c = '\n';
					fprintf(pFile,"%s%c",Line_Description,c);

						//print open tag of Line_Contents
						fprintf(pFile,"%s\n",otLine_Contents);
						for (int j = 0; j < pDoc->m_pLineHolder[i].m_CharacterHolderIndex; j++)
						{
							//words??
							//character
							CharNo.Format(_T("<CharNo>%d</CharNo>\n"),pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharNum);
							Char_Position_X.Format(_T("<Char_Position_X>%d</Char_Position_X>\n"),pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X);
							Char_Position_Y.Format(_T("<Char_Position_Y>%d</Char_Position_Y>\n"),pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y);
							Char_Height.Format(_T("<Char_Height>%d</Char_Height>\n"),pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Height);
							Char_Width.Format(_T("<Char_Width>%d</Char_Width>\n"),pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Width);
							Char_Size.Format(_T("<Char_Size>%s%s</Char_Size>\n"),Char_Height,Char_Width);
			
							//3 best characters
							Char_Path.Format(_T("<Char_Path>%s%c.tif</Char_Path>\n"),pDoc->m_PerfectImagePath,pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[0].charname);
							Char_Rate.Format(_T("<Char_Rate>%d</Char_Rate>\n"),pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[0].rate);
							Char1.Format(_T("<Char>%s%s</Char>\n"),Char_Path,Char_Rate);

							Char_Path.Format(_T("<Char_Path>%s%c.tif</Char_Path>\n"),pDoc->m_PerfectImagePath,pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[1].charname);
							Char_Rate.Format(_T("<Char_Rate>%d</Char_Rate>\n"),pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[1].rate);
							Char2.Format(_T("<Char>%s%s</Char>\n"),Char_Path,Char_Rate);

							Char_Path.Format(_T("<Char_Path>%s%c.tif</Char_Path>\n"),pDoc->m_PerfectImagePath,pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[2].charname);
							Char_Rate.Format(_T("<Char_Rate>%d</Char_Rate>\n"),pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[2].rate);
							Char3.Format(_T("<Char>%s%s</Char>\n"),Char_Path,Char_Rate);
							
							Recognized_Chars.Format(_T("%s%s%s\n"),Char1,Char2,Char3);
							
							Character.Format(_T("<Character>%s%s%s%s%s</Character>\n"),CharNo,Char_Position_X,Char_Position_Y,Char_Size,Recognized_Chars);
							//print char
							fprintf(pFile,"%s\n",Character);

						}
						//print close tag of Line_content
						fprintf(pFile,"%s\n",ctLine_Contents);

					//print close tag of Line
					fprintf(pFile,"%s\n",ctLine);

				}
			
			//print close tag of Image_Contents
			fprintf(pFile,"%s\n",ctImage_Contents);
		//print close tag of Image
		fprintf(pFile,"%s\n",ctImage);

    //close document
	fclose(pFile);
	
}

//void CDIAXmlDoc::CreateXmlDoc3(CDocImAnDoc* pDoc)
//{
//	ofstream pFile;
//	CString FileName;
//	//char* FileName;
//	//FileName = new char[100];
//
//	CString t1, t2, t3, t4, t5, t6;
//	t1 = "\t";
//	t2 = "\t\t";
//	t3 = "\t\t\t";
//	t4 = "\t\t\t\t";
//	t5 = "\t\t\t\t\t";
//	t6 = "\t\t\t\t\t\t";
//	
//	//format standards
//	
//	/*sprintf(otImage,"<Image>\n");
//	sprintf(ctImage,"</Image>\n");
//	sprintf(otLine,"\t\t<Line>\n");
//	sprintf(ctLine,"\t\t</Line>\n");
//
//	sprintf(otImage_Contents,"\t<Image_Contents>\n");
//	sprintf(ctImage_Contents,"\t</Image_Contents>\n");
//	sprintf(otLine_Contents,"\t\t\t<Line_Contents>\n");
//	sprintf(ctLine_Contents,"\t\t\t</Line_Contents>\n");*/
//
//	//sprintf(FileName,"%s.xml",pDoc->m_ImageName); 
//	//FileName = pDoc->m_ImageName  ".xml";
//	FileName.Format(_T("%s.xml"),pDoc->m_ImageName);
//	char*  name;
//	name = new char[50];
//	//name = FileName;
//	name = (char*)(LPCTSTR)FileName;
//	//name = FileName.GetBuffer(sizeof(name));
//	//strcpy(name, (char*)(LPCTSTR)FileName);
//	//pFile = _tfopen(FileName, _T("w"));
//	pFile.open(name, ios::out);
//	
//	//write in the file
//	//CString header;
//	//char* header;
//	//header = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
//	//fprintf(pFile,header);
//	pFile << "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
//	
//	
//	////image
//	////print open tag of Image
//	pFile << "<Image>\n";
////	fprintf(pFile,otImage);
//	//	//description
//		
//		//sprintf(Image_Width,"\t\t\t<Image_Width>%d</Image_Width>\n",pDoc->GetActiveImage()->GetWidth());
//		pFile << "\t\t<Image_Size>\n";
//		pFile <<" \t\t\t<Image_Height>" << pDoc->GetActiveImage()->GetHeight() << "</Image_Height>\n" << flush;
//		//sprintf(Image_Height,"\t\t\t<Image_Height>%d</Image_Height>\n",pDoc->GetActiveImage()->GetHeight());
//		pFile << "\t\t\t<Image_Width>"<<pDoc->GetActiveImage()->GetWidth()<<"</Image_Width>\n";
//		pFile << "\t\t</Image_Size>\n"<< flush;
//
//		//sprintf(Image_Size,"\t\t<Image_Size>\n%s%s\t\t</Image_Size>\n",Image_Width,Image_Height);
//		//CString name1;
//		
//		//CString name;
//		//name.Format(_T("%s"),pDoc->GetActiveImage()->GetName());
//	//	sprintf(Image_Name,"\t\t<Image_Name> %s </Image_Name>\n",(LPCTSTR)name);
//	//
//	//	sprintf(Image_Type,"\t\t<Image_Type> tif </Image_Type>\n");
//	//
//	//	sprintf(Image_Description,"\t<Image_Description>\n%s%s\t</Image_Description>\n",Image_Name,Image_Size);
//
//	//	//print Image Description
//	//	fprintf(pFile,Image_Description);
//	////	//contents
//	////		
//	////	//print open tag of Image_Contents
//	//	fprintf(pFile,otImage_Contents);
//	////		
//	////			//lines
//	//			for (int i = 0; i < pDoc->m_LineHolderIndex;i++)
//	//			{
//	////				//print open tag of Line
//	//				fprintf(pFile,otLine);
//	////				//description
//	//
//	//				sprintf(LineNo,"\t\t\t\t<LineNo>%d</LineNo>\n",i);
//	//
//	//				sprintf(Line_Position_Y,"\t\t\t\t<Line_Position_Y>%d</Line_Position_Y>\n",pDoc->m_pLineHolder[i].m_Position_Y);
//
//	//				sprintf(Line_Height,"\t\t\t\t\t<Line_Height>%d</Line_Height>\n",pDoc->m_pLineHolder[i].m_Height);
//	//				sprintf(Line_Width,"\t\t\t\t\t<Line_Width>%d</Line_Width>\n",pDoc->m_pLineHolder[i].m_Width);
//	//				sprintf(Line_Size,"\t\t\t\t<Line_Size>\n%s%s\t\t\t\t</Line_Size>\n",Line_Width,Line_Height);
//	//				
//	//				sprintf(Line_NoCharacters,"\t\t\t\t<Line_NoCharacters>%d</Line_NoCharacters>\n",pDoc->m_pLineHolder[i].m_CharacterHolderIndex);
//	//				sprintf(Line_Description,"\t\t\t<Line_Description>\n%s%s%s%s\t\t\t</Line_Description>\n",LineNo,Line_Position_Y,Line_Size,Line_NoCharacters);
//
//	//				//print Line_Description
//
//	//				fprintf(pFile,Line_Description);
//
//	//					//print open tag of Line_Contents
//	//					fprintf(pFile,otLine_Contents);
//	//					for (int j = 0; j < pDoc->m_pLineHolder[i].m_CharacterHolderIndex; j++)
//	//					{
//	//						//words??
//	//						//character
//	//					
//	//					sprintf(CharNo,"\t\t\t\t\t<CharNo>%d</CharNo>\n",pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharNum);
//	//					
//	//					sprintf(Char_Position_X,"\t\t\t\t\t<Char_Position_X>%d</Char_Position_X>\n",pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X);
//	//						
//	//					sprintf(Char_Position_Y,"\t\t\t\t\t<Char_Position_Y>%d</Char_Position_Y>\n",pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y);
//	//						
//	//					sprintf(Char_Height,"\t\t\t\t\t\t<Char_Height>%d</Char_Height>\n",pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Height);
//	//					
//	//					sprintf(Char_Width,"\t\t\t\t\t\t<Char_Width>%d</Char_Width>\n",pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Width);
//	//				
//	//					
//	//					sprintf(Char_Size,"\t\t\t\t\t<Char_Size>\n%s%s\t\t\t\t\t</Char_Size>\n",Char_Height,Char_Width);
//	//
//	//						//3 best characters
//	//					sprintf(Char_Path,"");
//	//					sprintf(Char_Rate,"");
//	//					char name = pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[0].charName;
//	//					sprintf(Char_Path,"\t\t\t\t\t\t<Char_Path>%s%c.tif</Char_Path>\n",(LPCTSTR)pDoc->m_PerfectImagePath,name);
//	//					sprintf(Char_Rate,"\t\t\t\t\t\t<Char_Rate>%d</Char_Rate>\n",pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[0].rate);
//	//					sprintf(Char1,"\t\t\t\t\t<Char>\n%s%s\t\t\t\t\t</Char>\n",Char_Path,Char_Rate);
//
//	//					
//	//					sprintf(Char_Path,"");
//	//					sprintf(Char_Rate,"");
//	//					name = pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[1].charName;
//	//					sprintf(Char_Path,"\t\t\t\t\t\t<Char_Path>%s%c.tif</Char_Path>\n",(LPCTSTR)pDoc->m_PerfectImagePath,name);
//	//					sprintf(Char_Rate,"\t\t\t\t\t\t<Char_Rate>%d</Char_Rate>\n",pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[1].rate);	
//	//					sprintf(Char2,"\t\t\t\t\t<Char>\n%s%s\t\t\t\t\t</Char>\n",Char_Path,Char_Rate);
//
//	//					sprintf(Char_Path,"");
//	//					sprintf(Char_Rate,"");
//	//					name = pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[2].charName;
//	//					sprintf(Char_Path,"\t\t\t\t\t\t<Char_Path>%s%c.tif</Char_Path>\n",(LPCTSTR)pDoc->m_PerfectImagePath,name);	
//	//					sprintf(Char_Rate,"\t\t\t\t\t\t<Char_Rate>%d</Char_Rate>\n",pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[2].rate);
//	//					sprintf(Char3,"\t\t\t\t\t<Char>\n%s%s\t\t\t\t\t</Char>\n",Char_Path,Char_Rate);
//
//	//					sprintf(Recognized_Chars,"\t\t\t\t<Recognized_Chars>\n%s%s%s\t\t\t\t</Recognized_Chars>\n",Char1,Char2,Char3);
//	//					sprintf(Character,"\t\t\t<Character>\n%s%s%s%s%s\t\t\t</Character>\n",CharNo,Char_Position_X,Char_Position_Y,Char_Size,Recognized_Chars);
//
//	//					//print char
//	//					fprintf(pFile,Character);
//
//	//					}
//	//				//print close tag of Line_content
//	//				fprintf(pFile,ctLine_Contents);
//
//	//				//print close tag of Line
//	//				fprintf(pFile,ctLine);
//
//	//			}
//
//	//		//print close tag of Image_Contents
//	//		fprintf(pFile,ctImage_Contents);
//	//	//print close tag of Image
//	//	fprintf(pFile,ctImage);
//
//    //close document
//	//fclose(pFile);
//	pFile.close();
//	
//}