// DlgAddImages.cpp : implementation file
//

#include "stdafx.h"
#include "DocImAn.h"
#include "DlgAddImages.h"
#include ".\dlgaddimages.h"


// CDlgAddImages dialog

IMPLEMENT_DYNCREATE(CDlgAddImages, CDHtmlDialog)

CDlgAddImages::CDlgAddImages(CWnd* pParent /*=NULL*/)
	: CDHtmlDialog(CDlgAddImages::IDD, CDlgAddImages::IDH, pParent)
{
}

CDlgAddImages::~CDlgAddImages()
{
}

void CDlgAddImages::DoDataExchange(CDataExchange* pDX)
{
	CDHtmlDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_Image1, m_Image1Box);
	DDX_Control(pDX, IDC_Image2, m_Image2Box);
	DDX_Control(pDX, IDC_ModImage2, m_GetImage2Button);
	DDX_Control(pDX, IDC_1_2, m_12Button);
	DDX_Control(pDX, IDC_Image3, m_newImageBox);
}

BOOL CDlgAddImages::OnInitDialog()
{
	CDHtmlDialog::OnInitDialog();
	
	indexImage1 = m_pDoc1->m_index - 1;
	DisplayImage(m_Image1Box,m_pDoc1->GetActiveImage());
	m_showImage2 = false;
	m_showNewImage = false;
	return TRUE;  // return TRUE  unless you set the focus to a control
}



BEGIN_MESSAGE_MAP(CDlgAddImages, CDHtmlDialog)
	//ON_BN_CLICKED(IDC_ModImage1, OnBnClickedModimage1)
	ON_BN_CLICKED(IDC_ModImage2, OnBnClickedModimage2)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_1_2, OnBnClicked12)
	ON_BN_CLICKED(IDC_2_1, OnBnClicked21)
	ON_BN_CLICKED(IDC_SubstractionButton, OnBnClickedSubstractionbutton)
	ON_BN_CLICKED(IDC_AdditionButton, OnBnClickedAdditionbutton)
	ON_BN_CLICKED(IDC_CompensationMean, OnBnClickedCompensationmean)
END_MESSAGE_MAP()

BEGIN_DHTML_EVENT_MAP(CDlgAddImages)
	DHTML_EVENT_ONCLICK(_T("ButtonOK"), OnButtonOK)
	DHTML_EVENT_ONCLICK(_T("ButtonCancel"), OnButtonCancel)
END_DHTML_EVENT_MAP()



// CDlgAddImages message handlers
void CDlgAddImages::SetDocument(CDocImAnDoc *pDoc)
{
	m_pDoc1 = pDoc;
	//Change Histograms and displays
	 //OnImageChange();
}

HRESULT CDlgAddImages::OnButtonOK(IHTMLElement* /*pElement*/)
{
	OnOK();
	return S_OK;  // return TRUE  unless you set the focus to a control
}

HRESULT CDlgAddImages::OnButtonCancel(IHTMLElement* /*pElement*/)
{
	OnCancel();
	return S_OK;  // return TRUE  unless you set the focus to a control
}



void CDlgAddImages::OnBnClickedModimage2()
{
	
	//CWinApp::OnFileNew();
	//m_pDoc2->OnNewDocument();
	
	m_pDoc1->CreateNewUndoImage();
	m_pDoc1->OnFileImportimageToAdd();
	indexImage2 = m_pDoc1->m_index - 1;
	//m_pDoc2->OnFileImportimageToAdd();
	m_showImage2 = true;
	//DisplayImage(m_Image2Box,m_pDoc1->GetUndoImage(indexImage2));

}

void CDlgAddImages::DisplayImage(CStatic &Wind,CImage* Image)

{
	//
	CDC * pDC = Wind.GetDC();
	CRect rect;
	Wind.GetClientRect(&rect);
	CRgn ClipRgn;
	ClipRgn.CreateRectRgn(rect.left, rect.top, rect.right, rect.bottom);
	pDC->SelectClipRgn(&ClipRgn);
	

	CBitmap bmp;
	CDC dc;
	
	dc.CreateCompatibleDC(NULL);
	Image->GetBitmap(&bmp);
	int m_ImageWidth = Image->GetWidth();
	int m_ImageHeight = Image->GetHeight();
	dc.SelectObject(&bmp);
	pDC->SetStretchBltMode(COLORONCOLOR);
	pDC->StretchBlt(0,0,rect.Width(), rect.Height(),&dc,0,0,m_ImageWidth,m_ImageHeight,SRCCOPY);
	
	
	
}

void CDlgAddImages::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	if (m_showImage2 == false) DisplayImage(m_Image1Box,m_pDoc1->GetUndoImage(indexImage1));
	if (m_showImage2 == true)
	{
		//DisplayImage(m_Image2Box, m_pDoc1->GetActiveImage());
		DisplayImage(m_Image2Box, m_pDoc1->GetUndoImage(indexImage2));
		DisplayImage(m_Image1Box, m_pDoc1->GetUndoImage(indexImage1));
	}
	if (m_showNewImage == true) 
	{
		DisplayImage(m_newImageBox,m_pDoc1->GetUndoImage(indexImage3));
		DisplayImage(m_Image2Box, m_pDoc1->GetUndoImage(indexImage2));
		DisplayImage(m_Image1Box, m_pDoc1->GetUndoImage(indexImage1));
	}
}

int CDlgAddImages::AddValuesCompensation(int value1, int value2)
{
	if (value1 == value2) return value1;
	if ((value1 == 255) && (value2 == 0)) return value1;
	if ((value1 == 0) && (value2 == 255)) return 255;
	if (((value1 != 0) && (value1 != 255)) && (value2 == 0)) return 0;
	//if ((valu
	if (((value1 != 0) && (value1 != 255)) && (value2 == 255)) return 255;
	if (((value1 != 0) && (value1 != 255)) && ((value2 != 0) && (value2 != 255))) return ((value1 + value2)/2);
	else return -3;
}
int CDlgAddImages::AddValuesCompensationMean(int value1, int value2)
{
	if (value1 == value2) return value1;
	if ((value1 == 255) && (value2 == 0)) return value1;
	if ((value1 == 0) && (value2 == 255)) return 0;
	if (((value1 != 0) && (value1 != 255)) && (value2 == 0)) 
		//return ((value1+value1+value2)/3);
		return (((value1*4)+(100))/5);
	
	
	if (((value1 != 0) && (value1 != 255)) && (value2 == 255)) return 255;
	if (((value1 != 0) && (value1 != 255)) && ((value2 != 0) && (value2 != 255))) return ((value1 + value2)/2);
	else return -3;
}
int CDlgAddImages::AddValuesDarken(int value1, int value2)
{
	if (value1 == value2) return value1;
	if (value2 < value1) return /*value1 - */value2;
	if (value2 > value1) return value1;
	else return -1;
}
int CDlgAddImages::AddValuesAddition(int value1, int value2)
{
	if (value1 == value2) return value1;
	if ((value2 + value1)< 255 )
	{
		return value1 + value2;
	}
	else return 255;
}
int CDlgAddImages::AddValuesMean(int value1, int value2)
{
	if (value1 == value2) return value1;
	else return ((value1 + value2)/2);
}
void CDlgAddImages::OnBnClicked12()
{
	m_pDoc1->CreateNewUndoImage();
	indexImage3 = m_pDoc1->m_index - 1;
	for (int i = 0; i < m_pDoc1->GetUndoImage(indexImage2)->GetWidth(); i++)
	{
		for (int j = 0; j < m_pDoc1->GetUndoImage(indexImage2)->GetHeight(); j++)
		{
			int v1, v2, newvalue;
			v1 = (int) GetRValue(m_pDoc1->GetUndoImage(indexImage1)->GetRGBColor(i,j));
			v2 = (int) GetRValue(m_pDoc1->GetUndoImage(indexImage2)->GetRGBColor(i,j));
			if (v1 != v2)
			{ 
				newvalue = AddValuesCompensation(v1, v2);
			}
			else 
				newvalue = v1;
			//set to red
			//if (newvalue == -1) m_pDoc1->GetUndoImage(m_pDoc1->m_index-1)->SetRGBColor(i,j,RGB(0,0,0));
			//set to blue
			//if (newvalue == -2) m_pDoc1->GetUndoImage(m_pDoc1->m_index-1)->SetRGBColor(i,j,RGB(255,255,255));
			//otherwise
			if (newvalue < 0) m_pDoc1->GetUndoImage(indexImage3)->SetRGBColor(i,j,RGB(128,128,128));
			m_pDoc1->GetUndoImage(indexImage3)->SetRGBColor(i,j,RGB(newvalue,newvalue,newvalue));
		}
	}
	m_showNewImage = true;
}


void CDlgAddImages::OnBnClicked21()
{
	m_pDoc1->CreateNewUndoImage();
	indexImage3 = m_pDoc1->m_index - 1;
	for (int i = 0; i < m_pDoc1->GetUndoImage(indexImage1)->GetWidth(); i++)
	{
		for (int j = 0; j < m_pDoc1->GetUndoImage(indexImage1)->GetHeight(); j++)
		{
			int v1, v2, newvalue;
			v1 = (int) GetRValue(m_pDoc1->GetUndoImage(indexImage1)->GetRGBColor(i,j));
			v2 = (int) GetRValue(m_pDoc1->GetUndoImage(indexImage2)->GetRGBColor(i,j));

			newvalue = AddValuesDarken(v2,v1);
			//set to red
			//if (newvalue == -1) m_pDoc1->GetUndoImage(m_pDoc1->m_index-1)->SetRGBColor(i,j,RGB(255,0,0));
			if (newvalue < 0)
				m_pDoc1->GetUndoImage(indexImage3)->SetRGBColor(i,j,RGB(128,128,128));
			m_pDoc1->GetUndoImage(indexImage3)->SetRGBColor(i,j,RGB(newvalue,newvalue, newvalue));
		}
	}
	m_showNewImage = true;
}

void CDlgAddImages::OnBnClickedSubstractionbutton()
{
	m_pDoc1->CreateNewUndoImage();
	indexImage3 = m_pDoc1->m_index - 1;
	for (int i = 0; i < m_pDoc1->GetUndoImage(indexImage1)->GetWidth(); i++)
	{
		for (int j = 0; j < m_pDoc1->GetUndoImage(indexImage1)->GetHeight(); j++)
		{
			int v1, v2, newvalue;
			v1 = (int) GetRValue(m_pDoc1->GetUndoImage(indexImage1)->GetRGBColor(i,j));
			v2 = (int) GetRValue(m_pDoc1->GetUndoImage(indexImage2)->GetRGBColor(i,j));

			newvalue = AddValuesAddition(v1, v2);
			//set to red
			if (newvalue == -1) m_pDoc1->GetUndoImage(indexImage3)->SetRGBColor(i,j,RGB(0,0,0));
			//set to blue
			if (newvalue == -2) m_pDoc1->GetUndoImage(indexImage3)->SetRGBColor(i,j,RGB(255,255,255));
			//otherwise
			m_pDoc1->GetUndoImage(indexImage3)->SetRGBColor(i,j,RGB(newvalue,newvalue, newvalue));
		}
	}
	m_showNewImage = true;
}

void CDlgAddImages::OnBnClickedAdditionbutton()
{
	m_pDoc1->CreateNewUndoImage();
	indexImage3 = m_pDoc1->m_index - 1;
	for (int i = 0; i < m_pDoc1->GetUndoImage(indexImage1)->GetWidth(); i++)
	{
		for (int j = 0; j < m_pDoc1->GetUndoImage(indexImage1)->GetHeight(); j++)
		{
			int v1, v2, newvalue;
			v1 = (int) GetRValue(m_pDoc1->GetUndoImage(indexImage1)->GetRGBColor(i,j));
			v2 = (int) GetRValue(m_pDoc1->GetUndoImage(indexImage2)->GetRGBColor(i,j));

			newvalue = AddValuesMean(v1, v2);
			//set to red
			if (newvalue == -1) m_pDoc1->GetUndoImage(indexImage3)->SetRGBColor(i,j,RGB(0,0,0));
			//set to blue
			if (newvalue == -2) m_pDoc1->GetUndoImage(indexImage3)->SetRGBColor(i,j,RGB(255,255,255));
			//otherwise
			m_pDoc1->GetUndoImage(indexImage3)->SetRGBColor(i,j,RGB(newvalue,newvalue, newvalue));
		}
	}
	m_showNewImage = true;
}

void CDlgAddImages::OnBnClickedCompensationmean()
{
	m_pDoc1->CreateNewUndoImage();
	indexImage3 = m_pDoc1->m_index - 1;
	for (int i = 0; i < m_pDoc1->GetUndoImage(indexImage2)->GetWidth(); i++)
	{
		for (int j = 0; j < m_pDoc1->GetUndoImage(indexImage2)->GetHeight(); j++)
		{
			int v1, v2, newvalue;
			v1 = (int) GetRValue(m_pDoc1->GetUndoImage(indexImage1)->GetRGBColor(i,j));
			v2 = (int) GetRValue(m_pDoc1->GetUndoImage(indexImage2)->GetRGBColor(i,j));
			if (v1 != v2)
			{ 
				newvalue = AddValuesCompensationMean(v1, v2);
			}
			else 
				newvalue = v1;
			
			if (newvalue < 0) m_pDoc1->GetUndoImage(indexImage3)->SetRGBColor(i,j,RGB(128,128,128));
			m_pDoc1->GetUndoImage(indexImage3)->SetRGBColor(i,j,RGB(newvalue,newvalue,newvalue));
		}
	}
	m_showNewImage = true;
}
