// DlgDIAHistograms.cpp : implementation file
//

#include "stdafx.h"
#include "DocImAn.h"
#include "DlgDIAHistograms.h"
#include ".\dlgdiahistograms.h"
#include "DIAHistograms.h"


// CDlgDIAHistograms dialog

IMPLEMENT_DYNAMIC(CDlgDIAHistograms, CDialog)
CDlgDIAHistograms::CDlgDIAHistograms(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgDIAHistograms::IDD, pParent)
{
}

CDlgDIAHistograms::~CDlgDIAHistograms()
{
}

void CDlgDIAHistograms::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_IN_HISTO_BOX_B, m_InHistoBox);
	DDX_Control(pDX, IDC_IN_HISTO_BOX_B2, m_OutHistoBox);
	DDX_Control(pDX, IDC_EDIT1, m_charLine);
	DDX_Control(pDX, IDC_EDIT3, m_charNumber);
	DDX_Control(pDX, IDC_IN_HISTO_BOX_B3, m_3HistoBox);
	DDX_Control(pDX, IDC_IN_HISTO_BOX_B4, m_Loc_Backgr_box);
	DDX_Control(pDX, IDC_IN_HISTO_BOX_B5, m_Loc_Foregr_Box);
	DDX_Control(pDX, IDC_CHECK1, m_check_globally);
	DDX_Control(pDX, IDC_CHECK_ALL_IMAGE, m_checkAll);
	DDX_Control(pDX, IDC_CHECK_SEG, m_checkSeg);
	DDX_Control(pDX, IDC_CHECK_LOC, m_check_Loc);
	DDX_Control(pDX, IDC_CHECKBC, m_checkBc);
	DDX_Control(pDX, IDC_CHECK2, m_checkAB);
	DDX_Control(pDX, IDC_CHECK5, m_checkAB1);
	DDX_Control(pDX, IDC_CHECK3, m_checkBC1);
	DDX_Control(pDX, IDC_CHECK4, m_checkBC2);
	DDX_Control(pDX, IDC_CHECK_LOCAL_CALC, m_check_loc_calc);
}


BEGIN_MESSAGE_MAP(CDlgDIAHistograms, CDialog)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnBnClickedButton2)
	ON_BN_CLICKED(IDC_EXPORT_ALL, OnBnClickedExportAll)
	ON_BN_CLICKED(IDC_ThreshHisto, OnBnClickedThreshhisto)
	ON_BN_CLICKED(IDC_EXPORT_ALL_CHARS, OnBnClickedExportAllChars)
END_MESSAGE_MAP()


// CDlgDIAHistograms message handlers

BOOL CDlgDIAHistograms::OnInitDialog()
{
	CDialog::OnInitDialog();
	m_bShowHisto = true;
	m_bShowCharHisto = false;
	m_charLine.SetWindowText(_T("0"));
	m_charNumber.SetWindowText(_T("0"));
	int max = 0;
	//initialise all histograms
	for (int i = 0; i < 255; i++)
	{
			m_ImageHisto.m_inHistogram[i] = 0;
			m_Seg_Backgr.m_inHistogram[i] = 0;
			m_Seg_Foregr.m_inHistogram[i] = 0;
			m_Loc_Backgr.m_inHistogram[i] = 0;
			m_Loc_Foregr.m_inHistogram[i] = 0;
			//m_charsHisto.m_inHistogram[i] = 0;
	}
	m_bIsImaHisto = false;
	m_bIsSegForegr = false;
	m_bIsSegBackgr= false;
	m_bIsLocForegr= false;
	m_bIsLocBackgr= false;
	m_check_globally.SetCheck(0);
	m_check_loc_calc.SetCheck(1);
	m_checkAll.SetCheck(0);
	m_checkSeg.SetCheck(0);
	m_check_Loc.SetCheck(1);
	m_checkBc.SetCheck(0);

	CreateAllHistograms();
//	for (int i = 0; i < 255; i++)
//	{
//		m_DifHisto.m_inHistogram[i] = m_Histo.m_inHistogram[i] - m_Histo.m_outHistogram[i];
//		if (m_DifHisto.m_inHistogram[i] > max) max = m_DifHisto.m_inHistogram[i];
//	}
//	m_DifHisto.m_maxvalueInHisto = max;
////	m_DifCharHisto.m_pdoc = m_charHisto.m_pdoc;
//	DisplayHistogram(m_InHistoBox,m_Histo.m_inHistogram, m_Histo.m_maxvalueInHisto);
//	DisplayHistogram(m_OutHistoBox,m_Histo.m_outHistogram, m_Histo.m_maxvalueOutHisto);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	
}
void CDlgDIAHistograms::CreateAllHistograms()
{
	CreateImagehisto();
	CreateSegmentedHistograms();
	CreateLocatedHistograms();


}
void CDlgDIAHistograms::CreateImagehisto()
{
	//compute m_ImageHisto
	CRect rect(0,0,GetDocument()->GetActiveImage()->GetWidth(),GetDocument()->GetActiveImage()->GetHeight());
	m_ImageHisto.ComputeHistogram(m_ImageHisto.m_inHistogram,&m_ImageHisto.m_maxvalueInHisto,rect,GetDocument()->GetActiveImage());
	unsigned long max = 0;
	for (int i = 0; i < 255; i++)
	{
		if (m_ImageHisto.m_inHistogram[i] > max) max = m_ImageHisto.m_inHistogram[i];
	}
	m_ImageHisto.m_maxvalueInHisto = max;
	m_bIsImaHisto = true;
}
void CDlgDIAHistograms::SetHisto(CDIAHistograms histo)
{
	for (int i = 0; i < 256; i++)
	{
		m_ImageHisto.m_inHistogram[i] = histo.m_inHistogram[i];
		m_ImageHisto.m_maxvalueInHisto = histo.m_maxvalueInHisto;
		//m_Histo.m_inHistogram[i] = histo.m_inHistogram[i];
		//m_Histo.m_maxvalueInHisto = histo.m_maxvalueInHisto;
		//m_Histo.m_outHistogram[i] = histo.m_outHistogram[i];
		//m_Histo.m_maxvalueOutHisto = histo.m_maxvalueOutHisto;
	}
}

CDocImAnDoc* CDlgDIAHistograms::GetDocument()
{
	return m_pDoc;
}
void CDlgDIAHistograms::SetDocument(CDocImAnDoc *pDoc)
{
	m_pDoc = pDoc;
	m_ImageHisto.m_pdoc = GetDocument();
	m_Seg_Backgr.m_pdoc = GetDocument();
	m_Seg_Foregr.m_pdoc = GetDocument();
	m_Loc_Backgr.m_pdoc = GetDocument();
	m_Loc_Foregr.m_pdoc = GetDocument();
}
void CDlgDIAHistograms::DisplayHistogram(CStatic &box,unsigned long * Histo, unsigned long maxval)
{
	CDC * pDC;
	CRect rect;

	pDC = box.GetDC();
	box.GetClientRect(&rect);

	CRgn ClipRgn;
	ClipRgn.CreateRectRgn(rect.left, rect.top, rect.right, rect.bottom);
	pDC->SelectClipRgn(&ClipRgn);

	int bpp = pDC->GetDeviceCaps(BITSPIXEL);
	int planes = pDC->GetDeviceCaps(PLANES);

	CBitmap bmp;
	
	if (0 == bmp.CreateBitmap(256, maxval,planes,bpp,NULL))
	{
		return;
	}
	else
	{
		CDC dc;
		dc.CreateCompatibleDC(NULL);
		dc.SelectObject(&bmp);
		CBrush brush;
		brush.CreateSolidBrush(RGB(158,164,246));
		dc.SelectObject(brush);
		dc.FillRect(CRect(0, 0, 258, maxval), &brush);

		CPen pen(PS_SOLID,0, RGB(78,2,204));
		dc.SelectObject(pen);
		
		
		for (int i = 0; i < 256; i++ )
		{
			dc.MoveTo(i,maxval);
			dc.LineTo(i, maxval-Histo[i]);
		}
		//pDC->BitBlt(0,0,rect.Width(), rect.Height(), &dc, 0, 0, SRCCOPY);

		pDC->SetStretchBltMode(COLORONCOLOR);
		
		pDC->StretchBlt(0,0,rect.Width(), rect.Height(),&dc,0,0,256,maxval,SRCCOPY);
		
	
	}
}
void CDlgDIAHistograms::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	if (!m_bShowCharHisto)
	{
		if (m_bIsImaHisto)
		{
			DisplayHistogram(m_InHistoBox,m_ImageHisto.m_inHistogram, m_ImageHisto.m_maxvalueInHisto);
		}
		if (m_bIsSegBackgr)
		{
			DisplayHistogram(m_OutHistoBox,m_Seg_Backgr.m_inHistogram, m_ImageHisto.m_maxvalueInHisto);
			//DisplayHistogram(m_OutHistoBox,m_Seg_Backgr.m_inHistogram, m_Seg_Backgr.m_maxvalueInHisto);
		}
		if (m_bIsSegForegr)
		{
			DisplayHistogram(m_3HistoBox,m_Seg_Foregr.m_inHistogram, m_ImageHisto.m_maxvalueInHisto);
			//DisplayHistogram(m_3HistoBox,m_Seg_Foregr.m_inHistogram, m_Seg_Foregr.m_maxvalueInHisto);
		}
		if (m_bIsLocForegr)
		{
			DisplayHistogram(m_Loc_Foregr_Box,m_Loc_Foregr.m_inHistogram, m_ImageHisto.m_maxvalueInHisto);
			//DisplayHistogram(m_Loc_Foregr_Box,m_Loc_Foregr.m_inHistogram, m_Loc_Foregr.m_maxvalueInHisto);
		}
		if (m_bIsLocBackgr)
		{
			DisplayHistogram(m_Loc_Backgr_box,m_Loc_Backgr.m_inHistogram, m_ImageHisto.m_maxvalueInHisto);
			//DisplayHistogram(m_Loc_Backgr_box,m_Loc_Backgr.m_inHistogram, m_Loc_Backgr.m_maxvalueInHisto);
		}
	}
	else
	{
	/*if (m_bShowHisto)
	{
		DisplayHistogram(m_InHistoBox,m_Histo.m_inHistogram, m_Histo.m_maxvalueInHisto);
		DisplayHistogram(m_OutHistoBox,m_Histo.m_outHistogram, m_Histo.m_maxvalueOutHisto);
		DisplayHistogram(m_3HistoBox,m_DifHisto.m_inHistogram, m_DifHisto.m_maxvalueInHisto);

	}*/
		if (m_bShowCharHisto)
		{
			DisplayHistogram(m_InHistoBox,m_ImageHisto.m_inHistogram, m_ImageHisto.m_maxvalueInHisto);
			DisplayHistogram(m_3HistoBox,GetDocument()->m_pLineHolder[m_charline].m_pCharacterHolder[m_charnum].m_charHisto.m_inHistogram, GetDocument()->m_pLineHolder[m_charline].m_pCharacterHolder[m_charnum].m_charHisto.m_maxvalueInHisto);
			DisplayHistogram(m_Loc_Foregr_Box,GetDocument()->m_pLineHolder[m_charline].m_pCharacterHolder[m_charnum].m_charForegrHisto.m_inHistogram, GetDocument()->m_pLineHolder[m_charline].m_pCharacterHolder[m_charnum].m_charHisto.m_maxvalueInHisto);
			DisplayHistogram(m_Loc_Backgr_box,GetDocument()->m_pLineHolder[m_charline].m_pCharacterHolder[m_charnum].m_charBackgrHisto.m_inHistogram, GetDocument()->m_pLineHolder[m_charline].m_pCharacterHolder[m_charnum].m_charHisto.m_maxvalueInHisto);
		}
	}
	// Do not call CDialog::OnPaint() for painting messages
}

void CDlgDIAHistograms::OnBnClickedButton1()
{
	FILE * pFile;
	static char BASED_CODE szFilter[]=
		"Comma Separated Values(*.csv)|All Files (*.*)|*.*||";

	char Values[] = "Values";
	
	char   c = '\n';
	long val;

	CString m_name;// = GetImage()->GetName();	
	m_name.Format(_T("%sBackGroundHisto.tif"),GetDocument()->GetActiveImage()->GetName());
	CFileDialog m_FileDialog(FALSE,NULL,m_name,OFN_FILEMUSTEXIST|OFN_HIDEREADONLY
		,NULL, 0);
	if (m_FileDialog.DoModal() == IDOK)
		{	
			CString m_pathName = m_FileDialog.GetPathName();
			pFile = _tfopen(m_pathName, _T("w"));
			fprintf(pFile,"%s%c",Values,c);
					
					for (int i = 0; i <= 255;i++)
					{
						val = m_ImageHisto.m_inHistogram[i];
						fprintf(pFile,"%i %c",val,c);
					}
			fclose(pFile);
		}
}

void CDlgDIAHistograms::OnOK()
{
	// TODO: Add your specialized code here and/or call the base class

	CDialog::OnOK();
}

void CDlgDIAHistograms::OnBnClickedButton2()
{
	//display character histos
	CString line, num;
	//int iline, inum;
	//m_DifHisto = new long[256];
	//m_DifCharHisto = new long[256];
	m_bShowHisto = false;
	m_charHisto.m_pdoc = m_ImageHisto.m_pdoc;
	m_charLine.GetWindowText(line);
	m_charNumber.GetWindowText(num);
	m_charline = _ttoi(line);
	m_charnum = _ttoi(num);
	m_DifCharHisto.m_pdoc = m_ImageHisto.m_pdoc;
	CreateCharacterHistograms(m_charline, m_charnum);
	DisplayHistogram(m_InHistoBox,m_ImageHisto.m_inHistogram, m_ImageHisto.m_maxvalueInHisto);
	DisplayHistogram(m_3HistoBox,GetDocument()->m_pLineHolder[m_charline].m_pCharacterHolder[m_charnum].m_charHisto.m_inHistogram, GetDocument()->m_pLineHolder[m_charline].m_pCharacterHolder[m_charnum].m_charHisto.m_maxvalueInHisto);
	DisplayHistogram(m_Loc_Foregr_Box,GetDocument()->m_pLineHolder[m_charline].m_pCharacterHolder[m_charnum].m_charForegrHisto.m_inHistogram, GetDocument()->m_pLineHolder[m_charline].m_pCharacterHolder[m_charnum].m_charHisto.m_maxvalueInHisto);
	DisplayHistogram(m_Loc_Backgr_box,GetDocument()->m_pLineHolder[m_charline].m_pCharacterHolder[m_charnum].m_charBackgrHisto.m_inHistogram, GetDocument()->m_pLineHolder[m_charline].m_pCharacterHolder[m_charnum].m_charHisto.m_maxvalueInHisto);
		
	m_bShowCharHisto = true;

}

void CDlgDIAHistograms::CreateCharacterHistograms(int line, int num)
{
	GetDocument()->m_pLineHolder[line].m_pCharacterHolder[num].CreateCharacterHisto(GetDocument());
	GetDocument()->m_pLineHolder[line].m_pCharacterHolder[num].CreateCharacterForegrBackgrHisto(GetDocument());

	//CRect rect(m_ImageHisto.m_pdoc->m_pLineHolder[line].m_pCharacterHolder[num].m_Position_X,
	//	m_ImageHisto.m_pdoc->m_pLineHolder[line].m_pCharacterHolder[num].m_Position_Y,
	//	m_ImageHisto.m_pdoc->m_pLineHolder[line].m_pCharacterHolder[num].m_Position_X + m_ImageHisto.m_pdoc->m_pLineHolder[line].m_pCharacterHolder[num].m_Width,
	//	m_ImageHisto.m_pdoc->m_pLineHolder[line].m_pCharacterHolder[num].m_Position_Y + m_ImageHisto.m_pdoc->m_pLineHolder[line].m_pCharacterHolder[num].m_Height);
	//
	//CRect rectLoc(m_ImageHisto.m_pdoc->m_pLineHolder[line].m_pCharacterHolder[num].m_CharLocation.left,
	//	m_ImageHisto.m_pdoc->m_pLineHolder[line].m_pCharacterHolder[num].m_CharLocation.top,
	//	m_ImageHisto.m_pdoc->m_pLineHolder[line].m_pCharacterHolder[num].m_CharLocation.right,
	//	m_ImageHisto.m_pdoc->m_pLineHolder[line].m_pCharacterHolder[num].m_CharLocation.bottom);

	////GetDocument()->m_pLineHolder[line].m_pCharacterHolder[num].m_pc
	//m_charHisto.ComputeHistogram(m_charHisto.m_inHistogram, &m_charHisto.m_maxvalueInHisto, rect ,m_ImageHisto.m_pdoc->GetActiveImage());
	//m_charHisto.ComputeHistogram(m_charHisto.m_outHistogram, &m_charHisto.m_maxvalueOutHisto, rectLoc ,m_ImageHisto.m_pdoc->GetActiveImage());
	//m_DifCharHisto.ComputeHistogram(m_charHisto.m_inHistogram, &m_charHisto.m_maxvalueInHisto, rect ,m_ImageHisto.m_pdoc->GetActiveImage());
	//

	//
	//for (int x = rect.left + rectLoc.left; x < rect.left + rectLoc.right; x++)
	//{
	//	for (int y = rect.top + rectLoc.top; y < rect.top + rectLoc.bottom; y++)
	//	{
	//		int val  =(int) m_charHisto.m_pdoc->GetActiveImage()->GetRed(x,y);
	//		m_DifCharHisto.m_inHistogram[val]--;
	//	}
	//}

	//unsigned int max = 0;
	//unsigned int max2 = 0;
	//unsigned int max3 = 0;
	//for (int i = 0; i < 255; i++)
	//{
	//	//m_DifCharHisto.m_inHistogram[i] = m_charHisto.m_inHistogram[i] - m_charHisto.m_outHistogram[i];
	//	//m_DifCharHisto.m_inHistogram[i] = m_DifCharHisto.m_inHistogram[i];
	//	if (m_DifCharHisto.m_inHistogram[i] > max) max = m_DifCharHisto.m_inHistogram[i];
	//	if (m_charHisto.m_inHistogram[i] > max2) max2 = m_charHisto.m_inHistogram[i];
	//	if (m_charHisto.m_outHistogram[i] > max3) max3 = m_charHisto.m_outHistogram[i];
	//}
	//m_DifCharHisto.m_maxvalueInHisto = max;
	//m_charHisto.m_maxvalueInHisto = max2;
	//m_charHisto.m_maxvalueOutHisto = max3;
}

void CDlgDIAHistograms::OnBnClickedExportAll()
{


	FILE * pFile;
	static char BASED_CODE szFilter[]=
		"Comma Separated Values(*.csv)|All Files (*.*)|*.*||";

	char Values[] = "Values";
	char Image[] = "Image";
	char SegBack[] = "Segm_Backgr";
	char SegFore[] = "Segm_Foregr";
	char LocBack[] = "Localised_Backgr";
	char LocFore[] = "Localised_Foregr";
	
	char   c = '\n';
	long image,segB,segF,locF,locB;

	CString m_name;// = GetImage()->GetName();	
	m_name.Format(_T("%sAllHisto.tif"),GetDocument()->GetActiveImage()->GetName());
	CFileDialog m_FileDialog(FALSE,NULL,m_name,OFN_FILEMUSTEXIST|OFN_HIDEREADONLY
		,NULL, 0);
	if (m_FileDialog.DoModal() == IDOK)
		{	
			CString m_pathName = m_FileDialog.GetPathName();
			pFile = _tfopen(m_pathName, _T("w"));
			fprintf(pFile,"%s,%s,%s,%s,%s%c",Image,SegBack,SegFore,LocBack,LocFore,c);
					
					for (int i = 0; i <= 255;i++)
					{
						image = m_ImageHisto.m_inHistogram[i];
						segB = m_Seg_Backgr.m_inHistogram[i];
						segF = m_Seg_Foregr.m_inHistogram[i];
						locB = m_Loc_Backgr.m_inHistogram[i];
						locF = m_Loc_Foregr.m_inHistogram[i];


						fprintf(pFile,"%i,%i,%i,%i,%i %c",image,segB,segF,locB,locF,c);
					}
			fclose(pFile);
		}
}
void CDlgDIAHistograms::SetLocalised(bool isLocalised)
{
	m_bIsLocalised = isLocalised;
}
bool CDlgDIAHistograms::IsLocalised()
{	
	return m_bIsLocalised;
}
void CDlgDIAHistograms::SetSegmented(bool isSegmented)
{
	m_bIsSegmented = isSegmented;
}
bool CDlgDIAHistograms::IsSegmented()
{
	return m_bIsSegmented;
}

void CDlgDIAHistograms::CreateSegmentedHistograms()
{
	

	if (IsSegmented())
	{
		//copy m_ImageHisto first
		for (int i = 0; i < 255; i++)
		{
			m_Seg_Backgr.m_inHistogram[i] = m_ImageHisto.m_inHistogram[i];
		}
		m_Seg_Backgr.m_maxvalueInHisto = m_ImageHisto.m_maxvalueInHisto;
		//loop throught segmented characters
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				for (int x = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X; x < GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X+ GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width-1; x++)
				{
					for (int y = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y; y < GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height-1; y++)
					{
						int val  =(int) GetDocument()->GetActiveImage()->GetRed(x,y);
						m_Seg_Foregr.m_inHistogram[val]++;
						m_Seg_Backgr.m_inHistogram[val]--;
					}
				}
			}
		}
		//find max val in out histo
		unsigned long maxFore = 0;
		unsigned long maxBack = 0;
		for (int i = 0; i < 255; i++)
		{
			if (m_Seg_Backgr.m_inHistogram[i] >= maxBack) 
			{
				if (m_Seg_Backgr.m_inHistogram[i] > 20000)
				{
					TRACE(_T("error in point %d"),i);
				}
				else
				{
					maxBack = m_Seg_Backgr.m_inHistogram[i];
				}
				
			}
			if (m_Seg_Foregr.m_inHistogram[i] >= maxFore)
			{
				maxFore = m_Seg_Foregr.m_inHistogram[i];
			}
		}
		m_Seg_Foregr.m_maxvalueInHisto = maxFore;
		m_Seg_Backgr.m_maxvalueInHisto = maxBack;
		m_bIsSegForegr = true;
		m_bIsSegBackgr = true;
	}

}
void CDlgDIAHistograms::CreateLocatedHistograms()
{
	if (IsLocalised())
	{
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				CRect rect(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X,
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y,
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width,
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height);
	
				CRect rectLoc(rect.left + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left,
				rect.top + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top,
				rect.left + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right,
				rect.top + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom);
			
			
				CDIAHistograms histo;//located box
				histo.ComputeHistogram(histo.m_inHistogram,&histo.m_maxvalueInHisto,rectLoc,GetDocument()->GetActiveImage());
				
				CDIAHistograms histo2;//segmented box
				histo2.ComputeHistogram(histo2.m_inHistogram,&histo2.m_maxvalueInHisto,rect,GetDocument()->GetActiveImage());

				//add them to the total Loc_F and Loc_B
				for (int i = 0; i < 255; i++)
				{
					m_Loc_Foregr.m_inHistogram[i]= m_Loc_Foregr.m_inHistogram[i] + histo.m_inHistogram[i];
					m_Loc_Backgr.m_inHistogram[i]= m_Loc_Backgr.m_inHistogram[i] + (histo2.m_inHistogram[i] - histo.m_inHistogram[i]);
					
				}
			}
		}
		unsigned long maxF = 0;
		unsigned long maxB = 0;
		for (int i = 0; i < 255; i++)
		{	
			if (m_Loc_Backgr.m_inHistogram[i] > maxB)
			{
				if (m_Loc_Backgr.m_inHistogram[i] > 20000)
					{
						TRACE(_T("error in point %d"),i);
					}
					else
					{
						maxB = m_Loc_Backgr.m_inHistogram[i];
					}
			}
			if (m_Loc_Foregr.m_inHistogram[i] > maxF) maxF = m_Loc_Foregr.m_inHistogram[i];
			//if (m_Loc_Backgr.m_inHistogram[i] > maxB) maxB = m_Loc_Backgr.m_inHistogram[i];
		}
		m_Loc_Backgr.m_maxvalueInHisto = maxB;
		m_Loc_Foregr.m_maxvalueInHisto = maxF;
		m_bIsLocForegr = true;
		m_bIsLocBackgr = true;
	}


}
void CDlgDIAHistograms::FindAB()
{
	for (int i = 0; i < 255; i++)
	{
		if (m_Loc_Backgr.m_inHistogram[i] == 0)
			{
				m_AB = i;
			}
	}
}
void CDlgDIAHistograms::FindAB1()
{
	//find the peak at the begining
	int max = 0;
	int pos = 0;
	//find lenght
	for(int i = 0; i < pos; i++)
	{
		if (m_Loc_Backgr.m_inHistogram[i] == 0)
		{
			pos = i;
		}
	}
	for(int i = 0; i < pos; i++)
	{
		if (m_Loc_Foregr.m_inHistogram[i] > max)
		{
			max = m_Loc_Foregr.m_inHistogram[i];
		}
	}
	m_AB = max;
}
void CDlgDIAHistograms::FindBC()
{
	for (int i = 0; i < 255; i++)
	{
		if (m_Loc_Foregr.m_inHistogram[i] > m_Loc_Backgr.m_inHistogram[i])
		{
			if (m_Loc_Foregr.m_inHistogram[i+1] < m_Loc_Backgr.m_inHistogram[i+1])
			{
				m_BC = i;//could be also i+1;
			}
		}
	}
}
void CDlgDIAHistograms::FindBC2()
{
	for (int i = 0; i < 255; i++)
	{
		if (m_Loc_Foregr.m_inHistogram[i] > m_Seg_Backgr.m_inHistogram[i])
			{
				if (m_Loc_Foregr.m_inHistogram[i+1] < m_Seg_Backgr.m_inHistogram[i+1])
				{
					m_BC = i;
				}
			}
	}
}

void CDlgDIAHistograms::FindBC3()
{
	for (int i = 0; i < 255; i++)
	{
		if (m_Seg_Backgr.m_inHistogram[i] < m_Loc_Backgr.m_inHistogram[i])
			{
				if (m_Seg_Backgr.m_inHistogram[i+1] > m_Loc_Backgr.m_inHistogram[i+1])
				{
					m_BC = i;
				}
			}
	}
}
void CDlgDIAHistograms::FindThresholdValues()
{
	//find the threshold values globally
	//AB = ((LocF(y) > Loc_B(y)) && (Loc_F(y+1) < (Loc_B(y+1)))

	for (int i = 0; i < 255; i++)
	{
		if (i+1 < 255)
		{
			if (m_Loc_Foregr.m_inHistogram[i] > m_Loc_Backgr.m_inHistogram[i])
			{
				if (m_Loc_Foregr.m_inHistogram[i+1] < m_Loc_Backgr.m_inHistogram[i+1])
				{
					m_AB = i;//could be also i+1;
				}
			}
			if (m_Loc_Foregr.m_inHistogram[i] > m_Seg_Backgr.m_inHistogram[i])
			{
				if (m_Loc_Foregr.m_inHistogram[i+1] < m_Seg_Backgr.m_inHistogram[i+1])
				{
					m_BC = i;
				}
			}
			if (m_Seg_Backgr.m_inHistogram[i] < m_Loc_Backgr.m_inHistogram[i])
			{
				if (m_Seg_Backgr.m_inHistogram[i+1] > m_Loc_Backgr.m_inHistogram[i+1])
				{
					m_BC2 = i;
				}
			}
		}
	}

	//for each character find the threshold values
	//for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	//{
	//	for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
	//	{

	//	}
	//}
}
void CDlgDIAHistograms::FindThresholdValues2()
{
	//find the threshold values globally
	//AB = ((LocF(y) > Loc_B(y)) && (Loc_F(y+1) < (Loc_B(y+1)))

	for (int i = 0; i < 255; i++)
	{
		if (i+1 < 255)
		{
			if (m_Loc_Backgr.m_inHistogram[i] == 0)
			{
				m_AB = i;
			}
			//if (m_Loc_Foregr.m_inHistogram[i] > m_Loc_Backgr.m_inHistogram[i])
			//{
			//	if (m_Loc_Foregr.m_inHistogram[i+1] < m_Loc_Backgr.m_inHistogram[i+1])
			//	{
			//		m_AB = i;//could be also i+1;
			//	}
			//}
			if (m_Loc_Foregr.m_inHistogram[i] > m_Seg_Backgr.m_inHistogram[i])
			{
				if (m_Loc_Foregr.m_inHistogram[i+1] < m_Seg_Backgr.m_inHistogram[i+1])
				{
					m_BC = i;
				}
			}
			if (m_Seg_Backgr.m_inHistogram[i] < m_Loc_Backgr.m_inHistogram[i])
			{
				if (m_Seg_Backgr.m_inHistogram[i+1] > m_Loc_Backgr.m_inHistogram[i+1])
				{
					m_BC2 = i;
				}
			}
		}
	}

	//for each character find the threshold values
	//for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	//{
	//	for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
	//	{

	//	}
	//}
}
void CDlgDIAHistograms::OnBnClickedThreshhisto()
{
	int global = m_check_globally.GetCheck();
	int bc = m_checkBc.GetCheck();
	int ab = m_checkAB.GetCheck();
	int all = m_checkAll.GetCheck();
	int seg = m_checkSeg.GetCheck();
	int loc = m_check_Loc.GetCheck();
	int bc2 = m_checkBC2.GetCheck();
	int bc1 = m_checkBC1.GetCheck();
	int ab1 = m_checkAB1.GetCheck();
	int loc_calc = m_check_loc_calc.GetCheck();

	RANGE_VALS * ranges;
	ranges = new RANGE_VALS[3];
	if (global) //we calculate it globally
	{	
		
		ranges[0].firstVal = 0;
		ranges[0].lastVal = m_AB;
		ranges[0].colour = 0;
		if (ab)
		{
			FindAB();
		}
		if (ab1)
		{
			FindAB1();
		}
		if (bc)
		{
		
			FindBC();
			/*ranges[1].firstVal = m_AB+1;
			ranges[1].lastVal = m_BC;
			ranges[1].colour = -1;

			ranges[2].firstVal = m_BC+1;
			ranges[2].lastVal = 255;
			ranges[2].colour = 255;*/
		}
		if (bc2)
		{
	
			FindBC2();
		
		}
		/*if (bc3)
		{
	
			FindBC3();
			
		}*/
		//if (bc)
		////else 
		//{
		//	FindThresholdValues();
		//	ranges[1].firstVal = m_AB+1;
		//	ranges[1].lastVal = m_BC2;
		//	ranges[1].colour = -1;

		//	ranges[2].firstVal = m_BC2+1;
		//	ranges[2].lastVal = 255;
		//	ranges[2].colour = 255;
		//}
		//if (firstbackgr)
		//{
		//	//FindThresholdValues2();
		//	ranges[1].firstVal = m_AB+1;
		//	ranges[1].lastVal = m_BC2;
		//	ranges[1].colour = -1;

		//	ranges[2].firstVal = m_BC2+1;
		//	ranges[2].lastVal = 255;
		//	ranges[2].colour = 255;
		//}
		ranges[1].firstVal = m_AB+1;
		ranges[1].lastVal = m_BC;
		ranges[1].colour = -1;

		ranges[2].firstVal = m_BC+1;
		ranges[2].lastVal = 255;
		ranges[2].colour = 255;

		if (all)
		{
			//apply to the whole image
			GetDocument()->CreateNewUndoImage(IT_GREYSCALE);

			ApplyAdvancedTreshold(GetDocument()->GetActiveImage(),ranges,3);
			GetDocument()->GetActiveImage()->SetDirty(); 
			//GetDocument()->UpdateAllViews(this,0L,NULL);
		}
		else if (seg)
			{
				GetDocument()->CreateNewUndoImage(IT_GREYSCALE);
				for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
				{
					for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
					{
						ApplyAdvancedTreshold(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,ranges,3);
					}
				}
			}
		else if (loc)
		{
			GetDocument()->CreateNewUndoImage(IT_GREYSCALE);
			for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
			{
				for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
				{
					ApplyAdvancedTreshold(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage,ranges,3);
				}
			}
		}
	}
	else if (loc_calc)
	{
		
		if (ab)
		{
			FindAB();
		}
		if (ab1)
		{
			FindAB1();
		}
		if (bc)
		{
			FindBC();
		}
		if (bc2)
		{
			FindBC2();
		}
		ranges[0].firstVal = 0;
		ranges[0].lastVal = 0;
		ranges[0].colour = 0;

		ranges[1].firstVal = 1;
		ranges[1].lastVal = m_BC;
		ranges[1].colour = -1;
	//	CalculateDiffHisto();
		
		if (loc)
		{
			ApplyAdvancedThresholdToCharacters(GetDocument()->GetActiveImage(),ranges, 3);
			GetDocument()->GetActiveImage()->SetDirty();
			ExportBackgroundPercentPerCharcsv();
		}
	}
}
bool IsInRange(int number, int start, int end)
{
	return ((number >= start) && (number <= end) && (start < end));
}

void CDlgDIAHistograms::ApplyAdvancedTreshold(CImage *image, RANGE_VALS* range, int size)
{
	for (int i = 0; i < image->GetWidth(); i++)
	{
		for (int j = 0; j < image->GetHeight(); j++)
		{
			int pixel = (int)GetRValue(image->GetRGBColor(i,j));
			for (int x = 0; x < size; x++)
			{
				if (IsInRange(pixel,range[x].firstVal,range[x].lastVal))
				{
					if (range[x].colour >= 0 )
					{
						image->SetRGBColor(i,j,RGB(range[x].colour,range[x].colour,range[x].colour));
					}
				}
			}


		}
	}
}

void CDlgDIAHistograms::OnBnClickedExportAllChars()
{
	
	FILE * pFile;
	static char BASED_CODE szFilter[]=
		"Comma Separated Values(*.csv)|All Files (*.*)|*.*||";

	char Values[] = "Values";
	char CharImage[] = "Char Image";
	char SegBack[] = "Segm_Backgr";
	char SegFore[] = "Segm_Foregr";
	char LocBack[] = "Localised_Backgr";
	char LocFore[] = "Localised_Foregr";
	
	char   c = '\n';
	long image,locF,locB;

	CString m_name;// = GetImage()->GetName();	
	m_name.Format(_T("%sAllCharsHisto.csv"),GetDocument()->GetActiveImage()->GetName());
	CFileDialog m_FileDialog(FALSE,NULL,m_name,OFN_FILEMUSTEXIST|OFN_HIDEREADONLY
		,NULL, 0);
	if (m_FileDialog.DoModal() == IDOK)
	{	
		CString m_pathName = m_FileDialog.GetPathName();
		pFile = _tfopen(m_pathName, _T("w"));
		
				
		for (int i = 0; i <= 255;i++)
		{
			for (int x = 0; x < GetDocument()->m_LineHolderIndex; x++)
			{

				for (int y = 0; y < GetDocument()->m_pLineHolder[x].m_CharacterHolderIndex; y++)
				{
					//fprintf(pFile,"%s%d-%d,%s%d-%d,%s%d-%d, ,%c",CharImage,x,y,LocBack,x,y,LocFore,x,y,c);
					
					GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].CreateCharacterHisto(GetDocument());
					GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].CreateCharacterForegrBackgrHisto(GetDocument());
					
					image = GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_charHisto.m_inHistogram[i];
					locB = GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_charBackgrHisto.m_inHistogram[i];
					locF = GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_charForegrHisto.m_inHistogram[i];
					fprintf(pFile,"%i,%i,%i, ,",image,locB,locF);
					
				}

			}
			fprintf(pFile,"\n");
		}
		
		fclose(pFile);
	}
}
void CDlgDIAHistograms::ExportBackgroundPercent()
{
	
	FILE * pFile;
	int histoBackPer[100];
	int histoForePer[100];
	int histoBackVal[256];
	int histoForeVal[256];
	for (int i = 0; i < 256; i++)
	{
		if (i < 100)
		{
			histoBackPer[i] = 0;
			histoForePer[i] = 0;
			histoBackVal[i] = 0;
			histoForeVal[i] = 0;
		}
		else
		{
			histoBackVal[i] = 0;
			histoForeVal[i] = 0;
		}
	}

	static char BASED_CODE szFilter[]=
		"Comma Separated Values(*.csv)|All Files (*.*)|*.*||";

	char   c = '\n';
	long Backgrpercent, ForegroundPercent;
	int BackgroundThreshold, ForegroundThreshold;

	CString m_name;// = GetImage()->GetName();	
	m_name.Format(_T("%sAllCharsBFPercents.dat"),GetDocument()->GetActiveImage()->GetName());
	CFileDialog m_FileDialog(FALSE,NULL,m_name,OFN_FILEMUSTEXIST|OFN_HIDEREADONLY
		,NULL, 0);
	if (m_FileDialog.DoModal() == IDOK)
	{	
		CString m_pathName = m_FileDialog.GetPathName();
		pFile = _tfopen(m_pathName, _T("w"));

			for (int x = 0; x < GetDocument()->m_LineHolderIndex; x++)
			{

				for (int y = 0; y < GetDocument()->m_pLineHolder[x].m_CharacterHolderIndex; y++)
				{
					
					histoBackPer[(int)GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_charBackgrPercent]++;
					histoForePer[(int)GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_charForegrPercent]++;
					histoBackVal[GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_charBackThreshVal]++;
					histoForeVal[GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_charForegrThresVal]++;
				//	fprintf(pFile,"%i,%i,%i,%i,\n",Backgrpercent,BackgroundThreshold,ForegroundPercent,ForegroundThreshold);	
				}
			}
			for (int i = 0; i < 256; i++)
			{
				if (i < 100)
				{
					fprintf(pFile,"%i\t%i\t%i\t%i\n",histoBackPer[i],histoBackVal[i],histoForePer[i],histoForeVal[i]);
				}else
				{
					fprintf(pFile," \t%i\t \t%i\n",histoBackVal[i],histoForeVal[i]);
				}	
			}
		fclose(pFile);
	}
}
void CDlgDIAHistograms::ExportBackgroundPercentPerCharcsv()
{
	
	FILE * pFile;
	/*int histoBackPer[100];
	int histoForePer[100];
	int histoBackVal[256];
	int histoForeVal[256];
	for (int i = 0; i < 256; i++)
	{
		if (i < 100)
		{
			histoBackPer[i] = 0;
			histoForePer[i] = 0;
			histoBackVal[i] = 0;
			histoForeVal[i] = 0;
		}
		else
		{
			histoBackVal[i] = 0;
			histoForeVal[i] = 0;
		}
	}*/

	static char BASED_CODE szFilter[]=
		"Comma Separated Values(*.csv)|All Files (*.*)|*.*||";

	char   c = '\n';
	long Backgrpercent;
	int CharType;
	int BackgroundThreshold;

	CString m_name;// = GetImage()->GetName();	
	m_name.Format(_T("%sAllCharsBFPercents.dat"),GetDocument()->GetActiveImage()->GetName());
	CFileDialog m_FileDialog(FALSE,NULL,m_name,OFN_FILEMUSTEXIST|OFN_HIDEREADONLY
		,NULL, 0);
	if (m_FileDialog.DoModal() == IDOK)
	{	
		CString m_pathName = m_FileDialog.GetPathName();
		pFile = _tfopen(m_pathName, _T("w"));

			for (int x = 0; x < GetDocument()->m_LineHolderIndex; x++)
			{

				for (int y = 0; y < GetDocument()->m_pLineHolder[x].m_CharacterHolderIndex; y++)
				{
					Backgrpercent = (int)GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_charBackgrPercent;
					CharType = GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_CharFinalType;
					fprintf(pFile,"%i,%i\n",Backgrpercent,CharType);	
				}
			}
			
		fclose(pFile);
	}
}
void CDlgDIAHistograms::ExportBackgroundPercentPerChartab()
{
	
	FILE * pFile;
	/*int histoBackPer[100];
	int histoForePer[100];
	int histoBackVal[256];
	int histoForeVal[256];
	for (int i = 0; i < 256; i++)
	{
		if (i < 100)
		{
			histoBackPer[i] = 0;
			histoForePer[i] = 0;
			histoBackVal[i] = 0;
			histoForeVal[i] = 0;
		}
		else
		{
			histoBackVal[i] = 0;
			histoForeVal[i] = 0;
		}
	}*/

	static char BASED_CODE szFilter[]=
		"Comma Separated Values(*.csv)|All Files (*.*)|*.*||";

	char   c = '\n';
	long Backgrpercent;
	int CharType;
	int BackgroundThreshold;

	CString m_name;// = GetImage()->GetName();	
	m_name.Format(_T("%sAllCharsBFPercents.dat"),GetDocument()->GetActiveImage()->GetName());
	CFileDialog m_FileDialog(FALSE,NULL,m_name,OFN_FILEMUSTEXIST|OFN_HIDEREADONLY
		,NULL, 0);
	if (m_FileDialog.DoModal() == IDOK)
	{	
		CString m_pathName = m_FileDialog.GetPathName();
		pFile = _tfopen(m_pathName, _T("w"));

			for (int x = 0; x < GetDocument()->m_LineHolderIndex; x++)
			{

				for (int y = 0; y < GetDocument()->m_pLineHolder[x].m_CharacterHolderIndex; y++)
				{
					Backgrpercent = (int)GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_charBackgrPercent;
					CharType = GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_CharFinalType;
					fprintf(pFile,"%i\t%i\n",Backgrpercent,CharType);	
				}
			}
			
		fclose(pFile);
	}
}
void CDlgDIAHistograms::CalculateDiffHisto(int linenum, int charnum)
{
	//given the histo of the char fore and backgr
	//calculate how much backgr is in the foregr histo
	int val = 0;
	GetDocument()->m_pLineHolder[linenum].m_pCharacterHolder[charnum].m_charBackThreshVal = 0;
	for (int i = 0; i < 256;i++)
	{
		if (GetDocument()->m_pLineHolder[linenum].m_pCharacterHolder[charnum].m_charBackgrHisto.m_inHistogram[i] > GetDocument()->m_pLineHolder[linenum].m_pCharacterHolder[charnum].m_charForegrHisto.m_inHistogram[i])
		{
			val += GetDocument()->m_pLineHolder[linenum].m_pCharacterHolder[charnum].m_charForegrHisto.m_inHistogram[i];
		}
		else
		{
			val += GetDocument()->m_pLineHolder[linenum].m_pCharacterHolder[charnum].m_charBackgrHisto.m_inHistogram[i];
		}
		/*if (GetDocument()->m_pLineHolder[linenum].m_pCharacterHolder[charnum].m_charForegrHisto.m_inHistogram[i] > GetDocument()->m_pLineHolder[linenum].m_pCharacterHolder[charnum].m_charBackgrHisto.m_inHistogram[i])
		{
			val += GetDocument()->m_pLineHolder[linenum].m_pCharacterHolder[charnum].m_charBackgrHisto.m_inHistogram[i];
		}
		else
		{
			val += GetDocument()->m_pLineHolder[linenum].m_pCharacterHolder[charnum].m_charForegrHisto.m_inHistogram[i];
		}*/
	}

	//calculate the percentage of the value
	//total number of pixels = width x height
	int total = GetDocument()->m_pLineHolder[linenum].m_pCharacterHolder[charnum].m_LocatedHeight * GetDocument()->m_pLineHolder[linenum].m_pCharacterHolder[charnum].m_LocatedWidth;
	//Given the total calculate what percent of the pixels does that mean
	float percent = ((float) val*100/(float) total);
	int accumulator = 0;
	int BackgroundPercentVal = -1;

	
	for (int x = 255; x >=0; x--)
		{
			accumulator += GetDocument()->m_pLineHolder[linenum].m_pCharacterHolder[charnum].m_charForegrHisto.m_inHistogram[x];
			if ((((accumulator * 100)/total)>= percent) && (BackgroundPercentVal == -1))
			{
				BackgroundPercentVal = x;
			}
			/*if ((m_histo[x] != 0) && (m_BackgroundBegining == -1))
			{
				m_BackgroundBegining = x;
			}*/
		}
		//return ForegroundPercent;
		GetDocument()->m_pLineHolder[linenum].m_pCharacterHolder[charnum].m_charBackgrPercent = percent;
		GetDocument()->m_pLineHolder[linenum].m_pCharacterHolder[charnum].m_charBackThreshVal = BackgroundPercentVal;
		accumulator = 0;
		percent = 40.0;
		int foreground40 = -1;
		for (int x = 0; x < 256; x ++)
		{
			accumulator += GetDocument()->m_pLineHolder[linenum].m_pCharacterHolder[charnum].m_charForegrHisto.m_inHistogram[x];
			if ((((accumulator * 100)/total)>= percent) && (foreground40 == -1))
			{
				foreground40 = x;
			}
		}
		GetDocument()->m_pLineHolder[linenum].m_pCharacterHolder[charnum].m_charForegrPercent = percent;
		GetDocument()->m_pLineHolder[linenum].m_pCharacterHolder[charnum].m_charForegrThresVal = foreground40;
	

}

void CDlgDIAHistograms::ApplyAdvancedThresholdToCharacters(CImage *image, RANGE_VALS* range, int size)
{
	if (m_bIsLocalised)
	{
		for (int i = 0 ; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				CreateCharacterHistograms(i, j);
				CalculateDiffHisto(i, j);
				
				for (int x = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left; x < GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right; x++)
				{
					for (int y = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top; y < GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom; y++)
					{ 
						int x_pos = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + x;
						int y_pos = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + y;
						int pixel = (int)GetRValue(image->GetRGBColor(x_pos,y_pos));
						
						if (IsInRange(pixel,0,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_charForegrThresVal))
						{
							if (range[0].colour >= 0 )
							{
								image->SetRGBColor(x_pos,y_pos,RGB(0,0,0));
							}
						}
						else if (IsInRange(pixel,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_charBackThreshVal,255))
						{
							image->SetRGBColor(x_pos,y_pos,RGB(255,255,255));
						}
						
					}
				}
		
			}
		}
	}

}