#pragma once
#include "afxwin.h"
#include "DIAHistograms.h"
#include "DocImAnDoc.h"


// CDlgDIAHistograms dialog

class CDlgDIAHistograms : public CDialog
{
	DECLARE_DYNAMIC(CDlgDIAHistograms)

public:
	CDlgDIAHistograms(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDlgDIAHistograms();

// Dialog Data
	enum { IDD = IDD_HISTOGRAMS };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	
	CDIAHistograms m_Histo;
	CDIAHistograms m_charHisto;
	CDIAHistograms m_DifHisto;
	CDIAHistograms m_DifCharHisto;
	//unsigned long * m_TotalForegroundHisto;
	CDocImAnDoc * m_pDoc;
	CDIAHistograms m_ImageHisto;
	CDIAHistograms m_Seg_Backgr;
	CDIAHistograms m_Seg_Foregr;
	CDIAHistograms m_Loc_Backgr;
	CDIAHistograms m_Loc_Foregr;
	CDIAHistograms * m_charsHisto;
	int m_AB,m_BC,m_BC2;
	bool m_bIsImaHisto;
	bool m_bIsSegForegr;
	bool m_bIsSegBackgr;
	bool m_bIsLocForegr;
	bool m_bIsLocBackgr;

	bool m_bIsSegmented;
	bool m_bIsLocalised;
	int m_charline, m_charnum;
	CStatic m_InHistoBox;
	CStatic m_OutHistoBox;
	virtual BOOL OnInitDialog();
	void SetDocument(CDocImAnDoc *pDoc);
	CDocImAnDoc* GetDocument();
	void SetHisto(CDIAHistograms histo);
	void DisplayHistogram(CStatic &box,unsigned long * Histo, unsigned long maxval);
	void CreateCharacterHistograms(int line, int num);
	void CreateSegmentedHistograms();
	void SetLocalised(bool isLocalised);
	bool IsLocalised();
	void SetSegmented(bool isSegmented);
	bool IsSegmented();
	void CreateAllHistograms();
	void CreateImagehisto();
	void CreateLocatedHistograms();
	void FindThresholdValues();
	void FindThresholdValues2();
	void FindAB();
	void FindAB1();
	void FindBC();
	void FindBC2();
	void FindBC3();
//void CalculateDiffHisto();
	void CalculateDiffHisto(int linenum, int charnum);
	void ExportBackgroundPercent();
	void ExportBackgroundPercentPerCharcsv();
	void ExportBackgroundPercentPerChartab();

	typedef struct RANGE_VALS
	{
		int		firstVal;
		int		lastVal;
		int		colour;
	};
	
	void ApplyAdvancedThresholdToCharacters(CImage *image, RANGE_VALS* range, int size);
	void ApplyAdvancedTreshold(CImage *image, RANGE_VALS* range, int size);
	
	afx_msg void OnPaint();
	afx_msg void OnBnClickedButton1();
protected:
	virtual void OnOK();
public:
	CEdit m_charLine;
	CEdit m_charNumber;
	afx_msg void OnBnClickedButton2();
	bool m_bShowCharHisto;
	bool m_bShowHisto;
	CStatic m_3HistoBox;
	afx_msg void OnBnClickedExportAll();
	CStatic m_Loc_Backgr_box;
	CStatic m_Loc_Foregr_Box;
	afx_msg void OnBnClickedThreshhisto();
	CButton m_check_globally;
	CButton m_checkAll;
	CButton m_checkSeg;
	CButton m_check_Loc;
	CButton m_checkBc;
	CButton m_checkAB;
	afx_msg void OnBnClickedExportAllChars();
	CButton m_checkAB1;
	CButton m_checkBC1;
	CButton m_checkBC2;
	CButton m_check_loc_calc;
};
