// DlgDIAPlot2D.cpp : implementation file
//

#include "stdafx.h"
#include "DocImAn.h"
#include "DlgDIAPlot2D.h"
//#include ".\dlgdiaplot2d.h"


// CDlgDIAPlot2D dialog

IMPLEMENT_DYNAMIC(CDlgDIAPlot2D, CDialog)
CDlgDIAPlot2D::CDlgDIAPlot2D(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgDIAPlot2D::IDD, pParent)
{
}

CDlgDIAPlot2D::~CDlgDIAPlot2D()
{
}

void CDlgDIAPlot2D::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PLOT, m_plotBox);
}


void CDlgDIAPlot2D::DisplayHistogram(CStatic &box,CDocImAnDoc::CTYPE ** Plot, int width, int height)
{
	CDC * pDC;
	CRect rect;

	pDC = box.GetDC();
	box.GetClientRect(&rect);

	CRgn ClipRgn;
	ClipRgn.CreateRectRgn(rect.left, rect.top, rect.right, rect.bottom);
	pDC->SelectClipRgn(&ClipRgn);

	int bpp = pDC->GetDeviceCaps(BITSPIXEL);
	int planes = pDC->GetDeviceCaps(PLANES);
	
	int red; 
	int green;
	int blue;
	CBitmap bmp;
	
	if (0 == bmp.CreateBitmap( width, height,planes,bpp,NULL))
	{
		return;
	}
	else
	{
		CDC dc;
		dc.CreateCompatibleDC(NULL);
		dc.SelectObject(&bmp);
		CBrush brush;
		brush.CreateSolidBrush(RGB(158,164,246));
		dc.SelectObject(brush);
		dc.FillRect(CRect(0, 0,width, height), &brush);
		//CPen pen(PS_SOLID,0, RGB(78,2,204));
		//dc.SelectObject(pen);
		
		
		for (int i = 0; i < width; i++ )
		{
			for (int j = 0; j < height; j++)
			{
				
				//int color;
				//color = 
				if (Plot[i][j].total > 0)
				{
					
					if (Plot[i][j].type[0])//if short then bluish
					{
						red = 0;//- ((Plot[i][j].type[0]*40)*Plot[i][j].total+1);
						green = 0;// - ((Plot[i][j].type[1]*40)*Plot[i][j].total+1);
						blue = 255 - ((Plot[i][j].type[0]*20)*Plot[i][j].total+1);
					}
					if (Plot[i][j].type[1]) //if TALL then green
					{
						red = 0;//- ((Plot[i][j].type[0]*40)*Plot[i][j].total+1);
						green = 255 - ((Plot[i][j].type[1]*20)*Plot[i][j].total+1);
						blue = 0;// - ((Plot[i][j].type[0]*40)*Plot[i][j].total+1);
					
					}
					if (Plot[i][j].type[2]) //if Low then orange
					{
						red = 255 - ((Plot[i][j].type[2]*20)*Plot[i][j].total+1);
						green = 128;// - ((Plot[i][j].type[1]*40)*Plot[i][j].total+1);
						blue = 0;// - ((Plot[i][j].type[0]*40)*Plot[i][j].total+1);
					
					}
					if (Plot[i][j].type[3]) //if Error then red	
					{
						red = 255 - ((Plot[i][j].type[3]*20)*Plot[i][j].total+1);
						green = 0;// - ((Plot[i][j].type[1]*40)*Plot[i][j].total+1);
						blue = 0;// - ((Plot[i][j].type[0]*40)*Plot[i][j].total+1);
					
					}
					if (Plot[i][j].type[4]) //if punctuation then purple
					{
						red = 128 ;//- ((Plot[i][j].type[0]*40)*Plot[i][j].total+1);
						green = 0;// - ((Plot[i][j].type[1]*40)*Plot[i][j].total+1);
						blue = 255 - ((Plot[i][j].type[4]*20)*Plot[i][j].total+1);
					
					}
					//CPen pen(PS_SOLID,Plot[i][j], RGB(78,2,204));
					//dc.SelectObject(pen);
					dc.MoveTo(i,j);
					//dc.Ellipse(i,j,i+Plot[i][j],j+Plot[i][j]);
					dc.SetPixel(i,j,RGB(red,green,blue));
				}
			}
		}
		//pDC->BitBlt(0,0,rect.Width(), rect.Height(), &dc, 0, 0, SRCCOPY);

		pDC->SetStretchBltMode(COLORONCOLOR);
		
		pDC->StretchBlt(0,0,rect.Width(), rect.Height(),&dc,0,0,width,height,SRCCOPY);
		
	
	}
}
CDocImAnDoc* CDlgDIAPlot2D::GetDocument()
{
	return m_pDoc;
}
void CDlgDIAPlot2D::SetDocument(CDocImAnDoc *pDoc)
{
	m_pDoc = pDoc;

}
BEGIN_MESSAGE_MAP(CDlgDIAPlot2D, CDialog)
	ON_WM_PAINT()
END_MESSAGE_MAP()


 //CDlgDIAPlot2D message handlers

BOOL CDlgDIAPlot2D::OnInitDialog()
{
	CDialog::OnInitDialog();

	//DisplayHistogram(m_plotBox,GetDocument()->m_2DCharPlot, 50, 50);
	DisplayHistogram(m_plotBox,GetDocument()->m_2DCharPlotType, 50, 50);
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgDIAPlot2D::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	//DisplayHistogram(m_plotBox,GetDocument()->m_2DCharPlot, 50, 50);
	DisplayHistogram(m_plotBox,GetDocument()->m_2DCharPlotType, 50, 50);

	// Do not call CDialog::OnPaint() for painting messages
}
