// DlgExportChar.cpp : implementation file
//

#include "stdafx.h"
#include "DocImAn.h"
#include "DlgExportChar.h"
#include ".\dlgexportchar.h"


// CDlgExportChar dialog

IMPLEMENT_DYNAMIC(CDlgExportChar, CDialog)
CDlgExportChar::CDlgExportChar(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgExportChar::IDD, pParent)
	, m_iExportAllIm(0)
	, m_iExportAllProj(0)
{
}

CDlgExportChar::~CDlgExportChar()
{
}

void CDlgExportChar::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BT_EXPORT_ALL_IM, m_BtExportAllIm);
	//DDX_Control(pDX, IDC_EXPORT_ALL_IM, m_BtExportAllIm);
	//	DDX_Control(pDX, IDC_EXPORT_ALL_PROJ, m_BtExportAllProj);
	DDX_Control(pDX, IDC_BT_EXPORT_ALL_PROJ, m_BtExportAllProj);
	DDX_Control(pDX, IDC_LINE_NUM, m_EdLineNum);
	DDX_Control(pDX, IDC_CHAR_NUM, m_EdCharNum);
}


BEGIN_MESSAGE_MAP(CDlgExportChar, CDialog)
	ON_BN_CLICKED(IDC_BT_EXPORT_ALL_IM, OnBnClickedBtExportAllIm)
	ON_BN_CLICKED(IDC_BT_EXPORT_ALL_PROJ, OnBnClickedBtExportAllProj)
	ON_BN_CLICKED(IDC_BT_EXPORT_CHAR, OnBnClickedBtExportChar)
	ON_BN_CLICKED(IDC_BUTTON2, OnBnClickedButton2)
END_MESSAGE_MAP()


// CDlgExportChar message handlers


void CDlgExportChar::SetDocument(CDocImAnDoc *pDoc)
{
	m_pDoc = pDoc;
}
CDocImAnDoc* CDlgExportChar::GetDocument()
{
	return m_pDoc;
}
CImage * CDlgExportChar::GetImage()
{
	if (m_pDoc != NULL)	return m_pDoc->GetActiveImage();
	else return NULL;
}
void CDlgExportChar::OnBnClickedBtExportAllIm()
{
	//Make sure that the Character Images are Stored
	if (GetDocument() != NULL)
	{
		if (GetDocument()->m_IsCharLocalized)
		{
			for (int i = 0; i < GetDocument()->m_LineHolderIndex -1; i++)
			{
				for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
				{
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ExportCharacter();
				}
			}
		}
	}
	
}

BOOL CDlgExportChar::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_EdLineNum.SetWindowText(_T(""));
	
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgExportChar::OnBnClickedBtExportAllProj()
{
	if (GetDocument() != NULL)
	{
		if (GetDocument()->m_IsCharLocalized)
		{
			for (int i = 0; i < GetDocument()->m_LineHolderIndex -1; i++)
			{
				for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
				{
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ExportCharacterProjectionV();
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ExportCharacterProjectionH();
				}
			}
		}
	}
	
}

void CDlgExportChar::OnBnClickedBtExportChar()
{

	if (GetDocument() != NULL)
	{
		if (GetDocument()->m_IsCharLocalized)
		{
			CString text;
			m_EdLineNum.GetWindowText(text);	
			int Line = _ttoi( text );
			m_EdCharNum.GetWindowText(text);
			int Num = _ttoi(text);
			
			if ((Line >=0)&& (Line < GetDocument()->m_LineHolderIndex))
			{
				if ((Num>= 0) && (Num < GetDocument()->m_pLineHolder[Line].m_CharacterHolderIndex))
				{
					GetDocument()->m_pLineHolder[Line].m_pCharacterHolder[Num].ExportCharacter();
					GetDocument()->m_pLineHolder[Line].m_pCharacterHolder[Num].ExportCharacterProjectionV();
					GetDocument()->m_pLineHolder[Line].m_pCharacterHolder[Num].ExportCharacterProjectionH();
				}
			}
		}
	}

}

void CDlgExportChar::OnBnClickedButton2()
{
	//Make sure that the Character Images are Stored
	if (GetDocument() != NULL)
	{
		if (GetDocument()->m_IsCharLocalized)
		{
			for (int i = 0; i < GetDocument()->m_LineHolderIndex -1; i++)
			{
				for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
				{
					//CString name;
					//name.Format(_T("%s%d-%d.tif"),GetDocument()->m_ExportedCharsPath,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLineNum,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharNum)
					char name = 'x';
					GetDocument()->Exportimage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage,name);
				}
			}
		}
	}
}
