// DlgPerfectChars2.cpp : implementation file
//

#include "stdafx.h"
#include "DocImAn.h"
#include "DlgPerfectChars2.h"
#include "DIACharacter.h"
#include ".\dlgperfectchars2.h"
#include "CharVector.h"


// CDlgPerfectChars2 dialog

IMPLEMENT_DYNAMIC(CDlgPerfectChars2, CDialog)
CDlgPerfectChars2::CDlgPerfectChars2(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgPerfectChars2::IDD, pParent)
{
	m_bShowEdgeImage = false;
}

CDlgPerfectChars2::~CDlgPerfectChars2()
{
}

void CDlgPerfectChars2::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CHAR_IMAGE_FRAME, m_CharImageFrame);
	DDX_Control(pDX, IDC_VERTICAL_PROJ_FRAME, m_VertProjFrame);
	DDX_Control(pDX, IDC_HORIZ_PROJ_FRAME, m_HorizProjFrame);
	DDX_Control(pDX, IDC_EDIT_CHAR_NAME, m_EdCharName);
	DDX_Control(pDX, IDC_EDIT_CHAR_SIZE_TYPE, m_EdCharSizeType);
	DDX_Control(pDX, IDC_EDIT_VERT_MAX, m_EdVertMax);
	DDX_Control(pDX, IDC_EDIT_HORZ_MAX, m_EdHorz_Max);
	DDX_Control(pDX, IDC_ED_DISPLAY, m_EdDisplay);
	DDX_Control(pDX, IDC_ED_HEIGHT, m_EdHeight);
	DDX_Control(pDX, IDC_ED_WIDTH, m_EdWidth);
	DDX_Control(pDX, IDC_ED_WEIGHT, m_EdWeight);
	DDX_Control(pDX, IDC_DIVS, m_DivsBox);
	DDX_Control(pDX, IDC_DIVS2, m_DivsBox2);
	DDX_Control(pDX, IDC_NO_RUNS_V, m_NoRunsVBox);
	DDX_Control(pDX, IDC_NO_RUNS_H, m_NoRunsHBox);
	DDX_Control(pDX, IDC_NO_RUNS_V2, m_NoRunsH2Box);
	DDX_Control(pDX, IDC_NO_RUNS_H2, m_RunsBoxH2);
	DDX_Control(pDX, IDC_EDIT_CAPITAL, m_EdCapital);
	DDX_Control(pDX, IDC_ED_VERTICAL, m_ed_Vertical);
	DDX_Control(pDX, IDC_ED_HORIZONTAL, m_ed_Horizontal);
	DDX_Control(pDX, IDC_ED_DIAGONAL_UP, m_ed_DiagonalUp);
	DDX_Control(pDX, IDC_ED_DIAGONAL_DOWN, m_ed_DiagonalDown);
}


BEGIN_MESSAGE_MAP(CDlgPerfectChars2, CDialog)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_STORE_CHAR, OnBnClickedStoreChar)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_SAVE_NAME, OnBnClickedSaveName)
	ON_BN_CLICKED(IDC_EXPORT_IMAGE, OnBnClickedExportImage)
	ON_BN_CLICKED(IDC_CHANGE_SIZE2, OnBnClickedChangeSize2)
	ON_BN_CLICKED(IDC_CHANGE_VMAX, OnBnClickedChangeVmax)
	ON_BN_CLICKED(IDC_CHANGE_HMAX, OnBnClickedChangeHmax)
	ON_BN_CLICKED(IDC_CHANGE_WEIGHT, OnBnClickedChangeWeight)
	ON_BN_CLICKED(IDC_STORE_CAPITAL, OnBnClickedStoreCapital)
	ON_BN_CLICKED(IDC_Contours_Profiles, OnBnClickedContoursProfiles)
	ON_BN_CLICKED(IDC_AddToClassifier, OnBnClickedAddtoclassifier)
	ON_BN_CLICKED(IDC_CHANGE_CAPITAL, OnBnClickedChangeCapital)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(IDC_BUTTON4, OnBnClickedButton4)
	ON_BN_CLICKED(IDC_AddGroundTruth, OnBnClickedAddgroundtruth)
END_MESSAGE_MAP()

void CDlgPerfectChars2::SetCharacter(CDIACharacter* pChar)
{
	m_pChar = pChar;
}
CDIACharacter* CDlgPerfectChars2::GetCharacter()
{
	return m_pChar;
}
CImage * CDlgPerfectChars2::GetCharImage()
{
	if (m_pChar != NULL)	return m_pChar->m_pLocatedCharImage;
	else return NULL;
}
void CDlgPerfectChars2::DisplayImage(CStatic &Wind,CImage* Image)

{
	//
	CDC * pDC = Wind.GetDC();
	CRect rect;
	Wind.GetClientRect(&rect);
	CRgn ClipRgn;
	ClipRgn.CreateRectRgn(rect.left, rect.top, rect.right, rect.bottom);
	pDC->SelectClipRgn(&ClipRgn);
	

	CBitmap bmp;
	CDC dc;
	
	dc.CreateCompatibleDC(NULL);
	Image->GetBitmap(&bmp);
	int m_HistoWidth = Image->GetWidth();
	int m_HistoHeight = Image->GetHeight();
	//Image->GetImageMap(0)->SetPTVisible(1,true);
	//Image->GetImageMap(0)->SetPTVisible(2,true);
	//Image->GetImageMap(0)->SetPTVisible(0,true);
	dc.SelectObject(&bmp);
	pDC->SetStretchBltMode(COLORONCOLOR);
	pDC->StretchBlt(0,0,rect.Width(), rect.Height(),&dc,0,0,m_HistoWidth,m_HistoHeight,SRCCOPY);
}
void CDlgPerfectChars2::DisplayRuns(CStatic &box, int*  NoRuns, int size, bool HoV)
{
	CDC * pDC;
	CRect rect;

	pDC = box.GetDC();
	box.GetClientRect(&rect);

	CRgn ClipRgn;
	ClipRgn.CreateRectRgn(rect.left, rect.top, rect.right, rect.bottom);
	pDC->SelectClipRgn(&ClipRgn);

	int bpp = pDC->GetDeviceCaps(BITSPIXEL);
	int planes = pDC->GetDeviceCaps(PLANES);

	CBitmap bmp;

	//if (0 == bmp.CreateBitmap(rect.right, maxval,planes,bpp,NULL))
	if (0 == bmp.CreateBitmap(rect.Width(), rect.Height(),planes,bpp,NULL))
	{
		return;
	}
	else
	{
		CDC dc;
		dc.CreateCompatibleDC(NULL);
		dc.SelectObject(&bmp);
		CBrush brush;
		brush.CreateSolidBrush(RGB(158,164,246));
		dc.SelectObject(brush);
		dc.FillRect(CRect(0, 0, rect.Width(), rect.Height()), &brush);

		CPen pen(PS_SOLID,0, RGB(78,2,204));
		dc.SelectObject(pen);
		CPen Redpen(PS_SOLID,0, RGB(255,0,0));
		
		if (HoV)
		{
			//display proj H
			dc.MoveTo(0,rect.top);

			//long * pArray = HistoD->GetPointArray();
			for (int i = 0; i < size ; i++)
			{
				int x, y;
				x = i*rect.Width()/size;
				y = NoRuns[i]* rect.Height()/5;
				dc.LineTo(x,rect.Height() - y);
			}
		}
		else
		{
			dc.MoveTo(0,0);

			//long * pArray = HistoD->GetPointArray();
			
			for (int i = 0; i < size; i++)
			{
				int x, y;
				y = i*rect.Height()/size;
				x = NoRuns[i] * rect.Width()/5;
				dc.LineTo(x,y);

			}

		}
	
	pDC->BitBlt(0,0,rect.Width(), rect.Height(),&dc,0,0,SRCCOPY);
	}
}
void CDlgPerfectChars2::DisplayRuns(CStatic &box, CDIACharacter::CROSSINGS* Runs,int index, int size, bool HoV)
{
	CDC * pDC;
	CRect rect;

	pDC = box.GetDC();
	box.GetClientRect(&rect);

	CRgn ClipRgn;
	ClipRgn.CreateRectRgn(rect.left, rect.top, rect.right, rect.bottom);
	pDC->SelectClipRgn(&ClipRgn);

	int bpp = pDC->GetDeviceCaps(BITSPIXEL);
	int planes = pDC->GetDeviceCaps(PLANES);

	CBitmap bmp;

	//if (0 == bmp.CreateBitmap(rect.right, maxval,planes,bpp,NULL))
	if (0 == bmp.CreateBitmap(rect.Width(), rect.Height(),planes,bpp,NULL))
	{
		return;
	}
	else
	{
		CDC dc;
		dc.CreateCompatibleDC(NULL);
		dc.SelectObject(&bmp);
		CBrush brush;
		brush.CreateSolidBrush(RGB(158,164,246));
		dc.SelectObject(brush);
		dc.FillRect(CRect(0, 0, rect.Width(), rect.Height()), &brush);

		CPen pen(PS_SOLID,0, RGB(78,2,204));
		dc.SelectObject(pen);
		CPen Redpen(PS_SOLID,0, RGB(255,0,0));
		
		if (HoV)
		{
			//display proj H
			dc.MoveTo(0,rect.Height());
			int current = 0;
			int x, y;
			x = 0;
			y = 0;
			for (int i = 0; i < index; i++)
			{
				
				x = current*rect.Width()/size;
				y = Runs[i].Crossings*rect.Height()/5;
				dc.LineTo(x,rect.Height() - y);
				current += Runs[i].NoCrossings;
				x = current*rect.Width()/size;
				dc.LineTo(x,rect.Height() - y);
			}
			dc.LineTo(x,rect.Height());

			
		}
		else
		{

			
			dc.MoveTo(0,0);

			//long * pArray = HistoD->GetPointArray();
			int current = 0;
			int x, y;
			x = 0;
			y = 0;
			for (int i = 0; i < index; i++)
			{
				
				y = current* rect.Height()/size;
				x = Runs[i].Crossings * rect.Width()/5;
				dc.LineTo(x,y);
				current += Runs[i].NoCrossings;
				y = current*rect.Height()/size;
				dc.LineTo(x,y);

			}
			dc.LineTo(0,y);

		}
	
	pDC->BitBlt(0,0,rect.Width(), rect.Height(),&dc,0,0,SRCCOPY);
	}
}
void CDlgPerfectChars2::DisplayBitmap(CStatic &box, float ** fvalues, CPoint size)
{
	//convert the float into int
	int ** values;
	values = new int*[size.x];
	for (int i = 0; i < size.x; i++)
	{
		values[i] = new int [size.y];
		for (int j = 0; j < size.y; j++)
		{
			values[i][j] = (int)(fvalues[i][j]* 255/5);
		}
	}

	DisplayBitmap(box,values,size);
}
void CDlgPerfectChars2::DisplayBitmap(CStatic &box,int** values, CPoint size)
{

	CDC * pDC = box.GetDC();
	CRect rect;
	box.GetClientRect(&rect);
	CRgn ClipRgn;
	ClipRgn.CreateRectRgn(rect.left, rect.top, rect.right, rect.bottom);
	pDC->SelectClipRgn(&ClipRgn);
	

	CBitmap bmp;
	CDC dc;
	int bpp = pDC->GetDeviceCaps(BITSPIXEL);
	int planes = pDC->GetDeviceCaps(PLANES);

	CPen pen;//(PS_SOLID,0, RGB(0,0,0));
	
	//LOGPEN penInfo;
	
	dc.CreateCompatibleDC(NULL);
	bmp.CreateBitmap(size.x,size.y,bpp,planes,NULL);
	
	//Image->GetBitmap(&bmp);
	/*int m_HistoWidth = Image->GetWidth();
	int m_HistoHeight = Image->GetHeight();*/
	dc.SelectObject(&bmp);
	
	//dc.SelectObject(pen);
	for (int i = 0; i < size.x; i++)
	{
		for (int j = 0; j < size.y; j++)
		{
			
			pen.CreatePen(PS_SOLID,0,RGB((int)values[i][j],(int)values[i][j],(int)values[i][j]));
			dc.SelectObject(pen);
			dc.MoveTo(i,j);
			dc.LineTo(i+1,j+1);
			pen.DeleteObject();
		}
	}

	//dc.MoveTo(0,HistoD->GetMaximum());


	pDC->SetStretchBltMode(COLORONCOLOR);
	pDC->StretchBlt(0,0,rect.Width(), rect.Height(),&dc,0,0,size.x,size.y,SRCCOPY);
	
}

//void CDlgPerfectChars2::DisplayProjection(CStatic &box,unsigned long * Histo, unsigned long maxval, bool VorH)
void CDlgPerfectChars2::DisplayProjection(CStatic &box,CDistribution <long> * HistoD, bool HoV)
{

	CDC * pDC;
	CRect rect;

	pDC = box.GetDC();
	box.GetClientRect(&rect);

	CRgn ClipRgn;
	ClipRgn.CreateRectRgn(rect.left, rect.top, rect.right, rect.bottom);
	pDC->SelectClipRgn(&ClipRgn);

	int bpp = pDC->GetDeviceCaps(BITSPIXEL);
	int planes = pDC->GetDeviceCaps(PLANES);

	CBitmap bmp;

	//if (0 == bmp.CreateBitmap(rect.right, maxval,planes,bpp,NULL))
	if (0 == bmp.CreateBitmap(rect.Width(), rect.Height(),planes,bpp,NULL))
	{
		return;
	}
	else
	{
		CDC dc;
		dc.CreateCompatibleDC(NULL);
		dc.SelectObject(&bmp);
		CBrush brush;
		brush.CreateSolidBrush(RGB(158,164,246));
		dc.SelectObject(brush);
		dc.FillRect(CRect(0, 0, rect.Width(), rect.Height()), &brush);

		CPen pen(PS_SOLID,0, RGB(78,2,204));
		dc.SelectObject(pen);
		CPen Redpen(PS_SOLID,0, RGB(255,0,0));
		
		if (HoV)
		{
			//display proj H
			dc.MoveTo(0,HistoD->GetMaximum());

			long * pArray = HistoD->GetPointArray();
			for (int i = 0; i <= HistoD->GetCount()-1; i++)
			{
				int x, y;
				x = i*rect.Width()/HistoD->GetCount();
				y = pArray[i]* rect.Height()/HistoD->GetMaximum();
				dc.LineTo(x,rect.Height() - y);
			}
			int val = 0;
			//display maxs H
			for (int j = 0; j < HistoD->GetCount(); j++)
				{
					dc.SelectObject(Redpen);
					if (m_pChar->m_CharHMax[val] == j)
					{
						int x = m_pChar->m_CharHMax[val]*rect.Width()/HistoD->GetCount();
						int y = rect.Height();
						dc.MoveTo(x,0);
						dc.LineTo(x,y);
						val++;
					}
				}
			
			
		}
		else 
		{
			dc.MoveTo(0,0);

			long * pArray = HistoD->GetPointArray();
			
			for (int i = 0; i < HistoD->GetCount(); i++)
			{
				int x, y;
				y = i*rect.Height()/HistoD->GetCount();
				x = pArray[i] * rect.Width()/HistoD->GetMaximum();
				dc.LineTo (x,y);
				/*x = i*rect.Width()/HistoD->GetCount();
				y = pArray[i]* rect.Height()/HistoD->GetMaximum();
				dc.LineTo(x,rect.Height() - y);*/
				/*if (i == MaxPosV[val])
				{
					dc.SelectObject(Redpen);
					int a = MaxPosV[i];
					int b = rect.Width();
					dc.MoveTo(0,b);
					dc.LineTo(a,b);
					val++;

				}*/
				/*dc.MoveTo(x,y);
				dc.SelectObject(pen);*/

				
			}
			int val = 0;
			//displays MaxV
			for (int j = 0; j < HistoD->GetCount(); j++)
				{
					dc.SelectObject(Redpen);
					if (m_pChar->m_CharVMax[val] == j)
					{

						int y = m_pChar->m_CharVMax[val]*rect.Height()/HistoD->GetCount();
						int x = rect.Width();
						dc.MoveTo(0,y);
						dc.LineTo(x,y);
						val++;
						
					}
				}
			

		}
		pDC->BitBlt(0,0,rect.Width(), rect.Height(),&dc,0,0,SRCCOPY);
	}
}

void CDlgPerfectChars2::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	//void CDlgPerfectChars2::DisplayProjection(CStatic &box,unsigned long * Histo, unsigned long maxval, bool VorH)

	DisplayImage(m_CharImageFrame,m_pChar->m_pLocatedCharImage);
	if (m_bFeaturesExtracted)
	{
		DisplayBitmap(m_DivsBox,m_pChar->m_CharDivisions.Value,m_pChar->m_CharDivisions.size);
		DisplayBitmap(m_DivsBox2,m_pChar->m_CharDivisions.Normalized,m_pChar->m_CharDivisions.size);
		//
		/*DisplayRuns(m_NoRunsHBox, m_pChar->m_HNoRuns, m_pChar->m_LocatedWidth, true);
		DisplayRuns(m_NoRunsVBox, m_pChar->m_VNoRuns, m_pChar->m_LocatedHeight,false);
		DisplayRuns(m_NoRunsH2Box, m_pChar->m_CharCrossingsV,m_pChar->m_CharCrossingsIndexV, m_pChar->m_LocatedHeight,false);
		DisplayRuns(m_RunsBoxH2, m_pChar->m_CharCrossingsH,m_pChar->m_CharCrossingsIndexH, m_pChar->m_LocatedWidth,true);
	*/
		
	}

	//CalcMax();
	if (Projscreated)
	{
		if (!Cont_Proj)
		{
			DisplayProjection(m_VertProjFrame,m_pChar->m_pCharacterDistributionV, false);
			DisplayProjection(m_HorizProjFrame,m_pChar->m_pCharacterDistributionH, true);
		}else
		{
			DisplayProjection(m_VertProjFrame,m_pChar->m_pContourDistributionR,false);
			DisplayProjection(m_HorizProjFrame,m_pChar->m_pContourDistributionL,true);

		}
	}
	if (m_bShowEdgeImage)
	{
		DisplayImage(m_CharImageFrame,m_pChar->m_EdgeImage);
	}
	
}

BOOL CDlgPerfectChars2::OnInitDialog()
{
	CDialog::OnInitDialog();
	Projscreated = false;
	Cont_Proj = false;
	m_bFeaturesExtracted = false;
	m_bShowEdgeImage = false;

	//CalcMax();
	CreateAndDisplayProjs();
//	CreateAndDisplayCrossings();
	DisplayFeatures();

	//GetDocument()->m_pCharVector = new CCharVector*;
	//load the file with the characters
	//GetDocument()->ImportCharVectorFromFile();


	//load the perfect chracters file into the vector
	/*GetDocument()->ImportCharVectorFromFile(GetDocument()->m_CharFilePath,GetDocument()->m_pCharVector,GetDocument()->m_CharVectorIndex);
	GetDocument()->ImportCharVectorFromFile(GetDocument()->m_CapitalsFilePath,GetDocument()->m_pCharCapitalVector,GetDocument()->m_CharCapitalVectorIndex);
	GetDocument()->ImportClassifier();*/
	

//	CString val = (char)(m_pChar->m_CharFinalType);
////	LPTSTR val =  _T("%i",m_pChar->m_CharFinalType);
//	m_EdCharSizeType.SetWindowText(val);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}
void CDlgPerfectChars2::SetWindowText(CEdit &window, LPCTSTR text)
{
	window.SetWindowText(text);
}
void CDlgPerfectChars2::SetSizeTypeWindowText()
{
	switch (m_pChar->m_CharFinalType)
	{
	case 0:
		{
			m_EdCharSizeType.SetWindowText(_T("SHORT"));
			break;
		}
	case 1:
		{
			m_EdCharSizeType.SetWindowText(_T("HIGH"));
			break;
		}
	case 2:
		{
			m_EdCharSizeType.SetWindowText(_T("LOW"));
			break;
		}
	case 3:
		{
			m_EdCharSizeType.SetWindowText(_T("ERROR"));
			break;
		}
	case 4:
		{
			m_EdCharSizeType.SetWindowText(_T("PUNCTUATION"));
			break;
		}
	}

}
void CDlgPerfectChars2::CreateAndDisplayProjs()
{

	//re-do m_pCharacterDistribution H & V
	//first delete old projectin and distribution
	Projscreated = true;
	delete m_pChar->m_pCharacterProjV;
	delete m_pChar->m_pCharacterDistributionH;
	
	//create them again to fit the localized character
	
	m_pChar->m_pCharacterProjV = new long [(m_pChar->m_LocatedWidth)];
	m_pChar->m_pCharImage->GetProjection(m_pChar->m_CharLocation.left,m_pChar->m_CharLocation.top,m_pChar->m_LocatedWidth,m_pChar->m_LocatedHeight,0, m_pChar->m_pCharacterProjV ,PRJ_GREY);
	m_pChar->m_pCharacterDistributionH = new CDistribution <long>;
	m_pChar->m_pCharacterDistributionH->Create(m_pChar->m_pCharacterProjV,m_pChar->m_LocatedWidth);

	delete m_pChar->m_pCharacterProjH;
	delete m_pChar->m_pCharacterDistributionV;

	//create them again to fit the localized character
	m_pChar->m_pCharacterProjH = new long [(m_pChar->m_CharLocation.bottom - m_pChar->m_CharLocation.top + 1)];
	m_pChar->m_pCharImage->GetProjection(m_pChar->m_CharLocation.left,m_pChar->m_CharLocation.top,m_pChar->m_LocatedWidth,m_pChar->m_LocatedHeight,m_pChar->m_pCharacterProjH, 0 ,PRJ_GREY);
	m_pChar->m_pCharacterDistributionV = new CDistribution <long>;
	m_pChar->m_pCharacterDistributionV->Create(m_pChar->m_pCharacterProjH,m_pChar->m_LocatedHeight);
	m_pChar->ExtractFeatures();
	//CalcMax();
	DisplayProjection(m_VertProjFrame,m_pChar->m_pCharacterDistributionV, false);
	DisplayProjection(m_HorizProjFrame,m_pChar->m_pCharacterDistributionH, true);
	//create contours too
	//m_pChar->GetContours();
}
void CDlgPerfectChars2::CalcMax()
{
	m_pChar->CalculateStrongMaxInProjs();
	////m_pChar->m_pCharacterDistributionV->AAPeakSmoothing(2.0,0.11,0.11);
	//MaxCountV = m_pChar->m_pCharacterDistributionV->GetMaximaCount();
 //   MaxPosV = m_pChar->m_pCharacterDistributionV->GetMaximaPositions();
	//FindStrongMaxs(MaxCountV, MaxPosV,m_pChar->m_pCharacterDistributionV,false);
	////m_pChar->m_pCharacterDistributionH->AAPeakSmoothing(2.0,0.11,0.11);
	//MaxCountH = m_pChar->m_pCharacterDistributionH->GetMaximaCount();
	//MaxPosH = m_pChar->m_pCharacterDistributionH->GetMaximaPositions();
	//FindStrongMaxs(MaxCountH,MaxPosH,m_pChar->m_pCharacterDistributionH,true);

}
//void CDlgPerfectChars2::FindStrongMaxs(int Count, int* Pos,CDistribution <long>* Distri,bool HoV)
//{
//	//for each max go to the sides and find the minima on the sides.
//	//if the minima are low enough, then it is a strong max
//	int * newPos;
//	int newPosCount = 0;
//	newPos = new int[Count];
//	int LeftMin, RightMin, LValue,RValue,MaxPos;
//	for (int i = 0; i < Count;i++)
//	{
//		RightMin = Distri->GetLocalMinimumPos(Pos[i],1,1);
//		LeftMin = Distri->GetLocalMinimumPos(Pos[i],0,1);
//		RValue = Distri->GetAt(RightMin);
//		MaxPos = Distri->GetAt(Pos[i]);
//		LValue = Distri->GetAt(LeftMin);
//		
//		if ((RightMin - LeftMin) > 5)
//		{
//			newPos[newPosCount] = Pos[i];
//			newPosCount++;
//		}
//	}
//	
//	if (HoV)
//	{
//		m_pChar->m_CharHMaxCount = newPosCount;
//		m_pChar->m_CharHMax = new int[newPosCount];
//		m_pChar->m_CharHMax = newPos;
//	}
//	else
//	{
//		m_pChar->m_CharVMaxCount = newPosCount;
//		m_pChar->m_CharVMax = new int[newPosCount];
//		m_pChar->m_CharVMax = newPos;
//	}
//
//}

void CDlgPerfectChars2::DisplayFeatures()
{
	CPoint size;
	if ((m_pChar->m_CharFinalType == 0) || (m_pChar->m_CharFinalType == 4))
	{
		size.x = 5;
		size.y = 5;
	}
	else
	{
		size.x = 5;
		size.y = 7;

	}
	m_pChar->ExtractFeatures(size.x,size.y);
	SetSizeTypeWindowText();
	CString text;
	text.Format(_T("%d"),m_pChar->m_LocatedWidth);
	SetWindowText(m_EdWidth,text);

	text.Format(_T("%d"),m_pChar->m_LocatedHeight);
	SetWindowText(m_EdHeight,text);

	SetMaxsWindowText(m_pChar->m_CharHMaxCount,true);
	SetMaxsWindowText(m_pChar->m_CharVMaxCount,false);
	//m_pChar->CalculateWeight();
	
	text.Format(_T("%d"),m_pChar->m_CharWeight);
	SetWindowText(m_EdWeight,text);

	//m_pChar->GetDivisions();
	DisplayBitmap(m_DivsBox,m_pChar->m_CharDivisions.Value,m_pChar->m_CharDivisions.size);
	DisplayBitmap(m_DivsBox2,m_pChar->m_CharDivisions.Normalized,m_pChar->m_CharDivisions.size);
	//m_pChar->GetRuns();
	/*DisplayRuns(m_NoRunsHBox, m_pChar->m_HNoRuns, m_pChar->m_LocatedWidth, true);
    DisplayRuns(m_NoRunsVBox, m_pChar->m_VNoRuns, m_pChar->m_LocatedHeight,false);
	DisplayRuns(m_NoRunsH2Box, m_pChar->m_CharCrossingsV, m_pChar->m_CharCrossingsIndexV, m_pChar->m_LocatedWidth,false);*/

	//angles
	int angle;
	angle = m_pChar->m_vertical/m_pChar->m_TotalEdge  * 100;
	text.Format(_T("%d"),angle);
	SetWindowText(m_ed_Vertical, text);

	angle =  m_pChar->m_horizontal/m_pChar->m_TotalEdge * 100;
	text.Format(_T("%d"),angle);
	SetWindowText(m_ed_Horizontal, text);

	angle =  m_pChar->m_diagonalUp/m_pChar->m_TotalEdge  * 100;
	text.Format(_T("%d"),angle);
	SetWindowText(m_ed_DiagonalUp, text);

	angle = m_pChar->m_diagonalDown/m_pChar->m_TotalEdge  * 100;
	text.Format(_T("%d"),angle);
	SetWindowText(m_ed_DiagonalDown, text);
	
	m_bFeaturesExtracted = true;
}
void CDlgPerfectChars2::SetMaxsWindowText(int val, bool HoV)
{
	switch (val)
		{
		case 0:
			{
				if (HoV) m_EdHorz_Max.SetWindowText(_T("0"));
				else m_EdVertMax.SetWindowText(_T("0"));
				
				break;
			}
		case 1:
			{
				if (HoV) m_EdHorz_Max.SetWindowText(_T("1"));
				else m_EdVertMax.SetWindowText(_T("1"));
				break;
			}
		case 2:
			{
				if (HoV) m_EdHorz_Max.SetWindowText(_T("2"));
				else m_EdVertMax.SetWindowText(_T("2"));
				break;
			}
		case 3:
			{
				if (HoV) m_EdHorz_Max.SetWindowText(_T("3"));
				else m_EdVertMax.SetWindowText(_T("3"));
				break;
			}
		case 4:
			{
				if (HoV) m_EdHorz_Max.SetWindowText(_T("4"));
				else m_EdVertMax.SetWindowText(_T("4"));
				break;
			}
		
		}
}

void CDlgPerfectChars2::CalculateCharWeight()
{
	//implement this on the character class and call it from here
	//divide the character on 3 sectins and calculate the part that contains more pixels
	//only performed on tall characters
	//short characters are all centre weight
	if (m_pChar->m_CharFinalType == 0) //short
	{
		m_pChar->m_CharWeight = 0;
	}
	else // if type is not short
	{	
        		
	}


}
void CDlgPerfectChars2::DisplayLine(CStatic &box,int index)
{
	
	CDC * pDC;
	CRect rect;

	pDC = box.GetDC();
	box.GetClientRect(&rect);

	CRgn ClipRgn;
	ClipRgn.CreateRectRgn(rect.left, rect.top, rect.right, rect.bottom);
	pDC->SelectClipRgn(&ClipRgn);

	int bpp = pDC->GetDeviceCaps(BITSPIXEL);
	int planes = pDC->GetDeviceCaps(PLANES);

	CBitmap bmp;
	CDC dc;
	//if (0 == bmp.CreateBitmap(rect.right, maxval,planes,bpp,NULL))
	if (0 == bmp.CreateBitmap(rect.Width(), rect.Height(),planes,bpp,NULL))
	{
		return;
	}
	else
	{
		
		dc.CreateCompatibleDC(NULL);
		dc.SelectObject(&bmp);
		
		CPen Redpen(PS_SOLID,0, RGB(255,0,0));
		dc.SelectObject(Redpen);
	/*	if (m_pChar->m_CharCrossings[index].HoV)
		{
			dc.MoveTo(0,m_pChar->m_CharCrossings[index].Position);
			dc.LineTo(m_pChar->m_LocatedWidth,m_pChar->m_CharCrossings[index].Position);
		}
		else
		{
			dc.MoveTo(m_pChar->m_CharCrossings[index].Position,0);
			dc.LineTo(m_pChar->m_CharCrossings[index].Position,m_pChar->m_LocatedHeight);
		}*/
	}
	pDC->BitBlt(0,0,rect.Width(), rect.Height(),&dc,0,0,SRCCOPY);
		
}
//void CDlgPerfectChars2::CreateAndDisplayCrossings()
//{
//	//we want a crossing between each peak and middle points
//	int i = 0; 
//	//H crossings and as there are no more than 4 peaks
//	while (i+1 < m_pChar->m_CharHMaxCount)
//	{
//		int pos = m_pChar->m_CharHMax[i + 1] - m_pChar->m_CharHMax[i];
//		m_pChar->CalculateCrossings(true,pos,true);
//		i++;
//	}
//	i = 0;
//	while (i+1 < m_pChar->m_CharVMaxCount)
//	{
//		int pos = m_pChar->m_CharVMax[i + 1] - m_pChar->m_CharVMax[i];
//		m_pChar->CalculateCrossings(false,pos,true);
//		i++;
//	}
//	//calculate also the crossings at the centre of the character
//	m_pChar->CalculateCrossings(true,m_pChar->m_CharCenter.y,true);
//	m_pChar->CalculateCrossings(false,m_pChar->m_CharCenter.x,true);
//
//
//	//now display the crossings
//	for (int j = 0; j < m_pChar->m_CharCrossingsIndex; j++)
//	{
//		//DisplayLine(m_CharImageFrame,i);
//	}
//	
//	
//	
//}
void CDlgPerfectChars2::SetDocument(CDocImAnDoc *pDoc)
{
	m_pDoc = pDoc;
}
CDocImAnDoc* CDlgPerfectChars2::GetDocument()
{
	return m_pDoc;
}
CImage* CDlgPerfectChars2::GetImage()
{
	return m_pImage;
}
void CDlgPerfectChars2::SetImage(CImage* image)
{
	m_pImage = image;
}

void CDlgPerfectChars2::OnBnClickedStoreChar()
{
	//we are going to store al the features inthe vector
	//and we are going to add it to the list
	//create Vector
	GetDocument()->ImportCharVectorFromFile(GetDocument()->m_CharFilePath,GetDocument()->m_pCharVector,GetDocument()->m_CharVectorIndex);
	
	CCharVector Vector;
	m_pChar->CreateLocatedCharImage(m_pChar->m_pCharImage,true);
	m_pChar->ExtractFeatures();
	Vector.CreateVectorFromCharacter(m_pChar);
	GetDocument()->AddNewCharacterVector(Vector,GetDocument()->m_pCharVector, GetDocument()->m_CharVectorIndex);

	//export the image
	CString imagename;
	
	imagename.Format(_T("%s%c.tif"),GetDocument()->m_PerfectImagePath,m_pChar->m_CharName);
	m_pChar->m_pLocatedCharImage->ExportTIFF((LPCTSTR) imagename);

	GetDocument()->ExportCharVectorToFile(GetDocument()->m_pCharVector,GetDocument()->m_CharVectorIndex,GetDocument()->m_CharFilePath,GetDocument()->m_PerfectImagePath);
	
}
void CDlgPerfectChars2::OnBnClickedStoreCapital()
{
	//we are going to store al the features inthe vector
	//and we are going to add it to the list
	//create Vector
	GetDocument()->ImportCharVectorFromFile(GetDocument()->m_CapitalsFilePath,GetDocument()->m_pCharCapitalVector,GetDocument()->m_CharCapitalVectorIndex);
	CCharVector Vector;
	m_pChar->CreateLocatedCharImage(m_pChar->m_pCharImage,true);
	m_pChar->ExtractFeatures();
	Vector.CreateVectorFromCharacter(m_pChar);
	GetDocument()->AddNewCharacterVector(Vector,GetDocument()->m_pCharCapitalVector, GetDocument()->m_CharCapitalVectorIndex);

	//export the image
	CString imagename;
	
	imagename.Format(_T("%s%c.tif"),GetDocument()->m_PerfectCapitalImagePath,m_pChar->m_CharName);
	m_pChar->m_pLocatedCharImage->ExportTIFF((LPCTSTR) imagename);
	
	GetDocument()->ExportCharVectorToFile(GetDocument()->m_pCharCapitalVector,GetDocument()->m_CharCapitalVectorIndex,GetDocument()->m_CapitalsFilePath,GetDocument()->m_PerfectCapitalImagePath);
	
}


void CDlgPerfectChars2::OnBnClickedOk()
{
	//save to file
	CDialog::OnOK();
	//save the vector of perfect chars to the file again
	/*GetDocument()->ExportCharVectorToFile(GetDocument()->m_pCharVector,GetDocument()->m_CharVectorIndex,GetDocument()->m_CharFilePath,GetDocument()->m_PerfectImagePath);
	GetDocument()->ExportCharVectorToFile(GetDocument()->m_pCharCapitalVector,GetDocument()->m_CharCapitalVectorIndex,GetDocument()->m_CapitalsFilePath,GetDocument()->m_PerfectCapitalImagePath);
	GetDocument()->ExportClassifier();*/
}

void CDlgPerfectChars2::OnBnClickedSaveName()
{
	CString Name;
	m_EdCharName.GetWindowText(Name);
	//int iNum = _ttoi(Num);
//	if (!Name.Compare(""))
	m_pChar->m_CharName = Name.GetAt(0);
}

void CDlgPerfectChars2::OnBnClickedExportImage()
{
	//CString imagename;
	//ExportCharacter(m_pCharVector[i]->m_CharImage,m_pCharVector[i]->GetCharName());
	//imagename.Format(_T("%c.tif"),m_pChar->m_CharName);
	//imagename.Format(_T("X:\\celia\\Memorial Images\\Original Characters\\Perfect Set\\PerfectChars\\%c.tif"),m_pChar->m_CharName);
	GetDocument()->Exportimage(m_pChar->m_pLocatedCharImage,m_pChar->m_CharName);
	//m_pChar->m_pLocatedCharImage->ExportTIFF((LPCTSTR) imagename);
}

void CDlgPerfectChars2::OnBnClickedChangeSize2()
{

	CString size;
	m_EdCharSizeType.GetWindowText(size);
	int iNum = _ttoi(size);
//	if (!Name.Compare(""))
	//m_pChar->m_CharFinalType = Name.GetAt(0);
	m_pChar->m_CharFinalType = iNum;
}

void CDlgPerfectChars2::OnBnClickedChangeVmax()
{
	CString Num;
	m_EdVertMax.GetWindowText(Num);
	int iNum = _ttoi(Num);
	m_pChar->m_CharVMaxCount = iNum;
}

void CDlgPerfectChars2::OnBnClickedChangeHmax()
{
	CString Num;
	m_EdHorz_Max.GetWindowText(Num);
	int iNum = _ttoi(Num);
	m_pChar->m_CharHMaxCount = iNum;
}

void CDlgPerfectChars2::OnBnClickedChangeWeight()
{
	CString Num;
	m_EdWeight.GetWindowText(Num);
	int iNum = _ttoi(Num);
	m_pChar->m_CharWeight = iNum;
}

void CDlgPerfectChars2::OnBnClickedChangeCapital()
{
	CString Num;
	m_EdCapital.GetWindowText(Num);
	int iNum = _ttoi(Num);
	if (iNum == 0) 
	{
		m_pChar->m_bIsCapital = false;
	}
	else if (iNum == 1)
	{
		m_pChar->m_bIsCapital = true;
	}
	else 
	{
		m_pChar->m_bIsCapital = true;
	}
}


void CDlgPerfectChars2::OnBnClickedContoursProfiles()
{
	if (Cont_Proj) Cont_Proj = false;
	else Cont_Proj = true;
}

void CDlgPerfectChars2::OnBnClickedAddtoclassifier()
{
	GetDocument()->ImportClassifier();
	GetDocument()->m_bNeedSaveClassifier = true;

	CCharVector Vector;
	CString vectorname;
	Vector.CreateVectorFromCharacter(m_pChar);
	vectorname = GetDocument()->AddCharacterToClassifier(Vector);
	CString finalpath;
	finalpath.Format(_T("%s-%c"),vectorname,'g');
	GetDocument()->Exportimage(m_pChar->m_pLocatedCharImage,finalpath,GetDocument()->m_ClassifiedCharsPath);
	
	
	

	CDIACharacter* char2;
	char2 = new CDIACharacter;
	char2 = m_pChar;
	CRect rect(0,0,char2->m_LocatedWidth,char2->m_LocatedHeight);
	char2->ApplyThreshold(char2->m_pLocatedCharImage,rect,250);
	char2->ExtractFeatures();
	
	CCharVector Vector2;
	Vector2.CreateVectorFromCharacter(char2);
	//Vector2.SetCharImage(char2->m_pLocatedCharImage);
	vectorname = GetDocument()->AddCharacterToClassifier(Vector2);
	finalpath.Format(_T("%s-%c"),vectorname,'b');
	GetDocument()->Exportimage(m_pChar->m_pLocatedCharImage,finalpath,GetDocument()->m_ClassifiedCharsPath);
	
	GetDocument()->ExportClassifier();
	GetDocument()->ImportClassifier();
	GetDocument()->m_bNeedSaveClassifier = true;
	//GetDocument()->ExportClassifier();
}



void CDlgPerfectChars2::OnBnClickedCancel()
{
	// TODO: Add your control notification handler code here

	OnCancel();
	onCancel = true;
}

void CDlgPerfectChars2::OnBnClickedButton4()
{
	m_bShowEdgeImage = !m_bShowEdgeImage;
	DisplayImage(m_CharImageFrame,m_pChar->m_EdgeImage);
}

void CDlgPerfectChars2::OnBnClickedAddgroundtruth()
{
	GetDocument()->m_pLineHolder[m_pChar->m_CharLineNum].m_pCharacterHolder[m_pChar->m_CharNum].m_Groundtruthchar = m_pChar->m_CharName;
	OnOK();
}
