#include "DIACharacter.h"
#include "DocImAnDoc.h"
#include "afxwin.h"
#pragma once


// CDlgPerfectChars2 dialog

class CDlgPerfectChars2 : public CDialog
{
	DECLARE_DYNAMIC(CDlgPerfectChars2)

public:
	CDlgPerfectChars2(CWnd* pParent = NULL);   // standard constructor
	virtual			~CDlgPerfectChars2();
	void			SetCharacter(CDIACharacter* pChar);
	void			SetImage(CImage* image);
	CImage*			GetImage();
	CDIACharacter*	GetCharacter();
	CImage*			GetCharImage();
	void			DisplayImage(CStatic &Wind,CImage* Image);
	void			DisplayProjection(CStatic &box,CDistribution <long> * HistoD, bool HoV);
	void			DisplayBitmap(CStatic &box,int** values, CPoint size);
	void			DisplayBitmap(CStatic &box,float** values, CPoint size);
	void			DisplayLine(CStatic &box,int index);
	void			DisplayRuns(CStatic &box, int*  NoRuns, int size, bool HoV);
	void			DisplayRuns(CStatic &box, CDIACharacter::CROSSINGS * Runs,int index, int size, bool HoV);
	void			CalcMax();
	void			CreateAndDisplayProjs();
	void			SetSizeTypeWindowText();
	void			SetWindowText(CEdit &window, LPCTSTR text);
//	void			FindStrongMaxs(int Count, int* Pos,CDistribution <long>* Distri, bool HoV);
	void			DisplayFeatures();
	void			SetMaxsWindowText(int val, bool HoV);
	void			CalculateCharWeight();
	//void			CreateAndDisplayCrossings();
	void			SetDocument(CDocImAnDoc *pDoc);
	CDocImAnDoc*	GetDocument();

// Dialog Data
	enum { IDD = IDD_PERFECT_CHARS };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	

	DECLARE_MESSAGE_MAP()
	
public:
	CDIACharacter* m_pChar;
	CImage* m_pImage;
	CStatic m_CharImageFrame;
	CStatic m_VertProjFrame;
	CStatic m_HorizProjFrame;
	CEdit m_EdCharName;
	CEdit m_EdCharSizeType;
	CEdit m_EdVertMax;
	CEdit m_EdHorz_Max;
	afx_msg void OnPaint();
	virtual BOOL OnInitDialog();
	int MaxCountV, MaxCountH;
	int* MaxPosV;
	int* MaxPosH;
	bool Projscreated;
	bool Cont_Proj;
	bool m_bFeaturesExtracted;
	bool onCancel;
	bool m_bShowEdgeImage;
	CEdit m_EdDisplay;
	CDocImAnDoc* m_pDoc;
	afx_msg void OnBnClickedStoreChar();
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedSaveName();
	CEdit m_EdHeight;
	CEdit m_EdWidth;
	CEdit m_EdWeight;
	afx_msg void OnBnClickedExportImage();
	afx_msg void OnBnClickedChangeSize2();
	afx_msg void OnBnClickedChangeVmax();
	afx_msg void OnBnClickedChangeHmax();
	afx_msg void OnBnClickedChangeWeight();
	afx_msg void OnBnClickedStoreCapital();
	afx_msg void OnBnClickedContoursProfiles();
	CStatic m_DivsBox;
	CStatic m_DivsBox2;
	CStatic m_NoRunsVBox;
	CStatic m_NoRunsHBox;
	CStatic m_NoRunsH2Box;
	CStatic m_RunsBoxH2;
	afx_msg void OnBnClickedAddtoclassifier();
	afx_msg void OnBnClickedChangeCapital();
	CEdit m_EdCapital;
	afx_msg void OnBnClickedCancel();
	CEdit m_ed_Vertical;
	CEdit m_ed_Horizontal;
	CEdit m_ed_DiagonalUp;
	CEdit m_ed_DiagonalDown;
	afx_msg void OnBnClickedButton4();
	afx_msg void OnBnClickedAddgroundtruth();
};
