// DlgTestingEnvironment.cpp : implementation file
//

#include "stdafx.h"
#include "DocImAn.h"
#include "DocImAnDoc.h"
#include "DIAHiColorImage.h"
#include "DIAXmlDoc.h"


#include "DlgTestingEnvironment.h"
#include ".\dlgtestingenvironment.h"


// CDlgTestingEnvironment dialog

IMPLEMENT_DYNAMIC(CDlgTestingEnvironment, CDialog)
CDlgTestingEnvironment::CDlgTestingEnvironment(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgTestingEnvironment::IDD, pParent)
{
}

CDlgTestingEnvironment::~CDlgTestingEnvironment()
{
}

void CDlgTestingEnvironment::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_INPUT_CHAR, m_InputChar);
	DDX_Control(pDX, IDC_RECOGNIZED_CHAR, m_RecognizedChar);
	DDX_Control(pDX, IDC_DetailsList, m_DetailsList);
	DDX_Control(pDX, IDC_PREVIOUS, m_Previous);
	DDX_Control(pDX, IDC_NEXT, m_Next);
}

void CDlgTestingEnvironment::SetDocument(CDocImAnDoc *pDoc)
{
	m_pDoc = pDoc;
}
CDocImAnDoc* CDlgTestingEnvironment::GetDocument()
{
	return m_pDoc;
}

BEGIN_MESSAGE_MAP(CDlgTestingEnvironment, CDialog)
	ON_BN_CLICKED(IDC_COMPUTE_WEIGHT_VECTOR, OnBnClickedComputeWeightVector)
	ON_BN_CLICKED(IDC_FIND_BEST_MATCH, OnBnClickedFindBestMatch)
	ON_BN_CLICKED(IDC_GET_CHAR, OnBnClickedGetChar)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_GET_IMAGE2, OnBnClickedGetImage2)
	ON_BN_CLICKED(IDC_NEXT, OnBnClickedNext)
	ON_BN_CLICKED(IDC_PREVIOUS, OnBnClickedPrevious)
	ON_BN_CLICKED(IDC_FIND_BEST_MATCH2, OnBnClickedFindBestMatch2)
	ON_BN_CLICKED(IDC_TestVector, OnBnClickedTestvector)
	ON_BN_CLICKED(IDC_RECOGNIZE_WHOLE_IMAGE2, OnBnClickedRecognizeWholeImage2)
	ON_BN_CLICKED(IDC_TestVector2, OnBnClickedTestvector2)
	ON_BN_CLICKED(IDC_RECOGNIZE_GRAVITY, OnBnClickedRecognizeGravity)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(IDC_RecognizeGrav, OnBnClickedRecognizegrav)
	ON_BN_CLICKED(IDC_RECOGNISE_TREE, OnBnClickedRecogniseTree)
	ON_BN_CLICKED(IDC_RECOGNISE_VECTOR, OnBnClickedRecogniseVector)
	ON_BN_CLICKED(IDC_RecognizeFlexible, OnBnClickedRecognizeflexible)
	ON_BN_CLICKED(IDC_Tubbs1, OnBnClickedTubbs1)
	ON_BN_CLICKED(IDC_Tubbs2, OnBnClickedTubbs2)
	ON_BN_CLICKED(IDC_WEIGHT, OnBnClickedWeight)
	ON_BN_CLICKED(IDC_Rec_Probability, OnBnClickedRecProbability)
	ON_BN_CLICKED(IDC_BUTTON4, OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON6, OnBnClickedButton6)
	ON_BN_CLICKED(IDC_BUTTON5, OnBnClickedButton5)
END_MESSAGE_MAP()


// CDlgTestingEnvironment message handlers

void CDlgTestingEnvironment::OnBnClickedComputeWeightVector()
{
	//Create the vector 
	//divide the 100 percent recognition by the features

	//m_pDoc->m_pWeightVector
	

}

BOOL CDlgTestingEnvironment::OnInitDialog()
{
	CDialog::OnInitDialog();
	GetDocument()->m_pCharVector = NULL;
	GetDocument()->m_pCharCapitalVector = NULL;
	GetDocument()->m_CharVectorIndex = 0;
	GetDocument()->m_CharCapitalVectorIndex = 0;
	// TODO:  Add extra initialization here
	//GetDocument()->ImportCharCapitalVectorFromFile();	
	//GetDocument()->ImportCharVectorFromFile();
	GetDocument()->ImportCharVectorFromFile(GetDocument()->m_CharFilePath,GetDocument()->m_pCharVector,GetDocument()->m_CharVectorIndex);
	GetDocument()->ImportCharVectorFromFile(GetDocument()->m_CapitalsFilePath,GetDocument()->m_pCharCapitalVector,GetDocument()->m_CharCapitalVectorIndex);
	GetDocument()->ImportClassifier();
	
	//GetDocument()->ImportCharVectorFromFile(GetDocument()->m_CapitalsFilePath,GetDocument()->m_pCharCapitalVector,GetDocument()->m_CharCapitalVectorIndex);
	m_bDisplayRecognizedImage = false;
	m_bOpenChar = false;
	m_ShowOnlyOneChar = true;
	m_CurrentDisplayChar = 0;
	m_CurrentDisplayLine = 0;
	m_CurrentBestChar = '0';
//	m_Next.
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgTestingEnvironment::OnOK()
{
	CDialog::OnOK();

	GetDocument()->DeleteVectorList();
	GetDocument()->ExportClassifier();
	
}
void CDlgTestingEnvironment::DisplayImage(CStatic &Wind,CImage* Image)

{
	//
	CDC * pDC = Wind.GetDC();
	CRect rect;
	Wind.GetClientRect(&rect);
	CRgn ClipRgn;
	ClipRgn.CreateRectRgn(rect.left, rect.top, rect.right, rect.bottom);
	pDC->SelectClipRgn(&ClipRgn);
	

	CBitmap bmp;
	CDC dc;
	
	dc.CreateCompatibleDC(NULL);
	Image->GetBitmap(&bmp);
	int m_HistoWidth = Image->GetWidth();
	int m_HistoHeight = Image->GetHeight();
	dc.SelectObject(&bmp);
	pDC->SetStretchBltMode(COLORONCOLOR);
	pDC->StretchBlt(0,0,rect.Width(), rect.Height(),&dc,0,0,m_HistoWidth,m_HistoHeight,SRCCOPY);
}
char CDlgTestingEnvironment::FindBestMatch(CImage* image)
{
	//for each Vector compare the character 
	//and print the best match
	//m_bestChar;
	//m_minCost;
	//char bestChar;
	m_CurrentBestChar = '0';
	if (image != NULL)
	{
		if (GetDocument()->m_CharVectorIndex > 0)
		{
			//open image
			CImage* loadedImage;
			CString ImagePath;
			ImagePath.Format(_T("%s%c.tif"),GetDocument()->m_PerfectImagePath,GetDocument()->m_pCharVector[0]->GetCharName());
			//TRACE(_T("%s\n"),ImagePath);
			
			loadedImage = ImgLoadFromFile((LPCTSTR)ImagePath, 
			RUNTIME_CLASS(CDIAHiColorImage),
			NULL,
			RUNTIME_CLASS(CDIAGreyScale),
			RUNTIME_CLASS(CDIABiLevelImage));
			//m_minCost = GetDocument()->m_pCharVector[0]->CompareImageInVectorWeight(loadedImage,image);
			//m_minCost = GetDocument()->m_pCharVector[0]->CompareImageInVectorGravity(image);
			m_minCost = (int)GetDocument()->m_pCharVector[0]->CompareImageInVectorCentred2(loadedImage,image);
			m_CurrentBestChar = GetDocument()->m_pCharVector[0]->GetCharName();
			for (int i = 0; i < GetDocument()->m_CharVectorIndex; i++)
			{
				ImagePath.Format(_T("%s%c.tif"),GetDocument()->m_PerfectImagePath,GetDocument()->m_pCharVector[i]->GetCharName());
				//TRACE(_T("%s\n"),ImagePath);
				
				loadedImage = ImgLoadFromFile((LPCTSTR)ImagePath, 
				RUNTIME_CLASS(CDIAHiColorImage),
				NULL,
				RUNTIME_CLASS(CDIAGreyScale),
				RUNTIME_CLASS(CDIABiLevelImage));
				//int* cost = new int[9];
				//if (GetDocument()->m_pCharVector[i]->m_CharIm
				int cost;
				//cost = GetDocument()->m_pCharVector[i]->CompareImageInVectorGravity(image);
				cost = (int)GetDocument()->m_pCharVector[i]->CompareImageInVectorCentred2(loadedImage,image);
				//cost = GetDocument()->m_pCharVector[0]->CompareImageInVectorWeight(loadedImage,image);
				CString text;
				text.Format(_T("Cost for character %c = %d"),GetDocument()->m_pCharVector[i]->GetCharName(),cost);
				//m_DetailsList.SetWindowText((LPCTSRT)text);
				m_DetailsList.AddString((LPCTSTR)text);
				if (cost <= m_minCost)
				{
					m_minCost = cost;
					m_CurrentBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
				}
			}
	
			
			//display results
		
			CString text;
			text.Format(_T("Min Cost= %d"),m_minCost);
			CString character;
			character.Format(_T("Best Matching Character = %c"),m_CurrentBestChar);
			m_DetailsList.AddString((LPCTSTR)text);
			m_DetailsList.AddString((LPCTSTR) character);
			//m_bDisplayRecognizedImage = true;
		}
	}
	return m_CurrentBestChar;
	
}
bool CDlgTestingEnvironment::FindBestMatch(CImage* image,int type,int MatchingType, int Lineno, int charno)
{
	//for each Vector compare the character 
	//and print the best match
	//m_bestChar;
	//m_minCost;
	//char bestChar;
	CString bar;
	bar.Format(_T("---------------"));
	m_CurrentBestChar = '0';
	CImage* loadedImage;
	
	CString ImagePath;
	bool capital = false;
	if (image != NULL)
	{
		if (GetDocument()->m_CharVectorIndex > 0)
		{
			//m_minCost = GetDocument()->m_pCharVector[0]->CompareImageInVectorCentred(image);
			m_minCost = 1000000;
			m_BestChars[0].rate = 1000000;
			m_BestChars[1].rate = 1000000;
			m_BestChars[2].rate = 1000000;
			for (int i = 0; i < GetDocument()->m_CharVectorIndex; i++)
			{
				//open image
				
				ImagePath.Format(_T("%s%c.tif"),GetDocument()->m_PerfectImagePath,GetDocument()->m_pCharVector[i]->GetCharName());
				//TRACE(_T("%s\n"),ImagePath);
				
				loadedImage = ImgLoadFromFile((LPCTSTR)ImagePath, 
				RUNTIME_CLASS(CDIAHiColorImage),
				NULL,
				RUNTIME_CLASS(CDIAGreyScale),
				RUNTIME_CLASS(CDIABiLevelImage));
				//int* cost = new int[9];
			//	if (GetDocument()->m_pCharVector[i]->GetCharType() == type)
			//	{
					int cost;
					if (MatchingType == 1)//then compareImages centred
					{
						cost = (int)GetDocument()->m_pCharVector[i]->CompareImageInVectorCentred2(loadedImage,image);
					}
					if (MatchingType == 2)//then compare images by centre of gravity
					{
						cost = GetDocument()->m_pCharVector[i]->CompareImageInVectorGravity(image);
					}
					if (MatchingType == 3)
					{
						cost = GetDocument()->CompareImagesFlexible(loadedImage,image);
						//cost = GetDocument()->m_pCharVector[i]->CompareImageInVectorFlexible(GetDocument()->m_pCharVector[i]->GetCharImage(),image);
					}
					if (MatchingType == 4)  //tubbs1 matching type
					{		

						cost = GetDocument()->m_pCharVector[i]->CompareImageInVectorTubbs1(loadedImage,image);
					}
					if (MatchingType == 5)  //tubbs1 matching type
					{		

						cost = GetDocument()->m_pCharVector[i]->CompareImageInVectorTubbs2(loadedImage,image);
					}
					if (MatchingType == 6)  //tubbs1 matching type
					{		
						TRACE(_T("%c"),GetDocument()->m_pCharVector[i]->GetCharName());
						cost = GetDocument()->m_pCharVector[i]->CompareImageInVectorWeight(loadedImage,image);
					}
				/*	if (MatchingType == 7)
					{
						cost = GetDocument()->m_pCharVector[i]->
					}*/

					//if (cost <= m_minCost)
					//{
					//	m_minCost = cost;
					//	m_CurrentBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
					//}
				/*	if (cost <= m_BestChars[2].rate)
					{
						if (cost <= m_BestChars[1].rate)
						{
							if(cost <= m_BestChars[0].rate)
							{
								m_BestChars[2] = m_BestChars[1];
								m_ThirdBestChar = m_SecondBestChar;
								m_BestChars[1] = m_BestChars[0];
								m_SecondBestChar = m_CurrentBestChar;
								m_BestChars[0] = cost;
								m_CurrentBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
								
							}
							else
							{
								m_bestChars[2] = m_bestChars[1];
								m_ThirdBestChar = m_SecondBestChar;
								m_bestChars[1] = cost;
								m_SecondBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
							}
						}
						else
						{
							m_bestChars[2] = cost;
							m_ThirdBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
						}
					}*/
			
					if(cost <= m_BestChars[0].rate)
					{

						m_BestChars[2].rate = m_BestChars[1].rate;
						m_BestChars[2].charname = m_BestChars[1].charname;
					
						m_BestChars[1].rate = m_BestChars[0].rate;
						m_BestChars[1].charname = m_BestChars[0].charname;
						
						m_BestChars[0].rate = cost;
						m_BestChars[0].charname = GetDocument()->m_pCharVector[i]->GetCharName();//m_BestPercentages[i].charname;
						m_BestChars[0].isCapital = false;
					
						
					}
					else
						if (cost <= m_BestChars[1].rate)
						{
							m_BestChars[2].rate = m_BestChars[1].rate;
							m_BestChars[2].charname = m_BestChars[1].charname;
						
							m_BestChars[1].rate = cost;
							m_BestChars[1].charname = GetDocument()->m_pCharVector[i]->GetCharName();
							m_BestChars[1].isCapital = false;
						}
					else if (cost <= m_BestChars[2].rate)
					{
						m_BestChars[2].rate = cost;
						m_BestChars[2].charname =GetDocument()->m_pCharVector[i]->GetCharName();
						m_BestChars[2].isCapital = false;
						
					}
			
				}	
			//}
		}
		//if (type == 1) 
		//{//then is a tall char and we need to compare it to the Capitals
			if (GetDocument()->m_CharCapitalVectorIndex > 0)
			{
				for (int i = 0; i < GetDocument()->m_CharCapitalVectorIndex; i++)
				{
					ImagePath.Format(_T("%s%c.tif"),GetDocument()->m_PerfectCapitalImagePath,GetDocument()->m_pCharCapitalVector[i]->GetCharName());
					//TRACE(_T("%s\n"),ImagePath);
					
					loadedImage = ImgLoadFromFile((LPCTSTR)ImagePath, 
					RUNTIME_CLASS(CDIAHiColorImage),
					NULL,
					RUNTIME_CLASS(CDIAGreyScale),
					RUNTIME_CLASS(CDIABiLevelImage));
					int cost;
					if (MatchingType == 1)//then compareImages centred
					{
						cost = (int)GetDocument()->m_pCharCapitalVector[i]->CompareImageInVectorCentred2(loadedImage,image);
					}
					if (MatchingType == 2)//then compare images by centre of gravity
					{
						cost = GetDocument()->m_pCharCapitalVector[i]->CompareImageInVectorGravity(image);
					}
					if (MatchingType == 3)
					{
						cost = GetDocument()->CompareImagesFlexible(loadedImage,image);
						//cost = GetDocument()->m_pCharCapitalVector[i]->CompareImageInVectorFlexible(GetDocument()->m_pCharCapitalVector[i]->GetCharImage(),image);
					}
					if (MatchingType == 4)  //tubbs1 matching type
					{		

						cost = GetDocument()->m_pCharVector[i]->CompareImageInVectorTubbs1(loadedImage,image);
					}
					if (MatchingType == 5)  //tubbs1 matching type
					{		

						cost = GetDocument()->m_pCharVector[i]->CompareImageInVectorTubbs2(loadedImage,image);
					}
					if (MatchingType == 6)  //tubbs1 matching type
					{		
						TRACE(_T("%c"),GetDocument()->m_pCharCapitalVector[i]->GetCharName());
						cost = GetDocument()->m_pCharVector[i]->CompareImageInVectorWeight(loadedImage,image);
					}
					CString text;
					//text.Format(_T("Cost for character %c = %d"),GetDocument()->m_pCharCapitalVector[i]->GetCharName(),cost);
					//m_DetailsList.SetWindowText((LPCTSRT)text);
				//	m_DetailsList.AddString((LPCTSTR)text);
					/*if (cost <= m_minCost)
					{
						m_minCost = cost;
                        capital = true;
						m_CurrentBestChar = GetDocument()->m_pCharCapitalVector[i]->GetCharName();
					}*/
					/*if (cost <= m_bestChars[2])
					{
						if (cost <= m_bestChars[1])
						{
							if(cost <= m_bestChars[0])
							{
								m_bestChars[2] = m_bestChars[1];
								m_ThirdBestChar = m_SecondBestChar;
								m_bestChars[1] = m_bestChars[0];
								m_SecondBestChar = m_CurrentBestChar;
								m_bestChars[0] = cost;
								m_CurrentBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
								capital = true;
							}
							else
							{
								m_bestChars[2] = m_bestChars[1];
								m_ThirdBestChar = m_SecondBestChar;
								m_bestChars[1] = cost;
								m_SecondBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
							}
						}
						else
						{
							m_bestChars[2] = cost;
							m_ThirdBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
						}
					}*/
					if(cost <= m_BestChars[0].rate)
					{

						m_BestChars[2].rate = m_BestChars[1].rate;
						m_BestChars[2].charname = m_BestChars[1].charname;
					
						m_BestChars[1].rate = m_BestChars[0].rate;
						m_BestChars[1].charname = m_BestChars[0].charname;
						
						m_BestChars[0].rate = cost;
						m_BestChars[0].charname = GetDocument()->m_pCharCapitalVector[i]->GetCharName();//m_BestPercentages[i].charname;
						m_BestChars[0].isCapital = true;
					
						
					}
					else
						if (cost <= m_BestChars[1].rate)
						{
							m_BestChars[2].rate = m_BestChars[1].rate;
							m_BestChars[2].charname = m_BestChars[1].charname;
						
							m_BestChars[1].rate = cost;
							m_BestChars[1].charname = GetDocument()->m_pCharCapitalVector[i]->GetCharName();
							m_BestChars[1].isCapital = true;
						}
					else 
						if (cost < m_BestChars[2].rate)
						{
							m_BestChars[2].rate = cost;
							m_BestChars[2].charname =GetDocument()->m_pCharCapitalVector[i]->GetCharName();
							m_BestChars[2].isCapital = true;
							
						}
					
				}
			}
		//}
		//text.Format(_T("Cost for character %c = %d"),GetDocument()->m_pCharCapitalVector[i]->GetCharName(),cost);
					//m_DetailsList.SetWindowText((LPCTSRT)text);
				//	m_DetailsList.AddString((LPCTSTR)text);
			////display results
		
			//CString text;
			////text.Format(_T("Min Cost= %d"),m_minCost);
			//text.Format(_T("Min Cost= %d"),m_BestChars[0].rate);
			///*CString character;
			//character.Format(_T("Best Matching Character = %c"),m_CurrentBestChar);
			//m_DetailsList.AddString((LPCTSTR)text);
			//m_DetailsList.AddString((LPCTSTR) character);*/
			//
			//CString character0,character1,character2;
			//character0.Format(_T("Best 0 = %c,cost: %d"),m_CurrentBestChar,m_bestChars[0]);
			//character1.Format(_T("Best 1 = %c,cost: %d"),m_SecondBestChar,m_bestChars[1]);
			//character2.Format(_T("Best 2 = %c,cost: %d"),m_ThirdBestChar,m_bestChars[2]);
			////m_DetailsList.AddString((LPCTSTR)text);
			//m_DetailsList.AddString((LPCTSTR) character0);
			//m_DetailsList.AddString((LPCTSTR) character1);
			//m_DetailsList.AddString((LPCTSTR) character2);
			//m_DetailsList.AddString((LPCTSTR) bar);

	//display results
		
	CString text;
	//text.Format(_T("Min Cost= %d"),m_minCost);
	text.Format(_T("Min Cost= %d"),m_BestChars[0].rate);
	
	CalculateRecognitionRate(Lineno,charno);
	CString character0,character1,character2;
	character0.Format(_T("Best1 = %c,cost: %d,C=%d"),m_BestChars[0].charname,m_BestChars[0].rate,m_BestChars[0].isCapital);
	character1.Format(_T("Best2 = %c,cost: %d,C=%d"),m_BestChars[1].charname,m_BestChars[1].rate,m_BestChars[1].isCapital);
	character2.Format(_T("Best3 = %c,cost: %d,C=%d"),m_BestChars[2].charname,m_BestChars[2].rate,m_BestChars[2].isCapital);
	
	m_DetailsList.AddString((LPCTSTR) character0);
	m_DetailsList.AddString((LPCTSTR) character1);
	m_DetailsList.AddString((LPCTSTR) character2);
	m_DetailsList.AddString((LPCTSTR) bar);
	}
	m_CurrentBestChar = m_BestChars[0].charname;
	capital = m_BestChars[0].isCapital;
	TRACE(_T("%c\n"),m_CurrentBestChar);
	return capital;
	
}


int CDlgTestingEnvironment::FindCost(CImage* image,char charName,int MatchingType)
{
	//for each Vector compare the character 
	//and print the best match
	//m_bestChar;
	//m_minCost;
	//char bestChar;
	CString bar;
	bar.Format(_T("---------------"));
	m_CurrentBestChar = '0';
	CImage* loadedImage;
	
	CString ImagePath;
	bool capital = false;
	int cost;
	if (image != NULL)
	{
		//if (GetDocument()->m_CharVectorIndex > 0)
		//{
			//m_minCost = GetDocument()->m_pCharVector[0]->CompareImageInVectorCentred(image);
			m_minCost = 1000000;
			m_BestChars[0].rate = 1000000;
			m_BestChars[1].rate = 1000000;
			m_BestChars[2].rate = 1000000;
		//	for (int i = 0; i < GetDocument()->m_CharVectorIndex; i++)
		//	{
				//open image
			//C:\Documents and Settings\Celia.APHRODITE\My Documents\Memorial Images\Perfect Set\PerfectCharsModified\Capitals
				ImagePath = FindAddress3(charName);
				//ImagePath.Format(_T("%s%c.tif"),GetDocument()->m_PerfectImagePath,GetDocument()->m_pCharVector[i]->GetCharName());
				//TRACE(_T("%s\n"),ImagePath);
				
				loadedImage = ImgLoadFromFile((LPCTSTR)ImagePath, 
				RUNTIME_CLASS(CDIAHiColorImage),
				NULL,
				RUNTIME_CLASS(CDIAGreyScale),
				RUNTIME_CLASS(CDIABiLevelImage));
			
					
					if (MatchingType == 1)//then compareImages centred
					{
						cost = (int)GetDocument()->m_pCharVector[0]->CompareImageInVectorCentred2(loadedImage,image);
					}
					if (MatchingType == 2)//then compare images by centre of gravity
					{
						cost = GetDocument()->m_pCharVector[0]->CompareImageInVectorGravity(image);
					}
					if (MatchingType == 3)
					{
						cost = GetDocument()->CompareImagesFlexible(loadedImage,image);
						//cost = GetDocument()->m_pCharVector[i]->CompareImageInVectorFlexible(GetDocument()->m_pCharVector[i]->GetCharImage(),image);
					}
					if (MatchingType == 4)  //tubbs1 matching type
					{		

						cost = GetDocument()->m_pCharVector[0]->CompareImageInVectorTubbs1(loadedImage,image);
					}
					if (MatchingType == 5)  //tubbs1 matching type
					{		

						cost = GetDocument()->m_pCharVector[0]->CompareImageInVectorTubbs2(loadedImage,image);
					}
					if (MatchingType == 6)  //tubbs1 matching type
					{		

						cost = GetDocument()->CompareImageInVectorWeight(loadedImage,image);
					}
		
	}
					
		//	}
		//}

	//CString text;
	////text.Format(_T("Min Cost= %d"),m_minCost);
	//text.Format(_T("Min Cost= %d"),m_BestChars[0].rate);
	//
	//CalculateRecognitionRate(Lineno,charno);
	//CString character0,character1,character2;
	//character0.Format(_T("Best1 = %c,cost: %d,C=%d"),m_BestChars[0].charname,m_BestChars[0].rate,m_BestChars[0].isCapital);
	//character1.Format(_T("Best2 = %c,cost: %d,C=%d"),m_BestChars[1].charname,m_BestChars[1].rate,m_BestChars[1].isCapital);
	//character2.Format(_T("Best3 = %c,cost: %d,C=%d"),m_BestChars[2].charname,m_BestChars[2].rate,m_BestChars[2].isCapital);
	//
	//m_DetailsList.AddString((LPCTSTR) character0);
	//m_DetailsList.AddString((LPCTSTR) character1);
	//m_DetailsList.AddString((LPCTSTR) character2);
	//m_DetailsList.AddString((LPCTSTR) bar);
	//}
	//m_CurrentBestChar = m_BestChars[0].charname;
	//capital = m_BestChars[0].isCapital;
	TRACE(_T("%c\n"),cost);
	return cost;
	
}


bool CDlgTestingEnvironment::FindBestMatchUsingFeaturesTree(CCharVector &vector, int Lineno, int charno)
{
	//for each Vector compare the character 
	//and print the best match
	//m_bestChar;
	//m_minCost;
	//char bestChar;
	CString bar;
	int cost = 100000;
	m_BestChars[0].rate = 100000;
	m_BestChars[1].rate = 100000;
	m_BestChars[2].rate = 100000;
	bar.Format(_T("---------------"));
	m_CurrentBestChar = '0';
	bool capital = false;
	for (int i = 0; i < GetDocument()->m_CharVectorIndex; i++)
	{
		char name = GetDocument()->m_pCharVector[i]->GetCharName();
		int type = vector.GetCharType();
		if (vector.GetCharType() == GetDocument()->m_pCharVector[i]->GetCharType())
		{
			int Hmax = vector.GetHMax();
			if (vector.GetHMax() == GetDocument()->m_pCharVector[i]->GetHMax())
			{
				int VMax = vector.GetVMax();
				if (vector.GetVMax() == GetDocument()->m_pCharVector[i]->GetVMax())
				{
					cost = GetDocument()->m_pCharVector[i]->CompareImageInVectorCentred(vector.GetCharImage());
				}
			}
		}
		if (cost != 100000)//then there is no character that fits
		{
			/*if (cost <= m_bestChars[2])
			{
				if (cost <= m_bestChars[1])
				{
					if(cost <= m_bestChars[0])
					{
						m_bestChars[2] = m_bestChars[1];
						m_ThirdBestChar = m_SecondBestChar;
						m_bestChars[1] = m_bestChars[0];
						m_SecondBestChar = m_CurrentBestChar;
						m_bestChars[0] = cost;
						m_CurrentBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
						
					}
					else
					{
						m_bestChars[2] = m_bestChars[1];
						m_ThirdBestChar = m_SecondBestChar;
						m_bestChars[1] = cost;
						m_SecondBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
					}
				}
				else
				{
					m_bestChars[2] = cost;
					m_ThirdBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
				}
			}*/
			if (cost <= m_BestChars[2].rate)
			{
				if (cost <= m_BestChars[1].rate)
				{
					if(cost <= m_BestChars[0].rate)
					{
						//test
						m_BestChars[2] = m_BestChars[1];
						m_BestChars[1] = m_BestChars[0];
						//
						/*m_BestChars[2].rate = m_BestChars[1].rate;
						m_BestChars[2].charname = m_BestChars[1].charname;
					
						m_BestChars[1].rate = m_BestChars[0].rate;
						m_BestChars[1].charname = m_BestChars[0].charname;
						*/
						m_BestChars[0].rate = cost;
						m_BestChars[0].charname = m_BestPercentages[i].charname;
						m_BestChars[0].isCapital = m_BestPercentages[i].isCapital;
					
						
					}
					else
					{
						//
						m_BestChars[2] = m_BestChars[1];
						//
						/*m_bestChars[2] = m_bestChars[1];
						m_ThirdBestChar = m_SecondBestChar;*/

						m_BestChars[1].rate = cost;
						m_BestChars[1].charname = m_BestPercentages[i].charname;
						m_BestChars[1].isCapital = m_BestPercentages[i].isCapital;
					}
				}
				else
				{
					m_BestChars[2].rate = cost;
					m_BestChars[2].charname = m_BestPercentages[i].charname;
					m_BestChars[2].isCapital = m_BestPercentages[i].isCapital;
					//m_ThirdBestChar = m_bestCharsPercent[i];
				}
			}
		}
		cost = 100000;	
	//if (vector.GetCharType() == 1) 
	//{//then is a tall char and we need to compare it to the Capitals
	//	if (GetDocument()->m_CharCapitalVectorIndex > 0)
	//	{
	//		for (int i = 0; i < GetDocument()->m_CharCapitalVectorIndex; i++)
	//		{
	//			if (vector.GetCharType() == GetDocument()->m_pCharCapitalVector[i]->GetCharType())
	//			{
	//				if (vector.GetHMax() == GetDocument()->m_pCharCapitalVector[i]->GetHMax())
	//				{
	//					if (vector.GetVMax() == GetDocument()->m_pCharCapitalVector[i]->GetVMax())
	//					{
	//						cost = GetDocument()->m_pCharCapitalVector[i]->CompareImageInVectorCentred(vector.GetCharImage());
	//					}
	//				}
	//			}
	//		}
	//	}
	//	if (cost != 100000)//then there is no character that fits
	//	{
	//		if (cost <= m_bestChars[2])
	//		{
	//			if (cost <= m_bestChars[1])
	//			{
	//				if(cost <= m_bestChars[0])
	//				{
	//					m_bestChars[2] = m_bestChars[1];
	//					m_ThirdBestChar = m_SecondBestChar;
	//					m_bestChars[1] = m_bestChars[0];
	//					m_SecondBestChar = m_CurrentBestChar;
	//					m_bestChars[0] = cost;
	//					m_CurrentBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
	//					capital = true;
	//				}
	//				else
	//				{
	//					m_bestChars[2] = m_bestChars[1];
	//					m_ThirdBestChar = m_SecondBestChar;
	//					m_bestChars[1] = cost;
	//					m_SecondBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
	//				}
	//			}
	//			else
	//			{
	//				m_bestChars[2] = cost;
	//				m_ThirdBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
	//			}
	//		}
	//		}
	//	cost = 100000;
	//	}
	
	}
		
	
	////display results
	//	
	//CString text;
	////text.Format(_T("Min Cost= %d"),m_minCost);
	//text.Format(_T("Min Cost= %d"),m_bestChars[0]);
	///*CString character;
	//character.Format(_T("Best Matching Character = %c"),m_CurrentBestChar);
	//m_DetailsList.AddString((LPCTSTR)text);
	//m_DetailsList.AddString((LPCTSTR) character);*/
	//
	//CString character0,character1,character2;
	//character0.Format(_T("Best 0 = %c,cost: %d"),m_CurrentBestChar,m_bestChars[0]);
	//character1.Format(_T("Best 1 = %c,cost: %d"),m_SecondBestChar,m_bestChars[1]);
	//character2.Format(_T("Best 2 = %c,cost: %d"),m_ThirdBestChar,m_bestChars[2]);
	////m_DetailsList.AddString((LPCTSTR)text);
	//m_DetailsList.AddString((LPCTSTR) character0);
	//m_DetailsList.AddString((LPCTSTR) character1);
	//m_DetailsList.AddString((LPCTSTR) character2);
	//m_DetailsList.AddString((LPCTSTR) bar);

	//display results
		
	CString text;
	//text.Format(_T("Min Cost= %d"),m_minCost);
	text.Format(_T("Min Cost= %d"),m_BestChars[0].rate);
	capital = m_BestChars[0].isCapital;
	
	CalculateRecognitionRate( Lineno,charno);
	CString character0,character1,character2;
	character0.Format(_T("Best1 = %c,cost: %d,C=%b"),m_BestChars[0].charname,m_BestChars[0].rate,m_BestChars[0].isCapital);
	character1.Format(_T("Best2 = %c,cost: %d,C=%b"),m_BestChars[1].charname,m_BestChars[1].rate,m_BestChars[1].isCapital);
	character2.Format(_T("Best3 = %c,cost: %d,C=%b"),m_BestChars[2].charname,m_BestChars[2].rate,m_BestChars[2].isCapital);
	
	m_DetailsList.AddString((LPCTSTR) character0);
	m_DetailsList.AddString((LPCTSTR) character1);
	m_DetailsList.AddString((LPCTSTR) character2);
	m_DetailsList.AddString((LPCTSTR) bar);
	return capital;
}
bool CDlgTestingEnvironment::FindBestMatchUsingFeaturesTree2(CCharVector &vector, CImage * image, int Lineno, int charno)
{
	//for each Vector compare the character 
	//and print the best match
	//m_bestChar;
	//m_minCost;
	//char bestChar;
	CString bar;
	int cost = 100000;
	m_BestChars[0].rate = 100000;
	m_BestChars[1].rate = 100000;
	m_BestChars[2].rate = 100000;
	bar.Format(_T("---------------"));
	m_BestChars[0].charname = '0';
	m_BestChars[1].charname = '0';
	m_BestChars[2].charname = '0';
	bool capital = false;
	for (int i = 0; i < GetDocument()->m_CharVectorIndex; i++)
	{
		char name = GetDocument()->m_pCharVector[i]->GetCharName();
		int type = vector.GetCharType();
		if (vector.GetCharType() == GetDocument()->m_pCharVector[i]->GetCharType())
		{
			//for tall characters
			if (GetDocument()->m_pCharVector[i]->GetCharType() == 1)//tall
			{
				if (vector.GetWeight() == GetDocument()->m_pCharVector[i]->GetWeight())
				{
					if (vector.GetWeight() == 0)//left weight
					{

					}
					if (vector.GetWeight() == 1)//center weight
					{

					}
					if (vector.GetWeight() == 2)//right weight
					{
					}
					if (vector.GetWeight() == 3)//error
					{
						//do nothing for now
					}
				}
			}else if (vector.GetCharType() == 0)//small chars
			{

			}
			else if (vector.GetCharType() == 2)//Low Characters
			{

			}
			int Hmax = vector.GetHMax();
			if (vector.GetHMax() == GetDocument()->m_pCharVector[i]->GetHMax())
			{
				int VMax = vector.GetVMax();
				if (vector.GetVMax() == GetDocument()->m_pCharVector[i]->GetVMax())
				{
					cost = GetDocument()->m_pCharVector[i]->CompareImageInVectorCentred(image);
				}
			}
		}
		if (cost != 100000)//then there is no character that fits
		{
			if (cost <= m_BestChars[2].rate)
			{
				if (cost <= m_BestChars[1].rate)
				{
					if(cost <= m_BestChars[0].rate)
					{
						//test
						m_BestChars[2] = m_BestChars[1];
						m_BestChars[1] = m_BestChars[0];
						//
						/*m_BestChars[2].rate = m_BestChars[1].rate;
						m_BestChars[2].charname = m_BestChars[1].charname;
					
						m_BestChars[1].rate = m_BestChars[0].rate;
						m_BestChars[1].charname = m_BestChars[0].charname;
						*/
						m_BestChars[0].rate = cost;
						m_BestChars[0].charname = m_BestPercentages[i].charname;
						m_BestChars[0].isCapital = m_BestPercentages[i].isCapital;
					
						
					}
					else
					{
						//
						m_BestChars[2] = m_BestChars[1];
						//
						/*m_bestChars[2] = m_bestChars[1];
						m_ThirdBestChar = m_SecondBestChar;*/

						m_BestChars[1].rate = cost;
						m_BestChars[1].charname = m_BestPercentages[i].charname;
						m_BestChars[1].isCapital = m_BestPercentages[i].isCapital;
					}
				}
				else
				{
					m_BestChars[2].rate = cost;
					m_BestChars[2].charname = m_BestPercentages[i].charname;
					m_BestChars[2].isCapital = m_BestPercentages[i].isCapital;
					//m_ThirdBestChar = m_bestCharsPercent[i];
				}
			}
		/*	if (cost <= m_bestChars[2])
			{
				if (cost <= m_bestChars[1])
				{
					if(cost <= m_bestChars[0])
					{
						m_bestChars[2] = m_bestChars[1];
						m_ThirdBestChar = m_SecondBestChar;
						m_bestChars[1] = m_bestChars[0];
						m_SecondBestChar = m_CurrentBestChar;
						m_bestChars[0] = cost;
						m_CurrentBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
						
					}
					else
					{
						m_bestChars[2] = m_bestChars[1];
						m_ThirdBestChar = m_SecondBestChar;
						m_bestChars[1] = cost;
						m_SecondBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
					}
				}
				else
				{
					m_bestChars[2] = cost;
					m_ThirdBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
				}
			}*/
		}
		cost = 100000;	
	//if (vector.GetCharType() == 1) 
	//{//then is a tall char and we need to compare it to the Capitals
	//	if (GetDocument()->m_CharCapitalVectorIndex > 0)
	//	{
	//		for (int i = 0; i < GetDocument()->m_CharCapitalVectorIndex; i++)
	//		{
	//			if (vector.GetCharType() == GetDocument()->m_pCharCapitalVector[i]->GetCharType())
	//			{
	//				if (vector.GetHMax() == GetDocument()->m_pCharCapitalVector[i]->GetHMax())
	//				{
	//					if (vector.GetVMax() == GetDocument()->m_pCharCapitalVector[i]->GetVMax())
	//					{
	//						cost = GetDocument()->m_pCharCapitalVector[i]->CompareImageInVectorCentred(vector.GetCharImage());
	//					}
	//				}
	//			}
	//		}
	//	}
	//	if (cost != 100000)//then there is no character that fits
	//	{
	//		if (cost <= m_bestChars[2])
	//		{
	//			if (cost <= m_bestChars[1])
	//			{
	//				if(cost <= m_bestChars[0])
	//				{
	//					m_bestChars[2] = m_bestChars[1];
	//					m_ThirdBestChar = m_SecondBestChar;
	//					m_bestChars[1] = m_bestChars[0];
	//					m_SecondBestChar = m_CurrentBestChar;
	//					m_bestChars[0] = cost;
	//					m_CurrentBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
	//					capital = true;
	//				}
	//				else
	//				{
	//					m_bestChars[2] = m_bestChars[1];
	//					m_ThirdBestChar = m_SecondBestChar;
	//					m_bestChars[1] = cost;
	//					m_SecondBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
	//				}
	//			}
	//			else
	//			{
	//				m_bestChars[2] = cost;
	//				m_ThirdBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
	//			}
	//		}
	//		}
	//	cost = 100000;
	//	}
	
	}
		
	
	//display results
		
	//CString text;
	////text.Format(_T("Min Cost= %d"),m_minCost);
	//text.Format(_T("Min Cost= %d"),m_bestChars[0]);
	///*CString character;
	//character.Format(_T("Best Matching Character = %c"),m_CurrentBestChar);
	//m_DetailsList.AddString((LPCTSTR)text);
	//m_DetailsList.AddString((LPCTSTR) character);*/
	//
	//CString character0,character1,character2;
	//character0.Format(_T("Best 0 = %c,cost: %d"),m_CurrentBestChar,m_bestChars[0]);
	//character1.Format(_T("Best 1 = %c,cost: %d"),m_SecondBestChar,m_bestChars[1]);
	//character2.Format(_T("Best 2 = %c,cost: %d"),m_ThirdBestChar,m_bestChars[2]);
	////m_DetailsList.AddString((LPCTSTR)text);
	//m_DetailsList.AddString((LPCTSTR) character0);
	//m_DetailsList.AddString((LPCTSTR) character1);
	//m_DetailsList.AddString((LPCTSTR) character2);
	//m_DetailsList.AddString((LPCTSTR) bar);
	CString text;
	//text.Format(_T("Min Cost= %d"),m_minCost);
	text.Format(_T("Min Cost= %d"),m_BestChars[0].rate);
	
	CalculateRecognitionRate( Lineno,charno);
	CString character0,character1,character2;
	character0.Format(_T("Best1 = %c,cost: %d,C = %b"),m_BestChars[0].charname,m_BestChars[0].rate,m_BestChars[0].isCapital);
	character1.Format(_T("Best2 = %c,cost: %d,C = %b"),m_BestChars[1].charname,m_BestChars[1].rate,m_BestChars[1].isCapital);
	character2.Format(_T("Best3 = %c,cost: %d,C = %b"),m_BestChars[2].charname,m_BestChars[2].rate,m_BestChars[2].isCapital);
	
	m_DetailsList.AddString((LPCTSTR) character0);
	m_DetailsList.AddString((LPCTSTR) character1);
	m_DetailsList.AddString((LPCTSTR) character2);
	m_DetailsList.AddString((LPCTSTR) bar);

	return capital;
}





int GetPercentageFromResultVector(CCharVector* vector)
{
	int result = 0;
	//Type
	if (vector->GetCharType() == 0) //means the types were equal
	{
		//nothing result += 0;
	}
	else //different types
	{
		result += 200;
	}
	//HMax
	if (vector->GetHMax() == 0) //they are equal
	{
		result += 0;
	}
	else
	{
		result += 100;
		//if (vector->GetHMax() == 1) //differs in one
		//{
		//	result += 25;
		//}
		//else result += 50;
	}
	//VMax
	if (vector->GetVMax() == 0) //they are equal
	{
		result += 0;
	}
	else
	{
		//if (vector->GetVMax() == 1) //differs in one
		//{
		//	result += 25;
		//}
		//else result += 50;
		result += 100;
	}
	//Width
	result += (vector->GetWidth());
	result += (vector->GetHeight());

return result;
}
void CDlgTestingEnvironment::insertPercentInOrder(int value, char cchar, bool isCapital)
{
	int index = 9;
	while ((value < m_BestPercentages[index].rate) && (index >= 0))
	{
		index--;
	}
	index++;
	if (index < 10)
	{
		int j;
		for (j = 9; j > index; j--)
		{
			m_BestPercentages[j].rate = m_BestPercentages[j-1].rate;
			//m_bestPercentages[j] = m_bestPercentages[j-1];

			//m_bestCharsPercent[j] = m_bestCharsPercent[j-1];
			m_BestPercentages[j].charname = m_BestPercentages[j-1].charname;
		}
		m_BestPercentages[j].rate = value;
		m_BestPercentages[j].charname = cchar;
		m_BestPercentages[j].isCapital = isCapital;
	}

}
//void CDlgTestingEnvironment::insertPercentInOrder(int value, char cchar)
//{
//	int size = 10;
//	int index = size-1;
//	while((m_bestPercentages[index]> value) && (index >= 0))
//	{
//		index--;
//	}
//	if (index < 0) index = 0;
//	int i = size-1;
//
//	while (i >= index)
//	{
//		m_bestPercentages[i] = m_bestPercentages[i-1];
//		m_bestCharsPercent[i] = m_bestCharsPercent[i-1];
//		i--;
//	}
//	m_bestPercentages[index] = value;
//	m_bestCharsPercent[index] = cchar;
//	/*if (value >= m_bestPercentages[9])
//		{
//			if (value >= m_bestPercentages[8])
//			{
//				if(value >= m_bestPercentages[7])
//				{
//					if (value >= m_bestPercentages[6])
//					{
//						if (value >= m_bestPercentages[5])
//						{
//							if(value >= m_bestPercentages[4])
//							{
//								if (value >= m_bestPercentages[3])
//								{
//									if (value >= m_bestPercentages[2])
//									{
//										if(value >= m_bestPercentages[1])
//										{
//											if(value >= m_bestPercentages[0])
//											{
//												m_bestPercentages[2] = m_bestChars[1];
//												m_ThirdBestChar = m_SecondBestChar;
//												m_bestChars[1] = m_bestChars[0];
//												m_SecondBestChar = m_CurrentBestChar;
//												m_bestChars[0] = cost;
//												m_CurrentBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
//											}
//										}
//									}
//								}
//							}
//						}
//					}
//				}
//			}
//		}
//					
//				}
//				else
//				{
//					m_bestChars[2] = m_bestChars[1];
//					m_ThirdBestChar = m_SecondBestChar;
//					m_bestChars[1] = cost;
//					m_SecondBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
//				}
//			}
//			else
//			{
//				m_bestChars[2] = cost;
//				m_ThirdBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
//			}
//		}
//	*/
//}
void CDlgTestingEnvironment::FindBestMatchUsingFeaturesVector(CCharVector& vector,CImage* image, int Lineno, int charno)
{
	CString bar;
	int costPercent = 0;
	int cost = 0;
	for (int i = 0; i < 10; i++)
	{
		m_BestPercentages[i].rate = 1000000;
		//m_bestPercentages[i] = 1000000;
		m_BestPercentages[i].charname = '0';
		m_BestPercentages[i].isCapital = false;
		//m_bestCharsPercent[i] = '0';
	}
	for (int i = 0; i < 3; i++)
	{
		m_BestChars[i].charname = '0';
		m_BestChars[i].rate = 1000000;
		m_BestChars[i].isCapital = false;
	}
	//m_bestChars[0] = 1000000;
	//m_bestChars[1] = 1000000;
	//m_bestChars[2] = 1000000;
	
	bar.Format(_T("---------------"));
	//m_CurrentBestChar = '0';
	//m_SecondBestChar = '0';
	//m_ThirdBestChar = '0';
	//bool capital = false;
	CCharVector* resultVector;
	CCharVector* newVector;
	newVector = new CCharVector;
	newVector->CreateVectorFromVector(vector);
	
	
	for (int i = 0; i < GetDocument()->m_CharVectorIndex; i++)
	{
		resultVector = GetDocument()->m_pCharVector[i]->CompareVectors(newVector);
		costPercent = GetPercentageFromResultVector(resultVector);
		char cchar = GetDocument()->m_pCharVector[i]->GetCharName();
		insertPercentInOrder(costPercent, cchar, false);
	}
	if (vector.GetCharType() == 1)
	{
		for (int i = 0; i < GetDocument()->m_CharCapitalVectorIndex; i++)
		{
			resultVector = GetDocument()->m_pCharCapitalVector[i]->CompareVectors(newVector);
			costPercent = GetPercentageFromResultVector(resultVector);
			char cchar = GetDocument()->m_pCharCapitalVector[i]->GetCharName();
			insertPercentInOrder(costPercent, cchar, true);
		}
	}
//	now we have the best 10 vectors
	
	for (int i = 0; i < 10; i++)
	{
	//	if (m_BestPercentages[i].rate < 200)
		//{
		CString m_pathName;
		if (m_BestPercentages[i].isCapital)
		{
			m_pathName.Format(_T("%s%c.tif"),GetDocument()->m_PerfectCapitalImagePath,m_BestPercentages[i].charname);
		}
		else
		{
			m_pathName.Format(_T("%s%c.tif"),GetDocument()->m_PerfectImagePath,m_BestPercentages[i].charname);
		}
			CImage * CharImage;
			CharImage = new CImage;
			CharImage = ImgLoadFromFile((LPCTSTR)m_pathName, 
				RUNTIME_CLASS(CDIAHiColorImage),
				NULL,
				RUNTIME_CLASS(CDIAGreyScale),
				RUNTIME_CLASS(CDIABiLevelImage));

		
			cost = newVector->CompareImageInVectorCentred(image,CharImage);
			if (cost <= m_BestChars[2].rate)
			{
				if (cost <= m_BestChars[1].rate)
				{
					if(cost <= m_BestChars[0].rate)
					{
						//test
						m_BestChars[2] = m_BestChars[1];
						m_BestChars[1] = m_BestChars[0];
						//
						/*m_BestChars[2].rate = m_BestChars[1].rate;
						m_BestChars[2].charname = m_BestChars[1].charname;
					
						m_BestChars[1].rate = m_BestChars[0].rate;
						m_BestChars[1].charname = m_BestChars[0].charname;
						*/
						m_BestChars[0].rate = cost;
						m_BestChars[0].charname = m_BestPercentages[i].charname;
						m_BestChars[0].isCapital = m_BestPercentages[i].isCapital;
					
						
					}
					else
					{
						//
						m_BestChars[2] = m_BestChars[1];
						//
						/*m_bestChars[2] = m_bestChars[1];
						m_ThirdBestChar = m_SecondBestChar;*/

						m_BestChars[1].rate = cost;
						m_BestChars[1].charname = m_BestPercentages[i].charname;
						m_BestChars[1].isCapital = m_BestPercentages[i].isCapital;
					}
				}
				else
				{
					m_BestChars[2].rate = cost;
					m_BestChars[2].charname = m_BestPercentages[i].charname;
					m_BestChars[2].isCapital = m_BestPercentages[i].isCapital;
					//m_ThirdBestChar = m_bestCharsPercent[i];
				}
		//	}
		}
				
	}
	//display results
		
	CString text;
	//text.Format(_T("Min Cost= %d"),m_minCost);
	text.Format(_T("Min Cost= %d"),m_BestChars[0].rate);
	
	CalculateRecognitionRate( Lineno, charno);
	CString character0,character1,character2;
	character0.Format(_T("Best1=%c,cost:%d,C=%b,Rate:%i"),m_BestChars[0].charname,m_BestChars[0].rate,m_BestChars[0].isCapital,GetDocument()->m_pLineHolder[Lineno].m_pCharacterHolder[charno].m_CharRecogninition[0].rate);
	character1.Format(_T("Best2=%c,cost:%d,C=%b,Rate:%i"),m_BestChars[1].charname,m_BestChars[1].rate,m_BestChars[1].isCapital,GetDocument()->m_pLineHolder[Lineno].m_pCharacterHolder[charno].m_CharRecogninition[1].rate);
	character2.Format(_T("Best3=%c,cost:%d,C=%b,Rate:%i"),m_BestChars[2].charname,m_BestChars[2].rate,m_BestChars[2].isCapital,GetDocument()->m_pLineHolder[Lineno].m_pCharacterHolder[charno].m_CharRecogninition[2].rate);
	
	m_DetailsList.AddString((LPCTSTR) character0);
	m_DetailsList.AddString((LPCTSTR) character1);
	m_DetailsList.AddString((LPCTSTR) character2);
	m_DetailsList.AddString((LPCTSTR) bar);

	
	
	//return false;

}
void CDlgTestingEnvironment::CalculateRecognitionRate(int Lineno, int charno)
{
	//0 = HIGH confidence
	//1 = REGULAR confidence
	//2 = LOW confidence

	for (int i = 0; i<3; i++)
	{
		GetDocument()->m_pLineHolder[Lineno].m_pCharacterHolder[charno].m_CharRecogninition[i].charname = m_BestChars[i].charname;
		GetDocument()->m_pLineHolder[Lineno].m_pCharacterHolder[charno].m_CharRecogninition[i].isCapital = m_BestChars[i].isCapital;
	}
	int diff1, diff2;
	diff1 = abs(m_BestChars[0].rate - m_BestChars[1].rate);
	diff2 = abs(m_BestChars[1].rate - m_BestChars[2].rate);

	if (diff1 <= 10)//if 0 and 1 are very close to each other
	{
		GetDocument()->m_pLineHolder[Lineno].m_pCharacterHolder[charno].m_CharRecogninition[0].rate = 1;
		//m_CharRecognitionRate[0] = 1;
		//m_CharRecognitionRate[1] = 1;
		GetDocument()->m_pLineHolder[Lineno].m_pCharacterHolder[charno].m_CharRecogninition[1].rate = 1;
		if (diff2 <= 10)
		{
			GetDocument()->m_pLineHolder[Lineno].m_pCharacterHolder[charno].m_CharRecogninition[2].rate = 1;
			//m_CharRecognitionRate[2] = 1;
		}
		else
		{
			GetDocument()->m_pLineHolder[Lineno].m_pCharacterHolder[charno].m_CharRecogninition[2].rate = 2;
			//m_CharRecognitionRate[2] = 2;
		}
	}else 
	{
		GetDocument()->m_pLineHolder[Lineno].m_pCharacterHolder[charno].m_CharRecogninition[0].rate = 0;
		GetDocument()->m_pLineHolder[Lineno].m_pCharacterHolder[charno].m_CharRecogninition[1].rate = 2;
		GetDocument()->m_pLineHolder[Lineno].m_pCharacterHolder[charno].m_CharRecogninition[2].rate = 2;
	//	m_CharRecognitionRate[0] = 0;
	//	m_CharRecognitionRate[1] = 2;
	//	m_CharRecognitionRate[2] = 2;
	}

}
//bool CDlgTestingEnvironment::FindBestMatchUsingFeatures(CImage* image,int type, int weight)
//{
	////for each Vector compare the character 
	////and print the best match
	////m_bestChar;
	////m_minCost;
	////char bestChar;
	//CString bar;
	//bar.Format(_T("---------------"));
	//m_CurrentBestChar = '0';
	//bool capital = false;
	//if (image != NULL)
	//{
	//	if (GetDocument()->m_CharVectorIndex > 0)
	//	{
	//		//m_minCost = GetDocument()->m_pCharVector[0]->CompareImageInVectorCentred(image);
	//		m_minCost = 1000000;
	//		m_bestChars[0] = 1000000;
	//		m_bestChars[1] = 1000000;
	//		m_bestChars[2] = 1000000;
	//		for (int i = 0; i < GetDocument()->m_CharVectorIndex; i++)
	//		{
	//			//int* cost = new int[9];
	//			if (GetDocument()->m_pCharVector[i]->GetCharType() == type)
	//			{
	//				int cost;
	//				if (MatchingType == 1)//then compareImages centred
	//				{
	//					cost = GetDocument()->m_pCharVector[i]->CompareImageInVectorCentred(image);
	//				}
	//				if (MatchingType == 2)//then compare images by centre of gravity
	//				{
	//					cost = GetDocument()->m_pCharVector[i]->CompareImageInVectorGravity(image);
	//				}
	//				CString text;
	//				//text.Format(_T("Cost for character %c = %d"),GetDocument()->m_pCharVector[i]->GetCharName(),cost);
	//				
	//			//	m_DetailsList.AddString((LPCTSTR)text);

	//				//if (cost <= m_minCost)
	//				//{
	//				//	m_minCost = cost;
	//				//	m_CurrentBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
	//				//}
	//				if (cost <= m_bestChars[2])
	//				{
	//					if (cost <= m_bestChars[1])
	//					{
	//						if(cost <= m_bestChars[0])
	//						{
	//							m_bestChars[2] = m_bestChars[1];
	//							m_ThirdBestChar = m_SecondBestChar;
	//							m_bestChars[1] = m_bestChars[0];
	//							m_SecondBestChar = m_CurrentBestChar;
	//							m_bestChars[0] = cost;
	//							m_CurrentBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
	//							
	//						}
	//						else
	//						{
	//							m_bestChars[2] = m_bestChars[1];
	//							m_ThirdBestChar = m_SecondBestChar;
	//							m_bestChars[1] = cost;
	//							m_SecondBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
	//						}
	//					}
	//					else
	//					{
	//						m_bestChars[2] = cost;
	//						m_ThirdBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
	//					}
	//				}
	//			}
	//		}
	//	}
	//	if (type == 1) 
	//	{//then is a tall char and we need to compare it to the Capitals
	//		if (GetDocument()->m_CharCapitalVectorIndex > 0)
	//		{
	//			for (int i = 0; i < GetDocument()->m_CharCapitalVectorIndex; i++)
	//			{
	//				int cost;
	//				if (MatchingType == 1)//then compareImages centred
	//				{
	//					cost = GetDocument()->m_pCharCapitalVector[i]->CompareImageInVectorCentred(image);
	//				}
	//				if (MatchingType == 2)//then compare images by centre of gravity
	//				{
	//					cost = GetDocument()->m_pCharCapitalVector[i]->CompareImageInVectorGravity(image);
	//				}
	//				CString text;
	//				//text.Format(_T("Cost for character %c = %d"),GetDocument()->m_pCharCapitalVector[i]->GetCharName(),cost);
	//				//m_DetailsList.SetWindowText((LPCTSRT)text);
	//			//	m_DetailsList.AddString((LPCTSTR)text);
	//				/*if (cost <= m_minCost)
	//				{
	//					m_minCost = cost;
 //                       capital = true;
	//					m_CurrentBestChar = GetDocument()->m_pCharCapitalVector[i]->GetCharName();
	//				}*/
	//				if (cost <= m_bestChars[2])
	//				{
	//					if (cost <= m_bestChars[1])
	//					{
	//						if(cost <= m_bestChars[0])
	//						{
	//							m_bestChars[2] = m_bestChars[1];
	//							m_ThirdBestChar = m_SecondBestChar;
	//							m_bestChars[1] = m_bestChars[0];
	//							m_SecondBestChar = m_CurrentBestChar;
	//							m_bestChars[0] = cost;
	//							m_CurrentBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
	//							capital = true;
	//						}
	//						else
	//						{
	//							m_bestChars[2] = m_bestChars[1];
	//							m_ThirdBestChar = m_SecondBestChar;
	//							m_bestChars[1] = cost;
	//							m_SecondBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
	//						}
	//					}
	//					else
	//					{
	//						m_bestChars[2] = cost;
	//						m_ThirdBestChar = GetDocument()->m_pCharVector[i]->GetCharName();
	//					}
	//				}
	//				
	//			}
	//		}
	//	}
	//	
	//		//display results
	//	
	//		CString text;
	//		//text.Format(_T("Min Cost= %d"),m_minCost);
	//		text.Format(_T("Min Cost= %d"),m_bestChars[0]);
	//		/*CString character;
	//		character.Format(_T("Best Matching Character = %c"),m_CurrentBestChar);
	//		m_DetailsList.AddString((LPCTSTR)text);
	//		m_DetailsList.AddString((LPCTSTR) character);*/
	//		
	//		CString character0,character1,character2;
	//		character0.Format(_T("Best 0 = %c,cost: %d"),m_CurrentBestChar,m_bestChars[0]);
	//		character1.Format(_T("Best 1 = %c,cost: %d"),m_SecondBestChar,m_bestChars[1]);
	//		character2.Format(_T("Best 2 = %c,cost: %d"),m_ThirdBestChar,m_bestChars[2]);
	//		//m_DetailsList.AddString((LPCTSTR)text);
	//		m_DetailsList.AddString((LPCTSTR) character0);
	//		m_DetailsList.AddString((LPCTSTR) character1);
	//		m_DetailsList.AddString((LPCTSTR) character2);
	//		m_DetailsList.AddString((LPCTSTR) bar);
	//		
	//	
	//}
	//TRACE(_T("%c\n"),m_CurrentBestChar);
	//return capital;
	
//}
void CDlgTestingEnvironment::DisplayRecognitionInList(char bestChar)
{
	//display results
		
	CString text;
	text.Format(_T("Min Cost= %d"),m_minCost);
	CString character;
	character.Format(_T("Best Matching Character = %c"),bestChar);
	m_DetailsList.AddString((LPCTSTR)text);
	m_DetailsList.AddString((LPCTSTR) character);
	m_bDisplayRecognizedImage = true;
}

void CDlgTestingEnvironment::OnBnClickedFindBestMatch()
{
	//DisplayRecognitionInList(FindBestMatch(m_pBlindCharImage));
	m_CurrentBestChar = FindBestMatch(m_pBlindCharImage);
	m_ShowOnlyOneChar = true;
	m_bOpenChar = true;

	this->UpdateWindow();
	////for each Vector compare the character 
	////and print the best match
	////m_bestChar;
	////m_minCost;
	//if (m_pBlindCharImage != NULL)
	//{
	//	m_minCost = GetDocument()->m_pCharVector[0]->CompareImageInVectorCentred(m_pBlindCharImage);
	//	for (int i = 0; i < GetDocument()->m_CharVectorIndex; i++)
	//	{
	//		//int* cost = new int[9];
	//		int cost;
	//		cost = GetDocument()->m_pCharVector[i]->CompareImageInVectorCentred(m_pBlindCharImage);
	//		CString text;
	//		text.Format(_T("Cost for character %c = %d"),GetDocument()->m_pCharVector[i]->GetCharName(),cost);
	//		//m_DetailsList.SetWindowText((LPCTSRT)text);
	//		m_DetailsList.AddString((LPCTSTR)text);
	//		if (cost <= m_minCost)
	//		{
	//			m_minCost = cost;
	//			m_bestChar = GetDocument()->m_pCharVector[i]->GetCharName();
	//		}
	//	}
	//}
	////display results
	//CString text;
	//text.Format(_T("Min Cost= %d"),m_minCost);
	//CString character;
	//character.Format(_T("Best Matching Character = %c"),m_bestChar);
	//m_DetailsList.AddString((LPCTSTR)text);
	//m_DetailsList.AddString((LPCTSTR) character);
	//m_bDisplayRecognizedImage = true;

}

void CDlgTestingEnvironment::OnBnClickedGetChar()
{
	m_bOpenChar = true;
	m_ShowOnlyOneChar = true;
	m_pBlindCharImage = new CImage;
	CFileDialog m_FileDialog(TRUE, NULL, NULL, OFN_HIDEREADONLY|OFN_FILEMUSTEXIST, 
		_T("TIFF Files(*.tiff; *.tif)|*.tiff; *.tif|All Files (*.*)|*.*||"));
	if (m_FileDialog.DoModal() == IDOK)
	{
		CString m_pathName = m_FileDialog.GetPathName();
		//deletion of old undo array
	
		m_pBlindCharImage = ImgLoadFromFile((LPCTSTR)m_pathName, 
			RUNTIME_CLASS(CDIAHiColorImage),
			NULL,
			RUNTIME_CLASS(CDIAGreyScale),
			RUNTIME_CLASS(CDIABiLevelImage));
	}
}

void CDlgTestingEnvironment::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	if (m_bOpenChar)
	{
		if (m_ShowOnlyOneChar)
		{
			DisplayImage(m_InputChar,m_pBlindCharImage);
		}
		else
		{
			if (m_CurrentDisplayChar < GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_CharacterHolderIndex)
			{
			//	DisplayImage(m_InputChar,GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].m_pLocatedCharImage);
			}
		}
	}
	if (m_bDisplayRecognizedImage)
	{
		//CImage* loadedImage;
		CString pathName;
		
		pathName.Format(_T("%s%c.tif"),GetDocument()->m_PerfectImagePath,m_CurrentBestChar);
		//pathName.Format(_T("X:\\celia\\Memorial Images\\Original Characters\\Perfect Set\\PerfectChars\\%c.tif"),m_pCharVector[i]->GetCharName());
		//pathName.Format(_T("PerfectChars\\%c.tif"),m_pCharVector[i]->GetCharName());
		TRACE(_T("%s\n"),pathName);

		
	/*	loadedImage = ImgLoadFromFile((LPCTSTR)pathName, 
		RUNTIME_CLASS(CDIAHiColorImage),
		NULL,
		RUNTIME_CLASS(CDIAGreyScale),
		RUNTIME_CLASS(CDIABiLevelImage));*/

		//if (m_ShowOnlyOneChar)
	//	{
		//if (loadedImage != NULL)
		//{
			//DisplayImage(m_RecognizedChar,loadedImage);
		//}

	//	}
	//	else
		//{
		//	DisplayImage(m_InputChar,GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].m_pLocatedCharImage);
		//}
	}

}

void CDlgTestingEnvironment::OnBnClickedGetImage2()
{
	//open the image and get the characters
	//given the m_displayChar find out what char is it
	m_CurrentDisplayChar = 0;
	m_CurrentDisplayLine = 0;

	if (GetDocument()->m_LineHolderIndex > 0)
	{
		GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].CreateCharImage(GetDocument()->GetActiveImage(),true);
		GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].CreateLocatedCharImage(m_pDoc->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].m_pCharImage,true);
		m_CurrentBestChar = FindBestMatch(GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].m_pLocatedCharImage,GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].m_CharFinalType,1,m_CurrentDisplayLine,m_CurrentDisplayChar);
	}
	m_bOpenChar = true;
	m_ShowOnlyOneChar = false;		
	m_bDisplayRecognizedImage = true;
		
}
void CDlgTestingEnvironment::GetNextChar()
{
		m_CurrentDisplayChar++;
		if (m_CurrentDisplayChar == GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_CharacterHolderIndex)
		{//then we go to next line
			if (m_CurrentDisplayLine < GetDocument()->m_LineHolderIndex-1)
			{
				m_CurrentDisplayChar = 0;
				m_CurrentDisplayLine++;
				GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].CreateCharImage(GetDocument()->GetActiveImage(),true);
				GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].CreateLocatedCharImage(m_pDoc->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].m_pCharImage,true);
				m_CurrentBestChar = FindBestMatch(GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].m_pLocatedCharImage,GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].m_CharFinalType,6,m_CurrentDisplayLine,m_CurrentDisplayChar);
				
				//DisplayRecognitionInList(FindBestMatch(GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].m_pLocatedCharImage,GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].m_CharFinalType));
				//FindBestMatch(GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].m_pLocatedCharImage);
			//	m_CurrentDisplayChar++;
				
			}
		}
		else
		{
			GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].CreateCharImage(GetDocument()->GetActiveImage(),true);
			GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].CreateLocatedCharImage(m_pDoc->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].m_pCharImage,true);
			//FindBestMatch(GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].m_pLocatedCharImage);
			//DisplayRecognitionInList(FindBestMatch(GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].m_pLocatedCharImage,GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].m_CharFinalType));
			m_CurrentBestChar = FindBestMatch(GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].m_pLocatedCharImage,GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].m_CharFinalType,6,m_CurrentDisplayLine,m_CurrentDisplayChar);
			//m_CurrentDisplayChar++;
		}
		m_bDisplayRecognizedImage = true;
	//	this->UpdateWindow();

	////m_CurrentDisplayChar++;
	//if (m_CurrentDisplayLine < GetDocument()->m_LineHolderIndex) 
	//{
	//	if (m_CurrentDisplayChar < GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_CharacterHolderIndex)
	//	{
	//		GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].CreateLocatedCharImage(m_pDoc->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].m_pCharImage,true);
	//		FindBestMatch(GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].m_pLocatedCharImage);
	//		m_CurrentDisplayChar++;
	//	}
	//	else
	//		{
	//			//then it is the last character of the line, and we go to the next line
	//			if (GetDocument()->m_LineHolderIndex < (m_CurrentDisplayLine+1))
	//			{
	//				//then it is not the last character of the last line
	//				m_CurrentDisplayChar = 0;
	//				m_CurrentDisplayLine++;
	//				GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].CreateLocatedCharImage(m_pDoc->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].m_pCharImage,true);
	//				FindBestMatch(GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].m_pLocatedCharImage);
	//				m_CurrentDisplayChar++;
	//				
	//			}
	//		}
	//	
	//}
	//GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].CreateCharImage(GetDocument()->GetActiveImage(), false);
	/*GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].CreateLocatedCharImage(m_pDoc->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].m_pCharImage,true);
	FindBestMatch(GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].m_pLocatedCharImage);
	m_CurrentDisplayChar++;*/
}
void CDlgTestingEnvironment::GetPreviousChar()
{
	if(m_CurrentDisplayChar == 0)
	{
		if (m_CurrentDisplayLine != 0)
		{
			m_CurrentDisplayLine--;
			m_CurrentDisplayChar = GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_CharacterHolderIndex-1;
		}
	}
	else
	{
		m_CurrentDisplayChar--;
	}
	
	m_CurrentBestChar = FindBestMatch(GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].m_pLocatedCharImage);
	//FindBestMatch(GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_pCharacterHolder[m_CurrentDisplayChar].m_pLocatedCharImage);
	m_bDisplayRecognizedImage = true;

}

void CDlgTestingEnvironment::OnBnClickedNext()
{
	GetNextChar();
	m_ShowOnlyOneChar = false;
	m_bOpenChar = true;
	//m_bDisplayRecognizedImage = true;
	//this->UpdateWindow();
	//if ((m_CurrentDisplayLine == GetDocument()->m_LineHolderIndex) && ( m_CurrentDisplayChar == GetDocument()->m_pLineHolder[m_CurrentDisplayLine].m_CharacterHolderIndex))
	//{
	//	//then it is the last char
	//	//disable the button next
	//}
	
}

void CDlgTestingEnvironment::OnBnClickedPrevious()
{
	GetPreviousChar();
	m_ShowOnlyOneChar = false;
	m_bOpenChar = true;
	//m_bDisplayRecognizedImage = true;
	//this->m_InputChar.UpdateWindow();
}

void CDlgTestingEnvironment::OnBnClickedFindBestMatch2()
{
	m_CurrentDisplayLine = 0;
	m_CurrentDisplayChar = 0;
}
void CDlgTestingEnvironment::PerformRecognition(int MatchingType)
{
	//for each character image in the opened image
	//create a new image of the same size as original image
	//paste recognized characters in the new image in exactly same place they were
	bool isCapital;
	GetDocument()->CreateNewUndoImage(0);
	for (int a = 0; a < GetDocument()->GetUndoImage(GetDocument()->m_index -1)->GetWidth(); a++)
	{
		for (int b = 0; b <  GetDocument()->GetUndoImage(GetDocument()->m_index -1)->GetHeight(); b++)
		{
			 GetDocument()->GetUndoImage(GetDocument()->m_index -1)->SetRGBColor(a,b,RGB(255,255,255));
		}
	}
	CString newname;
	newname.Format(_T("%sRecognized.tif"),GetDocument()->m_RecognizedImagePath);
	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	{
		for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
		{
			//recognize the characters
			
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetDocument()->GetUndoImage(GetDocument()->m_index - 2),false);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateLocatedCharImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,true);
			isCapital = FindBestMatch(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharFinalType,MatchingType,i,j);
			
			//get the image with that name
			CImage* loadedImage;
			CString pathName;
			pathName = FindAddress3(m_CurrentBestChar);
			/*if (isCapital)
			{	
				pathName.Format(_T("%s%c.tif"),GetDocument()->m_PerfectCapitalImagePath,m_CurrentBestChar);
				TRACE(_T("%s\n"),pathName);
			}
			else
			{
				pathName.Format(_T("%s%c.tif"),GetDocument()->m_PerfectImagePath,m_CurrentBestChar);
				TRACE(_T("%s\n"),pathName);
			}*/
			
			loadedImage = ImgLoadFromFile((LPCTSTR)pathName, 
			RUNTIME_CLASS(CDIAHiColorImage),
			NULL,
			RUNTIME_CLASS(CDIAGreyScale),
			RUNTIME_CLASS(CDIABiLevelImage));
			//paste it in m_pRecognizedImage
			for (int x = 0; x < loadedImage->GetWidth(); x++)
			{
				for (int y = 0; y < loadedImage->GetHeight(); y++)
				{
					//copy the pixels into the rith position
					int xPos,yPos;
					xPos = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left + x;
					yPos = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top + y;
					int color = (int) GetRValue(loadedImage->GetRGBColor(x,y));
					GetDocument()->GetActiveImage()->SetRGBColor(xPos,yPos,RGB(color,color,color));
					
				}
			}
		}
	}
	if (TRUE == GetDocument()->GetUndoImage(GetDocument()->m_index-1)->ExportTIFF((LPCTSTR)newname))
	{}
	
	
}


void CDlgTestingEnvironment::PerformProbabilityRecognition(int MatchingType, int level)
{
	//for each character image in the opened image
	//create a new image of the same size as original image
	//paste recognized characters in the new image in exactly same place they were
//	bool isCapital;
	//GetDocument()->CreateNewUndoImage(0);
	GetDocument()->CreateNewUndoImage(IT_HICOLOR);
	for (int a = 0; a < GetDocument()->GetUndoImage(GetDocument()->m_index -1)->GetWidth(); a++)
	{
		for (int b = 0; b <  GetDocument()->GetUndoImage(GetDocument()->m_index -1)->GetHeight(); b++)
		{
			 GetDocument()->GetUndoImage(GetDocument()->m_index -1)->SetRGBColor(a,b,RGB(255,255,255));
		}
	}
	CString newname;
	newname.Format(_T("%sRecognized.tif"),GetDocument()->m_RecognizedImagePath);

	FILE * pFileText;
	CString pathNameText;
	pathNameText.Format(_T("%s-Recognised.txt"),GetDocument()->GetActiveImage()->GetName());
	pFileText = _tfopen(pathNameText, _T("w"));

	FILE * pFileText2;
	CString pathNameText2;
	pathNameText2.Format(_T("%s-Confidence-Recognised.txt"),GetDocument()->GetActiveImage()->GetName());
	pFileText2 = _tfopen(pathNameText2, _T("w"));
	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	{
		for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
		{
			//recognize the characters
			
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ExtractFeatures();
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetDocument()->GetUndoImage(GetDocument()->m_index - 2),false);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateLocatedCharImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,true);
			//create vector from character

			CDIACharacter * character;
			character = new CDIACharacter;
			character = &GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j];
			CCharVector vector;
			vector.CreateVectorFromCharacter(character);
			int cost;
			bool confident;
			m_CurrentBestChar = FindBestMatchUsingProbability(vector, GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage, level, confident, cost);
			//FindBestMatch(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharFinalType,MatchingType,i,j);
			
			//get the image with that name
			//modify minchar to the new Values
				char newMinChar;
				if (m_CurrentBestChar == '~') newMinChar = '"';
				else if (m_CurrentBestChar == '$') newMinChar = ',';
				else if (m_CurrentBestChar == '^') newMinChar = '.';
				else if (m_CurrentBestChar == '#') newMinChar = ':';
				else newMinChar = m_CurrentBestChar;
				char colour;
				if (confident) colour = 'B';
				else colour = 'R';
				//find the distance to the previus character
				if (j == 0)//it is the first character
				{
					fprintf(pFileText,"%c",newMinChar);
					fprintf(pFileText2,"%c",colour);
				}else
				{
					//find the center of the previous character in the charholder
					int value = j-1;
					 if (abs(((GetDocument()->m_pLineHolder[i].m_pCharacterHolder[value].m_CharCenter.x + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[value].m_Position_X )- (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X))) < 40)
					 {
						 //it is the next character
						 fprintf(pFileText,"%c",newMinChar);
						 fprintf(pFileText2,"%c",colour);
					 }
					 else
					 {
						 //There is a space between them
						 //find how many spaces
						int distance = abs((GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j-1].m_CharCenter.x + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j-1].m_Position_X) - (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X));
						int newdistance = (float)distance/35.00;
						for (int z = 0; z < newdistance; z++)
						{
							fprintf(pFileText," ");
						}
						 fprintf(pFileText,"%c",newMinChar);
						 fprintf(pFileText2,"%c",colour);
					 }
				}

			//store Statistics
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_FTRChar.charName = m_CurrentBestChar;
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_FTRChar.isBlue = confident;
			//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_FTRChar.secondCharName = 


			ApplyRecognisedChar(GetDocument()->GetActiveImage(), m_CurrentBestChar, i, j, confident);
			//ApplyRecognisedChar(GetDocument()->GetActiveImage(), m_CurrentBestChar, i, j);
			TRACE(_T("%c\n"),m_CurrentBestChar);
		
		}
		fprintf(pFileText,"\n");
		fprintf(pFileText2,"\n");
	}
	fclose(pFileText);
	fclose(pFileText2);
	
	
	
}
void CDlgTestingEnvironment::ApplyRecognisedChar(CImage *image, char charName, int LinePos, int CharPos)
{
			CImage* loadedImage;
			CString pathName;
			pathName = FindAddress3(charName);
			
			
			loadedImage = ImgLoadFromFile((LPCTSTR)pathName, 
			RUNTIME_CLASS(CDIAHiColorImage),
			NULL,
			RUNTIME_CLASS(CDIAGreyScale),
			RUNTIME_CLASS(CDIABiLevelImage));
			//paste it in m_pRecognizedImage
			int base = CalculateAverageBase(LinePos);
			for (int x = 0; x < loadedImage->GetWidth(); x++)
			{
				for (int y = 0; y < loadedImage->GetHeight(); y++)
				{
					//copy the pixels into the rith position
					int xPos,yPos;
					if ((GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharFinalType != 2) && (GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharFinalType != 4))
					{
						yPos = GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Position_Y + base - GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharLocation.Height() + y;
					}else
					{
						yPos = GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Position_Y + GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharLocation.top + y;
					}
					xPos = GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Position_X + GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharLocation.left + x;
					//yPos = GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Position_Y + GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharLocation.top + y;
					int color = (int) GetRValue(loadedImage->GetRGBColor(x,y));
					image->SetRGBColor(xPos,yPos,RGB(color,color,color));
					
				}
			}
}

void CDlgTestingEnvironment::ApplyRecognisedChar(CImage *image, char charName, int LinePos, int CharPos, bool confident)
{
			CImage* loadedImage;
			CString pathName;
			pathName = FindAddress3(charName);
			
			
			loadedImage = ImgLoadFromFile((LPCTSTR)pathName, 
			RUNTIME_CLASS(CDIAHiColorImage),
			NULL,
			RUNTIME_CLASS(CDIAGreyScale),
			RUNTIME_CLASS(CDIABiLevelImage));
			//paste it in m_pRecognizedImage
			int base = CalculateAverageBase(LinePos);
			for (int x = 0; x < loadedImage->GetWidth(); x++)
			{
				for (int y = 0; y < loadedImage->GetHeight(); y++)
				{
					//copy the pixels into the rith position
					int xPos,yPos;
					if ((GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharFinalType != 2) && (GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharFinalType != 4))
					{
						yPos = GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Position_Y + base - loadedImage->GetHeight() + y;
					}else
					{
						yPos = GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Position_Y + GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharLocation.top + y;
					}
					//move to the center of the character box
					int left;
					left = (int)GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Position_X + ((float)GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Width/2) - (loadedImage->GetWidth()/2);
					xPos = left + x;
					//yPos = GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Position_Y + GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharLocation.top + y;
					int color = (int) GetRValue(loadedImage->GetRGBColor(x,y));
					
					if ((color == 0) && (!confident))
					{
						//color = red
						image->SetRGBColor(xPos,yPos,RGB(255,75,33));
					}
					else
						if ((color == 0) && (confident))
						{
							image->SetRGBColor(xPos,yPos,RGB(33,75,255));
						}
						if (color == 255)
						{
							image->SetRGBColor(xPos,yPos,RGB(255,255,255));
						}
					
				}
			}
}


void CDlgTestingEnvironment::ApplyNewCharImage(CImage *Outimage, CImage * charImage, int LinePos, int CharPos)
{
			int base = CalculateAverageBase(LinePos);
			for (int x = 0; x < charImage->GetWidth(); x++)
			{
				for (int y = 0; y < charImage->GetHeight(); y++)
				{
					//copy the pixels into the rith position
					int xPos,yPos;

					if ((GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharFinalType != 2) || (GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharFinalType != 4))
					{
						yPos = GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Position_Y + base - charImage->GetHeight() + y;
					}else
					{
						yPos = GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Position_Y + GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharLocation.top + y;
					}
					//move to the center of the character box
					int left;
					left = (int)GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Position_X + ((float)GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharLocation.Width()/2) - (charImage->GetWidth()/2);
					xPos = left + x;
					//xPos = GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Position_X + GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharLocation.left + x;
					int color = (int) GetRValue(charImage->GetRGBColor(x,y));
					Outimage->SetRGBColor(xPos,yPos,RGB(color,color,color));
					
				}
			}
}
//
//void CDocImAnView::ApplyNewCharImage(CImage *Outimage, CImage * charImage, int LinePos, int CharPos)
//{
//			int base = CalculateAverageBase(LinePos);
//			for (int x = 0; x < charImage->GetWidth(); x++)
//			{
//				for (int y = 0; y < charImage->GetHeight(); y++)
//				{
//					//copy the pixels into the rith position
//					int xPos,yPos;
//					xPos = GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Position_X + GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharLocation.left + x;
//					yPos = GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Position_Y + base - GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharLocation.Height() + y;
//					int color = (int) GetRValue(charImage->GetRGBColor(x,y));
//					Outimage->SetRGBColor(xPos,yPos,RGB(color,color,color));
//					
//				}
//			}
//			
//}
int CDlgTestingEnvironment::CalculateAverageBase(int line)
{
	int average = 0;
	int count = 0;
	//get all short and tall chars of the line and calculate the average of their bottom location
	for (int i = 0; i < GetDocument()->m_pLineHolder[line].m_CharacterHolderIndex; i++)
	{
		int type = GetDocument()->m_pLineHolder[line].m_pCharacterHolder[i].m_CharFinalType;
		if ((type == 1) || (type == 0))//it is short or tall then add to average
		{
			int bottom = GetDocument()->m_pLineHolder[line].m_pCharacterHolder[i].m_CharLocation.bottom;
			average = average + bottom;
			count++;
		}
	}
	return (int)((float)average /(float) count);
}
//
void CDlgTestingEnvironment::OnBnClickedTestvector()
{
	//for each character in the vector test the values
	for (int i = 0; i < GetDocument()->m_CharVectorIndex; i++)
	{
		TRACE(_T("%c\n"),GetDocument()->m_pCharVector[i]->GetCharName());
		
	}
}



void CDlgTestingEnvironment::OnBnClickedRecognizeWholeImage2()
{
	PerformRecognition(1);
	GetDocument()->m_bIsImageRecognized = true;
}


void CDlgTestingEnvironment::OnBnClickedTestvector2()
{
	for (int i = 0; i < GetDocument()->m_CharCapitalVectorIndex; i++)
	{
		TRACE(_T("%c\n"),GetDocument()->m_pCharCapitalVector[i]->GetCharName());
		
	}
}

void CDlgTestingEnvironment::OnBnClickedRecognizeGravity()
{
	PerformRecognition(1);
}

void CDlgTestingEnvironment::OnBnClickedCancel()
{
	GetDocument()->DeleteVectorList();
	OnCancel();
}

void CDlgTestingEnvironment::OnBnClickedRecognizegrav()
{
	PerformRecognition(2);
}


void CDlgTestingEnvironment::RecognitionRateEvaluation(char bestchar,int bestcharcost, char secondchar, int secondcharcost, char thirdchar, int thirdcharcost, int chartype)
{
	//given the best matches, and the type of char then calculate the recognition rate
	if (abs((bestcharcost - secondcharcost)))
	{

	}
}
void CDlgTestingEnvironment::PerformRecognitionTree()
{
	//for each character image in the opened image
	//create a new image of the same size as original image
	//paste recognized characters in the new image in exactly same place they were
	bool isCapital;
	GetDocument()->CreateNewUndoImage(0);
	for (int a = 0; a < GetDocument()->GetUndoImage(GetDocument()->m_index -1)->GetWidth(); a++)
	{
		for (int b = 0; b <  GetDocument()->GetUndoImage(GetDocument()->m_index -1)->GetHeight(); b++)
		{
			 GetDocument()->GetUndoImage(GetDocument()->m_index -1)->SetRGBColor(a,b,RGB(255,255,255));
		}
	}
	//CString newname;
	//newname.Format(_T("%sRecognized.tif"),GetDocument()->m_RecognizedImagePath);
	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	{
		for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
		{
			//recognize the characters
			int hmax = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharHMaxCount;
			int vmax = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharVMaxCount;
			int weight = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharWeight;
			//
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetDocument()->GetUndoImage(GetDocument()->m_index - 2),false);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateLocatedCharImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,true);

			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].Clear();
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ExtractFeatures();
			CDIACharacter * character;
			character = new CDIACharacter;
			////
			
			//tDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CalculateStrongMaxInProjs();
			//tDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CalculateWeight();
			hmax = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharHMaxCount;
			vmax = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharVMaxCount;
			weight = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharWeight;
			////

			character = &GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j];
			CCharVector vector;
			vector.CreateVectorFromCharacter(character);
			hmax = vector.GetHMax();
			vmax = vector.GetVMax();
			weight = vector.GetWeight();
			//vector.CreateVectorFromCharacter(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j]);
			//vector.SetCharName(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharName);
			//vector.SetWidth(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width);
			//vector.SetHeight(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height);
			//vector.SetAspectRatio((float)GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height/(float) GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width);
			//vector.SetCharType(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharFinalType);
			//vector.SetHMax(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharHMaxCount);
			isCapital = FindBestMatchUsingFeaturesTree2(vector,character->m_pLocatedCharImage,i,j);
			
			//get the image with that name
			CImage* loadedImage;
			CString pathName;
			//if (isCapital)
			//{	
			//	pathName.Format(_T("%s%c.tif"),GetDocument()->m_PerfectCapitalImagePath,m_CurrentBestChar);
			//	TRACE(_T("%s\n"),pathName);
			//}
			//else
			//{
				pathName.Format(_T("%s%c.tif"),GetDocument()->m_PerfectImagePath,m_CurrentBestChar);
				TRACE(_T("%s\n"),pathName);
			//}
			
			loadedImage = ImgLoadFromFile((LPCTSTR)pathName, 
			RUNTIME_CLASS(CDIAHiColorImage),
			NULL,
			RUNTIME_CLASS(CDIAGreyScale),
			RUNTIME_CLASS(CDIABiLevelImage));
			//paste it in m_pRecognizedImage
			for (int x = 0; x < loadedImage->GetWidth(); x++)
			{
				for (int y = 0; y < loadedImage->GetHeight(); y++)
				{
					//copy the pixels into the right position
					int xPos,yPos;
					xPos = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left + x;
					yPos = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top + y;
					int color = (int) GetRValue(loadedImage->GetRGBColor(x,y));
					GetDocument()->GetActiveImage()->SetRGBColor(xPos,yPos,RGB(color,color,color));
					
				}
			}
		}
	}
	//if (TRUE == GetDocument()->GetUndoImage(GetDocument()->m_index-1)->ExportTIFF((LPCTSTR)newname))
	//{}
}

void CDlgTestingEnvironment::PerformRecognitionTree2()
{
	//for each character image in the opened image
	//create a new image of the same size as original image
	//paste recognized characters in the new image in exactly same place they were
	//bool isCapital;
	GetDocument()->CreateNewUndoImage(0);
	for (int a = 0; a < GetDocument()->GetUndoImage(GetDocument()->m_index -1)->GetWidth(); a++)
	{
		for (int b = 0; b <  GetDocument()->GetUndoImage(GetDocument()->m_index -1)->GetHeight(); b++)
		{
			 GetDocument()->GetUndoImage(GetDocument()->m_index -1)->SetRGBColor(a,b,RGB(255,255,255));
		}
	}
	//CString newname;
	//newname.Format(_T("%sRecognized.tif"),GetDocument()->m_RecognizedImagePath);
	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	{
		for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
		{
			//recognize the characters
			//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ExtractFeatures();
			int hmax = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharHMaxCount;
			int vmax = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharVMaxCount;
			int weight = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharWeight;
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ExtractFeatures();
			//
			hmax = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharHMaxCount;
			vmax = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharVMaxCount;
			weight = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharWeight;
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetDocument()->GetUndoImage(GetDocument()->m_index - 2),false);
			//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetDocument()->GetActiveImage(),false);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateLocatedCharImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,true);

			//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].Clear();
			
			CDIACharacter * character;
			character = new CDIACharacter;
			character = &GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j];
			CCharVector vector;
			vector.CreateVectorFromCharacter(character);
			//delete character;
			hmax = vector.GetHMax();
			vmax = vector.GetVMax();
			weight = vector.GetWeight();
			//vector.CreateVectorFromCharacter(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j]);
			vector.SetCharName(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharName);
			vector.SetWidth(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width);
			vector.SetHeight(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height);
			//vector.SetAspectRatio((float)GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height/(float) GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width);
			vector.SetCharType(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharFinalType);
			vector.SetHMax(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharHMaxCount);
			vector.SetVMax(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharVMaxCount);
			char recognisedChar = FindBestMatchUsingFeaturesTree3(vector,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage,i,j);
			if (recognisedChar == '@')
			{
				//there was no character stored at that location. The character is not recognised, for now
				recognisedChar = '@';
			}
			//get the image with that name
			CImage* loadedImage;
			CString filename;
			filename.Format(_T("PerfectCharsLocation.txt"));
			CString pathName;

			pathName = FindAddress3(recognisedChar);
			TRACE(_T("%s\n"),pathName);
			//if (isCapital)
			//{	
			//	pathName.Format(_T("%s%c.tif"),GetDocument()->m_PerfectCapitalImagePath,m_CurrentBestChar);
			//	TRACE(_T("%s\n"),pathName);
			//}
			//else
			//{
				//pathName.Format(_T("%s%c.tif"),GetDocument()->m_PerfectImagePath,recognisedChar);
				//TRACE(_T("%s\n"),pathName);
			//}
			
			loadedImage = ImgLoadFromFile((LPCTSTR)pathName, 
			RUNTIME_CLASS(CDIAHiColorImage),
			NULL,
			RUNTIME_CLASS(CDIAGreyScale),
			RUNTIME_CLASS(CDIABiLevelImage));
			//paste it in m_pRecognizedImage
			
			for (int x = 0; x < loadedImage->GetWidth(); x++)
			{
				for (int y = 0; y < loadedImage->GetHeight(); y++)
				{
					//copy the pixels into the right position
					int xPos,yPos;
					xPos = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left + x;
					yPos = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top + y;
					int color = (int) GetRValue(loadedImage->GetRGBColor(x,y));
					GetDocument()->GetActiveImage()->SetRGBColor(xPos,yPos,RGB(color,color,color));
					
				}
			}
			
		}
	}

	//if (TRUE == GetDocument()->GetUndoImage(GetDocument()->m_index-1)->ExportTIFF((LPCTSTR)newname))
	//{}
}
void CDlgTestingEnvironment::PerformRecognitionVector()
{
	bool isCapital = false;
	//Get character vectors and compare them to all the vectors
	//Get the three lowest ones and match
	GetDocument()->CreateNewUndoImage(0);
	for (int a = 0; a < GetDocument()->GetUndoImage(GetDocument()->m_index -1)->GetWidth(); a++)
	{
		for (int b = 0; b <  GetDocument()->GetUndoImage(GetDocument()->m_index -1)->GetHeight(); b++)
		{
			 GetDocument()->GetUndoImage(GetDocument()->m_index -1)->SetRGBColor(a,b,RGB(255,255,255));
		}
	}
	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	{
		for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
		{
			
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetDocument()->GetUndoImage(GetDocument()->m_index - 2),false);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateLocatedCharImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,true);

			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].Clear();
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ExtractFeatures();
			CDIACharacter * character;
			character = new CDIACharacter;
		

			character = &GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j];
			CCharVector vector;
			vector.CreateVectorFromCharacter(character);
			//FindBestMatchUsingFeaturesVector(vector,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage);
			FindBestMatchUsingFeaturesVector(vector,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage, i, j);
			

			//store bestchars in the character
			for (int x = 0; x < 3; x++)
			{
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[x].charname = m_BestChars[x].charname;
				//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[2].charName = m_BestChars[1].rate;
				//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[3].charName = m_BestChars[2].rate;
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[x].rate = (float)m_BestChars[x].rate;
				//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[1].rate = m_BestChars[1].charname;
				//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[2].rate = m_BestChars[2].charname;
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[x].isCapital= m_BestChars[x].isCapital;
				//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[1].charName = m_BestChars[1].isCapital;
				//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[2].charName = m_BestChars[2].isCapital;
			}
			//get the image with that name
			CImage* loadedImage;
			CString pathName;
			if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[0].isCapital)
			{	
				pathName.Format(_T("%s%c.tif"),GetDocument()->m_PerfectCapitalImagePath,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[0].charname);
				TRACE(_T("%s\n"),pathName);
			}
			else
			{
				pathName.Format(_T("%s%c.tif"),GetDocument()->m_PerfectImagePath,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[0].charname);
				TRACE(_T("%s\n"),pathName);
			}
			
			loadedImage = ImgLoadFromFile((LPCTSTR)pathName, 
			RUNTIME_CLASS(CDIAHiColorImage),
			NULL,
			RUNTIME_CLASS(CDIAGreyScale),
			RUNTIME_CLASS(CDIABiLevelImage));
			//paste it in m_pRecognizedImage
			for (int x = 0; x < loadedImage->GetWidth(); x++)
			{
				for (int y = 0; y < loadedImage->GetHeight(); y++)
				{
					//copy the pixels into the right position
					int xPos,yPos;
					xPos = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left + x;
					yPos = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top + y;
					int color = (int) GetRValue(loadedImage->GetRGBColor(x,y));
					//if ((x == 0) || (x == loadedImage->GetWidth()-1)|| (y == 0) || (y == loadedImage->GetHeight()-1))
					//{
					//	if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[0] == 1)
					//	{
					//		//green
					//			if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[2] == 1)
					//			{
					//				//red
					//				GetDocument()->GetActiveImage()->SetRGBColor(xPos,yPos,RGB(255,0,0));
					//			}else GetDocument()->GetActiveImage()->SetRGBColor(xPos,yPos,RGB(0,255,0));

					//	}else 
					//		if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[0] == 0)
					//		{
					//			//blue
					//			GetDocument()->GetActiveImage()->SetRGBColor(xPos,yPos,RGB(0,0,255));
					//		}
					//	
					//	
					//		
					//}
					//else 
						GetDocument()->GetActiveImage()->SetRGBColor(xPos,yPos,RGB(color,color,color));
					
				}
			}
		}
	}
	

}

void CDlgTestingEnvironment::OnBnClickedRecogniseTree()
{
	PerformRecognitionTree2(); 
	GetDocument()->m_bIsImageRecognized = true;
}


void CDlgTestingEnvironment::OnBnClickedRecogniseVector()
{
	PerformRecognitionVector();
	GetDocument()->m_bIsImageRecognized = true;
}


//void CDlgTestingEnvironment::RecogniseUsingProbabilities()
//{
//	if ((GetDocument()->m_bIsImageImproved) && (GetDocument()->m_bIsTableCreated))
//	{
//		//for each of the characters create a feature Vector
//			GetDocument()->CreateNewUndoImage(0);
//		for (int a = 0; a < GetDocument()->GetUndoImage(GetDocument()->m_index -1)->GetWidth(); a++)
//		{
//			for (int b = 0; b <  GetDocument()->GetUndoImage(GetDocument()->m_index -1)->GetHeight(); b++)
//			{
//				GetDocument()->GetUndoImage(GetDocument()->m_index -1)->SetRGBColor(a,b,RGB(255,255,255));
//			}
//		}
//		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
//		{
//			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
//			{
//				
//				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetDocument()->GetUndoImage(GetDocument()->m_index - 2),false);
//				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateLocatedCharImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,true);
//
//				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].Clear();
//				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ExtractFeatures();
//				CDIACharacter * character;
//				character = new CDIACharacter;
//			
//
//				character = &GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j];
//				CCharVector vector;
//				vector.CreateVectorFromCharacter(character);
//				float * prob = new float[GetDocument()->m_ProbabilityVectorIndex];
//				prob = CalculateProbabilities(vector);
//
//				//find best 3
//				int * highest = new int[3];
//				highest = FindHighest(prob,GetDocument()->m_ProbabilityVectorIndex);
//				//store the best 3 in the character holder
//				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[0].charname = GetDocument()->m_pProbabilityVector[highest[0]].GetCharName();
//				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[0].isCapital = GetDocument()->m_pProbabilityVector[highest[0]].GetCapital();
//				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[0].rate = prob[highest[0]];
//				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[1].charname = GetDocument()->m_pProbabilityVector[highest[1]].GetCharName();
//				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[1].isCapital = GetDocument()->m_pProbabilityVector[highest[1]].GetCapital();
//				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[1].rate = prob[highest[1]];
//				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[2].charname = GetDocument()->m_pProbabilityVector[highest[2]].GetCharName();
//				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[2].isCapital = GetDocument()->m_pProbabilityVector[highest[2]].GetCapital();
//				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[2].rate = prob[highest[2]];
//
//			}
//		}
//	}
//
//}
//int* CDlgTestingEnvironment::FindHighest(float * prob, int size)
//{
//	int * index = new int[3];
//	index[0] = -1;
//	index[1] = -1;
//	index[2] = -1;
//	float vals[3] = {0,0,0};
//	/*vals[0] = 0;
//	vals[1] = 0;
//	vals[2] = 0;*/
//	for(int i = 0; i < size; i++)
//	{
//		if (prob[i] >= vals[0])
//		{
//			//then it is the highest
//			//swift the other two values
//			vals[2] = vals[1];
//			index[2] = index[1];
//			vals[1] = vals[0];
//			index[1] = index[0];
//			vals[0] = prob[i];
//			index[0] = i;
//		}
//		else if (prob[i] >= vals[1])
//		{
//			//it is the second highest
//			vals[2] = vals[1];
//			index[2] = index[1];
//			vals[1] = prob[i];
//			index[1] = i;
//		}
//		else if (prob[i] > vals[2])
//		{
//			vals[2] = prob[i];
//			index[2] = i;
//		}
//	}
//	return index;
//
//}
//float * CDlgTestingEnvironment::CalculateProbabilities(CCharVector &vector)
//{
//	//calculates the probability for each character in the contingencyTable
//	//returns an array of with all the probabilities
//	float * resultsVector;
//	resultsVector = new float[GetDocument()->m_ProbabilityVectorIndex];
//	for (int i = 0; i < GetDocument()->m_ProbabilityVectorIndex; i++)
//	{
//		resultsVector[i] = 1.00;
//	}
//	
//	for (int i = 0; i < GetDocument()->m_ProbabilityVectorIndex; i++)
//	{
//		
//		//one for each feature
//			resultsVector[i] = resultsVector[i] * GetPobability(i, 0, vector.GetCharType());
//			resultsVector[i] = resultsVector[i] * GetPobability(i, 1, vector.GetVMax());
//			resultsVector[i] = resultsVector[i] * GetPobability(i, 2, vector.GetHMax());
//			resultsVector[i] = resultsVector[i] * GetPobability(i, 3, vector.GetWidth());
//			resultsVector[i] = resultsVector[i] * GetPobability(i, 4, vector.GetHeight());
//			resultsVector[i] = resultsVector[i] * GetPobability(i, 5, vector.GetAspectRatio());
//			resultsVector[i] = resultsVector[i] * GetPobability(i, 6, vector.GetDivision(0));
//			resultsVector[i] = resultsVector[i] * GetPobability(i, 7, vector.GetDivision(1));
//			resultsVector[i] = resultsVector[i] * GetPobability(i, 8, vector.GetDivision(2));
//			resultsVector[i] = resultsVector[i] * GetPobability(i, 9, vector.GetDivision(3));
//			resultsVector[i] = resultsVector[i] * GetPobability(i, 10, vector.GetDivision(4));
//			resultsVector[i] = resultsVector[i] * GetPobability(i, 11, vector.GetNoCrossingH());
//			resultsVector[i] = resultsVector[i] * GetPobability(i, 12, vector.GetNoCrossingV());
//			resultsVector[i] = resultsVector[i] * GetPobability(i, 13, vector.GetWeight());
//			resultsVector[i] = resultsVector[i] * GetPobability(i, 14, vector.GetNoHoles());
//			resultsVector[i] = resultsVector[i] * GetPobability(i, 15, vector.GetNoComponents());
//		
//	}
//	return resultsVector;
//
//	
//}
float CDlgTestingEnvironment::GetPobability(int charnum, int featureNo, int val)
{
	float prob;
	bool found = false;
	for (int i = 0; i < GetDocument()->m_ppContingencyTable[charnum].Features[featureNo].noOfValues; i++)
	{
		if (GetDocument()->m_ppContingencyTable[charnum].Features[featureNo].Values[i].val == val)
		{
			prob = (float)GetDocument()->m_ppContingencyTable[charnum].Features[featureNo].Values[i].count / (float)GetDocument()->m_ppContingencyTable[charnum].Features[featureNo].total;
			found = true;
		}

	}
	if (!found)
	{
		prob = 0.00;
	}
	return prob;
}
float CDlgTestingEnvironment::GetPobability(int charnum, int featureNo, float val)
{
	float prob;
	bool found = false;
	for (int i = 0; i < GetDocument()->m_ppContingencyTable[charnum].Features[featureNo].noOfValues; i++)
	{
		if ((float)GetDocument()->m_ppContingencyTable[charnum].Features[featureNo].Values[i].val == val)
		{
			prob = (float)GetDocument()->m_ppContingencyTable[charnum].Features[featureNo].Values[i].count / (float)GetDocument()->m_ppContingencyTable[charnum].Features[featureNo].total;
			found = true;
		}

	}
	if (!found)
	{
		prob = 0.00;
	}
	return prob;
}
void CDlgTestingEnvironment::OnBnClickedRecognizeflexible()
{
	PerformRecognition(3);
}

void CDlgTestingEnvironment::OnBnClickedTubbs1()
{
	// TODO: Add your control notification handler code here
	PerformRecognition(4);
}

void CDlgTestingEnvironment::OnBnClickedTubbs2()
{
	PerformRecognition(5);
}

void CDlgTestingEnvironment::OnBnClickedWeight()
{
	PerformRecognition(6);
}


CString CDlgTestingEnvironment::FindAddress2(char CharName, CString path,CString filename)
{
	FILE * pFile;
	char name, c;
	CString filePath;
	CString fullpath;
	int size;
	int loopCount = 0;
	//char * address;
	//char address2[200];
	//address = new char[200];
	filePath.Format(_T("%s%s"),path, filename);
	bool found = false;

	CString address3;
	if (_tfopen(filePath, _T("r")))
	{
		pFile = _tfopen(filePath, _T("r"));
		fscanf(pFile, "%d\n", &size);
		//find the char in the file
		while ((!found) && (loopCount < size))
		{
			loopCount++;
			fscanf(pFile,"%c", &name);
			
			if (name == CharName)
			{
				fscanf(pFile,"\t");
				char val = '0';
				while (val != '\n')
				{
					fscanf(pFile,"%c", &val);
					if (val != '\n')

					address3 = address3 + val;
				}

				//fgets( address, 200, pFile );
			//	fscanf(pFile,"%s\n",&address);
				found = true;
			}
			else
			{	
				c = '0';
				while (c != '\n')
				{
					fscanf(pFile,"%c",&c );//go to next line
				}
			}
		}
		fclose(pFile);
	}
	/*for (int i = 0; i < 200; i++)
	{
		address2[i] = address[i];
	}*/
	CString cadena;
	//char buffera[33] = "Esto es un arreglo de caracteres";
	/*for( i= 0; i < strlen(address2)-1; i++){

		cadena = cadena + address[i];
	}*/
	fullpath.Format(_T("%s"),address3);
	return fullpath;

}

CString CDlgTestingEnvironment::FindAddress3(char CharName)
{
	
	char name;
	
	CString fullpath;
	
	//char * address;
	
	int loopCount = 0;
	bool found = false;

	CString address3;
	
		//find the char in the file
		while ((!found) && (loopCount < GetDocument()->n_LocatedChars))
		{
			
			name = GetDocument()->m_CharAddresses[loopCount].charName;
			
			if (name == CharName)
			{
				/*int loop2 = 0;
				char val = '0';
				while (val != '\n')
				{
					val = GetDocument()->m_CharAddresses[loopCount].charAddress[loop2];
					loop2++;
					if (val != '\n') address3 = address3 + val;
				}*/
				fullpath = GetDocument()->m_CharAddresses[loopCount].charAddress;
				found = true;
			}
			
			loopCount++;
		}
		
	
	
	//fullpath.Format(_T("%s"),address3);
	return fullpath;

}
char CDlgTestingEnvironment::FindBestMatchUsingFeaturesTree3(CCharVector &vector, CImage * image, int Lineno, int charno)
{
	//get features and check the TreeArray
	//Then for each of the characters in the array pos do matching.
	int level1 = vector.GetCharType(); //type 
	int level2 = vector.GetWeight(); //weight
	int level3 = vector.GetHMax(); //h-max
	int level4 = 5;//vector.GetVMax();//v-max
	int level5 = 5;
	int level6 = 5;
	int level7 = 5;
	char minChar;
	CImage* loadedImage;
	CString ImagePath;
	CString filename;
	filename.Format(_T("PerfectCharsLocation.txt"));
	bool capital = false;
	
	CDocImAnDoc::ItemType Item;
	Item = GetDocument()->TreeArray[level1][level2][level3][level4][level5][level6][level7];
	BEST_CHAR * bestChars;
	if (Item.n_chars > 0)
	{
		bestChars = new BEST_CHAR[Item.n_chars];
		//check if is an error. in that case compare to all the chars of its type
		for (int i = 0; i < Item.n_chars; i++)
		{
			//open chars and match to given located char

			if (image != NULL)
			{
				
				//open image
				CString charaddress = FindAddress3(Item.pchars[i]);
					//open the perfect char image

					//do matching
				
				//TRACE(_T("%s\n"),ImagePath);
				//loadedImage = new CImage;
				loadedImage = ImgLoadFromFile((LPCTSTR)charaddress, 
				RUNTIME_CLASS(CDIAHiColorImage),
				NULL,
				RUNTIME_CLASS(CDIAGreyScale),
				RUNTIME_CLASS(CDIABiLevelImage));
				bestChars[i].charname = Item.pchars[i];
				
				int cost = GetDocument()->m_pCharVector[i]->CompareImageInVectorWeight(loadedImage,image);
				bestChars[i].rate = cost;
			}
		}
		//find lowest cost bestchar
		int minCost = bestChars[0].rate;
		minChar = bestChars[0].charname;
		for (int i = 1; i < Item.n_chars; i++)
		{
			if (bestChars[i].rate <= minCost)
			{
				minCost = bestChars[i].rate;
				minChar = bestChars[i].charname;
			}
		}
		delete bestChars;
		delete loadedImage;
	}
	else
	{
		minChar = '@';
	}
	
	return minChar;
}

char CDlgTestingEnvironment::FindBestMatchUsingProbability2(CCharVector &vector, CImage * image, int level, int &getcost)
{
	//For all characters find if it is probable they are of the same class
	//If probability > 0 then add to the matching list
	char minChar;
	int minCost;
	//CImage* loadedImage;
	CString ImagePath;
	
	CString bar;
	bar.Format(_T("---------------"));
	CString text;

	bool capital = false;
	CDlgTestingEnvironment::BEST_CHAR bestChars[100];

	int n_bestChars = 0;
	int cost;

	bestChars[0].rate = 1000000000;
	bestChars[0].charname = '@';
	CString pathName;
	pathName.Format(_T("%sPossibleChars.txt"),GetDocument()->GetActiveImage()->GetName());
	FILE * pFile;
	pFile = _tfopen(pathName, _T("a"));
	if (GetDocument()->m_ProbabilityVectorIndex > 0 )
	{
		n_bestChars = 0;
		for (int i = 0; i < GetDocument()->m_ProbabilityVectorIndex; i++)
		{
			if (level == 0)
			{
				cost = FindCost(image,GetDocument()->m_pProbabilityVector[i].GetCharName(),6);
											
				bestChars[n_bestChars].rate = cost;
				bestChars[n_bestChars].charname = GetDocument()->m_pProbabilityVector[i].GetCharName();
				n_bestChars++;
			}
			else
			if (GetPobability(i, 0, vector.GetCharType()) > 0)
			{
				if ( level > 1) 
				{
					if (GetPobability(i, 8, vector.GetWeight()) > 0)
					{
						if (level > 2)
						{
							if (GetPobability(i, 2, vector.GetHMax()) > 0)
							{
								if (level > 3)
								{
									if (GetPobability(i, 1, vector.GetVMax()) > 0)
									{
										if (level > 4)
										{
											//we will see
											//level 4
											cost = FindCost(image,GetDocument()->m_pProbabilityVector[i].GetCharName(),6);	
											bestChars[n_bestChars].rate = cost;
											bestChars[n_bestChars].charname = GetDocument()->m_pProbabilityVector[i].GetCharName();
											n_bestChars++;
										}
										else
										{
											//level 4
											cost = FindCost(image,GetDocument()->m_pProbabilityVector[i].GetCharName(),6);
											bestChars[n_bestChars].rate = cost;
											bestChars[n_bestChars].charname = GetDocument()->m_pProbabilityVector[i].GetCharName();
											n_bestChars++;
										}
									
									}
								}
								else
								{
									//level 3
									cost = FindCost(image,GetDocument()->m_pProbabilityVector[i].GetCharName(),6);
									bestChars[n_bestChars].rate = cost;
									bestChars[n_bestChars].charname = GetDocument()->m_pProbabilityVector[i].GetCharName();
									n_bestChars++;
								}
							}
						}
						else
						{
							//level 2
							cost = FindCost(image,GetDocument()->m_pProbabilityVector[i].GetCharName(),6);
							bestChars[n_bestChars].rate = cost;
							bestChars[n_bestChars].charname = GetDocument()->m_pProbabilityVector[i].GetCharName();
							n_bestChars++;
						}
					}
				}
				else
				{
					//try to match to this char
					//level 1
					cost = FindCost(image,GetDocument()->m_pProbabilityVector[i].GetCharName(),6);
					bestChars[n_bestChars].rate = cost;
					bestChars[n_bestChars].charname = GetDocument()->m_pProbabilityVector[i].GetCharName();
					n_bestChars++;
				}
			}
		}
	
	fprintf(pFile,"Exporting Character Matches\n");
	fprintf(pFile,"-----------------------------------------------------------------\n");
	
	minCost = bestChars[0].rate;
	minChar = bestChars[0].charname;
	for (int i = 0; i < n_bestChars; i++)
	{
		//display result of matched chars
		//text.Format(_T("Char = %c,cost: %d"),bestChars[i].charname,bestChars[i].rate);
		//m_DetailsList.AddString((LPCTSTR) text);
		fprintf(pFile,"Character %c ||| Cost %d\n", bestChars[i].charname, bestChars[i].rate);
	//	fprintf(pFile,"-----------------------------------------------------------------\n");
		TRACE(_T("Char = %c || cost = %i \n"),bestChars[i].charname, bestChars[i].rate);
		if (bestChars[i].rate <= minCost)
		{

			minCost = bestChars[i].rate;
			minChar = bestChars[i].charname;
		}
	}
	//delete bestChars;

	}
	else
	{
		minChar = '@';
	} 
	fprintf(pFile,"-----------------------------------------------------------------\n");
	fprintf(pFile,"Best Char = %c ||| Cost %d\n",minChar, minCost);
	fprintf(pFile,"-----------------------------------------------------------------\n");
	fclose(pFile);
	//display best char results
	//m_DetailsList.AddString((LPCTSTR) bar);
	//text.Format(_T("BestChar = %c,cost: %d"),minChar,minCost);
	//m_DetailsList.AddString((LPCTSTR) text);
	//m_DetailsList.AddString((LPCTSTR) bar);
	TRACE(_T("------------------------------------------------\n"));
	TRACE(_T("Best Char = %c || cost = %i \n"),minChar,minCost);
	getcost = minCost;
	return minChar;


}

////
////quicksort
//void CDlgTestingEnvironment::quicksort(CDlgTestingEnvironment::BEST_CHAR &array, int top, int bottom)
//{
//      // top = subscript of beginning of vector being considered
//      // bottom = subscript of end of vector being considered
//      // this process uses recursion - the process of calling itself
//     int middle;
//     if (top < bottom)
//    {
//          middle = partition(array, top, bottom);
//          quicksort(array, top, middle);   // sort top partition
//          quicksort(array, middle+1, bottom);    // sort bottom partition
//     }
//     return;
//}
//
//
////Function to determine the partitions
//// partitions the array and returns the middle index (subscript)
//int CDlgTestingEnvironment::partition(BEST_CHAR &array, int top, int bottom)
//{
//     int x = array[top];
//     int i = top - 1;
//     int j = bottom + 1;
//     int temp;
//     do
//     {
//           do      
//           {
//                  j - -;
//           }while (x >array[j]);
//
//          do  
//         {
//                 i++;
//          } while (x <array[i]);
//
//          if (i < j)
//         { 
//                 temp = array[i];    // switch elements at positions i and j
//                 array[i] = array[j];
//                 array[j] = temp;
//         }
//     }while (i < j);     
//     return j;           // returns middle index 
//}
//
//
//
////







char CDlgTestingEnvironment::FindBestMatchUsingProbability(CCharVector &vector, CImage * image, int level, bool &confident,int &getcost)
{
	//For all characters find if it is probable they are of the same class
	//If probability > 0 then add to the matching list
	char minChar;
	int minCost;
	char minChar2;
	int minCost2;
	char minChar3;
	int minCost3;
	float average = 0;
	//CImage* loadedImage;
	CString ImagePath;
	
	CString bar;
	bar.Format(_T("---------------"));
	CString text;

	bool capital = false;
	BEST_CHAR bestChars[100];

	int n_bestChars = 0;
	int cost;
	CString pathName;
	bestChars[0].rate = 1000000000;
	bestChars[0].charname = '@';
	pathName.Format(_T("%sPossibleChars.txt"),GetDocument()->GetActiveImage()->GetName());
	FILE * pFile;
	pFile = _tfopen(pathName, _T("a"));
	if (GetDocument()->m_ProbabilityVectorIndex > 0 )
	{
		n_bestChars = 0;
		for (int i = 0; i < GetDocument()->m_ProbabilityVectorIndex; i++)
		{
			if (level == 0)
			{
				cost = FindCost(image,GetDocument()->m_pProbabilityVector[i].GetCharName(),6);
											
				bestChars[n_bestChars].rate = cost;
				bestChars[n_bestChars].charname = GetDocument()->m_pProbabilityVector[i].GetCharName();
				n_bestChars++;
			}
			else
			if (GetPobability(i, 0, vector.GetCharType()) > 0)
			{
				if ( level > 1) 
				{
					if (GetPobability(i, 8, vector.GetWeight()) > 0)
					{
						if (level > 2)
						{
							if (GetPobability(i, 2, vector.GetHMax()) > 0)
							{
								if (level > 3)
								{
									if (GetPobability(i, 1, vector.GetVMax()) > 0)
									{
										if (level > 4)
										{
											//we will see
											//level 4
											cost = FindCost(image,GetDocument()->m_pProbabilityVector[i].GetCharName(),6);
											
											bestChars[n_bestChars].rate = cost;
											bestChars[n_bestChars].charname = GetDocument()->m_pProbabilityVector[i].GetCharName();
											n_bestChars++;
										}
										else
										{
											//level 4
											cost = FindCost(image,GetDocument()->m_pProbabilityVector[i].GetCharName(),6);
											bestChars[n_bestChars].rate = cost;
											bestChars[n_bestChars].charname = GetDocument()->m_pProbabilityVector[i].GetCharName();
											n_bestChars++;
										}
									
									}
								}
								else
								{
									//level 3
									cost = FindCost(image,GetDocument()->m_pProbabilityVector[i].GetCharName(),6);
									bestChars[n_bestChars].rate = cost;
									bestChars[n_bestChars].charname = GetDocument()->m_pProbabilityVector[i].GetCharName();
									n_bestChars++;
								}
							}
						}
						else
						{
							//level 2
							cost = FindCost(image,GetDocument()->m_pProbabilityVector[i].GetCharName(),6);
							bestChars[n_bestChars].rate = cost;
							bestChars[n_bestChars].charname = GetDocument()->m_pProbabilityVector[i].GetCharName();
							n_bestChars++;
						}
					}
				}
				else
				{
					//try to match to this char
					//level 1
					cost = FindCost(image,GetDocument()->m_pProbabilityVector[i].GetCharName(),6);
					bestChars[n_bestChars].rate = cost;
					bestChars[n_bestChars].charname = GetDocument()->m_pProbabilityVector[i].GetCharName();
					n_bestChars++;
				}
			}
		}
	fprintf(pFile,"Exporting Character Matches\n");
	//fprintf(pFile,"-----------------------------------------------------------------\n");
	minCost2 = 10000;
	minChar2 = bestChars[0].charname;
	minCost3 = 10000;
	minChar3 = bestChars[0].charname;
	minCost = 10000;
	minChar = bestChars[0].charname;
	
	for (int i = 0; i < n_bestChars; i++)
	{
		//display result of matched chars
		//text.Format(_T("Char = %c,cost: %d"),bestChars[i].charname,bestChars[i].rate);
		//m_DetailsList.AddString((LPCTSTR) text);
		int difference;
		if (i < n_bestChars-1)
		{
			difference = bestChars[i+1].rate - bestChars[i].rate;
		}
		else 
		{
			difference = 0;
		}
		//	average += difference;
		fprintf(pFile,"Character,%c, Cost ,%d\n", bestChars[i].charname, bestChars[i].rate);
		//fprintf(pFile,"-----------------------------------------------------------------\n");
		TRACE(_T("Char = %c || cost = %i \n"),bestChars[i].charname, bestChars[i].rate);

		if (bestChars[i].rate <= minCost3)
		{
			if (bestChars[i].rate <= minCost2)
			{
				if (bestChars[i].rate <= minCost)
				{
					minCost3 = minCost2;
					minChar3 = minChar2;
					minCost2 = minCost;
					minChar2 = minChar;
					minCost = bestChars[i].rate;
					minChar = bestChars[i].charname;
					
				}
				else
				{
					minCost3 = minCost2;
					minChar3 = minChar2;
					minCost2 = bestChars[i].rate;
					minChar2 = bestChars[i].charname;

				}
			}
			else
			{
				minCost3 = bestChars[i].rate;
				minChar3 = bestChars[i].charname;
			}
		}
	}
	//delete bestChars;

	}
	else
	{
		minChar = '@';
	}

	//find if the first and second have a close distance
	int distance1, distance2;
	char goodchar;

	distance1 = minCost2 - minCost;
	distance2 = minCost3 - minCost2;
	//average = average/(n_bestChars-1);
	
	if (distance1 < (0.16 * minCost))
	{
		goodchar = 'F';
		confident = false;
	}
	else
	{	
		goodchar = 'T';
		confident = true;

	}

	fprintf(pFile,"-----------------------------------------------------------------\n");
	fprintf(pFile,"Best Char = ,%c, ||| Cost ,%d,%d,%d,TRUE,%c\n",minChar, minCost,distance1,distance2,goodchar);
	fprintf(pFile,"-----------------------------------------------------------------\n");
	fclose(pFile);
	//display best char results
	//m_DetailsList.AddString((LPCTSTR) bar);
	//text.Format(_T("BestChar = %c,cost: %d"),minChar,minCost);
	//m_DetailsList.AddString((LPCTSTR) text);
	//m_DetailsList.AddString((LPCTSTR) bar);
	TRACE(_T("------------------------------------------------"));
	TRACE(_T("Best Char = %c || cost = %i \n"),minChar,minCost);
	
	

	return minChar;
}

//char CDlgTestingEnvironment::FindBestMatchUsingProbability(CCharVector &vector, CImage * image, int level, bool confident)
//{
//	//For all characters find if it is probable they are of the same class
//	//If probability > 0 then add to the matching list
//	char minChar;
//	int minCost;
//	char minChar2;
//	int minCost2;
//	char minChar3;
//	int minCost3;
//	float average = 0;
//	//CImage* loadedImage;
//	CString ImagePath;
//	
//	CString bar;
//	bar.Format(_T("---------------"));
//	CString text;
//
//	bool capital = false;
//	BEST_CHAR bestChars[100];
//
//	int n_bestChars = 0;
//	int cost;
//	CString pathName;
//	bestChars[0].rate = 1000000000;
//	bestChars[0].charname = '@';
//	pathName.Format(_T("%s\\PossibleChars.txt"),GetDocument()->m_ClassifiedCharsPath);
//	FILE * pFile;
//	pFile = _tfopen(pathName, _T("a"));
//	if (GetDocument()->m_ProbabilityVectorIndex > 0 )
//	{
//		n_bestChars = 0;
//		for (int i = 0; i < GetDocument()->m_ProbabilityVectorIndex; i++)
//		{
//			if (level == 0)
//			{
//				cost = FindCost(image,GetDocument()->m_pProbabilityVector[i].GetCharName(),6);
//											
//				bestChars[n_bestChars].rate = cost;
//				bestChars[n_bestChars].charname = GetDocument()->m_pProbabilityVector[i].GetCharName();
//				n_bestChars++;
//			}
//			else
//			if (GetPobability(i, 0, vector.GetCharType()) > 0)
//			{
//				if ( level > 1) 
//				{
//					if (GetPobability(i, 8, vector.GetWeight()) > 0)
//					{
//						if (level > 2)
//						{
//							if (GetPobability(i, 2, vector.GetHMax()) > 0)
//							{
//								if (level > 3)
//								{
//									if (GetPobability(i, 1, vector.GetVMax()) > 0)
//									{
//										if (level > 4)
//										{
//											//we will see
//											//level 4
//											cost = FindCost(image,GetDocument()->m_pProbabilityVector[i].GetCharName(),6);
//											
//											bestChars[n_bestChars].rate = cost;
//											bestChars[n_bestChars].charname = GetDocument()->m_pProbabilityVector[i].GetCharName();
//											n_bestChars++;
//										}
//										else
//										{
//											//level 4
//											cost = FindCost(image,GetDocument()->m_pProbabilityVector[i].GetCharName(),6);
//											bestChars[n_bestChars].rate = cost;
//											bestChars[n_bestChars].charname = GetDocument()->m_pProbabilityVector[i].GetCharName();
//											n_bestChars++;
//										}
//									
//									}
//								}
//								else
//								{
//									//level 3
//									cost = FindCost(image,GetDocument()->m_pProbabilityVector[i].GetCharName(),6);
//									bestChars[n_bestChars].rate = cost;
//									bestChars[n_bestChars].charname = GetDocument()->m_pProbabilityVector[i].GetCharName();
//									n_bestChars++;
//								}
//							}
//						}
//						else
//						{
//							//level 2
//							cost = FindCost(image,GetDocument()->m_pProbabilityVector[i].GetCharName(),6);
//							bestChars[n_bestChars].rate = cost;
//							bestChars[n_bestChars].charname = GetDocument()->m_pProbabilityVector[i].GetCharName();
//							n_bestChars++;
//						}
//					}
//				}
//				else
//				{
//					//try to match to this char
//					//level 1
//					cost = FindCost(image,GetDocument()->m_pProbabilityVector[i].GetCharName(),6);
//					bestChars[n_bestChars].rate = cost;
//					bestChars[n_bestChars].charname = GetDocument()->m_pProbabilityVector[i].GetCharName();
//					n_bestChars++;
//				}
//			}
//		}
//	fprintf(pFile,"Exporting Character Matches\n");
//	//fprintf(pFile,"-----------------------------------------------------------------\n");
//	minCost2 = 10000;
//	minChar2 = bestChars[0].charname;
//	minCost3 = 10000;
//	minChar3 = bestChars[0].charname;
//	minCost = 10000;
//	minChar = bestChars[0].charname;
//	
//	for (int i = 0; i < n_bestChars; i++)
//	{
//		//display result of matched chars
//		//text.Format(_T("Char = %c,cost: %d"),bestChars[i].charname,bestChars[i].rate);
//		//m_DetailsList.AddString((LPCTSTR) text);
//		int difference;
//		if (i < n_bestChars-1)
//		{
//			difference = bestChars[i+1].rate - bestChars[i].rate;
//		}
//		else 
//		{
//			difference = 0;
//		}
//		//	average += difference;
//		fprintf(pFile,"Character,%c, Cost ,%d\n", bestChars[i].charname, bestChars[i].rate);
//		//fprintf(pFile,"-----------------------------------------------------------------\n");
//		TRACE(_T("Char = %c || cost = %i \n"),bestChars[i].charname, bestChars[i].rate);
//	
//	//minCost = bestChars[0].rate;
//	//minChar = bestChars[0].charname;
//	//for (int i = 0; i < n_bestChars; i++)
//	//{
//	//	//display result of matched chars
//	//	text.Format(_T("Char = %c,cost: %d"),bestChars[i].charname,bestChars[i].rate);
//	//	m_DetailsList.AddString((LPCTSTR) text);
//
//		if (bestChars[i].rate <= minCost3)
//		{
//			if (bestChars[i].rate <= minCost2)
//			{
//				if (bestChars[i].rate <= minCost)
//				{
//					minCost3 = minCost2;
//					minChar3 = minChar2;
//					minCost2 = minCost;
//					minChar2 = minChar;
//					minCost = bestChars[i].rate;
//					minChar = bestChars[i].charname;
//					
//				}
//				else
//				{
//					minCost3 = minCost2;
//					minChar3 = minChar2;
//					minCost2 = bestChars[i].rate;
//					minChar2 = bestChars[i].charname;
//
//				}
//			}
//			else
//			{
//				minCost3 = bestChars[i].rate;
//				minChar3 = bestChars[i].charname;
//			}
//		}
//	}
//	//delete bestChars;
//
//	}
//	else
//	{
//		minChar = '@';
//	}
//
//	//find if the first and second have a close distance
//	int distance1, distance2;
//	char goodchar;
//
//	distance1 = minCost2 - minCost;
//	distance2 = minCost3 - minCost2;
//	//average = average/(n_bestChars-1);
//	if (distance1 < distance2)
//	{
//		goodchar = 'F';
//	}
//	else
//	{
//		goodchar = 'T';
//	}
//
//	fprintf(pFile,"-----------------------------------------------------------------\n");
//	fprintf(pFile,"Best Char = ,%c, ||| Cost ,%d,%d,%d,TRUE,%c\n",minChar, minCost,distance1,distance2,goodchar);
//	fprintf(pFile,"-----------------------------------------------------------------\n");
//	fclose(pFile);
//	//display best char results
//	//m_DetailsList.AddString((LPCTSTR) bar);
//	//text.Format(_T("BestChar = %c,cost: %d"),minChar,minCost);
//	//m_DetailsList.AddString((LPCTSTR) text);
//	//m_DetailsList.AddString((LPCTSTR) bar);
//	TRACE(_T("------------------------------------------------"));
//	TRACE(_T("Best Char = %c || cost = %i \n"),minChar,minCost);
//	//display best char results
//	m_DetailsList.AddString((LPCTSTR) bar);
//	text.Format(_T("BestChar = %c,cost: %d"),minChar,minCost);
//	m_DetailsList.AddString((LPCTSTR) text);
//	m_DetailsList.AddString((LPCTSTR) bar);
//
//	return minChar;
//}
void CDlgTestingEnvironment::OnBnClickedRecProbability()
{
	PerformProbabilityRecognition(6,3);
}

void CDlgTestingEnvironment::OnBnClickedButton4()
{
	PerformProbabilityRecognition(6,0);
}

void CDlgTestingEnvironment::OnBnClickedButton6()
{
	PerformProbabilityRecognition(6,1);
}


void CDlgTestingEnvironment::OnBnClickedButton5()
{
	PerformProbabilityRecognition(6,2);
}
