#include "DocImAnDoc.h"
#include "afxwin.h"
#pragma once


// CDlgTestingEnvironment dialog

class CDlgTestingEnvironment : public CDialog
{
	DECLARE_DYNAMIC(CDlgTestingEnvironment)

public:

	typedef struct BEST_CHAR
	{	
		int rate;
		char charname;
		bool isCapital;

	};
	CDlgTestingEnvironment(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDlgTestingEnvironment();
	void	SetDocument(CDocImAnDoc *pDoc);
	void	DisplayImage(CStatic &Wind,CImage* Image);
	CDocImAnDoc* GetDocument();
	char FindBestMatch(CImage* image);
	bool FindBestMatch(CImage* image,int type,int MatchingType, int Lineno, int charno);
	int FindCost(CImage* image,char charName,int MatchingType);
	bool FindBestMatchUsingFeaturesTree(CCharVector &vector, int Lineno, int charno);
	bool FindBestMatchUsingFeaturesTree(CCharVector &vector, CImage * image, int Lineno, int charno);
	bool FindBestMatchUsingFeaturesTree2(CCharVector &vector, CImage * image, int Lineno, int charno);
	char FindBestMatchUsingFeaturesTree3(CCharVector &vector, CImage * image, int Lineno, int charno);
	void FindBestMatchUsingFeaturesVector(CCharVector &vector, CImage* image, int Lineno, int charno);
	char FindBestMatchUsingProbability(CCharVector &vector, CImage * image, int level, bool &confident,int &getcost);
	char FindBestMatchUsingProbability2(CCharVector &vector, CImage * image, int level, int &cost);
	void ApplyRecognisedChar(CImage *image, char charName, int LinePos, int CharPos);
	void CDlgTestingEnvironment::ApplyRecognisedChar(CImage *image, char charName, int LinePos, int CharPos, bool confident);
	void ApplyNewCharImage(CImage *Outimage, CImage * charImage, int LinePos, int CharPos);
	void GetNextChar();
	void GetPreviousChar();
	void PerformRecognition(int MatchingType);
	void PerformProbabilityRecognition(int MatchingType, int level);
	void PerformRecognitionTree();
	void PerformRecognitionTree2();
	void PerformRecognitionVector();
	//void PerformRecognition();
	void DisplayRecognitionInList(char bestChar);
	void RecognitionRateEvaluation(char bestchar,int bestcharcost, char secondchar, int secondcharcost, char thirdchar, int thirdcharcost, int chartype);
	//void insertPercentInOrder(int value, char cchar);
	void insertPercentInOrder(int value, char cchar, bool isCapital);
	void CalculateRecognitionRate(int Lineno, int charno);
	CString FindAddress2(char CharName, CString path,CString filename);
	CString FindAddress3(char CharName);
	/*float * CalculateProbabilities(CCharVector &vector);
	void RecogniseUsingProbabilities();*/
	float GetPobability(int charnum, int featureNo, int val);
	float GetPobability(int charnum, int featureNo, float val);
	//int * FindHighest(float * prob, int size);
	//bool FindBestMatchUsingFeatures(CImage* image,int type,int weight);
	int	CalculateAverageBase(int line);
	void quicksort(CDlgTestingEnvironment::BEST_CHAR &array, int top, int bottom);
	int partition(CDlgTestingEnvironment::BEST_CHAR &array, int top, int bottom);
	
	

	//void ClassifyAndMatch();

// Dialog Data
	enum { IDD = IDD_DIALOG3 };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

private:
	CDocImAnDoc *m_pDoc;
	CImage* m_pBlindCharImage;
	bool m_bDisplayRecognizedImage;
	bool m_ShowOnlyOneChar;
	bool m_bOpenChar;
	bool m_bIsCapital;
	//char m_bestChar;
	//int m_bestChars[3];
	CList <int,int> m_bestPercentList;
	//int m_bestPercentages[10];
	//char m_bestCharsPercent[10];

	
	BEST_CHAR m_BestPercentages[10];
	int m_minCost;
	int m_CurrentDisplayChar;
	int m_CurrentDisplayLine;
	char m_CurrentBestChar;
	//char m_SecondBestChar;
	//char m_ThirdBestChar;
	int m_CharRecognitionRate[3];
	BEST_CHAR m_BestChars[3];

	
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedComputeWeightVector();
	virtual BOOL OnInitDialog();
protected:
	virtual void OnOK();
public:
	afx_msg void OnBnClickedFindBestMatch();
	afx_msg void OnBnClickedGetChar();
	CStatic m_InputChar;
	CStatic m_RecognizedChar;
	CListBox m_DetailsList;
	afx_msg void OnPaint();
	afx_msg void OnBnClickedGetImage2();
	CButton m_Previous;
	CButton m_Next;
	afx_msg void OnBnClickedNext();
	afx_msg void OnBnClickedPrevious();
	afx_msg void OnBnClickedFindBestMatch2();
	afx_msg void OnBnClickedTestvector();
	afx_msg void OnBnClickedRecognizeWholeImage2();
	afx_msg void OnBnClickedTestvector2();
	afx_msg void OnBnClickedRecognizeGravity();
	afx_msg void OnBnClickedCancel();
	afx_msg void OnBnClickedRecognizegrav();
	afx_msg void OnBnClickedRecogniseTree();
	afx_msg void OnBnClickedRecogniseVector();
	afx_msg void OnBnClickedRecognizeflexible();
	afx_msg void OnBnClickedTubbs1();
	afx_msg void OnBnClickedTubbs2();
	afx_msg void OnBnClickedWeight();
	afx_msg void OnBnClickedRecProbability();
	afx_msg void OnBnClickedButton4();
	afx_msg void OnBnClickedButton6();
	afx_msg void OnBnClickedButton5();
};
