// DocImAnDoc.cpp : implementation of the CDocImAnDoc class
//

#include "stdafx.h"
#include "DocImAn.h"
#include <iostream>
#include <fstream>
using namespace std;

#include "DocImAnDoc.h"
#include "DocImAnView.h"

#include "TextLine.h"
#include "DIAHiColorImage.h"
#include "DIALoColorImage.h"
#include "DIABiLevelImage.h"
#include "DIAGreyScale.h"
#include "CharVector.h"
#include "ClassList.h"



#include ".\docimandoc.h"
#include "MainFrm.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//#include <fuzzy_engine_h.h>
//#pragma comment(lib,"fuzzy_dll.lib")		//were the fuzzy AI engine is

class CTextLine;
// CDocImAnDoc

IMPLEMENT_DYNCREATE(CDocImAnDoc, CDocument)

BEGIN_MESSAGE_MAP(CDocImAnDoc, CDocument)
	ON_COMMAND(ID_FILE_IMPORTIMAGE, OnFileImportimage)
	ON_COMMAND(ID_FILE_EXPORTIMAGE, OnFileExportimage)
	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDO, OnUpdateEditUndo)
	ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
END_MESSAGE_MAP()


// CDocImAnDoc construction/destruction

CDocImAnDoc::CDocImAnDoc()
{
	m_pImage = NULL;
	m_pLineHolder = NULL;
	//m_pLineHolder2 = NULL;
	m_LineHolderIndex = 0;
	m_pUndoImage = new CImage* [10];
	m_index=0;
	m_ShowFix = false;
	m_ShowInBox = false;
	m_IsCharSegmented = false;
	m_bIsLineSegmented = false;
	m_bIsImageImproved = false;
	m_bIsHistoStretched = false;
	m_pCharVector = NULL;
	m_CharVectorIndex = 0;
	m_pCharCapitalVector = NULL;
	m_CharCapitalVectorIndex = 0;
	//m_pProbabilityVector = NULL;
	is_charAddress = false;

}

CDocImAnDoc::~CDocImAnDoc()
{
	ClearDocument();
}

BOOL CDocImAnDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

		DeleteUndoList();
		m_pImage = NULL;
		if (m_pLineHolder != NULL)
		{
			delete[] m_pLineHolder;
			m_pLineHolder = NULL;
		}
		
		
		m_LineHolderIndex = 0;
		m_ShowFix = false;
		m_IsCharLocalized = FALSE;

	m_pImage = NULL;
	m_pLineHolder = NULL;
//	m_pLineHolder2 = NULL;
	m_LineHolderIndex = 0;
	m_ShowFix = false;
	m_IsCharLocalized = false;
	m_bIsPreprocessed = false;
	m_bIsImageRecognized = false;
	m_bIsImageImproved = false;
	m_bIsTableCreated = false;
	m_bNeedSaveClassifier = false;
	m_bIsHistoStretched = false;
	m_ImportedGroundTruth = false;
	//m_pProbabilityVector = NULL;
	m_ProbabilityVectorIndex = 0;
	m_2DCharPlot = NULL;
	m_2DCharPlotType = NULL;
	m_pImage = NULL;
	m_pLineHolder = NULL;
	//m_pLineHolder2 = NULL;
	m_LineHolderIndex = 0;
	m_pUndoImage = new CImage* [10];
	m_index=0;
	m_ShowFix = false;
	m_ShowInBox = false;
	m_IsCharSegmented = false;
	m_bIsLineSegmented = false;
	m_bIsImageImproved = false;
	m_bIsHistoStretched = false;
	m_pCharVector = NULL;
	m_CharVectorIndex = 0;
	m_pCharCapitalVector = NULL;
	m_CharCapitalVectorIndex = 0;
	//m_pProbabilityVector = NULL;
	
	
	// (SDI documents will reuse this document)

	//path in Liverpool

	m_PerfectCharactersLocation.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Original Characters\\Perfect Set\\"));
	//m_PerfectImagePath.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Original Characters\\Perfect Set\\PerfectCharsModified\\"));
	//m_PerfectCapitalImagePath.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Original Characters\\Perfect Set\\PerfectCharsModified\\Capitals\\"));
	m_ImagePath.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Original Characters\\Perfect Set\\PerfectCharacter")); 
	m_CharFilePath.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Original Characters\\Perfect Set\\PerfectCharactersVector.csv"));
	m_CapitalsFilePath.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Original Characters\\Perfect Set\\PerfectCapitalsVector.csv"));
	m_RecognizedImagePath.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Original Characters\\Perfect Set\\Recognized Images\\"));
	m_ExportedCharsPath.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Original Characters\\Perfect Set\\Exported Images\\"));
	m_ClassifiedCharsPath.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Original Characters\\Perfect Set\\Classifier\\"));
	m_ClassifierFilePath.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Original Characters\\Perfect Set\\Classifier\\Classifier.csv"));
	m_TreePathName.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Original Characters\\Perfect Set\\Tree2.txt"));
	m_CharLocationFile.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Original Characters\\Perfect Set\\PerfectCharsLocation3.txt"));

	m_PerfectImagePath.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Original Characters\\Perfect Set\\PerfectChars2\\"));
	m_PerfectCapitalImagePath.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Original Characters\\Perfect Set\\PerfectChars2\\Capitals\\"));
	

	//Path in Salford
	/*m_PerfectCharactersLocation.Format(_T("C:\\Documents and Settings\\Celia.APHRODITE\\My Documents\\Memorial Images\\Perfect Set\\"));
	m_PerfectImagePath.Format(_T("C:\\Documents and Settings\\Celia.APHRODITE\\My Documents\\Memorial Images\\Perfect Set\\PerfectChars\\"));
	m_ImagePath.Format(_T("C:\\Documents and Settings\\Celia.APHRODITE\\My Documents\\Memorial Images\\Perfect Set\\PerfectCharacter")); 
	m_CharFilePath.Format(_T("C:\\Documents and Settings\\Celia.APHRODITE\\My Documents\\Memorial Images\\Perfect Set\\PerfectCharactersVector.csv"));
	m_RecognizedImagePath.Format(_T("C:\\Documents and Settings\\Celia.APHRODITE\\My Documents\\Memorial Images\\Perfect Set\\Recognized Images\\"));
	m_CapitalsFilePath.Format(_T("C:\\Documents and Settings\\Celia.APHRODITE\\My Documents\\Memorial Images\\Perfect Set\\PerfectCapitalsVector.csv"));
	m_PerfectCapitalImagePath.Format(_T("C:\\Documents and Settings\\Celia.APHRODITE\\My Documents\\Memorial Images\\Perfect Set\\PerfectChars\\Capitals\\"));
	m_ExportedCharsPath.Format(_T("C:\\Documents and Settings\\Celia.APHRODITE\\My Documents\\Memorial Images\\Perfect Set\\Exported Images\\"));
	m_ClassifiedCharsPath.Format(_T("C:\\Documents and Settings\\Celia.APHRODITE\\My Documents\\Memorial Images\\Perfect Set\\Classifier\\"));
	m_ClassifierFilePath.Format(_T("C:\\Documents and Settings\\Celia.APHRODITE\\My Documents\\Memorial Images\\Perfect Set\\Classifier\\Classifier.csv"));
	m_TreePathName.Format(_T("C:\\Documents and Settings\\Celia.APHRODITE\\My Documents\\Memorial Images\\Perfect Set\\Tree2.txt"));
	m_CharLocationFile.Format(_T("C:\\Documents and Settings\\Celia.APHRODITE\\My Documents\\Memorial Images\\Perfect Set\\PerfectCharsLocationSalford.txt"));
	*///
	//int numberOfFuzzyEngines = 2;
	//InitDLL(numberOfFuzzyEngines);
	//

	ItemType item;
	item.n_chars = 0;
	//item.Name = "empty";
	item.level = -1;
	item.value = '';
	
	//initialise CClassList::ItemType TreeArray[5][5][5][5][5][5][5];
	
	//for (int i = 0; i < 6; i++)
	//{
	//	for (int j = 0; j < 6; j++)
	//	{
	//		for (int k = 0; k < 6; k++)
	//		{
	//			for (int l = 0; l < 6; l++)
	//			{
	//				for (int m = 0; m < 6; m++)
	//				{
	//					for (int n = 0; n < 6; n++)
	//					{
	//						for (int o = 0; o < 6; o++)
	//						{
	//							TreeArray[i][j][k][l][m][n][o] = item;
	//						}
	//					}
	//				}
	//			}
	//		}
	//	}
	//}
	//CreateClassTree();
	if (!is_charAddress)
	{
		CreateCharLocationFile();
	}
//	ImportClassifier();




	m_FTR_Statistics.correct_in_blue = 0;
	m_FTR_Statistics.correct_in_red = 0;
	m_FTR_Statistics.incorrect_but_second = 0;
	m_FTR_Statistics.incorrect_in_blue = 0;
	m_FTR_Statistics.incorrect_in_red = 0;
	m_FTR_Statistics.total_correct = 0;
	m_FTR_Statistics.total_chars = 0;
	m_FTR_Statistics.total_incorrect = 0;
	m_FTR_Statistics.total_noise = 0;
	m_FTR_Statistics.missed_chars = 0;
	
	m_Refined2_Statistics.correct_in_blue = 0;
	m_Refined2_Statistics.correct_in_red = 0;
	m_Refined2_Statistics.incorrect_but_second = 0;
	m_Refined2_Statistics.incorrect_in_blue = 0;
	m_Refined2_Statistics.incorrect_in_red = 0;
	m_Refined2_Statistics.total_correct = 0;
	m_Refined2_Statistics.total_chars = 0;
	m_Refined2_Statistics.total_incorrect = 0;
	m_Refined2_Statistics.total_noise = 0;
	m_Refined2_Statistics.missed_chars = 0;

	m_Refined1_Statistics.correct_in_blue = 0;
	m_Refined1_Statistics.correct_in_red = 0;
	m_Refined1_Statistics.incorrect_but_second = 0;
	m_Refined1_Statistics.incorrect_in_blue = 0;
	m_Refined1_Statistics.incorrect_in_red = 0;
	m_Refined1_Statistics.total_correct = 0;
	m_Refined1_Statistics.total_chars = 0;
	m_Refined1_Statistics.total_incorrect = 0;
	m_Refined1_Statistics.total_noise = 0;
	m_Refined1_Statistics.missed_chars = 0;
	
	m_IsFTRStatistics = false;
	m_IsRefined1Statistics = false;
	m_IsRefined2Statistics = false;

	m_WrongCharStats.total_chars = 0;
	m_WrongCharStats.total_wrong_chars = 0;

	m_CharacterStats.total_chars = 0;
	m_CharacterStats.total_wrong_chars = 0;

	return TRUE;
}





void AFXAPI SerializeElements( CArchive& ar, CTextLine* m_pLineHolder, int LineHolderIndex )
{
		if( ar.IsStoring() )
        {
			for (int i = 0; i <= (LineHolderIndex-1); i++)
			{
				m_pLineHolder[i].Serialize(ar);
			}
        }
        else
        {
			//m_pLineHolder = new CTextLine[LineHolderIndex];
           
			for (int i = 0; i <= (LineHolderIndex-1); i++)
			{
				m_pLineHolder[i].Serialize(ar);
			}
		}
}
			//LineHolderIndex++;
 //       }
	//for (int i = 0; i < LineHolderIndex-1; i++)
	//{

	//	if( ar.IsStoring() )
 //       {
 //           m_pLineHolder[i].Serialize(ar);
 //       }
 //       else
 //       {
	//		CTextLine* m_pLineHolder = new CTextLine;
 //          // CTextLine* pNewLine = new CTextLine;
 //           //pNewLine->Serialize(ar);
 //           m_pLineHolder[i].Serialize(ar);
	//		//LineHolderIndex++;
 //       }
	//	
	//}


void CDocImAnDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		ar << m_pImage << m_LineHolderIndex << m_IsCharLocalized << m_IsCharSegmented << m_bIsPreprocessed << m_bIsLineSegmented;	
		SerializeElements(ar,m_pLineHolder,m_LineHolderIndex);
	
	}
	else
	{
		ClearDocument();

		ar >> m_pImage >> m_LineHolderIndex >> m_IsCharLocalized >> m_IsCharSegmented >> m_bIsPreprocessed >> m_bIsLineSegmented;	
		if (m_pUndoImage == NULL)
			m_pUndoImage = new CImage* [10];
		m_index = 0;
		m_pUndoImage[0] = m_pImage;
		m_index++;

		if (m_pImage) m_pImage->SetDirty();

		m_pLineHolder = new CTextLine[m_LineHolderIndex];
		SerializeElements(ar,m_pLineHolder,m_LineHolderIndex);
		
	}
}

void CDocImAnDoc::ClearDocument()
{
	
		DeleteUndoList();
		//delete m_pImage;
		m_pImage = NULL;
		
		//m_pLineHolder2 = NULL;
		/*for (int i = 0; i < m_LineHolderIndex; i++)
		{
			
			delete m_pLineHolder[i];
			m_pLineHolder[i] = NULL;
		}*/
		if (m_pLineHolder != NULL)
		{
			delete[] m_pLineHolder;
			m_pLineHolder = NULL;
		}
		
		
		m_LineHolderIndex = 0;
		m_ShowFix = false;
		m_IsCharLocalized = FALSE;
	//	if (m_pRecognizedImage != NULL)
	//	{
	//		delete m_pRecognizedImage;
	//	}
	//	m_pRecognizedImage = NULL;
		DeleteVectorList();
		if (m_bNeedSaveClassifier)
		{
			ExportClassifier();
		}
	//	DeleteContingencyTable();
		
	//	DeleteClassTree();
	
		

		/*for (int i = 0; i < m_ProbabilityVectorIndex; i++)
		{
		
			for (int j = 0; j < m_nFeatures; j++)
			{
				delete m_ppContingencyTable[i].Features[j].Values;
			
			}
			delete m_ppContingencyTable[i].Features;
		
		}
		delete[] m_ppContingencyTable;*/


		//m_pProbabilityVector.empty();
		
}

// CDocImAnDoc diagnostics

//#ifdef _DEBUG
void CDocImAnDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CDocImAnDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}

void CDocImAnDoc::SetActiveImage(CImage * mImage)
{
	m_pImage = mImage;
}

CImage * CDocImAnDoc::GetActiveImage()
{
	return m_pImage;
}
//#endif //_DEBUG


// CDocImAnDoc commands

void CDocImAnDoc::UpdateAllViews(CView* pSender, LPARAM lHint, CObject* pHint)
{
	CDocument::UpdateAllViews(pSender, lHint, pHint);
	//Let the mainframe update things as well
	CMainFrame * pMainFrame = (CMainFrame *) AfxGetApp()->m_pMainWnd;
	pMainFrame->UpdateAllWindows();
}


void CDocImAnDoc::OnFileImportimage()
{
	
	CFileDialog m_FileDialog(TRUE, NULL, NULL, OFN_HIDEREADONLY|OFN_FILEMUSTEXIST, 
		_T("TIFF Files(*.tiff; *.tif)|*.tiff; *.tif|All Files (*.*)|*.*||"));
	if (m_FileDialog.DoModal() == IDOK)
	{
		CString m_pathName = m_FileDialog.GetPathName();
		//deletion of old undo array
		if (m_index>0)
		{
			ClearDocument();
			m_pUndoImage = new CImage* [10];
		
		}
		m_pUndoImage[0] = ImgLoadFromFile((LPCTSTR)m_pathName, 
			RUNTIME_CLASS(CDIAHiColorImage),
			NULL,
			RUNTIME_CLASS(CDIAGreyScale),
			RUNTIME_CLASS(CDIABiLevelImage));

		m_pImage = m_pUndoImage[0];
		m_index++;
	    POSITION pos;
        pos = GetFirstViewPosition();
        CDocImAnView * pView = (CDocImAnView * )GetNextView(pos);
		pView->OnSize(SIZE_RESTORED,m_pImage->GetWidth(),m_pImage->GetHeight());
		pView->m_CharEnhComplete = false;
		m_bIsPreprocessed = false;
        pView->Invalidate();
		UpdateAllViews(NULL, 0, NULL);
	}
}


void CDocImAnDoc::OnFileImportimageToAdd()
{
	
	CFileDialog m_FileDialog(TRUE, NULL, NULL, OFN_HIDEREADONLY|OFN_FILEMUSTEXIST, 
		_T("TIFF Files(*.tiff; *.tif)|*.tiff; *.tif|All Files (*.*)|*.*||"));
	if (m_FileDialog.DoModal() == IDOK)
	{
		CString m_pathName = m_FileDialog.GetPathName();
		//deletion of old undo array
		
		m_pUndoImage[m_index] = ImgLoadFromFile((LPCTSTR)m_pathName, 
			RUNTIME_CLASS(CDIAHiColorImage),
			NULL,
			RUNTIME_CLASS(CDIAGreyScale),
			RUNTIME_CLASS(CDIABiLevelImage));

		m_pImage = m_pUndoImage[m_index];
		m_index++;
	    POSITION pos;
        pos = GetFirstViewPosition();
        CDocImAnView * pView = (CDocImAnView * )GetNextView(pos);
		pView->OnSize(SIZE_RESTORED,m_pImage->GetWidth(),m_pImage->GetHeight());
        pView->Invalidate();
		UpdateAllViews(NULL, 0, NULL);
	}
}
void CDocImAnDoc::OnFileExportimage()
{ 
	if (m_pImage->GetName() != NULL)
	{
		CString m_name = m_pImage->GetName();	

		CFileDialog m_FileDialog(FALSE, NULL, NULL, OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, 
		_T("TIFF Files(*.tiff; *.tif)|*.tiff; *.tif|Windows Bitmap (*.bmp)|*.bmp|JPEG Files (*.jpeg; *.jpg)|*.jpeg; *.jpg|PNG Files (*.png)|*.png|All Image Files|*.bmp; *.jpeg; *.jpg; *.tiff; *.tif; *.png|All Files (*.*)|*.*||"));

		if (m_FileDialog.DoModal() == IDOK)
		{	
			CString m_pathName = m_FileDialog.GetPathName();
			if (TRUE == m_pImage->ExportTIFF((LPCTSTR)m_pathName))
			{}
		}
	}
}

void CDocImAnDoc::OnEditUndo()
{
	if (m_pUndoImage != NULL)
	{	
		if (m_index > 1)
		{
			delete m_pUndoImage[m_index-1];
			m_index--;
			m_pImage = m_pUndoImage[m_index-1];				
		}		
	}
//	m_pImage->RequestUpdate();
	UpdateAllViews(NULL, 0, NULL);
}
CImage * CDocImAnDoc::GetUndoImage(int index)
{
	return m_pUndoImage[index];
}

void CDocImAnDoc::CreateNewUndoImage(DWORD Type)
{
	if (Type == 0) Type = m_pImage->GetType();
	if (CImage::IsType(Type, IT_HICOLOR) )
	{
		m_pUndoImage[m_index] = new CDIAHiColorImage();
	}
	else if (CImage::IsType(Type, IT_GREYSCALE))
	{
		m_pUndoImage[m_index] = new CDIAGreyScale();
	}
	else if (CImage::IsType(Type, IT_LOCOLOR))
	{
		m_pUndoImage[m_index] = new CDIALoColorImage();
	}
	else if (CImage::IsType(Type, IT_BILEVEL))
	{
		m_pUndoImage[m_index] = new CDIABiLevelImage();
	}
	
	m_pUndoImage[m_index]->CreateFromImage(m_pImage);
	//m_pUndoImage[m_index]->CreateDuplicate(m_pImage);
	m_pImage = m_pUndoImage[m_index];
	m_index++;
}

void CDocImAnDoc::DeleteVectorList()
{

	if (m_CharVectorIndex > 0)
	{
		//for (int i = 0 ; i < m_CharVectorIndex; i++)
		//{
			
	//		delete m_pCharVector[i];
	//		m_pCharVector[i] = NULL;
	//	}
		
		delete[] m_pCharVector; 
		m_pCharVector = NULL;
		
		m_CharVectorIndex = 0;
	}
	if (m_CharCapitalVectorIndex > 0)
	{
	//	for (int i = 0 ; i < m_CharCapitalVectorIndex; i++)
	//	{
			
		//	delete m_pCharCapitalVector[i];
		//	m_pCharCapitalVector[i] = NULL;
		//}
		
		delete[] m_pCharCapitalVector; 
		m_pCharCapitalVector = NULL;
		
		m_CharCapitalVectorIndex = 0;
	}
}
void CDocImAnDoc::DeleteUndoList()
{
	if (m_pUndoImage !=NULL)
	{
		for (int i = 0 ; i < m_index; i++)
		{
			delete m_pUndoImage[i];
			m_pUndoImage[i] = NULL;
		}
		delete[] m_pUndoImage;
		m_pUndoImage = NULL;
		m_index = 0;
	}
}


void CDocImAnDoc::OnUpdateEditUndo(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_index > 1);
}

void CDocImAnDoc::AddNewCharacterVector(CCharVector &Vector)
{
	//insert in order
	//if the character is already in the list then delete it
	//if it is not there then create a new object with it and add it in
	//in the right position
	
	if (m_CharVectorIndex > 0)
	{
		int count = 0;
		char name = m_pCharVector[count]->GetCharName();
		char vecname = Vector.GetCharName();
		while ((count < (m_CharVectorIndex-1))&&(m_pCharVector[count]->GetCharName() != Vector.GetCharName()) )
		{
			char first = m_pCharVector[count]->GetCharName();
			char second = Vector.GetCharName();
			count++;
		}
		
		if (m_pCharVector[count]->GetCharName() == Vector.GetCharName())
		{
			//then the character existed already and we just change the values to the new ones
			m_pCharVector[count]->SetAspectRatio(Vector.GetAspectRatio());
			m_pCharVector[count]->SetCharName(Vector.GetCharName());
			m_pCharVector[count]->SetCharType(Vector.GetCharType());
//			m_pCharVector[count]->SetHCrossing(Vector.GetHCrossing());
	//		m_pCharVector[count]->SetVCrossing(Vector.GetVCrossing());
			m_pCharVector[count]->SetHeight(Vector.GetHeight());
			m_pCharVector[count]->SetWidth(Vector.GetWidth());
			m_pCharVector[count]->SetHMax(Vector.GetHMax());
			m_pCharVector[count]->SetNoComponents(Vector.GetNoComponents());
			m_pCharVector[count]->SetNoHoles(Vector.GetNoHoles());
			m_pCharVector[count]->SetVMax(Vector.GetVMax());
			m_pCharVector[count]->SetCharImage(Vector.GetCharImage());
			for (int i = 0; i < 5; i++)
			{
				m_pCharVector[count]->SetDivision(i,Vector.GetDivision(i));
			}
		}
		else 
		{
			//then it went into the end so the character was not in the list
			
			m_pCharVector[m_CharVectorIndex] = new CCharVector();
			m_pCharVector[m_CharVectorIndex]->SetAspectRatio(Vector.GetAspectRatio());
			m_pCharVector[m_CharVectorIndex]->SetCharName(Vector.GetCharName());
			m_pCharVector[m_CharVectorIndex]->SetCharType(Vector.GetCharType());
//			m_pCharVector[m_CharVectorIndex]->SetHCrossing(Vector.GetHCrossing());
		//	m_pCharVector[m_CharVectorIndex]->SetVCrossing(Vector.GetVCrossing());
			m_pCharVector[m_CharVectorIndex]->SetHeight(Vector.GetHeight());
			m_pCharVector[m_CharVectorIndex]->SetWidth(Vector.GetWidth());
			m_pCharVector[m_CharVectorIndex]->SetHMax(Vector.GetHMax());
			m_pCharVector[m_CharVectorIndex]->SetNoComponents(Vector.GetNoComponents());
			m_pCharVector[m_CharVectorIndex]->SetNoHoles(Vector.GetNoHoles());
			m_pCharVector[m_CharVectorIndex]->SetVMax(Vector.GetVMax());
			m_pCharVector[m_CharVectorIndex]->SetCharImage(Vector.GetCharImage());
			for (int i = 0; i < 5; i++)
			{
				m_pCharVector[m_CharVectorIndex]->SetDivision(i,Vector.GetDivision(i));
			}

			m_CharVectorIndex++;
		}
	}
	else 
		{
			//then it is the first CharVector
			m_pCharVector = new CCharVector*;
			m_pCharVector[0] = new CCharVector();
			m_pCharVector[0]->SetAspectRatio(Vector.GetAspectRatio());
			m_pCharVector[0]->SetCharName(Vector.GetCharName());
			m_pCharVector[0]->SetCharType(Vector.GetCharType());
//			m_pCharVector[0]->SetHCrossing(Vector.GetHCrossing());
		//	m_pCharVector[0]->SetVCrossing(Vector.GetVCrossing());
			m_pCharVector[0]->SetHeight(Vector.GetHeight());
			m_pCharVector[0]->SetWidth(Vector.GetWidth());
			m_pCharVector[0]->SetHMax(Vector.GetHMax());
			m_pCharVector[0]->SetNoComponents(Vector.GetNoComponents());
			m_pCharVector[0]->SetNoHoles(Vector.GetNoHoles());
			m_pCharVector[0]->SetVMax(Vector.GetVMax());
		    m_pCharVector[0]->SetCharImage(Vector.GetCharImage());
			for (int i = 0; i < 5; i++)
			{
				m_pCharVector[0]->SetDivision(i,Vector.GetDivision(i));
			}

			m_CharVectorIndex = 1;
		}
}
void CDocImAnDoc::AddNewCharacterVector(CCharVector &Vector, CCharVector** &VectorList, int &vectorIndex)
{
	//insert in order
	//if the character is already in the list then delete it
	//if it is not there then create a new object with it and add it in
	//in the right position
	
	if (vectorIndex > 0)
	{
		int count = 0;
		char name = VectorList[count]->GetCharName();
		char vecname = Vector.GetCharName();
		while ((count < (vectorIndex-1))&&(VectorList[count]->GetCharName() != Vector.GetCharName()) )
		{
			char first = VectorList[count]->GetCharName();
			char second = Vector.GetCharName();
			count++;
		}
		
		if (VectorList[count]->GetCharName() == Vector.GetCharName())
		{
			//then the character existed already and we just change the values to the new ones
			VectorList[count]->SetAspectRatio(Vector.GetAspectRatio());
			VectorList[count]->SetCharName(Vector.GetCharName());
			VectorList[count]->SetCharType(Vector.GetCharType());
			VectorList[count]->SetNoCrossingH(Vector.GetNoCrossingH());
			//if (Vector.GetNoCrossingH() > 0)
			//{
			//	CCharVector::CROSSINGS crossing;
			//	//VectorList[count]->m_CrossingsH = new CCharVector::CROSSINGS[Vector.GetNoCrossingH()];
			//	for (int i = 0; i < Vector.GetNoCrossingH(); i ++)
			//	{
			//		crossing.Crossings = Vector.m_CrossingsH[i].Crossings;
			//		crossing.NoCrossings = Vector.m_CrossingsH[i].NoCrossings;
			//		VectorList[count]->m_CrossingsH.push_back(crossing);
			//		//VectorList[count]->m_CrossingsH[i].Crossings = Vector.m_CrossingsH[i].Crossings;
			//		//VectorList[count]->m_CrossingsH[i].NoCrossings = Vector.m_CrossingsH[i].NoCrossings;
			//	}
			//}

			VectorList[count]->SetNoCrossingV(Vector.GetNoCrossingV());
			//if (Vector.GetNoCrossingV() > 0)
			//{
			//	//VectorList[count]->m_CrossingsV = new CCharVector::CROSSINGS[Vector.GetNoCrossingV()];
			//	CCharVector::CROSSINGS crossing;
			//	for (int i = 0; i < Vector.GetNoCrossingV(); i ++)
			//	{
			//		crossing.Crossings = Vector.m_CrossingsV[i].Crossings;
			//		crossing.NoCrossings = Vector.m_CrossingsV[i].NoCrossings;
			//		VectorList[count]->m_CrossingsV.push_back(crossing);
			//		//VectorList[count]->m_CrossingsV[i].Crossings = Vector.m_CrossingsV[i].Crossings;
			//		//VectorList[count]->m_CrossingsV[i].NoCrossings = Vector.m_CrossingsV[i].NoCrossings;
			//	}
			//}
//			VectorList[count]->SetHCrossing(Vector.GetHCrossing());
	//		VectorList[count]->SetVCrossing(Vector.GetVCrossing());
			VectorList[count]->SetHeight(Vector.GetHeight());
			VectorList[count]->SetWidth(Vector.GetWidth());
			VectorList[count]->SetHMax(Vector.GetHMax());
			VectorList[count]->SetNoComponents(Vector.GetNoComponents());
			VectorList[count]->SetNoHoles(Vector.GetNoHoles());
			VectorList[count]->SetVMax(Vector.GetVMax());
			VectorList[count]->SetCharImage(Vector.GetCharImage());
			VectorList[count]->SetWeight(Vector.GetWeight());
			VectorList[count]->SetHMaxDistance(Vector.GetHMaxDistance());
			VectorList[count]->SetVMaxDistance(Vector.GetVMaxDistance());
			for (int i = 0; i < 25; i++)
			{
				VectorList[count]->SetDivision(i,Vector.GetDivision(i));
			}
		}
		else 
		{
			//then it went into the end so the character was not in the list
			
			VectorList[vectorIndex] = new CCharVector();
			VectorList[vectorIndex]->SetAspectRatio(Vector.GetAspectRatio());
			VectorList[vectorIndex]->SetCharName(Vector.GetCharName());
			VectorList[vectorIndex]->SetCharType(Vector.GetCharType());
			VectorList[vectorIndex]->SetNoCrossingH(Vector.GetNoCrossingH());
			//if (Vector.GetNoCrossingH() > 0)
			//{
			//	CCharVector::CROSSINGS crossing;
			//	for (int i = 0; i < Vector.GetNoCrossingH(); i ++)
			//	{
			//		crossing.Crossings = Vector.m_CrossingsH[i].Crossings;
			//		crossing.NoCrossings = Vector.m_CrossingsH[i].NoCrossings;
			//		VectorList[vectorIndex]->m_CrossingsH.push_back(crossing);
			//		//VectorList[count]->m_CrossingsV[i].Crossings = Vector.m_CrossingsV[i].Crossings;
			//		//VectorList[count]->m_CrossingsV[i].NoCrossings = Vector.m_CrossingsV[i].NoCrossings;
			//	}
			//	/*VectorList[count]->m_CrossingsH = new CCharVector::CROSSINGS[Vector.GetNoCrossingH()];
			//	for (int i = 0; i < Vector.GetNoCrossingH(); i ++)
			//	{
			//		VectorList[count]->m_CrossingsH[i].Crossings = Vector.m_CrossingsH[i].Crossings;
			//		VectorList[count]->m_CrossingsH[i].NoCrossings = Vector.m_CrossingsH[i].NoCrossings;
			//	}*/
			//}

			VectorList[vectorIndex]->SetNoCrossingV(Vector.GetNoCrossingV());
			//if (Vector.GetNoCrossingV() > 0)
			//{
			//	CCharVector::CROSSINGS crossing;
			//	for (int i = 0; i < Vector.GetNoCrossingV(); i ++)
			//	{
			//		crossing.Crossings = Vector.m_CrossingsV[i].Crossings;
			//		crossing.NoCrossings = Vector.m_CrossingsV[i].NoCrossings;
			//		VectorList[vectorIndex]->m_CrossingsV.push_back(crossing);
			//		//VectorList[count]->m_CrossingsV[i].Crossings = Vector.m_CrossingsV[i].Crossings;
			//		//VectorList[count]->m_CrossingsV[i].NoCrossings = Vector.m_CrossingsV[i].NoCrossings;
			//	}
			//	/*VectorList[count]->m_CrossingsV = new CCharVector::CROSSINGS[Vector.GetNoCrossingV()];
			//	for (int i = 0; i < Vector.GetNoCrossingV(); i ++)
			//	{
			//		VectorList[count]->m_CrossingsV[i].Crossings = Vector.m_CrossingsV[i].Crossings;
			//		VectorList[count]->m_CrossingsV[i].NoCrossings = Vector.m_CrossingsV[i].NoCrossings;
			//	}*/
			//}
//			VectorList[vectorIndex]->SetHCrossing(Vector.GetHCrossing());
	//		VectorList[vectorIndex]->SetVCrossing(Vector.GetVCrossing());
			VectorList[vectorIndex]->SetHeight(Vector.GetHeight());
			VectorList[vectorIndex]->SetWidth(Vector.GetWidth());
			VectorList[vectorIndex]->SetHMax(Vector.GetHMax());
			VectorList[vectorIndex]->SetNoComponents(Vector.GetNoComponents());
			VectorList[vectorIndex]->SetNoHoles(Vector.GetNoHoles());
			VectorList[vectorIndex]->SetVMax(Vector.GetVMax());
			VectorList[vectorIndex]->SetCharImage(Vector.GetCharImage());
			VectorList[vectorIndex]->SetWeight(Vector.GetWeight());
			VectorList[vectorIndex]->SetHMaxDistance(Vector.GetHMaxDistance());
			VectorList[vectorIndex]->SetVMaxDistance(Vector.GetVMaxDistance());
			for (int i = 0; i < 25; i++)
			{
				VectorList[vectorIndex]->SetDivision(i,Vector.GetDivision(i));
			}
			vectorIndex++;
		}
	}
	else 
		{
			//then it is the first CharVector
			VectorList = new CCharVector*;
			VectorList[0] = new CCharVector();
			VectorList[0]->SetAspectRatio(Vector.GetAspectRatio());
			VectorList[0]->SetCharName(Vector.GetCharName());
			VectorList[0]->SetCharType(Vector.GetCharType());
			VectorList[0]->SetNoCrossingH(Vector.GetNoCrossingH());
			//if (Vector.GetNoCrossingH() > 0)
			//{
			//	CCharVector::CROSSINGS crossing;
			//	for (int i = 0; i < Vector.GetNoCrossingH(); i ++)
			//	{
			//		crossing.Crossings = Vector.m_CrossingsH[i].Crossings;
			//		crossing.NoCrossings = Vector.m_CrossingsH[i].NoCrossings;
			//		VectorList[0]->m_CrossingsH.push_back(crossing);
			//		//VectorList[count]->m_CrossingsV[i].Crossings = Vector.m_CrossingsV[i].Crossings;
			//		//VectorList[count]->m_CrossingsV[i].NoCrossings = Vector.m_CrossingsV[i].NoCrossings;
			//	}
			//	/*VectorList[0]->m_CrossingsH = new CCharVector::CROSSINGS[Vector.GetNoCrossingH()];
			//	for (int i = 0; i < Vector.GetNoCrossingH(); i ++)
			//	{
			//		VectorList[0]->m_CrossingsH[i].Crossings = Vector.m_CrossingsH[i].Crossings;
			//		VectorList[0]->m_CrossingsH[i].NoCrossings = Vector.m_CrossingsH[i].NoCrossings;
			//	}*/
			//}

			VectorList[0]->SetNoCrossingV(Vector.GetNoCrossingV());
			//if (Vector.GetNoCrossingV() > 0)
			//{
			//	CCharVector::CROSSINGS crossing;
			//	for (int i = 0; i < Vector.GetNoCrossingV(); i ++)
			//	{
			//		crossing.Crossings = Vector.m_CrossingsV[i].Crossings;
			//		crossing.NoCrossings = Vector.m_CrossingsV[i].NoCrossings;
			//		VectorList[0]->m_CrossingsV.push_back(crossing);
			//		//VectorList[count]->m_CrossingsV[i].Crossings = Vector.m_CrossingsV[i].Crossings;
			//		//VectorList[count]->m_CrossingsV[i].NoCrossings = Vector.m_CrossingsV[i].NoCrossings;
			//	}
			//	/*VectorList[0]->m_CrossingsV = new CCharVector::CROSSINGS[Vector.GetNoCrossingV()];
			//	for (int i = 0; i < Vector.GetNoCrossingV(); i ++)
			//	{
			//		VectorList[0]->m_CrossingsV[i].Crossings = Vector.m_CrossingsV[i].Crossings;
			//		VectorList[0]->m_CrossingsV[i].NoCrossings = Vector.m_CrossingsV[i].NoCrossings;
			//	}*/
			//}
			//VectorList[0]->SetHCrossing(Vector.GetHCrossing());
			//VectorList[0]->SetVCrossing(Vector.GetVCrossing());
			VectorList[0]->SetHeight(Vector.GetHeight());
			VectorList[0]->SetWidth(Vector.GetWidth());
			VectorList[0]->SetHMax(Vector.GetHMax());
			VectorList[0]->SetNoComponents(Vector.GetNoComponents());
			VectorList[0]->SetNoHoles(Vector.GetNoHoles());
			VectorList[0]->SetVMax(Vector.GetVMax());
		    VectorList[0]->SetCharImage(Vector.GetCharImage());
			VectorList[0]->SetWeight(Vector.GetWeight());
			VectorList[0]->SetHMaxDistance(Vector.GetHMaxDistance());
			VectorList[0]->SetVMaxDistance(Vector.GetVMaxDistance());
			for (int i = 0; i < 25; i++)
			{
				VectorList[0]->SetDivision(i,Vector.GetDivision(i));
			}
			vectorIndex = 1;
		}
}

void CDocImAnDoc::ExportCharVectorToFile(CCharVector** &VectorList, int &vectorIndex, CString FilePath, CString ImagePath)
{
	//this wil export all the list of character vectors to a File
	//each field will be separated by commas
	//each character will take just one line

	//the characters will be stored in 2 files:
	//1 for the vector
	//2 for the char images

	FILE * pFile;
	pFile = _tfopen(FilePath, _T("w"));
	fprintf(pFile,"%d\n",vectorIndex);

	for (int i = 0; i < vectorIndex; i++)
	{
		fprintf(pFile,"%c,%d,%d,%d,%d,%d,%f",VectorList[i]->GetCharName(),VectorList[i]->GetCharType(),VectorList[i]->GetVMax(),VectorList[i]->GetHMax(),VectorList[i]->GetWidth(),VectorList[i]->GetHeight(),VectorList[i]->GetAspectRatio());
	/*	if (VectorList[i]->m_CrossingsV.size()> 0 )
		{
			fprintf(pFile,",%d",VectorList[i]->m_CrossingsV.size());
			for (int x = 0; x < (int)(VectorList[i]->m_CrossingsV.size()); x++)
			{
				CCharVector::CROSSINGS crossing = VectorList[i]->m_CrossingsV[x];
				fprintf(pFile,",%d",crossing.Crossings);
				fprintf(pFile,",%d",crossing.NoCrossings);
			}
		}else*/ fprintf(pFile,",%d",VectorList[i]->m_CrossingsH.size());
	/*	if (VectorList[i]->m_CrossingsH.size()> 0 )
		{
			fprintf(pFile,",%d",VectorList[i]->m_CrossingsH.size());
			for (int x = 0; x < (int)(VectorList[i]->m_CrossingsH.size()); x++)
			{
				CCharVector::CROSSINGS crossing = VectorList[i]->m_CrossingsH[x];
				fprintf(pFile,",%d",crossing.Crossings);
				fprintf(pFile,",%d",crossing.NoCrossings);
			}
		}else*/ fprintf(pFile,",%d",VectorList[i]->m_CrossingsV.size());

		fprintf(pFile,",%d,%d,%d",VectorList[i]->GetWeight(),VectorList[i]->GetNoHoles(),VectorList[i]->GetNoComponents());
		fprintf(pFile,",%d,%d",VectorList[i]->GetHMaxDistance(),VectorList[i]->GetVMaxDistance());
		for (int j = 0; j < 25; j++)
		{
			fprintf(pFile,",%d",VectorList[i]->GetDivision(j));
		}
		fprintf(pFile,"\n");
		//export perfect CharImage

		CString ImagePath;
		ImagePath.Format(_T("%s%c.tif"),ImagePath,VectorList[i]->GetCharName());
		//TRACE(_T("%s\n"),ImagePath);
	}
	fclose(pFile);

}
void CDocImAnDoc::ExportCharVectorToFile()
{
	//this wil export all the list of character vectors to a File
	//each field will be separated by commas
	//each character will take just one line

	//the characters will be stored in 2 files:
	//1 for the vector
	//2 for the char images

	FILE * pFile;
	pFile = _tfopen(m_CharFilePath, _T("w"));
	fprintf(pFile,"%d\n",m_CharVectorIndex);
	for (int i = 0; i < m_CharVectorIndex; i++)
		{
		fprintf(pFile,"%c,%d,%d,%d,%f,%d,%d,%d,%d,%d,%d,%d",m_pCharVector[i]->GetCharName(),m_pCharVector[i]->GetCharType(),m_pCharVector[i]->GetWidth(),m_pCharVector[i]->GetHeight(),m_pCharVector[i]->GetAspectRatio(),m_pCharVector[i]->GetVMax(),m_pCharVector[i]->GetHMax(),m_pCharVector[i]->GetDivision(0),m_pCharVector[i]->GetDivision(1),m_pCharVector[i]->GetDivision(2),m_pCharVector[i]->GetDivision(3),m_pCharVector[i]->GetDivision(4));
		if (m_pCharVector[i]->GetNoCrossingV()> 0 )
			{
				
				fprintf(pFile,",%d",m_pCharVector[i]->GetNoCrossingV());
				for (int x = 0; x < m_pCharVector[i]->GetNoCrossingV(); x++)
				{
					CCharVector::CROSSINGS crossingsV = m_pCharVector[i]->m_CrossingsV[x];
					fprintf(pFile,",%d",crossingsV.Crossings);
					fprintf(pFile,",%d",crossingsV.NoCrossings);
				}
			}else fprintf(pFile,",%d",m_pCharVector[i]->GetNoCrossingV());
			if (m_pCharVector[i]->GetNoCrossingH()> 0 )
			{
				fprintf(pFile,",%d",m_pCharVector[i]->GetNoCrossingH());
				for (int x = 0; x < m_pCharVector[i]->GetNoCrossingH(); x++)
				{
					CCharVector::CROSSINGS crossingsH = m_pCharVector[i]->m_CrossingsH[x];
					fprintf(pFile,",%d",crossingsH.Crossings);
					fprintf(pFile,",%d",crossingsH.NoCrossings);
				}
			}else 
				fprintf(pFile,",%d",m_pCharVector[i]->GetNoCrossingH());
		/*	if (m_pCharVector[i]->GetNoCrossingV()> 0 )
			{
				fprintf(pFile,",%d",m_pCharVector[i]->GetNoCrossingV());
				for (int x = 0; x < m_pCharVector[i]->GetNoCrossingV(); x++)
				{
					fprintf(pFile,",%d",m_pCharVector[i]->GetCrossingsValV(x));
					fprintf(pFile,",%d",m_pCharVector[i]->GetCrossingsPercentV(x));
				}
			}else fprintf(pFile,",%d",m_pCharVector[i]->GetNoCrossingV());

			if (m_pCharVector[i]->GetNoCrossingH()> 0 )
			{
				fprintf(pFile,",%d",m_pCharVector[i]->GetNoCrossingH());
				for (int x = 0; x < m_pCharVector[i]->GetNoCrossingH(); x++)
				{
					fprintf(pFile,",%d",m_pCharVector[i]->GetCrossingsValH(x));
					fprintf(pFile,",%d",m_pCharVector[i]->GetCrossingsPercentH(x));
				}
			}else fprintf(pFile,",%d",m_pCharVector[i]->GetNoCrossingH());*/

			fprintf(pFile,",%d,%d,%d\n",m_pCharVector[i]->GetNoComponents(),m_pCharVector[i]->GetNoHoles(),m_pCharVector[i]->GetWeight());

	//for (int i = 0; i < m_CharVectorIndex; i++)
	//{
	//	fprintf(pFile,"%c,%d,%d,%d,%f,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d\n",m_pCharVector[i]->GetCharName(),m_pCharVector[i]->GetCharType(),m_pCharVector[i]->GetWidth(),m_pCharVector[i]->GetHeight(),m_pCharVector[i]->GetAspectRatio(),m_pCharVector[i]->GetVMax(),m_pCharVector[i]->GetHMax(),m_pCharVector[i]->GetDivision(0),m_pCharVector[i]->GetDivision(1),m_pCharVector[i]->GetDivision(2),m_pCharVector[i]->GetDivision(3),m_pCharVector[i]->GetDivision(4),0,0,m_pCharVector[i]->GetNoComponents(),m_pCharVector[i]->GetNoHoles());
	//	//export perfect CharImage

		CString ImagePath;
		ImagePath.Format(_T("%s%c.tif"),m_PerfectImagePath,m_pCharVector[i]->GetCharName());
		//TRACE(_T("%s\n"),ImagePath);
	}
	fclose(pFile);

}


void CDocImAnDoc::ImportCharVectorFromFile(CString filePath, CCharVector** &vectorList, int &vectorIndex)
{
	//read from file and store the vectors on the list
	FILE * pFile;
	char VectorName;
	int VectorType;
	int VectorWidth;
	int VectorHeight;
	float VectorAspectRatio;
	int VMax;
	int HMax;
	int VCrossing;
	int HCrossing;
	int NoComp;
	int NoHoles;
	int Divisions;
	int Weight;
	int HMaxDist;
	int VMaxDist;
	if (_tfopen(filePath, _T("r")))
	{
		pFile = _tfopen(filePath, _T("r"));
		
		int count;
		fscanf(pFile,"%d\n",&count);
		vectorIndex = count;
		//vectorList* = new CCharVector;
		vectorList = new CCharVector*[count];
		for (int i = 0; i < count;i++)
		{
		
			fscanf(pFile,"%c,%d,%d,%d,%d,%d,%f,%d,%d\n", &VectorName, &VectorType, &VMax, &HMax, &VectorWidth, &VectorHeight, &VectorAspectRatio,&HCrossing,&VCrossing);

			vectorList[i] = new CCharVector;
			vectorList[i]->SetCharName(VectorName);
			vectorList[i]->SetCharType(VectorType);
			vectorList[i]->SetWidth(VectorWidth);
			vectorList[i]->SetHeight(VectorHeight);
			vectorList[i]->SetAspectRatio(VectorAspectRatio);
			vectorList[i]->SetVMax(VMax);
			vectorList[i]->SetHMax(HMax);

			//read VCrossings
			
			
			vectorList[i]->SetNoCrossingV(VCrossing);
			vectorList[i]->SetNoCrossingH(HCrossing);
			//	if (VCrossing > 0)
			//	{
			//		int cross, noCross;
			//		CCharVector::CROSSINGS newCrossing;
			//		//m_pProbabilityVector[i].m_Vectors[j].m_CrossingsV = 0;
			//		//classVector.m_Vectors[j].m_CrossingsV = new CCharVector::CROSSINGS[VCrossing];
			//		for (int x = 0; x < VCrossing; x++)
			//		{
			//			fscanf(pFile,",%d,%d",&cross,&noCross);
			//			newCrossing.Crossings = cross;
			//			newCrossing.NoCrossings = noCross;
			//			vectorList[i]->m_CrossingsV.push_back(newCrossing);
			//			//m_pProbabilityVector[i].m_Vectors[j].SetCrossingsValV(x,cross);
			//			//m_pProbabilityVector[i].m_Vectors[j].SetCrossingsPercentV(x,noCross);
			//		}
			//	}
		
			////read HCrossings
		
			//	fscanf(pFile,",%d", &HCrossing);
			//	vectorList[i]->SetNoCrossingH(HCrossing);
			//	if (HCrossing > 0)
			//	{
			//		int cross, noCross;
			//		CCharVector::CROSSINGS newCrossing;
			//		//m_pProbabilityVector[i].m_Vectors[j].m_CrossingsH = new CCharVector::CROSSINGS[HCrossing];
			//		for (int x = 0; x < HCrossing; x++)
			//		{
			//			fscanf(pFile,",%d,%d",&cross,&noCross);
			//			newCrossing.Crossings = cross;
			//			newCrossing.NoCrossings = noCross;
			//			vectorList[i]->m_CrossingsH.push_back(newCrossing);
			//			//m_pProbabilityVector[i].m_Vectors[j].SetCrossingsValH(x,cross);
			//			//m_pProbabilityVector[i].m_Vectors[j].SetCrossingsPercentH(x,noCross);
			//		}
			//	}		

			fscanf(pFile,",%d,%d,%d",&Weight,&NoHoles,&NoComp);
			vectorList[i]->SetNoComponents(NoComp);
			vectorList[i]->SetNoHoles(NoHoles);
			vectorList[i]->SetWeight(Weight);

			fscanf(pFile,",%d,%d",&HMaxDist,&VMaxDist);
			vectorList[i]->SetHMaxDistance(HMaxDist);
			vectorList[i]->SetVMaxDistance(VMaxDist);
			for (int j = 0; j < 25; j++)
			{
				fscanf(pFile,",%d",&Divisions);
				vectorList[i]->SetDivision(j,Divisions);
			}
			fscanf(pFile,"\n");
			//load the image
			CImage* loadedImage;
			CString ImagePath;
			ImagePath.Format(_T("%s%c.tif"),m_PerfectImagePath,vectorList[i]->GetCharName());
			//TRACE(_T("%s\n"),ImagePath);
			
			loadedImage = ImgLoadFromFile((LPCTSTR)ImagePath, 
			RUNTIME_CLASS(CDIAHiColorImage),
			NULL,
			RUNTIME_CLASS(CDIAGreyScale),
			RUNTIME_CLASS(CDIABiLevelImage));

			vectorList[i]->SetCharImage(loadedImage);
			int val2 = (int) GetRValue(loadedImage->GetRGBColor(0,0));
			int val = (int) GetRValue(vectorList[i]->GetCharImage()->GetRGBColor(0,0));
			//delete loadedImage;
			//loadedImage = NULL;
		}
		fclose(pFile);
		
	}
}

//void CDocImAnDoc::ImportCharCapitalVectorFromFile()
//{
//	//read from file and store the vectors on the list
//	FILE * pFile;
//	char VectorName;
//	int VectorType;
//	int VectorWidth;
//	int VectorHeight;
//	float VectorAspectRatio;
//	int VMax;
//	int HMax;
//	int VCrossing;
//	int HCrossing;
//	int NoComp;
//	int NoHoles;
//	int Divisions[5];
//	if (_tfopen(m_CapitalsFilePath, _T("r")))
//	{
//		pFile = _tfopen(m_CapitalsFilePath, _T("r"));
//		
//		int count;
//		fscanf(pFile,"%d\n",&count);
//		m_CharCapitalVectorIndex = count;
//		m_pCharCapitalVector = new CCharVector*[count];
//		for (int i = 0; i < count;i++)
//		{
//		
//			fscanf(pFile,"%c,%d,%d,%d,%f,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d\n", &VectorName, &VectorType, &VectorWidth, &VectorHeight, &VectorAspectRatio, &VMax, &HMax,&Divisions[0],&Divisions[1],&Divisions[2],&Divisions[3],&Divisions[4], &VCrossing, &HCrossing, &NoComp, &NoHoles );
//
//			m_pCharCapitalVector[i] = new CCharVector;
//			m_pCharCapitalVector[i]->SetCharName(VectorName);
//			m_pCharCapitalVector[i]->SetCharType(VectorType);
//			m_pCharCapitalVector[i]->SetWidth(VectorWidth);
//			m_pCharCapitalVector[i]->SetHeight(VectorHeight);
//			m_pCharCapitalVector[i]->SetAspectRatio(VectorAspectRatio);
//			m_pCharCapitalVector[i]->SetVMax(VMax);
//			m_pCharCapitalVector[i]->SetHMax(HMax);
//			//m_pCharCapitalVector[i]->SetVCrossing(VCrossing);
//			//m_pCharCapitalVector[i]->SetHCrossing(HCrossing);
//			m_pCharCapitalVector[i]->SetNoComponents(NoComp);
//			m_pCharCapitalVector[i]->SetNoHoles(NoHoles);
//			for (int j = 0; j < 5; j++)
//			{
//				m_pCharCapitalVector[i]->SetDivision(j,Divisions[j]);
//			}
//			//load the image
//			CImage* loadedImage;
//			CString ImagePath;
//			ImagePath.Format(_T("%s%c.tif"),m_PerfectCapitalImagePath,m_pCharCapitalVector[i]->GetCharName());
//			TRACE(_T("%s\n"),ImagePath);
//			
//			loadedImage = ImgLoadFromFile((LPCTSTR)ImagePath, 
//			RUNTIME_CLASS(CDIAHiColorImage),
//			NULL,
//			RUNTIME_CLASS(CDIAGreyScale),
//			RUNTIME_CLASS(CDIABiLevelImage));
//
//			m_pCharCapitalVector[i]->SetCharImage(loadedImage);	
//			char name = m_pCharCapitalVector[i]->GetCharName();
//			int width = m_pCharCapitalVector[i]->GetCharImage()->GetWidth();
//			//delete loadedImage;
//			//loadedImage = NULL;
//		}
//		fclose(pFile);
//	}
//}
void CDocImAnDoc::ImportCharCapitalVectorFromFile()
{
	//read from file and store the vectors on the list
	FILE * pFile;
	char VectorName;
	int VectorType;
	int VectorWidth;
	int VectorHeight;
	float VectorAspectRatio;
	int VMax;
	int HMax;
	int VCrossing;
	int HCrossing;
	int NoComp;
	int NoHoles;
	int Divisions[5];
	int Weight;
	if (_tfopen(m_CapitalsFilePath, _T("r")))
	{
		pFile = _tfopen(m_CapitalsFilePath, _T("r"));
		
		int count;
		fscanf(pFile,"%d\n",&count);
		m_CharCapitalVectorIndex = count;
		m_pCharCapitalVector = new CCharVector*[count];
		for (int i = 0; i < count;i++)
		{
		
			fscanf(pFile,"%c,%d,%d,%d,%f,%d,%d,%d,%d,%d,%d,%d,%d", &VectorName, &VectorType, &VectorWidth, &VectorHeight, &VectorAspectRatio, &VMax, &HMax,&Divisions[0],&Divisions[1],&Divisions[2],&Divisions[3],&Divisions[4], &VCrossing);

			m_pCharCapitalVector[i] = new CCharVector;
			m_pCharCapitalVector[i]->SetCharName(VectorName);
			m_pCharCapitalVector[i]->SetCharType(VectorType);
			m_pCharCapitalVector[i]->SetWidth(VectorWidth);
			m_pCharCapitalVector[i]->SetHeight(VectorHeight);
			m_pCharCapitalVector[i]->SetAspectRatio(VectorAspectRatio);
			m_pCharCapitalVector[i]->SetVMax(VMax);
			m_pCharCapitalVector[i]->SetHMax(HMax);

			//read VCrossings
			
				m_pCharCapitalVector[i]->SetNoCrossingV(VCrossing);
				if (VCrossing > 0)
				{
					int cross, noCross;
					CCharVector::CROSSINGS newCrossing;
					//m_pProbabilityVector[i].m_Vectors[j].m_CrossingsV = 0;
					//classVector.m_Vectors[j].m_CrossingsV = new CCharVector::CROSSINGS[VCrossing];
					for (int x = 0; x < VCrossing; x++)
					{
						fscanf(pFile,",%d,%d",&cross,&noCross);
						newCrossing.Crossings = cross;
						newCrossing.NoCrossings = noCross;
						m_pCharCapitalVector[i]->m_CrossingsV.push_back(newCrossing);
						//m_pProbabilityVector[i].m_Vectors[j].SetCrossingsValV(x,cross);
						//m_pProbabilityVector[i].m_Vectors[j].SetCrossingsPercentV(x,noCross);
					}
				}
			////m_pCharCapitalVector[i]->SetVCrossing(VCrossing);
			//
			//m_pCharCapitalVector[i]->SetNoCrossingV(VCrossing);
			//if (VCrossing > 0)
			//{
			//	int cross, noCross;
			//	//m_pCharCapitalVector[i]->m_CrossingsV = new CCharVector::CROSSINGS[VCrossing];
			//	for (int x = 0; x < VCrossing; x++)
			//	{
			//		fscanf(pFile,",%d,%d",&cross,&noCross);
			//		m_pCharCapitalVector[i]->SetCrossingsValV(x,cross);
			//		m_pCharCapitalVector[i]->SetCrossingsPercentV(x,noCross);
			//	}
			//}

			//read HCrossings

			fscanf(pFile,",%d", &HCrossing);
			m_pCharCapitalVector[i]->SetNoCrossingH(HCrossing);
			if (HCrossing > 0)
			{
				int cross, noCross;
				CCharVector::CROSSINGS newCrossing;
				//m_pProbabilityVector[i].m_Vectors[j].m_CrossingsH = new CCharVector::CROSSINGS[HCrossing];
				for (int x = 0; x < HCrossing; x++)
				{
					fscanf(pFile,",%d,%d",&cross,&noCross);
					newCrossing.Crossings = cross;
					newCrossing.NoCrossings = noCross;
					m_pCharCapitalVector[i]->m_CrossingsH.push_back(newCrossing);
					//m_pProbabilityVector[i].m_Vectors[j].SetCrossingsValH(x,cross);
					//m_pProbabilityVector[i].m_Vectors[j].SetCrossingsPercentH(x,noCross);
				}
			}			
		////	m_pCharCapitalVector[i]->SetHCrossing(HCrossing);
		//	fscanf(pFile,",%d", &HCrossing);
		//	m_pCharCapitalVector[i]->SetNoCrossingH(HCrossing);
		//	if (HCrossing > 0)
		//	{
		//		int cross, noCross;
		//		m_pCharCapitalVector[i]->m_CrossingsH = new CCharVector::CROSSINGS[HCrossing];
		//		for (int x = 0; x < HCrossing; x++)
		//		{
		//			fscanf(pFile,",%d,%d",&cross,&noCross);
		//			m_pCharCapitalVector[i]->SetCrossingsValH(x,cross);
		//			m_pCharCapitalVector[i]->SetCrossingsPercentH(x,noCross);
		//		}
		//	}

			/*m_pCharCapitalVector[i]->SetHCrossing(HCrossing);*/
			fscanf(pFile,",%d,%d,%d\n",&NoComp,&NoHoles, &Weight);
			m_pCharCapitalVector[i]->SetNoComponents(NoComp);
			m_pCharCapitalVector[i]->SetNoHoles(NoHoles);
			m_pCharCapitalVector[i]->SetWeight(Weight);
			for (int j = 0; j < 5; j++)
			{
				m_pCharCapitalVector[i]->SetDivision(j,Divisions[j]);
			}
			//load the image
			CImage* loadedImage;
			CString ImagePath;
			ImagePath.Format(_T("%s%c.tif"),m_PerfectCapitalImagePath,m_pCharCapitalVector[i]->GetCharName());
			//TRACE(_T("%s\n"),ImagePath);
			
			loadedImage = ImgLoadFromFile((LPCTSTR)ImagePath, 
			RUNTIME_CLASS(CDIAHiColorImage),
			NULL,
			RUNTIME_CLASS(CDIAGreyScale),
			RUNTIME_CLASS(CDIABiLevelImage));

			m_pCharCapitalVector[i]->SetCharImage(loadedImage);	
			char name = m_pCharCapitalVector[i]->GetCharName();
			int width = m_pCharCapitalVector[i]->GetCharImage()->GetWidth();
			//delete loadedImage;
			//loadedImage = NULL;
		}
		fclose(pFile);
	}
}
void CDocImAnDoc::ImportCharVectorFromFile()
{
	//read from file and store the vectors on the list
	FILE * pFile;
	char VectorName;
	int VectorType;
	int VectorWidth;
	int VectorHeight;
	float VectorAspectRatio;
	int VMax;
	int HMax;
	int VCrossing;
	int HCrossing;
	int NoComp;
	int NoHoles;
	int Divisions[5];
	int Weight;
	if (_tfopen(m_CharFilePath, _T("r")))
	{
		pFile = _tfopen(m_CharFilePath, _T("r"));
		
		int count;
		fscanf(pFile,"%d\n",&count);
		m_CharVectorIndex = count;
		m_pCharVector = new CCharVector* [count];
		//for (int i = 0; i < count;i++)
		//{
		//
		for (int i = 0; i < count;i++)
		{
		
			fscanf(pFile,"%c,%d,%d,%d,%f,%d,%d,%d,%d,%d,%d,%d,%d", &VectorName, &VectorType, &VectorWidth, &VectorHeight, &VectorAspectRatio, &VMax, &HMax,&Divisions[0],&Divisions[1],&Divisions[2],&Divisions[3],&Divisions[4], &VCrossing);

			m_pCharVector[i] = new CCharVector;
			m_pCharVector[i]->SetCharName(VectorName);
			m_pCharVector[i]->SetCharType(VectorType);
			m_pCharVector[i]->SetWidth(VectorWidth);
			m_pCharVector[i]->SetHeight(VectorHeight);
			m_pCharVector[i]->SetAspectRatio(VectorAspectRatio);
			m_pCharVector[i]->SetVMax(VMax);
			m_pCharVector[i]->SetHMax(HMax);

			//read VCrossings
			
			
				m_pCharVector[i]->SetNoCrossingV(VCrossing);
				if (VCrossing > 0)
				{
					int cross, noCross;
					CCharVector::CROSSINGS newCrossing;
					//m_pProbabilityVector[i].m_Vectors[j].m_CrossingsV = 0;
					//classVector.m_Vectors[j].m_CrossingsV = new CCharVector::CROSSINGS[VCrossing];
					for (int x = 0; x < VCrossing; x++)
					{
						fscanf(pFile,",%d,%d",&cross,&noCross);
						newCrossing.Crossings = cross;
						newCrossing.NoCrossings = noCross;
						m_pCharVector[i]->m_CrossingsV.push_back(newCrossing);
						//m_pProbabilityVector[i].m_Vectors[j].SetCrossingsValV(x,cross);
						//m_pProbabilityVector[i].m_Vectors[j].SetCrossingsPercentV(x,noCross);
					}
				}
			/*
			
			m_pCharVector[i]->SetNoCrossingV(VCrossing);
			if (VCrossing > 0)
			{
				int cross, noCross;
				m_pCharVector[i]->m_CrossingsV = new CCharVector::CROSSINGS[VCrossing];
				for (int x = 0; x < VCrossing; x++)
				{
					fscanf(pFile,",%d,%d",&cross,&noCross);
					m_pCharVector[i]->SetCrossingsValV(x,cross);
					m_pCharVector[i]->SetCrossingsPercentV(x,noCross);
				}
			}*/
			//read HCrossings
		
				fscanf(pFile,",%d", &HCrossing);
			m_pCharVector[i]->SetNoCrossingH(HCrossing);
			if (HCrossing > 0)
			{
				int cross, noCross;
				CCharVector::CROSSINGS newCrossing;
				//m_pProbabilityVector[i].m_Vectors[j].m_CrossingsH = new CCharVector::CROSSINGS[HCrossing];
				for (int x = 0; x < HCrossing; x++)
				{
					fscanf(pFile,",%d,%d",&cross,&noCross);
					newCrossing.Crossings = cross;
					newCrossing.NoCrossings = noCross;
					m_pCharVector[i]->m_CrossingsH.push_back(newCrossing);
					//m_pProbabilityVector[i].m_Vectors[j].SetCrossingsValH(x,cross);
					//m_pProbabilityVector[i].m_Vectors[j].SetCrossingsPercentH(x,noCross);
				}
			}		
			/*fscanf(pFile,",%d", &HCrossing);
			m_pCharVector[i]->SetNoCrossingH(HCrossing);
			if (HCrossing > 0)
			{
				int cross, noCross;
				m_pCharVector[i]->m_CrossingsH = new CCharVector::CROSSINGS[HCrossing];
				for (int x = 0; x < HCrossing; x++)
				{
					fscanf(pFile,",%d,%d",&cross,&noCross);
					m_pCharVector[i]->SetCrossingsValH(x,cross);
					m_pCharVector[i]->SetCrossingsPercentH(x,noCross);
				}
			}*/

			
			fscanf(pFile,",%d,%d,%d\n",&NoComp,&NoHoles, &Weight);
			m_pCharVector[i]->SetNoComponents(NoComp);
			m_pCharVector[i]->SetNoHoles(NoHoles);
			m_pCharVector[i]->SetWeight(Weight);
	
			for (int j = 0; j < 5; j++)
			{
				m_pCharVector[i]->SetDivision(j,Divisions[j]);
			}
			//load the image
			CImage* loadedImage;
			CString ImagePath;
			ImagePath.Format(_T("%s%c.tif"),m_PerfectImagePath,m_pCharVector[i]->GetCharName());
			//TRACE(_T("%s\n"),ImagePath);
			
			loadedImage = ImgLoadFromFile((LPCTSTR)ImagePath, 
			RUNTIME_CLASS(CDIAHiColorImage),
			NULL,
			RUNTIME_CLASS(CDIAGreyScale),
			RUNTIME_CLASS(CDIABiLevelImage));

			m_pCharVector[i]->SetCharImage(loadedImage);
			char name = m_pCharVector[i]->GetCharName();
			int width = m_pCharVector[i]->GetCharImage()->GetWidth();
			//delete loadedImage;
			//loadedImage = NULL;
		}
		fclose(pFile);
	}
}

void CDocImAnDoc::ExportCharacterCVS(CDIAGreyScale image, char name)
{
	int **ImageArray;
	/*ImageArray = new int* [(character.m_CharLocation.bottom-character.m_CharLocation.top + 1)];
	for (int x = 0; x < (character.m_CharLocation.bottom-character.m_CharLocation.top + 1); x++)
	{
		ImageArray[x] = new int [(character.m_CharLocation.right- character.m_CharLocation.left +1)];
	}*/
	ImageArray = new int* [image.GetHeight()];
	for (int x = 0; x < image.GetHeight(); x++)
	{
		ImageArray[x] = new int [image.GetWidth()];
	}
	//for every value in the inner character
	
	for (int j = 0; j < image.GetHeight(); j++)
	{
		for (int i = 0; i < image.GetWidth(); i++)
		{
			int value = (int) GetRValue(image.GetRGBColor(i,j));
			//TRACE(_T("%d"),m_pCharImage->GetRed((m_CharLocation.left + i),(m_CharLocation.top + j)));
			//TRACE(_T("%d"),m_pCharImage->GetRed(2,2));
			ImageArray[j][i] = value;
		}
	}

	//export all characters
	FILE * pFile;
	CString Column;
	char Row[] = "Row";
	char c = '\n';
//	long Cl,Rw;
	int num2 = 1;

	CString VarName;
	//CString NumChar;
	//CString m_name = m_ImageName;	
			
	//VarName = m_name ;//+ ".csv";
	//VarName += "Character"; 
	//NumChar = num;
	//VarName += NumChar;
	//VarName.Format(_T("X:\\celia\\Memorial Images\\Original Characters\\Perfect Set\\PerfectCharacter-%c.csv"),name);
	VarName.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Original Characters\\Perfect Set\\PerfectCharacter-%c.csv"),name); 
	//TRACE(VarName);
	pFile = _tfopen(VarName, _T("w"));
	for (int i = 0; i < image.GetWidth();i++)
	{
		//Column.Format(_T("Column%d"), num2);
		fprintf(pFile,"Column%d,",num2);
		num2++;
	}
	fprintf(pFile, "%c",c);
	for (int i = 0; i < image.GetWidth(); i++)
	{
		for (int j = 0; j < image.GetHeight(); j++)
		{
			fprintf(pFile,"%d,",255-ImageArray[j][i]);
		}
		fprintf(pFile,"%c",c);
	}
	fclose(pFile);

	for (int x = 0; x < image.GetHeight(); x++)
	{
		delete ImageArray[x];
	}
	delete []ImageArray;
}

void CDocImAnDoc::Exportimage(CImage * image, char name)
{ 
		CString ImagePath;
		ImagePath.Format(_T("%s-%c.tif"),m_ImagePath,name);

		CFileDialog m_FileDialog(FALSE, NULL, NULL, OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, 
		_T("TIFF Files(*.tiff; *.tif)|*.tiff; *.tif|Windows Bitmap (*.bmp)|*.bmp|JPEG Files (*.jpeg; *.jpg)|*.jpeg; *.jpg|PNG Files (*.png)|*.png|All Image Files|*.bmp; *.jpeg; *.jpg; *.tiff; *.tif; *.png|All Files (*.*)|*.*||"));
		image->ExportTIFF((LPCTSTR)ImagePath);
}
void CDocImAnDoc::Exportimage(CImage * image, char name, CString path)
{ 
		CString ImagePath;
		ImagePath.Format(_T("%s-%c.tif"),path,name);

		CFileDialog m_FileDialog(FALSE, NULL, NULL, OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, 
		_T("TIFF Files(*.tiff; *.tif)|*.tiff; *.tif|Windows Bitmap (*.bmp)|*.bmp|JPEG Files (*.jpeg; *.jpg)|*.jpeg; *.jpg|PNG Files (*.png)|*.png|All Image Files|*.bmp; *.jpeg; *.jpg; *.tiff; *.tif; *.png|All Files (*.*)|*.*||"));
		image->ExportTIFF((LPCTSTR)ImagePath);
}
void CDocImAnDoc::Exportimage(CImage * image, CString name, CString path)
{ 
		CString ImagePath;
		ImagePath.Format(_T("%s%s.tif"),path,name);

		CFileDialog m_FileDialog(FALSE, NULL, NULL, OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, 
		_T("TIFF Files(*.tiff; *.tif)|*.tiff; *.tif|Windows Bitmap (*.bmp)|*.bmp|JPEG Files (*.jpeg; *.jpg)|*.jpeg; *.jpg|PNG Files (*.png)|*.png|All Image Files|*.bmp; *.jpeg; *.jpg; *.tiff; *.tif; *.png|All Files (*.*)|*.*||"));
		image->ExportTIFF((LPCTSTR)ImagePath);
}
//CString CDocImAnDoc::AddCharacterToClassifier(CCharVector &Vector)
//{
//	bool flag = false;
//	int charnum;
//	int charval;
//	//loop through classifierVector and find if it is there
//
//	if (m_ProbabilityVectorIndex > 0)
//	{
//		for (int i = 0; i < m_ProbabilityVectorIndex; i++)
//		{
//			if ((m_pProbabilityVector[i].GetCharName() == Vector.GetCharName()) && (m_pProbabilityVector[i].GetCapital() == Vector.GetCapital()))
//			{
//				charnum = m_pProbabilityVector[i].AddNewVector(Vector);
//				charval = i;
//				flag = true;
//			}
//		}
//		if (flag == false) //it didn't find it
//		{
//			//add the vector at the end
//			
//			charnum = m_pProbabilityVector[m_ProbabilityVectorIndex].AddNewVector(Vector);
//			charval = m_ProbabilityVectorIndex;
//			m_ProbabilityVectorIndex++;
//		}
//	}
//	else
//	{
//		charnum = m_pProbabilityVector[0].AddNewVector(Vector);
//		charval = 0;
//		m_ProbabilityVectorIndex++;
//	}
//
//	CString Imagename;
//	Imagename.Format(_T("%c-%d-%d"),Vector.GetCharName(),charval,charnum);
//	return Imagename;
//	//Exportimage(Vector.GetCharImage(),Vector.GetCharName(),ImagePath);
//}

CString CDocImAnDoc::AddCharacterToClassifier(CCharVector &Vector)
{
	m_bNeedSaveClassifier = true;
	int charnum;
	//int charval;
	bool flag = false;
	//loop through classifierVector and find if it is there
	
	if (m_ProbabilityVectorIndex > 0)
	{
		
		for (int i = 0; i < m_ProbabilityVectorIndex; i++)
		{
			//CClassifierVector classVector;
			
			//classVector = m_pProbabilityVector[i];
			if ((m_pProbabilityVector[i].GetCharName() == Vector.GetCharName()) && (m_pProbabilityVector[i].GetCapital() == Vector.GetCapital()))
			{
				//if the character already existed
				charnum = m_pProbabilityVector[i].AddNewCharacter(Vector);
				//charnum = classVector.GetNoOfChars();
				//charval = m_ProbabilityVectorIndex;
				flag = true;
			}
		}
		if (flag == false)//if it hasn't been found
		{
			m_pProbabilityVector[m_ProbabilityVectorIndex].SetCharName(Vector.GetCharName());
			m_pProbabilityVector[m_ProbabilityVectorIndex].SetCapital(Vector.GetCapital());
			charnum = m_pProbabilityVector[m_ProbabilityVectorIndex].AddNewVector(Vector);
			//charval = m_ProbabilityVectorIndex;
			//charnum = classVector.GetNoOfChars();
			m_ProbabilityVectorIndex++;
			
		}
		
	}
	else
	{//if it is the first charvector 
	
		//CClassifierVector classVector;
		m_pProbabilityVector[m_ProbabilityVectorIndex].SetCharName(Vector.GetCharName());
		m_pProbabilityVector[m_ProbabilityVectorIndex].SetCapital(Vector.GetCapital());
		charnum = m_pProbabilityVector[m_ProbabilityVectorIndex].AddNewVector(Vector);
		//charval = m_ProbabilityVectorIndex;
		//charnum = classVector.GetNoOfChars();
		m_ProbabilityVectorIndex++;
		
		
		
		
	}

	CString Imagename;
	int capital;
	if (Vector.GetCapital() == true) capital = 1;
	else capital = 0;
	Imagename.Format(_T("%d%c-%d"),capital,Vector.GetCharName(),charnum);
	return Imagename;
	//Exportimage(Vector.GetCharImage(),Vector.GetCharName(),ImagePath);
}

void CDocImAnDoc::ImportClassifier()
{
	FILE * pFile;
	int NoOfVectors;
	char VectorName;
	int Capital;
	int NoOfChars;
	int VectorType;
	int VectorWidth;
	int VectorHeight;
	float VectorAspectRatio;
	int VMax;
	int HMax;
	int VCrossing;
	int HCrossing;
	int NoComp;
	int NoHoles;
	int Divisions[25];
	int Weight;
	int HMaxDistance, VMaxDistance;

	m_ProbabilityVectorIndex = 0;

	if (_tfopen(m_ClassifierFilePath, _T("r")))
	{
		pFile = _tfopen(m_ClassifierFilePath, _T("r"));
		
		fscanf(pFile,"%d\n",&NoOfVectors);
		m_ProbabilityVectorIndex = NoOfVectors;
		
		
		for (int i = 0; i < m_ProbabilityVectorIndex;i++)
		{

			fscanf(pFile,"%c,%d,%d\n",&VectorName, &NoOfChars, &Capital);
			m_pProbabilityVector[i].SetCharName(VectorName);
			m_pProbabilityVector[i].SetNoOfChars(NoOfChars);
			bool val;
			//if (Capital == 1) m_pProbabilityVector[i].SetCapital(true);
			//else m_pProbabilityVector[i].SetCapital(false);
			if (Capital == 1) val = true;
			else val = false;
			m_pProbabilityVector[i].SetCapital(val);

			//m_pProbabilityVector[i].m_Vectors = new CCharVector[NoOfChars];

			for (int j = 0; j < NoOfChars; j++)
			{
				//CCharVector charvector;
				fscanf(pFile,"%d,%d,%d,%f,%d,%d,%d", &VectorType, &VectorWidth, &VectorHeight, &VectorAspectRatio, &VMax, &HMax,&VCrossing);
				m_pProbabilityVector[i].m_Vectors[j].SetCharName(VectorName);
				m_pProbabilityVector[i].m_Vectors[j].SetCharType(VectorType);
				m_pProbabilityVector[i].m_Vectors[j].SetWidth(VectorWidth);
				m_pProbabilityVector[i].m_Vectors[j].SetHeight(VectorHeight);
				m_pProbabilityVector[i].m_Vectors[j].SetAspectRatio(VectorAspectRatio);
				m_pProbabilityVector[i].m_Vectors[j].SetVMax(VMax);
				m_pProbabilityVector[i].m_Vectors[j].SetHMax(HMax);

				//read VCrossings
				m_pProbabilityVector[i].m_Vectors[j].SetNoCrossingV(VCrossing);
				//if (VCrossing > 0)
				//{
				//	int cross, noCross;
				//	CCharVector::CROSSINGS newCrossing;
				//	//m_pProbabilityVector[i].m_Vectors[j].m_CrossingsV = 0;
				//	//classVector.m_Vectors[j].m_CrossingsV = new CCharVector::CROSSINGS[VCrossing];
				//	for (int x = 0; x < VCrossing; x++)
				//	{
				//		fscanf(pFile,",%d,%d",&cross,&noCross);
				//		newCrossing.Crossings = cross;
				//		newCrossing.NoCrossings = noCross;
				//		m_pProbabilityVector[i].m_Vectors[j].m_CrossingsV.push_back(newCrossing);
				//		//m_pProbabilityVector[i].m_Vectors[j].SetCrossingsValV(x,cross);
				//		//m_pProbabilityVector[i].m_Vectors[j].SetCrossingsPercentV(x,noCross);
				//	}
				//}
				//read HCrossings
			
				fscanf(pFile,",%d", &HCrossing);
				m_pProbabilityVector[i].m_Vectors[j].SetNoCrossingH(HCrossing);
				//if (HCrossing > 0)
				//{
				//	int cross, noCross;
				//	CCharVector::CROSSINGS newCrossing;
				//	//m_pProbabilityVector[i].m_Vectors[j].m_CrossingsH = new CCharVector::CROSSINGS[HCrossing];
				//	for (int x = 0; x < HCrossing; x++)
				//	{
				//		fscanf(pFile,",%d,%d",&cross,&noCross);
				//		newCrossing.Crossings = cross;
				//		newCrossing.NoCrossings = noCross;
				//		m_pProbabilityVector[i].m_Vectors[j].m_CrossingsH.push_back(newCrossing);
				//		//m_pProbabilityVector[i].m_Vectors[j].SetCrossingsValH(x,cross);
				//		//m_pProbabilityVector[i].m_Vectors[j].SetCrossingsPercentH(x,noCross);
				//	}
				//}				
				fscanf(pFile,",%d,%d,%d,%d,%d",&NoComp,&NoHoles,&Weight,&HMaxDistance,&VMaxDistance);
				
				m_pProbabilityVector[i].m_Vectors[j].SetNoComponents(NoComp);
				m_pProbabilityVector[i].m_Vectors[j].SetNoHoles(NoHoles);
				m_pProbabilityVector[i].m_Vectors[j].SetWeight(Weight);
				m_pProbabilityVector[i].m_Vectors[j].SetHMaxDistance(HMaxDistance);
				m_pProbabilityVector[i].m_Vectors[j].SetVMaxDistance(VMaxDistance);
			
				for (int x = 0; x < 25; x++)
				{
					fscanf(pFile,",%d",&Divisions[x]);
					m_pProbabilityVector[i].m_Vectors[j].SetDivision(x,Divisions[x]);
				}
				//classVector.AddNewCharacter(charvector);
				//m_pProbabilityVector[i] = classVector;
				fscanf(pFile,"\n");
			}
		}
		fclose(pFile);
		
		
	}
	ComputeContingencyTable();

}
//void CDocImAnDoc::ImportClassifier2()
//{
//	FILE * pFile;
//	//char SCharType;
//	//char SWidth;
//	//char SHeight;
//	//char SAspRatio;
//	//char SVMax;
//	//char SHMax;
//	//char SDivision0;
//	//char SDivision1;
//	//char SDivision2;
//	//char SDivision3;
//	//char SDivision4;
//	//char SNoCrossV;
//	//char SNoCrossH;
//
//	int NoOfVectors;
//	char VectorName;
//	int Capital;
//	int NoOfChars;
//	int VectorType;
//	int VectorWidth;
//	int VectorHeight;
//	float VectorAspectRatio;
//	int VMax;
//	int HMax;
//	int VCrossing;
//	int HCrossing;
//	int NoComp;
//	int NoHoles;
//	int Divisions[5];
//	//m_pProbabilityVector = new CClassifierVector[62];
//	m_ProbabilityVectorIndex = 0;
//	//CClassifierVector classVector;
//	if (_tfopen(m_ClassifierFilePath, _T("r")))
//	{
//		pFile = _tfopen(m_ClassifierFilePath, _T("r"));
//		//fscanf(pFile,"\n",NULL);
//		//fscanf(pFile,"%c,%c,%c,%c,%c,%c,%c,%c,%c,%c,%c,%c,%c\n",&SCharType,&SWidth,&SHeight,&SAspRatio,&SVMax,&SHMax,&SDivision0,&SDivision1,&SDivision2,&SDivision3,&SDivision4,&SNoCrossV,&SNoCrossH);
//		
//		fscanf(pFile,"%d\n",&NoOfVectors);
//		m_ProbabilityVectorIndex = NoOfVectors;
//		
//		
//		for (int i = 0; i < m_ProbabilityVectorIndex;i++)
//		{
//		
//			fscanf(pFile,"%c,%d,%d\n",&VectorName, &NoOfChars, &Capital);
//			CClassifierVector newVector;
//			newVector.SetCharName(VectorName);
//			newVector.SetNoOfChars(NoOfChars);
//			//m_pProbabilityVector[i].SetCharName(VectorName);
//			//m_pProbabilityVector[i].SetNoOfChars(NoOfChars);
//			bool val;
//			if (Capital == 1) val = true;
//			else val = false;
//			newVector.SetCapital(val);
//			//m_pProbabilityVector[i].SetCapital(val);
//			for (int j = 0; j < NoOfChars; j++)
//			{
//				//CCharVector charvector;
//				fscanf(pFile,"%d,%d,%d,%f,%d,%d,%d,%d,%d,%d,%d,%d", &VectorType, &VectorWidth, &VectorHeight, &VectorAspectRatio, &VMax, &HMax,&Divisions[0],&Divisions[1],&Divisions[2],&Divisions[3],&Divisions[4], &VCrossing);
//				m_pProbabilityVector[i].m_Vectors[j].SetCharName(VectorName);
//				m_pProbabilityVector[i].m_Vectors[j].SetCharType(VectorType);
//				m_pProbabilityVector[i].m_Vectors[j].SetWidth(VectorWidth);
//				m_pProbabilityVector[i].m_Vectors[j].SetHeight(VectorHeight);
//				m_pProbabilityVector[i].m_Vectors[j].SetAspectRatio(VectorAspectRatio);
//				m_pProbabilityVector[i].m_Vectors[j].SetVMax(VMax);
//				m_pProbabilityVector[i].m_Vectors[j].SetHMax(HMax);
//
//				//read VCrossings
//				m_pProbabilityVector[i].m_Vectors[j].SetNoCrossingV(VCrossing);
//				if (VCrossing > 0)
//				{
//					int cross, noCross;
//					CCharVector::CROSSINGS newCrossing;
//					//m_pProbabilityVector[i].m_Vectors[j].m_CrossingsV = 0;
//					//classVector.m_Vectors[j].m_CrossingsV = new CCharVector::CROSSINGS[VCrossing];
//					for (int x = 0; x < VCrossing; x++)
//					{
//						fscanf(pFile,",%d,%d",&cross,&noCross);
//						newCrossing.Crossings = cross;
//						newCrossing.NoCrossings = noCross;
//						m_pProbabilityVector[i].m_Vectors[j].m_CrossingsV.push_back(newCrossing);
//						//m_pProbabilityVector[i].m_Vectors[j].SetCrossingsValV(x,cross);
//						//m_pProbabilityVector[i].m_Vectors[j].SetCrossingsPercentV(x,noCross);
//					}
//				}
//				//read HCrossings
//			
//				fscanf(pFile,",%d", &HCrossing);
//				m_pProbabilityVector[i].m_Vectors[j].SetNoCrossingH(HCrossing);
//				if (HCrossing > 0)
//				{
//					int cross, noCross;
//					CCharVector::CROSSINGS newCrossing;
//					//m_pProbabilityVector[i].m_Vectors[j].m_CrossingsH = new CCharVector::CROSSINGS[HCrossing];
//					for (int x = 0; x < HCrossing; x++)
//					{
//						fscanf(pFile,",%d,%d",&cross,&noCross);
//						newCrossing.Crossings = cross;
//						newCrossing.NoCrossings = noCross;
//						m_pProbabilityVector[i].m_Vectors[j].m_CrossingsH.push_back(newCrossing);
//						//m_pProbabilityVector[i].m_Vectors[j].SetCrossingsValH(x,cross);
//						//m_pProbabilityVector[i].m_Vectors[j].SetCrossingsPercentH(x,noCross);
//					}
//				}				
//				fscanf(pFile,",%d,%d\n",&NoComp,&NoHoles);
//				m_pProbabilityVector[i].m_Vectors[j].SetNoComponents(NoComp);
//				m_pProbabilityVector[i].m_Vectors[j].SetNoHoles(NoHoles);
//			
//				for (int j = 0; j < 5; j++)
//				{
//					m_pProbabilityVector[i].m_Vectors[j].SetDivision(j,Divisions[j]);
//				}
//				//classVector.AddNewCharacter(charvector);
//				//m_pProbabilityVector[i] = classVector;
//			}
//		}
//		fclose(pFile);
//		
//		
//	}
////	ComputeContingencyTable();
//
//}
//void CDocImAnDoc::ImportClassifier()
//{
//	FILE * pFile;
//	int NoOfVectors;
//	char VectorName;
//	int Capital;
//	int NoOfChars;
//	int VectorType;
//	int VectorWidth;
//	int VectorHeight;
//	float VectorAspectRatio;
//	int VMax;
//	int HMax;
//	int VCrossing;
//	int HCrossing;
//	int NoComp;
//	int NoHoles;
//	int Divisions[5];
//	//m_pProbabilityVector = new CClassifierVector[62];
//	//m_ProbabilityVectorIndex = 0;
//	CClassifierVector classVector;
//	if (_tfopen(m_ClassifierFilePath, _T("r")))
//	{
//		pFile = _tfopen(m_ClassifierFilePath, _T("r"));
//		
//		fscanf(pFile,"%d\n",&NoOfVectors);
//		m_ProbabilityVectorIndex = NoOfVectors;
//		
//		
//		for (int i = 0; i < NoOfVectors;i++)
//		{
//		
//			fscanf(pFile,"%c,%d,%d\n",&VectorName, &NoOfChars, &Capital);
//			classVector.SetCharName(VectorName);
//			classVector.SetNoOfChars(NoOfChars);
//			bool val;
//			//if (Capital == 1) m_pProbabilityVector[i].SetCapital(true);
//			//else m_pProbabilityVector[i].SetCapital(false);
//			if (Capital == 1) val = true;
//			else val = false;
//			classVector.SetCapital(val);
//
//			//classVector.m_Vectors = new CCharVector[NoOfChars];
//
//			for (int j = 0; j < NoOfChars; j++)
//			{
//				CCharVector newVector;
//				fscanf(pFile,"%d,%d,%d,%f,%d,%d,%d,%d,%d,%d,%d,%d", &VectorType, &VectorWidth, &VectorHeight, &VectorAspectRatio, &VMax, &HMax,&Divisions[0],&Divisions[1],&Divisions[2],&Divisions[3],&Divisions[4], &VCrossing);
//				newVector.SetCharName(VectorName);
//				newVector.SetCharType(VectorType);
//				newVector.SetWidth(VectorWidth);
//				newVector.SetHeight(VectorHeight);
//				newVector.SetAspectRatio(VectorAspectRatio);
//				newVector.SetVMax(VMax);
//				newVector.SetHMax(HMax);
//
//				//read VCrossings
//				newVector.SetNoCrossingV(VCrossing);
//				if (VCrossing > 0)
//				{
//					int cross, noCross;
//					CCharVector::CROSSINGS newCrossing;
//					//m_pProbabilityVector[i].m_Vectors[j].m_CrossingsV = 0;
//					//classVector.m_Vectors[j].m_CrossingsV = new CCharVector::CROSSINGS[VCrossing];
//					for (int x = 0; x < VCrossing; x++)
//					{
//						fscanf(pFile,",%d,%d",&cross,&noCross);
//						newCrossing.Crossings = cross;
//						newCrossing.NoCrossings = noCross;
//						newVector.m_CrossingsV.push_back(newCrossing);
//						//m_pProbabilityVector[i].m_Vectors[j].SetCrossingsValV(x,cross);
//						//m_pProbabilityVector[i].m_Vectors[j].SetCrossingsPercentV(x,noCross);
//					}
//				}
//				//read HCrossings
//			
//				fscanf(pFile,",%d", &HCrossing);
//				newVector.SetNoCrossingH(HCrossing);
//				if (HCrossing > 0)
//				{
//					int cross, noCross;
//					CCharVector::CROSSINGS newCrossing;
//					//m_pProbabilityVector[i].m_Vectors[j].m_CrossingsH = new CCharVector::CROSSINGS[HCrossing];
//					for (int x = 0; x < HCrossing; x++)
//					{
//						fscanf(pFile,",%d,%d",&cross,&noCross);
//						newCrossing.Crossings = cross;
//						newCrossing.NoCrossings = noCross;
//						newVector.m_CrossingsH.push_back(newCrossing);
//						//m_pProbabilityVector[i].m_Vectors[j].SetCrossingsValH(x,cross);
//						//m_pProbabilityVector[i].m_Vectors[j].SetCrossingsPercentH(x,noCross);
//					}
//				}			
//				fscanf(pFile,",%d,%d\n",&NoComp,&NoHoles);
//				newVector.SetNoComponents(NoComp);
//				newVector.SetNoHoles(NoHoles);
//			
//				for (int j = 0; j < 5; j++)
//				{
//					newVector.SetDivision(j,Divisions[j]);
//				}
//			classVector.m_Vectors.push_back(newVector);
//			}
//		m_pProbabilityVector.push_back(classVector);
//		}
//		fclose(pFile);
//		
//		
//	}
//
//}
//void CDocImAnDoc::ExportClassifier()
//{
//	FILE * pFile;
//	pFile = _tfopen(m_ClassifierFilePath, _T("w"));
//	fprintf(pFile,"%d\n",m_ProbabilityVectorIndex);
//	for (int i = 0; i < m_ProbabilityVectorIndex; i++)
//	{
//		fprintf(pFile,"%c,%d,%d\n",m_pProbabilityVector[i].GetCharName(),m_pProbabilityVector[i].GetNoOfChars(),m_pProbabilityVector[i].GetCapital());
//
//
//		for (int j = 0; j < m_pProbabilityVector[i].GetNoOfChars();j++)
//		{
//			
//			fprintf(pFile,"%d,%d,%d,%f,%d,%d,%d,%d,%d,%d,%d",m_pProbabilityVector[i].m_Vectors[j].GetCharType(),m_pProbabilityVector[i].m_Vectors[j].GetWidth(),m_pProbabilityVector[i].m_Vectors[j].GetHeight(),m_pProbabilityVector[i].m_Vectors[j].GetAspectRatio(),m_pProbabilityVector[i].m_Vectors[j].GetVMax(),m_pProbabilityVector[i].m_Vectors[j].GetHMax(),m_pProbabilityVector[i].m_Vectors[j].GetDivision(0),m_pProbabilityVector[i].m_Vectors[j].GetDivision(1),m_pProbabilityVector[i].m_Vectors[j].GetDivision(2),m_pProbabilityVector[i].m_Vectors[j].GetDivision(3),m_pProbabilityVector[i].m_Vectors[j].GetDivision(4));
//			if (m_pProbabilityVector[i].m_Vectors[j].GetNoCrossingV()> 0 )
//			{
//				fprintf(pFile,",%d",m_pProbabilityVector[i].m_Vectors[j].GetNoCrossingV());
//				for (int x = 0; x < m_pProbabilityVector[i].m_Vectors[j].GetNoCrossingV(); x++)
//				{
//					fprintf(pFile,",%d",m_pProbabilityVector[i].m_Vectors[j].GetCrossingsValV(x));
//					fprintf(pFile,",%d",m_pProbabilityVector[i].m_Vectors[j].GetCrossingsPercentV(x));
//				}
//			}else fprintf(pFile,",%d",m_pProbabilityVector[i].m_Vectors[j].GetNoCrossingV());
//			if (m_pProbabilityVector[i].m_Vectors[j].GetNoCrossingH()> 0 )
//			{
//				fprintf(pFile,",%d",m_pProbabilityVector[i].m_Vectors[j].GetNoCrossingH());
//				for (int x = 0; x < m_pProbabilityVector[i].m_Vectors[j].GetNoCrossingH(); x++)
//				{
//					fprintf(pFile,",%d",m_pProbabilityVector[i].m_Vectors[j].GetCrossingsValH(x));
//					fprintf(pFile,",%d",m_pProbabilityVector[i].m_Vectors[j].GetCrossingsPercentH(x));
//				}
//			}else 
//				fprintf(pFile,",%d",m_pProbabilityVector[i].m_Vectors[j].GetNoCrossingH());
//			fprintf(pFile,",%d,%d\n",m_pProbabilityVector[i].m_Vectors[j].GetNoComponents(),m_pProbabilityVector[i].m_Vectors[j].GetNoHoles());
//
//		
//
//	//	CString imagename;
//	//	imagename.Format(_T("%s%c-%d.tif"),m_ClassifiedCharsPath,m_pProbabilityVector[i].m_Vectors[j].GetCharName(),j);
//	//	Exportimage(m_pProbabilityVector[i].m_Vectors[j].GetCharImage(),m_pProbabilityVector[i].m_Vectors[j].GetCharName(),m_ClassifiedCharsPath);
//	//	m_pProbabilityVector[i].m_Vectors[j].GetCharImage()->ExportTIFF((LPCTSTR)imagename);
//		}
//	}
//
//
//	fclose(pFile);		
//}
//void CDocImAnDoc::ExportClassifier()
//{
//	FILE * pFile;
//	pFile = _tfopen(m_ClassifierFilePath, _T("w"));
//	fprintf(pFile,"%d\n",m_pProbabilityVector.size());
//	for (int i = 0; i < (int)m_pProbabilityVector.size(); i++)
//	{
//		CClassifierVector newVector = m_pProbabilityVector[i];
//	
//		fprintf(pFile,"%c,%d,%d\n",newVector.GetCharName(),newVector.GetNoOfChars(),newVector.GetCapital());
//
//
//		for (int j = 0; j < (int)newVector.m_Vectors.size();j++)
//		{
//			
//			CCharVector charVector = newVector.m_Vectors[j];
//			fprintf(pFile,"%d,%d,%d,%f,%d,%d,%d,%d,%d,%d,%d",charVector.GetCharType(),charVector.GetWidth(),charVector.GetHeight(),charVector.GetAspectRatio(),charVector.GetVMax(),charVector.GetHMax(),charVector.GetDivision(0),charVector.GetDivision(1),charVector.GetDivision(2),charVector.GetDivision(3),charVector.GetDivision(4));
//			if (charVector.GetNoCrossingV()> 0 )
//			{
//				
//				fprintf(pFile,",%d",charVector.GetNoCrossingV());
//				for (int x = 0; x < charVector.GetNoCrossingV(); x++)
//				{
//					CCharVector::CROSSINGS crossingsV = charVector.m_CrossingsV[x];
//					fprintf(pFile,",%d",crossingsV.Crossings);
//					fprintf(pFile,",%d",crossingsV.NoCrossings);
//				}
//			}else fprintf(pFile,",%d",charVector.GetNoCrossingV());
//			if (charVector.GetNoCrossingH()> 0 )
//			{
//				fprintf(pFile,",%d",charVector.GetNoCrossingH());
//				for (int x = 0; x < charVector.GetNoCrossingH(); x++)
//				{
//					CCharVector::CROSSINGS crossingsH = charVector.m_CrossingsH[x];
//					fprintf(pFile,",%d",crossingsH.Crossings);
//					fprintf(pFile,",%d",crossingsH.NoCrossings);
//				}
//			}else 
//				fprintf(pFile,",%d",charVector.GetNoCrossingH());
//			fprintf(pFile,",%d,%d\n",charVector.GetNoComponents(),charVector.GetNoHoles());
//
//		
//
//		}
//	}
//	m_pProbabilityVector.empty();
//
//	fclose(pFile);		
//
//
//}
void CDocImAnDoc::ExportClassifier()
{
	FILE * pFile;

	/*char SCharType[] = "Char Type";
	char SWidth[] = "Char Width";
	char SHeight[] = "Char Height";
	char SAspRatio[] = "Aspect Ratio";
	char SVMax[] = "V Max";
	char SHMax[] = "H Max";
	char SDivision0[] = "TL Div";
	char SDivision1[] = "TR Div";
	char SDivision2[] = "BL Div";
	char SDivision3[] = "BR Div";
	char SDivision4[] = "Centre Div";
	char SNoCrossV[] = "NoCrossings V";
	char SNoCrossH[] = "NoCrossings H";
	char SWeight[] = "Char Weight";*/

	pFile = _tfopen(m_ClassifierFilePath, _T("w"));
	//fprintf(pFile,"%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s\n",SCharType,SWidth,SHeight,SAspRatio,SVMax,SHMax,SDivision0,SDivision1,SDivision2,SDivision3,SDivision4,SNoCrossV, SNoCrossH);
	fprintf(pFile,"%d\n",m_ProbabilityVectorIndex);
	for (int i = 0; i < m_ProbabilityVectorIndex; i++)
	{
		//CClassifierVector newVector = m_pProbabilityVector[i];
		int capital;
		if (m_pProbabilityVector[i].GetCapital() == true)
		{
			capital = 1;
		}
		else capital = 0;
		fprintf(pFile,"%c,%d,%d\n", m_pProbabilityVector[i].GetCharName(), m_pProbabilityVector[i].GetNoOfChars(), capital);


		for (int j = 0; j <  m_pProbabilityVector[i].GetNoOfChars();j++)
		{
			
			//CCharVector charVector =  m_pProbabilityVector[i].m_Vectors[j];
			fprintf(pFile,"%d,%d,%d,%f,%d,%d",m_pProbabilityVector[i].m_Vectors[j].GetCharType(),m_pProbabilityVector[i].m_Vectors[j].GetWidth(),m_pProbabilityVector[i].m_Vectors[j].GetHeight(),m_pProbabilityVector[i].m_Vectors[j].GetAspectRatio(),m_pProbabilityVector[i].m_Vectors[j].GetVMax(),m_pProbabilityVector[i].m_Vectors[j].GetHMax());
			
			
			/*if (m_pProbabilityVector[i].m_Vectors[j].GetNoCrossingV()> 0 )
			{
				
				fprintf(pFile,",%d",m_pProbabilityVector[i].m_Vectors[j].GetNoCrossingV());
				for (int x = 0; x < m_pProbabilityVector[i].m_Vectors[j].GetNoCrossingV(); x++)
				{
					CCharVector::CROSSINGS crossingsV = m_pProbabilityVector[i].m_Vectors[j].m_CrossingsV[x];
					fprintf(pFile,",%d",crossingsV.Crossings);
					fprintf(pFile,",%d",crossingsV.NoCrossings);
				}
			}else*/ fprintf(pFile,",%d",m_pProbabilityVector[i].m_Vectors[j].GetNoCrossingV());
			/*if (m_pProbabilityVector[i].m_Vectors[j].GetNoCrossingH()> 0 )
			{
				fprintf(pFile,",%d",m_pProbabilityVector[i].m_Vectors[j].GetNoCrossingH());
				for (int x = 0; x < m_pProbabilityVector[i].m_Vectors[j].GetNoCrossingH(); x++)
				{
					CCharVector::CROSSINGS crossingsH = m_pProbabilityVector[i].m_Vectors[j].m_CrossingsH[x];
					fprintf(pFile,",%d",crossingsH.Crossings);
					fprintf(pFile,",%d",crossingsH.NoCrossings);
				}
			}else */
				fprintf(pFile,",%d",m_pProbabilityVector[i].m_Vectors[j].GetNoCrossingH());
			int weight = m_pProbabilityVector[i].m_Vectors[j].GetWeight();
			fprintf(pFile,",%d,%d,%d,%d,%d",m_pProbabilityVector[i].m_Vectors[j].GetNoComponents(),m_pProbabilityVector[i].m_Vectors[j].GetNoHoles(),m_pProbabilityVector[i].m_Vectors[j].GetWeight(),m_pProbabilityVector[i].m_Vectors[j].GetHMaxDistance(),m_pProbabilityVector[i].m_Vectors[j].GetVMaxDistance());
			for (int x = 0; x < 25; x++)
			{
				fprintf(pFile,",%d",m_pProbabilityVector[i].m_Vectors[j].GetDivision(x));
			}
			fprintf(pFile,"\n");
		

		}
	}
	
	fclose(pFile);		


}
int CDocImAnDoc::ComputeTotalNumberofVectors()
{
	int totalVectorsCT = 0;
	if (m_ProbabilityVectorIndex > 0)
	{
		//for each character
		for (int i = 0; i < m_ProbabilityVectorIndex; i++)
		{
			totalVectorsCT += m_pProbabilityVector[i].GetNoOfChars();
		}
	}
	return totalVectorsCT;
}
void CDocImAnDoc::ComputeContingencyTable()
{
	m_nFeatures = 38;
	CString tracex;
	m_totalVectorsCT = 0;
	if (m_ProbabilityVectorIndex > 0)
	{
		//for each character
		m_ppContingencyTable = new CTABLE[m_ProbabilityVectorIndex];
		for (int i = 0; i < m_ProbabilityVectorIndex; i++)
		{
			//trace
			tracex.Format(_T("Character-%c"),m_pProbabilityVector[i].GetCharName());

			TRACE(tracex);
			m_ppContingencyTable[i].capital = m_pProbabilityVector[i].GetCapital();
			m_ppContingencyTable[i].name = m_pProbabilityVector[i].GetCharName();
			m_ppContingencyTable[i].Features = new CFEATURE[m_nFeatures];
			m_ppContingencyTable[i].TotalVectors = 0;
			//for each of the vectors update the table
			//create 20 different feature values max
			for (int x = 0; x < m_nFeatures; x++)
			{
				m_ppContingencyTable[i].Features[x].noOfValues = 0;
				m_ppContingencyTable[i].Features[x].pos = x;
				m_ppContingencyTable[i].Features[x].total = 0;
				m_ppContingencyTable[i].Features[x].Values = new CCOUNT[50];

				for (int y = 0; y < 50; y++)
				{
					m_ppContingencyTable[i].Features[x].Values[y].count = 0;
					m_ppContingencyTable[i].Features[x].Values[y].val = -1;
				}

			}
			for (int j = 0; j < m_pProbabilityVector[i].GetNoOfChars(); j++)
			{

				//add type = 0
				AddFeatureToTable(i,0,m_pProbabilityVector[i].m_Vectors[j].GetCharType());
				//add VMax = 1
				AddFeatureToTable(i,1,m_pProbabilityVector[i].m_Vectors[j].GetVMax());
				//add HMax = 2
				AddFeatureToTable(i,2,m_pProbabilityVector[i].m_Vectors[j].GetHMax());
				//add Width = 3
				AddFeatureToTable(i,3,m_pProbabilityVector[i].m_Vectors[j].GetWidth());
				//add Height = 4
				AddFeatureToTable(i,4,m_pProbabilityVector[i].m_Vectors[j].GetHeight());
				//add AR = 5
				float val1 = m_pProbabilityVector[i].m_Vectors[j].GetAspectRatio()*10;
				int val1i = (int) val1;
				float val1f = (float) val1i/10;
				AddFeatureToTable(i,5,val1f);
				//add NoOfCrossH = 6
				AddFeatureToTable(i,6,m_pProbabilityVector[i].m_Vectors[j].GetNoCrossingH());
				//add NoOfCrossV = 7
				AddFeatureToTable(i,7,m_pProbabilityVector[i].m_Vectors[j].GetNoCrossingV());
				//add Weight = 8
				AddFeatureToTable(i,8,m_pProbabilityVector[i].m_Vectors[j].GetWeight());
				//add NoOfHoles = 9
				AddFeatureToTable(i,9,m_pProbabilityVector[i].m_Vectors[j].GetNoHoles());
				//add NoOfConnectedComp = 10
				AddFeatureToTable(i,10,m_pProbabilityVector[i].m_Vectors[j].GetNoComponents());
				//add HMaxDistance = 11
				AddFeatureToTable(i,11,m_pProbabilityVector[i].m_Vectors[j].GetHMaxDistance());
				//add VMaxDistance = 12
				AddFeatureToTable(i,12,m_pProbabilityVector[i].m_Vectors[j].GetVMaxDistance());
				int val = 13;
				for (int x = 0; x < 25; x++)
				{	
					AddFeatureToTable(i,val,m_pProbabilityVector[i].m_Vectors[j].GetDivision(x));
					val++;
				}
				

			}

		}
	}
	m_bIsTableCreated = true;
}


void CDocImAnDoc::DeleteContingencyTable()
{
	for (int i = 0; i < m_ProbabilityVectorIndex; i++)
	{
		for (int x = 0; x < m_nFeatures; x++)
		{
			//delete m_ppContingencyTable[i].Features[x].Values;
		}
		//delete m_ppContingencyTable[i].Features;
	}
	//delete m_ppContingencyTable;
}
void CDocImAnDoc::AddFeatureToTable(int character,int featureNo, int val)
{
	
	int count = 0;
	bool found = false;
	while((count < m_ppContingencyTable[character].Features[featureNo].noOfValues) && (found == false))
	{
		if (m_ppContingencyTable[character].Features[featureNo].Values[count].val == val)
		{
			m_ppContingencyTable[character].Features[featureNo].Values[count].count++;
			
			found = true;
		}
		count++;
	}
	if (found == false)
	{
		m_ppContingencyTable[character].Features[featureNo].Values[m_ppContingencyTable[character].Features[featureNo].noOfValues].val = val;
		m_ppContingencyTable[character].Features[featureNo].Values[m_ppContingencyTable[character].Features[featureNo].noOfValues].count = 1;
		m_ppContingencyTable[character].Features[featureNo].noOfValues++;

	}
	m_ppContingencyTable[character].Features[featureNo].total++;
}
void CDocImAnDoc::AddFeatureToTable(int character,int featureNo, float val)
{
	
	int count = 0;
	bool found = false;
	while((count < m_ppContingencyTable[character].Features[featureNo].noOfValues) && (found == false))
	{
		if (m_ppContingencyTable[character].Features[featureNo].Values[count].val1 == val)
		{
			m_ppContingencyTable[character].Features[featureNo].Values[count].count++;
			
			found = true;
		}
		count++;
	}
	if (found == false)
	{
		m_ppContingencyTable[character].Features[featureNo].Values[m_ppContingencyTable[character].Features[featureNo].noOfValues].val1 = val;
		m_ppContingencyTable[character].Features[featureNo].Values[m_ppContingencyTable[character].Features[featureNo].noOfValues].count = 1;
		m_ppContingencyTable[character].Features[featureNo].noOfValues++;

	}
	m_ppContingencyTable[character].Features[featureNo].total++;
}
void CDocImAnDoc::TraceFeatureTable()
{
	CString val1;
	for (int i = 0; i < m_ProbabilityVectorIndex; i++)
	{
		val1.Format(_T("Character-%c\n"),m_ppContingencyTable[i].name);
		TRACE(val1);
		for (int j = 0; j < m_nFeatures; j++)
		{
			val1.Format(_T("-Feature-%d\n"),j);
			TRACE(val1);
			for (int k = 0; k < m_ppContingencyTable[i].Features[j].noOfValues; k++)
			{
				val1.Format(_T("Value: %d, %d times\n"),m_ppContingencyTable[i].Features[j].Values[k].val,m_ppContingencyTable[i].Features[j].Values[k].count);
				TRACE(val1);
			}
		}
		
	}
}

void CDocImAnDoc::ExportFeatureTable()
{
	FILE * pFile;
	CString filename;
	filename.Format(_T("%sFeatureTable.csv"),m_ClassifiedCharsPath);
	pFile = _tfopen(filename, _T("w"));
	CString val1;
	
	for (int i = 0; i < m_ProbabilityVectorIndex; i++)
	{
		val1.Format(_T("Character-%c\n"),m_ppContingencyTable[i].name);
		//TRACE(val1);
		fprintf(pFile,"%s\n",val1);
		for (int j = 0; j < m_nFeatures; j++)
		{
			val1.Format(_T("-Feature-%d\n"),j);
			//TRACE(val1);
			fprintf(pFile,"%s\n",val1);
			for (int k = 0; k < m_ppContingencyTable[i].Features[j].noOfValues; k++)
			{
				val1.Format(_T("Value: %d, %d times\n"),m_ppContingencyTable[i].Features[j].Values[k].val,m_ppContingencyTable[i].Features[j].Values[k].count);
				//TRACE(val1);
				fprintf(pFile,"%s\n",val1);
			}
		}
		
	}
	fclose(pFile);
}

void CDocImAnDoc::RecogniseUsingProbabilities()
{

	int size = 5;
	int uno;
	if /*((m_bIsImageImproved) && */(m_bIsTableCreated)//)
	{
		//for each of the characters create a feature Vector
		CreateNewUndoImage(0);
		for (int a = 0; a < GetUndoImage(m_index -1)->GetWidth(); a++)
		{
			for (int b = 0; b <  GetUndoImage(m_index -1)->GetHeight(); b++)
			{
				GetUndoImage(m_index-1)->SetRGBColor(a,b,RGB(255,255,255));
			}
		}
		for (int i = 0; i < m_LineHolderIndex; i++)
		{
			for (int j = 0; j < m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				
				
				CDIACharacter * character;
				character = new CDIACharacter;
			
				m_pLineHolder[i].m_pCharacterHolder[j].ExtractFeatures();
				character = &m_pLineHolder[i].m_pCharacterHolder[j];
				CCharVector vector;
				character->ExtractFeatures();
				character->CreateCharImage(GetUndoImage(m_index-2),false);
				character->CreateLocatedCharImage(character->m_pCharImage,true);
				character->ExtractFeatures();
				vector.CreateVectorFromCharacter(character);

				float * prob = new float[m_ProbabilityVectorIndex];
				prob = CalculateProbabilities2(vector);

				float * probDistri = new float[m_ProbabilityVectorIndex];
				probDistri = CalculateDivisionsProbabilities(vector);

				//
			//	for (int x = 0; x < m_ProbabilityVectorIndex; x++)
			//	{
			//		prob[x] = prob[x] * probDistri[x];
			//	}
				//
				//
//				//output prob
//					CString pathName;
//					pathName.Format(_T("%s\\Probabilities.txt"),m_ClassifiedCharsPath);
//					FILE * pFile;
//					pFile = _tfopen(pathName, _T("a"));
//					fprintf(pFile,"Exporting Probabilities. Line: %d Character: %d\n",i,j);
//					for (int x = 0; x < m_ProbabilityVectorIndex; x++)
//					{
//						fprintf(pFile,"%d--%f\n",x,prob[x]);
//					}
//					fclose(pFile);
//				//
//
//					//output probDistrib
////					CString pathName;
//					pathName.Format(_T("%s\\Probabilities.txt"),m_ClassifiedCharsPath);
//					//FILE * pFile;
//					pFile = _tfopen(pathName, _T("a"));
//					fprintf(pFile,"Exporting Distribution Probabilities. Line: %d Character: %d\n",i,j);
//					for (int x = 0; x < m_ProbabilityVectorIndex; x++)
//					{
//						fprintf(pFile,"%d--%f\n",x,probDistri[x]);
//					}
//					fclose(pFile);
//				//
				int * highest = new int[size];
				highest = FindHighest(prob,m_ProbabilityVectorIndex,size);


				//black character
				CDIACharacter* char2;
				char2 = new CDIACharacter;
				char2 = character;
				CRect rect(0,0,char2->m_LocatedWidth,char2->m_LocatedHeight);
				char2->ApplyThreshold(char2->m_pLocatedCharImage,rect,250);
				char2->ExtractFeatures();
				
				CCharVector Vector2;
				Vector2.CreateVectorFromCharacter(char2);
				float * prob2 = new float[m_ProbabilityVectorIndex];
				prob2 = CalculateProbabilities2(Vector2);

				float * probDistri2 = new float[m_ProbabilityVectorIndex];
				probDistri2 = CalculateDivisionsProbabilities(Vector2);


				//
			
//				//output prob2
//					
//					pathName.Format(_T("%s\\Probabilities.txt"),m_ClassifiedCharsPath);
////					FILE * pFile;
//					pFile = _tfopen(pathName, _T("a"));
//					fprintf(pFile,"Exporting Probabilities 2. Line: %d Character: %d\n",i,j);
//					for (int x = 0; x < m_ProbabilityVectorIndex; x++)
//					{
//						fprintf(pFile,"%d--%f\n",x,prob[x]);
//					}
//					fclose(pFile);
//				//
//					//output prob Distri 2
//					//CString pathName;
//					pathName.Format(_T("%s\\Probabilities.txt"),m_ClassifiedCharsPath);
//					//FILE * pFile;
//					pFile = _tfopen(pathName, _T("a"));
//					fprintf(pFile,"Exporting Distribution Probabilities 2. Line: %d Character: %d\n",i,j);
//					for (int x = 0; x < m_ProbabilityVectorIndex; x++)
//					{
//						fprintf(pFile,"%d--%f\n",x,probDistri2[x]);
//					}
//					fclose(pFile);
//				//
				
				int * highest2 = new int[size];
				highest2 = FindHighest(prob2,m_ProbabilityVectorIndex,size);
				
				//join both highest removing repeted values
				int newsize = size*2;
				INFO highestvals[10];
				
				for (int x = 0; x < size; x++)
				{
					highestvals[x].Pos = highest[x];
					highestvals[x].Name = m_pProbabilityVector[highest[x]].GetCharName();
					highestvals[x].Capital = m_pProbabilityVector[highest[x]].GetCapital();
					highestvals[x].Val = prob[highest[x]];
					highestvals[x].Cost = GetCost(highestvals[x],character->m_pLocatedCharImage);
					for (int y = 0; y < size; y++)
					{
						if (highest2[y] == highest[x])
						{
							highest2[y] = -1;
						}
					}
				}
				uno = 0;
				for (int x = 0; x < size; x++)
				{
					if (highest2[x] >= 0)
					{
						highestvals[size+uno].Pos = highest2[x];
						highestvals[size+uno].Capital = m_pProbabilityVector[highest2[x]].GetCapital();
						highestvals[size+uno].Name = m_pProbabilityVector[highest2[x]].GetCharName();
						highestvals[size+uno].Val = prob2[highest2[x]];
						highestvals[size+uno].Cost = GetCost(highestvals[size+uno],character->m_pLocatedCharImage);
						uno++;
					}
				}
				//export highestvals
				CString pathName;
				pathName.Format(_T("%s\\Probabilities.txt"),m_ClassifiedCharsPath);
				FILE * pFile;
				pFile = _tfopen(pathName, _T("a"));
				fprintf(pFile,"Exporting highestvals Probabilities. Line: %d Character: %d\n",i,j);
				for (int x = 0; x < 10; x++)
				{
					
					fprintf(pFile," %c -- Cost: %d,Prob: %d\n",highestvals[x].Name,highestvals[x].Cost,(int)highestvals[x].Val);
					fprintf(pFile,"-----------------------------------------------------------------\n");
				}
				fclose(pFile);
				//

				INFO mini[3];
				for (int y = 0; y < 3; y++)
				{
					mini[y].Capital = highestvals[0].Capital;
					mini[y].Name = highestvals[0].Name;
					mini[y].Pos = highestvals[0].Pos;
					mini[y].Val = highestvals[0].Val;
					mini[y].Cost = highestvals[0].Cost;
				}
				for (int x = 0; x < (size+uno);x++)
				{
					int cost = GetFlexCost(highestvals[x],character->m_pLocatedCharImage);
					if ((highestvals[x].Cost <= mini[0].Cost) && (highestvals[x].Name != mini[0].Name))
					{
						mini[2].Capital = mini[1].Capital;
						mini[2].Name = mini[1].Name;
						mini[2].Cost = mini[1].Cost;
						mini[2].Pos = mini[1].Pos;

						mini[1].Capital = mini[0].Capital;
						mini[1].Cost = mini[0].Cost;
						mini[1].Name = mini[0].Name;
						mini[1].Pos = mini[0].Pos;

						mini[0].Capital = highestvals[x].Capital;
						mini[0].Name = highestvals[x].Name;
						mini[0].Cost = highestvals[x].Cost;
						mini[0].Pos = highestvals[x].Pos;
						
					}
					else if ((highestvals[x].Cost <= mini[1].Cost) && (highestvals[x].Name != mini[1].Name))
					{
						mini[2].Capital = mini[1].Capital;
						mini[2].Name = mini[1].Name;
						mini[2].Cost = mini[1].Cost;
						mini[2].Pos = mini[1].Pos;
						
						mini[1].Capital = highestvals[x].Capital;
						mini[1].Cost = highestvals[x].Cost;
						mini[1].Name = highestvals[x].Name;
						mini[1].Pos = highestvals[x].Pos;

					}else if ((highestvals[x].Cost < mini[2].Cost) && (highestvals[x].Name != mini[2].Name))
					{
						mini[2].Capital = highestvals[x].Capital;
						mini[2].Name = highestvals[x].Name;
						mini[2].Cost = highestvals[x].Cost;
						mini[2].Pos = highestvals[x].Pos;
					}
				}

			//for each mini find the distrib prob

			/*		float mini0Distance = CalculateDivisionsDistance(mini[0].Pos,vector);
					float mini0Prob = probDistri[mini[0].Pos];
					float mini1Distance = CalculateDivisionsDistance(mini[1].Pos,vector);
					float mini1Prob = probDistri[mini[1].Pos];
					float mini2Distance = CalculateDivisionsDistance(mini[2].Pos,vector);
					float mini2Prob = probDistri[mini[2].Pos];*/
				
					m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[0].charname = mini[0].Name;
					m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[0].isCapital = mini[0].Capital;
					m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[0].rate = prob[mini[0].Pos];

					m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[1].charname = mini[1].Name;
					m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[1].isCapital = mini[1].Capital;
					m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[1].rate = prob[mini[1].Pos];

					m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[2].charname = mini[2].Name;
					m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[2].isCapital = mini[2].Capital;
					m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[2].rate = prob[mini[2].Pos];
				
					//paste in new image
				CImage* loadedImage;
				//CString pathName;
				if (m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[0].isCapital)
				{	
					pathName.Format(_T("%s%c.tif"),m_PerfectCapitalImagePath,m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[0].charname);
					TRACE(_T("%s\n"),pathName);
				}
				else
				{
					pathName.Format(_T("%s%c.tif"),m_PerfectImagePath,m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[0].charname);
					TRACE(_T("%s\n"),pathName);
				}
				
				loadedImage = ImgLoadFromFile((LPCTSTR)pathName, 
				RUNTIME_CLASS(CDIAHiColorImage),
				NULL,
				RUNTIME_CLASS(CDIAGreyScale),
				RUNTIME_CLASS(CDIABiLevelImage));
				//paste it in m_pRecognizedImage
				for (int x = 0; x < loadedImage->GetWidth(); x++)
				{
					for (int y = 0; y < loadedImage->GetHeight(); y++)
					{
						//copy the pixels into the right position
						int xPos,yPos;
						xPos = m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left + x;
						yPos = m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top + y;
						int color = (int) GetRValue(loadedImage->GetRGBColor(x,y));
						GetActiveImage()->SetRGBColor(xPos,yPos,RGB(color,color,color));
						
					}
				}
			
			}
		}
	}
	m_bIsImageRecognized = true;

}
int GetMaxPos(float * vals, int size)
{
	float maxval = 0.00;
	int maxpos = 0;
	for (int i = 0; i < size;i++)
	{
		if (vals[i] >= maxval)
		{
			maxval = vals[i];
			maxpos = i;
		}

	}
	return maxpos;

}
int* CDocImAnDoc::FindHighest(float * prob, int size, int total)
{
	int * index = new int[total];
	int * maxpos = new int[size];
	float * maxval = new float[size];
	float * temp = new float[size];
	for (int i = 0; i < size;i++)
	{
		temp[i] = prob[i];
		maxval[i] = 0.00;
		maxpos[i] = 0;
	}
	for (int i = 0; i < size; i++)
	{
		maxpos[i] = GetMaxPos(temp,size);
		temp[maxpos[i]] = -1;
	}
	for (int i = 0; i < total; i++)
	{
		index[i] = maxpos[i];
	}
	return index;
}
int* CDocImAnDoc::FindHighest(float * prob, int size)
{
	int * index = new int[3];
	index[0] = -1;
	index[1] = -1;
	index[2] = -1;
	float vals[3] = {0,0,0};
	/*vals[0] = 0;
	vals[1] = 0;
	vals[2] = 0;*/
	for(int i = 0; i < size; i++)
	{
		if (prob[i] >= vals[0])
		{
			//then it is the highest
			//swift the other two values
			vals[2] = vals[1];
			index[2] = index[1];
			vals[1] = vals[0];
			index[1] = index[0];
			vals[0] = prob[i];
			index[0] = i;
		}
		else if (prob[i] >= vals[1])
		{
			//it is the second highest
			vals[2] = vals[1];
			index[2] = index[1];
			vals[1] = prob[i];
			index[1] = i;
		}
		else if (prob[i] > vals[2])
		{
			vals[2] = prob[i];
			index[2] = i;
		}
	}
	return index;

}
float * CDocImAnDoc::CalculateProbabilities(CCharVector &vector)
{
	//calculates the probability for each character in the contingencyTable
	//returns an array of with all the probabilities
	float * resultsVector;
	resultsVector = new float[m_ProbabilityVectorIndex];
	for (int i = 0; i < m_ProbabilityVectorIndex; i++)
	{
		resultsVector[i] = 0.00;
	}
	
	for (int i = 0; i < m_ProbabilityVectorIndex; i++)
	{
		
		//one for each feature

			resultsVector[i] = resultsVector[i] + GetPobability(i, 0, vector.GetCharType());
			resultsVector[i] = resultsVector[i] + GetPobability(i, 1, vector.GetVMax());
			resultsVector[i] = resultsVector[i] + GetPobability(i, 2, vector.GetHMax());

			//resultsVector[i] = resultsVector[i] + GetPobability(i, 3, vector.GetWidth());
			//resultsVector[i] = resultsVector[i] + GetPobability(i, 4, vector.GetHeight());

			resultsVector[i] = resultsVector[i] + GetPobability(i, 5, vector.GetAspectRatio());
			resultsVector[i] = resultsVector[i] + GetPobability(i, 6, vector.GetDivision(0));
			resultsVector[i] = resultsVector[i] + GetPobability(i, 7, vector.GetDivision(1));
			resultsVector[i] = resultsVector[i] + GetPobability(i, 8, vector.GetDivision(2));
			resultsVector[i] = resultsVector[i] + GetPobability(i, 9, vector.GetDivision(3));
			resultsVector[i] = resultsVector[i] + GetPobability(i, 10, vector.GetDivision(4));
			resultsVector[i] = resultsVector[i] + GetPobability(i, 11, vector.GetNoCrossingH());
			resultsVector[i] = resultsVector[i] + GetPobability(i, 12, vector.GetNoCrossingV());
			resultsVector[i] = resultsVector[i] + GetPobability(i, 13, vector.GetWeight());
			resultsVector[i] = resultsVector[i] + GetPobability(i, 14, vector.GetNoHoles());
			resultsVector[i] = resultsVector[i] + GetPobability(i, 15, vector.GetNoComponents());
			resultsVector[i] = resultsVector[i] + GetPobability(i, 16, vector.GetHMaxDistance());
			resultsVector[i] = resultsVector[i] + GetPobability(i, 17, vector.GetVMaxDistance());
	}
	return resultsVector;


	
}

float * CDocImAnDoc::CalculateProbabilities2(CCharVector &vector)
{
	//calculates the probability for each character in the contingencyTable
	//returns an array of with all the probabilities
	float * resultsVector;
	resultsVector = new float[m_ProbabilityVectorIndex];
	for (int i = 0; i < m_ProbabilityVectorIndex; i++)
	{
		resultsVector[i] = 1.00;
	}
	
	for (int i = 0; i < m_ProbabilityVectorIndex; i++)
	{
		
		//one for each feature
			float prior = CalculatePriorProbability(i);
			resultsVector[i] = resultsVector[i] * GetPobability(i, 0, vector.GetCharType());
			resultsVector[i] = resultsVector[i] * GetPobability(i, 1, vector.GetVMax());
			resultsVector[i] = resultsVector[i] * GetPobability(i, 2, vector.GetHMax());

			if (vector.GetCharType() != 0)
			{
				resultsVector[i] = resultsVector[i] * GetPobability(i, 8, vector.GetWeight());
			}
			for (int x = 0; x < 25;x++)
			{
				resultsVector[i] = resultsVector[i] * GetPobability(i,x + 13,vector.GetDivision(x));
			}
			resultsVector[i] = resultsVector[i] * CalculatePriorProbability(i);

		//	resultsVector[i] = resultsVector[i] * GetPobability(i, 14, vector.GetNoHoles());
		//	resultsVector[i] = resultsVector[i] * GetPobability(i, 15, vector.GetNoComponents());
		//	resultsVector[i] = resultsVector[i] * GetPobability(i, 16, vector.GetHMaxDistance());
		//	resultsVector[i] = resultsVector[i] * GetPobability(i, 17, vector.GetVMaxDistance());
			//
			//Prob(This character is an 'A' | We know this character has VMax = 2 and We know this character has HMax = 3)
			//= (Probability(That a character is an 'A') 
			//* Probability(That a character which is an 'A' has VMax = 2) 
			//* Probability(That a character which is an 'A' and has VMax = 2 also has HMax=3)) 
			// / (Probability(That a character has VMax = 2) 
			// * Probability(That a character which has VMax = 2 also has HMax = 3))

			//
	}
	return resultsVector;

	
}
float * CDocImAnDoc::CalculateDivisionsProbabilities(CCharVector &vector)
{
	//calculates the probability for each character in the contingencyTable
	//returns an array of with all the probabilities
	float * resultsVector;
	resultsVector = new float[m_ProbabilityVectorIndex];
	for (int i = 0; i < m_ProbabilityVectorIndex; i++)
	{
		resultsVector[i] = 1.00;
	}
	
	for (int i = 0; i < m_ProbabilityVectorIndex; i++)
	{
		
		//one for each feature
			float prior = CalculatePriorProbability(i);
			for (int j = 0; j < 25; j++)
			{
				float val = GetPobability(i, j + 13 , vector.GetDivision(j));
				resultsVector[i] = resultsVector[i] * GetPobability(i, j + 13 , vector.GetDivision(j));
			}
			resultsVector[i] = resultsVector[i]/25;
			resultsVector[i] = resultsVector[i] * CalculatePriorProbability(i);
		
	}
	return resultsVector;

	
}
float CDocImAnDoc::CalculateDivisionsDistance(int charPos,CCharVector vector)
{
	//calculates the probability for each character in the contingencyTable
	//returns an array of with all the probabilities
	
	float  resultsVector = 0;
	//resultsVector = new float[m_ProbabilityVectorIndex];
	/*for (int i = 0; i < m_ProbabilityVectorIndex; i++)
	{
		resultsVector[i] = 0.00;
	}*/
	
	//for (int i = 0; i < m_ProbabilityVectorIndex; i++)
//	{
		
		//one for each feature
		//	float prior = CalculatePriorProbability(i);
			for (int j = 0; j < 25; j++)
			{
			//	float val = GetPobability(i, j + 13 , vector.GetDivision(j));
				resultsVector = resultsVector + ComputeDistanceDiv(charPos, j + 13 , vector.GetDivision(j));
			}
			//resultsVector[i] = resultsVector[i]/25;
			//resultsVector[i] = resultsVector[i] + CalculatePriorProbability(i);
		
	//}
	return resultsVector;
	
	

	
}
float CDocImAnDoc::ComputeDistanceDiv(int charnum,int featureNo,int val)
{
	//compute average
	int acc = 0;
	int count = 0;
	for (int i = 0; i < m_ppContingencyTable[charnum].Features[featureNo].noOfValues; i++)
	{
		acc = acc + (m_ppContingencyTable[charnum].Features[featureNo].Values[i].val * m_ppContingencyTable[charnum].Features[featureNo].Values[i].count);
		count = count + m_ppContingencyTable[charnum].Features[featureNo].Values[i].count;
	}
	float average = (float)acc/(float)count;
	float result = pow(abs(average-val),2);
	return result;
}

float CDocImAnDoc::GetCombinedProbability(int charnum, int featureNo1, int val1, int featureNo2, int val2)
{
	
	bool found = false;
	int total = 0;
	for (int i = 0; i < m_pProbabilityVector[charnum].GetNoOfChars(); i++)
	{
		if ((m_pProbabilityVector[charnum].m_Vectors[i].GetFeatureNumber(featureNo1) == val1) && (m_pProbabilityVector[charnum].m_Vectors[i].GetFeatureNumber(featureNo2) == val2))
		{
			total++;
		}
	}
	if (total != 0)
	{
		return (float)total/(float)m_pProbabilityVector[charnum].GetNoOfChars();
	}else
	{
		//return (float)1/((float)m_pProbabilityVector[charnum].GetNoOfChars()*10);
		return 0.00;
	}
	/*for (int i = 0; i < m_ppContingencyTable[charnum].Features[featureNo1].noOfValues; i++)
	{
		if (m_ppContingencyTable[charnum].Features[featureNo1].Values[i].val == val1)
		{
			for (int j = 0; j < m_ppContingencyTable[charnum].Features[featureNo2].noOfValues; j++)
			{
				if (m_ppContingencyTable[charnum].Features[featureNo2].Values[i].val == val2)
				{
					prob = (float)m_ppContingencyTable[charnum].Features[featureNo1].Values[i].count / (float)m_ppContingencyTable[charnum].Features[featureNo].total;
					found = true;
				}
		}

	}*/

}
//float CDocImAnDoc::GetDivPobability(int charnum, int featureNo, int val)
//{
//	float prob;
//	bool found = false;
//	int total = 0;
//	for (int i = 0; i < m_ppContingencyTable[charnum].Features[featureNo].noOfValues; i++)
//	{
//		if (m_ppContingencyTable[charnum].Features[featureNo].Values[i].val == val)
//		{
//			prob = (float)m_ppContingencyTable[charnum].Features[featureNo].Values[i].count / (float)m_ppContingencyTable[charnum].Features[featureNo].total;
//			
//			found = true;
//		}
//
//	}
//	
//	if (!found)
//	{
//		//prob = (float)1/((float)m_pProbabilityVector[charnum].GetNoOfChars()*10);
//		prob = 0.00;
//	}
//	return prob;
//}
float CDocImAnDoc::GetPobability(int charnum, int featureNo, int val)
{
	float prob;
	bool found = false;
	int total = 0;
	for (int i = 0; i < m_ppContingencyTable[charnum].Features[featureNo].noOfValues; i++)
	{
		if (m_ppContingencyTable[charnum].Features[featureNo].Values[i].val == val)
		{
			prob = (float)m_ppContingencyTable[charnum].Features[featureNo].Values[i].count / (float)m_ppContingencyTable[charnum].Features[featureNo].total;
			
			found = true;
		}

	}
	
	if (!found)
	{
		prob = (float)1/((float)m_pProbabilityVector[charnum].GetNoOfChars()*10);
		//prob = 0.00;
	}
	return prob;
}
float CDocImAnDoc::GetPobability(int charnum, int featureNo, float val)
{
	float prob;
	bool found = false;
	for (int i = 0; i < m_ppContingencyTable[charnum].Features[featureNo].noOfValues; i++)
	{
		val = val*10;
		int val1 =(int) val;
		float val1f = (float) val1 /10 ;

		float val22 = (float)m_ppContingencyTable[charnum].Features[featureNo].Values[i].val*10;
		int val2 = (int) val22;
		float val2f = (float) val2/10;
		if (val2f == val1f)
//		if ((float)m_ppContingencyTable[charnum].Features[featureNo].Values[i].val == val)
		{
			prob = (float)m_ppContingencyTable[charnum].Features[featureNo].Values[i].count / (float)m_ppContingencyTable[charnum].Features[featureNo].total;
			found = true;
		}

	}
	if (!found)
	{
		//prob = (float)1/(float)m_ppContingencyTable[charnum].Features[featureNo].noOfValues;
		prob = 0.00;
	}
	return prob;
}
float CDocImAnDoc::CalculatePriorProbability(int charnum)
{
	float result;
	int noChars = m_pProbabilityVector[charnum].GetNoOfChars();
	int totalVectors = ComputeTotalNumberofVectors();
	result = ((float)m_pProbabilityVector[charnum].GetNoOfChars() / (float)ComputeTotalNumberofVectors());
	return result;
}

int CDocImAnDoc::GetCost(INFO highval,CImage *image)
{
	//import the charImage of the perfect char
	CImage* loadedImage;
	CString pathName;
	if (highval.Capital)
	{	
		pathName.Format(_T("%s%c.tif"),m_PerfectCapitalImagePath,highval.Name);
	}
	else
	{
		pathName.Format(_T("%s%c.tif"),m_PerfectImagePath,highval.Name);
	}
	
	loadedImage = ImgLoadFromFile((LPCTSTR)pathName, 
	RUNTIME_CLASS(CDIAHiColorImage),
	NULL,
	RUNTIME_CLASS(CDIAGreyScale),
	RUNTIME_CLASS(CDIABiLevelImage));
	
	int cost = CompareImagesCentred(image, loadedImage);
	//int cost = CompareImagesFlexible(image, loadedImage);
	//int cost2 = CompareImagesCentred(loadedImage, image);

	return cost;
}
int CDocImAnDoc::GetFlexCost(INFO highval,CImage *image)
{
	//import the charImage of the perfect char
	CImage* loadedImage;
	CString pathName;
	if (highval.Capital)
	{	
		pathName.Format(_T("%s%c.tif"),m_PerfectCapitalImagePath,highval.Name);
	}
	else
	{
		pathName.Format(_T("%s%c.tif"),m_PerfectImagePath,highval.Name);
	}
	
	loadedImage = ImgLoadFromFile((LPCTSTR)pathName, 
	RUNTIME_CLASS(CDIAHiColorImage),
	NULL,
	RUNTIME_CLASS(CDIAGreyScale),
	RUNTIME_CLASS(CDIABiLevelImage));
	//int cost = CompareImagesCentred(image, loadedImage);
	int cost = CompareImagesFlexible(image, loadedImage);
	//int cost2 = CompareImagesCentred(loadedImage, image);

	return cost;
}
int CDocImAnDoc::CompareImagesCentred(CImage* image1,CImage* image2)
{

	CRect rectVector;
	CRect rectImage;
	int newwidth = min(image2->GetWidth(),image1->GetWidth());
	int newheight = min(image2->GetHeight(),image1->GetHeight());
	CPoint centre1;
	CPoint centre2;
	centre2.x = image1->GetWidth()/2;
	centre2.y = image1->GetHeight()/2;
	centre1.x = image2->GetWidth()/2;
	centre1.y = image2->GetHeight()/2;
	int* costs;
	int costIndex = 0;
	int sizeOfSearch = 3;
	const int sizeOfArray = ((centre1.x + sizeOfSearch) - (centre1.x - sizeOfSearch)+1) * ((centre1.y + sizeOfSearch) - (centre1.y - sizeOfSearch)+1);
	costs = new int[sizeOfArray];
	
	//find the centre of both images
	for (int i = centre1.x - sizeOfSearch; i <= centre1.x + sizeOfSearch; i++)
	{
		for (int j = centre1.y - sizeOfSearch; j <= centre1.y + sizeOfSearch; j++)
		{
			////find the centre of the other image
			CPoint point(i,j);
			costs[costIndex] = CompareSSDImages(image2,image1,point,centre2);
			costIndex++;
		}
	}
	int minVal = costs[0];
	for (int i = 1; i < costIndex; i++)
	{
		if (costs[i] <= minVal)
			minVal = costs[i];
	}
	delete[] costs;
	return minVal;

}
int CDocImAnDoc::CompareSSDImages(CImage* image1, CImage* image2,CPoint point1,CPoint point2)
{
//int cost = 0;
	float cost = 0.0;
	//given 2 images and a centre point: match them
	//point2 is the centre of the image2
	//point1 is teh possition in image1, but not necessary centered
	for (int i = 0; i < image2->GetWidth(); i++)
	{
		for (int j = 0; j < image2->GetHeight(); j++)
		{
			int posxl = point1.x - point2.x + i;
			//int posxr = point1.x + point2.x + i;
			int posyt = point1.y - point2.y + j;
		//	int posyb = point1.y + point2.y;
			//if ((posxl < 0)|| (posyt < 0) ||(posxr >= image1->GetWidth()) || (posyb >= image1->GetHeight()))
			if ((posxl >= 0)&& (posxl < image1->GetWidth()) && (posyt >= 0) && ( posyt<image1->GetHeight()))
			{
				//add the cost
				
				float val = (float) abs(image1->GetRed(posxl,posyt) - image2->GetRed(i,j));
				//Normalize it??
				val = (float) val/255;
				cost += pow(val,2);
			}
		}
	}

	return (int) cost;
}
int CDocImAnDoc::CompareTubbs1Images(CImage* image1, CImage* image2,CPoint point1,CPoint point2)
{
	//int cost = 0;
	float cost = 0.0;

	//given 2 images and a centre point: match them
	//calculate how many pixels are there in 11, 01, 10
	//DistanceTubbs1 = 11/(11 + 10 + 01)

	//point2 is the centre of the unknwon char
	//point1 is the possition in vectorchar, but not necessarily centered
	int val11 = 0;
	int val10 = 0;
	int val01 = 0;
	int uchar;
	int vchar;
	for (int i = 0; i < image1->GetWidth(); i++)
	{
		for (int j = 0; j < image1->GetHeight(); j++)
		{
			int posxl = point2.x - point1.x  + i;
			//int posxr = point1.x + point2.x + i;
			int posyt = point2.y - point1.y + j;
		//	int posyb = point1.y + point2.y;
			
			//if ((posxl < 0)|| (posyt < 0) ||(posxr >= image1->GetWidth()) || (posyb >= image1->GetHeight()))
			if ((posxl >= 0)&& (posxl < image1->GetWidth()) && (posyt >= 0) && ( posyt<image1->GetHeight()))
			{
				uchar = (int) GetRValue(image2->GetRGBColor(posxl,posyt));
				vchar = (int) GetRValue(image1->GetRGBColor(i,j));
				//val11
				if ((uchar == vchar) && (uchar == 1))
				{
					val11++;
				}
				else if ((uchar == 0 ) && ( vchar == 1))
				{
					val01++;
				}
				else if ((vchar == 0 ) && ( uchar == 1))
				{
					val10++;
				}

				//add the cost
				
				//float val = (float) abs((int) GetRValue(image1->GetRGBColor(i,j)) - (int) GetRValue(image2->GetRed(posxl,posyt)));
				////Normalize it??
				//val = (float) val/255;
				//cost += pow(val,2);
			}
			/*else
			{
				cost++;
			}*/
		}
	}
	cost = val11/(val11 + val10 + val01);

	return (int) cost;
}

int CDocImAnDoc::CompareTubbs2Images(CImage* image1, CImage* image2,CPoint point1,CPoint point2)
{
	//int cost = 0;
	float cost = 0.0;

	//given 2 images and a centre point: match them
	//calculate how many pixels are there in 11, 01, 10
	//Distance2 = (11*00 - 10*01)/(11*00 + 10*01)

	//point2 is the centre of the unknwon char
	//point1 is the possition in vectorchar, but not necessarily centered
	int val11 = 0;
	int val10 = 0;
	int val01 = 0;
	int val00 = 0;
	int uchar;
	int vchar;
	for (int i = 0; i < image1->GetWidth(); i++)
	{
		for (int j = 0; j < image1->GetHeight(); j++)
		{
			int posxl = point2.x - point1.x  + i;
			//int posxr = point1.x + point2.x + i;
			int posyt = point2.y - point1.y + j;
		//	int posyb = point1.y + point2.y;
			
			//if ((posxl < 0)|| (posyt < 0) ||(posxr >= image1->GetWidth()) || (posyb >= image1->GetHeight()))
			if ((posxl >= 0)&& (posxl < image1->GetWidth()) && (posyt >= 0) && ( posyt<image1->GetHeight()))
			{
				uchar = (int) GetRValue(image2->GetRGBColor(posxl,posyt));
				vchar = (int) GetRValue(image1->GetRGBColor(i,j));
				//val11
				if ((uchar == vchar) && (uchar == 1))
				{
					val11++;
				}
				else if ((uchar == 0 ) && ( vchar == 1))
				{
					val01++;
				}
				else if ((vchar == 0 ) && ( uchar == 1))
				{
					val10++;
				}
				else if ((uchar == vchar) && (uchar == 0))
				{
					val00++;
				}

				//add the cost
				
				//float val = (float) abs((int) GetRValue(image1->GetRGBColor(i,j)) - (int) GetRValue(image2->GetRed(posxl,posyt)));
				////Normalize it??
				//val = (float) val/255;
				//cost += pow(val,2);
			}
			/*else
			{
				cost++;
			}*/
		}
	}
	 
	cost = (val11*val00 - val10*val01)/(val11*val00 + val10*val01);

	return (int) cost;
}



int CDocImAnDoc::CompareImagesFlexible(CImage* image1, CImage* image2,CPoint point1,CPoint point2, int totPix)
{
	//int cost = 0;
	float cost = 0.0;
	//given 2 images and a centre point: match them
	//point2 is the centre of the image2
	//point1 is teh possition in image1, but not necessary centered
	float percent = (float)1/(float)totPix;
	float halfPercent = (float)1 / (float)(totPix * 2);
	int tot = 0;
	for (int i = 0; i < image2->GetWidth(); i++)
	{
		for (int j = 0; j < image2->GetHeight(); j++)
		{
			int posxl = point1.x - point2.x + i;
			//int posxr = point1.x + point2.x + i;
			int posyt = point1.y - point2.y + j;
		//	int posyb = point1.y + point2.y;
			//if ((posxl < 0)|| (posyt < 0) ||(posxr >= image1->GetWidth()) || (posyb >= image1->GetHeight()))
			if ((posxl >= 0)&& (posxl < image1->GetWidth()) && (posyt >= 0) && ( posyt<image1->GetHeight()))
			{
				//add the cost
				tot++;
				if (image1->GetRed(posxl,posyt) == image2->GetRed(i,j))//if they are the same
				{
						cost += percent;
				}
				else 
					if ((image2->GetRed(i,j) == 0) && (image2->GetRed(i,j)!= 255))
					{
						cost += percent;
					}

			}
		}
	}
	int temp = (int) (((float)(tot - cost)/(float)tot)*100);
	return temp;
}
int CDocImAnDoc::CompareImagesFlexible(CImage* image1,CImage* image2)
{
	//int y_diff, x_diff;
	CRect rectVector;
	CRect rectImage;
	int newwidth = min(image2->GetWidth(),image1->GetWidth());
	int newheight = min(image2->GetHeight(),image1->GetHeight());
	CPoint centre1;
	CPoint centre2;
	centre2.x = image1->GetWidth()/2;
	centre2.y = image1->GetHeight()/2;
	centre1.x = image2->GetWidth()/2;
	centre1.y = image2->GetHeight()/2;
	int* costs;
	//costs = new int*;
	int costIndex = 0;
	int sizeOfSearch = 0;
	const int sizeOfArray = ((centre1.x + sizeOfSearch) - (centre1.x - sizeOfSearch)+1) * ((centre1.y + sizeOfSearch) - (centre1.y - sizeOfSearch)+1);
	costs = new int[sizeOfArray];
	
	//find the centre of both images

	for (int i = centre1.x - sizeOfSearch; i <= centre1.x + sizeOfSearch; i++)
	{
		for (int j = centre1.y - sizeOfSearch; j <= centre1.y + sizeOfSearch; j++)
		{
			////find the centre of the other image
			CPoint point(i,j);
			costs[costIndex] = CompareImagesFlexible(image2,image1,point,centre2,1);
			costIndex++;

		}

	}
	int maxVal = costs[0];
	for (int i = 1; i < costIndex; i++)
	{
		if (costs[i] > maxVal)
			maxVal = costs[i];
	}
	//int minVal = costs[0];
	//for (int i = 1; i < costIndex; i++)
	//{
	//	if (costs[i] <= minVal)
	//		minVal = costs[i];
	//}
	//delete costs;
	
	delete[] costs;
	return maxVal;




}

CDocImAnDoc::INFO CDocImAnDoc::FindBestMatch(CImage* image,int type,int MatchingType)
{
	//for each Vector compare the character 
	//and print the best match
	//m_bestChar;
	//m_minCost;
	//char bestChar;
	CString bar;
	bar.Format(_T("---------------"));
	INFO m_CurrentBestChar;
	INFO m_BestChars[3];
	m_CurrentBestChar.Name= '0';
	m_CurrentBestChar.Capital = false;
	if (image != NULL)
	{
		if (m_CharVectorIndex > 0)
		{
			//m_minCost = m_pCharVector[0]->CompareImageInVectorCentred(image);
			int m_minCost = 1000000;
			m_BestChars[0].Cost = 1000000;
			m_BestChars[1].Cost = 1000000;
			m_BestChars[2].Cost = 1000000;
			m_BestChars[0].Name = '0';
			m_BestChars[1].Name = '0';
			m_BestChars[2].Name = '0';
			for (int i = 0; i < m_CharVectorIndex; i++)
			{
				//int* cost = new int[9];
				if (m_pCharVector[i]->GetCharType() == type)
				{
					int cost;
					if (MatchingType == 1)//then compareImages centred
					{
						cost = m_pCharVector[i]->CompareImageInVectorCentred(image);
					}
					if (MatchingType == 2)//then compare images by centre of gravity
					{
						cost = m_pCharVector[i]->CompareImageInVectorGravity(image);
					}
					if(cost <= m_BestChars[0].Cost)
					{

						m_BestChars[2].Cost = m_BestChars[1].Cost;
						m_BestChars[2].Name = m_BestChars[1].Name;
					
						m_BestChars[1].Cost = m_BestChars[0].Cost;
						m_BestChars[1].Name = m_BestChars[0].Name;
						
						m_BestChars[0].Cost = cost;
						m_BestChars[0].Name = m_pCharVector[i]->GetCharName();//m_BestPercentages[i].charname;
						m_BestChars[0].Capital = false;
					
						
					}
					else
						if (cost <= m_BestChars[1].Cost)
						{
							m_BestChars[2].Cost = m_BestChars[1].Cost;
							m_BestChars[2].Name = m_BestChars[1].Name;
						
							m_BestChars[1].Cost = cost;
							m_BestChars[1].Name = m_pCharVector[i]->GetCharName();
							m_BestChars[1].Capital = false;
						}
					else if (cost <= m_BestChars[2].Cost)
					{
						m_BestChars[2].Cost = cost;
						m_BestChars[2].Name =m_pCharVector[i]->GetCharName();
						m_BestChars[2].Capital = false;
						
					}
			
				}	
			}
		}
		if (type == 1) 
		{//then is a tall char and we need to compare it to the Capitals
			if (m_CharCapitalVectorIndex > 0)
			{
				for (int i = 0; i < m_CharCapitalVectorIndex; i++)
				{
					int cost;
					if (MatchingType == 1)//then compareImages centred
					{
						cost = m_pCharCapitalVector[i]->CompareImageInVectorCentred(image);
					}
					if (MatchingType == 2)//then compare images by centre of gravity
					{
						cost = m_pCharCapitalVector[i]->CompareImageInVectorGravity(image);
					}
					CString text;
				
					if(cost <= m_BestChars[0].Cost)
					{

						m_BestChars[2].Cost = m_BestChars[1].Cost;
						m_BestChars[2].Name = m_BestChars[1].Name;
					
						m_BestChars[1].Cost = m_BestChars[0].Cost;
						m_BestChars[1].Name = m_BestChars[0].Name;
						
						m_BestChars[0].Cost = cost;
						m_BestChars[0].Name = m_pCharCapitalVector[i]->GetCharName();//m_BestPercentages[i].charname;
						m_BestChars[0].Capital = true;
					
						
					}
					else
						if (cost <= m_BestChars[1].Cost)
						{
							m_BestChars[2].Cost = m_BestChars[1].Cost;
							m_BestChars[2].Name = m_BestChars[1].Name;
						
							m_BestChars[1].Cost = cost;
							m_BestChars[1].Name = m_pCharCapitalVector[i]->GetCharName();
							m_BestChars[1].Capital = true;
						}
					else 
						if (cost < m_BestChars[2].Cost)
						{
							m_BestChars[2].Cost = cost;
							m_BestChars[2].Name =m_pCharCapitalVector[i]->GetCharName();
							m_BestChars[2].Capital = true;
							
						}
					
				}
			}
		}
		
		
		
	CString text;
	//text.Format(_T("Min Cost= %d"),m_minCost);
	text.Format(_T("Min Cost= %d"),m_BestChars[0].Cost);
	
	//CalculateRecognitionRate(Lineno,charno);
	
	}
	m_CurrentBestChar.Name = m_BestChars[0].Name;
	m_CurrentBestChar.Capital = m_BestChars[0].Capital;
	TRACE(_T("%c\n"),m_CurrentBestChar);
	return m_CurrentBestChar;
	
}
char CDocImAnDoc::FindBestMatch(CImage* image)
{
	//for each Vector compare the character 
	//and print the best match
	//m_bestChar;
	//m_minCost;
	//char bestChar;
	int m_CurrentBestChar = '0';
	if (image != NULL)
	{
		if (m_CharVectorIndex > 0)
		{
			int m_minCost = m_pCharVector[0]->CompareImageInVectorCentred(image);
			for (int i = 0; i < m_CharVectorIndex; i++)
			{
				//int* cost = new int[9];
				//if (m_pCharVector[i]->m_CharIm
				int cost;
				cost = m_pCharVector[i]->CompareImageInVectorCentred(image);
				CString text;
				text.Format(_T("Cost for character %c = %d"),m_pCharVector[i]->GetCharName(),cost);
				//m_DetailsList.SetWindowText((LPCTSRT)text);
				//m_DetailsList.AddString((LPCTSTR)text);
				if (cost <= m_minCost)
				{
					m_minCost = cost;
					m_CurrentBestChar = m_pCharVector[i]->GetCharName();
				}
			}
		}
	}
	return m_CurrentBestChar;
	
}
void CDocImAnDoc::ExportImagePlot()
{
	//this wil export all the list of character vectors to a File
	//each field will be separated by commas
	//each character will take just one line

	//the characters will be stored in 2 files:
	//1 for the vector
	//2 for the char images
	

	FILE * pFile;
	static char BASED_CODE szFilter[]=
		"Comma Separated Values(*.csv)|All Files (*.*)|*.*||";

	char Values[] = "Values";
	char Image[] = "Image";
	char SegBack[] = "Segm_Backgr";
	char SegFore[] = "Segm_Foregr";
	char LocBack[] = "Localised_Backgr";
	char LocFore[] = "Localised_Foregr";
	
	char   c = '\n';
	

	CString m_name;
	m_name.Format(_T("%s2DPlot.csv"),GetActiveImage()->GetName());
	CFileDialog m_FileDialog(FALSE,NULL,m_name,OFN_OVERWRITEPROMPT|OFN_HIDEREADONLY
		,NULL, 0);
	if (m_FileDialog.DoModal() == IDOK)
	{
		CString m_pathName = m_FileDialog.GetPathName();
		pFile = _tfopen(m_pathName, _T("w"));
		for (int i = 0; i < 50; i++)
		{
			for (int j = 0; j < 50; j++)
			{
				if (m_2DCharPlotType[i][j].total > 0)
				{
					TRACE("found one");

				}
					fprintf(pFile,"%d,",m_2DCharPlotType[i][j].total);
			}
			fprintf(pFile,"\n");
		}
		fprintf(pFile,"\n\n");

		for (int i = 0; i < 50; i++)
		{
			for (int j = 0; j < 50; j++)
			{
				fprintf(pFile,"%d,",m_2DCharPlotType[i][j].type[0]);
			}
			fprintf(pFile,"\n");
		}
		fprintf(pFile,"\n\n");

			for (int i = 0; i < 50; i++)
		{
			for (int j = 0; j < 50; j++)
			{
				fprintf(pFile,"%d,",m_2DCharPlotType[i][j].type[1]);
			}
			fprintf(pFile,"\n");
		}
		fprintf(pFile,"\n\n");

			for (int i = 0; i < 50; i++)
		{
			for (int j = 0; j < 50; j++)
			{
				fprintf(pFile,"%d,",m_2DCharPlotType[i][j].type[2]);
			}
			fprintf(pFile,"\n");
		}
		fprintf(pFile,"\n\n");
		fclose(pFile);
	}
	

}
void CDocImAnDoc::ExportImagePlot2()
{
	FILE * pFile;
	static char BASED_CODE szFilter[]=
		"Comma Separated Values(*.csv)|All Files (*.*)|*.*||";


	
	char   c = '\n';
	//long image,segB,segF,locF,locB;

	CString m_name;
	m_name.Format(_T("%s2DPlot2.csv"),GetActiveImage()->GetName());
	CFileDialog m_FileDialog(FALSE,NULL,m_name,OFN_OVERWRITEPROMPT|OFN_HIDEREADONLY
		,NULL, 0);
	if (m_FileDialog.DoModal() == IDOK)
	{
		if (m_IsCharLocalized)
		{
			CString m_pathName = m_FileDialog.GetPathName();
			pFile = _tfopen(m_pathName, _T("w"));
			for (int i = 0; i < m_LineHolderIndex; i++)
			{
				for (int j = 0; j < m_pLineHolder[i].m_CharacterHolderIndex; j++)
				{
					fprintf(pFile,"%d\t%d\n",m_pLineHolder[i].m_pCharacterHolder[j].m_LocatedHeight,m_pLineHolder[i].m_pCharacterHolder[j].m_LocatedWidth);
				}
				
			}
			fclose(pFile);
		}
	}
	

}
void CDocImAnDoc::ExportImagePlot3()
{
	FILE * pFile;
	static char BASED_CODE szFilter[]=
		"Comma Separated Values(*.csv)|All Files (*.*)|*.*||";


	
	char   c = '\n';
	//long image,segB,segF,locF,locB;

	CString m_name;
	m_name.Format(_T("%s2DPlot2.csv"),GetActiveImage()->GetName());
	CFileDialog m_FileDialog(FALSE,NULL,m_name,OFN_OVERWRITEPROMPT|OFN_HIDEREADONLY
		,NULL, 0);
	if (m_FileDialog.DoModal() == IDOK)
	{
		if (m_IsCharLocalized)
		{
			CString m_pathName = m_FileDialog.GetPathName();
			pFile = _tfopen(m_pathName, _T("w"));
			for (int i = 0; i < m_LineHolderIndex; i++)
			{
				for (int j = 0; j < m_pLineHolder[i].m_CharacterHolderIndex; j++)
				{
					fprintf(pFile,"%d\t%d\t%d\n",m_pLineHolder[i].m_pCharacterHolder[j].m_LocatedHeight,m_pLineHolder[i].m_pCharacterHolder[j].m_LocatedWidth, m_pLineHolder[i].m_pCharacterHolder[j].m_CharHMaxCount);
				}
				
			}
			fclose(pFile);
		}
	}
	

}
void CDocImAnDoc::ExportImagePlot4()
{
	FILE * pFile;
	static char BASED_CODE szFilter[]=
		"Comma Separated Values(*.csv)|All Files (*.*)|*.*||";


	
	char   c = '\n';
	//long image,segB,segF,locF,locB;

	CString m_name;
	m_name.Format(_T("%s2DPlot2.csv"),GetActiveImage()->GetName());
	CFileDialog m_FileDialog(FALSE,NULL,m_name,OFN_OVERWRITEPROMPT|OFN_HIDEREADONLY
		,NULL, 0);
	if (m_FileDialog.DoModal() == IDOK)
	{
		if (m_IsCharLocalized)
		{
			CString m_pathName = m_FileDialog.GetPathName();
			pFile = _tfopen(m_pathName, _T("w"));
			for (int i = 0; i < m_LineHolderIndex; i++)
			{
				for (int j = 0; j < m_pLineHolder[i].m_CharacterHolderIndex; j++)
				{
					fprintf(pFile,"%d\t%d\t%d\t%d\n",m_pLineHolder[i].m_pCharacterHolder[j].m_LocatedHeight,m_pLineHolder[i].m_pCharacterHolder[j].m_LocatedWidth, m_pLineHolder[i].m_pCharacterHolder[j].m_CharHMaxCount,m_pLineHolder[i].m_pCharacterHolder[j].m_CharVMaxCount);
				}
				
			}
			fclose(pFile);
		}
	}
	

}
CString FindAddress(char CharName, CString path,CString filename)
{
	FILE * pFile;
	char name;
	CString filePath;
	CString fullpath;
	filePath.Format(_T("%s%s"),path, filename);
	bool found = false;
	if (_tfopen(filePath, _T("r")))
	{
		pFile = _tfopen(filePath, _T("r"));
		fscanf(pFile, "\n");
		//find the char in the file
		while (!found)
		{
			fscanf(pFile,"%d\t", &name);
			if (name == CharName)
			{
				fscanf(pFile,"%s",&fullpath);
				found = true;
			}
			else fscanf(pFile,"\n");//go to next line
		}
		fclose(pFile);
	}
	return fullpath;

}

void CDocImAnDoc::CreateClassTree()
{
	//List = new CClassList();
	FILE * pFile;

	int level1;
	int level2;
	int level3;
	int level4;
	int level5;
	int level6;
	int level7;
	int level;
	
	int n_chars;
	char p_char;
	ItemType Item;
	//CString filePath;
	//m_TreePathName.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Original Characters\\Perfect Set\\Tree2.txt"));
	if (_tfopen(m_TreePathName, _T("r")))
	{
		pFile = _tfopen(m_TreePathName, _T("r"));
		
		int count;
		fscanf(pFile,"%d\n",&count);
		//m_CharVectorIndex = count;
		//m_pCharVector = new CCharVector* [count];
		//for (int i = 0; i < count;i++)
		//{
		//
		m_ntree = count;
		for (int i = 0; i < count; i++)
		{
			fscanf(pFile,"%d\t%d\t%d\t%d\t%d\t%d\t%d\t%s\t%d\t%d\t", &level1, &level2, &level3, &level4, &level5, &level6, &level7, &Item.Name, &level, &n_chars);
			Item.level = level;
			Item.n_chars = n_chars;
			Item.pchars = new char[n_chars];
			//Item.Name = feature;
			for (int j = 0; j < n_chars; j++)
			{	//for each of the chars
				fscanf(pFile,"%c\t",&p_char);
				Item.pchars[j] = p_char;
				
				
			}
			TreeArray[level1][level2][level3][level4][level5][level6][level7] = Item;
			delete Item.pchars;
		}
		fclose(pFile);
		

	}
	

}

void CDocImAnDoc::DeleteClassTree()
{
	
		for (int i = 0; i < 6; i++)
		{
			for (int j = 0; j < 6; j++)
			{
				for (int k = 0; k < 6; k++)
				{
					for (int l = 0; l < 6; l++)
					{
						for (int m = 0; m < 6; m++)
						{
							for (int n = 0; n < 6; n++)
							{
								for (int o = 0; o < 6; o++)
								{
									if (TreeArray[i][j][k][l][m][n][o].pchars != 0)
									delete TreeArray[i][j][k][l][m][n][o].pchars;
								}
							}
						}
					}
				}
			}
		}
		
	

}

void CDocImAnDoc::CreateCharLocationFile()
{
	//List = new CClassList();
	FILE * pFile;
	
	char p_char;
	AddressType myAddress;
	//myAddress.charAddress = new char[200];
	//CString filePath;
	//filePath.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Original Characters\\Perfect Set\\PerfectCharsLocation.txt"));
	if (_tfopen(m_CharLocationFile, _T("r")))
	{
		pFile = _tfopen(m_CharLocationFile, _T("r"));	
		int count;
		fscanf(pFile,"%d\n",&count);
		n_LocatedChars = count;
		for (int i = 0; i < n_LocatedChars; i++)
		{
			fscanf(pFile,"%c\t\n", &p_char);
			m_CharAddresses[i].charName = p_char;
		
			char val = '0';
			int num = 0;
			while (val != '\n')
			{
				fscanf(pFile,"%c", &val);
				
				if (val != '\n')
				{
					m_CharAddresses[i].charAddress  = m_CharAddresses[i].charAddress + val;
					num++;
					
				}//else myAddress.charAddress = myAddress.charAddress + val;
			}//now we know how long the string is
			m_CharAddresses[i].size = num;
			//m_CharAddresses[i].charAddress = new char[num];

			//for (int j = 0; j < m_CharAddresses[i].size; j++)
			//{
				//m_CharAddresses[i].charAddress = myAddress.charAddress;
			//}
			//m_CharAddresses[i] = myAddress;		
		}
		fclose(pFile);
		is_charAddress = true;
		

	}
	
		

	
	

}

int CDocImAnDoc::CompareWeightImages(CImage* image1, CImage* image2,CPoint point1,CPoint point2)
{
	//int cost = 0;
	float cost = 0.0;
	//given 2 images and a centre point: match them
	//point2 is the centre of the unknwon char
	//point1 is the possition in vectorchar, but not necessarily centered

	//create a new image as the union of both
	int left = max(point1.x,point2.x);
	int top = max(point1.y, point2.y);
	int right = max((image1->GetWidth()-point1.x-1),(image2->GetWidth()-point2.x-1));
	int bottom = max((image1->GetHeight()-point1.y-1),(image2->GetHeight()-point2.y-1));

	int newHeight = top + bottom + 1;
	int newWidth = left + right + 1;

	CPoint midpoint;
	midpoint.x = (newWidth/2)+1;
	midpoint.y = (newHeight/2)+1;

	int val1 = -1;
	int val2 = -1;

	int val11 = 0;
	int val10 = 0;
	int val01 = 0;
	int val00 = 0;

	//CImage * newImage;
	//newImage->Create(newWidth, newHeight,RGB(255,255,255),T_(o));
	
	int** newImage;
	newImage = new int*[newWidth];
	for (int i = 0; i < newWidth; i++)
	{
		newImage[i] = new int[newHeight];
		
	}

	for (int i = 0; i < newWidth; i++)
	{
		for (int j = 0; j < newHeight; j++)
		{
			val1 = -1;
			val2 = -1;
			newImage[i][j] = 255;
				
			//image1
			if ((i >= (midpoint.x - point1.x ))&& (i < (midpoint.x + image1->GetWidth() - point1.x)) && (j >= (midpoint.y - point1.y)) && (j < (midpoint.y + image1->GetHeight() - point1.y)))//then the pixel is inside the image1
			{
				CPoint point(point1.x - midpoint.x + i,point1.y - midpoint.y + j);
				val1 = image1->GetBlue(point.x, point.y);
				
			}
			//image2
			if ((i >= (midpoint.x - point2.x ))&& (i < (midpoint.x + image2->GetWidth() - point2.x)) && (j >= (midpoint.y - point2.y)) && (j < (midpoint.y + image2->GetHeight() - point2.y)))//then the pixel is inside the image2
			{
				CPoint point22(point2.x - midpoint.x + i ,point2.y - midpoint.y + j);
				val2 = image2->GetBlue(point22.x, point22.y);

			}

			//depending on the values of val1 and val2
			
			if ((val1 >= 0)&& (val2 >= 0) && ( val1 == val2))
			{
				newImage[i][j] = val1;
			}
			else
			{
				if ((val1 >= 0)&& (val2 >= 0) && (val1 == 0))//one is black and the other is white
				{
					newImage[i][j] = -110; 
				}
				else if ((val1 >= 0)&& (val2 >= 0) && (val2 == 0))//one is black and the other is white
				{
					newImage[i][j] = -101; 
				}
			}
			if ((val1 < 0) && (val2 == 0)) //if one image is small but the other is black
			{
				newImage[i][j] = -101;
			}
			if ((val2 < 0) && (val1 == 0))
			{
				newImage[i][j] = -110; 
			}
			
			//testing
			//if ((val1 >= 0)&& (val2 >= 0) && ( val1 == val2))
			//{
			//	newImage[i][j] = val1;
			//}
			//else
			//{
			//	if ((val1 >= 0) && (val2 >= 0) && (val1 == 0))//one is black and the other is white
			//	{
			//		newImage[i][j] = -110; 
			//	}
			//	else if ((val1 >= 0) && (val2 >= 0) && (val2 == 0))//one is black and the other is white
			//	{
			//		newImage[i][j] = -101; 
			//	}
			//}
			//if ((val1 < 0) && (val2 == 0)) //if one image is small but the other is black
			//{
			//	newImage[i][j] = -110;
			//}
			//if ((val2 < 0) && (val1 == 0))
			//{
			//	newImage[i][j] = -101; 
			//}

			
		}
			
	}

		for (int i = 0; i < newWidth; i++)
		{
			for (int j = 0; j < newHeight; j++)
			{
				if (newImage[i][j] ==    0) val11++;
				if (newImage[i][j] ==  255) val00++;
				if (newImage[i][j] == -101) val01++;
				if (newImage[i][j] == -110) val10++;


				//find how many 01 or 10 are in its neighbourhood.
				if (i - 1 >= 0) 
				{
					
					if (newImage[i-1][j] < 0) 
					{
						if (newImage[i-1][j] == -101){ val01++;}
						else val10++;
					}
					if (j - 1 >= 0)
					{
						if (newImage[i][j-1] < 0) 
						{
							if (newImage[i][j-1] == -101){ val01++;}
							else val10++;
						}
						if (newImage[i-1][j-1] <0)
						{
							if (newImage[i-1][j-1] == -101){ val01++;}
							else val10++;
						}
					}
					if (j + 1 > newHeight)
					{
						if (newImage[i-1][j+1] <0)
						{
							if (newImage[i-1][j+1] == -101){ val01++;}
							else val10++;
						}
					}
				}
				if (i + 1 < newWidth)
				{
					if (newImage[i+1][j] < 0) 
					{
						if (newImage[i+1][j] == -101){ val01++;}
						else val10++;
					} 
					if (j + 1 > newHeight)
					{
						if (newImage[i+1][j+1] <0)
						{
							if (newImage[i+1][j+1] == -101){ val01++;}
							else val10++;
						}

						if (newImage[i][j+1] <0)
						{
							if (newImage[i][j+1] == -101){ val01++;}
							else val10++;
						}
					}
					if (j - 1 <= 0)
					{
						if (newImage[i+1][j-1] <0)
						{
							if (newImage[i+1][j-1] == -101){ val01++;}
							else val10++;
						}
					}
				}

				
			}

		}

	////////find the distance to the closest mathching pixel
	//	bool found = false;
	//	int loop = 1;
	//	int distance = 0;
	//	for (int i = 0; i < newWidth; i++)
	//	{
	//		for (int j = 0; j < newHeight; j++)
	//		{	//if it is a non matching pixel
	//			found = false;
	//			loop = 1;
	//			if ((newImage[i][j] == -110) /*|| (newImage[i][j] == -101)*/) 
	//			{
	//				
	//				while (!found)
	//				{
	//					
	//					for (int x = -loop; x<= loop; x++)
	//					{
	//						for (int y = -loop; y <= loop; y++)
	//						{
	//							if ((i + x >=0) && (i + x < newWidth) && (j + y >= 0) && (j + y < newHeight))
	//							{
	//								if ((newImage[i+x][j+y] == 0) || (newImage[i+x][j+y] == -101))//matching pixel is found
	//								{	
	//									if (!found)
	//									{
	//										distance = loop;
	//										//distance = min(abs(x),abs(y));
	//										found = true;
	//									}
	//								}
	//							}
	//						}
	//					}
	//				loop++;
	//				}
	//			if (newImage[i][j] == -101)  val01 = val01 + distance;
	//			if (newImage[i][j] == -110)	 val10 = val10 + distance;

	//			}
	//		}
	//	}

	//
	//	cost = (float)val10+val01;	

		//////find the distance to the closest mathching pixel
		bool found = false;
		int loop = 1;
		int distance = 0;
		for (int i = 0; i < newWidth; i++)
		{
			for (int j = 0; j < newHeight; j++)
			{	//if it is a non matching pixel
				found = false;
				loop = 1;
				if ((newImage[i][j] == -110) /*|| (newImage[i][j] == -101)*/) 
				{
					
					while (!found)
					{
						
						for (int x = -loop; x<= loop; x++)
						{
							for (int y = -loop; y <= loop; y++)
							{
								if ((i + x >=0) && (i + x < newWidth) && (j + y >= 0) && (j + y < newHeight))
								{
									if ((newImage[i+x][j+y] == 0) || (newImage[i+x][j+y] == -101))//matching pixel is found
									{	
										if (!found)
										{
											//distance = loop;
											distance = (int) sqrt(pow((double)x,2) + pow((double)y,2));
											//distance = min(abs(x),abs(y));
											found = true;
										}
									}
								}
							}
						}
					loop++;
					}
				if (newImage[i][j] == -101)  val01 = val01 + distance;
				if (newImage[i][j] == -110)	 val10 = val10 + distance;

				}
			}
		}
		cost = (float)val10+val01;
		for (int i = 0; i < newWidth; i++)
		{
			delete newImage[i];
		}
		delete newImage;
	return (int) (cost);
	
}


bool CDocImAnDoc::IsNeighbourColor(CPoint point, int color, int** arrayvals)
{
	int val = arrayvals[point.x][point.y];
	//int val = (int) GetRValue(m_pLocatedCharImage->GetRGBColor(point.x, point.y));
	if (val == color)
	{
		return true;
	}
	else return false;
}


int CDocImAnDoc::CompareImageInVectorWeight(CImage* image1,CImage* image2)
{

	CRect rectVector;
	CRect rectImage;
	
	int newwidth = min(image2->GetWidth(),image1->GetWidth());
	int newheight = min(image2->GetHeight(),image1->GetHeight());
	CPoint centre1;
	CPoint centre2;
	centre2.x = image1->GetWidth()/2;
	centre2.y = image1->GetHeight()/2;
	centre1.x = image2->GetWidth()/2;
	centre1.y = image2->GetHeight()/2;
	int* costs;
	//costs = new int*;
	int costIndex = 0;
	int sizeOfSearch = 3;
	int sizeOfSearchUp = 3;
	const int sizeOfArray = ((centre1.x + sizeOfSearch) - (centre1.x - sizeOfSearch)+1) * ((centre1.y + sizeOfSearchUp) - (centre1.y - sizeOfSearchUp)+1);
	costs = new int[sizeOfArray];

	int vals11 = 0;
	int vals10 = 0;
	int vals01 = 0;

	for (int i = centre1.x - sizeOfSearch; i <= centre1.x + sizeOfSearch; i++)
	{
		for (int j = centre1.y - sizeOfSearchUp; j <= centre1.y + sizeOfSearchUp; j++)
		{
			////find the centre of the other image
			CPoint point(i,j);
			costs[costIndex] = CompareWeightImages(image2,image1,point,centre2);
			costIndex++;

		}

	}
	/*int maxVal = costs[0];
	for (int i = 1; i < costIndex; i++)
	{
		if (costs[i] > maxVal)
			maxVal = costs[i];
	}*/
	int minVal = costs[0];
	for (int i = 1; i < costIndex; i++)
	{
		if (costs[i] <= minVal)
			minVal = costs[i];
	}
	//delete costs;
	
	delete[] costs;
	return minVal;
}

