// DocImAnView.h : interface of the CDocImAnView class
//
//#include "ImageLib.h"
#include "Image.h"
//#include "DlgDIAPlot2D.h"

#pragma once


class CDocImAnView : public CScrollView
{
protected: // create from serialization only
	CDocImAnView();
	DECLARE_DYNCREATE(CDocImAnView)

// Attributes
public:
	CDocImAnDoc* GetDocument() const;

// Operations
public:

// Overrides
public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);

protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);

// Implementation
public:
	virtual ~CDocImAnView();

	int m_magnification;
	bool m_bViewIndividualCharacters;
	bool m_bViewLocatedCharacters;
	bool m_bViewSegmentedCharacters;
	BOOL m_Increasing;
	bool m_CharEnhComplete;
	BOOL m_applying_separatorsH,m_applying_separatorsV;
public:
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
	
	void	SetActiveImage(CImage * mImage);
	void	PreprocessImage();
	void	PreprocessImageSoft();
	void	PerformSegmentation(CImage * pOrigImage);
	void	PerformLineSegmentation(CImage * pOrigImage);
	void	LocateCharacters();
	void	LocateCharacters2();
	void	LocateCharacters3(int threshold, int noiseSize);
	void	LocateCharacters4(int threshold, int noiseSize);
	void	ClassifyCharacters();
	void	ClassifyCharacters2();
	void	ClassifyCharacters3();
	void	CharacterAnalysis();
	void	Create2DCharPlot();
	CImage * GetActiveImage();
	//void	ReSegment();
	double	CalculateVariance(CPoint point, int neighbourhood, double mean, CImage * Image, int Width, int Height);
	double	CalculateVariance2(CPoint point, int neighbourhood, double mean, CImage * Image, int Width, int Height);
	static double	CalculateMean(CPoint point, int neighbourhood, CImage * Image, int Width, int Height);
	static int		CalculateMedian(CPoint point, int neighbourhood, CImage * Image, int Width, int Height);
	int		CalculateMaxInNeighb(CPoint point,int neighb, CImage *Image);
	int		CalculateMinInNeighb(CPoint point,int neighb, CImage *Image);
	void	ApplyLocalContrastThreshold(CImage * Image);
	void	ClearBackground();
	void	outputCleanImage();
	void	ThresholdHighestVals();
	void	SpaceCleanCharacters();
	void	SpaceCleanCharacters2();
	void	SortArray(int *MyArray,int *SortedArray, int ArrayElems);
	void	ApplyGaussianFilter(CImage * Image);
	void	ApplyAdaptiveHistogram();
	void	ApplyAdaptiveHistogramMaxMin();
	void	ThresholdInGroups();
	int		AddValuesCompensationMean(int value1, int value2);
	void	ExtractCharacterFeatures();
	void	FTR();
	void	FTR2();
	void	ThresholdPercent();
	//void	OnOcrRecogniseusinguncertainareas();
	bool	GetBit(int number, int pos);
	void	ApplyNewCharImage(CImage *Outimage, CImage * charImage, int LinePos, int CharPos);
	int		CalculateAverageBase(int line);
	void	ComputeRecognitionStatisticsFTR();
	void	ComputeRecognitionStatisticsRefined1();
	
	void	ComputeRecognitionStatisticsRefined2();
	void	ExportStatistics();
	void	ExportStatistics2();
	void	ImportGroundTruthImage();
	void	ImportFTRRecognisedImage();
	void	ImportRefined1RecognisedImage();
	void	ImportRefined2RecognisedImage();
	void	ExportRefined2RecognisedImage();
	void	ExportGroundTruthImage();
	void	ImportWrongCharStats();
	void	ImportCorrectCharStats();
	void	ExportWrongCharStats();
	void	ExportCorrectCharStats();
	void	AddWrongCharStat(char char_name, char other_char_name);
	void	AddCorrectCharStats(char char_name, bool iscorrect);
	void	CalculateLevensteinDistance(int column);
	int		Distance(CString s, CString t);
	int		Distance(CString s, CString t,int &total,int &missing, int &noise, int &wrong);
	
	//void	PerformRecognition();
#ifdef _DEBUG
	

#endif

protected:

	int m_OffsetX;
	int m_OffsetY;
	CImage::FilterStruct m_BlurFilter;
	CImage::FilterStruct m_GaussianFilter;
	CImage::FilterStruct m_SmoothFilter;

	CImage::FilterStruct m_Kernel4LineDet;
	CImage::FilterStruct m_Kernel3LineDet;
	CImage::FilterStruct m_Kernel2LineDet;
	CImage::FilterStruct m_Kernel1LineDet;

	//typedef struct RANGE_VALS
	//{
	//	int		firstVal;
	//	int		lastVal;
	//	int		colour;
	//};

	bool b_isDemoSeg;
	bool b_isDemoFTR;
	bool b_isDemoRef;
	bool IsResegmenting;
	bool m_bShowLines;
	//bool m_IsCharLocalized;
	bool m_ShowCharCentres;
	bool m_bShowUncertainAreas;
	float m_Magnification;
	int m_showGreenUncertain;
	int m_showPinkUncertain;
	int m_showGreypixels;
	int m_showOrangeUncertain;
	
	

	inline int CDocImAnView::GetWidth()
	{ if (GetActiveImage() == NULL) return 200; else return (int)(GetActiveImage()->GetWidth()); }
	inline int CDocImAnView::GetHeight()
	{ if (GetActiveImage() == NULL) return 200; else return (int)(GetActiveImage()->GetHeight());}

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()

public:
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnIncreaseSize();
	afx_msg void OnDecreaseSize();
	virtual void OnInitialUpdate();
protected:
	virtual void OnUpdate(CView* /*pSender*/, LPARAM /*lHint*/, CObject* /*pHint*/);
	//void ApplySeparators();
public:
	afx_msg void OnFiltersSmoothing();
	afx_msg void OnFiltersBlur();
	afx_msg void OnHistogramsTransformation();
	afx_msg void OnHistogramsEqualization();
	afx_msg void OnImageProjections();
	afx_msg void OnViewIndividualcharacterview();
	afx_msg void OnUpdateViewIndividualcharacterview(CCmdUI *pCmdUI);
	afx_msg void OnSegmentationComplete();
	afx_msg void OnCharacterenhanceComplete();
	afx_msg void OnCharacterenhanceResegment();
	afx_msg void OnCharacterenhanceExportlocatedcharacters();
	afx_msg void OnCharacterenhanceComplete40();
	afx_msg void OnCharacterenhanceGroupvaluesinsets();
	afx_msg void OnFiltersNiblack();
	afx_msg void OnFiltersMean();
	afx_msg void OnFiltersNiblackdimos();
	afx_msg void OnFiltersThreshold128();
	afx_msg void OnFiltersSauvola();
	afx_msg void OnSegmentationShowcharactercentres();
	afx_msg void OnFiltersAdaptivehistogram();
	afx_msg void OnSegmentationOnlysegmentation();
	afx_msg void OnSegmentationLines();
	afx_msg void OnImageAddtwoimages();
	afx_msg void OnFiltersEdgepreservingsmooth();
	afx_msg void OnFiltersThreshold40();
	afx_msg void OnImageOutputcleanimage();
	afx_msg void OnOcrOcrimage();
	afx_msg void OnPreprocessingNormal();
	afx_msg void OnPreprocessingSoft();
	afx_msg void OnFixedwidthsegmentationWidth();
	afx_msg void OnCharacterenhanceLocalizecharacters();
	afx_msg void OnCharacterenhanceLocalizecharacters32829();
	afx_msg void OnImageClean();
	afx_msg void OnFiltersGaussian();
	afx_msg void OnFiltersMedian();
	afx_msg void OnCompletemethodsFuzzymedian();
	afx_msg void OnCompletemethodsFuzzymean();
	afx_msg void OnCompletemethodsAdaptivethr40();
	afx_msg void OnThresholdThresholdingroups();
	afx_msg void OnSegmentationFixedlinesegmentation();
	afx_msg void OnCompletemethodsGatos();
	afx_msg void OnImageClean32855();
	afx_msg void OnExportLocatedcharacterimages();
	afx_msg void OnSegmentationDivisions();
	afx_msg void OnTestingOpentestingenvironment();
	afx_msg void OnEnhancementFlexibletextrecovery();
	afx_msg void OnTestingImportperfectcharacterstofile();
	afx_msg void OnEnhancementFtrimproved();
	afx_msg void OnLinesegmentationWithpreprocessing();
	afx_msg void OnLinesegmentationWithoutpreprocessing();
	afx_msg void OnLinesegmentationFixed();
	afx_msg void OnLinesegmentationFixedwithoutpre();
	afx_msg void OnOcrAddperfectcharforocr();
	afx_msg void OnImageCcanalysis();
	afx_msg void OnExportToxmldoc();
	afx_msg void OnOcrAddimagestoclassifier();
	afx_msg void OnOcrCreateocrtable();
	afx_msg void OnFixedLinesegmentation();
	afx_msg void OnFixedComplete();
	afx_msg void OnFiltersLinefinder();
	afx_msg void OnFiltersAdaptivehistotomaxmin();
	afx_msg void OnSegmentationLocate4();
	afx_msg void OnSegmentationCcbasedlocation();
	afx_msg void OnTextsegmentationMenu();
	afx_msg void OnHistogramsBackgroundhistogram();
	afx_msg void OnCharactersDisplayuncertainareasofimportance();
	afx_msg void OnViewLocalisedcharacterview();
	afx_msg void OnUpdateViewLocalisedcharacterview(CCmdUI *pCmdUI);
	afx_msg void OnViewSegmentedcharacterview();
	afx_msg void OnUpdateViewSegmentedcharacterview(CCmdUI *pCmdUI);
	afx_msg void OnCharactersDisplayuncertainareasnexttoorange();
	afx_msg void OnCharactersCleargreenpoints();
	afx_msg void OnPinkpointsClear();
	afx_msg void OnPinkpointsAddtochars();
	afx_msg void OnCleargreenpointsClear();
	afx_msg void OnCleargreenpointsAdd();
	afx_msg void OnCleargreenpointsGreen();
	afx_msg void OnPinkpointsPink();
	afx_msg void OnGreyClear();
	afx_msg void OnGreyAdd();
	afx_msg void OnGreyGrey();
	afx_msg void OnOrangeClear();
	afx_msg void OnOrangeAdd();
	afx_msg void OnOrangeOrange();
	afx_msg void OnCharactersSetuncertainareas();
	afx_msg void OnCharactersRefinement();
	afx_msg void OnOcrRecogniseusinguncertainareas();
	//void OnOcrRecogniseusinguncertainareas2();
	afx_msg void OnExportCharactersizes();
	afx_msg void OnOcrRecognise();
	afx_msg void OnOcrFullrecovery();
	afx_msg void OnOcrAddgroundtruthtoimage();
	afx_msg void OnOcrComputeindividualstatistics();
	afx_msg void OnOcrComputestatisticsgroupofimages();
	afx_msg void OnModiOriginal();
	afx_msg void OnLevensteindistanceTest();
	afx_msg void OnModiFtr();
	afx_msg void OnModiGatos();
	afx_msg void OnAbbyyOriginal();
	afx_msg void OnAbbyyFtr();
	afx_msg void OnAbbyyGatos();
	afx_msg void OnLevensteindistanceFtr();
	afx_msg void OnLevensteindistanceAll();
	afx_msg void OnModiOtsu();
	afx_msg void OnAbbyyOtsu();
	afx_msg void OnAbbyyRefined2();
	afx_msg void OnModiRefined2();
	afx_msg void OnMatchingRefined();
	//afx_msg void OnDemo1();
	
	afx_msg void On33();
	afx_msg void On3Comparison();
	afx_msg void On34();
	afx_msg void On44();
	afx_msg void On45();
	afx_msg void On46();
	afx_msg void OnDemo5();
	afx_msg void On36();
	afx_msg void On1Segmentation();
	afx_msg void On11();
public:
	afx_msg void OnFtrdemoCompleteftr();
public:
	afx_msg void On2Ct();
public:
	afx_msg void On2Ab();
public:
	afx_msg void On2Combination();
public:
	afx_msg void OnFtrdemoFtrdemo();
public:
	afx_msg void OnFtrdemo0();
public:
	afx_msg void OnRefinementdemoLocationofareasofuncertainty();
};

#ifndef _DEBUG  // debug version in DocImAnView.cpp
inline CDocImAnDoc* CDocImAnView::GetDocument() const
   { return reinterpret_cast<CDocImAnDoc*>(m_pDocument); }
#endif

