#include "stdafx.h"
#include "ExtraMath.h"

#include <math.h>
#include <stdio.h>
#include <stdlib.h>

double CExtraMath::AngleTwoPoints(int X1, int Y1, int X2, int Y2)
{
	int Xd = X2 - X1;
	int Yd = Y2 - Y1;

	if(Xd == 0)
	{
		if(Yd <= 0)
			return 0.0;
		else if(Yd > 0)
			return 180.0;
		else
		{
			fprintf(stderr,"AngleTwoPoints(%d,%d , %d,%d): ERROR!\n",X1,Y1,X2,Y2);
			return -1;
		}
	}
	else if(Xd < 0)
	{
		if(Yd == 0)
			return 270.0;
		else if(Yd < 0)
		{
			if(abs(Xd) > abs(Yd))
				return 270.0 + RadiansToDegrees(acos(double(abs(Xd)) / double(sqrt(pow((double)Xd,2)+pow((double)Yd,2)))));
			else
				return 360.0 - RadiansToDegrees(acos(double(abs(Yd)) / double(sqrt(pow((double)Xd,2)+pow((double)Yd,2)))));
		}
		else if(Yd > 0)
		{
			if(abs(Xd) > Yd)
				return 270.0 - RadiansToDegrees(acos(double(abs(Xd)) / double(sqrt(pow((double)Xd,2)+pow((double)Yd,2)))));
			else
				return 180.0 + RadiansToDegrees(acos(double(Yd) / double(sqrt(pow((double)Xd,2)+pow((double)Yd,2)))));
		}
		else
		{
			fprintf(stderr,"AngleTwoPoints(%d,%d , %d,%d): ERROR!\n",X1,Y1,X2,Y2);
			return -1;
		}
	}
	else if(Xd > 0)
	{
		if(Yd == 0)
			return 90.0;
		else if(Yd < 0)
		{
			if(abs(Yd) >= Xd)
			{
				return 0.0 + RadiansToDegrees(acos(double(abs(Yd)) / double(sqrt(pow((double)Xd,2)+pow((double)Yd,2)))));
			}
			else
			{
				return 90.0 - RadiansToDegrees(acos(double(Xd) / double(sqrt(pow((double)Xd,2)+pow((double)Yd,2)))));
			}
		}
		else if(Yd > 0)
		{
	
			if(Yd >= Xd)
			{
				return 90.0 + RadiansToDegrees(acos(double(Xd) / double(sqrt(pow((double)Xd,2)+pow((double)Yd,2)))));
			}
			else
			{
				return 180.0 - RadiansToDegrees(acos(double(Yd) / double(sqrt(pow((double)Xd,2)+pow((double)Yd,2)))));
			}
		}
		else
		{
			fprintf(stderr,"AngleTwoPoints(%d,%d , %d,%d): ERROR!\n",X1,Y1,X2,Y2);
			return -1;
		}
	}
	else
	{
		fprintf(stderr,"AngleTwoPoints(%d,%d , %d,%d): ERROR!\n",X1,Y1,X2,Y2);
		return -1;
	}
}

double CExtraMath::DegreesToRadians(double Degrees)
{
	return M_PI * Degrees / 180.0;
}

double CExtraMath::DistanceTwoPoints(int X1, int Y1, int X2, int Y2)
{
	return sqrt(pow(double(X2 - X1),2) + pow(double(Y2 - Y1),2));
}

bool CExtraMath::DoLineSegmentsIntersect(int AX1, int AY1, int AX2, int AY2, int BX1, int BY1, int BX2, int BY2)
{
	int xinters;
	if(AY1 > CExtraMath::Min(BY1,BY2))
	{
		if(AY1 <= CExtraMath::Max(BY1,BY2))
		{
			if(AX1 <= CExtraMath::Max(BX1,BX2))
			{
				if (BY1 != BY2)
				{
					xinters = (AY1-BY1)*(BX2-BX1)/(BY2-BY1)+BX1;
					if (BX1 == BX2 || AX1 <= xinters)
						return true;
				}
			}
		}
	}
	
	return false;
}

/*
			for (i=1;i<=m_nPoints;i++) {
				p2 = m_pPoints[i % m_nPoints];
				if (Point.y > CDaveMath::Min(p1->GetY(),p2->GetY())) {
					if (Point.y <= CDaveMath::Max(p1->GetY(),p2->GetY())) {
						if (Point.x <= CDaveMath::Max(p1->GetX(),p2->GetX())) {
					if (p1->GetY() != p2->GetY()) {
						xinters = (Point.y-p1->GetY())*(p2->GetX()-p1->GetX())/(p2->GetY()-p1->GetY())+p1->GetX();
						if (p1->GetX() == p2->GetX() || Point.x <= xinters)
						counter++;
					}
					}
				}
				}
				p1 = p2;
			}
*/

int CExtraMath::IsGreater(const int A, const int B)
{
	return B - A;
}

int CExtraMath::IsSmaller(const int A, const int B)
{
	return A - B;
}

int CExtraMath::IsGreaterP(const int * A, const int * B)
{
	return *B - *A;
}

/*int CExtraMath::IsLineToRight(const RangeLine * A, const RangeLine * B)
{
	return A->P2->GetX() - B->P1->GetX();
}*/

int CExtraMath::IsSmallerP(const int * A, const int * B)
{
	return *A - *B;
}

bool CExtraMath::IsIn(int SearchFor,int * InArray, int NoArrayMembers)
{
	int i;
	
	for(i = 0; i < NoArrayMembers; i++)
	{
		if(InArray[i] == SearchFor)
			return true;
	}
	
	return false;
}

//int CExtraMath::CompareLineSegments(const LineSegment * A, const LineSegment * B)
//{
//	return B->y1 - A->y1;
//}

int CExtraMath::Max(int A, int B)
{
	if(A >= B)
		return A;
	else
		return B;
}


int CExtraMath::Min(int A, int B)
{
	if(A <= B)
		return A;
	else
		return B;
}


double CExtraMath::RadiansToDegrees(double Radians)
{
	return 180.0 * Radians / M_PI;
}

