#include "StdAfx.h"
#include "DocImAnDoc.h"
#include ".\textline.h"

//IMPLEMENT_SERIAL(CTextLine, CObject, 1);
CTextLine::CTextLine(void)
{
	m_pCharacterSeparators = NULL;
	m_pTextLineProj = NULL;
	m_pTextLineDistribution = NULL;
	m_pCharacterHolder = NULL;
	m_pFixedWidthArray = NULL;
}

CTextLine::~CTextLine(void)
{
	if (m_pTextLineProj != NULL)
	{
		delete[] m_pTextLineProj;
		m_pTextLineProj = NULL;
	}
	if (m_pTextLineDistribution != NULL)
	{
		delete[] m_pTextLineDistribution;
		m_pTextLineDistribution = NULL;
	}
	if (m_pCharacterSeparators != NULL)
	{
		delete[] m_pCharacterSeparators;
		m_pCharacterSeparators = NULL;
	}
	if (m_pCharacterHolder != NULL)
	{
		delete[] m_pCharacterHolder;
		m_pCharacterHolder = NULL;
	}
	if (m_pFixedWidthArray != NULL)
	{
		//delete[] m_pFixedWidthArray;
		m_pFixedWidthArray = NULL;
	}
	
}

CImage * CTextLine::GetImage()
{
	if (m_pdoc != NULL)	return m_pdoc->GetActiveImage();
	else return NULL;
}
void CTextLine::CreateLine(int width, long FirstSeparator, long SecondSeparator, CImage * p_Image, BOOL ThinLine)
{
	m_Width = width;
	m_Height = SecondSeparator - FirstSeparator;
	m_Position_Y = FirstSeparator;
	m_pTextLineProj = new long [m_Width];
	p_Image->GetProjection(0,m_Position_Y,m_Width,m_Height,NULL, m_pTextLineProj ,PRJ_GREY);
	m_pTextLineDistribution = new CDistribution <long>;
	m_pTextLineDistribution->Create(m_pTextLineProj,m_Width);
	//m_pTextLineDistribution->GetMaximaPositions();
	m_ThinLine = ThinLine;
	m_CharShortAverage[0] = 0; // top
	m_CharShortAverage[1] = 0; // ntop
	m_CharShortAverage[2] = 0; // bottom
	m_CharShortAverage[3] = 0; // size


}

void CTextLine::DeleteLine()
{
	m_Width = NULL;
	m_Height = NULL;
	m_Position_Y = NULL;
	delete m_pTextLineProj;
	m_pTextLineProj = NULL;
	delete[] m_pTextLineDistribution;
	m_pTextLineDistribution = NULL;
	//for (int i = 0 ; i < m_CharacterHolderIndex;i++)
	//{
//		delete m_pCharacterHolder[i];
//	}

	delete[] m_pCharacterHolder;
	m_pCharacterHolder = NULL;
	m_CharacterHolderIndex = 0;
	//for (int i = 0; i < m_CharacterSeparatorIndex; i++)
	//{
	//	delete m_pCharacterSeparators[i];
//	}
	delete[] m_pCharacterSeparators;
	m_pCharacterSeparators = NULL;
	m_ThinLine = NULL;
	//delete[] m_pFixedWidthArray;
	//m_pFixedWidthArray = NULL;

}
int CTextLine::CountWideCharacters()
{
	int value = 0;
	for (int i = 0; i < m_CharacterHolderIndex; i++)
	{
		if (m_pCharacterHolder[i].m_CharType[3] == 1)
		{
			if (m_pCharacterHolder[i].m_Width > 35)
			{
				value++;
			}
		}

	}
	return value;
}

int CTextLine::CharCentreAverage()
{
	int accumulator = 0;
	int total = 0;
	double average;
	for ( int i = 0; i < m_CharacterHolderIndex; i++)
	{
		if (m_pCharacterHolder[i].m_CharType[3] != 1)// if is not well segmented
		{
			if (m_pCharacterHolder[i].m_CharType[1] == 1)//if is a high character
			{
				accumulator += (m_pCharacterHolder[i].m_CharCenter.y + 6);
			}
			else
				if ( m_pCharacterHolder[i].m_CharType[2] == 1) //if it is a low character
				{
					accumulator += (m_pCharacterHolder[i].m_CharCenter.y  - 6);
				}
				else
				{
					accumulator += m_pCharacterHolder[i].m_CharCenter.y;
				}
			total++;
		}
	}
	average = accumulator/ total;
	return (int) (average + m_Position_Y) ;
}

void AFXAPI SerializeElements( CArchive& ar, CDIACharacter* m_pCharacterHolder, int CharacterHolderIndex )
{
	

		if( ar.IsStoring() )
        {
			for (int i = 0; i <= (CharacterHolderIndex-1); i++)
			{	
			   // ar << CharacterHolder[i];
		
					m_pCharacterHolder[i].Serialize(ar);
			}
        }
        else
        {
//			m_pCharacterHolder = new CDIACharacter[CharacterHolderIndex];
        
			for (int i = 0; i <= (CharacterHolderIndex-1); i++)
			{
				//ar >> CharacterHolder[i];
				m_pCharacterHolder[i].Serialize(ar);
			}
		
        }
		
	

}
void CTextLine::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{	
		ar << m_Width << m_Height << m_Position_Y  << m_CharacterHolderIndex; 
		ar.Write(&FixedSegmentationPoint, sizeof(FIXINFO));
		
			//m_pCharacterHolder[i].Serialize(ar);
		SerializeElements(ar,m_pCharacterHolder,m_CharacterHolderIndex);
		

		
		
	}
	else
	{	
		ar >> m_Width >> m_Height >> m_Position_Y  >> m_CharacterHolderIndex;
		ar.Read(&FixedSegmentationPoint, sizeof(FIXINFO));

		m_pCharacterHolder = new CDIACharacter[m_CharacterHolderIndex];
		SerializeElements(ar,m_pCharacterHolder,m_CharacterHolderIndex);
		//ar.Read(&m_CharLocation, sizeof(CRect));
	}
}
