#pragma once
#include "DIAGreyScale.h"
#include "Distribution.h"
#include "DIACharacter.h"


class CDocImAnDoc;


class CTextLine : public CDIAGreyScale
{
	//DECLARE_SERIAL(CTextLine);
public:

	CTextLine(void);
	~CTextLine(void);
	CImage * GetImage();
	void CreateLine(int width, long FirstSeparator, long SecondSeparator, CImage * p_Image, BOOL ThinLine);
	void DeleteLine();
	int CountWideCharacters();
	int CharCentreAverage();

	int m_Width;
	long m_Height;
	long m_Position_Y;
	CDistribution <long> * m_pTextLineDistribution;
	CDocImAnDoc * m_pdoc;
	long * m_pTextLineProj;

	typedef struct SEPARATOR
	{
		int  Value;
		BOOL Strong;
	};
	//SEPARATOR * m_pSeparators;
	SEPARATOR * m_pWordSeparators;
	SEPARATOR * m_pCharacterSeparators;
	//BOOL m_WordSeparatorsComputed, m_CharacterSeparatorsComputed;
	//int m_WordSeparatorIndex;
	int m_CharacterSeparatorIndex;
	BOOL m_ThinLine;
	CDIACharacter * m_pCharacterHolder;
	int m_CharacterHolderIndex;
	int m_CharacterHolderIndex2;
	long m_mean;
	long m_ChartMax, m_ChartMax2;
	

	typedef struct FIXINFO
	{
		long FirstPos;
		int WidthVal;
		long Score;
	};
	FIXINFO FixedSegmentationPoint;
	FIXINFO * m_pFixedWidthArray;
	int m_CharShortAverage[4]; //[0] = top // [1] = ntotal // [2] = bottom // [3] = size
	//m_CharShorAverage does the average of the top and bottom values of the short
	//character per each line
	//int * words;
	int m_CharTallest[2]; // [0] = high // [1] = low
	
	virtual void Serialize(CArchive& ar);
};
