// XMLAttribute.cpp
// © 2004,2005 David Bridson
// Licenced under the GPL
#include "stdafx.h"
#include "XMLAttribute.h"

#include <stdlib.h>
#include <string.h>

#include "ExtraString.h"

// CONSTRUCTION

CXMLAttribute::CXMLAttribute()
{
	m_sName = NULL;
	m_sValue = NULL;
}

CXMLAttribute::CXMLAttribute(char * NewName, int NewValue)
{
	m_sName = NULL;
	m_sValue = NULL;
	SetName(NewName);
	SetValue(NewValue);
}

CXMLAttribute::CXMLAttribute(char * NewName,bool NewValue)
{
	m_sName = NULL;
	m_sValue = NULL;
	SetName(NewName);
	if(NewValue)
		SetValue("Yes");
	else
		SetValue("No");
}

CXMLAttribute::CXMLAttribute(char * NewName, char * NewValue)
{
	m_sName = NULL;
	m_sValue = NULL;
	SetName(NewName);
	SetValue(NewValue);
}

CXMLAttribute::CXMLAttribute(char * NewName, double NewValue)
{
	m_sName = NULL;
	m_sValue = NULL;
	SetName(NewName);
	SetValue(NewValue);
}

CXMLAttribute::~CXMLAttribute()
{
	delete  []m_sName;
	delete  []m_sValue;
}

// METHODS

unsigned int CXMLAttribute::ChangeState(const unsigned int NewState)
{
/*
	if(NewState == ST_ATT_NAME)
		printf("Attribute: Changing State To ST_ATT_NAME\n");
	else if(NewState == ST_ATT_BEFORE_EQUALS)
		printf("Attribute: Changing State To ST_ATT_BEFORE_EQUALS\n");
	else if(NewState == ST_ATT_EQUALS)
		printf("Attribute: Changing State To ST_ATT_EQUALS\n");
	else if(NewState == ST_ATT_AFTER_EQUALS)
		printf("Attribute: Changing State To ST_ATT_AFTER_EQUALS\n");
	else if(NewState == ST_ATT_STARTQUOTE)
		printf("Attribute: Changing State To ST_ATT_STARTQUOTE\n");
	else if(NewState == ST_ATT_VALUE)
		printf("Attribute: Changing State To ST_ATT_VALUE\n");
	else if(NewState == ST_ATT_ENDQUOTE)
		printf("Attribute: Changing State To ST_ATT_ENDQUOTE\n");
	else if(NewState == ST_UNDEFINED)
		printf("Attribute: Changing State To ST_UNDEFINED\n");
*/
	return NewState;
}

bool CXMLAttribute::CreateFromFile(FILE * File)
{
	unsigned int CurrentState = ST_START;
	char CurrentChar;	
	int Backup;
	
	char * Data = NULL;
	int DataAlloc = 0;
	
	delete [] m_sName;
	m_sName = NULL;

	while(!feof(File))
	{
		CurrentChar = fgetc(File);
//		printf("CurrentChar: %c\t%d\n",CurrentChar,CurrentChar);
		
		if(CExtraString::IsAlphaNumeric(CurrentChar) || CurrentChar == '-' || CurrentChar == '_' || CurrentChar == '.')
		{
			if(CurrentState == ST_START)
			{
				CurrentState = ChangeState(ST_ATT_NAME);
				delete [] Data;
				Data = new char[DATA_INIT];
				if(Data == NULL)
				{
					fprintf(stderr,"Couldn't Allocate Memory For Data\n");
					return false;
				}
				memset(Data,0,sizeof(char) * DATA_INIT);
				DataAlloc = DATA_INIT;
				Data[0] = CurrentChar;
			}
			else if(CurrentState == ST_ATT_NAME)
			{
				if(strlen(Data) == DataAlloc - 1)
				{
					char * temp = new char[DataAlloc + DATA_INCR];
					if(temp == NULL)
					{
						fprintf(stderr,"Couldn't ReAllocate Memory For Data\n");
						return false;
					}
					memcpy(temp,Data,sizeof(char) * DataAlloc);
					memset(&(temp[DataAlloc]),0,sizeof(char) * DATA_INCR);
					delete [] Data;
					Data = temp;
					DataAlloc += DATA_INCR;
				}
				Data[strlen(Data)] = CurrentChar;
			}
			else if(CurrentState == ST_ATT_BEFORE_EQUALS)
			{
				Backup++;
				fseek(File,-Backup,SEEK_CUR);
				return true;
			}
			else if(CurrentState == ST_ATT_STARTQUOTE)
			{
				CurrentState = ChangeState(ST_ATT_VALUE);
				delete [] Data;
				Data = new char[DATA_INIT];
				if(Data == NULL)
				{
					fprintf(stderr,"Couldn't Allocate Memory For Data\n");
					return false;
				}
				memset(Data,0,sizeof(char) * DATA_INIT);
				DataAlloc = DATA_INIT;
				Data[0] = CurrentChar;
			}
			else if(CurrentState == ST_ATT_VALUE)
			{
				if(strlen(Data) == DataAlloc - 1)
				{
					char * temp = new char[DataAlloc + DATA_INCR];
					if(temp == NULL)
					{
						fprintf(stderr,"Couldn't ReAllocate Memory For Data\n");
						return false;
					}
					memcpy(temp,Data,sizeof(char) * DataAlloc);
					memset(&(temp[DataAlloc]),0,sizeof(char) * DATA_INCR);
					delete [] Data;
					Data = temp;
				}
				Data[strlen(Data)] = CurrentChar;
			}
			else
			{
				CurrentState = ChangeState(ST_UNDEFINED);
			}
		}
		else if(CExtraString::IsWSpace(CurrentChar) || CurrentChar == '\n')
		{
			if(CurrentState == ST_ATT_NAME)
			{
				CurrentState = ChangeState(ST_ATT_BEFORE_EQUALS);
				Backup = 1;
				delete [] m_sName;
				m_sName = new char[strlen(Data)+1];
				if(m_sName == NULL)
				{
					fprintf(stderr,"Couldn't Allocate Memory for m_sName\n");
				}
				memcpy(m_sName,Data,sizeof(char) * (strlen(Data)+1));
				delete [] Data;
				Data = NULL;
//				printf("AttributeName: %s\n",m_sName);
			}
			else if(CurrentState == ST_ATT_BEFORE_EQUALS)
			{
				Backup++;
			}
			else if(CurrentState == ST_ATT_EQUALS)
			{
				CurrentState = ChangeState(ST_ATT_AFTER_EQUALS);
			}
			else if(CurrentState == ST_ATT_AFTER_EQUALS)
			{
			}
			else
			{
				CurrentState = ChangeState(ST_UNDEFINED);
			}
		}
		else if(CurrentChar == '=')
		{
			if
			(
				CurrentState == ST_ATT_BEFORE_EQUALS
			)
			{
				CurrentState = ChangeState(ST_ATT_EQUALS);
			}
			else if(CurrentState == ST_ATT_NAME)
			{
				CurrentState = ChangeState(ST_ATT_EQUALS);
				delete [] m_sName;
				m_sName = new char[strlen(Data)+1];
				if(m_sName == NULL)
				{
					fprintf(stderr,"Couldn't Allocate Memory for m_sName\n");
				}
				memcpy(m_sName,Data,sizeof(char) * (strlen(Data)+1));
				delete [] Data;
				Data = NULL;
//				printf("AttributeName: %s\n",m_sName);
			}
			else
			{
				CurrentState = ChangeState(ST_UNDEFINED);
			}
		}
		else if(CurrentChar == '\"')
		{
			if
			(
				CurrentState == ST_ATT_AFTER_EQUALS ||
				CurrentState == ST_ATT_EQUALS
			)
			{
				CurrentState = ChangeState(ST_ATT_STARTQUOTE);
			}
			else if(CurrentState == ST_ATT_VALUE)
			{
				CurrentState = ChangeState(ST_ATT_ENDQUOTE);
				delete [] m_sValue;
				m_sValue = new char[strlen(Data)+1];
				if(m_sValue == NULL)
				{
					fprintf(stderr,"Couldn't Allocate Memory for m_sValue\n");
					return false;
				}
				memcpy(m_sValue,Data,sizeof(char) * (strlen(Data)+1));
				delete [] Data;
				return true;
			}
		}
		else if(CurrentChar == '/' || CurrentChar == '>')
		{
			if(CurrentState == ST_ATT_BEFORE_EQUALS)
			{
				Backup++;
				fseek(File,-Backup,SEEK_CUR);
				return true;
			}
			else if(CurrentState == ST_ATT_ENDQUOTE)
			{
				Backup = 1;
				fseek(File,-Backup,SEEK_CUR);
				return true;
			}
			else
			{
				CurrentState = ChangeState(ST_UNDEFINED);
			}
		}
		else
		{
			CurrentState = ChangeState(ST_UNDEFINED);
		}
	}
	
/*
	const unsigned int ST_ATT_NAME          = 1640529137;
	const unsigned int ST_ATT_BEFORE_EQUALS =  314885809;
	const unsigned int ST_ATT_EQUALS        = 1831324534;
	const unsigned int ST_ATT_AFTER_EQUALS  = 1384179739;
	const unsigned int ST_ATT_STARTQUOTE    = 1920006059;
	const unsigned int ST_ATT_VALUE         =  347366392;
	const unsigned int ST_ATT_ENDQUOTE      = 1418602843;
*/
}

char * CXMLAttribute::GetName()
{
	return m_sName;
}

char * CXMLAttribute::GetValue()
{
	return m_sValue;
}

bool CXMLAttribute::SetName(char * NewName)
{
	delete [] m_sName;
	m_sName = new char[strlen(NewName) + 1];
	if(m_sName == NULL)
	{
		fprintf(stderr,"SetName: Couldn't Allocate Memory For m_sName\n");
		return false;
	}
	memcpy(m_sName,NewName,sizeof(char) * (strlen(NewName) + 1));
}

bool CXMLAttribute::SetValue(char * NewValue)
{
	delete [] m_sValue;
	m_sValue = new char[strlen(NewValue) + 1];
	if(m_sValue == NULL)
	{
		fprintf(stderr,"SetValue: Couldn't Allocate Memory For m_sValue\n");
		return false;
	}
	memcpy(m_sValue,NewValue,sizeof(char) * (strlen(NewValue) + 1));
	return true;
}

bool CXMLAttribute::SetValue(int NewValue)
{
	delete [] m_sValue;
	m_sValue = new char[CExtraString::strlen(NewValue) + 1];
	if(m_sValue == NULL)
	{
		fprintf(stderr,"SetValue: Couldn't Allocate Memory For m_sValue\n");
		return false;
	}
	memset(m_sValue,0,CExtraString::strlen(NewValue) + 1);
	sprintf(m_sValue,"%d",NewValue);
	return true;
}

bool CXMLAttribute::SetValue(double NewValue)
{
	delete [] m_sValue;
	m_sValue = new char[CExtraString::strlen(NewValue) + 1];
	if(m_sValue == NULL)
	{
		fprintf(stderr,"SetValue: Couldn't Allocate Memory For m_sValue\n");
		return false;
	}
	memset(m_sValue,0,CExtraString::strlen(NewValue) + 1);
	sprintf(m_sValue,"%f",NewValue);
	return true;
}

bool CXMLAttribute::WriteToFile(FILE * File)
{
	return(fprintf(File,"%s=\"%s\"",m_sName,m_sValue) >= 0);
}
