// XMLAttribute.h
// © 2004,2005 David Bridson
// Licenced under the GPL

#ifndef XMLATTRIBUTE_H
#define XMLATTRIBUTE_H

#include <stdio.h>

class CXMLAttribute
{
	// CONSTRUCTION
public:
	CXMLAttribute();
	CXMLAttribute(char * NewName,int    NewValue);
	CXMLAttribute(char * NewName,bool   NewValue);
	CXMLAttribute(char * NewName,char * NewValue);
	CXMLAttribute(char * NewName,double NewValue);
	~CXMLAttribute();

	// METHODS
public:
	unsigned int ChangeState(const unsigned int NewState);
	bool   CreateFromFile(FILE * File);
	char * GetName();
	char * GetValue();
	bool   SetName(char * NewName);
	bool   SetValue(char * NewValue);
	bool   SetValue(double NewValue);
	bool   SetValue(int NewValue);
	bool   WriteToFile(FILE * File);

	// DATA ITEMS
private:
	char * m_sName;
	char * m_sValue;

	static const unsigned int ST_START             =  611254133;
	static const unsigned int ST_ATT_NAME          = 1640529137;
	static const unsigned int ST_ATT_BEFORE_EQUALS =  314885809;
	static const unsigned int ST_ATT_EQUALS        = 1831324534;
	static const unsigned int ST_ATT_AFTER_EQUALS  = 1384179739;
	static const unsigned int ST_ATT_STARTQUOTE    = 1920006059;
	static const unsigned int ST_ATT_VALUE         =  347366392;
	static const unsigned int ST_ATT_ENDQUOTE      = 1418602843;
	static const unsigned int ST_UNDEFINED         = 1206633517;

	static const unsigned int DATA_INIT = 1024;
	static const unsigned int DATA_INCR = 1024;
};

#endif // XMLATTRIBUTE_H
