// XMLHeader.cpp
// © 2004,2005 David Bridson
// Licenced under the GPL
#include "stdafx.h"
#include "XMLDefinition.h"

#include <string.h>

// CONSTRUCTION

CXMLDefinition::CXMLDefinition()
{
	m_sEncoding = NULL;
	m_sVersion  = NULL;
}

CXMLDefinition::CXMLDefinition(char * NewVersion,char * NewEncoding)
{
	m_sEncoding = NULL;
	m_sVersion  = NULL;
	SetEncoding(NewEncoding);
	SetVersion(NewVersion);
}

CXMLDefinition::~CXMLDefinition()
{
	delete [] m_sEncoding;
	delete [] m_sVersion;
}

// METHODS

unsigned int CXMLDefinition::ChangeState(unsigned int NewState)
{
	return NewState;
}

bool CXMLDefinition::CreateFromFile(FILE * File)
{
	return false;
}

bool CXMLDefinition::SetEncoding(char * NewEncoding)
{
	delete [] m_sEncoding;
	m_sEncoding = new char[strlen(NewEncoding) + 1];
	if(m_sEncoding == NULL)
		return false;
	memcpy(m_sEncoding,NewEncoding,sizeof(char) * (strlen(NewEncoding) + 1));
	return true;
}

bool CXMLDefinition::SetVersion(char * NewVersion)
{
	delete [] m_sVersion;
	m_sVersion = new char[strlen(NewVersion) + 1];
	if(m_sVersion == NULL)
		return false;
	memcpy(m_sVersion,NewVersion,sizeof(char) * (strlen(NewVersion) + 1));
	return true;
}

bool CXMLDefinition::WriteToFile(FILE * File)
{
	fprintf(File,"<?xml version=\"%s\" encoding=\"%s\">",m_sVersion,m_sEncoding);
	return true;
}
