// XMLHeader.cpp
// © 2004,205 David Bridson
// Licenced under the GPL
#include "stdafx.h"
#include "XMLDocType.h"

#include <string.h>

// CONSTRUCTION

CXMLDocType::CXMLDocType()
{
	m_sBaseElementName = NULL;
	m_sDTDFileName = NULL;
}

CXMLDocType::CXMLDocType(char * NewBaseElementName, char * NewDTDFileName)
{
	m_sBaseElementName = NULL;
	m_sDTDFileName = NULL;
	SetBaseElementName(NewBaseElementName);
	SetDTDFileName(NewDTDFileName);
}

CXMLDocType::~CXMLDocType()
{
	delete [] m_sBaseElementName;
	delete [] m_sDTDFileName;
}

// METHODS

unsigned int CXMLDocType::ChangeState(unsigned int NewState)
{
	return NewState;
}

bool CXMLDocType::CreateFromFile(FILE * File)
{
	return true;
}

bool CXMLDocType::SetBaseElementName(char * NewBaseElementName)
{
	delete [] m_sBaseElementName;
	m_sBaseElementName = new char[strlen(NewBaseElementName) + 1];
	if(m_sBaseElementName == NULL)
	{
		fprintf(stderr,"SetBaseElementName: Couldn't Allocate Memory For m_sBaseElementName\n");
		return false;
	}
	memcpy(m_sBaseElementName,NewBaseElementName,sizeof(char) * (strlen(NewBaseElementName) + 1));
	return true;
}

bool CXMLDocType::SetDTDFileName(char * NewDTDFileName)
{
	delete [] m_sDTDFileName;
	m_sDTDFileName = new char[strlen(NewDTDFileName) + 1];
	if(m_sDTDFileName == NULL)
	{
		fprintf(stderr,"SetDTDFileName: Couldn't Allocate Memory For m_sDTDFileName\n");
		return false;
	}
	memcpy(m_sDTDFileName,NewDTDFileName,sizeof(char) * (strlen(NewDTDFileName) + 1));
	return true;
}

bool CXMLDocType::WriteToFile(FILE * File)
{
	fprintf(File,"<!DOCTYPE %s SYSTEM \"%s\">",m_sBaseElementName,m_sDTDFileName);
	return true;
}
