// XMLDocument.h
// © 2004,2005 David Bridson
// Licenced under the GPL

#ifndef XMLDOCUMENT_H
#define XMLDOCUMENT_H

#include <stdio.h>

#include "XMLLib.h"

class CXMLDocument
{
	// CONSTRUCTION
public:
	CXMLDocument();
	~CXMLDocument();

	// METHODS
public:
	bool CreateFromFile(FILE * File);
	bool CreateFromFile(const char * FileName);
	CXMLElement * GetBaseElement();
	void SetBaseElement(CXMLElement * NewBaseElement);
	void SetDefinition(CXMLDefinition * NewDefinition);
	void SetDocType(CXMLDocType * NewDocType);
	bool WriteToFile(FILE * File);
	bool WriteToFile(char * FileName);
private:
	unsigned int ChangeState(unsigned int NewState);
	void PrintState(unsigned int State);

	// DATA ITEMS
private:
	CXMLDefinition * m_pDefinition;
	CXMLDocType    * m_pDocType;
	CXMLElement    * m_pBaseElement;

	static const unsigned int ST_IGNORE_TAG              =  226617367;
	static const unsigned int ST_INITIAL_WHITE_SPACE     =  886233956;
	static const unsigned int ST_TAG_START_MARKER        =  839831595;
	static const unsigned int ST_TAG_INITIAL_WHITE_SPACE =  623146808;
	static const unsigned int ST_TAG_RECURSING           = 1065210732;
	static const unsigned int ST_OTHER_CONTENT           = 1048411409;
	static const unsigned int ST_UNDEFINED               = 1825191135;
};

#endif // XMLDOCUMENT_H
