// ClusteringCylindrical.h: interface for the CClusteringCylindrical class.
//
//////////////////////////////////////////////////////////////////////
//Delevoped by Dimosthenis Karatzas: karatzas@csc.liv.ac.uk
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CLUSTERINGCYLINDRICAL_H__INCLUDED_)
#define AFX_CLUSTERINGCYLINDRICAL_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Clustering3D.h"

#ifndef PI
#define PI 3.1415926535897932384626433832795f
#endif

#define CLUST_AM_DEGREES	0x01
#define CLUST_AM_RADIANS	0x02

#include "LibraryDeclaration.h"

//Make sure that functions declared using AFX_API, i.e. friend operator >> for serialization, are exported correctly
#ifndef IMAGE_CLASSES_NORMAL_USE
	#undef AFX_API
	#define AFX_API AFX_EXT_CLASS
#endif

class IMG_DECL_CLASS CClusteringCylindrical : public CClustering3D  
{
	DECLARE_SERIAL(CClusteringCylindrical)

public:
	BYTE GetAngleMode();
	void SetAngleMode(BYTE Mode);
	//Initialization
	CClusteringCylindrical();
	virtual ~CClusteringCylindrical();

	//Operations
	int		AddPoint(float r, float theta, float z);
	void	InitializeCluster(int ClusterID, float r, float theta, float z);
	BOOL	GetClusterInfo(int ClusterID, float *r, float *theta, float *z, int *size);
	int		HypotheticAssignment(float r, float theta, float z);

	//Variables
private:
	BYTE m_AngleMode;
};

//Restore AFX_API
#ifndef IMAGE_CLASSES_NORMAL_USE
	#undef AFX_API
	#define AFX_API
#endif

#endif