// HoughTransform2D.h: interface for the CHoughTransform2D class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_HOUGHTRANSFORM2D_H__AC068C37_E13E_427A_9070_E8FAB4E0F0B1__INCLUDED_)
#define AFX_HOUGHTRANSFORM2D_H__AC068C37_E13E_427A_9070_E8FAB4E0F0B1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef PI
#define PI 3.1415926535897932384626433832795f
#endif

#include "LibraryDeclaration.h"

class IMG_DECL_CLASS CHoughTransform2D : public CObject  
{
	typedef struct tagFPoint
	{
		float x;
		float y;
		float w;	//weight
	} FPoint;

public:
	float GetUFromCellX(int x);
	float GetRFromCellY(int y);
	BOOL IsInCell(float x, float y, int cellX, int cellY);
	void Reset();
	void SetU(float minU, float maxU, float quantU);
	void SetR(float minR, float maxR, float quantR);
	void LineHoughTransform(float ***pCell, int *pNumberOfCellsX, int *pNumberOfCellsY);
	int AddPoint(float x, float y, float w = 1.0f);
	CHoughTransform2D();
	virtual ~CHoughTransform2D();

	int			m_MaxPoints;
	FPoint *	m_Point;
	int			m_ArrayIncreamentStep;
	int			m_ArrayAllocated;
	float		m_DefaultMinR;	//R==rho is the distance of x,y from the origin
	float		m_DefaultMaxR;	
	float		m_DefaultQuantizationR;
	float		m_DefaultMinU;	//U==theta is the angle of x,y from x-axis. Given in radians
	float		m_DefaultMaxU;
	float		m_DefaultQuantizationU;
	float		m_DefaultOriginX; //Origin coordinates
	float		m_DefaultOriginY;
	int			m_nCellsX;
	int			m_nCellsY;
	float **	m_Cell;
};

#endif // !defined(AFX_HOUGHTRANSFORM2D_H__AC068C37_E13E_427A_9070_E8FAB4E0F0B1__INCLUDED_)
