#ifndef CONNECTEDCOMPONENT_H
#define CONNECTEDCOMPONENT_H

class CRun;

class CConnectedComponent
{
	// CONSTRUCTION
public:
	CConnectedComponent();
	~CConnectedComponent();

	// METHODS
public:
	bool AddRun(CRun * Run);
	int  GetSize();
	bool Create(CRun * Run);
	int  GetCentroidX();
	int  GetCentroidY();
	CConnectedComponent * GetNeighbour(int Index);
	int  GetNoRuns();
	CRun * GetRun(int Index);
	bool IsIn(int x, int y);
	bool Merge(CConnectedComponent * CC);
	int GetNoNeighbours();
	int GetX1();
	int GetX2();
	int GetY1();
	int GetY2();
	bool SetNeighbour(int Index,CConnectedComponent * Neighbour);
	bool SetNoNeighbours(int NoNeighbours);
	bool SetNoRuns(int Number);

	// DATA ITEMS
private:
	int     m_nRuns;
	int     m_nRunsAlloc;
	CRun ** m_pRuns;

	int     m_nNeighbours;
	CConnectedComponent ** m_pNeighbours;

	int m_nX1;
	int m_nX2;
	int m_nY1;
	int m_nY2;

	static const int RUN_INIT = 100;
	static const int RUN_INCR = 100;
};

#endif // CONNECTEDCOMPONENT_H

