#ifndef EXTRAMATH_H
#define EXTRAMATH_H

// #include "Range.h"

struct LineSegment;

class CExtraMath
{
	// METHODS
public:
	static double AngleTwoPoints(int X1, int Y1, int X2, int Y2);
	static int    CompareLineSegments(const LineSegment * A, const LineSegment * B);
	static double DegreesToRadians(double Degrees);
	static double DistanceTwoPoints(int X1, int Y1, int X2, int Y2);
	static bool   DoLineSegmentsIntersect(int AX1, int AY1, int AX2, int AY2, int BX1, int BY1, int BX2, int BY2);
	static int    IsGreater(const int A, const int B);
	static int    IsGreaterP(const int * A, const int * B);
//	static int    IsLineToRight(const RangeLine * A, const RangeLine * B);
	static int    IsSmaller(const int A, const int B);
	static int    IsSmallerP(const int * A, const int * B);
	static bool   IsIn(int SearchFor,int * InArray, int NoArrayMembers);
	static int    Min(int A, int B);
	static int    Max(int A, int B);
	static double RadiansToDegrees(double Radians);

	// DATA TYPES
public:
	typedef struct Line
	{
		double Slope;
		double Intercept;
	};
};

typedef struct Point
{
	int x;
	int y;
};

typedef Point Vertex;

typedef struct Edge
{
	int StartV;
	int EndV;
};

typedef struct LineSegment
{
	int x1;
	int y1;
	int x2;
	int y2;
};

typedef LineSegment Rect;

#endif // EXTRAMATH_H

