
#ifdef DLLDIR_EX
   #define DLLDIR  __declspec(dllexport)   // export DLL information
#else
   #define DLLDIR  __declspec(dllimport)   // import DLL information
#endif 


// The extern "C" declaration allows mixed languages compactability,
// it prevents the C++ compiler from using decorated (modified)
// names for the functions 
extern "C" { 


	bool DLLDIR InitDLL(unsigned int size);
	bool DLLDIR SwapProcessingNode(int index);

	bool DLLDIR InitFuzzyRules(char *VesselRules,int index);
	bool DLLDIR killMemory();		//kill and reset all systems
	bool DLLDIR StutdownDLL();		//when shuting down program
	void DLLDIR CleanUP(void *fis,double **dataMatrix,int data_row_n,double **fisMatrix,int fis_row_n,double **outputMatrix);
	void DLLDIR SetDebugMode(bool value);


	void DLLDIR ShowFuzzyDebugWindow();
	void DLLDIR CloseFuzzyDebugWindow();//lets see what the fuzzy DLL is
	

	void DLLDIR SetupInputMemory(int noElements,int noInputsPerElements);
	void DLLDIR SetupOutputMemory(int noElements,int noOutputsPerElements);
	void DLLDIR SetupMFMemory(int noElements,int inputs,int MFperElement);
	void DLLDIR SetupInputOutputMemory(int noElements);//Setup the input output needed
	void DLLDIR SetMembershipFunctionBounds(int n_input,double bounds[]);		//change the bounds of input x
	void DLLDIR SetFuzzyRules(int rule_no,int in_rule,double in_rules[],int out_rule,double out_rules[]);
	void DLLDIR SetOutputMembershipFunctionParam(int n_ouput,int,double values[]);

	void DLLDIR ResetInputMemory();			
	void DLLDIR ResetOutputMemory();
	void DLLDIR ResetMFMemory();
	void DLLDIR ResetMemory();
	void DLLDIR ResizeInputMemory(int noElements,int noInputsPerElements);
	void DLLDIR ResizeOutputMemory(int noElements,int noOutputsPerElements);
	void DLLDIR ResizeMFMemory(int noElements,int nputs,int MFperElement);
	
	bool DLLDIR DeleteMFFunctionMemory();
	bool DLLDIR DeleteOutputMemory();
	bool DLLDIR DeleteInputMemory();
	
	double DLLDIR ** GetInputPointer(int *inRows,int *inCols);
	double DLLDIR ** GetOutputPointer(int *outRows,int *outCols);
	double DLLDIR *** GetMFPointer(int *,int *mfR,int *mfC);

	int DLLDIR NumberOfOutputs();		//how many rules are there per fuzzy logic run
	int DLLDIR NumberOfInputs();		//
	int DLLDIR NumberOfRules();


	//general acessor methods
 
	void DLLDIR SetOrMethod(char *method);
	void DLLDIR SetAndMethod(char *method);
	void DLLDIR SetDefuzzMethod(char *method);
	void DLLDIR SetImplicatorMethod(char *method);
	void DLLDIR SetAggregatorMethod(char *method);

	//operations
	
	double DLLDIR FindInputLowParam(int n_input);
	double DLLDIR FindInputHighParam(int n_input);
	double DLLDIR FindOutputHighParam(int n_input);

	void DLLDIR GetMembershipFunctionParam(int n_input,int n_mf,double *params);
	void DLLDIR SetMembershipFunctionParam(int n_input,int n_mf,double values[]);
	void DLLDIR DoFuzzyLogic();			//process the current node
	void DLLDIR DoALLFuzzyLogic();		//process all active nodes
	void DLLDIR CalculateMemberShipFunctions();
	void DLLDIR WriteFuzzyRuleFile(char *filename);		//used to write the rule file to disk
	void DLLDIR WriteFuzzyRuleFileWithDefaultIDs(char *filename);
	//old code

	double DLLDIR CheckIfAVessel(char *fis_file,double magnitude,double intensity,int debug);		//keep but should rewrite
	double DLLDIR checkImageFormat(char *fis_file,int red,int green,int blue,int debug);

};
