// DocImAnView.cpp : implementation of the CDocImAnView class
//
#include "ImageLib.h"
#include "stdafx.h"
#include "DocImAn.h"
#include "Image.h"
#include "DocImAnDoc.h"
#include "DocImAnView.h"
#include "TextLine.h"
#include "DIADlgHistogramTransformation.h"
#include "DIADlgProjectionsDialog.h"
#include "DIADlgCharEnh.h"
#include "DIASegmentation.h"
#include "DIAHistograms.h"
#include "DlgGroups.h"
#include "DlgAddImages.h"
#include "DlgOcr.h"
#include "DlgExportChar.h"
#include "DIADlgFindDivisions.h"
#include "DlgTestingEnvironment.h"
#include "RecurseDir.h"
#include "DIAHiColorImage.h"
#include "DlgPerfectChars2.h"
#include "DIAXmlDoc.h"
#include "XMLDocument.h"
#include "XMLElement.h"
#include "GetValues.h"
#include "DlgDIASegmentation.h"
#include "DlgDIAHistograms.h"
#include "DlgDIAPlot2D.h"
#include "DlgDIATest.h"
#include "DlgSetUncertainAreas.h"
#include "Distance.h"
#include "DemoSegStep11.h"
#include "DemoSegStep2.h"
#include "DemoLoc.h"
#include "DemoCT.h"
#include "DemoAB.h"
#include "DemoComb.h"
#include "DemoFTRIm.h"

#include ".\docimanview.h"
#include "MainFrm.h"

//#import "MDIVWCTL.DLL"
//using namespace MODI;
//CoInitialize(NULL);


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

class CDocImAnDoc;
// CDocImAnView

IMPLEMENT_DYNCREATE(CDocImAnView, CScrollView)

BEGIN_MESSAGE_MAP(CDocImAnView, CScrollView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
	ON_COMMAND(ID_INCREASE_SIZE, OnIncreaseSize)
	ON_COMMAND(ID_DECREASE_SIZE, OnDecreaseSize)
	ON_WM_SIZE()
	ON_COMMAND(ID_FILTERS_SMOOTHING, OnFiltersSmoothing)
	ON_COMMAND(ID_FILTERS_BLUR, OnFiltersBlur)
	ON_COMMAND(ID_HISTOGRAMS_TRANSFORMATION, OnHistogramsTransformation)
	ON_COMMAND(ID_HISTOGRAMS_EQUALIZATION, OnHistogramsEqualization)
	ON_COMMAND(ID_IMAGE_PROJECTIONS, OnImageProjections)
	ON_COMMAND(ID_VIEW_INDIVIDUALCHARACTERVIEW, OnViewIndividualcharacterview)
	ON_UPDATE_COMMAND_UI(ID_VIEW_INDIVIDUALCHARACTERVIEW, OnUpdateViewIndividualcharacterview)
	ON_COMMAND(ID_SEGMENTATION_COMPLETE, OnSegmentationComplete)
	ON_COMMAND(ID_CHARACTERENHANCE_COMPLETE, OnCharacterenhanceComplete)
	ON_COMMAND(ID_CHARACTERENHANCE_RESEGMENT, OnCharacterenhanceResegment)
	ON_COMMAND(ID_CHARACTERENHANCE_EXPORTLOCATEDCHARACTERS, OnCharacterenhanceExportlocatedcharacters)
	ON_COMMAND(ID_CHARACTERENHANCE_COMPLETE40, OnCharacterenhanceComplete40)
	ON_COMMAND(ID_CHARACTERENHANCE_GROUPVALUESINSETS, OnCharacterenhanceGroupvaluesinsets)
	ON_COMMAND(ID_FILTERS_NIBLACK, OnFiltersNiblack)
	ON_COMMAND(ID_FILTERS_MEAN, OnFiltersMean)
	ON_COMMAND(ID_FILTERS_NIBLACKDIMOS, OnFiltersNiblackdimos)
	ON_COMMAND(ID_FILTERS_THRESHOLD128, OnFiltersThreshold128)
	ON_COMMAND(ID_FILTERS_SAUVOLA, OnFiltersSauvola)
	ON_COMMAND(ID_SEGMENTATION_SHOWCHARACTERCENTRES, OnSegmentationShowcharactercentres)
	ON_COMMAND(ID_FILTERS_ADAPTIVEHISTOGRAM, OnFiltersAdaptivehistogram)
	ON_COMMAND(ID_SEGMENTATION_ONLYSEGMENTATION, OnSegmentationOnlysegmentation)
	ON_COMMAND(ID_SEGMENTATION_LINES, OnSegmentationLines)
	ON_COMMAND(ID_IMAGE_ADDTWOIMAGES, OnImageAddtwoimages)
	ON_COMMAND(ID_FILTERS_EDGEPRESERVINGSMOOTH, OnFiltersEdgepreservingsmooth)
	ON_COMMAND(ID_FILTERS_THRESHOLD40, OnFiltersThreshold40)
	ON_COMMAND(ID_IMAGE_OUTPUTCLEANIMAGE, OnImageOutputcleanimage)
	ON_COMMAND(ID_OCR_OCRIMAGE, OnOcrOcrimage)
	ON_COMMAND(ID_PREPROCESSING_NORMAL, OnPreprocessingNormal)
	ON_COMMAND(ID_PREPROCESSING_SOFT, OnPreprocessingSoft)
	ON_COMMAND(ID_FIXEDWIDTHSEGMENTATION_WIDTH, OnFixedwidthsegmentationWidth)
	ON_COMMAND(ID_CHARACTERENHANCE_LOCALIZECHARACTERS, OnCharacterenhanceLocalizecharacters)
	ON_COMMAND(ID_CHARACTERENHANCE_LOCALIZECHARACTERS, OnCharacterenhanceLocalizecharacters)
	ON_COMMAND(ID_IMAGE_CLEAN, OnImageClean)
	ON_COMMAND(ID_FILTERS_GAUSSIAN, OnFiltersGaussian)
	ON_COMMAND(ID_FILTERS_MEDIAN, OnFiltersMedian)
	ON_COMMAND(ID_COMPLETEMETHODS_FUZZYMEDIAN, OnCompletemethodsFuzzymedian)
	ON_COMMAND(ID_COMPLETEMETHODS_FUZZYMEAN, OnCompletemethodsFuzzymean)
	ON_COMMAND(ID_COMPLETEMETHODS_ADAPTIVETHR40, OnCompletemethodsAdaptivethr40)
	ON_COMMAND(ID_THRESHOLD_THRESHOLDINGROUPS, OnThresholdThresholdingroups)
	ON_COMMAND(ID_SEGMENTATION_FIXEDLINESEGMENTATION, OnSegmentationFixedlinesegmentation)
	ON_COMMAND(ID_COMPLETEMETHODS_GATOS, OnCompletemethodsGatos)
	ON_COMMAND(ID_IMAGE_CLEAN32855, OnImageClean32855)
	ON_COMMAND(ID_EXPORT_LOCATEDCHARACTERIMAGES, OnExportLocatedcharacterimages)
	ON_COMMAND(ID_SEGMENTATION_DIVISIONS, OnSegmentationDivisions)
	ON_COMMAND(ID_TESTING_OPENTESTINGENVIRONMENT, OnTestingOpentestingenvironment)
	ON_COMMAND(ID_ENHANCEMENT_FLEXIBLETEXTRECOVERY, OnEnhancementFlexibletextrecovery)
	//ON_COMMAND(ID_TESTING_IMPORTPERFECTCHARACTERSTOFILE, OnTestingImportperfectcharacterstofile)
	ON_COMMAND(ID_ENHANCEMENT_FTRIMPROVED, OnEnhancementFtrimproved)
	ON_COMMAND(ID_LINESEGMENTATION_WITHPREPROCESSING, OnLinesegmentationWithpreprocessing)
	ON_COMMAND(ID_LINESEGMENTATION_WITHOUTPREPROCESSING, OnLinesegmentationWithoutpreprocessing)
	ON_COMMAND(ID_LINESEGMENTATION_FIXED, OnLinesegmentationFixed)
	ON_COMMAND(ID_LINESEGMENTATION_FIXEDWITHOUTPRE, OnLinesegmentationFixedwithoutpre)
	ON_COMMAND(ID_OCR_ADDPERFECTCHARFOROCR, OnOcrAddperfectcharforocr)
	ON_COMMAND(ID_IMAGE_CCANALYSIS, OnImageCcanalysis)
	ON_COMMAND(ID_EXPORT_TOXMLDOC, OnExportToxmldoc)
	ON_COMMAND(ID_OCR_ADDIMAGESTOCLASSIFIER, OnOcrAddimagestoclassifier)
	ON_COMMAND(ID_OCR_CREATEOCRTABLE, OnOcrCreateocrtable)
	ON_COMMAND(ID_FIXED_LINESEGMENTATION, OnFixedLinesegmentation)
	ON_COMMAND(ID_FIXED_COMPLETE, OnFixedComplete)
	ON_COMMAND(ID_FILTERS_LINEFINDER, OnFiltersLinefinder)
	ON_COMMAND(ID_FILTERS_ADAPTIVEHISTOTOMAXMIN, OnFiltersAdaptivehistotomaxmin)
	ON_COMMAND(ID_SEGMENTATION_LOCATE4, OnSegmentationLocate4)
	ON_COMMAND(ID_SEGMENTATION_CCBASEDLOCATION, OnSegmentationCcbasedlocation)
	ON_COMMAND(ID_TEXTSEGMENTATION_MENU, OnTextsegmentationMenu)
	ON_COMMAND(ID_HISTOGRAMS_BACKGROUNDHISTOGRAM, OnHistogramsBackgroundhistogram)
	ON_COMMAND(ID_CHARACTERS_DISPLAYUNCERTAINAREASOFIMPORTANCE, OnCharactersDisplayuncertainareasofimportance)
	ON_COMMAND(ID_VIEW_LOCALISEDCHARACTERVIEW, OnViewLocalisedcharacterview)
	ON_UPDATE_COMMAND_UI(ID_VIEW_LOCALISEDCHARACTERVIEW, OnUpdateViewLocalisedcharacterview)
	ON_COMMAND(ID_VIEW_SEGMENTEDCHARACTERVIEW, OnViewSegmentedcharacterview)
	ON_UPDATE_COMMAND_UI(ID_VIEW_SEGMENTEDCHARACTERVIEW, OnUpdateViewSegmentedcharacterview)
	ON_COMMAND(ID_CHARACTERS_DISPLAYUNCERTAINAREASNEXTTOORANGE, OnCharactersDisplayuncertainareasnexttoorange)
	ON_COMMAND(ID_CHARACTERS_CLEARGREENPOINTS, OnCharactersCleargreenpoints)
	ON_COMMAND(ID_PINKPOINTS_CLEAR, OnPinkpointsClear)
	ON_COMMAND(ID_PINKPOINTS_ADDTOCHARS, OnPinkpointsAddtochars)
	ON_COMMAND(ID_CLEARGREENPOINTS_CLEAR, OnCleargreenpointsClear)
	ON_COMMAND(ID_CLEARGREENPOINTS_ADD, OnCleargreenpointsAdd)
	ON_COMMAND(ID_CLEARGREENPOINTS_GREEN, OnCleargreenpointsGreen)
	ON_COMMAND(ID_PINKPOINTS_PINK, OnPinkpointsPink)
	ON_COMMAND(ID_GREY_CLEAR, OnGreyClear)
	ON_COMMAND(ID_GREY_ADD, OnGreyAdd)
	ON_COMMAND(ID_GREY_GREY, OnGreyGrey)
	ON_COMMAND(ID_ORANGE_CLEAR, OnOrangeClear)
	ON_COMMAND(ID_ORANGE_ADD, OnOrangeAdd)
	ON_COMMAND(ID_ORANGE_ORANGE, OnOrangeOrange)
	ON_COMMAND(ID_CHARACTERS_SETUNCERTAINAREAS, OnCharactersSetuncertainareas)
	ON_COMMAND(ID_CHARACTERS_REFINEMENT, OnCharactersRefinement)
	ON_COMMAND(ID_OCR_RECOGNISEUSINGUNCERTAINAREAS, OnOcrRecogniseusinguncertainareas)
	ON_COMMAND(ID_EXPORT_CHARACTERSIZES, OnExportCharactersizes)
	ON_COMMAND(ID_OCR_RECOGNISE, OnOcrRecognise)
	ON_COMMAND(ID_OCR_FULLRECOVERY, OnOcrFullrecovery)
	ON_COMMAND(ID_OCR_ADDGROUNDTRUTHTOIMAGE, OnOcrAddgroundtruthtoimage)
	ON_COMMAND(ID_OCR_COMPUTEINDIVIDUALSTATISTICS, OnOcrComputeindividualstatistics)
	ON_COMMAND(ID_OCR_COMPUTESTATISTICSGROUPOFIMAGES, OnOcrComputestatisticsgroupofimages)
	ON_COMMAND(ID_MODI_ORIGINAL, OnModiOriginal)
	ON_COMMAND(ID_LEVENSTEINDISTANCE_TEST, OnLevensteindistanceTest)
	ON_COMMAND(ID_MODI_FTR, OnModiFtr)
	ON_COMMAND(ID_MODI_GATOS, OnModiGatos)
	ON_COMMAND(ID_ABBYY_ORIGINAL, OnAbbyyOriginal)
	ON_COMMAND(ID_ABBYY_FTR, OnAbbyyFtr)
	ON_COMMAND(ID_ABBYY_GATOS, OnAbbyyGatos)
	ON_COMMAND(ID_LEVENSTEINDISTANCE_FTR, OnLevensteindistanceFtr)
	ON_COMMAND(ID_LEVENSTEINDISTANCE_ALL, OnLevensteindistanceAll)
	ON_COMMAND(ID_MODI_OTSU, OnModiOtsu)
	ON_COMMAND(ID_ABBYY_OTSU, OnAbbyyOtsu)
	ON_COMMAND(ID_ABBYY_REFINED2, OnAbbyyRefined2)
	ON_COMMAND(ID_MODI_REFINED2, OnModiRefined2)
	ON_COMMAND(ID_MATCHING_REFINED, OnMatchingRefined)
	//ON_COMMAND(ID_DEMO_1, OnDemo1)
	//ON_COMMAND(ID_DEMO_2, OnDemo2)
	ON_COMMAND(ID_3_3, On33)
	ON_COMMAND(ID_3_COMPARISON, On3Comparison)
	ON_COMMAND(ID_3_4, On34)
	ON_COMMAND(ID_4_4, On44)
	ON_COMMAND(ID_4_5, On45)
	ON_COMMAND(ID_4_6, On46)
	ON_COMMAND(ID_DEMO_5, OnDemo5)
	ON_COMMAND(ID_3_6, On36)
	ON_COMMAND(ID_1_SEGMENTATION, On1Segmentation)
	ON_COMMAND(ID_1_1, On11)
	ON_COMMAND(ID_FTRDEMO_COMPLETEFTR, &CDocImAnView::OnFtrdemoCompleteftr)
	ON_COMMAND(ID_2_CT, &CDocImAnView::On2Ct)
	ON_COMMAND(ID_2_AB, &CDocImAnView::On2Ab)
	ON_COMMAND(ID_2_COMBINATION, &CDocImAnView::On2Combination)
	ON_COMMAND(ID_FTRDEMO_FTRDEMO, &CDocImAnView::OnFtrdemoFtrdemo)
	ON_COMMAND(ID_FTRDEMO_0, &CDocImAnView::OnFtrdemo0)
	ON_COMMAND(ID_REFINEMENTDEMO_LOCATIONOFAREASOFUNCERTAINTY, &CDocImAnView::OnRefinementdemoLocationofareasofuncertainty)
	END_MESSAGE_MAP()

// CDocImAnView construction/destruction

CDocImAnView::CDocImAnView()
{
	m_OffsetX = 0;
	m_OffsetY = 0;
	m_magnification = 1;
	m_Increasing = TRUE;
	m_ShowCharCentres = false;
	IsResegmenting = false;
	m_bShowLines = false;
	m_bShowUncertainAreas = false;
	
	m_applying_separatorsV = FALSE;
	m_applying_separatorsH = FALSE;
	m_bViewIndividualCharacters = false;
	m_bViewLocatedCharacters = true;
	m_bViewSegmentedCharacters = true;

	int filterBlur[7][7]={
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0},
	{0,0,1,1,1,0,0},
	{0,0,1,1,1,0,0},
	{0,0,1,1,1,0,0},
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0}
	};
	int filterSmooth[7][7]={
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0},
	{0,0,1,2,1,0,0},
	{0,0,2,4,2,0,0},
	{0,0,1,2,1,0,0},
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0}
	};

	int i;	int j;
	for (i=0;i<7;i++)
	{
		for (j=0;j<7;j++)
		{
			m_SmoothFilter.Filter[i][j]=filterSmooth[i][j];
		}
	}
	m_SmoothFilter.Div=16;
	m_SmoothFilter.Size=3;

	for (i=0;i<7;i++)
	{
		for (j=0;j<7;j++)
		{
			m_BlurFilter.Filter[i][j]=filterBlur[i][j];
		}
	}
	m_BlurFilter.Div=9;
	m_BlurFilter.Size=3;
	
	int filterGaussian[7][7]={
	{0,0,0 ,0 ,0 ,0,0},
	{0,1,4 ,7 ,4 ,1,0},
	{0,4,16,26,16,4,0},
	{0,7,26,41,26,7,0},
	{0,4,16,26,16,4,0},
	{0,1,4 ,7 ,4 ,1,0},
	{0,0,0 ,0 ,0 ,0,0}
	};
	m_GaussianFilter.Div=273;
	m_GaussianFilter.Size=5;

	for (i=0;i<7;i++)
	{
		for (j=0;j<7;j++)
		{
			m_GaussianFilter.Filter[i][j]=filterGaussian[i][j];
		}
	}

}

CDocImAnView::~CDocImAnView()
{
}

CImage * CDocImAnView::GetActiveImage()
{
	return GetDocument()->GetActiveImage();
}
void CDocImAnView::SetActiveImage(CImage * mImage)
{
	return GetDocument()->SetActiveImage( mImage);
}
BOOL CDocImAnView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CDocImAnView drawing

void CDocImAnView::OnDraw(CDC* pDC)
{
	CDocImAnDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CDC DC;
	DC.CreateCompatibleDC(NULL);	
	
	CBitmap bmp;
	if (GetActiveImage() == NULL)
	{

	  
	}
	else
	{
		GetActiveImage()->SetDirty();
		//Select the image into DC
		GetActiveImage()->GetBitmap(&bmp);
		DC.SelectObject(&bmp);
	}
	
	//draw the background//
	CRect cRect; 	//CRect aRect;
	CBrush brush;
	GetClientRect(&cRect);
	brush.CreateSolidBrush(RGB(150,50,50));

	pDC->SelectObject(&brush);
	pDC->FillRect(CRect(0,0,cRect.right,cRect.bottom), &brush);
	pDC->SetStretchBltMode(COLORONCOLOR);
	

	if (m_Increasing = FALSE) pDC->StretchBlt(m_OffsetX,m_OffsetY,GetWidth()* m_magnification ,GetHeight()* m_magnification,&DC,0,0,GetWidth(),GetHeight(),SRCCOPY);
	else pDC->StretchBlt(m_OffsetX,m_OffsetY,GetWidth()* m_magnification ,GetHeight()* m_magnification,&DC,0,0,GetWidth(),GetHeight() ,SRCCOPY);
	//if (
	if (m_bShowLines)
	{
		if (m_bViewSegmentedCharacters)
		{
			CPen pen;
			pen.CreatePen(PS_SOLID,2,RGB(0,0,0));
			pDC->SelectObject(pen);
			if (pDoc->m_LineHolderIndex > 0)
			{
				for (int i = 0; i < pDoc->m_LineHolderIndex; i++)
				{
					pDC->MoveTo(m_OffsetX,m_OffsetY + (pDoc->m_pLineHolder[i].m_Position_Y* m_magnification));
					pDC->LineTo(m_OffsetX + (pDoc->m_pLineHolder[i].m_Width* m_magnification),m_OffsetY + (pDoc->m_pLineHolder[i].m_Position_Y * m_magnification));
				}
			}
		}
	}
	//dlg projections
	m_bViewIndividualCharacters = true;
	if (m_bViewSegmentedCharacters)
	{
		if (!m_bViewIndividualCharacters)
		{//showing all the characters

			CPen pen;
			pen.CreatePen(PS_SOLID,2,RGB(0,0,0));
			CPen pen2;
			pen2.CreatePen(PS_SOLID,2,RGB(255,0,0));
			pDC->SelectObject(pen);
			if (pDoc->m_LineHolderIndex > 0)
			{
				for (int i = 0; i < pDoc->m_LineHolderIndex; i++)
				{
					pDC->MoveTo(m_OffsetX,m_OffsetY + (pDoc->m_pLineHolder[i].m_Position_Y* m_magnification));
					pDC->LineTo(m_OffsetX + (pDoc->m_pLineHolder[i].m_Width* m_magnification),m_OffsetY + (pDoc->m_pLineHolder[i].m_Position_Y * m_magnification));
					/*if (IsResegmenting)
					{	
						
						pDC->SelectObject(pen2);
						pDC->MoveTo(m_OffsetX,m_OffsetY + (pDoc->m_pLineHolder2[i].m_Position_Y* m_magnification));
						pDC->LineTo(m_OffsetX + (pDoc->m_pLineHolder2[i].m_Width * m_magnification), m_OffsetY + (pDoc->m_pLineHolder2[i].m_Position_Y * m_magnification));
						pDC->MoveTo(m_OffsetX,m_OffsetY + ((pDoc->m_pLineHolder2[i].m_Position_Y + pDoc->m_pLineHolder2[i].m_Height) * m_magnification));
						pDC->LineTo(m_OffsetX + (pDoc->m_pLineHolder2[i].m_Width * m_magnification), m_OffsetY + ((pDoc->m_pLineHolder2[i].m_Position_Y + pDoc->m_pLineHolder2[i].m_Height) * m_magnification));
						pDC->SelectObject(pen);
					}*/
					for (int j = 0; j < pDoc->m_pLineHolder[i].m_CharacterSeparatorIndex;j++)
					{
						if (pDoc->m_pLineHolder[i].m_pCharacterSeparators[j].Value <= pDoc->m_pLineHolder[i].m_Width)
						{
							if (pDoc->m_pLineHolder[i].m_pCharacterSeparators[j].Strong == TRUE)
							{
								pDC->MoveTo(m_OffsetX + (pDoc->m_pLineHolder[i].m_pCharacterSeparators[j].Value * m_magnification),m_OffsetY + (pDoc->m_pLineHolder[i].m_Position_Y * m_magnification));
								pDC->LineTo(m_OffsetX + (pDoc->m_pLineHolder[i].m_pCharacterSeparators[j].Value * m_magnification),m_OffsetY + ((pDoc->m_pLineHolder[i].m_Position_Y + pDoc->m_pLineHolder[i].m_Height)* m_magnification));
							}
						}
					}
					/*if (IsResegmenting)
					{
						if (pDoc->m_pLineHolder2[i].m_pCharacterHolder != NULL)
						{
							for (int x = 0; x < pDoc->m_pLineHolder2[i].m_CharacterHolderIndex2; x++)
							{
							
								pDC->SelectObject(pen2);
								pDC->MoveTo(m_OffsetX + (pDoc->m_pLineHolder2[i].m_pCharacterHolder[x].m_Position_X * m_magnification), m_OffsetY + (pDoc->m_pLineHolder2[i].m_pCharacterHolder[x].m_Position_Y * m_magnification));
								pDC->LineTo(m_OffsetX + (pDoc->m_pLineHolder2[i].m_pCharacterHolder[x].m_Position_X * m_magnification), m_OffsetY + ((pDoc->m_pLineHolder2[i].m_pCharacterHolder[x].m_Position_Y + pDoc->m_pLineHolder2[i].m_pCharacterHolder[x].m_Width)  * m_magnification));
								pDC->MoveTo(m_OffsetX + ((pDoc->m_pLineHolder2[i].m_pCharacterHolder[x].m_Position_X + pDoc->m_pLineHolder2[i].m_pCharacterHolder[x].m_Width)  * m_magnification), m_OffsetY + (pDoc->m_pLineHolder2[i].m_pCharacterHolder[x].m_Position_Y * m_magnification));
								pDC->LineTo(m_OffsetX + ((pDoc->m_pLineHolder2[i].m_pCharacterHolder[x].m_Position_X + pDoc->m_pLineHolder2[i].m_pCharacterHolder[x].m_Width)  * m_magnification), m_OffsetY + ((pDoc->m_pLineHolder2[i].m_pCharacterHolder[x].m_Position_Y + pDoc->m_pLineHolder2[i].m_pCharacterHolder[x].m_Width)  * m_magnification));
								pDC->SelectObject(pen);
							}
						}
					}*/
					
				}
				pDC->MoveTo(m_OffsetX, m_OffsetY + ((pDoc->m_pLineHolder[pDoc->m_LineHolderIndex-1].m_Position_Y + pDoc->m_pLineHolder[pDoc->m_LineHolderIndex-1].m_Height) * m_magnification));
				pDC->LineTo(m_OffsetX + (pDoc->m_pLineHolder[pDoc->m_LineHolderIndex-1].m_Width * m_magnification), m_OffsetY + ((pDoc->m_pLineHolder[pDoc->m_LineHolderIndex-1].m_Position_Y + pDoc->m_pLineHolder[pDoc->m_LineHolderIndex-1].m_Height)*m_magnification));
			
				
			}
		}
	
	else
	{
		if (m_bViewSegmentedCharacters)//showing characters one by one, only the good ones
		{
			CPen pen,pen2;
			pen.CreatePen(PS_SOLID,2,RGB(0,0,0));
			pen2.CreatePen(PS_SOLID,2,RGB(0,0,255));
			pDC->SelectObject(pen);
			if (pDoc->m_LineHolderIndex > 0)
			{
				for (int i = 0; i < pDoc->m_LineHolderIndex; i ++)
				{
					if (pDoc->m_pLineHolder[i].m_CharacterHolderIndex != 0)
					{
						for (int j = 0; j < pDoc->m_pLineHolder[i].m_CharacterHolderIndex; j++)
						{
							pDC->MoveTo(m_OffsetX + (pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X * m_magnification), m_OffsetY + (pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y * m_magnification));
							pDC->LineTo(m_OffsetX + ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Width) * m_magnification), m_OffsetY + (pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y)* m_magnification);
							pDC->LineTo(m_OffsetX + ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Width) * m_magnification), m_OffsetY + ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Height)* m_magnification));
							pDC->LineTo(m_OffsetX + (pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X * m_magnification), m_OffsetY + (pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Height)* m_magnification);
							pDC->LineTo(m_OffsetX + (pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X * m_magnification), m_OffsetY + (pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y * m_magnification));
							//if showing charcter InBox
							//if (pDoc->m_ShowInBox == true)
							////if (pDoc->m_IsCharLocalized == true)
							//{	
							//	pDC->MoveTo(m_OffsetX + ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left) * m_magnification), m_OffsetY + ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top) * m_magnification));
							//	pDC->LineTo(m_OffsetX + ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right) * m_magnification), m_OffsetY + ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top) * m_magnification));
							//	pDC->LineTo(m_OffsetX + ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right) * m_magnification), m_OffsetY + ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom) * m_magnification));
							//	pDC->LineTo(m_OffsetX + ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left) * m_magnification), m_OffsetY + ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom) * m_magnification));
							//	pDC->LineTo(m_OffsetX + ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left) * m_magnification), m_OffsetY + ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top) * m_magnification));	
							//}
						}
					}

				}
			}
		}

	}

	}
	//showing fixed width character boxes in red, on top of previously segmented ones
	if (pDoc->m_pLineHolder != NULL)
	{
		if (pDoc->m_ShowFix == true)
		{
			int Pos = 0;
			CPen pen;
			pen.CreatePen(PS_SOLID,2,RGB(255,0,0));
			pDC->SelectObject(pen);

			for (int i = 0; i < pDoc->m_LineHolderIndex; i ++)
				{
					Pos = 0;
					int loops = pDoc->m_pLineHolder[i].m_Width / pDoc->m_pLineHolder[i].FixedSegmentationPoint.WidthVal;
					for (int j = 0; j < loops; j++)
						{
							pDC->MoveTo(m_OffsetX + ((pDoc->m_pLineHolder[i].FixedSegmentationPoint.FirstPos + Pos) * m_magnification), m_OffsetY + (pDoc->m_pLineHolder[i].m_Position_Y * m_magnification));
							pDC->LineTo(m_OffsetX + ((pDoc->m_pLineHolder[i].FixedSegmentationPoint.FirstPos + Pos) * m_magnification), m_OffsetY + ((pDoc->m_pLineHolder[i].m_Position_Y + pDoc->m_pLineHolder[i].m_Height)* m_magnification));
							Pos += pDoc->m_pLineHolder[i].FixedSegmentationPoint.WidthVal;
						}	
				}
		}
	}
	//show in Localized chars
	
		if (pDoc->m_pLineHolder != NULL)
		{
			if (pDoc->m_IsCharLocalized == true)
			//if (pDoc->m_ShowInBox == true)
			{

				CPen penShort, penHigh, penLow, pen, penPunct;
				penShort.CreatePen(PS_SOLID,1,RGB(0,0,255));
				penHigh.CreatePen(PS_SOLID,1,RGB(0,255,0));
				penLow.CreatePen(PS_SOLID,1,RGB(248,191,36));
				penPunct.CreatePen(PS_SOLID,1,RGB(255,231,25));

				pen.CreatePen(PS_SOLID,1,RGB(255,0,0));
				/*CPen pen;
				pen.CreatePen(PS_SOLID,2,RGB(0,0,255));
				pDC->SelectObject(pen);*/
				if (pDoc->m_LineHolderIndex > 0)
					{
						for (int i = 0; i < pDoc->m_LineHolderIndex; i ++)
						{
							if (pDoc->m_pLineHolder[i].m_CharacterHolderIndex != 0)
							{
								for (int j = 0; j < pDoc->m_pLineHolder[i].m_CharacterHolderIndex; j++)
								{
									switch (pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharFinalType)
									{
									case 0:
										pDC->SelectObject(penShort);
										break;
									case 1:
										pDC->SelectObject(penHigh);
										break;
									case 2:
										pDC->SelectObject(penLow);
										break;
									case 3:
										pDC->SelectObject(pen);
										break;
									default:
										pDC->SelectObject(pen);
										break;

									}


									/*if ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharType[0] == -1) || (pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharType[3] == 1)) pDC->SelectObject(pen);
									if (pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharType[0] == 1) pDC->SelectObject(penShort);
									if (pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharType[1] == 1) pDC->SelectObject(penHigh);
									if (pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharType[2] == 1) pDC->SelectObject(penLow);
									if (pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharType[4] == 1)
										pDC->SelectObject(penPunct);*/
									if (m_bViewLocatedCharacters)
									{
										pDC->MoveTo(m_OffsetX + ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X)* m_magnification),m_OffsetY + ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y) * m_magnification));
										pDC->LineTo(m_OffsetX + ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X) * m_magnification),m_OffsetY + ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y) * m_magnification));
										pDC->LineTo(m_OffsetX + ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X)* m_magnification),m_OffsetY + ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y) * m_magnification));
										pDC->LineTo(m_OffsetX + ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X)* m_magnification),m_OffsetY + ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y)* m_magnification));
										pDC->LineTo(m_OffsetX + ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X)* m_magnification),m_OffsetY + ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y)* m_magnification));
									}
									if (m_bShowUncertainAreas)
									{
										CPen penH, penV, penHV;
										CPen BlackPen, WhitePen,GreyPen;

										BlackPen.CreatePen(PS_SOLID,1,RGB(0,0,0));
										WhitePen.CreatePen(PS_SOLID,1,RGB(255,255,255));
										GreyPen.CreatePen(PS_SOLID,1,RGB(128,128,128));

										//orange
										if (m_showOrangeUncertain == 0)
										{
											penHV.CreatePen(PS_SOLID,1,RGB(255,255,255));
										}
										else if (m_showOrangeUncertain == 1)
										{
											penHV.CreatePen(PS_SOLID,1,RGB(255,115,0));
										}
										else if (m_showOrangeUncertain == 2)
										{
											penHV.CreatePen(PS_SOLID,1,RGB(0,0,0));
										}
										//pink
										if (m_showPinkUncertain == 0)
										{
											penH.CreatePen(PS_SOLID,1,RGB(255,255,255));
										}else if (m_showPinkUncertain == 1)
										{
											penH.CreatePen(PS_SOLID,1,RGB(195,0,166));
										}else if (m_showPinkUncertain == 2)
										{
											penH.CreatePen(PS_SOLID,1,RGB(0,0,0));
										}
										//green
										if (m_showGreenUncertain == 0)
										{
											penV.CreatePen(PS_SOLID,1,RGB(255,255,255));
										}else if (m_showGreenUncertain == 1)
										{
											penV.CreatePen(PS_SOLID,1,RGB(6,141,54));
										}else if (m_showGreenUncertain == 2)
										{
											penV.CreatePen(PS_SOLID,1,RGB(0,0,0));
										}
										//grey
										CPen penG;
										if (m_showGreypixels == 0)
										{
											penG.CreatePen(PS_SOLID,1,RGB(255,255,255));
										}else if (m_showGreypixels == 2)
										{
											penG.CreatePen(PS_SOLID,1,RGB(0,0,0));
										}else if (m_showGreypixels == 1)
										{
											penG.CreatePen(PS_SOLID,1,RGB(128,128,128));
										}
										
										CPoint point2;
										CBrush * brush2;
										brush2 = new CBrush;
										for (int x = 0; x < GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_LocatedWidth; x++)
										{
											for (int y = 0; y < GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_LocatedHeight; y++)
											{
												point2.x = (m_OffsetX + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left + x) * m_magnification;
												point2.y = (m_OffsetY + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top + y) * m_magnification;
												//green
												if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_charUncertainAreas[x][y] == 100) //then it is green (100)
												{
													point2.x = m_OffsetX + (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left + x) * m_magnification;
													point2.y = m_OffsetY + (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top + y) * m_magnification;
													pDC->SelectObject(penV);
													pDC->MoveTo(point2);
													pDC->LineTo(point2.x + 1 * m_magnification, point2.y + 1 * m_magnification);
												}
												//pink
												else if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_charUncertainAreas[x][y] == 10) 
												{

													point2.x = m_OffsetX + (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left + x) * m_magnification;
													point2.y = m_OffsetY + (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top + y) * m_magnification;
													pDC->SelectObject(penH);
													pDC->MoveTo(point2);
													pDC->LineTo(point2.x+1,point2.y+1);

												}
												else 
												//orange
												if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_charUncertainAreas[x][y] == 1) //it is H and V
												{
													point2.x = m_OffsetX + (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left + x) * m_magnification;
													point2.y = m_OffsetY + (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top + y) * m_magnification;
													pDC->SelectObject(penHV);
													pDC->MoveTo(point2);
													pDC->LineTo(point2.x+1,point2.y+1);
												}
												//grey
												if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_charUncertainAreas[x][y] == -1)
												{
													
													point2.x = m_OffsetX + (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left + x) * m_magnification;
													point2.y = m_OffsetY + (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top + y) * m_magnification;
													pDC->SelectObject(penG);
													pDC->MoveTo(point2);
													pDC->LineTo(point2.x+1,point2.y+1);
												}
												//uncertain areas deleted
												if ((GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_charUncertainAreas[x][y] == 9)|| (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_charUncertainAreas[x][y] == 99) || (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_charUncertainAreas[x][y] == -1))
												{
													point2.x = m_OffsetX + (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left + x) * m_magnification;
													point2.y = m_OffsetY + (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top + y) * m_magnification;
													pDC->SelectObject(WhitePen);
													pDC->MoveTo(point2);
													pDC->LineTo(point2.x+1,point2.y+1);
												}
												if ((GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_charUncertainAreas[x][y] == 11) || (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_charUncertainAreas[x][y] == 101))
												{
													point2.x = m_OffsetX + (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left + x) * m_magnification;
													point2.y = m_OffsetY + (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top + y) * m_magnification;
													pDC->SelectObject(BlackPen);
													pDC->MoveTo(point2);
													pDC->LineTo(point2.x+1,point2.y+1);
												}
											/*	if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_charUncertainAreas[x][y] == 1) 
												{
													point2.x = m_OffsetX + (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left + x) * m_magnification;
													point2.y = m_OffsetY + (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top + y) * m_magnification;
													pDC->SelectObject(GreyPen);
													pDC->MoveTo(point2);
													pDC->LineTo(point2.x+1,point2.y+1);
												}*/



											}
										}
										delete brush2;
									}
								}
								
							}
						}
					}
			}
		}
	
	
	if ( m_ShowCharCentres == true)
	{
			CPen pen;
			pen.CreatePen(PS_SOLID,2,RGB(255,0,0));
			pDC->SelectObject(pen);
			if (pDoc->m_LineHolderIndex > 0)
				{
					for (int i = 0; i < pDoc->m_LineHolderIndex; i ++)
					{
						if (pDoc->m_pLineHolder[i].m_CharacterHolderIndex != 0)
						{
							for (int j = 0; j < pDoc->m_pLineHolder[i].m_CharacterHolderIndex; j++)
							{
								pDC->MoveTo(m_OffsetX + ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x) * m_magnification),m_OffsetY + ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.y) * m_magnification));
								pDC->LineTo(m_OffsetX + ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x+1) * m_magnification), m_OffsetY + ((pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + pDoc->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.y) * m_magnification));
							}
						}
					}
				}
	}
	if (GetDocument()->m_bIsImageRecognized)
	{
		////CPen pen;
		//CBrush *brush;
		//brush = new CBrush;
		//for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		//{
		//	for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
		//	{
		//		if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[0].rate == 0)
		//		{
		//			//paint rect in blue
		//			brush->CreateSolidBrush(RGB(0,0,255));
		//			//pen.CreatePen(PS_SOLID,2,RGB(0,0,255));
		//			//pDC->SelectObject(pen);
		//			
		//			
		//		}
		//		else if ((GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[0].rate == 1) && (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[1].rate == 1))
		//		{
		//			if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharRecogninition[2].rate == 2)
		//			{
		//				//green
		//				brush->CreateSolidBrush(RGB(0,255,0));
		//			}
		//			else //blue
		//				brush->CreateSolidBrush(RGB(0,0,255));

		//		}
		//			CRgn *rgn;
		//			rgn = new CRgn;
		//			int x1 = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left;
		//			int x2 = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right;
		//			int y1 = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top;
		//			int y2 = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom;
		//			rgn->CreateRectRgn(x1,y1,x2,y2);
		//			pDC->FrameRgn(rgn,brush,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_LocatedWidth,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_LocatedHeight);

		//	}
		//}
	}
}

// CDocImAnView printing

BOOL CDocImAnView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CDocImAnView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CDocImAnView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


// CDocImAnView diagnostics


void CDocImAnView::AssertValid() const
{
	CView::AssertValid();
}

void CDocImAnView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
#ifdef _DEBUG
CDocImAnDoc* CDocImAnView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDocImAnDoc)));
	return (CDocImAnDoc*)m_pDocument;
}
#endif //_DEBUG


void CDocImAnView::OnSize(UINT nType, int cx, int cy)
{
	CDocImAnDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	if ((GetWidth()>0) && (GetHeight()>0))
	{
		CWnd* pWnd=GetParent();
		int ScrollWidth=0;
		int ScrollHeight=0;
		CSize docSize(GetWidth(),GetHeight());
		CSize pageSize(cx,cy); //cx and cy is the new size of the client area
		int lsX;	//line size X
		int lsY;	//line size Y

		if (GetWidth()<(cx - ScrollWidth))
		{
			m_OffsetX=(int)(cx - GetWidth())/2;
			lsX=0;
		}
		else 
		{
			m_OffsetX=0;
			lsX=1;
		}

		if (GetHeight()<(cy - ScrollHeight))
		{
			m_OffsetY=(int)(cy - GetHeight())/2;
			lsY=0;
		}
		else 
		{
			m_OffsetY=0;
			lsY=1;
		}
		CSize lineSize(lsX,lsY);
		SetScrollSizes(MM_TEXT,docSize,pageSize,lineSize);

		//START NOTE: These should (and do indeed) happen in parent class' OnSize(...)
		//BUT that does not work for some reason when opening a new image, unless we enable the bars 
		//here first. Then OnSize(...) will enable them again the correct way, and that works (!?)
		SCROLLINFO info;
		info.fMask = SIF_PAGE|SIF_RANGE;
		info.nMin = 0;
		if (pageSize.cx < docSize.cx)
		{
			EnableScrollBarCtrl(SB_HORZ, TRUE);
			info.nPage = pageSize.cx;
			info.nMax = m_totalDev.cx-1;
			if (!SetScrollInfo(SB_HORZ, &info, TRUE))
				SetScrollRange(SB_HORZ, 0, docSize.cx, TRUE);
		}
		if (pageSize.cy < docSize.cy)
		{
			EnableScrollBarCtrl(SB_VERT, TRUE);
			info.nPage = pageSize.cy;
			info.nMax = m_totalDev.cy-1;
			if (!SetScrollInfo(SB_VERT, &info, TRUE))
				SetScrollRange(SB_VERT, 0, docSize.cy, TRUE);
		}

		Invalidate(FALSE);
	}
	CScrollView::OnSize(nType, cx, cy);
}


void CDocImAnView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	CSize sizeTotal;
	//calculate the total size of this view
	sizeTotal.cx = sizeTotal.cy = 100;
	SetScrollSizes(MM_TEXT, sizeTotal);

	CRect rect;
	GetClientRect(&rect);
	OnSize(SIZE_RESTORED,rect.Width(),rect.Height() );

	m_CharEnhComplete = false;

	Invalidate(FALSE);
}

void CDocImAnView::OnUpdate(CView* /*pSender*/, LPARAM /*lHint*/, CObject* /*pHint*/)
{
	CRect rect;
	GetClientRect(&rect);
	OnSize(SIZE_RESTORED,rect.Width(),rect.Height() );
//	if ((m_applying_separatorsH == TRUE) || (m_applying_separatorsV == TRUE)) ApplySeparators();
	Invalidate(FALSE);
}

void CDocImAnView::OnIncreaseSize()
{	
	if (m_magnification > 32) return;
	m_magnification = m_magnification * 2;
	m_Increasing = TRUE;
	CRect rect;
	GetClientRect(&rect);
	m_OffsetX = (int)((rect.Width() - (GetDocument()->GetActiveImage()->GetWidth() * m_magnification)) / 2.0);
	m_OffsetY = (int)((rect.Height() - (GetDocument()->GetActiveImage()->GetHeight() * m_magnification)) / 2.0);
	OnSize(SIZE_RESTORED,rect.Width(),rect.Height());
	GetActiveImage()->SetDirty(); 
	
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}
void CDocImAnView::OnDecreaseSize()
{
	if (m_magnification <= 1) return;
		
	m_magnification /= 2;
	
	m_Increasing = FALSE;
	CRect rect;
	GetClientRect(&rect);
	m_OffsetX = (int)((rect.Width() - (GetDocument()->GetActiveImage()->GetWidth() * m_magnification)) / 2.0);
	m_OffsetY = (int)((rect.Height() - (GetDocument()->GetActiveImage()->GetHeight() * m_magnification)) / 2.0);
	OnSize(SIZE_RESTORED,rect.Width(),rect.Height());
	GetActiveImage()->SetDirty(); 
	
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);

}


void CDocImAnView::OnFiltersSmoothing()
{
	/*CImage::FilterStruct SmoothFilter;

	int filter[7][7]={
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0},
	{0,0,1,2,1,0,0},
	{0,0,2,4,2,0,0},
	{0,0,1,2,1,0,0},
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0}
	};

	int i;	int j;
	for (i=0;i<7;i++)
	{
		for (j=0;j<7;j++)
		{
			SmoothFilter.Filter[i][j]=filter[i][j];
		}
	}
	SmoothFilter.Div=16;
	SmoothFilter.Size=3;*/
	_tcscpy(m_SmoothFilter.Name,_T("Smoothing Filter"));

	//Create the undoimage before appliying the filter
	GetDocument()->CreateNewUndoImage();

	GetActiveImage()->ApplyFilter(&m_SmoothFilter);
	GetActiveImage()->SetDirty(); //otherwise, update will be requested from paint anyway//
	GetDocument()->UpdateAllViews(this,0L,NULL);

	//saving new image in the undo array
	
	Invalidate(FALSE);
}


void CDocImAnView::OnFiltersBlur()
{
	/*CImage::FilterStruct BlurFilter;
	int filter[7][7]={
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0},
	{0,0,1,1,1,0,0},
	{0,0,1,1,1,0,0},
	{0,0,1,1,1,0,0},
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0}
	};

	int i;	int j;
	for (i=0;i<7;i++)
	{
		for (j=0;j<7;j++)
		{
			BlurFilter.Filter[i][j]=filter[i][j];
		}
	}
	BlurFilter.Div=9;
	BlurFilter.Size=3;*/
	_tcscpy(m_BlurFilter.Name,_T("Blur Filter"));	

	//Create the undoimage before appliying the filter
	GetDocument()->CreateNewUndoImage();

	GetActiveImage()->ApplyFilter(&m_BlurFilter);
	GetActiveImage()->SetDirty(); //otherwise, update will be requested from paint anyway//
	GetDocument()->UpdateAllViews(this,0L,NULL);
	
	Invalidate(FALSE);
}

void CDocImAnView::OnHistogramsTransformation()
{
if (GetActiveImage() == NULL)
	{
		//CDlgErrorNoImage dlgError;
		//dlgError.DoModal();
		GetDocument()->UpdateAllViews(this,0L,NULL);
		Invalidate(FALSE);
	}
	else
	{
		CDIADlgHistogramTransformation dlg;
		dlg.SetDocument(GetDocument());
		dlg.m_equalizing = FALSE;
		if (IDOK == dlg.DoModal())
		{
			GetActiveImage()->SetDirty(); 
			GetDocument()->UpdateAllViews(this,0L,NULL);

			Invalidate(FALSE);
		}
	}}

void CDocImAnView::OnHistogramsEqualization()
{
	if (GetActiveImage() == NULL)
	{
		//CDlgErrorNoImage dlgError;
		//dlgError.DoModal();
		GetDocument()->UpdateAllViews(this,0L,NULL);
		Invalidate(FALSE);
	}
	else
	{
		CDIADlgHistogramTransformation dlg;
		dlg.SetDocument(GetDocument());
		//dlg.m_equalizing = TRUE;
		if (IDOK == dlg.DoModal())
		{
			GetActiveImage()->SetDirty(); 
			
			GetDocument()->UpdateAllViews(this,0L,NULL);

			Invalidate(FALSE);
		}
	}
}

void CDocImAnView::OnImageProjections()
{
	if (GetActiveImage() == NULL)
	{
		//CDlgErrorNoImage dlgError;
		//dlgError.DoModal();
		GetDocument()->UpdateAllViews(this,0L,NULL);
		Invalidate(FALSE);
	}
	else
	{
		CDIADlgProjectionsDialog dlg;
		dlg.SetDocument(GetDocument());
		
		if (IDOK == dlg.DoModal())
		{
			GetActiveImage()->SetDirty(); 
			//GetDocument()->m_LinesIndex = dlg.m_LineHolderIndex;
			//GetDocument()->m_pLines = new CTextLine [GetDocument()->m_LinesIndex];
			//memcpy(GetDocument()->m_pLines,dlg.m_pLineHolder,GetDocument()->m_LinesIndex * sizeof (CTextLine *));
			GetDocument()->UpdateAllViews(this,0L,NULL);
			Invalidate(FALSE);
		}
	}
}
void CDocImAnView::OnViewIndividualcharacterview()
{
	m_bViewIndividualCharacters = !m_bViewIndividualCharacters;
}

void CDocImAnView::OnUpdateViewIndividualcharacterview(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bViewIndividualCharacters);
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::OnSegmentationComplete()
{
	//* Do everything *//
	//First analysis of background
	//Then histogram transformation using analysis
	//Segmentation
	//Character Boxes
	
	//Background Analysis
	IsResegmenting = false;
	PreprocessImage();
	
	//Segmentation
	PerformSegmentation(GetActiveImage());


	//CharacterBox Location
	
	LocateCharacters();

	//classify Character Type, high or low
	
	ClassifyCharacters();

	//Re-Compute segmentation based on the character centres
	
	GetDocument()->m_ShowInBox = true;
	//ReSegment();
	//Go back to Original Image, keeping data of segmentation and character Box.
	if (GetDocument()->m_pUndoImage != NULL)
	{	
		while (GetDocument()->m_index >1)
		{
			delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
			GetDocument()->m_index--;
		}
		SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
	}
	//background and foreground analysis
	CharacterAnalysis();


	GetActiveImage()->SetDirty(); 
	
	
	//apply thresholding technique adaptive to each character
	

	//update image
	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);

}


void CDocImAnView::OnCharacterenhanceComplete()
{
	//* Do everything *//
	//First analysis of background
	//Then histogram transformation using analysis
	//Segmentation
	//Character Boxes
	//background analysis
	//box crossing to find regular peaks
	//more to be decided

	//Background Analysis
	int index = GetDocument()->m_index;
	m_CharEnhComplete = true;
	IsResegmenting = false;
	PreprocessImage();
	

	//Segmentation
	PerformSegmentation(GetActiveImage());
	
//testing
	if (GetDocument()->m_pUndoImage != NULL)
	{	
		while (GetDocument()->m_index > index)
		{
			delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
			GetDocument()->m_index--;
		}
		SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
	}
//end testing


	//CharacterBox Location
	
	LocateCharacters();

	//classify Character Type, high or low
	
	ClassifyCharacters();

	//Re-Compute segmentation based on the character centres
	
	GetDocument()->m_ShowInBox = true;

	//Go back to Original Image, keeping data of segmentation and character Box.
	/*if (GetDocument()->m_pUndoImage != NULL)
	{	
		while (GetDocument()->m_index >1)
		{
			delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
			GetDocument()->m_index--;
		}
		SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
	}*/
	//background and foreground analysis
	CharacterAnalysis();


	GetActiveImage()->SetDirty(); 
	
	
	//apply thresholding technique adaptive to each character
	

	//update image
	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);

	
}

void CDocImAnView::PreprocessImage()
{
	//Background Analysis
	CDIAHistograms histo;
	int AB = 50;
	int BC = 200;
	histo.m_pdoc = GetDocument();
	if (histo.m_pdoc != NULL)
	{
		histo.ComputeHistogram(histo.m_inHistogram,&histo.m_maxvalueInHisto,histo.m_pdoc->GetActiveImage());
		histo.m_pdoc->CreateNewUndoImage(IT_GREYSCALE);
	}

	//test 05/09/06
	histo.CalculateFunction(255,0);
	//histo.CalculateFunctionContrast(histo.m_inHistogram,AB,BC,true);

	//Histogram transformation
	histo.ComputeTransformation(GetActiveImage(),histo.m_pdoc->GetUndoImage(histo.m_pdoc->m_index-2));
	//test 05/10/06
	histo.ComputeEqualization(GetActiveImage(),histo.m_pdoc->GetUndoImage(histo.m_pdoc->m_index-2));
	//Preprocessing- Blurring and re-Transformation
	//Blur and smooth
	//GetActiveImage()->ApplyFilter(&m_BlurFilter);
	//GetActiveImage()->ApplyFilter(&m_SmoothFilter);

	////Threshold again Histogram transformation
	//	if (histo.m_pdoc != NULL)
	//	{
	//		histo.ComputeHistogram(histo.m_inHistogram,&histo.m_maxvalueInHisto,histo.m_pdoc->GetActiveImage());
	//		histo.m_pdoc->CreateNewUndoImage(IT_GREYSCALE);
	//	}
	//	histo.CalculateFunctionContrast(histo.m_inHistogram,AB,BC,true);

	//	//Histogram transformation
	//	histo.ComputeTransformation(GetActiveImage(),histo.m_pdoc->GetUndoImage(histo.m_pdoc->m_index-2));

	GetDocument()->m_bIsPreprocessed = true;

}

void CDocImAnView::PreprocessImageSoft()
{
	//Background Analysis
	CDIAHistograms histo;
	int AB = 50;
	int BC = 200;
	histo.m_pdoc = GetDocument();
	if (histo.m_pdoc != NULL)
	{
		histo.ComputeHistogram(histo.m_inHistogram,&histo.m_maxvalueInHisto,histo.m_pdoc->GetActiveImage());
		histo.m_pdoc->CreateNewUndoImage(IT_GREYSCALE);
	}
	histo.CalculateFunctionContrast(histo.m_inHistogram,AB,BC,true);

	//Histogram transformation
	histo.ComputeTransformation(GetActiveImage(),histo.m_pdoc->GetUndoImage(histo.m_pdoc->m_index-2));
	
	//Preprocessing- Blurring and re-Transformation
	//Blur and smooth
	GetActiveImage()->ApplyFilter(&m_BlurFilter);
	GetActiveImage()->ApplyFilter(&m_SmoothFilter);

	////Threshold again Histogram transformation
	//	if (histo.m_pdoc != NULL)
	//	{
	//		histo.ComputeHistogram(histo.m_inHistogram,&histo.m_maxvalueInHisto,histo.m_pdoc->GetActiveImage());
	//		histo.m_pdoc->CreateNewUndoImage(IT_GREYSCALE);
	//	}
	//	histo.CalculateFunctionContrast(histo.m_inHistogram,AB,BC);

	//	//Histogram transformation
	//	histo.ComputeTransformation(GetActiveImage(),histo.m_pdoc->GetUndoImage(histo.m_pdoc->m_index-2));

}

void CDocImAnView::PerformSegmentation(CImage * pOrigImage)
{
	//Segmentation
	DIASegmentation * seg;
	seg = new DIASegmentation;
	seg->m_pdoc = GetDocument();
	if (seg->m_pdoc != NULL)
	{
		//CImage * pOrigImage;
		
		seg->m_pdoc->CreateNewUndoImage(IT_GREYSCALE);
		//pOrigImage = seg->m_pdoc->GetUndoImage(seg->m_pdoc->m_index-1);

		seg->m_pHorzProj = new long[pOrigImage->GetHeight()];
		seg->m_pVertProj = new long[pOrigImage->GetWidth()];


		pOrigImage->GetProjection(0,0,pOrigImage->GetWidth(),pOrigImage->GetHeight(),seg->m_pHorzProj ,seg->m_pVertProj ,PRJ_GREY);

		seg->m_maxvalVert = seg->CalculateMaxVal(seg->m_pVertProj,pOrigImage->GetWidth());
		seg->m_maxvalHorz = seg->CalculateMaxVal(seg->m_pHorzProj,pOrigImage->GetHeight());		

		seg->m_pHorzProfileDistribution = new CDistribution <long>;
		seg->m_pHorzProfileDistribution->Create(seg->m_pVertProj,pOrigImage->GetWidth());
		seg->m_pVertProfileDistribution = new CDistribution <long>;
		seg->m_pVertProfileDistribution->Create(seg->m_pHorzProj,pOrigImage->GetHeight());
		seg->m_separatorIndexV = 0;
		seg->m_separatorIndexH = 0;
		seg->m_SeparatorsComputedH = false;
		seg->m_SeparatorsComputedV = false;
		seg->m_pSeparatorsH = new CTextLine::SEPARATOR[seg->m_pHorzProfileDistribution->GetMinimaCount()];
		seg->m_pSeparatorsV = new CTextLine::SEPARATOR[seg->m_pVertProfileDistribution->GetMinimaCount()];
		for (int i = 0; i < seg->m_pVertProfileDistribution->GetMinimaCount(); i++)
		{
			seg->m_pSeparatorsV[i].Strong = false;
		}

		for (int i = 0; i < seg->m_pHorzProfileDistribution->GetMinimaCount(); i++)
		{
			seg->m_pSeparatorsH[i].Strong = false;
		}
		seg->m_pdoc->m_LineHolderIndex = 0;
		seg->m_pdoc->m_pLineHolder = NULL;
	}

	seg->FindVerticalSeparators();
	seg->CreateHorizontalLines();
	seg->FindHorizontalSeparatorsFromLines2();
	seg->CreateCharacters();
	seg->ComputeCharacterStatistics();
	seg->m_pdoc->m_IsCharSegmented = true;
	//delete seg;
}
void CDocImAnView::LocateCharacters()
{
	GetDocument()->m_CharAverageWidth = 23;
		//CharacterBox Location
	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	{
		//initialize per each line
		GetDocument()->m_pLineHolder[i].m_CharShortAverage[0] = 0; // top
		GetDocument()->m_pLineHolder[i].m_CharShortAverage[1] = 0; // ntop
		GetDocument()->m_pLineHolder[i].m_CharShortAverage[2] = 0; // bottom
		GetDocument()->m_pLineHolder[i].m_CharShortAverage[3] = 0; // nbottom
		//GetDocument()->m_pLineHolder[i].m_CharShortAverage[4] = 0; // size
		//size of short characters is not initialize for each line, as is a general value;
		for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
		{
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ForegroundAnalysis(GetActiveImage(),false);
			//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CalculateForegroundPercentage(false);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].LocateChar2(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ClassifyCharacterType32(GetDocument()->m_pLineHolder[i].m_CharShortAverage);
		}
	}
	GetDocument()->m_IsCharLocalized = true;

}


void CDocImAnView::LocateCharacters2()
{
	
		//CharacterBox Location
	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	{
		for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
		{
			//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ForegroundAnalysis(GetActiveImage(),false);
			//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CalculateForegroundPercentage(false);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetDocument()->GetActiveImage(),false);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].LocateChar2(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage);
			//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ClassifyCharacterType3(GetDocument()->m_pLineHolder[i].m_CharShortAverage);
		}
	}
	GetDocument()->m_IsCharLocalized = true;

}
void CDocImAnView::LocateCharacters3(int threshold, int noiseSize)
{
	
		//CharacterBox Location
	//for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	{
		for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
		{
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetDocument()->GetActiveImage(),false);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].LocateChar5(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,threshold,noiseSize);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ClassifyCharacterType4(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_LocatedWidth,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_LocatedHeight);
			//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ClassifyCharacterType5(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_LocatedWidth,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_LocatedHeight);
		}
	}
	GetDocument()->m_IsCharLocalized = true;


}
void CDocImAnView::LocateCharacters4(int threshold, int noiseSize)
{
		//CharacterBox Location
	//for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	{
		for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
		{
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetDocument()->GetActiveImage(),false);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].LocateChar5(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,threshold,noiseSize);
			//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ClassifyCharacterType4(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_LocatedWidth,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_LocatedHeight);
			//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ClassifyCharacterType5(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_LocatedWidth,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_LocatedHeight);
		}
	}
	GetDocument()->m_IsCharLocalized = true;

}

void CDocImAnView::ClassifyCharacters()
{
	
	//classify Character Type, high or low
	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	{
		GetDocument()->m_pLineHolder[i].m_CharTallest[0] = 0;
		GetDocument()->m_pLineHolder[i].m_CharTallest[1] = 0;
		for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
		{
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ClassifyCharacterType4(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_LocatedWidth,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_LocatedHeight);
//			if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharType[0] == 0)
			if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharFinalType == 1)
			{
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ClassifyTallCharacter(GetDocument()->m_pLineHolder[i].m_CharShortAverage, GetDocument()->m_pLineHolder[i].m_CharTallest);
			}
		}
	}
}
void CDocImAnView::ClassifyCharacters3()
{
	//for each of the characters
	if (GetDocument()->m_IsCharLocalized)
	{
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{

			}
		}

	}
}
void CDocImAnView::Create2DCharPlot()
{	
	if (GetDocument()->m_IsCharLocalized)
	{
		//if it is not created yet
		if (GetDocument()->m_2DCharPlot == NULL)
		{
			GetDocument()->m_2DCharPlot = new int *[50];
			for (int i = 0; i < 50; i++)
			{
				GetDocument()->m_2DCharPlot[i] = new int[50];
				for (int j = 0; j < 50; j++)
				{
					GetDocument()->m_2DCharPlot[i][j] = 0;
				}
			}
		}
		if (GetDocument()->m_2DCharPlotType == NULL)
		{
			GetDocument()->m_2DCharPlotType = new CDocImAnDoc::CTYPE *[50];
			for (int i = 0; i < 50; i++)
			{
				GetDocument()->m_2DCharPlotType[i] = new CDocImAnDoc::CTYPE [50];
				for (int j = 0; j < 50; j++)
				{
					GetDocument()->m_2DCharPlotType[i][j].total = 0;
					GetDocument()->m_2DCharPlotType[i][j].type[0] = 0;
					GetDocument()->m_2DCharPlotType[i][j].type[1] = 0;
					GetDocument()->m_2DCharPlotType[i][j].type[2] = 0;
					GetDocument()->m_2DCharPlotType[i][j].type[3] = 0;
					GetDocument()->m_2DCharPlotType[i][j].type[4] = 0;
				}
			}
		}
		//for each localised character
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				int width = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_LocatedWidth;
				int height = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_LocatedHeight;
				GetDocument()->m_2DCharPlot[width][height]++;
				GetDocument()->m_2DCharPlotType[width][height].total++;
				int type = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharFinalType;
				GetDocument()->m_2DCharPlotType[width][height].type[type]++;
			}
		}
	}

}
void CDocImAnView::ClassifyCharacters2()
{
	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	{
		GetDocument()->m_pLineHolder[i].m_CharTallest[0] = 0;
		GetDocument()->m_pLineHolder[i].m_CharTallest[1] = 0;
	
		for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
		{
			//first separate short characters from the others
			//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ClassifyCharacterType3(GetDocument()->m_pLineHolder[i].m_CharShortAverage);
			//Then classify the tall ones into low or tall/capital
			if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharFinalType == 1)
			{
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].SetDocument(GetDocument());
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ClassifyTallCharacter2(GetDocument()->m_pLineHolder[i].m_CharShortAverage, GetDocument()->m_pLineHolder[i].m_CharTallest,j);
				
			}
	
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetDocument()->GetActiveImage(),false);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateLocatedCharImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,true);

		

		}
	}

}
void CDocImAnView::CharacterAnalysis()
{
	//background and foreground analysis analysis

	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	{
		for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
		{
			
		GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].BackgroundAnalysis(GetActiveImage());
		GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ForegroundAnalysis(GetActiveImage(),true);
		GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CalculateForegroundPercentage(true);
		}
	}

	if (GetDocument()->m_IsCharLocalized == TRUE)//apply to all image
	{
		//if (m_IsThresholded == false)
	//	{
	//		OnFiltersThreshold128();
	//	}
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{

				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetDocument()->GetActiveImage(),false);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateLocatedCharImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,true);
				//cc
	
				BYTE PTForeground = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage->GetImageMap(0)->GetPTByteLabel(PT_STR_FOREGROUND);
	
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindCC(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage,PTForeground);
				int cc = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_nComponents;
				//holes
				BYTE PTBackground = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage->GetImageMap(0)->GetPTByteLabel(PT_STR_BACKGROUND);
	
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindCC(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage,PTBackground);
				int holes = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_nHoles;
				
				//closed holes
			}
		}
	}
	else
	{
		GetActiveImage()->CCAnalysis(1);
		GetActiveImage()->SetShowComponents(true);
	}
}

//void CDocImAnView::ReSegment()
//{
//	//IsResegmenting = true;
//	//int maxwidth = 35;
//	////create new lines m_pLineHolder2
//	//GetDocument()->m_pLineHolder2 = new CTextLine [GetDocument()->m_LineHolderIndex];
//	////we will have same number of lines so still use m_LineHolderIndex
//	//for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
//	//{
//	//	//the new line will be 2 pixels up and down form highest and lowest
//	//	GetDocument()->m_pLineHolder2[i].CreateLine(GetDocument()->m_pLineHolder[i].m_Width,(long)GetDocument()->m_pLineHolder[i].m_CharTallest[1]-2,(long)GetDocument()->m_pLineHolder[i].m_CharTallest[0]-2,GetActiveImage(),FALSE);
//	//	for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
//	//	{
//	//		GetDocument()->m_pLineHolder2[i].m_pCharacterHolder = new CDIACharacter [GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex];
//	//		int distancecc1, distancecc2;//= (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j+1].m_CharCenter.x - GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x)/2;
//	//		int posRight, posLeft;
//	//		//for each character in the line
//	//		if (j == 0)//is the first character
//	//		{
//	//			if (GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex > 1)//if more than 1 character
//	//			{
//	//				if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j+1].m_CharCenter.x - GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x < maxwidth)
//	//				{
//	//					//calculate distance to next center
//	//					distancecc2 = (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j+1].m_CharCenter.x - GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x)/2;
//	//					posLeft = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x - distancecc2;
//	//					posRight = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x + distancecc2;
//	//					GetDocument()->m_pLineHolder2[i].m_pCharacterHolder[j].CreateCharacter(GetDocument()->m_pLineHolder2[i].m_Height, posLeft, posRight, GetDocument()->m_pLineHolder[i].m_Position_Y, GetActiveImage(),GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharNum);
//	//				}
//	//			}else // if there is only one character in the line
//	//			{
//	//				distancecc1 = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x - ((GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right - GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left)/2) - 4;
//	//				posLeft = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x - distancecc1;
//	//				posRight = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x + distancecc1;
//	//				GetDocument()->m_pLineHolder2[i].m_pCharacterHolder[j].CreateCharacter(GetDocument()->m_pLineHolder2[i].m_Height, posLeft, posRight, GetDocument()->m_pLineHolder[i].m_Position_Y, GetActiveImage(),GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharNum);
//	//			}
//	//				
//	//		}else //not the first character
//	//		{
//	//		
//	//			//calculate distance to previous center
//	//			distancecc1 = (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x - GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j-1].m_CharCenter.x)/2;
//	//			//calculate distance to next center
//	//			distancecc2 = (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j+1].m_CharCenter.x - GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x)/2;
//	//			distancecc2 = (distancecc2 + distancecc1) / 2;
//	//			posLeft = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x - distancecc2;
//	//			posRight = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x + distancecc2;
//	//			GetDocument()->m_pLineHolder2[i].m_pCharacterHolder[j].CreateCharacter(GetDocument()->m_pLineHolder2[i].m_Height, posLeft, posRight, GetDocument()->m_pLineHolder[i].m_Position_Y, GetActiveImage(),GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharNum);
//	//		}
//	//	}
//	//}
//	////for each new line
//	//
//	IsResegmenting = true;
//	int maxwidth = 35;
//	//int index;
//	//create new lines m_pLineHolder2
//	GetDocument()->m_pLineHolder2 = new CTextLine [GetDocument()->m_LineHolderIndex];
//	//we will have same number of lines so still use m_LineHolderIndex
//	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
//	{
//		if ( GetDocument()->m_pLineHolder[i].m_ThinLine == FALSE)
//		{
//			//the new line will be 25 pixels up and down form charCentreAverage
//			int CharCentreAverage = GetDocument()->m_pLineHolder[i].CharCentreAverage();
//
//			/*if ((CharCentreAverage - GetDocument()->m_pLineHolder[i].m_CharTallest[0]) > (GetDocument()->m_pLineHolder[i].m_CharTallest[1] - CharCentreAverage))
//			{
//				index = 0;
//			}
//			else index = 1;*/
//			//tallest character will be 44, so from centre 25 up and down
//			//long posTop = abs(CharCentreAverage - abs((CharCentreAverage - GetDocument()->m_pLineHolder[i].m_CharTallest[index]))-4);
//			//long posBottom = CharCentreAverage + abs((CharCentreAverage - GetDocument()->m_pLineHolder[i].m_CharTallest[index]) + 4);
//			long posTop = CharCentreAverage - 27;
//			long posBottom = CharCentreAverage + 27;
//			if (posTop < 0)
//			{
//				posBottom -= posTop;
//				posTop = 0;
//			}
//			if (posBottom > GetActiveImage()->GetHeight()) posBottom = GetActiveImage()->GetHeight();
//			GetDocument()->m_pLineHolder2[i].CreateLine(GetDocument()->m_pLineHolder[0].m_Width,posTop,posBottom,GetActiveImage(),FALSE);
//
//	//		int widechars = GetDocument()->m_pLineHolder[i].CountWideCharacters();
//	//		
//	//		int n = 0;
//	//		GetDocument()->m_pLineHolder2[i].m_CharacterHolderIndex2 = GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex + widechars;
//
//	//		for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
//	//		{
//	//			//before creating the line make sure that we don't
//	//			//have any incorrect previously segmented character
//	//			//estimate the average centre to centre distance
//
//	//			GetDocument()->m_pLineHolder2[i].m_pCharacterHolder = new CDIACharacter [GetDocument()->m_pLineHolder2[i].m_CharacterHolderIndex2];
//	//			int distancecc1, distancecc2;//= (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j+1].m_CharCenter.x - GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x)/2;
//	//			int posRight, posLeft;
//	//			//for each character in the line
//
//	//			//if is a wrong segmented character
//	//			if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharType[3] == 1)
//	//			{	
//	//				//first Character
//	//				posLeft = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X;
//	//				posRight = (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right - GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left + 1)/2;
//	//				GetDocument()->m_pLineHolder2[i].m_pCharacterHolder[j].CreateCharacter(GetDocument()->m_pLineHolder2[i].m_Height, posLeft, posRight, GetDocument()->m_pLineHolder2[i].m_Position_Y, GetActiveImage(),GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharNum);
//	//				n++;
//	//				//second Cahracter
//	//				posLeft = posRight;
//	//				posRight = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width;
//	//				GetDocument()->m_pLineHolder2[i].m_pCharacterHolder[j].CreateCharacter(GetDocument()->m_pLineHolder2[i].m_Height, posLeft, posRight, GetDocument()->m_pLineHolder2[i].m_Position_Y, GetActiveImage(),GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharNum + n);
//
//	//			}
//	//			else
//	//			{
//	//				if (j == 0)//is the first character
//	//				{
//	//					if (GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex > 1)//if more than 1 character
//	//					{
//	//							if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j+1].m_CharCenter.x - GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x < maxwidth)
//	//							{//if the distance from the centre to the next character centre
//	//							//is smaller than the max width
//	//								//calculate distance to next center
//	//								distancecc2 = (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j+1].m_CharCenter.x - GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x)/2;
//	//								posLeft = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x - distancecc2;
//	//								posRight = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x + distancecc2;
//	//								GetDocument()->m_pLineHolder2[i].m_pCharacterHolder[j].CreateCharacter(GetDocument()->m_pLineHolder2[i].m_Height, posLeft, posRight, GetDocument()->m_pLineHolder2[i].m_Position_Y, GetActiveImage(),GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharNum + n);
//	//							}
//	//							else //if next character is part of another word
//	//							{
//	//								posLeft = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left - 4;
//	//								posRight = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right + 4;
//	//								GetDocument()->m_pLineHolder2[i].m_pCharacterHolder[j].CreateCharacter(GetDocument()->m_pLineHolder2[i].m_Height, posLeft, posRight, GetDocument()->m_pLineHolder2[i].m_Position_Y, GetActiveImage(),GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharNum + n);
//	//							}
//	//												
//	//					}else // if there is only one character in the line
//	//					{
//	//						//distancecc1 = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x - ((GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right - GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left)/2) - 4;
//	//						posLeft = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left - 4;
//	//						posRight = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right + 4;
//	//						GetDocument()->m_pLineHolder2[i].m_pCharacterHolder[j].CreateCharacter(GetDocument()->m_pLineHolder2[i].m_Height, posLeft, posRight, GetDocument()->m_pLineHolder2[i].m_Position_Y, GetActiveImage(),GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharNum + n);
//	//					}
//	//						
//	//				}
//	//				else //not the first character
//	//				{
//	//					if (j == GetDocument()->m_pLineHolder2[i].m_CharacterHolderIndex2 - 1)
//	//					//is the last character
//	//					{	posLeft = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left - 4 +  GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X;
//	//						posRight =  GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X +  GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width;
//	//						GetDocument()->m_pLineHolder2[i].m_pCharacterHolder[j].CreateCharacter(GetDocument()->m_pLineHolder2[i].m_Height, posLeft, posRight, GetDocument()->m_pLineHolder2[i].m_Position_Y, GetActiveImage(),GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharNum + n);
//	//					}
//	//					else
//	//					{
//	//						if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x - GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j-1].m_CharCenter.x < maxwidth)
//	//							//calculate distance to previous center
//	//							distancecc1 = (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x - GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j-1].m_CharCenter.x)/2;
//	//						else distancecc1 = ((GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right - GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left + 1)/2) + 4;
//	//						if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j+1].m_CharCenter.x - GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x < maxwidth)
//	//							//calculate distance to next center
//	//							distancecc2 = (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j+1].m_CharCenter.x - GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x)/2;
//	//						else distancecc2 = distancecc1;
//	//					
//	//						distancecc2 = (distancecc2 + distancecc1) / 2;
//	//						posLeft = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x - distancecc2;
//	//						posRight = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x + distancecc2;
//	//						GetDocument()->m_pLineHolder2[i].m_pCharacterHolder[j + n].CreateCharacter(GetDocument()->m_pLineHolder2[i].m_Height, posLeft, posRight, GetDocument()->m_pLineHolder2[i].m_Position_Y, GetActiveImage(),GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharNum + n);
//	//					}
//	//				}
//	//			}
//	//		}
//		}
//	}
//	
//
//
//}
//
//

void CDocImAnView::OnCharacterenhanceResegment()
{
	//ReSegment();
	GetActiveImage()->SetDirty(); 
}

void CDocImAnView::OnCharacterenhanceExportlocatedcharacters()
{
	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++ )
	{
		for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
		{
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ExportCharacter();
		}
		
	}
}

void CDocImAnView::OnCharacterenhanceComplete40()
{
	
	////* Do everything *//
	////First analysis of background
	////Then histogram transformation using analysis
	////Segmentation
	////Character Boxes
	////background analysis
	////box crossing to find regular peaks
	////more to be decided

	////Background Analysis
	//IsResegmenting = false;
	//PreprocessImage();
	//

	////Segmentation
	//PerformSegmentation();
	//

	////CharacterBox Location
	//
	//LocateCharacters();

	////classify Character Type, high or low
	//
	//ClassifyCharacters();

	////Re-Compute segmentation based on the character centres
	//
	//GetDocument()->m_ShowInBox = true;

	////Go back to Original Image, keeping data of segmentation and character Box.
	///*if (GetDocument()->m_pUndoImage != NULL)
	//{	
	//	while (GetDocument()->m_index >+1)
	//	{
	//		delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
	//		GetDocument()->m_index--;
	//	}*/
	//	SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-4]);
	////}
	////background and foreground analysis
	//CharacterAnalysis();


	//GetActiveImage()->SetDirty(); 

	//box crossing to find out character stroke intensity
	//add a couple of pixels to inner box from each side

	//* Do everything *//
	//First analysis of background
	//Then histogram transformation using analysis
	//Segmentation
	//Character Boxes
	//background analysis
	//box crossing to find regular peaks
	//more to be decided

	//Background Analysis
	if (m_CharEnhComplete == false)
	{
		IsResegmenting = false;
		PreprocessImage();
		

		//Segmentation
		PerformSegmentation(GetActiveImage());
		
	//testing
		//deleting all intermediate images
		if (GetDocument()->m_pUndoImage != NULL)
		{	
			while (GetDocument()->m_index >1)
			{
				delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
				GetDocument()->m_index--;
			}
			SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
		}
	////end testing


		//CharacterBox Location
		
		LocateCharacters();

		//classify Character Type, high or low
		
		ClassifyCharacters();

		//Re-Compute segmentation based on the character centres
		
		GetDocument()->m_ShowInBox = true;

		//Go back to Original Image, keeping data of segmentation and character Box.
		/*if (GetDocument()->m_pUndoImage != NULL)
		{	
			while (GetDocument()->m_index >1)
			{
				delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
				GetDocument()->m_index--;
			}
			SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
		}*/
		//background and foreground analysis
		SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
		CharacterAnalysis();


		GetActiveImage()->SetDirty(); 
		
		
		//apply thresholding technique adaptive to each character
		

		//update image
		GetActiveImage()->SetDirty(); 
		GetDocument()->UpdateAllViews(this,0L,NULL);
		Invalidate(FALSE);

	
	}
	GetDocument()->CreateNewUndoImage();
	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	{
		for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
		{
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ApplyThreshold40(GetActiveImage(),GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_foreground40 );
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetActiveImage(),false);
		}
	}
	//update image
	//CharacterBox Location
	
	LocateCharacters();

	//classify Character Type, high or low
	
	ClassifyCharacters();

	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::ClearBackground()
{
	GetDocument()->CreateNewUndoImage();

	if (GetDocument()->m_IsCharLocalized == FALSE)//apply to all image
	{
		if (GetDocument()->m_IsCharSegmented == TRUE)//apply to each segmented character
		{
			for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
			{
				for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
				{

				}
			}
		}
	}

}
void CDocImAnView::OnCharacterenhanceGroupvaluesinsets()
{
	//depending on the max value in the foreground analysis
	//if (GetActiveImage() == NULL)
	//{
	//	//CDlgErrorNoImage dlgError;
	//	//dlgError.DoModal();
	//	GetDocument()->UpdateAllViews(this,0L,NULL);
	//	Invalidate(FALSE);
	//}
	//else
	//{
	//	CDlgGroups dlg;
	//	
	//	//dlg.SetDocument(GetDocument());
	//	//dlg.m_equalizing = FALSE;
	//	if (IDOK == dlg.DoModal())
	//	{
	//		GetActiveImage()->SetDirty(); 
	//		GetDocument()->UpdateAllViews(this,0L,NULL);

	//		Invalidate(FALSE);
	//	}
	//}}
}

void CDocImAnView::OnFiltersNiblack()
{

	double mean, variance;
	int niblack;
	CPoint point;
	int neighb = 5;//15x15 //5
	double k = -0.2; //Dimos uses 0.2 i was using 0.4

	GetDocument()->CreateNewUndoImage();

	if (GetDocument()->m_IsCharLocalized == FALSE)//apply to all image
	{
		if (GetDocument()->m_IsCharSegmented == true) //apply to segmented character
		{
			for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
			{
				for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
				{

					//for each segmented character 
					for (int x = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X; x <= GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width ; x++)
					{
						for (int y = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y; y <= GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y +GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height; y++)
						{
							point.SetPoint(x,y);
							mean = CalculateMean(point, neighb,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height);
							variance = CalculateVariance(point,neighb,mean,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height);
							niblack = (int) (mean + k * ( sqrt(variance)));
							if (niblack < 0) niblack = 0;
							int value = (int) GetRValue(GetActiveImage()->GetRGBColor((GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + x),(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + y)));
							if (( value > niblack) || (value > 200))
							{
								//is background set it to white 255
								//GetActiveImage()->SetRGBColor(i, j,RGB(0,0,0));

								//set it the the most repeted value of the background
								GetActiveImage()->SetRGBColor(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + x, GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + y,RGB(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_BackgroundHighest,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_BackgroundHighest,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_BackgroundHighest));
							}
							else // is foreground set to black 0
							{
								GetActiveImage()->SetRGBColor(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + x, GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + y,RGB(0,0,0));
							}
						//	GetActiveImage()->SetRGBColor(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + x, GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + y,RGB(niblack,niblack,niblack));
							//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetActiveImage(),false);
						

						}
					}
				}
			}
		}
		else
		{
			for (int i = 0; i < GetActiveImage()->GetWidth(); i++)
			{
				for (int j = 0; j < GetActiveImage()->GetHeight(); j++)
				{
					point.SetPoint(i,j);
					mean = CalculateMean(point, neighb,GetActiveImage(),GetActiveImage()->GetWidth(), GetActiveImage()->GetHeight());
					//variance = CalculateVariance(point,neighb,mean,GetActiveImage(),GetActiveImage()->GetWidth(), GetActiveImage()->GetHeight());
					variance = CalculateVariance2(point,neighb,mean,GetActiveImage(),GetActiveImage()->GetWidth(), GetActiveImage()->GetHeight());
					niblack = (int) (mean + k * (sqrt(variance)));
					if (niblack < 0) niblack = 0;
					int value  = (int) GetRValue(GetActiveImage()->GetRGBColor(i,j));
					if ( value > niblack || value > 200)
					{
						//is background set it to 0
					//	GetActiveImage()->SetRGBColor(i, j,RGB(0,0,0));
						//set it the the most repeted value of the background
						//GetActiveImage()->SetRGBColor(i, j,RGB(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_BackgroundHighest,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_BackgroundHighest,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_BackgroundHighest));
						GetActiveImage()->SetRGBColor(i,j,RGB(255,255,255));
					}
					else
					{
						//GetActiveImage()->SetRGBColor(i, j,RGB(0,0,0));
					}
					
				}
			}
		}
	}
	else //apply only to localized characters
	{
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				//for each located character 
				for (int x = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left; x <= GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right; x++)
				{
					for (int y = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top; y <= GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom; y++)
					{
						point.SetPoint(x,y);
						mean = CalculateMean(point, neighb,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom);
						variance = CalculateVariance(point,neighb,mean,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom);
						niblack = (int) (mean + k * ( sqrt(variance)));
						if (niblack < 0) niblack = 0;
						int value = (int) GetRValue(GetActiveImage()->GetRGBColor((GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + x),(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + y)));
						if (( value > niblack) || (value > 200))
						{
							//is background set it to white 255
							//GetActiveImage()->SetRGBColor(i, j,RGB(0,0,0));

							//set it the the most repeted value of the background
							GetActiveImage()->SetRGBColor(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + x, GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + y,RGB(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_BackgroundHighest,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_BackgroundHighest,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_BackgroundHighest));
						}
						else // is foreground set to black 0
						{
							GetActiveImage()->SetRGBColor(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + x, GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + y,RGB(0,0,0));
						}
					//	GetActiveImage()->SetRGBColor(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + x, GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + y,RGB(niblack,niblack,niblack));
						//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetActiveImage(),false);
					
					}
				}	
			}
		}
	}
	GetActiveImage()->SetDirty(); 
	//update image

	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}
double CDocImAnView::CalculateMean(CPoint point, int neighbourhood, CImage * Image, int Width, int Height)
{
	int startx, starty, endx, endy;
	int total = 0;
	int Accumulator = 0;
	int halfNeighbourhood = (neighbourhood/2);
	if ((point.x - halfNeighbourhood) < 0) 
	{
		startx = 0;
	}else 
	{
		startx = point.x - halfNeighbourhood;
	}

	if ((point.y - halfNeighbourhood) < 0) starty = 0;
	else starty = point.y - halfNeighbourhood;

	if ((startx + neighbourhood) >= Width) endx = Width-1;
	else endx = (startx + neighbourhood -1);

	if ((starty + neighbourhood) >= Height) endy = Height-1;
	else endy = (starty + neighbourhood -1);

	for (int i = startx; i <= endx; i++)
	{
		for (int j = starty; j <= endy; j++)
		{
			Accumulator += (int)Image->GetRed(i,j);
			total++;
			
		}
	}
/*int startx, starty, endx, endy;
	int total = 0;
	int Accumulator = 0;
	//int halfNeighbourhood = (neighbourhood/2) +1;
	if ((point.x - (neighbourhood/2)) < 0) 
	{
		startx = 0;
	}else 
	{
		startx = point.x - (neighbourhood/2);
	}

	if ((point.y - (neighbourhood/2)) < 0) starty = 0;
	else starty = point.y - (neighbourhood/2);

	if ((startx + neighbourhood-1) >= Width) endx = Width-1;
	else endx = (startx + neighbourhood-1);

	if ((starty + neighbourhood-1) >= Height) endy = Height-1;
	else endy = (starty + neighbourhood-1);

	for (int i = startx; i < endx; i++)
	{
		for (int j = starty; j < endy; j++)
		{
			Accumulator += (int)Image->GetRed(i,j);
			total++;
			
		}
	}*/
	return (int)Accumulator/total;
}
void CDocImAnView::SortArray(int *MyArray,int *SortedArray, int ArrayElems)
{
	//int *SortedArray;

	int SortedArrayIndex = 0;
	bool sorted = false;
	int maxVal = -1;
	int maxValPos = -1;
	while (sorted != true)
	{
		maxVal = -1;
		int maxValPos = -1;
		for (int i = 0; i < ArrayElems; i++)
		{
			if (MyArray[i] >= maxVal)
			{
				maxVal = MyArray[i];
				maxValPos = i;
			}
		}
		//introduce element in sortedArray
		if (maxVal != -1)
		{
			SortedArray[SortedArrayIndex] = maxVal;
			SortedArrayIndex++;
			//set MyArrayValue to -1
			MyArray[maxValPos] = -2;
		}
		if (SortedArrayIndex == ArrayElems)
		{
			sorted = true;
		}
	}

}
int  compare(const void * a, const void * b)
{ 
	return ( *(int*)a - *(int*)b );
}
int CDocImAnView::CalculateMedian(CPoint point, int neighbourhood, CImage * Image, int Width, int Height)
{
	int ArrayIndex = (int)pow((double)neighbourhood,2);
	//int *SortedArray;
	int *ValuesArray;
	ValuesArray = new int [ArrayIndex];
	//SortedArray = new int [ArrayIndex];
	
	int startx, starty, endx, endy;
	int total = 0;

	if ((point.x - (neighbourhood/2)) < 0) 
	{
		startx = 0;
	}else 
	{
		startx = point.x - (neighbourhood/2);
	}

	if ((point.y - (neighbourhood/2)) < 0) starty = 0;
	else starty = point.y - (neighbourhood/2);

	if ((startx + neighbourhood-1) >= Width) endx = Width-1;
	else endx = (startx + neighbourhood-1);

	if ((starty + neighbourhood-1) >= Height) endy = Height-1;
	else endy = (starty + neighbourhood-1);

	for (int i = startx; i < endx; i++)
	{
		for (int j = starty; j < endy; j++)
		{
			ValuesArray[total]=(int) Image->GetRed(i,j);
			//Accumulator += Image->GetRed(i,j);
			total++;
			
		}
	}
	//sort the array
	qsort(ValuesArray,total,sizeof(int),compare);
	
	//now get value in the middle of array
	int val = (int)(total/2);
	return ValuesArray[val];
	
}



double CDocImAnView::CalculateVariance(CPoint point, int neighbourhood, double mean, CImage * Image, int Width, int Height)
{
	int startx, starty, endx, endy;
	int total = 0;
	double Accumulator = 0;

	if ((point.x - (neighbourhood/2)) < 0) startx = 0;
	else startx = point.x - (neighbourhood/2);

	if ((point.y - (neighbourhood/2)) < 0) starty = 0;
	else starty = point.y - (neighbourhood/2);

	if ((startx + neighbourhood-1) >= Width) endx = Width-1;
	else endx = (startx + neighbourhood-1);

	if ((starty + neighbourhood-1) >= Height) endy = Height-1;
	else endy = (starty + neighbourhood-1);

	for (int i = startx; i <= endx; i++)
	{
		for (int j = starty; j <= endy; j++)
		{
			Accumulator += pow(((double)Image->GetRed(i,j)- mean),2);
			total++;
			
		}
	}
	return (Accumulator/total);
}
double CDocImAnView::CalculateVariance2(CPoint point, int neighbourhood, double mean, CImage * Image, int Width, int Height)
{
	int startx, starty, endx, endy;
	int total = 0;
	double Accumulator = 0;
	int variance;

	if ((point.x - (neighbourhood/2)) < 0) startx = 0;
	else startx = point.x - (neighbourhood/2);

	if ((point.y - (neighbourhood/2)) < 0) starty = 0;
	else starty = point.y - (neighbourhood/2);

	if ((startx + neighbourhood-1) >= Width) endx = Width-1;
	else endx = (startx + neighbourhood-1);

	if ((starty + neighbourhood-1) >= Height) endy = Height-1;
	else endy = (starty + neighbourhood-1);

	for (int i = startx; i <= endx; i++)
	{
		for (int j = starty; j <= endy; j++)
		{
			Accumulator += pow(((double)Image->GetRed(i,j)- mean),2);

			total++;
			
		}
	}
	variance = (int) Accumulator - (-1/total);
	variance = variance / (total-1);
	return variance;

}
void CDocImAnView::OnFiltersMean()
{
	double mean;
	CPoint point;
	int neighb = 5;//15x15

	GetDocument()->CreateNewUndoImage();

	if (GetDocument()->m_IsCharLocalized == FALSE)
	{
		for (int i = 0; i < GetActiveImage()->GetWidth(); i++)
		{
			for (int j = 0; j < GetActiveImage()->GetHeight(); j++)
			{
				point.SetPoint(i,j);
				mean = CalculateMean(point, neighb,GetActiveImage(),GetActiveImage()->GetWidth(), GetActiveImage()->GetHeight());
				GetActiveImage()->SetRGBColor(i,j,RGB(mean,mean,mean));
			}
		}
	}
	else{
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				//for each located character 
				for (int x = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left; x <= GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right; x++)
				{
					for (int y = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top; y <= GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom; y++)
					{
						point.SetPoint(x,y);
						mean = CalculateMean(point, neighb,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom);
						GetActiveImage()->SetRGBColor(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + x, GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + y,RGB(mean,mean,mean));
					}
				}
			}
		}
	}
	GetActiveImage()->SetDirty(); 
	//update image

	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::ApplyLocalContrastThreshold(CImage * Image)
{
	int neigh = 5;
	CPoint point;
	double mean, value;
	//CImage * newImage = new CImage();
	//newImage->CreateDuplicate(Image,0);
	for (int i = 0; i < Image->GetWidth(); i++)
	{
		for (int j = 0; j < Image->GetHeight(); j++)
		{
			point.SetPoint(i,j);
			mean = CalculateMean(point,neigh,Image,Image->GetWidth(),Image->GetHeight());
			value =(int) Image->GetRed(i,j);
			if (value >= mean) Image->SetRGBColor(i,j,RGB(255,255,255));
			else Image->SetRGBColor(i,j,RGB(0,0,0));
		}
	}
	//delete newImage;
}
void CDocImAnView::OnFiltersNiblackdimos()
{
	GetDocument()->CreateNewUndoImage();
	CRect rect;
	if (GetDocument()->m_IsCharLocalized == FALSE)//apply to all image
	{
		if /*((GetDocument()->m_IsCharLocalized) || */(GetDocument()->m_IsCharSegmented)//)//apply to each segmented character
		{
			for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
			{
				for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
				{
					rect.SetRect(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height);
					GetDocument()->GetUndoImage(GetDocument()->m_index-2)->Threshold_Niblack(5,rect,GetActiveImage(),2);	
				}
			}
		}
		else
		{
		rect.SetRect(0,0,GetActiveImage()->GetWidth(),GetActiveImage()->GetHeight());
		GetDocument()->GetUndoImage(GetDocument()->m_index-2)->Threshold_Niblack(5,rect,GetActiveImage(),2);
		}
	
	}
	else //apply to each localized character
	{
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				rect.SetRect(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom);
				GetDocument()->GetUndoImage(GetDocument()->m_index-2)->Threshold_Niblack(5,rect,GetActiveImage(),2);	
			}
		}
	}
	GetActiveImage()->SetDirty(); //otherwise, update will be requested from paint anyway//
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(false);
}

	

void CDocImAnView::OnFiltersThreshold128()
{
	GetDocument()->CreateNewUndoImage();
	CRect rect;
	rect.SetRect(0,0,GetActiveImage()->GetWidth(),GetActiveImage()->GetHeight());
	GetDocument()->GetUndoImage(GetDocument()->m_index-2)->Threshold(128,rect,GetActiveImage());
	
	GetActiveImage()->SetDirty(); //otherwise, update will be requested from paint anyway//
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}


void CDocImAnView::OnFiltersSauvola()
{
	double mean, variance;
	int min, max;
	int sauvola;
	CPoint point;
	int neighb = 5;//15x15 //5
	double k = -0.2; //Dimos uses 0.2 i was using 0.4
	//min = 
	GetDocument()->CreateNewUndoImage();

	if (GetDocument()->m_IsCharLocalized == FALSE)
	{
		for (int i = 0; i < GetActiveImage()->GetWidth(); i++)
		{
			for (int j = 0; j < GetActiveImage()->GetHeight(); j++)
			{
				point.SetPoint(i,j);
				min = CalculateMinInNeighb(point,neighb,GetActiveImage());
				max = CalculateMaxInNeighb(point,neighb,GetActiveImage());
				mean = CalculateMean(point, neighb,GetActiveImage(),GetActiveImage()->GetWidth(), GetActiveImage()->GetHeight());
				//variance = CalculateVariance(point,neighb,mean,GetActiveImage(),GetActiveImage()->GetWidth(), GetActiveImage()->GetHeight());
				variance = CalculateVariance2(point,neighb,mean,GetActiveImage(),GetActiveImage()->GetWidth(), GetActiveImage()->GetHeight());
				sauvola = (int) (mean + (1 + k * (1 - sqrt(variance)/128.0)));
				if (sauvola < 0) sauvola = 0;
				int value  = (int) GetRValue(GetActiveImage()->GetRGBColor(i,j));
				if ((max - min) < 30)
				{
					GetActiveImage()->SetRGBColor(i,j,RGB(255,255,255));
				}
				else
				{
					if ( value > sauvola || sauvola > 200)
					{
						//is background set it to 0
					//	GetActiveImage()->SetRGBColor(i, j,RGB(0,0,0));
						//set it the the most repeted value of the background
						//GetActiveImage()->SetRGBColor(i, j,RGB(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_BackgroundHighest,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_BackgroundHighest,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_BackgroundHighest));
						GetActiveImage()->SetRGBColor(i,j,RGB(255,255,255));
					}
					else
					{
						GetActiveImage()->SetRGBColor(i, j,RGB(0,0,0));
					}
				}
			}
		}
	}
	else{

		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				//for each located character 
				for (int x = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left; x <= GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right; x++)
				{
					for (int y = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top; y <= GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom; y++)
					{
						point.SetPoint(x,y);
						min = CalculateMinInNeighb(point,neighb,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage);
						max = CalculateMaxInNeighb(point,neighb,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage);
						mean = CalculateMean(point, neighb,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom);
						variance = CalculateVariance(point,neighb,mean,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom);
						sauvola = (int) (mean + (1 + k * (1 - sqrt(variance)/128.0)));
						if (sauvola < 0) sauvola = 0;
						int value = (int) GetRValue(GetActiveImage()->GetRGBColor((GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + x),(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + y)));
						int background = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_BackgroundHighest;
						if ((max - min) < 30)
						{
							//is background set it to white 255
							GetActiveImage()->SetRGBColor(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + x, GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + y,RGB(background,background,background));
						}
						else{
							if (( value > sauvola) || (value > 200))
							{
								//is background set it to white 255
								//set it the the most repeted value of the background
								GetActiveImage()->SetRGBColor(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + x, GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + y,RGB(background,background,background));
							}
							else // is foreground set to black 0
							{
								GetActiveImage()->SetRGBColor(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + x, GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + y,RGB(0,0,0));
							}
						}
					//	GetActiveImage()->SetRGBColor(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + x, GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + y,RGB(niblack,niblack,niblack));
						GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetActiveImage(),false);
					
					}
				}
				
			}
		}

	}
	GetActiveImage()->SetDirty(); 
	//update image

	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

int CDocImAnView::CalculateMaxInNeighb(CPoint point,int neighbourhood, CImage *Image)
{
	int max = 0;
	int startx, starty, endx, endy;
	if ((point.x - (neighbourhood/2)) < 0) 
	{
		startx = 0;
	}else 
	{
		startx = point.x - (neighbourhood/2);
	}

	if ((point.y - (neighbourhood/2)) < 0) starty = 0;
	else starty = point.y - (neighbourhood/2);

	if ((startx + neighbourhood-1) >= Image->GetWidth()) endx = Image->GetWidth()-1;
	else endx = (startx + neighbourhood-1);

	if ((starty + neighbourhood-1) >= Image->GetHeight()) endy = Image->GetHeight()-1;
	else endy = (starty + neighbourhood-1);

	for (int i = startx; i <= endx; i++)
	{
		for (int j = starty; j <= endy; j++)
		{
			int value = (int) Image->GetRed(i,j);
			if (value > max) max = value;
			
		}
	}

	return max;

}
int CDocImAnView::CalculateMinInNeighb(CPoint point,int neighbourhood, CImage *Image)
{
	int min;
	int startx, starty, endx, endy;
	if ((point.x - (neighbourhood/2)) < 0) 
	{
		startx = 0;
	}else 
	{
		startx = point.x - (neighbourhood/2);
	}

	if ((point.y - (neighbourhood/2)) < 0) starty = 0;
	else starty = point.y - (neighbourhood/2);

	if ((startx + neighbourhood-1) >= Image->GetWidth()) endx = Image->GetWidth()-1;
	else endx = (startx + neighbourhood-1);

	if ((starty + neighbourhood-1) >= Image->GetHeight()) endy = Image->GetHeight()-1;
	else endy = (starty + neighbourhood-1);
	min = (int) Image->GetRed(startx,starty);
	for (int i = startx; i <= endx; i++)
	{
		for (int j = starty; j <= endy; j++)
		{
			int value = (int) Image->GetRed(i,j);
			if (value < min) min = value;
		}
	}

	return min;

}
void CDocImAnView::OnSegmentationShowcharactercentres()
{
	m_ShowCharCentres = true;
}
void CDocImAnView::ApplyAdaptiveHistogram()
{
	CDIAHistograms histo;
	int Full_Character = 25;
	int BackGround_Percent = 60;
	if (GetDocument()->m_IsCharSegmented == TRUE)//apply to each segmented character
		{
			for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
			{
				for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
				{
					CRect rect;
					rect.left = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X;
					rect.right = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width;
					rect.top = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y;
					rect.bottom = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height;

					int AB = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CalculateForegroundPercentage2(Full_Character,(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width * GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height),GetActiveImage(),rect);
					int BC = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CalculateForegroundPercentage2(BackGround_Percent,(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width * GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height),GetActiveImage(),rect);
				/*	if ((AB >=180) || (BC>=180)) 
					{
						AB = 0;
						BC = 255;
					}*/
					histo.m_pdoc = GetDocument();
				
					histo.ComputeHistogram(histo.m_inHistogram,&histo.m_maxvalueInHisto,rect,histo.m_pdoc->GetActiveImage());
					
					histo.CalculateFunctionContrast(histo.m_inHistogram,AB,BC,false);
					//Histogram transformation
					histo.ComputeTransformation(GetActiveImage(),histo.m_pdoc->GetUndoImage(histo.m_pdoc->m_index-2),rect);
				}
			}
		}

}
void CDocImAnView::OnFiltersAdaptivehistogram()
{
	GetDocument()->CreateNewUndoImage();
	ApplyAdaptiveHistogram();
	//update image
	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::OnSegmentationOnlysegmentation()
{
	IsResegmenting = false;
	PreprocessImage();

	PerformSegmentation(GetActiveImage());

	//delete preprcessing and go back to original image
	if (GetDocument()->m_pUndoImage != NULL)
	{	
		while (GetDocument()->m_index >1)
		{
			delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
			GetDocument()->m_index--;
		}
		SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
	}

	//update image
	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::OnSegmentationLines()
{
	if (!GetDocument()->m_bIsPreprocessed)
	{
		PreprocessImage();
	}
	PerformLineSegmentation(GetActiveImage());
	GetDocument()->m_bIsLineSegmented = true;
}

void CDocImAnView::OnImageAddtwoimages()
{
	if (GetActiveImage() == NULL)
	{
		//CDlgErrorNoImage dlgError;
		//dlgError.DoModal();
		GetDocument()->UpdateAllViews(this,0L,NULL);
		Invalidate(FALSE);
	}
	else
	{
		CDlgAddImages dlg;
		dlg.SetDocument(GetDocument());
		
		if (IDOK == dlg.DoModal())
		{
			GetActiveImage()->SetDirty(); 
			GetDocument()->UpdateAllViews(this,0L,NULL);
			//create new char images after addition
			for (int i = 0; i < GetDocument()->m_LineHolderIndex; i ++)
			{
				for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
				{
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[i].CreateCharImage(GetActiveImage(),false);
				}
			}
			Invalidate(FALSE);
		}
	}
}


void CDocImAnView::OnFiltersEdgepreservingsmooth()
{
	GetDocument()->CreateNewUndoImage();
	CRect rect;
	if (GetDocument()->m_IsCharLocalized == FALSE)//apply to all image
	{
		if (GetDocument()->m_IsCharSegmented == TRUE)//apply to each segmented character
		{
			for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
			{
				for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
				{
					rect.SetRect(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height);
					GetDocument()->GetUndoImage(GetDocument()->m_index-2)->EdgePreservingSmoothing();	
				}
			}

		}
		else
		{
		rect.SetRect(0,0,GetActiveImage()->GetWidth(),GetActiveImage()->GetHeight());
		GetDocument()->GetUndoImage(GetDocument()->m_index-2)->EdgePreservingSmoothing();	
		}
	
	}
	else //apply to each localized character
	{
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				rect.SetRect(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom);
				GetDocument()->GetUndoImage(GetDocument()->m_index-2)->EdgePreservingSmoothing();		
			}
		}
	}
	GetActiveImage()->SetDirty(); //otherwise, update will be requested from paint anyway//
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(false);

}
void CDocImAnView::ThresholdPercent()
{	
	GetDocument()->CreateNewUndoImage();
	CRect rect;
	if (GetDocument()->m_IsCharLocalized)
	{
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				rect.top = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top;
				rect.bottom = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom;
				rect.left = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left;
				rect.right = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right;
			//	rect.SetRect(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width , GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height);
				//rect.SetRect(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right);
			}
		}
	
	}

}
void CDocImAnView::ThresholdHighestVals()
{
	GetDocument()->CreateNewUndoImage();
	CRect rect;
	int Full_Character = 25;
	int Localized_Character = 40;
	int Localized_Background = 80;
	int Background_pixels = 50;
	
	if (GetDocument()->m_IsCharLocalized == FALSE)//apply to all image
	{
		if (GetDocument()->m_IsCharSegmented == TRUE)//apply to each segmented character
		{
			for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
			{
				for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
				{
					
					rect.SetRect(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width , GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height);
					
					int percentFore = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CalculateForegroundPercentage2(Full_Character,(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width * GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height),GetActiveImage(),rect);
					int percentBack = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CalculateForegroundPercentage2(Background_pixels,(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width * GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height),GetActiveImage(),rect);
					//int percent = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CalculateForegroundPercentage2(50,(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width * GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height),GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,rect);
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ApplyThreshold402(GetActiveImage(),percentFore,percentBack,rect);	
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetActiveImage(),false);
				}
			}

		}
		else
		{
			
		}
	
	}
	else //apply to each localized character
	{
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				rect.top = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top;
				rect.bottom = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom;
				rect.left = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left;
				rect.right = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right;
			//	rect.SetRect(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width , GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height);
				//rect.SetRect(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right);
	
				int PercentFore = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CalculateForegroundPercentage2(Localized_Character,((rect.right-rect.left)*(rect.bottom-rect.top)),GetActiveImage(),rect);
				int PercentBack = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CalculateForegroundPercentage2(Localized_Background,((rect.right-rect.left)*(rect.bottom-rect.top)),GetActiveImage(),rect);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ApplyThreshold402(GetActiveImage(),PercentFore,PercentBack,rect);	
				//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ApplyThreshold(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_foreground40);
				
			}
		}
	}

}
void CDocImAnView::ThresholdInGroups()
{
	GetDocument()->CreateNewUndoImage();
	CRect rect;
	int Top5 = 5;
	int Top5Colour = 0;
	int Top10 = 10;
	int Top10Colour = 25;
	int Top20 = 20;
	int Top20Colour = 50;
	int Top25 = 25;
	int Top25Colour = 75;
	int Top30 = 30;
	int Top30Colour = 100;
	int Top35 = 35;
	int Top35Colour = 125;

	int FuzzyColour = 180;

	int Bottom40 = 50;
	int Bottom40Colour = 200;
	int Bottom20 = 80;
	int Bottom20Colour = 255;
	

	int Full_Character = 25;
	int Localized_Character = 40;
	int Localized_Background = 80;
	int Background_pixels = 60;
	
	if (GetDocument()->m_IsCharLocalized == FALSE)//apply to all image
	{
		if (GetDocument()->m_IsCharSegmented == TRUE)//apply to each segmented character
		{
			for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
			{
				for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
				{
					
					rect.SetRect(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width , GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height);

					int percentTop10 = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CalculateForegroundPercentage2(Top10,(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width * GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height),GetActiveImage(),rect);
					int percentTop5 = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CalculateForegroundPercentage2(Top5,(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width * GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height),GetActiveImage(),rect);
					int percentTop20 = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CalculateForegroundPercentage2(Top20,(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width * GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height),GetActiveImage(),rect);
					int percentTop25 = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CalculateForegroundPercentage2(Top25,(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width * GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height),GetActiveImage(),rect);
					int percentTop30 = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CalculateForegroundPercentage2(Top30,(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width * GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height),GetActiveImage(),rect);
					int percentTop35 = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CalculateForegroundPercentage2(Top35,(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width * GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height),GetActiveImage(),rect);
					int percentBottom20 = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CalculateForegroundPercentage2(Bottom20,(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width * GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height),GetActiveImage(),rect);
					int percentBottom40 = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CalculateForegroundPercentage2(Bottom40,(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width * GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height),GetActiveImage(),rect);
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ApplyThreshold(GetActiveImage(),rect,0,percentTop5,Top5Colour);
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ApplyThreshold(GetActiveImage(),rect,percentTop5,percentTop10,Top10Colour);
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ApplyThreshold(GetActiveImage(),rect,percentTop10,percentTop20,Top20Colour);
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ApplyThreshold(GetActiveImage(),rect,percentTop20,percentTop25,Top25Colour);
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ApplyThreshold(GetActiveImage(),rect,percentTop25,percentTop30,Top30Colour);
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ApplyThreshold(GetActiveImage(),rect,percentTop30,percentTop35,Top35Colour);
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ApplyThreshold(GetActiveImage(),rect,percentTop35,percentBottom40,FuzzyColour);
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ApplyThreshold(GetActiveImage(),rect,percentBottom40,percentBottom20,Bottom40Colour);
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ApplyThreshold(GetActiveImage(),rect,percentBottom20,255,Bottom20Colour);
					
					
					//int percentFore = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CalculateForegroundPercentage2(Full_Character,(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width * GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height),GetActiveImage(),rect);
					//int percentBack = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CalculateForegroundPercentage2(Background_pixels,(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width * GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height),GetActiveImage(),rect);
					////int percent = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CalculateForegroundPercentage2(50,(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width * GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height),GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,rect);
					//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ApplyThreshold402(GetActiveImage(),percentFore,percentBack,rect);	
					//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetActiveImage(),false);
				}
			}

		}
		else
		{
			
		}
	
	}
	else //apply to each localized character
	{
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				rect.top = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top;
				rect.bottom = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom;
				rect.left = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left;
				rect.right = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right;
			//	rect.SetRect(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width , GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height);
				//rect.SetRect(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right);
				int PercentFore = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CalculateForegroundPercentage2(Localized_Character,((rect.right-rect.left)*(rect.bottom-rect.top)),GetActiveImage(),rect);
				int PercentBack = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CalculateForegroundPercentage2(Localized_Background,((rect.right-rect.left)*(rect.bottom-rect.top)),GetActiveImage(),rect);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ApplyThreshold402(GetActiveImage(),PercentFore,PercentBack,rect);	
				//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ApplyThreshold(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_foreground40);
				
			}
		}
	}

}
void CDocImAnView::OnFiltersThreshold40()
{


	ThresholdHighestVals();

	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(false);
	
}
void CDocImAnView::outputCleanImage()
{
	GetDocument()->CreateNewUndoImage();
	for (int a = 0; a < GetActiveImage()->GetWidth(); a++)
	{
		for (int b = 0; b < GetActiveImage()->GetHeight(); b++)
		{
			GetActiveImage()->SetRGBColor(a,b,RGB(255,255,255));
		}
	}
	GetActiveImage()->SetDirty();
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(false);
	if (GetDocument()->m_IsCharLocalized == FALSE)
	{
		if (GetDocument()->m_IsCharSegmented == TRUE)
		{
			for (int x = 0; x < GetDocument()->m_LineHolderIndex; x++)
			{
				for ( int y = 0; y < GetDocument()->m_pLineHolder[x].m_CharacterHolderIndex; y ++)
				{
					for (int i = GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_Position_X; i < (GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_Position_X + GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_Width); i++)
					{
						for (int j = GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_Position_Y; j < (GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_Position_Y + GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_Height); j++)
						{
							COLORREF color = GetDocument()->GetUndoImage(GetDocument()->m_index - 2)->GetRGBColor(i,j);
							GetDocument()->GetActiveImage()->SetRGBColor(i ,j, GetDocument()->GetUndoImage(GetDocument()->m_index - 2)->GetRGBColor(i,j));
						}
					}
					
				}
			}
		}
	}
	else
	{
		for (int x = 0; x < GetDocument()->m_LineHolderIndex; x++)
		{
			for ( int y = 0; y < GetDocument()->m_pLineHolder[x].m_CharacterHolderIndex; y ++)
			{
				for (int i = (GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_Position_X + GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_CharLocation.left); i < (GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_Position_X + GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_CharLocation.right); i++)
				{
					for (int j = (GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_Position_Y + GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_CharLocation.top) ; j < (GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_Position_Y + GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_CharLocation.bottom); j++)
					{
						COLORREF color = GetDocument()->GetUndoImage(GetDocument()->m_index - 2)->GetRGBColor(i,j);
						GetDocument()->GetActiveImage()->SetRGBColor(i ,j, GetDocument()->GetUndoImage(GetDocument()->m_index - 2)->GetRGBColor(i,j));
					}
					
				}
			}
		}
	}

	/*GetActiveImage()->SetDirty();
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(false);*/
}
void CDocImAnView::OnImageOutputcleanimage()
{
	outputCleanImage();
	
}
void DrawImage(CPoint point, CImage * OldImage, CRect rect, CImage * NewImage)
{
	for (int i = 0; i <= (rect.right - rect.left); i++)
		{
			for (int j = 0; j <= (rect.bottom - rect.top); j++)
			{
				//COLORREF color = GetDocument()->GetUndoImage(GetDocument()->m_index - 2)->GetRGBColor(i,j);
				COLORREF color = OldImage->GetRGBColor(rect.left + i,rect.top + j);
				NewImage->SetRGBColor(point.x + i ,point.y + j, color);
				
			}
			
		}
}
void CDocImAnView::SpaceCleanCharacters()
{
	//calculate how wide and how long the new image has to be
	//we want to allow 10 pixels between each charater 
	//create a new image  with width = NoMaxCharsLine * Fixedwidth  + (10* (NoChars+2))
	CGreyScaleImage * NewImage;
	
	int maxCharacters = GetDocument()->m_pLineHolder[0].m_CharacterHolderIndex;
	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	{
		if (GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex > maxCharacters)
			maxCharacters = GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex;
		//if (i > maxCharacters) maxCharacters = i;
	}
	
	//we have now what is the maximum number of characters
	int spaceValue = 5;
	int SpaceValueLines = 10;
	int newWidth = GetDocument()->GetActiveImage()->GetWidth() + (maxCharacters * spaceValue);
	int newHeight = GetDocument()->GetActiveImage()->GetHeight() + (GetDocument()->m_LineHolderIndex * spaceValue);

	LPCTSTR newName  = GetDocument()->GetActiveImage()->GetName();
	NewImage = new CGreyScaleImage;
	NewImage->Create(newWidth,newHeight,RGB(255,255,255),newName);

	
	int linetimes = 0;
	int times = 0;
	CPoint position;
	//position.y = GetDocument()->m_pLineHolder[0].m_Position_Y;
	for (int x = 0; x < GetDocument()->m_LineHolderIndex; x++)
	{
		//position.y = GetDocument()->m_pLineHolder[x].m_Position_Y + linetimes;
		times = 0;
		//position.y = GetDocument()->m_pLineHolder[x].m_pCharacterHolder[0].m_CharLocation.top;
		position.x = GetDocument()->m_pLineHolder[x].m_pCharacterHolder[0].m_CharLocation.left + GetDocument()->m_pLineHolder[x].m_pCharacterHolder[0].m_Position_X;
		int heightpos = GetDocument()->m_pLineHolder[x].m_Position_Y ;
		int height = GetDocument()->m_pLineHolder[x].m_Height;
		int width = 0;
		for ( int y = 0; y < GetDocument()->m_pLineHolder[x].m_CharacterHolderIndex; y ++)
		{
			//find the character location on oldImage = charlocatin?

			CRect rectpos;
			rectpos = GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_CharLocation; 
			rectpos.left = GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_Position_X + GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_CharLocation.left;
			rectpos.right = GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_Position_X + GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_CharLocation.right;
			rectpos.top = GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_Position_Y + GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_CharLocation.top;
			rectpos.bottom = GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_Position_Y + GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_CharLocation.bottom;

			width = GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_CharLocation.right - GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_CharLocation.left+ 1;
			position.x = GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_CharLocation.left + GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_Position_X + spaceValue;
			//find character located width
			position.y = GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_CharLocation.top + heightpos + SpaceValueLines;
			DrawImage(position,GetDocument()->GetActiveImage(),rectpos,NewImage);

			
			position.x += width + spaceValue;
			
			
			//for (int i = (GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_Position_X + GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_CharLocation.left); i < (GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_Position_X + GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_CharLocation.right); i ++)
			//{
			//	for (int j = (GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_Position_Y + GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_CharLocation.top) ; j < (GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_Position_Y + GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_CharLocation.bottom); j++)
			//	{
			//		//COLORREF color = GetDocument()->GetUndoImage(GetDocument()->m_index - 2)->GetRGBColor(i,j);
			//		COLORREF color = GetDocument()->GetActiveImage()->GetRGBColor(i,j);
			//		NewImage->SetRGBColor(i + (spaceValue*times) ,j + (spaceValue*linetimes), color);
			//		
			//	}
			//	
			//}
			//times++;//for each character
		}
		//linetimes++;
		heightpos += height + SpaceValueLines;
	}
	SetActiveImage(NewImage);
	GetActiveImage()->SetDirty();
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(false);
}

void CDocImAnView::OnPreprocessingNormal()
{
	PreprocessImage();
}

void CDocImAnView::OnPreprocessingSoft()
{
	PreprocessImageSoft();
}

void CDocImAnView::OnFixedwidthsegmentationWidth()
{
	int index = GetDocument()->m_index;
	if (!GetDocument()->m_bIsPreprocessed)
	{
		PreprocessImage();
	}
	PerformLineSegmentation(GetActiveImage());
	GetDocument()->m_bIsLineSegmented = true;
	DIASegmentation * seg;
	seg = new DIASegmentation;
	seg->m_pdoc = GetDocument();
	//characters are created in computeFixedWidthSegmentation2//
	seg->ComputeFixedWidthSegmentation2(30);
	//seg->ComputeFixedWidthSegmentation3(50,30);
	m_bViewIndividualCharacters = true;
	GetDocument()->m_IsCharSegmented = true;
	//GetDocument()->m_ShowFix = true;
	
	delete seg;
	//delete intermediate images

	if (GetDocument()->m_pUndoImage != NULL)
	{	
		while (GetDocument()->m_index > index)
		{
			delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
			GetDocument()->m_index--;
		}
		SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
	}

	//SetActiveImage(GetDocument()->GetUndoImage(0));
	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);

}
void CDocImAnView::PerformLineSegmentation(CImage * pOrigImage)
{

	CString sReplacementText = _T("Performing Line Segmentation");
    ((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));

	//Segmentation
	DIASegmentation * seg;
	seg = new DIASegmentation;
	seg->m_pdoc = GetDocument();
	if (seg->m_pdoc != NULL)
	{
		//CImage * pOrigImage;
		
		seg->m_pdoc->CreateNewUndoImage(IT_GREYSCALE);
		//pOrigImage = seg->m_pdoc->GetUndoImage(seg->m_pdoc->m_index-1);

		seg->m_pHorzProj = new long[pOrigImage->GetHeight()];
		seg->m_pVertProj = new long[pOrigImage->GetWidth()];


		pOrigImage->GetProjection(0,0,pOrigImage->GetWidth(),pOrigImage->GetHeight(),seg->m_pHorzProj ,seg->m_pVertProj ,PRJ_GREY);

		seg->m_maxvalVert = seg->CalculateMaxVal(seg->m_pVertProj,pOrigImage->GetWidth());
		seg->m_maxvalHorz = seg->CalculateMaxVal(seg->m_pHorzProj,pOrigImage->GetHeight());		

		seg->m_pHorzProfileDistribution = new CDistribution <long>;
		seg->m_pHorzProfileDistribution->Create(seg->m_pVertProj,pOrigImage->GetWidth());
		seg->m_pVertProfileDistribution = new CDistribution <long>;
		seg->m_pVertProfileDistribution->Create(seg->m_pHorzProj,pOrigImage->GetHeight());
		seg->m_separatorIndexV = 0;
		seg->m_separatorIndexH = 0;
		seg->m_SeparatorsComputedH = false;
		seg->m_SeparatorsComputedV = false;
		seg->m_pSeparatorsH = new CTextLine::SEPARATOR[seg->m_pHorzProfileDistribution->GetMinimaCount()];
		seg->m_pSeparatorsV = new CTextLine::SEPARATOR[seg->m_pVertProfileDistribution->GetMinimaCount()];
		for (int i = 0; i < seg->m_pVertProfileDistribution->GetMinimaCount(); i++)
		{
			seg->m_pSeparatorsV[i].Strong = false;
		}

		for (int i = 0; i < seg->m_pHorzProfileDistribution->GetMinimaCount(); i++)
		{
			seg->m_pSeparatorsH[i].Strong = false;
		}
		seg->m_pdoc->m_LineHolderIndex = 0;
		seg->m_pdoc->m_pLineHolder = NULL;
	}

	seg->FindVerticalSeparators();
	seg->CreateHorizontalLines();
	
	delete seg;
}


void CDocImAnView::OnCharacterenhanceLocalizecharacters()
{
	int index = GetDocument()->m_index;
	if (!GetDocument()->m_IsCharSegmented)
	{ // if the image has not been segmented
		if (!GetDocument()->m_bIsPreprocessed)
		{
			PreprocessImage();
		}
		if ( !GetDocument()->m_bIsLineSegmented)
		{
			PerformLineSegmentation(GetActiveImage());
			GetDocument()->m_bIsLineSegmented = true;
		}
		DIASegmentation * seg;
		seg = new DIASegmentation;
		seg->m_pdoc = GetDocument();
		seg->ComputeFixedWidthSegmentation2(30);
		delete seg;

		if (GetDocument()->m_pUndoImage != NULL)
		{	
			while (GetDocument()->m_index > index)
			{
				delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
				GetDocument()->m_index--;
			}
			SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
		}
	//	SetActiveImage(GetDocument()->GetUndoImage(0));

		m_bViewIndividualCharacters = true;
		GetDocument()->m_IsCharSegmented = true;
	}
	index = GetDocument()->m_index;
	ThresholdHighestVals();
	
	LocateCharacters();

	ClassifyCharacters();
			
	GetDocument()->m_ShowInBox = true;
	
	CharacterAnalysis();

	while (GetDocument()->m_index > index)
	{
		delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
		GetDocument()->m_index--;
	}
	SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);

	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);

	
}

void CDocImAnView::OnCharacterenhanceLocalizecharacters32829()
{
	// TODO: Add your command handler code here
}

void CDocImAnView::OnImageClean()
{
	SpaceCleanCharacters();
}

void CDocImAnView::OnFiltersGaussian()
{

	//Create the undoimage before appliying the filter
	GetDocument()->CreateNewUndoImage();
	ApplyGaussianFilter(GetActiveImage());
	
	GetDocument()->UpdateAllViews(this,0L,NULL);
	
	Invalidate(FALSE);
}
void CDocImAnView::ApplyGaussianFilter(CImage * Image)
{
	_tcscpy(m_GaussianFilter.Name,_T("Gaussian Filter"));	

	//Create the undoimage before appliying the filter
	Image->ApplyFilter(&m_GaussianFilter);
	Image->SetDirty(); //otherwise, update will be requested from paint anyway//

}

void CDocImAnView::OnFiltersMedian()
{
	int median;
	CPoint point;
	int neighb = 5;//15x15

	GetDocument()->CreateNewUndoImage();

	if (GetDocument()->m_IsCharLocalized == FALSE)
	{
		for (int i = 0; i < GetActiveImage()->GetWidth(); i++)
		{
			for (int j = 0; j < GetActiveImage()->GetHeight(); j++)
			{
				point.SetPoint(i,j);
				median = CalculateMedian(point, neighb,GetDocument()->GetUndoImage(GetDocument()->m_index-2),GetActiveImage()->GetWidth(), GetActiveImage()->GetHeight());
				GetActiveImage()->SetRGBColor(i,j,RGB(median,median,median));
			}
		}
	}
	else{
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				//for each located character 
				for (int x = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left; x <= GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right; x++)
				{
					for (int y = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top; y <= GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom; y++)
					{
						point.SetPoint(x,y);
						median = CalculateMedian(point, neighb,GetDocument()->GetUndoImage(GetDocument()->m_index-2),GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom);
						GetActiveImage()->SetRGBColor(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + x, GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + y,RGB(median,median,median));
					}
				}
			}
		}
	}
	GetActiveImage()->SetDirty(); 
	//update image

	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::OnCompletemethodsFuzzymedian()
{
	// TODO: Add your command handler code here
}

void CDocImAnView::OnCompletemethodsFuzzymean()
{
	// TODO: Add your command handler code here
}

void CDocImAnView::OnCompletemethodsAdaptivethr40()
{
	int index = GetDocument()->m_index;
	if (!GetDocument()->m_IsCharSegmented)
	{ // if the image has not been segmented

		if (!GetDocument()->m_bIsPreprocessed)
		{
			PreprocessImage();
		}
		if ( !GetDocument()->m_bIsLineSegmented)
		{
			PerformLineSegmentation(GetActiveImage());
			GetDocument()->m_bIsLineSegmented = true;
		}
		DIASegmentation * seg;
		seg = new DIASegmentation;
		seg->m_pdoc = GetDocument();
		seg->ComputeFixedWidthSegmentation2(30);
		delete seg;

		if (GetDocument()->m_pUndoImage != NULL)
		{	
			while (GetDocument()->m_index > index)
			{
				delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
				GetDocument()->m_index--;
			}
			SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
		}
	//	SetActiveImage(GetDocument()->GetUndoImage(0));

		m_bViewIndividualCharacters = true;
		GetDocument()->m_IsCharSegmented = true;
	
		}
	index = GetDocument()->m_index;
	GetDocument()->CreateNewUndoImage();
	ApplyGaussianFilter(GetActiveImage());
	ThresholdHighestVals();

	ApplyAdaptiveHistogram();
	GetActiveImage()->SetDirty(); //otherwise, update will be requested from paint anyway//
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::OnThresholdThresholdingroups()
{
	ThresholdInGroups();
	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(false);
}

void CDocImAnView::OnSegmentationFixedlinesegmentation()
{
	if (!GetDocument()->m_bIsPreprocessed)
	{
		PreprocessImage();
	}
	DIASegmentation * seg;
	seg = new DIASegmentation;
	seg->m_pdoc = GetDocument();
	seg->ComputeFixedWidthLineSegmentation(50);
	delete seg;
	
	GetDocument()->m_bIsLineSegmented = true;
}

void CDocImAnView::OnCompletemethodsGatos()
{
	GetDocument()->CreateNewUndoImage(IT_GREYSCALE);
	CDIAGreyScale * newImage;
	newImage = new CDIAGreyScale;
	CRect rect;
	rect.SetRect(0,0,GetActiveImage()->GetWidth(),GetActiveImage()->GetHeight());
	newImage->CreateFromImage(GetDocument()->GetUndoImage(GetDocument()->m_index-1),0);
	newImage->Threshold_Gatos(40,rect,GetDocument()->GetUndoImage(GetDocument()->m_index-1),THR_OUTPUT_IMAGE);
	//THR_GATOS_PP
	SetActiveImage(GetDocument()->GetUndoImage(GetDocument()->m_index-1));
	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(false);
}

void CDocImAnView::OnImageClean32855()
{
	SpaceCleanCharacters2();
}
void CDocImAnView::SpaceCleanCharacters2()
{
	//calculate how wide and how long the new image has to be
	//we want to allow 10 pixels between each charater 
	//create a new image  with width = NoMaxCharsLine * Fixedwidth  + (10* (NoChars+2))
	CGreyScaleImage * NewImage;
	
	int maxCharacters = GetDocument()->m_pLineHolder[0].m_CharacterHolderIndex;
	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	{
		if (i > maxCharacters) maxCharacters = i;
	}
	
	//we have now what is the maximum number of characters
	int spaceValue = 1;
	int newWidth = GetDocument()->GetActiveImage()->GetWidth() + (maxCharacters * spaceValue);
	int newHeight = GetDocument()->GetActiveImage()->GetHeight() + (GetDocument()->m_LineHolderIndex * spaceValue);

	LPCTSTR newName  = GetDocument()->GetActiveImage()->GetName();
	NewImage = new CGreyScaleImage;
	NewImage->Create(newWidth,newHeight,RGB(255,255,255),newName);

	
	int linetimes = 0;
	int times = 0;
	for (int x = 0; x < GetDocument()->m_LineHolderIndex; x++)
	{
		times = 0;
		for ( int y = 0; y < GetDocument()->m_pLineHolder[x].m_CharacterHolderIndex; y ++)
		{
			
		
			for (int i = (GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_Position_X + GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_CharLocation.left); i < (GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_Position_X + GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_CharLocation.right); i ++)
			{
				for (int j = (GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_Position_Y + GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_CharLocation.top) ; j < (GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_Position_Y + GetDocument()->m_pLineHolder[x].m_pCharacterHolder[y].m_CharLocation.bottom); j++)
				{
					//COLORREF color = GetDocument()->GetUndoImage(GetDocument()->m_index - 2)->GetRGBColor(i,j);
					COLORREF color = GetDocument()->GetActiveImage()->GetRGBColor(i,j);
					NewImage->SetRGBColor(i + (spaceValue*times) ,j + (spaceValue*linetimes), color);
					
				}
				
			}
			times++;//for each character
		}
		linetimes+=3;
	}
	SetActiveImage(NewImage);
	GetActiveImage()->SetDirty();
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(false);
}
void CDocImAnView::OnExportLocatedcharacterimages()
{
	if (GetActiveImage() == NULL)
	{
		//CDlgErrorNoImage dlgError;
		//dlgError.DoModal();
		GetDocument()->UpdateAllViews(this,0L,NULL);
		Invalidate(FALSE);
	}
	else
	{
		CDlgExportChar dlg;
		dlg.SetDocument(GetDocument());
		
		if (IDOK == dlg.DoModal())
		{
			GetActiveImage()->SetDirty(); 
			GetDocument()->UpdateAllViews(this,0L,NULL);
			Invalidate(FALSE);
		}
	}
}

void CDocImAnView::OnSegmentationDivisions()
{
	if (GetActiveImage() == NULL)
	{
		//CDlgErrorNoImage dlgError;
		//dlgError.DoModal();
		GetDocument()->UpdateAllViews(this,0L,NULL);
		Invalidate(FALSE);
	}
	else
	{
		CDIADlgFindDivisions dlg;
		dlg.SetDocument(GetDocument());
		
		if (IDOK == dlg.DoModal())
		{
			GetActiveImage()->SetDirty(); 
			GetDocument()->UpdateAllViews(this,0L,NULL);
			Invalidate(FALSE);
		}
	}
}


void CDocImAnView::OnTestingOpentestingenvironment()
{
//if (GetActiveImage() == NULL)
//	{
//		//CDlgErrorNoImage dlgError;
//		//dlgError.DoModal();
//		GetDocument()->UpdateAllViews(this,0L,NULL);
//		Invalidate(FALSE);
//	}
//	else
//	{
		CDlgTestingEnvironment dlg;
		dlg.SetDocument(GetDocument());
		if (IDOK == dlg.DoModal())
		{
			//GetActiveImage()->SetDirty(); 
			GetDocument()->UpdateAllViews(this,0L,NULL);
			Invalidate(FALSE);
		}
	//}
}
void CDocImAnView::FTR()
{
	//We want to do a complete enhacement
	//TIMING - TRACING
	CString sReplacementText = _T("Enhancing Image Flexible Text Recovery");
    ((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));

	TRACE(_T("*****Enhancing Image Flexible Text Recovery*****\n"));
	//Global_Timing(GLTM_START);
	//END TIMING
	//first: segment the image

		int index = GetDocument()->m_index;
		if (!GetDocument()->m_bIsPreprocessed)
		{
			TRACE(_T("Preprocess Image... \n"));
			sReplacementText = _T("Preprocess Image...");
			((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));

			PreprocessImage();
		}
		TRACE(_T("Segmentation: Perform Line Segmentation... \n"));
		//sReplacementText = _T("Segmentation: Performing Line Segmentation...");
		//((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
			
		PerformLineSegmentation(GetActiveImage());

		GetDocument()->m_bIsLineSegmented = true;
		DIASegmentation * seg;
		seg = new DIASegmentation;
		seg->m_pdoc = GetDocument();
		//characters are created in computeFixedWidthSegmentation2//
		sReplacementText = _T("Segmentation: Performing Character Segmentation...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Segmentation: Perform Character Segmentation... \n"));

		seg->ComputeFixedWidthSegmentation2(30);

		m_bViewIndividualCharacters = true;
		GetDocument()->m_IsCharSegmented = true;
		//GetDocument()->m_ShowFix = true;
		
		delete seg;
		//delete intermediate images

		if (GetDocument()->m_pUndoImage != NULL)
		{	
			while (GetDocument()->m_index > index)
			{
				delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
				GetDocument()->m_index--;
			}
			SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
		}

	//second: apply adaptive histogram stretching	
		index = GetDocument()->m_index;
		GetDocument()->CreateNewUndoImage();

		sReplacementText = _T("Segmentation: Applying Local Adaptive Histogram...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Segmentation: Applying Local Adaptive Histogram... \n"));

		ApplyAdaptiveHistogram();

	//Third: Locate the characters
		sReplacementText = _T("Segmentation: Applying Threshold40 for the whole charImage...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Segmentation: Applying Threshold40 for the whole charImage... \n"));

		ThresholdHighestVals();

		sReplacementText = _T("Segmentation: Locate Characters in Boxes...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Segmentation: Locate Characters in Boxes... \n"));

		LocateCharacters();

		sReplacementText = _T("Segmentation: Classify Characters in boxes...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Segmentation: Classify Characters in boxes... \n"));

		ClassifyCharacters2();
				
		GetDocument()->m_ShowInBox = true;
		sReplacementText = _T("Segmentation: Character Analysis... ");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Segmentation: Character Analysis... \n"));

		CharacterAnalysis();

		while (GetDocument()->m_index > index)
		{
			delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
			GetDocument()->m_index--;
		}
		SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);

	//Fourth: Smooth the image 
		index = GetDocument()->m_index;
		GetDocument()->CreateNewUndoImage();
		sReplacementText = _T("Enhancement: Smoothing Image (Gaussian)...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Enhancement: Smoothing Image (Gaussian)... \n"));

		ApplyGaussianFilter(GetActiveImage());

	//Fifth: apply Threshold40
		sReplacementText = _T("Enhancement: Applying Threshold40...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Enhancement: Applying Threshold40... \n"));

		ThresholdHighestVals();
		

	//Sixth: create a new image and apply 2X Gauss + Sauvola
	
		sReplacementText = _T("Creating Niblack Image...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Creating Niblack Image... \n"));

		GetDocument()->CreateNewUndoImage(0);

		//CImage* niblackImage = new CImage;
		//niblackImage->CreateFromImage(GetDocument()->GetActiveImage());
		GetDocument()->GetUndoImage(GetDocument()->m_index - 1)->CreateFromImage(GetDocument()->GetUndoImage(GetDocument()->m_index - 3));
		CRect rect;

		ApplyGaussianFilter(GetDocument()->GetUndoImage(GetDocument()->m_index - 3));

		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				rect.SetRect(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom);
				//niblackImage->Threshold_Niblack(5,rect,GetActiveImage(),2);	
				GetDocument()->GetUndoImage(GetDocument()->m_index - 3)->Threshold_Niblack(5,rect,GetActiveImage(),2);
			}
		}
		//Compensation Mean
			TRACE(_T("Adding images Compensation Mean... \n"));
			sReplacementText = _T("Adding images Compensation Mean...");
			((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));

		GetDocument()->CreateNewUndoImage();

		int indexcompMean = GetDocument()->m_index - 1;
		int indexNiblack = GetDocument()->m_index - 2;
		int indexThres40 = GetDocument()->m_index - 3;
		for (int i = 0; i < GetDocument()->GetUndoImage(indexNiblack)->GetWidth(); i++)
		{
			for (int j = 0; j < GetDocument()->GetUndoImage(indexNiblack)->GetHeight(); j++)
			{
				int v1, v2, newvalue;
				v1 = (int) GetRValue(GetDocument()->GetUndoImage(indexThres40)->GetRGBColor(i,j));
				v2 = (int) GetRValue(GetDocument()->GetUndoImage(indexNiblack)->GetRGBColor(i,j));
				if (v1 != v2)
				{ 
					newvalue = AddValuesCompensationMean(v1, v2);
				}
				else 
					newvalue = v1;
				
				if (newvalue < 0) GetDocument()->GetUndoImage(indexcompMean)->SetRGBColor(i,j,RGB(128,128,128));
				GetDocument()->GetUndoImage(indexcompMean)->SetRGBColor(i,j,RGB(newvalue,newvalue,newvalue));
			}
		}

	//Localize Again
		LocateCharacters2();

	//Extract Features
		sReplacementText = _T("Extracting Features...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));

		ExtractCharacterFeatures();

	//Clean the background
	sReplacementText = _T("Cleaning the background...");
	((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));

	outputCleanImage();

	//update the image
	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	sReplacementText = _T("Done!");
	((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
	Invalidate(FALSE);
	GetDocument()->m_bIsImageImproved = true;
}

void CDocImAnView::FTR2()
{
	//We want to do a complete enhacement
	//TIMING - TRACING
	CString sReplacementText = _T("Enhancing Image Flexible Text Recovery");
    ((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));

	TRACE(_T("*****Enhancing Image Flexible Text Recovery*****\n"));
	//Global_Timing(GLTM_START);
	//END TIMING
	//first: segment the image

		int index = GetDocument()->m_index;
		if (!GetDocument()->m_bIsPreprocessed)
		{
			TRACE(_T("Preprocess Image... \n"));
			sReplacementText = _T("Preprocess Image...");
			((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));

			PreprocessImage();
		}
		TRACE(_T("Segmentation: Perform Line Segmentation... \n"));
		//sReplacementText = _T("Segmentation: Performing Line Segmentation...");
		//((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
			
		PerformLineSegmentation(GetActiveImage());

		GetDocument()->m_bIsLineSegmented = true;
		DIASegmentation * seg;
		seg = new DIASegmentation;
		seg->m_pdoc = GetDocument();
		//characters are created in computeFixedWidthSegmentation2//
		sReplacementText = _T("Segmentation: Performing Character Segmentation...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Segmentation: Perform Character Segmentation... \n"));

		seg->ComputeFixedWidthSegmentation2(30);

		m_bViewIndividualCharacters = true;
		GetDocument()->m_IsCharSegmented = true;
		//GetDocument()->m_ShowFix = true;
		
		delete seg;
		//delete intermediate images

		if (GetDocument()->m_pUndoImage != NULL)
		{	
			while (GetDocument()->m_index > index)
			{
				delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
				GetDocument()->m_index--;
			}
			SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
		}

	//second: apply adaptive histogram stretching	
		index = GetDocument()->m_index;
		GetDocument()->CreateNewUndoImage();

		sReplacementText = _T("Segmentation: Applying Local Adaptive Histogram...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Segmentation: Applying Local Adaptive Histogram... \n"));

		ApplyAdaptiveHistogramMaxMin();

	//Third: Locate the characters
		//sReplacementText = _T("Segmentation: Applying Threshold40 for the whole charImage...");
		//((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		//TRACE(_T("Segmentation: Applying Threshold40 for the whole charImage... \n"));

		//ThresholdHighestVals();

		sReplacementText = _T("Segmentation: Locate Characters in Boxes...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Segmentation: Locate Characters in Boxes... \n"));

		LocateCharacters3(128,3);

	//	sReplacementText = _T("Segmentation: Classify Characters in boxes...");
	//	((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
	//	TRACE(_T("Segmentation: Classify Characters in boxes... \n"));

		//ClassifyCharacters2();
				
		/*GetDocument()->m_ShowInBox = true;
		sReplacementText = _T("Segmentation: Character Analysis... ");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Segmentation: Character Analysis... \n"));

		CharacterAnalysis();*/

		while (GetDocument()->m_index > index)
		{
			delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
			GetDocument()->m_index--;
		}
		SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);

	//Fourth: Smooth the image 
		index = GetDocument()->m_index;
		GetDocument()->CreateNewUndoImage();
		sReplacementText = _T("Enhancement: Smoothing Image (Gaussian)...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Enhancement: Smoothing Image (Gaussian)... \n"));

		ApplyGaussianFilter(GetActiveImage());

	////Fifth: apply Threshold40
	//	sReplacementText = _T("Enhancement: Applying Threshold40...");
	//	((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
	//	TRACE(_T("Enhancement: Applying Threshold40... \n"));

	//	ThresholdHighestVals();
		
		GetDocument()->CreateNewUndoImage(0);
		CDlgDIAHistograms::RANGE_VALS * ranges;
		ranges = new CDlgDIAHistograms::RANGE_VALS[3];

		ranges[0].firstVal = 0;
		ranges[0].lastVal = 0;
		ranges[0].colour = 0;

		ranges[1].firstVal = 1;
		ranges[1].lastVal =-1;
		ranges[1].colour = -1;
		

		CDlgDIAHistograms dlgHistogram;
		dlgHistogram.SetDocument(GetDocument());
		dlgHistogram.ApplyAdvancedThresholdToCharacters(GetDocument()->GetActiveImage(),ranges, 3);

	
		GetDocument()->GetActiveImage()->SetDirty();

	//Sixth: create a new image and apply 2X Gauss + Sauvola
	
		sReplacementText = _T("Creating Niblack Image...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Creating Niblack Image... \n"));

		GetDocument()->CreateNewUndoImage(0);

		//CImage* niblackImage = new CImage;
		//niblackImage->CreateFromImage(GetDocument()->GetActiveImage());
		GetDocument()->GetUndoImage(GetDocument()->m_index - 1)->CreateFromImage(GetDocument()->GetUndoImage(GetDocument()->m_index - 3));
		CRect rect;

		ApplyGaussianFilter(GetDocument()->GetUndoImage(GetDocument()->m_index - 3));

		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				rect.SetRect(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom);
				//niblackImage->Threshold_Niblack(5,rect,GetActiveImage(),2);	
				GetDocument()->GetUndoImage(GetDocument()->m_index - 3)->Threshold_Niblack(5,rect,GetActiveImage(),2);
			}
		}
		//Compensation Mean
			TRACE(_T("Adding images Compensation Mean... \n"));
			sReplacementText = _T("Adding images Compensation Mean...");
			((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));

		GetDocument()->CreateNewUndoImage();

		int indexcompMean = GetDocument()->m_index - 1;
		int indexNiblack = GetDocument()->m_index - 2;
		int indexThres40 = GetDocument()->m_index - 3;
		for (int i = 0; i < GetDocument()->GetUndoImage(indexNiblack)->GetWidth(); i++)
		{
			for (int j = 0; j < GetDocument()->GetUndoImage(indexNiblack)->GetHeight(); j++)
			{
				int v1, v2, newvalue;
				v1 = (int) GetRValue(GetDocument()->GetUndoImage(indexThres40)->GetRGBColor(i,j));
				v2 = (int) GetRValue(GetDocument()->GetUndoImage(indexNiblack)->GetRGBColor(i,j));
				if (v1 != v2)
				{ 
					newvalue = AddValuesCompensationMean(v1, v2);
				}
				else 
					newvalue = v1;
				
				if (newvalue < 0) GetDocument()->GetUndoImage(indexcompMean)->SetRGBColor(i,j,RGB(128,128,128));
				GetDocument()->GetUndoImage(indexcompMean)->SetRGBColor(i,j,RGB(newvalue,newvalue,newvalue));
			}
		}

	//Localize Again
	//LocateCharacters2();
		LocateCharacters3(50,3);
		ClassifyCharacters2();
		GetDocument()->m_ShowInBox = true;
		CharacterAnalysis();
	//Extract Features
		sReplacementText = _T("Extracting Features...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
	
		ExtractCharacterFeatures();
	

	//Clean the background
	sReplacementText = _T("Cleaning the background...");
	((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));

	outputCleanImage();

	//update the image
	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	sReplacementText = _T("FTR Done!");
	((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
	Invalidate(FALSE);
	GetDocument()->m_bIsImageImproved = true;



}

void CDocImAnView::OnEnhancementFlexibletextrecovery()
{
	FTR2();
}

int CDocImAnView::AddValuesCompensationMean(int value1, int value2)
{
	if (value1 == value2) return value1;
	if ((value1 == 255) && (value2 == 0)) return value1;
	if ((value1 == 0) && (value2 == 255)) return 0;
	if (((value1 != 0) && (value1 != 255)) && (value2 == 0)) 
		//return ((value1+value1+value2)/3);
		return (((value1*4)+(100))/5);
	
	
	if (((value1 != 0) && (value1 != 255)) && (value2 == 255)) return 255;
	if (((value1 != 0) && (value1 != 255)) && ((value2 != 0) && (value2 != 255))) return ((value1 + value2)/2);
	else return -3;
}

void CDocImAnView::OnEnhancementFtrimproved()
{

	CString sReplacementText = _T("Enhancing Image Flexible Text Recovery");
    ((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));

	//TIMING - TRACING
	TRACE(_T("Enhancing Image Flexible Text Recovery... "));
	//Global_Timing(GLTM_START);
	//END TIMING
	int index = GetDocument()->m_index;
	DIASegmentation * seg;
	seg = new DIASegmentation;
	seg->m_pdoc = GetDocument();
	seg->ComputeFixedWidthSegmentation3(50,30);
	m_bViewIndividualCharacters = true;
	GetDocument()->m_IsCharSegmented = true;
	delete seg;

	//while (GetDocument()->m_index > index)
	//{
	//	delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
	//	GetDocument()->m_index--;
	//}
	//SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);

	//second: apply adaptive histogram stretching	
		index = GetDocument()->m_index;
		GetDocument()->CreateNewUndoImage();

		sReplacementText = _T("Segmentation: Applying Local Adaptive Histogram...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Segmentation: Applying Local Adaptive Histogram... \n"));

		ApplyAdaptiveHistogram();

	//Third: Locate the characters
		sReplacementText = _T("Segmentation: Applying Threshold40 for the whole charImage...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Segmentation: Applying Threshold40 for the whole charImage... \n"));

		ThresholdHighestVals();

		sReplacementText = _T("Segmentation: Locate Characters in Boxes...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Segmentation: Locate Characters in Boxes... \n"));

		LocateCharacters();

		sReplacementText = _T("Segmentation: Classify Characters in boxes...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Segmentation: Classify Characters in boxes... \n"));

		ClassifyCharacters2();
				
		GetDocument()->m_ShowInBox = true;
		sReplacementText = _T("Segmentation: Character Analysis... ");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Segmentation: Character Analysis... \n"));

		CharacterAnalysis();

		while (GetDocument()->m_index > index)
		{
			delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
			GetDocument()->m_index--;
		}
		SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);

	//Fourth: Smooth the image 
		index = GetDocument()->m_index;
		GetDocument()->CreateNewUndoImage();
		sReplacementText = _T("Enhancement: Smoothing Image (Gaussian)...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Enhancement: Smoothing Image (Gaussian)... \n"));

		ApplyGaussianFilter(GetActiveImage());

	//Fifth: apply Threshold40
		sReplacementText = _T("Enhancement: Applying Threshold40...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Enhancement: Applying Threshold40... \n"));

		ThresholdHighestVals();
		

	//Sixth: create a new image and apply 2X Gauss + Sauvola
	
		sReplacementText = _T("Creating Niblack Image...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Creating Niblack Image... \n"));

		GetDocument()->CreateNewUndoImage(0);

		//CImage* niblackImage = new CImage;
		//niblackImage->CreateFromImage(GetDocument()->GetActiveImage());
		GetDocument()->GetUndoImage(GetDocument()->m_index - 1)->CreateFromImage(GetDocument()->GetUndoImage(GetDocument()->m_index - 3));
		CRect rect;

		ApplyGaussianFilter(GetDocument()->GetUndoImage(GetDocument()->m_index - 3));

		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				rect.SetRect(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom);
				//niblackImage->Threshold_Niblack(5,rect,GetActiveImage(),2);	
				GetDocument()->GetUndoImage(GetDocument()->m_index - 3)->Threshold_Niblack(5,rect,GetActiveImage(),2);
			}
		}
	//	//Compensation Mean
	//		TRACE(_T("Adding images Compensation Mean... \n"));
	//		sReplacementText = _T("Adding images Compensation Mean...");
	//		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));

	//	GetDocument()->CreateNewUndoImage();

	//	int indexcompMean = GetDocument()->m_index - 1;
	//	int indexNiblack = GetDocument()->m_index - 2;
	//	int indexThres40 = GetDocument()->m_index - 3;
	//	for (int i = 0; i < GetDocument()->GetUndoImage(indexNiblack)->GetWidth(); i++)
	//	{
	//		for (int j = 0; j < GetDocument()->GetUndoImage(indexNiblack)->GetHeight(); j++)
	//		{
	//			int v1, v2, newvalue;
	//			v1 = (int) GetRValue(GetDocument()->GetUndoImage(indexThres40)->GetRGBColor(i,j));
	//			v2 = (int) GetRValue(GetDocument()->GetUndoImage(indexNiblack)->GetRGBColor(i,j));
	//			if (v1 != v2)
	//			{ 
	//				newvalue = AddValuesCompensationMean(v1, v2);
	//			}
	//			else 
	//				newvalue = v1;
	//			
	//			if (newvalue < 0) GetDocument()->GetUndoImage(indexcompMean)->SetRGBColor(i,j,RGB(128,128,128));
	//			GetDocument()->GetUndoImage(indexcompMean)->SetRGBColor(i,j,RGB(newvalue,newvalue,newvalue));
	//		}
	//	}

	////Localize Again
	//	LocateCharacters2();

	////Extract Features
	//	sReplacementText = _T("Extracting Features...");
	//	((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));

	//	ExtractCharacterFeatures();

	//Clean the background
	sReplacementText = _T("Cleaning the background...");
	((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));

	outputCleanImage();

	//update the image
	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	sReplacementText = _T("Done!");
	((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
	Invalidate(FALSE);
	GetDocument()->m_bIsImageImproved = true;

	//TIMING - TRACING
	//unsigned __int64 Difference = Global_Timing(GLTM_RESET);
	//TRACE(_T("Done (%I64d Cycles, ~%5.3f secs)\n"), Difference, Global_SecsFromCycles(Difference) );
	//END TIMING
}

void CDocImAnView::OnLinesegmentationWithpreprocessing()
{
	int index = GetDocument()->m_index;
	if (!GetDocument()->m_bIsPreprocessed)
	{
		PreprocessImage();
	}
	PerformLineSegmentation(GetActiveImage());
	GetDocument()->m_bIsLineSegmented = true;
	m_bShowLines = true;
	m_bViewSegmentedCharacters = true;

	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::OnLinesegmentationWithoutpreprocessing()
{
	PerformLineSegmentation(GetActiveImage());
	GetDocument()->m_bIsLineSegmented = true;
	m_bShowLines = true;
	m_bViewSegmentedCharacters = true;

	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::OnLinesegmentationFixed()
{
	if (!GetDocument()->m_bIsPreprocessed)
	{
		PreprocessImage();
	}
	DIASegmentation * seg;
	seg = new DIASegmentation;
	seg->m_pdoc = GetDocument();
	seg->ComputeFixedWidthLineSegmentation(50);
	delete seg;
	m_bShowLines = true;
	m_bViewSegmentedCharacters = true;
	GetDocument()->m_bIsLineSegmented = true;

	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::OnLinesegmentationFixedwithoutpre()
{
	DIASegmentation * seg;
	seg = new DIASegmentation;
	seg->m_pdoc = GetDocument();
	seg->ComputeFixedWidthLineSegmentation(50);
	delete seg;
	m_bShowLines = true;
	m_bViewSegmentedCharacters = true;
	GetDocument()->m_bIsLineSegmented = true;

	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::OnOcrAddperfectcharforocr()
{
	CDlgPerfectChars2 dlg;

	CImage* pCharImage = new CImage;
	CFileDialog m_FileDialog(TRUE, NULL, NULL, OFN_HIDEREADONLY|OFN_FILEMUSTEXIST, 
		_T("TIFF Files(*.tiff; *.tif)|*.tiff; *.tif|All Files (*.*)|*.*||"));
	if (m_FileDialog.DoModal() == IDOK)
	{
		CString m_pathName = m_FileDialog.GetPathName();
		//deletion of old undo array
		
		pCharImage = ImgLoadFromFile((LPCTSTR)m_pathName, 
			RUNTIME_CLASS(CDIAHiColorImage),
			NULL,
			RUNTIME_CLASS(CDIAGreyScale),
			RUNTIME_CLASS(CDIABiLevelImage));
	}
	CDIACharacter newChar;
	newChar.CreateCharacterFromImage(pCharImage);
	//m_pDoc->m_pLineHolder[iLine].m_pCharacterHolder[iNum].CreateCharImage(m_pDoc->GetActiveImage(),false);
	//m_pDoc->m_pLineHolder[iLine].m_pCharacterHolder[iNum].CreateLocatedCharImage(m_pDoc->m_pLineHolder[iLine].m_pCharacterHolder[iNum].m_pCharImage,true);
	dlg.SetCharacter(&newChar);
	dlg.SetDocument(GetDocument());

	if (IDOK == dlg.DoModal())
	{
		Invalidate(FALSE);
	}
	
}

void CDocImAnView::OnImageCcanalysis()
{
	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	{
		for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
		{
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage->GetImageMap(0)->SetPTVisible(1,true);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage->GetImageMap(0)->SetPTVisible(0,true);
		}
	}
	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}
void CDocImAnView::ExtractCharacterFeatures()
{
	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	{
		for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
		{
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetDocument()->GetUndoImage(GetDocument()->m_index - 2),false);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateLocatedCharImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,true);

			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].ExtractFeatures();
		}
	}
}
void CDocImAnView::OnExportToxmldoc()
{
	CDIAXmlDoc xmlDoc;
	xmlDoc.CreateXmlDoc2(GetDocument());
	


}

void CDocImAnView::OnOcrAddimagestoclassifier()
{
	CDlgPerfectChars2 dlg;
//	if (GetDocument()->m_bIsImageImproved)
//	{
		int i = 0;
		int j = 0;
		dlg.onCancel = false;
		while ((i < GetDocument()->m_LineHolderIndex) && (dlg.onCancel == false))
		{
			j = 0;
			while ((j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex) && (dlg.onCancel == false))
			{

		/*for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{*/

				//
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetDocument()->GetActiveImage(),false);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateLocatedCharImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,true);
				dlg.SetCharacter(&GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j]);
				dlg.SetDocument(GetDocument());

				if (IDOK == dlg.DoModal())
				{
					Invalidate(FALSE);
				}
				//
				/*GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetDocument()->GetActiveImage(),false);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateLocatedCharImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,false);
				
				CDIACharacter newChar;
				newChar.CreateCharacterFromImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage);
				dlg.SetCharacter(&newChar);
				dlg.SetDocument(GetDocument());
				dlg.onCancel = false;

				if (IDOK == dlg.DoModal())
				{
					Invalidate(FALSE);
					if (dlg.onCancel == true)
						break;
				}*/
				j++;
				
			}
		i++;
		}
	//}
}

void CDocImAnView::OnOcrCreateocrtable()
{
	//GetDocument()->ImportCharVectorFromFile();
	//GetDocument()->ImportCharCapitalVectorFromFile();
	GetDocument()->ImportCharVectorFromFile(GetDocument()->m_CharFilePath,GetDocument()->m_pCharVector,GetDocument()->m_CharVectorIndex);
	GetDocument()->ImportCharVectorFromFile(GetDocument()->m_CapitalsFilePath,GetDocument()->m_pCharCapitalVector,GetDocument()->m_CharCapitalVectorIndex);
	GetDocument()->ImportClassifier();
	GetDocument()->ComputeContingencyTable();
	//GetDocument()->TraceFeatureTable();
	GetDocument()->ExportFeatureTable();

}

void CDocImAnView::OnOcrOcrimage()
{
	GetDocument()->ImportCharVectorFromFile(GetDocument()->m_CharFilePath,GetDocument()->m_pCharVector,GetDocument()->m_CharVectorIndex);
	GetDocument()->ImportCharVectorFromFile(GetDocument()->m_CapitalsFilePath,GetDocument()->m_pCharCapitalVector,GetDocument()->m_CharCapitalVectorIndex);
	GetDocument()->ImportClassifier();
	GetDocument()->ComputeContingencyTable();
	//GetDocument()->TraceFeatureTable();
	/*if (!GetDocument()->m_bIsImageImproved)
	{
		FTR();
	}*/
	GetDocument()->RecogniseUsingProbabilities();
}
void CDocImAnView::OnFixedLinesegmentation()
{

	DIASegmentation * seg;
	seg = new DIASegmentation;
	seg->m_pdoc = GetDocument();
	seg->FixedWidthLinesSeg(50);
	//seg->ComputeFixedWidthSegmentation3(50,30);
	GetDocument()->m_bIsLineSegmented = true;
	m_bShowLines = true;
	m_bViewSegmentedCharacters = true;
	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}
void CDocImAnView::OnFixedComplete()
{
	DIASegmentation * seg;
	seg = new DIASegmentation;
	seg->m_pdoc = GetDocument();
	//seg->FixedWidthLinesSeg(50);
	seg->ComputeFixedWidthSegmentation3(50,30);
	GetDocument()->m_bIsLineSegmented = true;
	GetDocument()->m_IsCharSegmented = true;
	m_bViewSegmentedCharacters = true;
	m_bShowLines = true;
	m_bViewIndividualCharacters = true;
	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::OnFiltersLinefinder()
{

	double filterkernel4[7][7]={
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0},
	{0,0,-1667,-1667,-1667,0,0},
	{0,0,3333,3333,3333,0,0},
	{0,0,-1667,-1667,-1667,0,0},
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0}
	};

	int i;	int j;
	for (i=0;i<7;i++)
	{
		for (j=0;j<7;j++)
		{
			m_Kernel4LineDet.Filter[i][j]=filterkernel4[i][j];
		}
	}
	m_Kernel4LineDet.Div=16;
	m_Kernel4LineDet.Size=3;

	GetDocument()->CreateNewUndoImage();

	GetActiveImage()->ApplyFilter(&m_Kernel4LineDet);
	GetActiveImage()->SetDirty(); //otherwise, update will be requested from paint anyway//
	GetDocument()->UpdateAllViews(this,0L,NULL);

	//saving new image in the undo array
	
	Invalidate(FALSE);
	/*private double [][] ker4 = {{-0.1667,-0.1667,-0.1667},{0.3333,0.3333,0.3333},{-0.1667,-0.1667,-0.1667}};
  private double [][] ker2 = {{-0.1667,-0.1667,0.3333},{-0.1667,0.3333,-0.1667},{0.3333,-0.1667,-0.1667}};
  private double [][] ker3 = {{0.3333,-0.1667,-0.1667},{-0.1667,0.3333,-0.1667},{-0.1667,-0.1667,0.3333}};
  private double [][] ker1 = {{-0.1667,0.3333,-0.1667},{-0.1667,0.3333,-0.1667},{-0.1667,0.3333,-0.1667}};*/
}
void CDocImAnView::ApplyAdaptiveHistogramMaxMin()
{
	CDIAHistograms histo;
	//int Full_Character = 25;
	//int BackGround_Percent = 60;
	if (GetDocument()->m_IsCharSegmented == TRUE)//apply to each segmented character
	{
		GetDocument()->CreateNewUndoImage();
		//for each character image...
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				CDIAHistograms histo;
				CRect rect;
				histo.m_pdoc = GetDocument();
				rect.left = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X;
				rect.right = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width-1;
				rect.top = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y;
				rect.bottom = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height-1;

				histo.ComputeHistogram(histo.m_inHistogram,&histo.m_maxvalueInHisto,rect,GetActiveImage());
				histo.CalculateFunction(histo.GetMaximum(),histo.GetMinimum());
				histo.ComputeTransformation(GetActiveImage(),histo.m_pdoc->GetUndoImage(histo.m_pdoc->m_index-1),rect);
			}
		}
	}

}
void CDocImAnView::OnFiltersAdaptivehistotomaxmin()
{
	//CDIAHistograms histo;
	//histo.m_pdoc = GetDocument();
	int index = GetDocument()->m_index;
	CString sReplacementText;
	if (!GetDocument()->m_bIsPreprocessed)
	{
		TRACE(_T("Preprocess Image... \n"));
		sReplacementText = _T("Preprocess Image...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));

		PreprocessImage();
	}
	if(!GetDocument()->m_bIsLineSegmented)
	{
		TRACE(_T("Segmentation: Perform Line Segmentation... \n"));
		//sReplacementText = _T("Segmentation: Performing Line Segmentation...");
		//((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
			
		PerformLineSegmentation(GetActiveImage());

		GetDocument()->m_bIsLineSegmented = true;
	}
	if (!GetDocument()->m_IsCharSegmented)
	{
		DIASegmentation * seg;
		seg = new DIASegmentation;
		seg->m_pdoc = GetDocument();
		//characters are created in computeFixedWidthSegmentation2//
		sReplacementText = _T("Segmentation: Performing Character Segmentation...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Segmentation: Perform Character Segmentation... \n"));

		seg->ComputeFixedWidthSegmentation2(30);

		m_bViewIndividualCharacters = true;
		GetDocument()->m_IsCharSegmented = true;
		//GetDocument()->m_ShowFix = true;
		
		delete seg;
		//delete intermediate images
	}

	if (GetDocument()->m_pUndoImage != NULL)
	{	
		while (GetDocument()->m_index > index)
		{
			delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
			GetDocument()->m_index--;
		}
		SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
	}
	ApplyAdaptiveHistogramMaxMin();
		
	GetActiveImage()->SetDirty(); //otherwise, update will be requested from paint anyway//
	GetDocument()->UpdateAllViews(this,0L,NULL);

	//saving new image in the undo array
	
	Invalidate(FALSE);
}

void CDocImAnView::OnSegmentationLocate4()
{
	//CDIAHistograms histo;
	//histo.m_pdoc = GetDocument();
	int index = GetDocument()->m_index;
	CString sReplacementText;
	if (!GetDocument()->m_bIsPreprocessed)
	{
		TRACE(_T("Preprocess Image... \n"));
		sReplacementText = _T("Preprocess Image...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));

		PreprocessImage();
	}
	if(!GetDocument()->m_bIsLineSegmented)
	{
		TRACE(_T("Segmentation: Perform Line Segmentation... \n"));
		//sReplacementText = _T("Segmentation: Performing Line Segmentation...");
		//((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
			
		PerformLineSegmentation(GetActiveImage());

		GetDocument()->m_bIsLineSegmented = true;
	}
	if (!GetDocument()->m_IsCharSegmented)
	{
		DIASegmentation * seg;
		seg = new DIASegmentation;
		seg->m_pdoc = GetDocument();
		//characters are created in computeFixedWidthSegmentation2//
		sReplacementText = _T("Segmentation: Performing Character Segmentation...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Segmentation: Perform Character Segmentation... \n"));

		seg->ComputeFixedWidthSegmentation2(30);

		m_bViewIndividualCharacters = true;
		GetDocument()->m_IsCharSegmented = true;
		//GetDocument()->m_ShowFix = true;
		
		delete seg;
		//delete intermediate images
	}

	if (GetDocument()->m_pUndoImage != NULL)
	{	
		while (GetDocument()->m_index > index)
		{
			delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
			GetDocument()->m_index--;
		}
		SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
	}
	GetDocument()->CreateNewUndoImage();
	if (!GetDocument()->m_bIsHistoStretched)
	{
		//for each character image...
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				CDIAHistograms histo;
				CRect rect;
				histo.m_pdoc = GetDocument();
				rect.left = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X;
				rect.right = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width-1;
				rect.top = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y;
				rect.bottom = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height-1;

				histo.ComputeHistogram(histo.m_inHistogram,&histo.m_maxvalueInHisto,rect,GetActiveImage());
				histo.CalculateFunction(histo.GetMaximum(),histo.GetMinimum());
				histo.ComputeTransformation(GetActiveImage(),histo.m_pdoc->GetUndoImage(histo.m_pdoc->m_index-1),rect);
			}
		}
			GetDocument()->m_bIsHistoStretched = true;
	}
		

	
	
	int threshold, noise;
	CGetValues dlg;
	if (IDOK == dlg.DoModal())
	{
		threshold = dlg.m_SelectedThreshold;
		noise = dlg.m_SelectedNoise;
		LocateCharacters3(threshold, noise);
		GetDocument()->m_IsCharLocalized = true;
	}
	GetActiveImage()->SetDirty(); //otherwise, update will be requested from paint anyway//
	GetDocument()->UpdateAllViews(this,0L,NULL);

	//saving new image in the undo array
	
	Invalidate(FALSE);
}

void CDocImAnView::OnSegmentationCcbasedlocation()
{
	//CDIAHistograms histo;
	//histo.m_pdoc = GetDocument();
	int index = GetDocument()->m_index;
	CString sReplacementText;
	if (!GetDocument()->m_bIsPreprocessed)
	{
		TRACE(_T("Preprocess Image... \n"));
		sReplacementText = _T("Preprocess Image...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));

		PreprocessImage();
	}
	if(!GetDocument()->m_bIsLineSegmented)
	{
		TRACE(_T("Segmentation: Perform Line Segmentation... \n"));
		//sReplacementText = _T("Segmentation: Performing Line Segmentation...");
		//((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
			
		PerformLineSegmentation(GetActiveImage());

		GetDocument()->m_bIsLineSegmented = true;
	}
	if (!GetDocument()->m_IsCharSegmented)
	{
		DIASegmentation * seg;
		seg = new DIASegmentation;
		seg->m_pdoc = GetDocument();
		//characters are created in computeFixedWidthSegmentation2//
		sReplacementText = _T("Segmentation: Performing Character Segmentation...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Segmentation: Perform Character Segmentation... \n"));

		seg->ComputeFixedWidthSegmentation2(30);

		m_bViewIndividualCharacters = true;
		GetDocument()->m_IsCharSegmented = true;
		//GetDocument()->m_ShowFix = true;
		
		delete seg;
		//delete intermediate images
	}

	if (GetDocument()->m_pUndoImage != NULL)
	{	
		while (GetDocument()->m_index > index)
		{
			delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
			GetDocument()->m_index--;
		}
		SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
	}
	GetDocument()->CreateNewUndoImage();
	if (!GetDocument()->m_bIsHistoStretched)
	{
		//for each character image...
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				CDIAHistograms histo;
				CRect rect;
				histo.m_pdoc = GetDocument();
				rect.left = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X;
				rect.right = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width-1;
				rect.top = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y;
				rect.bottom = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height-1;

				histo.ComputeHistogram(histo.m_inHistogram,&histo.m_maxvalueInHisto,rect,GetActiveImage());
				histo.CalculateFunction(histo.GetMaximum(),histo.GetMinimum());
				histo.ComputeTransformation(GetActiveImage(),histo.m_pdoc->GetUndoImage(histo.m_pdoc->m_index-1),rect);
			}
		}
		GetDocument()->m_bIsHistoStretched = true;
	}
	////cc analysis?

	//for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	//{
	//	for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
	//	{

	//		GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetDocument()->GetActiveImage(),false);
	//		//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateLocatedCharImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,true);
	//		//cc

	//		BYTE PTForeground = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage->GetImageMap(0)->GetPTByteLabel(PT_STR_FOREGROUND);

	//		GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindCC(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,PTForeground);
	//		int cc = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_nComponents;
	//		//holes
	//		BYTE PTBackground = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage->GetImageMap(0)->GetPTByteLabel(PT_STR_BACKGROUND);

	//		GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindCC(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,PTBackground);
	//		int holes = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_nHoles;
	//		GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindConnectedComponentsInChar(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage);
	//		//closed holes
	//	}
	//}


	//for each character image...
	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	{
		for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
		{
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetActiveImage(),false);
			//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage->CCAnalysis(1);
			//int comp = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage->GetMaxComponent();

			//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindConnectedComponentsInChar(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage);

			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindCC(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,1);
		}
	}
	GetDocument()->m_IsCharLocalized = true;
	GetActiveImage()->SetDirty(); //otherwise, update will be requested from paint anyway//
	GetDocument()->UpdateAllViews(this,0L,NULL);

	//saving new image in the undo array
	
	Invalidate(FALSE);
}

void CDocImAnView::OnTextsegmentationMenu()
{
	CDlgDIASegmentation dlg;
	int index = GetDocument()->m_index;
	CString sReplacementText;
	if (IDOK == dlg.DoModal())
	{
		//preprocess
		if (dlg.m_prep == 1)
		{
			if (dlg.m_normal == 1)
			{
				//preprocess normal
				if (!GetDocument()->m_bIsPreprocessed)
				{
					TRACE(_T("Preprocess Image... \n"));
					sReplacementText = _T("Preprocess Image...");
					((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));

					PreprocessImage();

					GetDocument()->m_bIsPreprocessed = true;
				}
			}
			else 
			{
				//preprocess soft
				if (!GetDocument()->m_bIsPreprocessed)
				{
					TRACE(_T("Preprocess Image... \n"));
					sReplacementText = _T("Preprocess Image...");
					((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));

					PreprocessImageSoft();
					GetDocument()->m_bIsPreprocessed = true;
				}
			}
				/*if (GetDocument()->m_pUndoImage != NULL)
				{	
					while (GetDocument()->m_index > index)
					{
						delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
						GetDocument()->m_index--;
					}
					SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
				}*/

		}
		//segment lines
		if (!GetDocument()->m_bIsLineSegmented)
		{
			if (dlg.m_profile)
			{
				//apply profile segmentation
				TRACE(_T("Segmentation: Perform Line Segmentation... \n"));
				PerformLineSegmentation(GetActiveImage());
				GetDocument()->m_bIsLineSegmented = true;
				
			}
			else if (dlg.m_lineFix)
			{
				//apply Fix segmentation
				TRACE(_T("Segmentation: Perform Fix Line Segmentation... \n"));
				DIASegmentation * seg;
				seg = new DIASegmentation;
				seg->m_pdoc = GetDocument();
				seg->ComputeFixedWidthLineSegmentation(50);
				delete seg;
				GetDocument()->m_bIsLineSegmented = true;
			}
			//segment char
			if (!GetDocument()->m_IsCharSegmented)
			{
				if (dlg.m_charSegProfile)
				{
				}
				else 
					if (dlg.m_charSegFix)
					{
						DIASegmentation * seg;
						seg = new DIASegmentation;
						seg->m_pdoc = GetDocument();
						seg->FixedWidthCharsSeg(30);
						delete seg;
						GetDocument()->m_IsCharSegmented = true;

					}
					else
						if (dlg.m_charSegFixFlex)
						{
							DIASegmentation * seg;
							seg = new DIASegmentation;
							seg->m_pdoc = GetDocument();
							//characters are created in computeFixedWidthSegmentation2//
							sReplacementText = _T("Segmentation: Performing Character Segmentation...");
							((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
							TRACE(_T("Segmentation: Perform Character Segmentation... \n"));

							seg->ComputeFixedWidthSegmentation2(30);

							m_bViewIndividualCharacters = true;
							GetDocument()->m_IsCharSegmented = true;
							//GetDocument()->m_ShowFix = true;
							
							delete seg;
						}
				if (GetDocument()->m_bIsPreprocessed)
				{
					if (GetDocument()->m_pUndoImage != NULL)
					{	
						while (GetDocument()->m_index > index)
						{
							delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
							GetDocument()->m_index--;
						}
						SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
					}
					GetDocument()->m_bIsPreprocessed = false;
				}
			}
			if (!GetDocument()->m_IsCharLocalized)
			{
				index = GetDocument()->m_index;
				//char preprocessing
				if (dlg.m_charNone)
				{

				}
				else
				{
					if (dlg.m_charGaussian)
					{
						GetDocument()->CreateNewUndoImage();
						ApplyGaussianFilter(GetActiveImage());
					}
					if (dlg.m_charGlobal)
						{
							//global stretching
							//histogram stretching based on the whole images values
							GetDocument()->CreateNewUndoImage();
							ApplyAdaptiveHistogram();
						}
						else if (dlg.m_charLocal)
						{
							//adaptive stretching
							GetDocument()->CreateNewUndoImage();
							ApplyAdaptiveHistogramMaxMin();
						}
				}
				if (dlg.m_charLoc1)
				{
					//first method used up to now
					LocateCharacters();
					Create2DCharPlot();
				}
				else if (dlg.m_charLoc2)
				{
					//new location method
					int threshold, noise;
					if (dlg.m_charRequestThresh)
					{
						CGetValues dlg;
						if (IDOK == dlg.DoModal())
						{
							threshold = dlg.m_SelectedThreshold;
							noise = dlg.m_SelectedNoise;
							LocateCharacters3(threshold, noise);
							GetDocument()->m_IsCharLocalized = true;
						//	Create2DCharPlot();
							
						}
					}
					else
					{
						threshold = 128;
						noise = 3;
						LocateCharacters3(threshold, noise);
						GetDocument()->m_IsCharLocalized = true;
					//	Create2DCharPlot();
					}
						
				}
				
				if (dlg.m_charClassComp)
				{
					ClassifyCharacters2();
				
					GetDocument()->m_ShowInBox = true;
					sReplacementText = _T("Segmentation: Character Analysis... ");
					((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
					TRACE(_T("Segmentation: Character Analysis... \n"));

					CharacterAnalysis();
					ExtractCharacterFeatures();
				}
				if (dlg.m_char2Dplot)
				{
					CDlgDIAPlot2D dlg2;
					dlg2.SetDocument(GetDocument());
					if (IDOK == dlg2.DoModal())
					{
						if(dlg.m_charSave2Dplot)
						{
							GetDocument()->ExportImagePlot3();
						}
					}
				}


				while (GetDocument()->m_index > index)
				{
					delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
					GetDocument()->m_index--;
				}
		
				
				
			}
			
				
		}
	SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
		//update image
	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
	}

	
}


void CDocImAnView::OnHistogramsBackgroundhistogram()
{
	//if it is not segmented then do it and then get the histogram
	//and substract the values inside teh characters
	int index = GetDocument()->m_index;
	CString sReplacementText;
	if (!GetDocument()->m_bIsPreprocessed)
	{
		TRACE(_T("Preprocess Image... \n"));
		sReplacementText = _T("Preprocess Image...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));

		PreprocessImage();
	}
	if(!GetDocument()->m_bIsLineSegmented)
	{
		TRACE(_T("Segmentation: Perform Line Segmentation... \n"));
		//sReplacementText = _T("Segmentation: Performing Line Segmentation...");
		//((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
			
		PerformLineSegmentation(GetActiveImage());

		GetDocument()->m_bIsLineSegmented = true;
	}
	if (!GetDocument()->m_IsCharSegmented)
	{
		DIASegmentation * seg;
		seg = new DIASegmentation;
		seg->m_pdoc = GetDocument();
		//characters are created in computeFixedWidthSegmentation2//
		sReplacementText = _T("Segmentation: Performing Character Segmentation...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Segmentation: Perform Character Segmentation... \n"));

		seg->ComputeFixedWidthSegmentation2(30);

		m_bViewIndividualCharacters = true;
		GetDocument()->m_IsCharSegmented = true;
		//GetDocument()->m_ShowFix = true;
		
		delete seg;
		//delete intermediate images
	}

	if (GetDocument()->m_pUndoImage != NULL)
	{	
		while (GetDocument()->m_index > index)
		{
			delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
			GetDocument()->m_index--;
		}
		SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
	}
	//image is segmented now then get the histogram and create a copy
	//and substract the characters.
	//CDIAHistograms histo;
	//histo.m_pdoc = GetDocument();	
	//CRect rect(0,0,GetActiveImage()->GetWidth(),GetActiveImage()->GetHeight());
	//histo.ComputeHistogram(histo.m_inHistogram,&histo.m_maxvalueInHisto,rect,histo.m_pdoc->GetActiveImage());
	//for (int i = 0; i < 256; i++)
	//{
	//	histo.m_outHistogram[i] = histo.m_inHistogram[i];
	//	
	//}
	//for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	//{
	//	for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
	//	{
	//		for (int x = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X; x < GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X+ GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Width-1; x++)
	//		{
	//			for (int y = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y; y < GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Height-1; y++)
	//			{
	//				int val  =(int) GetActiveImage()->GetRed(x,y);
	//				histo.m_outHistogram[val]--;
	//			}
	//		}
	//	}
	//}
	////find max val in out histo
	//int max = 0;
	//int maxin = 0;
	//for (int i = 0; i < 256; i++)
	//{
	//	if (histo.m_inHistogram[i] > maxin) maxin = histo.m_inHistogram[i];
	//	if (histo.m_outHistogram[i] > max) max = histo.m_outHistogram[i];
	//}
	//histo.m_maxvalueInHisto = maxin;
	//histo.m_maxvalueOutHisto = max;
	CDlgDIAHistograms dlghisto;

	dlghisto.SetSegmented(GetDocument()->m_IsCharSegmented);
	dlghisto.SetLocalised(GetDocument()->m_IsCharLocalized);

	//dlghisto.SetHisto(histo);
	dlghisto.SetDocument(GetDocument());
	if (IDOK == dlghisto.DoModal())
	{
		GetActiveImage()->SetDirty(); 		
		GetDocument()->UpdateAllViews(this,0L,NULL);
		Invalidate(FALSE);
	}

}

void CDocImAnView::OnCharactersDisplayuncertainareasofimportance()
{
	//if (GetDocument()->m_bIsImageImproved)
	//{
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetActiveImage(),false);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateLocatedCharImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,false);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertValuablePoints();
			}
		}
		m_bShowUncertainAreas = true;
		GetActiveImage()->SetDirty(); 		
		GetDocument()->UpdateAllViews(this,0L,NULL);
		Invalidate(FALSE);
	//}
}

void CDocImAnView::OnViewLocalisedcharacterview()
{
	m_bViewLocatedCharacters = !m_bViewLocatedCharacters;
}

void CDocImAnView::OnUpdateViewLocalisedcharacterview(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bViewLocatedCharacters);
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::OnViewSegmentedcharacterview()
{
	m_bViewSegmentedCharacters = !m_bViewSegmentedCharacters;
}

void CDocImAnView::OnUpdateViewSegmentedcharacterview(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bViewSegmentedCharacters);
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::OnCharactersDisplayuncertainareasnexttoorange()
{
	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetActiveImage(),false);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateLocatedCharImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,false);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertValuablePoints();
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(1);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(100);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(10);
			}
		}
		m_showGreenUncertain = 1;
		m_showPinkUncertain = 1;
		m_showGreypixels = 1;
		m_showOrangeUncertain = 1;
		m_bShowUncertainAreas = true;
		GetActiveImage()->SetDirty(); 		
		GetDocument()->UpdateAllViews(this,0L,NULL);
		Invalidate(FALSE);
}

void CDocImAnView::OnCharactersCleargreenpoints()
{
	m_showGreenUncertain = 0;
	GetActiveImage()->SetDirty(); 		
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::OnPinkpointsClear()
{
	m_showPinkUncertain = 0;
	GetActiveImage()->SetDirty(); 		
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::OnPinkpointsAddtochars()
{
	m_showPinkUncertain = 2;
	GetActiveImage()->SetDirty(); 		
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::OnCleargreenpointsClear()
{
	m_showGreenUncertain = 0;
	GetActiveImage()->SetDirty(); 		
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::OnCleargreenpointsAdd()
{
	m_showGreenUncertain = 2;
	GetActiveImage()->SetDirty(); 		
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::OnCleargreenpointsGreen()
{
	m_showGreenUncertain = 1;
	GetActiveImage()->SetDirty(); 		
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::OnPinkpointsPink()
{
	m_showPinkUncertain = 1;
	GetActiveImage()->SetDirty(); 		
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::OnGreyClear()
{
	m_showGreypixels = 0;
	GetActiveImage()->SetDirty(); 		
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::OnGreyAdd()
{
	m_showGreypixels = 2;
	GetActiveImage()->SetDirty(); 		
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::OnGreyGrey()
{
	m_showGreypixels = 1;
	GetActiveImage()->SetDirty(); 		
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::OnOrangeClear()
{
	m_showOrangeUncertain = 0;
	GetActiveImage()->SetDirty(); 		
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::OnOrangeAdd()
{
	m_showOrangeUncertain = 2;
	GetActiveImage()->SetDirty(); 		
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::OnOrangeOrange()
{
	m_showOrangeUncertain = 1;
	GetActiveImage()->SetDirty(); 		
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::OnCharactersSetuncertainareas()
{
	CDlgSetUncertainAreas dlg;
	int Orange = 1;
	int Pink = 10;
	int Green = 100;
	int Grey = -1;
	int SetToLarge = 0;
	int SetToSmall = 0;
	int ON = 1;
	int OFF = -1;
	int GREY = 0;
	if (IDOK == dlg.DoModal())
	{
		
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				//keep orange as grey
				if (dlg.m_OrangeLargeGREY)
				{	
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertainCC(Orange, Orange + GREY,Orange + GREY);
				}
				//green
				if (dlg.m_GreenLargeOFF)
				{
					SetToLarge = Green + OFF;
				}
				if (dlg.m_GreenLargeON)
				{
					SetToLarge = Green + ON;
				}
				if (dlg.m_GreenSmallOFF)
				{
					SetToSmall = Green + OFF;
				}
				if (dlg.m_GreenSmallON)
				{
					SetToSmall = Green + ON;
				}
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertainCC(Green, SetToSmall,SetToLarge);
			
				
				//Pink
				if (dlg.m_PinkLargeOFF)
				{
					SetToLarge = Pink + OFF;
				}
				if (dlg.m_PinkLargeON)
				{
					SetToLarge = Pink + ON;
				}
				if (dlg.m_PinkSmallOFF)
				{
					SetToSmall = Pink + OFF;
				}
				if (dlg.m_PinkSmallON)
				{
					SetToSmall = Pink + ON;
				}
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertainCC(Pink, SetToSmall,SetToLarge);

			}
		}
		GetActiveImage()->SetDirty(); 		
		GetDocument()->UpdateAllViews(this,0L,NULL);
		Invalidate(FALSE);
	}

}



void CDocImAnView::OnCharactersRefinement()
{
	int Orange = 1;
	int Pink = 10;
	int Green = 100;
	int Grey = -1;
	int SetToLarge = 0;
	int SetToSmall = 0;
	int ON = 1;
	int OFF = -1;
	int GREY = 0;
	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	{
		for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
		{
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetActiveImage(),false);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateLocatedCharImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,false);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertValuablePoints();
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(1);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(100);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(10);

			//Orange
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertainCC(Orange, Orange + GREY,Orange + GREY);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].SetUncertainChanges(Orange, 128);
			//Green
			SetToLarge = Green + ON;
			SetToSmall = Green + OFF;
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertainCC(Green, SetToSmall,SetToLarge);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].SetUncertainChanges(SetToSmall, 255);//small green components will be white
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].SetUncertainChanges(SetToLarge, 0);//large green components will be black

			//Pink
			SetToLarge = Pink + OFF;
			SetToSmall = Pink + ON;
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertainCC(Pink, SetToSmall,SetToLarge);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].SetUncertainChanges(SetToSmall, 0);//small pink components will be black
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].SetUncertainChanges(SetToLarge, 255);//large pink components will be white
		}
	}
	m_showGreenUncertain = 1;
	m_showPinkUncertain = 1;
	m_showGreypixels = 1;
	m_showOrangeUncertain = 1;
	m_bShowUncertainAreas = true;
	GetActiveImage()->SetDirty(); 		
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}
bool CDocImAnView::GetBit(int number,int pos)
{
	int x;
	x = number >> pos;
	return (x & 01);
}
//void CDocImAnView::OnOcrRecogniseusinguncertainareas2()
//{
//	//this method will recognise first normally with the uncertain areas and then for each of the candidate chars ge the lowes cost one.
//
//	int Orange = 1;
//	int Pink = 10;
//	int Green = 100;
//	int Grey = -1;
//	int SetToLarge = 0;
//	int SetToSmall = 0;
//	int ON = 1;
//	int OFF = -1;
//	int GREY = 0;
//
//	int minCost;
//	char minChar;
//
//	int possibilities;
//	int noCCs;
//	int minUncertainSequence;
//	CDlgTestingEnvironment dlg;
//	dlg.SetDocument(GetDocument());
//
//
//	m_showGreenUncertain = 0;
//	m_showPinkUncertain = 0;
//	m_showGreypixels = 0;
//	m_showOrangeUncertain = 0;
//	m_bShowUncertainAreas = false;
//
//	GetDocument()->CreateNewUndoImage(0);
//	GetDocument()->ImportClassifier();
//	//clear the new image as background
//	for (int a = 0; a < GetDocument()->GetUndoImage(GetDocument()->m_index -1)->GetWidth(); a++)
//	{
//		for (int b = 0; b <  GetDocument()->GetUndoImage(GetDocument()->m_index -1)->GetHeight(); b++)
//		{
//			 GetDocument()->GetUndoImage(GetDocument()->m_index -1)->SetRGBColor(a,b,RGB(255,255,255));
//		}
//	}
//	//do the uncertain areas refinement
//	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
//	{
//		for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
//		{
//			//find the uncertain areas and remove others than orange
//			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetDocument()->GetUndoImage(GetDocument()->m_index-2),false);
//			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateLocatedCharImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,false);
//			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertValuablePoints();
//			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(Orange); //orange
//			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(Green);//green
//			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(Pink);//pink
//			
//			
//			//Green
//			SetToLarge = Green + ON;
//			SetToSmall = Green + OFF;
//			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertainCC(Green, SetToSmall,SetToLarge);
//			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].SetUncertainChanges(SetToSmall, 255);//small green components will be white
//			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].SetUncertainChanges(SetToLarge, 0);//large green components will be black
//			//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharUncertainCC;
//			
//			
//			//Pink
//			SetToLarge = Pink + OFF;
//			SetToSmall = Pink + ON;
//			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertainCC(Pink, SetToSmall,SetToLarge);
//			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].SetUncertainChanges(SetToSmall, 0);//small pink components will be black
//			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].SetUncertainChanges(SetToLarge, 255);//large pink components will be white
//
//			//Grey
//			SetToLarge = Grey + OFF;
//			SetToSmall = Grey + ON;
//			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertainCC(Grey, Grey,Grey);
//			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].SetUncertainChanges(Grey, 255);// Grey components will be black
//			//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].SetUncertainChanges(SetToLarge, 255);//Grey components will be black
//
//
//
//			//calculate the number of CC
//			bool val = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertainCC(Orange, Orange + GREY,Orange + GREY);
//			noCCs = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharUncertainCC.GetNoCCs();
//
//			
//			
//			if (noCCs > 0)
//			{
//				//Find how many CC we have and their combinations
//				
//				possibilities = pow(2,noCCs);
//				int number = 0;
//				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages = new CDIACharacter::POSSIBLE_CHARS[possibilities];
//				//create an image with each resulting image
//				for (int x = 0; x < possibilities; x++)
//				{	
//					//create a new possibleChar 
//					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].image = new CDIAGreyScale;
//					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].image->CreateFromImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage);
//					
//					//for each possible state get the value of each CC and set it to it
//					for (int y = 0; y < noCCs; y++)
//					{
//						bool bit = GetBit(number, y);
//						int color;
//						if (bit) color = 0;
//						else color = 255;
//						GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].SetUncertainChangesCC(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].image,Orange, color,y);
//					}
//					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].CCPosition = number;
//					number++;
//				}
//			}
//			else
//			{
//				possibilities = 1;
//				noCCs = 0;
//				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages = new CDIACharacter::POSSIBLE_CHARS[possibilities];
//				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[0].image = new CDIAGreyScale;
//				//create a new possibleChar 
//				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[0].image->CreateFromImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage);
//				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[0].CCPosition = -1;
//
//
//			}
//				//now for each image in m_charPossibleImages get recognition
//				for (int x = 0; x < possibilities; x++)
//				{	
//
//					//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].m_pChar.ExtractFeatures();
//					//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetDocument()->GetUndoImage(GetDocument()->m_index - 2),false);
//					//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].m_pChar.CreateLocatedCharImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].m_pChar.m_pLocatedCharImage,true);
//					//create vector from character
//					
//					CDIACharacter * character;
//					character = new CDIACharacter;
//					character = &GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j];
//					character->m_pLocatedCharImage->CreateFromImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].image,0);
//					//character->CreateCharacterFromImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].image);
//					character->ExtractFeatures();
//					//character = &GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].m_pChar;
//					CCharVector vector;
//					vector.CreateVectorFromCharacter(character);
//					int cost;
//					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].bestChar.charname = dlg.FindBestMatchUsingProbability2(vector, GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].image, 3,cost);
//					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].bestChar.rate = cost;
//
//
//					//
//					
//					//
//
//				}
//				//now we need to choose the best match
//				//we do this by choosing the smallest cost of all.
//				int index = 0;				
//				minCost = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[0].bestChar.rate;
//				minChar = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[0].bestChar.charname;
//				//minUncertainSequence = 
//				CString pathName;
//				pathName.Format(_T("%s\\PossibleChars.txt"),GetDocument()->m_ClassifiedCharsPath);
//				FILE * pFile;
//				pFile = _tfopen(pathName, _T("a"));
//				fprintf(pFile,"Exporting Possible Chars for Line: %d Character: %d\n",i,j);
//				fprintf(pFile,"-----------------------------------------------------------------\n");
//							
//				for (int x = 0; x < possibilities; x++)
//				{
//						//display result of matched chars
//						//text.Format(_T("Char = %c,cost: %d"),bestChars[i].charname,bestChars[i].rate);
//						//m_DetailsList.AddString((LPCTSTR) text);
//
//						//
//						
//							fprintf(pFile," Possible Chars = %c || Cost: %d \n",GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].bestChar.charname,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].bestChar.rate);
//							fprintf(pFile,"-----------------------------------------------------------------\n");
//						
//						//fclose(pFile);
//						//
//						if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].bestChar.rate <= minCost)
//						{
//							minCost = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].bestChar.rate;
//							minChar = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].bestChar.charname;
//							minUncertainSequence = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].CCPosition;
//							index = x;
//						}
//					
//				}
//				fprintf(pFile,"-----------------------------------------------------------------\n");
//				fprintf(pFile," || Recognised Char = %c || Cost: %d ||\n",minChar,minCost);
//				fprintf(pFile,"-----------------------------------------------------------------\n");
//						
//				fclose(pFile);
//
//				CString sReplacementText;
//				sReplacementText.Format( _T("Recognised Character = %c || cost = %d || sequence = %d || Line = %i || Char %i ||\n"),minChar, minCost,minUncertainSequence,i,j);
//				((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
//				//now we know the perfect character and we show it on the screen
//				//dlg.ApplyRecognisedChar(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage, minChar, i, j);
//
//				ApplyNewCharImage(GetActiveImage(), GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[index].image, i,j);
//				//for (int x = 0; x < GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[index].image->GetWidth(); x++)
//				//{
//				//	for (int y = 0; y < GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[index].image->GetHeight(); y++)
//				//	{
//				//		//copy the pixels into the rith position
//				//		int xPos,yPos;
//				//		xPos = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left + x;
//				//		yPos = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top + y;
//				//		int color = (int) GetRValue(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[index].image->GetRGBColor(x,y));
//				//		GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage->SetRGBColor(xPos,yPos,RGB(color,color,color));
//				//		
//				//	}
//				//}
//
//				GetActiveImage()->SetDirty(); 		
//				GetDocument()->UpdateAllViews(this,0L,NULL);
//				Invalidate(FALSE);
//			//}
//			//else
//			//{
//			//	//no orange areas have been found
//
//			//}
//		}
//	}
//
//	GetActiveImage()->SetDirty(); 		
//	GetDocument()->UpdateAllViews(this,0L,NULL);
//	Invalidate(FALSE);
//}
void CDocImAnView::OnOcrRecogniseusinguncertainareas()
{
	int Orange = 1;
	int Pink = 10;
	int Green = 100;
	int Grey = -1;
	int SetToLarge = 0;
	int SetToSmall = 0;
	int ON = 1;
	int OFF = -1;
	int GREY = 0;

	int minCost;
	char minChar;

	int possibilities = 0;
	int noCCs;
	int minUncertainSequence;
	CDlgTestingEnvironment dlg;
	dlg.SetDocument(GetDocument());


	m_showGreenUncertain = 0;
	m_showPinkUncertain = 0;
	m_showGreypixels = 0;
	m_showOrangeUncertain = 0;
	m_bShowUncertainAreas = false;

	GetDocument()->CreateNewUndoImage(0);
	GetDocument()->ImportClassifier();

	FILE * pFileText;
	CString pathNameText;
	pathNameText.Format(_T("%s-Refined-1-Recognised.txt"),GetDocument()->GetActiveImage()->GetName());
	pFileText = _tfopen(pathNameText, _T("w"));

	for (int a = 0; a < GetDocument()->GetUndoImage(GetDocument()->m_index -1)->GetWidth(); a++)
	{
		for (int b = 0; b <  GetDocument()->GetUndoImage(GetDocument()->m_index -1)->GetHeight(); b++)
		{
			 GetDocument()->GetUndoImage(GetDocument()->m_index -1)->SetRGBColor(a,b,RGB(255,255,255));
		}
	}

	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	{
		for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
		{
			//find the uncertain areas and remove others than orange
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetDocument()->GetUndoImage(GetDocument()->m_index-2),false);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateLocatedCharImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,false);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertValuablePoints();
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(Orange); //orange
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(Green);//green
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(Pink);//pink
			
			
			//Green
			SetToLarge = Green + ON;
			SetToSmall = Green + OFF;
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertainCC(Green, SetToSmall,SetToLarge);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].SetUncertainChanges(SetToSmall, 255);//small green components will be white
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].SetUncertainChanges(SetToLarge, 0);//large green components will be black
			//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharUncertainCC;
			
			
			//Pink
			SetToLarge = Pink + OFF;
			SetToSmall = Pink + ON;
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertainCC(Pink, SetToSmall,SetToLarge);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].SetUncertainChanges(SetToSmall, 0);//small pink components will be black
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].SetUncertainChanges(SetToLarge, 255);//large pink components will be white

			//Grey
			SetToLarge = Grey + OFF;
			SetToSmall = Grey + ON;
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertainCC(Grey, Grey,Grey);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].SetUncertainChanges(Grey, 255);// Grey components will be black
			//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].SetUncertainChanges(SetToLarge, 255);//Grey components will be black




			bool val = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertainCC(Orange, Orange + GREY,Orange + GREY);
			noCCs = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharUncertainCC.GetNoCCs();

			
			if (noCCs > 0)
			{
				//Find how many CC we have and their combinations
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_PossibleChars =pow((double)2,noCCs);
				possibilities = pow((double)2,noCCs);
				int number = 0;
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages = new CDIACharacter::POSSIBLE_CHARS[possibilities];
				//create an image with each resulting image
				for (int x = 0; x < possibilities; x++)
				{	
					//create a new possibleChar 
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].image = new CDIAGreyScale;
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].image->CreateFromImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage);
					
					//for each possible state get the value of each CC and set it to it
					for (int y = 0; y < noCCs; y++)
					{
						bool bit = GetBit(number, y);
						int color;
						if (bit) color = 0;
						else color = 255;
						GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].SetUncertainChangesCC(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].image,Orange, color,y);
					}
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].CCPosition = number;
					number++;
				}
			}
			else
			{
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_PossibleChars = 1;
				possibilities = 1;
				noCCs = 0;
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages = new CDIACharacter::POSSIBLE_CHARS[possibilities];
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[0].image = new CDIAGreyScale;
				//create a new possibleChar 
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[0].image->CreateFromImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[0].CCPosition = -1;


			}
				//now for each image in m_charPossibleImages get recognition
				for (int x = 0; x < possibilities; x++)
				{	

					//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].m_pChar.ExtractFeatures();
					//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetDocument()->GetUndoImage(GetDocument()->m_index - 2),false);
					//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].m_pChar.CreateLocatedCharImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].m_pChar.m_pLocatedCharImage,true);
					//create vector from character
					
					CDIACharacter * character;
					character = new CDIACharacter;
					character = &GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j];
					character->m_pLocatedCharImage->CreateFromImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].image,0);
					//character->CreateCharacterFromImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].image);
					character->ExtractFeatures();
					//character = &GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].m_pChar;
					CCharVector vector;
					vector.CreateVectorFromCharacter(character);
					int cost;
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].bestChar.charname = dlg.FindBestMatchUsingProbability2(vector, GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].image, 2,cost);
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].bestChar.rate = cost;


				}
				//now we need to choose the best match
				//we do this by choosing the smallest cost of all.
				int index = 0;				
				minCost = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[0].bestChar.rate;
				minChar = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[0].bestChar.charname;
				//minUncertainSequence = 
				CString pathName;
				pathName.Format(_T("%sRefined-1-PossibleChars.txt"),GetDocument()->GetActiveImage()->GetName());
				FILE * pFile;
				pFile = _tfopen(pathName, _T("a"));
				fprintf(pFile,"Exporting Possible Chars for Line: %d Character: %d\n",i,j);
				fprintf(pFile,"-----------------------------------------------------------------\n");
							
				for (int x = 0; x < possibilities; x++)
				{
				
					int intcost = (int)GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].bestChar.rate;
					fprintf(pFile," Possible Chars = %c || Cost: %d \n",GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].bestChar.charname,intcost);
					fprintf(pFile,"-----------------------------------------------------------------\n");
						
					
					if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].bestChar.rate <= minCost)
					{
						minCost = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].bestChar.rate;
						minChar = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].bestChar.charname;
						minUncertainSequence = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].CCPosition;
						index = x;
					}
					
				}
				fprintf(pFile,"-----------------------------------------------------------------\n");
				fprintf(pFile," || Recognised Char = %c || Cost: %d ||\n",minChar,minCost);
				fprintf(pFile,"-----------------------------------------------------------------\n");
				//modify minchar to the new Values
				char newMinChar;
				if (minChar == '~') newMinChar = '"';
				else if (minChar == '$') newMinChar = ',';
				else if (minChar == '^') newMinChar = '.';
				else if (minChar == '#') newMinChar = ':';
				else newMinChar = minChar;
				//find the distance to the previus character
				if (j == 0)//it is the first character
				{
					fprintf(pFileText,"%c",newMinChar);
				}else
				{
					//find the center of the previous character in the charholder
					int value = j-1;
					 if (abs(((GetDocument()->m_pLineHolder[i].m_pCharacterHolder[value].m_CharCenter.x + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[value].m_Position_X )- (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X))) < 40)
					 {
						 //it is the next character
						 fprintf(pFileText,"%c",newMinChar);
					 }
					 else
					 {
						 //There is a space between them
						 //find how many spaces
						int distance = abs((GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j-1].m_CharCenter.x + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j-1].m_Position_X) - (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X));
						int newdistance = (float)distance/35.00;
						for (int z = 0; z < newdistance; z++)
						{
							fprintf(pFileText," ");
						}
						 fprintf(pFileText,"%c",newMinChar);
					 }
				}	
				fclose(pFile);

				CString sReplacementText;
				sReplacementText.Format( _T("Recognised Character = %c || cost = %d || sequence = %d || Line = %i || Char %i ||\n"),minChar, minCost,minUncertainSequence,i,j);
				((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
				//now we know the perfect character and we show it on the screen
				//dlg.ApplyRecognisedChar(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage, minChar, i, j);


				//store Statistics
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Refined1Char.charName = minChar;
				//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_FTRChar.isBlue = confident;


				ApplyNewCharImage(GetActiveImage(), GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[index].image, i,j);
				//for (int x = 0; x < GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[index].image->GetWidth(); x++)
				//{
				//	for (int y = 0; y < GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[index].image->GetHeight(); y++)
				//	{
				//		//copy the pixels into the rith position
				//		int xPos,yPos;
				//		xPos = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left + x;
				//		yPos = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top + y;
				//		int color = (int) GetRValue(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[index].image->GetRGBColor(x,y));
				//		GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage->SetRGBColor(xPos,yPos,RGB(color,color,color));
				//		
				//	}
				//}

				GetActiveImage()->SetDirty(); 		
				GetDocument()->UpdateAllViews(this,0L,NULL);
				Invalidate(FALSE);
			//}
			//else
			//{
			//	//no orange areas have been found

			//}
		}
		fprintf(pFileText,"\n");

	}
	//delete possible images
	/*for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	{
		for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
		{
			for (int x = 0; x < GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_PossibleChars; x++)
			{	

				delete GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].image;
				delete GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages;

			}
		}
	}*/
	fclose(pFileText);
	GetActiveImage()->SetDirty(); 		
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}
void CDocImAnView::ApplyNewCharImage(CImage *Outimage, CImage * charImage, int LinePos, int CharPos)
{
			int base = CalculateAverageBase(LinePos);
			for (int x = 0; x < charImage->GetWidth(); x++)
			{
				for (int y = 0; y < charImage->GetHeight(); y++)
				{
					////copy the pixels into the right position
					///*int xPos,yPos;
					//xPos = GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Position_X + GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharLocation.left + x;
					//yPos = GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Position_Y + base - GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharLocation.Height() + y;
					//int color = (int) GetRValue(charImage->GetRGBColor(x,y));
					//Outimage->SetRGBColor(xPos,yPos,RGB(color,color,color));*/
					//int xPos,yPos;
					//if ((GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharFinalType != 2) && (GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharFinalType != 4))
					//{
					//	yPos = GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Position_Y + base - GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharLocation.Height() + y;
					//}else
					//{
					//	yPos = GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Position_Y + GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharLocation.top + y;
					//}
					////move to the center of the character box
					//int left;
					//left = (int)GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Position_X + ((float)GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Width/2) - (GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharLocation.Width()/2);
					//xPos = left + x;
					////xPos = GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Position_X + GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharLocation.left + x;
					//int color = (int) GetRValue(charImage->GetRGBColor(x,y));
					//Outimage->SetRGBColor(xPos,yPos,RGB(color,color,color));
				
					int xPos,yPos;
					if ((GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharFinalType != 2) && (GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharFinalType != 4))
					{
						//yPos = GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Position_Y + base - charImage->GetHeight() + y;
						yPos = GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Position_Y + GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharLocation.top + y;
						//yPos = GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Position_Y + base - GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharLocation.Height() + y;
					}else
					{
						yPos = GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Position_Y + GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharLocation.top + y;
					}
					//move to the center of the character box
					int left;
					left = (int)GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Position_X + ((float)GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Width/2) - (charImage->GetWidth()/2);
					xPos = left + x;
					//yPos = GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_Position_Y + GetDocument()->m_pLineHolder[LinePos].m_pCharacterHolder[CharPos].m_CharLocation.top + y;
					int color = (int) GetRValue(charImage->GetRGBColor(x,y));
					Outimage->SetRGBColor(xPos,yPos,RGB(color,color,color));
							
					
				}
			}

		
			
}
int CDocImAnView::CalculateAverageBase(int line)
{
	int average = 0;
	int count = 0;
	//get all short and tall chars of the line and calculate the average of their bottom location
	for (int i = 0; i < GetDocument()->m_pLineHolder[line].m_CharacterHolderIndex; i++)
	{
		int type = GetDocument()->m_pLineHolder[line].m_pCharacterHolder[i].m_CharFinalType;
		if ((type == 1) || (type == 0))//it is short or tall then add to average
		{
			int bottom = GetDocument()->m_pLineHolder[line].m_pCharacterHolder[i].m_CharLocation.bottom;
			average = average + bottom;
			count++;
		}
	}
	return (int)((float)average /(float) count);
}
void CDocImAnView::OnExportCharactersizes()
{

	FILE * pFile;
	CString FilePath;
	FilePath.Format(_T("%sCharacterSizes.txt"),GetDocument()->m_ExportedCharsPath);
	pFile = _tfopen(FilePath, _T("w"));
	if (GetDocument()->m_LineHolderIndex > 0)
	{
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			if (GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex > 0)
			{
				for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
				{
					fprintf(pFile,"%i\t%i\n",GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_LocatedWidth,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_LocatedHeight);
				}
			}
		}

	}
	fclose(pFile);

}

void CDocImAnView::OnOcrRecognise()
{
	int Orange = 1;
	int Pink = 10;
	int Green = 100;
	int Grey = -1;
	int SetToLarge = 0;
	int SetToSmall = 0;
	int ON = 1;
	int OFF = -1;
	int GREY = 0;

	int minCost;
	char minChar;

	int possibilities;
	int noCCs;
	int minUncertainSequence;
	CDlgTestingEnvironment dlg;
	dlg.SetDocument(GetDocument());


	m_showGreenUncertain = 0;
	m_showPinkUncertain = 0;
	m_showGreypixels = 0;
	m_showOrangeUncertain = 0;
	m_bShowUncertainAreas = false;
	GetDocument()->CreateNewUndoImage(0);
	//GetDocument()->CreateNewUndoImage(0);
	GetDocument()->ImportClassifier();

	/*int textLine, characterPos;
	textLine = 0;*/

	FILE * pFileText;
	CString pathNameText;
	pathNameText.Format(_T("%s-Refined-2-Recognised.txt"),GetDocument()->GetActiveImage()->GetName());
	pFileText = _tfopen(pathNameText, _T("w"));
	//create a new image to paste the recognition results
	/*CImage * recognisedImage;
	recognisedImage = new CImage;
	recognisedImage->CreateFromImage(GetDocument()->GetUndoImage(GetDocument()->m_index-1));*/


	for (int a = 0; a < GetDocument()->GetUndoImage(GetDocument()->m_index -1)->GetWidth(); a++)
	{
		for (int b = 0; b <  GetDocument()->GetUndoImage(GetDocument()->m_index -1)->GetHeight(); b++)
		{
			 GetDocument()->GetUndoImage(GetDocument()->m_index -1)->SetRGBColor(a,b,RGB(255,255,255));
			// GetDocument()->GetUndoImage(GetDocument()->m_index -2)->SetRGBColor(a,b,RGB(255,255,255));
			 //recognisedImage->SetRGBColor(a,b,RGB(255,255,255));
		}
	}

	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	{
		for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
		{
			//find the uncertain areas and remove others than orange
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetDocument()->GetUndoImage(GetDocument()->m_index-2),false);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateLocatedCharImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,false);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertValuablePoints();
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(Orange); //orange
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(Green);//green
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(Pink);//pink
			
			
			//Green
			SetToLarge = Green + ON;
			SetToSmall = Green + OFF;
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertainCC(Green, SetToSmall,SetToLarge);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].SetUncertainChanges(SetToSmall, 255);//small green components will be white
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].SetUncertainChanges(SetToLarge, 0);//large green components will be black
			//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharUncertainCC;
			
			
			//Pink
			SetToLarge = Pink + OFF;
			SetToSmall = Pink + ON;
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertainCC(Pink, SetToSmall,SetToLarge);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].SetUncertainChanges(SetToSmall, 0);//small pink components will be black
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].SetUncertainChanges(SetToLarge, 255);//large pink components will be white

			//Grey
			SetToLarge = Grey + OFF;
			SetToSmall = Grey + ON;
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertainCC(Grey, Grey,Grey);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].SetUncertainChanges(Grey, 255);// Grey components will be black
			//GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].SetUncertainChanges(SetToLarge, 255);//Grey components will be black




			bool val = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertainCC(Orange, Orange + GREY,Orange + GREY);
			noCCs = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharUncertainCC.GetNoCCs();

			
			//recognise the character first
			int level = 1;
			bool confident;
			char bestChar;
			int cost;
			//CDIACharacter * character;
			//character = new CDIACharacter;
			//character = &GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j];
			//CCharVector vector;
			//vector.CreateVectorFromCharacter(character);

			////
			CDIACharacter * character;
			character = new CDIACharacter;
			character = &GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j];
			//character->m_pLocatedCharImage->CreateFromImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage,0);
			//character->CreateCharacterFromImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].image);
			character->ExtractFeatures();
			//character = &GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].m_pChar;
			CCharVector vector;
			vector.CreateVectorFromCharacter(character);

			bestChar = dlg.FindBestMatchUsingProbability(vector, GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage, level, confident, cost);
			


			if (noCCs > 0)
			{
				//Find how many CC we have and their combinations
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_PossibleChars = pow((double)2,noCCs);
				possibilities = pow((double)2,noCCs);
				int number = 0;
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages = new CDIACharacter::POSSIBLE_CHARS[possibilities];
				//create an image with each resulting image
				for (int x = 0; x < possibilities; x++)
				{	
					//create a new possibleChar 
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].image = new CDIAGreyScale;
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].image->CreateFromImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage);
					
					//for each possible state get the value of each CC and set it to it
					for (int y = 0; y < noCCs; y++)
					{
						bool bit = GetBit(number, y);
						int color;
						if (bit) color = 0;
						else color = 255;
						GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].SetUncertainChangesCC(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].image,Orange, color,y);
					}
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].CCPosition = number;
					number++;
				}
			}
			else
			{

				//
				/*minChar = bestChar;
				minCost = cost;*/
				possibilities = 1;
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_PossibleChars = 1;
				noCCs = 0;
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages = new CDIACharacter::POSSIBLE_CHARS[possibilities];
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[0].image = new CDIAGreyScale;
				//create a new possibleChar 
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[0].image->CreateFromImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[0].CCPosition = -1;
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[0].bestChar.charname = bestChar;
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[0].bestChar.rate = cost;


			}
				//open the template image recognised to match to the candidates
				CString ImagePath;
				ImagePath = dlg.FindAddress3(bestChar);
				CImage* loadedImage;
				loadedImage = ImgLoadFromFile((LPCTSTR)ImagePath, 
				RUNTIME_CLASS(CDIAHiColorImage),
				NULL,
				RUNTIME_CLASS(CDIAGreyScale),
				RUNTIME_CLASS(CDIABiLevelImage));

				//now for each image in m_charPossibleImages get recognition
				for (int x = 0; x < possibilities; x++)
				{	

					int cost;
					cost = GetDocument()->CompareImageInVectorWeight(loadedImage,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].image);
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].bestChar.charname = bestChar;
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].bestChar.rate = cost;

				}

				//now we need to choose the best match
				//we do this by choosing the smallest cost of all.
				int index = 0;				
				minCost = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[0].bestChar.rate;
				minChar = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[0].bestChar.charname;
				//minUncertainSequence = 
				CString pathName;
				pathName.Format(_T("%sRefined-2-PossibleChars.txt"),GetDocument()->GetActiveImage()->GetName());
				FILE * pFile;
				pFile = _tfopen(pathName, _T("a"));
				
				

				fprintf(pFile,"Exporting Possible Chars for Line: %d Character: %d\n",i,j);
				fprintf(pFile,"-----------------------------------------------------------------\n");
							
				for (int x = 0; x < possibilities; x++)
				{
						//display result of matched chars
						
							int intcost = (int)GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].bestChar.rate;
							fprintf(pFile," Possible Chars = %c || Cost: %d \n",GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].bestChar.charname,intcost);
							fprintf(pFile,"-----------------------------------------------------------------\n");
						
						
						if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].bestChar.rate <= minCost)
						{
							minCost = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].bestChar.rate;
							minChar = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].bestChar.charname;
							minUncertainSequence = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].CCPosition;
							index = x;
						}
					
				}
				fprintf(pFile,"-----------------------------------------------------------------\n");
				fprintf(pFile," || Recognised Char = %c || Cost: %d ||\n",minChar,minCost);
				fprintf(pFile,"-----------------------------------------------------------------\n");
				//modify minchar to the new Values
				char newMinChar;
				if (minChar == '~') newMinChar = '"';
				else if (minChar == '$') newMinChar = ',';
				else if (minChar == '^') newMinChar = '.';
				else if (minChar == '#') newMinChar = ':';
				else newMinChar = minChar;
				//find the distance to the previus character
				if (j == 0)//it is the first character
				{
					fprintf(pFileText,"%c",newMinChar);
				}else
				{
					//find the center of the previous character in the charholder
					int value = j-1;
					 if (abs(((GetDocument()->m_pLineHolder[i].m_pCharacterHolder[value].m_CharCenter.x + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[value].m_Position_X )- (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X))) < 40)
					 {
						 //it is the next character
						 fprintf(pFileText,"%c",newMinChar);
					 }
					 else
					 {
						 //There is a space between them
						 //find how many spaces
						int distance = abs((GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j-1].m_CharCenter.x + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j-1].m_Position_X) - (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X));
						int newdistance = (float)distance/35.00;
						for (int z = 0; z < newdistance; z++)
						{
							fprintf(pFileText," ");
						}
						 fprintf(pFileText,"%c",newMinChar);
					 }
				}

				////paste the recognised character into the recognised image.
				////CString ImagePath;
				//ImagePath = dlg.FindAddress3(minChar);
				////CImage* loadedImage;
				//loadedImage = ImgLoadFromFile((LPCTSTR)ImagePath, 
				//RUNTIME_CLASS(CDIAHiColorImage),
				//NULL,
				//RUNTIME_CLASS(CDIAGreyScale),
				//RUNTIME_CLASS(CDIABiLevelImage));
				//ApplyNewCharImage(GetDocument()->GetUndoImage(GetDocument()->m_index-2), loadedImage, i,j);

				////

				fclose(pFile);

				CString sReplacementText;
				sReplacementText.Format( _T("Recognised Character = %c || cost = %d || sequence = %d || Line = %i || Char %i ||\n"),minChar, minCost,minUncertainSequence,i,j);
				((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
				//now we know the perfect character and we show it on the screen
				//dlg.ApplyRecognisedChar(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage, minChar, i, j);


				//Store Statistics
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Refined2Char.charName = minChar;

				ApplyNewCharImage(GetActiveImage(), GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[index].image, i,j);
				//for (int x = 0; x < GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[index].image->GetWidth(); x++)
				//{
				//	for (int y = 0; y < GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[index].image->GetHeight(); y++)
				//	{
				//		//copy the pixels into the rith position
				//		int xPos,yPos;
				//		xPos = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left + x;
				//		yPos = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top + y;
				//		int color = (int) GetRValue(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[index].image->GetRGBColor(x,y));
				//		GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pLocatedCharImage->SetRGBColor(xPos,yPos,RGB(color,color,color));
				//		
				//	}
				//}

				GetActiveImage()->SetDirty(); 		
				GetDocument()->UpdateAllViews(this,0L,NULL);
				Invalidate(FALSE);
			//}
			//else
			//{
			//	//no orange areas have been found

			//}
		}
		fprintf(pFileText,"\n");

	}
	fclose(pFileText);
	//delete the images
	/*for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	{
		for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
		{
			for (int x = 0; x < GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_PossibleChars; x++)
			{	

				delete GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages[x].image;
				delete GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharPossibleImages;

			}
		}
	}*/
	GetActiveImage()->SetDirty(); 
	
	//GetDocument()->Exportimage(recognisedImage,imagename,GetDocument()->GetActiveImage()->GetName());
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
}

void CDocImAnView::OnOcrFullrecovery()
{
	//in this function a set of image will be FTR, recognised, refined and recognised in both ways.
	//open the file that contains the paths and names of the images
	FILE * pFile;
	
	

	CString filePath;
	CString imagePath;
	filePath.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Thesis\\Results\\Results.txt"));
	if (_tfopen(filePath, _T("r")))
	{
		pFile = _tfopen(filePath, _T("r"));	
		int count;
		fscanf(pFile,"%d\n",&count);
		int n_Images = count;
		ImportCorrectCharStats();
		ImportWrongCharStats();
		GetDocument()->ImportClassifier();

		CDlgTestingEnvironment dlg;
		dlg.SetDocument(GetDocument());
		//for each image in the file, do full recognition
		for (int i = 0; i < n_Images; i++)
		{
			GetDocument()->OnNewDocument();
			imagePath.Empty();
			char val = '0';
			int num = 0;
			while (val != '\n')
			{
				fscanf(pFile,"%c", &val);
				
				if (val != '\n')
				{
					imagePath  = imagePath + val;
					num++;
					
				}
			}

			CImage* loadedImage;
			loadedImage = ImgLoadFromFile((LPCTSTR)imagePath, 
			RUNTIME_CLASS(CDIAHiColorImage),
			NULL,
			RUNTIME_CLASS(CDIAGreyScale),
			RUNTIME_CLASS(CDIABiLevelImage));
			GetDocument()->SetActiveImage(loadedImage);
			GetDocument()->CreateNewUndoImage(0);

			//improve the image FTR
			FTR2();

			//save this image
			CString FTRName;
			FTRName.Format(_T("FTR"));
			GetDocument()->Exportimage(GetDocument()->GetActiveImage(),FTRName,GetDocument()->GetActiveImage()->GetName());
			//FTRName.Format(_T("%sFTR.tif"),GetDocument()->GetActiveImage()->GetName());
			//GetDocument()->GetActiveImage()->SetName(FTRName);
			//now recognise this image and save it
			int index; 
			index = GetDocument()->m_index;
			GetDocument()->CreateNewUndoImage(0);
			GetDocument()->ImportClassifier();
			dlg.PerformProbabilityRecognition(6,1);

			ImportGroundTruthImage();
			//add FTR statistics (they are done inside
			ComputeRecognitionStatisticsFTR();
			
			FTRName.Format(_T("FTR-Recognised"));
			GetDocument()->Exportimage(GetDocument()->GetActiveImage(),FTRName,GetDocument()->GetActiveImage()->GetName());
		//	in this function the recognised.txt and possible characters.txt are exported

			GetActiveImage()->SetDirty(); 
			GetDocument()->UpdateAllViews(this,0L,NULL);
			//-----------------------------------------
			//open FTR image and refine it - method 1 -
			if (GetDocument()->m_pUndoImage != NULL)
			{	
				while (GetDocument()->m_index > index)
				{
					delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
					GetDocument()->m_index--;
				}
				SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
			}
			
			GetActiveImage()->SetDirty(); 
			GetDocument()->UpdateAllViews(this,0L,NULL);

			//refine1--
			//----------------------------------
			//OnOcrRecogniseusinguncertainareas();
			//ComputeRecognitionStatisticsRefined1();
			//GetActiveImage()->SetDirty(); 
			//GetDocument()->UpdateAllViews(this,0L,NULL);
			//export the refined image1 
			//CString Refined1Name;
			//Refined1Name.Format(_T("Refined-1"));
			//GetDocument()->Exportimage(GetDocument()->GetActiveImage(),Refined1Name,GetDocument()->GetActiveImage()->GetName());
			
		
			/*if (GetDocument()->m_pUndoImage != NULL)
			{	
				while (GetDocument()->m_index > index)
				{
					delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
					GetDocument()->m_index--;
				}
				SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
			}*/
			
			
			//refine2--
			OnOcrRecognise();
			ComputeRecognitionStatisticsRefined2();
			GetActiveImage()->SetDirty(); 
			GetDocument()->UpdateAllViews(this,0L,NULL);
			//export the refined image1 
			CString Refined2Name;
			
			Refined2Name.Format(_T("Refined-2"));
			GetDocument()->Exportimage(GetDocument()->GetActiveImage(),Refined2Name,GetDocument()->GetActiveImage()->GetName());
			
			ExportStatistics2();
			ExportStatistics();
			if (GetDocument()->m_pUndoImage != NULL)
			{	
				while (GetDocument()->m_index > index)
				{
					delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
					GetDocument()->m_index--;
				}
				SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
			}
			
		//	ExportWrongCharStats();
			//ExportCorrectCharStats();
			
		}
	}

	fclose(pFile);
}


void CDocImAnView::ComputeRecognitionStatisticsFTR()
{
	//for each character in the recognised image
	if (GetDocument()->m_ImportedGroundTruth)
	{
		GetDocument()->m_IsFTRStatistics = true;
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_FTRChar.charName == '')
				{
					//stop here
					GetDocument()->m_FTR_Statistics.total_correct;
				}
				GetDocument()->m_FTR_Statistics.total_chars++;
				if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Groundtruthchar == '@')
				{
					//if it is noise
					GetDocument()->m_FTR_Statistics.total_noise++;
				}
				else
				{
					if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_FTRChar.charName == GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Groundtruthchar)
					{	//is correct
						AddCorrectCharStats(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Groundtruthchar, true);
						GetDocument()->m_FTR_Statistics.total_correct++;
						
						if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_FTRChar.isBlue)
						{
							GetDocument()->m_FTR_Statistics.correct_in_blue++;
						}
						else
						{
							GetDocument()->m_FTR_Statistics.correct_in_red++;
						}
					}
					else //it is misrecognised
					{
						GetDocument()->m_FTR_Statistics.total_incorrect++;

						//add it to the wrong_Chars_Stats
						AddWrongCharStat(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Groundtruthchar,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_FTRChar.charName);
						AddCorrectCharStats(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Groundtruthchar, false);
						if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_FTRChar.isBlue)
						{
							GetDocument()->m_FTR_Statistics.incorrect_in_blue++;
							if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_FTRChar.secondCharName == GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Groundtruthchar)
							{
								GetDocument()->m_FTR_Statistics.incorrect_but_second++;
							}
							
						}
						else
						{
							GetDocument()->m_FTR_Statistics.incorrect_in_red++;
							if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_FTRChar.secondCharName == GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Groundtruthchar)
							{
								GetDocument()->m_FTR_Statistics.incorrect_but_second++;
							}
						}
					}
				}


				
			}
		}
	}
}

void CDocImAnView::ComputeRecognitionStatisticsRefined1()
{
	//for each character in the recognised image
	if (GetDocument()->m_ImportedGroundTruth)
	{
		GetDocument()->m_IsRefined1Statistics = true;
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				GetDocument()->m_Refined1_Statistics.total_chars++;
				if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Groundtruthchar == '@')
				{
					//if it is noise
					GetDocument()->m_Refined1_Statistics.total_noise++;
				}
				else
				{
					if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Refined1Char.charName == GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Groundtruthchar)
					{	
						GetDocument()->m_Refined1_Statistics.total_correct++;
						if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Refined1Char.isBlue)
						{
							GetDocument()->m_Refined1_Statistics.correct_in_blue++;
						}
						else
						{
							GetDocument()->m_Refined1_Statistics.correct_in_red++;
						}
					}
					else
					{
						GetDocument()->m_Refined1_Statistics.total_incorrect++;
						if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Refined1Char.isBlue)
						{
							GetDocument()->m_Refined1_Statistics.incorrect_in_blue++;
							if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Refined1Char.secondCharName == GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Groundtruthchar)
							{
								GetDocument()->m_Refined1_Statistics.incorrect_but_second++;
							}
						}
						else
						{
							GetDocument()->m_Refined1_Statistics.incorrect_in_red++;
						}
					}
				}


				
			}
		}
	}
}
void CDocImAnView::ComputeRecognitionStatisticsRefined2()
{
	//for each character in the recognised image
	if (GetDocument()->m_ImportedGroundTruth)
	{
		GetDocument()->m_IsRefined2Statistics = true;
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				GetDocument()->m_Refined2_Statistics.total_chars++;
				if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Groundtruthchar == '@')
				{
					//if it is noise
					GetDocument()->m_Refined2_Statistics.total_noise++;
				}
				else
				{
					if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Refined2Char.charName == GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Groundtruthchar)
					{	
						GetDocument()->m_Refined2_Statistics.total_correct++;
						if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Refined2Char.isBlue)
						{
							GetDocument()->m_Refined2_Statistics.correct_in_blue++;
						}
						else
						{
							GetDocument()->m_Refined2_Statistics.correct_in_red++;
						}
					}
					else
					{
						GetDocument()->m_Refined2_Statistics.total_incorrect++;
						if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Refined2Char.isBlue)
						{
							GetDocument()->m_Refined2_Statistics.incorrect_in_blue++;
							if (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Refined2Char.secondCharName == GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Groundtruthchar)
							{
								GetDocument()->m_Refined2_Statistics.incorrect_but_second++;
							}
						}
						else
						{
							GetDocument()->m_Refined2_Statistics.incorrect_in_red++;
						}
					}
				}

			}
		}
	}
}
void CDocImAnView::ExportStatistics()
{
	FILE * pFileText;
	CString pathNameText;
	pathNameText.Format(_T("%s-Statistics.txt"),GetDocument()->GetActiveImage()->GetName());
	pFileText = _tfopen(pathNameText, _T("w"));
	if (GetDocument()->m_IsFTRStatistics)
	{
		//export statistics
		fprintf(pFileText,"FTR Statistics of Image: %s\n",GetDocument()->GetActiveImage()->GetName());
		fprintf(pFileText,"Total Chars = ,%d\n",GetDocument()->m_FTR_Statistics.total_chars);
		fprintf(pFileText,"Recognised Chars = ,%d\n",GetDocument()->m_FTR_Statistics.total_correct);
		fprintf(pFileText,"Misrecognised Chars = ,%d\n",GetDocument()->m_FTR_Statistics.total_incorrect);
		fprintf(pFileText,"Noise Chars = ,%d\n",GetDocument()->m_FTR_Statistics.total_noise);
		fprintf(pFileText,"Recognised in Blue Chars = ,%d\n",GetDocument()->m_FTR_Statistics.correct_in_blue);
		fprintf(pFileText,"Recognised in Red Chars = ,%d\n",GetDocument()->m_FTR_Statistics.correct_in_red);
		fprintf(pFileText,"Misrecognised in Blue Chars = ,%d\n",GetDocument()->m_FTR_Statistics.incorrect_in_blue);
		fprintf(pFileText,"Misrecognised in Red Chars = ,%d\n",GetDocument()->m_FTR_Statistics.incorrect_in_red);
		fprintf(pFileText,"Misrecognised but Second Chars = ,%d\n",GetDocument()->m_FTR_Statistics.incorrect_but_second);
		fprintf(pFileText,"Missed Characters = , %d\n",GetDocument()->m_FTR_Statistics.missed_chars);
		fprintf(pFileText,"===============================\n\n");

	}
	if (GetDocument()->m_IsRefined1Statistics)
	{
		fprintf(pFileText,"Refined1 Statistics of Image: %s\n",GetDocument()->GetActiveImage()->GetName());
		fprintf(pFileText,"Total Chars = ,%d\n",GetDocument()->m_Refined1_Statistics.total_chars);
		fprintf(pFileText,"Recognised Chars = ,%d\n",GetDocument()->m_Refined1_Statistics.total_correct);
		fprintf(pFileText,"Misrecognised Chars = ,%d\n",GetDocument()->m_Refined1_Statistics.total_incorrect);
		fprintf(pFileText,"Noise Chars = ,%d\n",GetDocument()->m_Refined1_Statistics.total_noise);
		/*fprintf(pFileText,"Recognised in Blue Chars = ,%d\n",GetDocument()->m_FTR_Statistics.correct_in_blue);
		fprintf(pFileText,"Recognised in Red Chars = ,%d\n",GetDocument()->m_FTR_Statistics.correct_in_red);
		fprintf(pFileText,"Misrecognised in Blue Chars = ,%d\n",GetDocument()->m_FTR_Statistics.incorrect_in_blue);
		fprintf(pFileText,"Misrecognised in Red Chars = ,%d\n",GetDocument()->m_FTR_Statistics.incorrect_in_red);
		fprintf(pFileText,"Misrecognised but Second Chars = ,%d\n",GetDocument()->m_FTR_Statistics.incorrect_but_second);

		*/
		fprintf(pFileText,"Missed Characters = , %d\n",GetDocument()->m_Refined1_Statistics.missed_chars);
		fprintf(pFileText,"===============================\n\n");
	}
	if (GetDocument()->m_IsRefined2Statistics)
	{
		fprintf(pFileText,"Refined2 Statistics of Image: %s\n",GetDocument()->GetActiveImage()->GetName());
		fprintf(pFileText,"Total Chars = ,%d\n",GetDocument()->m_Refined2_Statistics.total_chars);
		fprintf(pFileText,"Recognised Chars = ,%d\n",GetDocument()->m_Refined2_Statistics.total_correct);
		fprintf(pFileText,"Misrecognised Chars = ,%d\n",GetDocument()->m_Refined2_Statistics.total_incorrect);
		fprintf(pFileText,"Noise Chars = ,%d\n",GetDocument()->m_Refined2_Statistics.total_noise);
		/*fprintf(pFileText,"Recognised in Blue Chars = ,%d\n",GetDocument()->m_FTR_Statistics.correct_in_blue);
		fprintf(pFileText,"Recognised in Red Chars = ,%d\n",GetDocument()->m_FTR_Statistics.correct_in_red);
		fprintf(pFileText,"Misrecognised in Blue Chars = ,%d\n",GetDocument()->m_FTR_Statistics.incorrect_in_blue);
		fprintf(pFileText,"Misrecognised in Red Chars = ,%d\n",GetDocument()->m_FTR_Statistics.incorrect_in_red);
		fprintf(pFileText,"Misrecognised but Second Chars = ,%d\n",GetDocument()->m_FTR_Statistics.incorrect_but_second);
		*/
		fprintf(pFileText,"Missed Characters = , %d\n",GetDocument()->m_Refined2_Statistics.missed_chars);
		
		fprintf(pFileText,"===============================\n\n");
	}
	fclose(pFileText);

}

void CDocImAnView::ExportStatistics2()
{
	
	
	
	if (GetDocument()->m_IsFTRStatistics)
	{
		FILE * pFileTextFTR;
		CString pathNameTextFTR;
		pathNameTextFTR.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Thesis\\Results\\FTRStatistics.csv"));
		pFileTextFTR = _tfopen(pathNameTextFTR, _T("a"));
		//export statistics
		CString name = GetDocument()->GetActiveImage()->GetName();
		for (int i = 0; i < name.GetLength()-4; i++)
		{
			fprintf(pFileTextFTR,"%c",name.GetAt(i));
		}
		fprintf(pFileTextFTR,",");
		fprintf(pFileTextFTR,"%d",GetDocument()->m_FTR_Statistics.total_chars);
		fprintf(pFileTextFTR,",");
		fprintf(pFileTextFTR,"%d",GetDocument()->m_FTR_Statistics.total_correct);
		fprintf(pFileTextFTR,",");
		fprintf(pFileTextFTR,"%d",GetDocument()->m_FTR_Statistics.total_incorrect);
		fprintf(pFileTextFTR,",");
		fprintf(pFileTextFTR,"%d",GetDocument()->m_FTR_Statistics.total_noise);
		fprintf(pFileTextFTR,",");
		fprintf(pFileTextFTR,"%d",GetDocument()->m_FTR_Statistics.missed_chars);
		fprintf(pFileTextFTR,",");
		//only for FTR
		fprintf(pFileTextFTR,"%d",GetDocument()->m_FTR_Statistics.correct_in_blue);
		fprintf(pFileTextFTR,",");
		fprintf(pFileTextFTR,"%d",GetDocument()->m_FTR_Statistics.correct_in_red);
		fprintf(pFileTextFTR,",");
		fprintf(pFileTextFTR,"%d",GetDocument()->m_FTR_Statistics.incorrect_in_blue);
		fprintf(pFileTextFTR,",");
		fprintf(pFileTextFTR,"%d",GetDocument()->m_FTR_Statistics.incorrect_in_red);
		fprintf(pFileTextFTR,",");
		fprintf(pFileTextFTR,"%d",GetDocument()->m_FTR_Statistics.incorrect_but_second);
		fprintf(pFileTextFTR,",");
		fprintf(pFileTextFTR,"%d",GetDocument()->m_FTR_Statistics.missed_chars);
		fprintf(pFileTextFTR,"\n");
		
		fclose(pFileTextFTR);
	}
	if (GetDocument()->m_IsRefined1Statistics)
	{
		FILE * pFileTextR1;
		CString pathNameTextR1;
		pathNameTextR1.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Thesis\\Results\\R1Statistics.csv"));
		pFileTextR1 = _tfopen(pathNameTextR1, _T("a"));

		CString name = GetDocument()->GetActiveImage()->GetName();
		for (int i = 0; i < name.GetLength(); i++)
		{
			fprintf(pFileTextR1,"%c",name.GetAt(i));
		}
			fprintf(pFileTextR1,",");
			fprintf(pFileTextR1,"%d",GetDocument()->m_Refined1_Statistics.total_chars);
			fprintf(pFileTextR1,",");
			fprintf(pFileTextR1,"%d",GetDocument()->m_Refined1_Statistics.total_correct);
			fprintf(pFileTextR1,",");
			fprintf(pFileTextR1,"%d",GetDocument()->m_Refined1_Statistics.total_incorrect);
			fprintf(pFileTextR1,",");
			fprintf(pFileTextR1,"%d",GetDocument()->m_Refined1_Statistics.total_noise);
			fprintf(pFileTextR1,",");
			fprintf(pFileTextR1,"%d",GetDocument()->m_Refined1_Statistics.missed_chars);
			fprintf(pFileTextR1,"\n");

		fclose(pFileTextR1);
	}
	if (GetDocument()->m_IsRefined2Statistics)
	{

		ExportRefined2RecognisedImage();
		FILE * pFileTextR2;
		CString pathNameTextR2;
		pathNameTextR2.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Thesis\\Results\\R2Statistics.csv"));
		pFileTextR2 = _tfopen(pathNameTextR2, _T("a"));

		CString name = GetDocument()->GetActiveImage()->GetName();
		for (int i = 0; i < name.GetLength(); i++)
		{
			fprintf(pFileTextR2,"%c",name.GetAt(i));
		}
			fprintf(pFileTextR2,",");
			fprintf(pFileTextR2,"%d",GetDocument()->m_Refined2_Statistics.total_chars);
			fprintf(pFileTextR2,",");
			fprintf(pFileTextR2,"%d",GetDocument()->m_Refined2_Statistics.total_correct);
			fprintf(pFileTextR2,",");
			fprintf(pFileTextR2,"%d",GetDocument()->m_Refined2_Statistics.total_incorrect);
			fprintf(pFileTextR2,",");
			fprintf(pFileTextR2,"%d",GetDocument()->m_Refined2_Statistics.total_noise);
			fprintf(pFileTextR2,",");
			fprintf(pFileTextR2,"%d",GetDocument()->m_Refined2_Statistics.missed_chars);
			fprintf(pFileTextR2,"\n");
		fclose(pFileTextR2);
	}
	

}

void CDocImAnView::OnOcrAddgroundtruthtoimage()
{
	CDlgPerfectChars2 dlg;

	int i = 0;
	int j = 0;
	dlg.onCancel = false;
	while ((i < GetDocument()->m_LineHolderIndex) && (dlg.onCancel == false))
	{
		j = 0;
		while ((j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex) && (dlg.onCancel == false))
		{


			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetDocument()->GetActiveImage(),false);
			GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateLocatedCharImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,true);
			dlg.SetCharacter(&GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j]);
			dlg.SetDocument(GetDocument());

			if (IDOK == dlg.DoModal())
			{
				Invalidate(FALSE);
			}
		
			
			j++;
			
		}
	i++;
	}
	ExportGroundTruthImage();
}

void CDocImAnView::ExportGroundTruthImage()
{
	FILE * pFileText;
	CString pathNameText;
	pathNameText.Format(_T("%s-GroundTruth.txt"),GetDocument()->GetActiveImage()->GetName());
	pFileText = _tfopen(pathNameText, _T("w"));
	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	{
		for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
		{
			char groundtruth = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Groundtruthchar;
			char newMinChar;
				if (groundtruth == '~') newMinChar = '"';
				else if (groundtruth == '$') newMinChar = ',';
				else if (groundtruth == '^') newMinChar = '.';
				else if (groundtruth == '#') newMinChar = ':';
				else newMinChar = groundtruth;
				//find the distance to the previus character
				if (j == 0)//it is the first character
				{
					fprintf(pFileText,"%c",newMinChar);
				}else
				{
					//find the center of the previous character in the charholder
					int value = j-1;
					 if (abs(((GetDocument()->m_pLineHolder[i].m_pCharacterHolder[value].m_CharCenter.x + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[value].m_Position_X )- (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X))) < 40)
					 {
						 //it is the next character
						 fprintf(pFileText,"%c",newMinChar);
					 }
					 else
					 {
						 //There is a space between them
						 //find how many spaces
						int distance = abs((GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j-1].m_CharCenter.x + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j-1].m_Position_X) - (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X));
						int newdistance = (float)distance/35.00;
						for (int z = 0; z < newdistance; z++)
						{
							fprintf(pFileText," ");
						}
						 fprintf(pFileText,"%c",newMinChar);
					 }
				}	
			
			
		}
		fprintf(pFileText,"\n");
	}
	fclose(pFileText);

}
void CDocImAnView::ImportGroundTruthImage()
{
	FILE * pFileText;
	CString pathNameText;
	pathNameText.Format(_T("%s-GroundTruth.txt"),GetDocument()->GetActiveImage()->GetName());
	char groundtruth;
	if (_tfopen(pathNameText, _T("r")))
	{
		pFileText = _tfopen(pathNameText, _T("r"));

		GetDocument()->m_ImportedGroundTruth = true;
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{

				fscanf(pFileText,"%c",&groundtruth);
				char space = ' ';
				while (groundtruth == space)
				{
					fscanf(pFileText,"%c",&groundtruth);
				}
				while (groundtruth == '&') 
				{
					//it is a missed character
					//add one to missed characters
					GetDocument()->m_FTR_Statistics.missed_chars++;
					GetDocument()->m_Refined1_Statistics.missed_chars++;
					GetDocument()->m_Refined2_Statistics.missed_chars++;
					fscanf(pFileText,"%c",&groundtruth);
				}
				char newGroudTruth;
				if (groundtruth == '"') newGroudTruth = '~';
				else if (groundtruth == ',') newGroudTruth = '$';
				else if (groundtruth == '.') newGroudTruth = '^';
				else if (groundtruth == ':') newGroudTruth = '#';
				else newGroudTruth = groundtruth;
				
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Groundtruthchar = newGroudTruth;
			}
			fscanf(pFileText,"\n");

		}
		fclose(pFileText);
	}

}
void CDocImAnView::ImportFTRRecognisedImage()
{
	FILE * pFileText;
	CString pathNameText;
	pathNameText.Format(_T("%sFTR.tif-Recognised.txt"),GetDocument()->GetActiveImage()->GetName());
	
	if (_tfopen(pathNameText, _T("r")))
	{
		pFileText = _tfopen(pathNameText, _T("r"));

		FILE * pFileText2;
		CString pathNameText2;
		pathNameText2.Format(_T("%sFTR.tif-Confidence-Recognised.txt"),GetDocument()->GetActiveImage()->GetName());
		char groundtruth;
		char colour;
		if (_tfopen(pathNameText2, _T("r")))
		{
			pFileText2 = _tfopen(pathNameText2, _T("r"));
			for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
			{
				for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
				{

					fscanf(pFileText,"%c",&groundtruth);
					fscanf(pFileText2,"%c",&colour);
					char space = ' ';
					while (groundtruth == space)
					{
						fscanf(pFileText,"%c",&groundtruth);
						fscanf(pFileText2,"%c",&colour);
					}
					char newGroudTruth;
					if (groundtruth == '"') newGroudTruth = '~';
					else if (groundtruth == ',') newGroudTruth = '$';
					else if (groundtruth == '.') newGroudTruth = '^';
					else if (groundtruth == ':') newGroudTruth = '#';
					else newGroudTruth = groundtruth;
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_FTRChar.charName = newGroudTruth;
					if (colour == 'B')
					{
						GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_FTRChar.isBlue = true;
					}
					else
					{
						GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_FTRChar.isBlue = false;
					}
					
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_FTRChar.secondCharName = newGroudTruth;
				}
				fscanf(pFileText,"\n");
				fscanf(pFileText2,"\n");

			}
			fclose(pFileText);
			fclose(pFileText2);
		}else
		{
			//get the name of the image and save it somewhere
			FILE * pFileText3;
			CString pathNameText3;
			pathNameText3.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Thesis\\Results\\NonFound.txt"));
			pFileText3 = _tfopen(pathNameText3, _T("a"));
			for (int x = 0; x < pathNameText.GetLength()-1;x++)
			{
				fprintf(pFileText3,"%c",pathNameText.GetAt(x));
			}
			fprintf(pFileText3,"\n");
			fclose(pFileText3);
		}


	}

}

void CDocImAnView::ImportRefined1RecognisedImage()
{
	FILE * pFileText;
	CString pathNameText;
	pathNameText.Format(_T("%sFTR.tif-Refined-1-Recognised.txt"),GetDocument()->GetActiveImage()->GetName());
	
	if (_tfopen(pathNameText, _T("r")))
	{
		pFileText = _tfopen(pathNameText, _T("r"));

		/*FILE * pFileText2;
		CString pathNameText2;
		pathNameText2.Format(_T("%sFTR.tif-Refined-1-Confidence-Recognised.txt"),GetDocument()->GetActiveImage()->GetName());
		*/char groundtruth;
		//char colour;
		//if (_tfopen(pathNameText2, _T("r")))
		//{
		//	pFileText2 = _tfopen(pathNameText2, _T("r"));
			for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
			{
				for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
				{

					fscanf(pFileText,"%c",&groundtruth);
				//	fscanf(pFileText2,"%c",&colour);
					char space = ' ';
					while (groundtruth == space)
					{
						fscanf(pFileText,"%c",&groundtruth);
					//	fscanf(pFileText2,"%c",&colour);
					}
					char newGroudTruth;
					if (groundtruth == '"') newGroudTruth = '~';
					else if (groundtruth == ',') newGroudTruth = '$';
					else if (groundtruth == '.') newGroudTruth = '^';
					else if (groundtruth == ':') newGroudTruth = '#';
					else newGroudTruth = groundtruth;
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Refined1Char.charName = newGroudTruth;
					/*if (colour == 'B')
					{
						GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_FTRChar.isBlue = true;
					}
					else
					{
						GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_FTRChar.isBlue = false;
					}*/
					
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Refined1Char.secondCharName = newGroudTruth;
				}
				fscanf(pFileText,"\n");
			//	fscanf(pFileText2,"\n");

			}
			fclose(pFileText);
		//	fclose(pFileText2);
		//}
	}

}

void CDocImAnView::ImportRefined2RecognisedImage()
{
	FILE * pFileText;
	CString pathNameText;
	pathNameText.Format(_T("%s-Refined-2-Recognised.txt"),GetDocument()->GetActiveImage()->GetName());
	
	if (_tfopen(pathNameText, _T("r")))
	{
		pFileText = _tfopen(pathNameText, _T("r"));

		/*FILE * pFileText2;
		CString pathNameText2;
		pathNameText2.Format(_T("%sFTR.tif-Refined-1-Confidence-Recognised.txt"),GetDocument()->GetActiveImage()->GetName());
		*/char groundtruth;
		//char colour;
		//if (_tfopen(pathNameText2, _T("r")))
		//{
		//	pFileText2 = _tfopen(pathNameText2, _T("r"));
			for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
			{
				for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
				{

					fscanf(pFileText,"%c",&groundtruth);
				//	fscanf(pFileText2,"%c",&colour);
					char space = ' ';
					while (groundtruth == space)
					{
						fscanf(pFileText,"%c",&groundtruth);
					//	fscanf(pFileText2,"%c",&colour);
					}
					char newGroudTruth;
					if (groundtruth == '"') newGroudTruth = '~';
					else if (groundtruth == ',') newGroudTruth = '$';
					else if (groundtruth == '.') newGroudTruth = '^';
					else if (groundtruth == ':') newGroudTruth = '#';
					else newGroudTruth = groundtruth;
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Refined2Char.charName = newGroudTruth;
					/*if (colour == 'B')
					{
						GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_FTRChar.isBlue = true;
					}
					else
					{
						GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_FTRChar.isBlue = false;
					}*/
					
					GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Refined2Char.secondCharName = newGroudTruth;
				}
				fscanf(pFileText,"\n");
			//	fscanf(pFileText2,"\n");

			}
			fclose(pFileText);
		//	fclose(pFileText2);
		//}
	}

}

void CDocImAnView::ExportRefined2RecognisedImage()
{
	FILE * pFileText;
	CString pathNameText;
	CString name;
	CString newname;
	char newname2[200];
	for (int x = 0; x < 200; x++)
	{
		newname2[x] = '-';
	}
	char m_char = '0';
	int i;
	name.Format(_T(""));
	name = GetDocument()->GetActiveImage()->GetName();
	i = name.GetLength()-1;
	newname.Format(_T(""));
	int x = 0;
	while (m_char != '\\')
	{
		m_char = name.GetAt(i);
		i--;
		if (m_char != '\\')
		{
			newname2[x]= m_char;
			x++;
			//newname.Format(_T("%s%c"),newname,m_char);
			newname.AppendChar(m_char);

		}
	}
	CString Othernewname;
	Othernewname = newname.MakeReverse();
//	pathNameText.Format(_T("%s-Refined-2-Recognised.txt"),GetDocument()->GetActiveImage()->GetName());
	pathNameText.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Thesis\\Results\\MATCHING\\Refined2\\%s-Refined-2-Recognised.txt"),newname);
	
	if (_tfopen(pathNameText, _T("w")))
	{
		pFileText = _tfopen(pathNameText, _T("w"));

		char groundtruth;
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				char groundtruth = GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Refined2Char.charName;
				char newMinChar;
					if (groundtruth == '~') newMinChar = '"';
					else if (groundtruth == '$') newMinChar = ',';
					else if (groundtruth == '^') newMinChar = '.';
					else if (groundtruth == '#') newMinChar = ':';
					else newMinChar = groundtruth;
					//find the distance to the previus character
					if (j == 0)//it is the first character
					{
						fprintf(pFileText,"%c",newMinChar);
					}else
					{
						//find the center of the previous character in the charholder
						int value = j-1;
						if (abs(((GetDocument()->m_pLineHolder[i].m_pCharacterHolder[value].m_CharCenter.x + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[value].m_Position_X )- (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X))) < 40)
						{
							//it is the next character
							fprintf(pFileText,"%c",newMinChar);
						}
						else
						{
							//There is a space between them
							//find how many spaces
							int distance = abs((GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j-1].m_CharCenter.x + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j-1].m_Position_X) - (GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharCenter.x + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X));
							int newdistance = (float)distance/35.00;
							for (int z = 0; z < newdistance; z++)
							{
								fprintf(pFileText," ");
							}
							fprintf(pFileText,"%c",newMinChar);
						}
					}	
				
				
			}
			fprintf(pFileText,"\n");
		}
		fclose(pFileText);
	}

}



void CDocImAnView::ImportWrongCharStats()
{
	FILE * pFileText;
	CString pathNameText;
	pathNameText.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Thesis\\Results\\WrongCharStats.txt"));
	int no_chars;
	int no_total_wrong_chars;
	char char_name;
	int no_wrong_chars;
	int no_other_chars;

	if (_tfopen(pathNameText, _T("r")))
	{
		pFileText = _tfopen(pathNameText, _T("r"));

		fscanf(pFileText,"%d,%d\n",&no_chars,&no_total_wrong_chars);
		GetDocument()->m_WrongCharStats.total_chars = no_chars;
		GetDocument()->m_WrongCharStats.worng_chars = new CDocImAnDoc::WRONG_CHAR[no_chars];
		GetDocument()->m_WrongCharStats.total_wrong_chars = no_total_wrong_chars;
		if (no_chars > 0)
		{
			for (int i = 0; i < no_chars;i++)
			{
				fscanf(pFileText,"%c,%d,%d\n",&char_name, &no_wrong_chars, &no_other_chars);
				GetDocument()->m_WrongCharStats.worng_chars[i].CharName = char_name;
				GetDocument()->m_WrongCharStats.worng_chars[i].total = no_wrong_chars;
				GetDocument()->m_WrongCharStats.worng_chars[i].total_otherChars = no_other_chars;
				if (no_other_chars >0)
				{
					GetDocument()->m_WrongCharStats.worng_chars[i].OtherChars = new CDocImAnDoc::WRONG_CHAR[80];
					char other_char;
					int total_other_char;
					for (int j = 0; j < no_other_chars;j++)
					{
						fscanf(pFileText,"\t%c,%d\n",&other_char,&total_other_char);
						GetDocument()->m_WrongCharStats.worng_chars[i].OtherChars[j].CharName = other_char;
						GetDocument()->m_WrongCharStats.worng_chars[i].OtherChars[j].total = total_other_char;
					}
				}
			}
		}
		fclose(pFileText);
		
	}

}

void CDocImAnView::ImportCorrectCharStats()
{
	FILE * pFileText;
	CString pathNameText;
	pathNameText.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Thesis\\Results\\CorrectCharStats.txt"));
	int no_chars;
	int no_total_right_chars;
	char char_name;
	int no_right_chars;
	int no_other_chars;

	if (_tfopen(pathNameText, _T("r")))
	{
		pFileText = _tfopen(pathNameText, _T("r"));

		fscanf(pFileText,"%d,%d\n",&no_chars,&no_total_right_chars);
		GetDocument()->m_CharacterStats.total_chars = no_chars;
		GetDocument()->m_CharacterStats.worng_chars = new CDocImAnDoc::WRONG_CHAR[no_chars];
		GetDocument()->m_CharacterStats.total_wrong_chars = no_total_right_chars;
		if (no_chars > 0)
		{
			for (int i = 0; i < no_chars;i++)
			{
				fscanf(pFileText,"%c,%d,%d\n",&char_name, &no_right_chars, &no_other_chars);
				GetDocument()->m_CharacterStats.worng_chars[i].CharName = char_name;
				GetDocument()->m_CharacterStats.worng_chars[i].total = no_right_chars;
				GetDocument()->m_CharacterStats.worng_chars[i].total_otherChars = no_other_chars;
				/*if (no_other_chars >0)
				{
					GetDocument()->m_WrongCharStats.worng_chars[i].OtherChars = new CDocImAnDoc::WRONG_CHAR[80];
					char other_char;
					int total_other_char;
					for (int j = 0; j < no_other_chars;j++)
					{
						fscanf(pFileText,"\t%c,%d\n",&other_char,&total_other_char);
						GetDocument()->m_WrongCharStats.worng_chars[i].OtherChars[j].CharName = other_char;
						GetDocument()->m_WrongCharStats.worng_chars[i].OtherChars[j].total = total_other_char;
					}
				}*/
			}
		}
		fclose(pFileText);
		
	}

}
void CDocImAnView::ExportWrongCharStats()
{
	FILE * pFileText;
	CString pathNameText;
	pathNameText.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Thesis\\Results\\WrongCharStats.txt"));


	if (_tfopen(pathNameText, _T("w")))
	{
		pFileText = _tfopen(pathNameText, _T("w"));
		fprintf(pFileText,"%d,%d\n",GetDocument()->m_WrongCharStats.total_chars,GetDocument()->m_WrongCharStats.total_wrong_chars);
		for (int i = 0; i < GetDocument()->m_WrongCharStats.total_chars; i++)
		{
			fprintf(pFileText,"%c,%d,%d\n",GetDocument()->m_WrongCharStats.worng_chars[i].CharName,GetDocument()->m_WrongCharStats.worng_chars[i].total,GetDocument()->m_WrongCharStats.worng_chars[i].total_otherChars);
			if (GetDocument()->m_WrongCharStats.worng_chars[i].total_otherChars > 0)
			{
				for (int j = 0; j < GetDocument()->m_WrongCharStats.worng_chars[i].total_otherChars;j++)
				{
					fprintf(pFileText,"\t%c,%d\n",GetDocument()->m_WrongCharStats.worng_chars[i].OtherChars[j].CharName,GetDocument()->m_WrongCharStats.worng_chars[i].OtherChars[j].total);
				}
				delete GetDocument()->m_WrongCharStats.worng_chars[i].OtherChars;
			}
		}
		delete GetDocument()->m_WrongCharStats.worng_chars;
		fclose(pFileText);

	}

}

void CDocImAnView::ExportCorrectCharStats()
{
	FILE * pFileText;
	CString pathNameText;
	pathNameText.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Thesis\\Results\\CorrectCharStats.txt"));
	if (_tfopen(pathNameText, _T("w")))
	{
		pFileText = _tfopen(pathNameText, _T("w"));
		fprintf(pFileText,"%d,%d\n",GetDocument()->m_CharacterStats.total_chars,GetDocument()->m_CharacterStats.total_wrong_chars);
		for (int i = 0; i < GetDocument()->m_CharacterStats.total_chars; i++)
		{
			fprintf(pFileText,"%c,%d,%d\n",GetDocument()->m_CharacterStats.worng_chars[i].CharName,GetDocument()->m_CharacterStats.worng_chars[i].total,GetDocument()->m_CharacterStats.worng_chars[i].total_otherChars);

		}
		delete GetDocument()->m_CharacterStats.worng_chars;
		fclose(pFileText);

	}

}
void CDocImAnView::AddCorrectCharStats(char char_name, bool is_correct)
{
	for (int i = 0; i < GetDocument()->m_CharacterStats.total_chars; i++)
	{
		if (GetDocument()->m_CharacterStats.worng_chars[i].CharName == char_name)
		{	
			GetDocument()->m_CharacterStats.worng_chars[i].total++;
			GetDocument()->m_CharacterStats.total_wrong_chars++;
			if (is_correct)
			{
				//the add it to the recognised and the total
				GetDocument()->m_CharacterStats.worng_chars[i].total_otherChars++;
			}

		}
	}

}
void CDocImAnView::AddWrongCharStat(char char_name, char other_char_name)
{
	if (other_char_name == '@')
	{
		other_char_name = other_char_name;
		AddCorrectCharStats(other_char_name, false);
	}
	else
	{
		for (int i = 0; i < GetDocument()->m_WrongCharStats.total_chars; i++)
		{
			if (GetDocument()->m_WrongCharStats.worng_chars[i].CharName == char_name)
			{
				GetDocument()->m_WrongCharStats.worng_chars[i].total++;
				GetDocument()->m_WrongCharStats.total_wrong_chars++;
				if (GetDocument()->m_WrongCharStats.worng_chars[i].total_otherChars == 0)
				{
					//it is the first character
					GetDocument()->m_WrongCharStats.worng_chars[i].OtherChars = new CDocImAnDoc::WRONG_CHAR[80];
					GetDocument()->m_WrongCharStats.worng_chars[i].total_otherChars = 1;
					GetDocument()->m_WrongCharStats.worng_chars[i].OtherChars[0].CharName = other_char_name;
					GetDocument()->m_WrongCharStats.worng_chars[i].OtherChars[0].total = 1;
					


				}
				else
				{
					bool found = false;
					//loop to find it
					for (int j = 0; j < GetDocument()->m_WrongCharStats.worng_chars[i].total_otherChars; j++)
					{
						if (GetDocument()->m_WrongCharStats.worng_chars[i].OtherChars[j].CharName == other_char_name)
						{
							//then just increase the amount
							found = true;
							GetDocument()->m_WrongCharStats.worng_chars[i].OtherChars[j].total++;
							
						}
					}
					//if it gets out and hasn't find it then add it at the end
					if (!found)
					{
						GetDocument()->m_WrongCharStats.worng_chars[i].OtherChars[GetDocument()->m_WrongCharStats.worng_chars[i].total_otherChars].CharName = other_char_name;
						GetDocument()->m_WrongCharStats.worng_chars[i].OtherChars[GetDocument()->m_WrongCharStats.worng_chars[i].total_otherChars].total = 1;
						GetDocument()->m_WrongCharStats.worng_chars[i].total_otherChars++;
					}

				}
			}
		}
	}
}


void CDocImAnView::OnOcrComputeindividualstatistics()
{
	ImportWrongCharStats();
	ImportGroundTruthImage();

	ImportFTRRecognisedImage();
	ComputeRecognitionStatisticsFTR();

	ImportRefined1RecognisedImage();
	ComputeRecognitionStatisticsRefined1();

	ImportRefined2RecognisedImage();
	ComputeRecognitionStatisticsRefined2();
	
	ExportStatistics();
	ExportStatistics2();
	ExportWrongCharStats();

}

void CDocImAnView::OnOcrComputestatisticsgroupofimages()
{
	FILE * pFile;

	CString filePath;
	CString imagePath;
	filePath.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Thesis\\Results\\Statistics.txt"));
	if (_tfopen(filePath, _T("r")))
	{
		pFile = _tfopen(filePath, _T("r"));	
		int count;
		fscanf(pFile,"%d\n",&count);
		int n_Images = count;
		
	//	ImportWrongCharStats();
		CDlgTestingEnvironment dlg;
		dlg.SetDocument(GetDocument());
		//for each image in the file, do full recognition
		for (int i = 0; i < n_Images; i++)
		{
			GetDocument()->OnNewDocument();
			imagePath.Empty();
			char val = '0';
			int num = 0;
			while (val != '\n')
			{
				fscanf(pFile,"%c", &val);
				
				if (val != '\n')
				{
					imagePath  = imagePath + val;
					num++;
					
				}
			}

			CImage* loadedImage;
			loadedImage = ImgLoadFromFile((LPCTSTR)imagePath, 
			RUNTIME_CLASS(CDIAHiColorImage),
			NULL,
			RUNTIME_CLASS(CDIAGreyScale),
			RUNTIME_CLASS(CDIABiLevelImage));
			GetDocument()->SetActiveImage(loadedImage);
			GetDocument()->CreateNewUndoImage(0);

			//improve the image FTR
			FTR2();

			ImportWrongCharStats();
			ImportCorrectCharStats();
			ImportGroundTruthImage();

			ImportFTRRecognisedImage();
			ComputeRecognitionStatisticsFTR();

			//ImportRefined1RecognisedImage();
			//ComputeRecognitionStatisticsRefined1();

			ImportRefined2RecognisedImage();
			ComputeRecognitionStatisticsRefined2();
			ExportStatistics2();
			ExportStatistics();
			
			ExportWrongCharStats();
			ExportCorrectCharStats();

		}
		fclose(pFile);
	}
}



void CDocImAnView::OnLevensteindistanceTest()
{
	CDistance distance;
	const char* string1 = "lela lela";

	const char* string2 = "ola ola";

	
	int missing;
	int wrong;
	int noise;
	int total;
	int cost = distance.LD(string1,string2,total,missing,noise,wrong);

}

void CDocImAnView::CalculateLevensteinDistance(int column)
{
	
	FILE * pFile;

	CString filePath;
	CString groundTruthImagePath;
	CString columnImagePath;
	CString groundtruthPath;
	CString columnPath;
	int column_num = 0;
	

	//CFileDialog m_FileDialog(TRUE, NULL, NULL, OFN_HIDEREADONLY|OFN_FILEMUSTEXIST, 
	//	//_T("csv Files(*.csv)|All Files (*.*)|*.*||"));
	//	_T("csv Files(*.csv; *.txt)|*.csv; *.csv|All Files (*.*)|*.*||"));
	//if (m_FileDialog.DoModal() == IDOK)
	//{
		
		//filePath.Format(_T("%s"),m_FileDialog.GetPathName());
		filePath.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Thesis\\Results\\cards\\cards.csv"));
	//}
	if (_tfopen(filePath, _T("r")))
	{
		pFile = _tfopen(filePath, _T("r"));	
		int count;
		fscanf(pFile,"%d\n",&count);
		int n_Images = count;
		char val = '0';
		//read the paths first
		while(val != '\n')
		{
			fscanf(pFile,"%c", &val);
		}
		fscanf(pFile,"%c", &val);
		while(val != '\n')
		{
			fscanf(pFile,"%c", &val);
		}
		//fscanf(pFile,"\n");//line with names
		//fscanf(pFile,"\n");//line with names

		groundtruthPath.Empty();
		column_num = 0;
		
		//int num = 0;
		while (val != ',')
		{
			fscanf(pFile,"%c", &val);
			
			if (val != ',')
			{
				groundtruthPath  = groundtruthPath + val;
			//	num++;
				
			}
		}
		column_num = 0;
		while (column_num < column)
		{
			fscanf(pFile,"%c", &val);
			if (val == ',') column_num++;
		}
		fscanf(pFile,"%c", &val);
		columnPath.Empty();
		while (val != ',')
		{
			if (val != ',')
			{
				columnPath  = columnPath + val;
			//	num++;
				
			}
			fscanf(pFile,"%c", &val);
		}

		//new line
		//fscanf(pFile,"\n", &val);
		while(val != '\n')
		{
			fscanf(pFile,"%c", &val);
		}
		int nothing;
		//for each image in the file,
		for (int i = 0; i < n_Images; i++)
		{
			//now read the name of the image
			columnImagePath.Empty();
			groundTruthImagePath.Empty();

			val = '0';
			//int num = 0;
			fscanf(pFile,"%c", &val);
			while (val != ',')
			{
				
				
				if (val != ',')
				{
					groundTruthImagePath  = groundTruthImagePath + val;
					//num++;
					
				}
				fscanf(pFile,"%c", &val);
			}

			//find the right column
			column_num = 0;
			while (column_num < column)
			{
				fscanf(pFile,"%c", &val);
				if (val == ',') column_num++;
			}
			columnImagePath.Empty();
			fscanf(pFile,"%c", &val);
			while (val != ',')
			{
				
				
				if (val != ',')
				{
					columnImagePath  = columnImagePath + val;
//					num++;
					
				}
				fscanf(pFile,"%c", &val);
			}

			//now open the two files
			CString groundtruth;
			groundtruth.Empty();

			CString text;
			groundtruth.Format(_T("%s\\%s"),groundtruthPath,groundTruthImagePath);
			text.Empty();
			text.Format(_T("%s\\%s"),columnPath,columnImagePath);
			int missing;
			int wrong;
			int noise;
			int total;
			int dis = Distance(groundtruth,text,total,missing,noise,wrong);

			while(val != '\n')
			{
				fscanf(pFile,"%c", &val);
			}
			FILE * pFile2;

			CString filePath;
			CString imagePath;
			CString name;
			//name.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Thesis\\Results\\Distances"));
			name.Format(_T("H:\\My Documents\\Celia\\Memorial Images\\Thesis\\Results\\CardDistances"));
			
			filePath.Format(_T("%s%d.csv"),name, column);
			
			if (_tfopen(filePath, _T("a")))
			{
				pFile2 = _tfopen(filePath, _T("a"));	
				//CString name = GetDocument()->GetActiveImage()->GetName();
				for (int i = 0; i < text.GetLength()-4; i++)
				{
					fprintf(pFile2,"%c",text.GetAt(i));
				}
				fprintf(pFile2,",%d,%d,%d,%d,%d\n",total,dis,missing,noise,wrong);
				fclose(pFile2);
			}
				
		}fclose(pFile);
	}
		  


}

int CDocImAnView::Distance(CString GroundTruthFile, CString OtherFile)
{
	//open the files
	FILE * pFile;
	FILE * pFile2;
	CDistance dis;
	const char* s2;
	char* s3;
	const char* t2;
	char* t3;

	if (_tfopen(GroundTruthFile, _T("r")))
	{
		

		if (_tfopen(OtherFile, _T("r")))
		{
			//file1
			
			//int size = sizeof(pFile);
			 FILE * stream = _tfopen( GroundTruthFile, _T("r"));
			fseek( stream, 0L, SEEK_END );
			long endPos = ftell( stream );
			fclose( stream );
			pFile = _tfopen(GroundTruthFile, _T("r"));
			s3 = new char[endPos];
			for (int i = 0; i < endPos; i++)
			{
				s3[i] = fgetc(pFile);				
			}
			fclose( pFile );
			//file2
			 FILE * stream2 = _tfopen( OtherFile,_T("r") );
			fseek( stream2, 0L, SEEK_END );
			endPos = ftell( stream2 );
			fclose( stream2 );

			
			pFile2 = _tfopen(OtherFile, _T("r"));
			//size = sizeof(pFile2);
			t3 = new char[endPos];
			for (int i = 0; i < endPos; i++)
			{
				t3[i] = fgetc(pFile2);				
			}
			fclose( pFile2 );

		}
		else return -1;
	

	s2 = s3;
	t2 = t3;

	//int cost = dis.LD(s2,t2);
	
	int missing;
	int wrong;
	int noise;
	int total;
	int cost = dis.LD(s2,t2);
	
	missing;
	wrong;
	noise;
	return cost;
	}
	else
		return -1;
}




int CDocImAnView::Distance(CString GroundTruthFile, CString OtherFile,int &total2,int &missing2, int &noise2, int &wrong2)
{
	//open the files
	FILE * pFile;
	FILE * pFile2;
	CDistance dis;
	const char* s2;
	char* s3;
	const char* t2;
	char* t3;

	if (_tfopen(GroundTruthFile, _T("r")))
	{
		

		if (_tfopen(OtherFile, _T("r")))
		{
			//file1
			
			//int size = sizeof(pFile);
			 FILE * stream = _tfopen( GroundTruthFile, _T("r"));
			fseek( stream, 0L, SEEK_END );
			long endPos = ftell( stream );
			fclose( stream );
			pFile = _tfopen(GroundTruthFile, _T("r"));
			s3 = new char[endPos];
			for (int i = 0; i < endPos; i++)
			{
				s3[i] = fgetc(pFile);				
			}
			fclose( pFile );
			//file2
			 FILE * stream2 = _tfopen( OtherFile,_T("r") );
			fseek( stream2, 0L, SEEK_END );
			endPos = ftell( stream2 );
			fclose( stream2 );

			
			pFile2 = _tfopen(OtherFile, _T("r"));
			//size = sizeof(pFile2);
			t3 = new char[endPos];
			for (int i = 0; i < endPos; i++)
			{
				t3[i] = fgetc(pFile2);				
			}
			fclose( pFile2 );

		}
		else
		{
			return -1;
		}
	

	s2 = s3;
	t2 = t3;

	//int cost = dis.LD(s2,t2);
	
	int missing;
	int wrong;
	int noise;
	int total;
	int cost = dis.LD(s2,t2,total,missing,noise,wrong);
	missing2 = missing;
	noise2 = noise;
	wrong2 = wrong;
	total2 = total;
	
	delete s3;
	delete t3;
	return cost;
	}
	else
	{
		return -1;
	}
}
void CDocImAnView::OnModiOriginal()
{
	CalculateLevensteinDistance(0);
	
}
void CDocImAnView::OnModiFtr()
{
	CalculateLevensteinDistance(1);
}

void CDocImAnView::OnModiGatos()
{
	CalculateLevensteinDistance(2);
}

void CDocImAnView::OnAbbyyOriginal()
{
	CalculateLevensteinDistance(3);
}

void CDocImAnView::OnAbbyyFtr()
{
	CalculateLevensteinDistance(4);
}

void CDocImAnView::OnAbbyyGatos()
{
	CalculateLevensteinDistance(5);
}

void CDocImAnView::OnLevensteindistanceFtr()
{
	CalculateLevensteinDistance(6);
}

void CDocImAnView::OnLevensteindistanceAll()
{
	CalculateLevensteinDistance(0);
	CalculateLevensteinDistance(1);
	CalculateLevensteinDistance(2);
	CalculateLevensteinDistance(3);
	CalculateLevensteinDistance(4);
	CalculateLevensteinDistance(5);
	CalculateLevensteinDistance(6);
	CalculateLevensteinDistance(8);
	CalculateLevensteinDistance(9);
	CalculateLevensteinDistance(10);
	CalculateLevensteinDistance(11);
	CalculateLevensteinDistance(12);
}

void CDocImAnView::OnModiOtsu()
{
	CalculateLevensteinDistance(10);
}

void CDocImAnView::OnAbbyyOtsu()
{
	CalculateLevensteinDistance(11);
}

void CDocImAnView::OnAbbyyRefined2()
{
	CalculateLevensteinDistance(9);
}

void CDocImAnView::OnModiRefined2()
{
	CalculateLevensteinDistance(8);
}

void CDocImAnView::OnMatchingRefined()
{
	CalculateLevensteinDistance(12);
}
void CDocImAnView::On1Segmentation()
{
b_isDemoSeg = true;
	b_isDemoFTR = false;
	b_isDemoRef = false;
	//if no image is open then call the open dialog
	if(GetDocument()->GetActiveImage() == NULL)
	{
		GetDocument()->OnFileImportimage();
	}
	CString sReplacementText = _T("Image Segmentation");
    ((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));

	//TRACE(_T("*****Enhancing Image Flexible Text Recovery*****\n"));
	//Global_Timing(GLTM_START);
	//END TIMING
	//first: segment the image

		int index = GetDocument()->m_index;
		if (!GetDocument()->m_bIsPreprocessed)
		{
			//TRACE(_T("Preprocess Image... \n"));
			sReplacementText = _T("Preprocessing Image...");
			((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));

			PreprocessImage();
		}
			GetActiveImage()->SetDirty(); 
			GetDocument()->UpdateAllViews(this,0L,NULL);

			Invalidate(FALSE);
		//Insert dlg 1
		DemoSegStep11 dlg;
		if (IDOK == dlg.DoModal())
		{
			GetActiveImage()->SetDirty(); 
			GetDocument()->UpdateAllViews(this,0L,NULL);

			Invalidate(FALSE);
		}


		//TRACE(_T("Segmentation: Perform Line Segmentation... \n"));
		//sReplacementText = _T("Segmentation: Performing Line Segmentation...");
		//((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
			
		PerformLineSegmentation(GetActiveImage());

		GetDocument()->m_bIsLineSegmented = true;
		DIASegmentation * seg;
		seg = new DIASegmentation;
		seg->m_pdoc = GetDocument();
		//characters are created in computeFixedWidthSegmentation2//
		sReplacementText = _T("Performing Character Segmentation...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		//TRACE(_T("Segmentation: Perform Character Segmentation... \n"));

		seg->ComputeFixedWidthSegmentation2(30);

		m_bViewIndividualCharacters = true;
		GetDocument()->m_IsCharSegmented = true;
		//GetDocument()->m_ShowFix = true;
		
		delete seg;
		//delete intermediate images
		
		if (GetDocument()->m_pUndoImage != NULL)
		{	
			while (GetDocument()->m_index > index)
			{
				delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
				GetDocument()->m_index--;
			}
			SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
		}
		//update the image
	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	sReplacementText = _T("Done!");
	((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
	Invalidate(FALSE);
	
	//Insert dlg 2
	DemoSegStep2 dlg2;
	if (IDOK == dlg2.DoModal())
	{
		GetActiveImage()->SetDirty(); 
		GetDocument()->UpdateAllViews(this,0L,NULL);

		Invalidate(FALSE);
	}

}
//void CDocImAnView::OnDemo1()
//{
//	b_isDemoSeg = true;
//	b_isDemoFTR = false;
//	b_isDemoRef = false;
//	//if no image is open then call the open dialog
//	if(GetDocument()->GetActiveImage() == NULL)
//	{
//		GetDocument()->OnFileImportimage();
//	}
//	CString sReplacementText = _T("Image Segmentation");
//    ((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
//
//	//TRACE(_T("*****Enhancing Image Flexible Text Recovery*****\n"));
//	//Global_Timing(GLTM_START);
//	//END TIMING
//	//first: segment the image
//
//		int index = GetDocument()->m_index;
//		if (!GetDocument()->m_bIsPreprocessed)
//		{
//			//TRACE(_T("Preprocess Image... \n"));
//			sReplacementText = _T("Preprocessing Image...");
//			((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
//
//			PreprocessImage();
//		}
//			GetActiveImage()->SetDirty(); 
//			GetDocument()->UpdateAllViews(this,0L,NULL);
//
//			Invalidate(FALSE);
//		//Insert dlg 1
//		DemoSegStep11 dlg;
//		if (IDOK == dlg.DoModal())
//		{
//			GetActiveImage()->SetDirty(); 
//			GetDocument()->UpdateAllViews(this,0L,NULL);
//
//			Invalidate(FALSE);
//		}
//
//
//		//TRACE(_T("Segmentation: Perform Line Segmentation... \n"));
//		//sReplacementText = _T("Segmentation: Performing Line Segmentation...");
//		//((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
//			
//		PerformLineSegmentation(GetActiveImage());
//
//		GetDocument()->m_bIsLineSegmented = true;
//		DIASegmentation * seg;
//		seg = new DIASegmentation;
//		seg->m_pdoc = GetDocument();
//		//characters are created in computeFixedWidthSegmentation2//
//		sReplacementText = _T("Performing Character Segmentation...");
//		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
//		//TRACE(_T("Segmentation: Perform Character Segmentation... \n"));
//
//		seg->ComputeFixedWidthSegmentation2(30);
//
//		m_bViewIndividualCharacters = true;
//		GetDocument()->m_IsCharSegmented = true;
//		//GetDocument()->m_ShowFix = true;
//		
//		delete seg;
//		//delete intermediate images
//		
//		if (GetDocument()->m_pUndoImage != NULL)
//		{	
//			while (GetDocument()->m_index > index)
//			{
//				delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
//				GetDocument()->m_index--;
//			}
//			SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
//		}
//		//update the image
//	GetActiveImage()->SetDirty(); 
//	GetDocument()->UpdateAllViews(this,0L,NULL);
//	sReplacementText = _T("Done!");
//	((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
//	Invalidate(FALSE);
//	
//	//Insert dlg 2
//	DemoSegStep2 dlg2;
//	if (IDOK == dlg2.DoModal())
//	{
//		GetActiveImage()->SetDirty(); 
//		GetDocument()->UpdateAllViews(this,0L,NULL);
//
//		Invalidate(FALSE);
//	}
//
//}
//
//void CDocImAnView::OnDemo2(){
//	
//		index = GetDocument()->m_index;
//		
//		GetDocument()->CreateNewUndoImage();
//		ApplyAdaptiveHistogramMaxMin();
//		//ApplyAdaptiveHistogram();
//		//ThresholdHighestVals();
//
//		sReplacementText = _T("Locate Characters...");
//		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
//		TRACE(_T("Segmentation: Locate Characters in Boxes... \n"));
//		
//		LocateCharacters4(128,3);
//		//Insert dlg 2
//		DemoLoc dlg3;
//		if (IDOK == dlg3.DoModal())
//		{
//			GetActiveImage()->SetDirty(); 
//			GetDocument()->UpdateAllViews(this,0L,NULL);
//
//			Invalidate(FALSE);
//		}
//		if (GetDocument()->m_pUndoImage != NULL)
//		{	
//			while (GetDocument()->m_index > index)
//			{
//				delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
//				GetDocument()->m_index--;
//			}
//			SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
//		}
//
//	//update the image
//	GetActiveImage()->SetDirty(); 
//	GetDocument()->UpdateAllViews(this,0L,NULL);
//	sReplacementText = _T("Done!");
//	((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
//	Invalidate(FALSE);
//}

void CDocImAnView::On33()
{

	
		//CT
		int index = GetDocument()->m_index;
		GetDocument()->CreateNewUndoImage();
		CString sReplacementText = _T("Enhancement: Smoothing Image (Gaussian)...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Enhancement: Smoothing Image (Gaussian)... \n"));

		ApplyGaussianFilter(GetActiveImage());
		GetDocument()->CreateNewUndoImage(0);
		CDlgDIAHistograms::RANGE_VALS * ranges;
		ranges = new CDlgDIAHistograms::RANGE_VALS[3];

		ranges[0].firstVal = 0;
		ranges[0].lastVal = 0;
		ranges[0].colour = 0;

		ranges[1].firstVal = 1;
		ranges[1].lastVal =-1;
		ranges[1].colour = -1;
		

		CDlgDIAHistograms dlgHistogram;
		dlgHistogram.SetDocument(GetDocument());
		dlgHistogram.ApplyAdvancedThresholdToCharacters(GetDocument()->GetActiveImage(),ranges, 3);
	
		if (GetDocument()->m_pUndoImage != NULL)
		{	
			while (GetDocument()->m_index > index)
			{
				delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
				GetDocument()->m_index--;
			}
			SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
		}
		
	//b_isDemoFTR = true;
	
	outputCleanImage();
		//update the image
	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	/*sReplacementText = _T("Done!");
	((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));*/
	Invalidate(FALSE);
	

}

void CDocImAnView::On3Comparison()
{
	if (b_isDemoSeg = true)
	{
		//Combination
		DemoFTRIm dlg;
		
		////Original Image index
		//int	index = GetDocument()->m_index;
		//TRACE(_T("Index 1= \d \n",GetDocument()->m_index));
		//GetDocument()->CreateNewUndoImage(0);
		////index + 1
		//ApplyGaussianFilter(GetActiveImage());
		//GetDocument()->CreateNewUndoImage(0);
		////index + 2
		//CDlgDIAHistograms::RANGE_VALS * ranges;
		//ranges = new CDlgDIAHistograms::RANGE_VALS[3];

		//ranges[0].firstVal = 0;
		//ranges[0].lastVal = 0;
		//ranges[0].colour = 0;

		//ranges[1].firstVal = 1;
		//ranges[1].lastVal =-1;
		//ranges[1].colour = -1;
		//

		//CDlgDIAHistograms dlgHistogram;
		//dlgHistogram.SetDocument(GetDocument());
		//dlgHistogram.ApplyAdvancedThresholdToCharacters(GetDocument()->GetActiveImage(),ranges, 3);

		//
		//int indexThres40 = index + 2;
	
		////Now create Niblack

		//GetDocument()->CreateNewUndoImage(0);
		////index + 3

		//
		//GetDocument()->GetUndoImage(GetDocument()->m_index - 1)->CreateFromImage(GetDocument()->GetUndoImage(GetDocument()->m_index - 3));
		//CRect rect;

		//ApplyGaussianFilter(GetDocument()->GetUndoImage(GetDocument()->m_index - 3));

		//
		//for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		//{
		//	for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
		//	{
		//		rect.SetRect(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom);	
		//		GetDocument()->GetUndoImage(GetDocument()->m_index - 3)->Threshold_Niblack(5,rect,GetActiveImage(),2);
		//	}
		//}
		////init the image in the dlg
		//
		//int indexNiblack = index + 3;

		//dlg.SetDocument(GetDocument());
		//GetDocument()->CreateNewUndoImage();
		////index + 4
	

		////int indexcompMean = GetDocument()->m_index-1;
		//int indexcompMean = index + 4-1;

		//for (int i = 0; i < GetDocument()->GetUndoImage(indexNiblack)->GetWidth(); i++)
		//{
		//	for (int j = 0; j < GetDocument()->GetUndoImage(indexNiblack)->GetHeight(); j++)
		//	{
		//		int v1, v2, newvalue;
		//		v1 = (int) GetRValue(GetDocument()->GetUndoImage(indexThres40)->GetRGBColor(i,j));
		//		v2 = (int) GetRValue(GetDocument()->GetUndoImage(indexNiblack)->GetRGBColor(i,j));
		//		if (v1 != v2)
		//		{ 
		//			newvalue = AddValuesCompensationMean(v1, v2);
		//		}
		//		else 
		//			newvalue = v1;
		//		
		//		if (newvalue < 0) GetDocument()->GetUndoImage(indexcompMean)->SetRGBColor(i,j,RGB(128,128,128));
		//		GetDocument()->GetUndoImage(indexcompMean)->SetRGBColor(i,j,RGB(newvalue,newvalue,newvalue));
		//	}
		//}
		int index = GetDocument()->m_index;
		GetDocument()->CreateNewUndoImage();
		

		ApplyGaussianFilter(GetActiveImage());

	////Fifth: apply Threshold40
	//	sReplacementText = _T("Enhancement: Applying Threshold40...");
	//	((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
	//	TRACE(_T("Enhancement: Applying Threshold40... \n"));

	//	ThresholdHighestVals();
		
		GetDocument()->CreateNewUndoImage(0);
		CDlgDIAHistograms::RANGE_VALS * ranges;
		ranges = new CDlgDIAHistograms::RANGE_VALS[3];

		ranges[0].firstVal = 0;
		ranges[0].lastVal = 0;
		ranges[0].colour = 0;

		ranges[1].firstVal = 1;
		ranges[1].lastVal =-1;
		ranges[1].colour = -1;
		

		CDlgDIAHistograms dlgHistogram;
		dlgHistogram.SetDocument(GetDocument());
		dlgHistogram.ApplyAdvancedThresholdToCharacters(GetDocument()->GetActiveImage(),ranges, 3);

	
		GetDocument()->GetActiveImage()->SetDirty();

	//Sixth: create a new image and apply 2X Gauss + Sauvola
	
		
		GetDocument()->CreateNewUndoImage(0);

		//CImage* niblackImage = new CImage;
		//niblackImage->CreateFromImage(GetDocument()->GetActiveImage());
		GetDocument()->GetUndoImage(GetDocument()->m_index - 1)->CreateFromImage(GetDocument()->GetUndoImage(GetDocument()->m_index - 3));
		CRect rect;

		ApplyGaussianFilter(GetDocument()->GetUndoImage(GetDocument()->m_index - 3));

		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				rect.SetRect(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom);
				//niblackImage->Threshold_Niblack(5,rect,GetActiveImage(),2);	
				GetDocument()->GetUndoImage(GetDocument()->m_index - 3)->Threshold_Niblack(5,rect,GetActiveImage(),2);
			}
		}
		//Compensation Mean
		

		GetDocument()->CreateNewUndoImage();

		int indexcompMean = GetDocument()->m_index - 1;
		int indexNiblack = GetDocument()->m_index - 2;
		int indexThres40 = GetDocument()->m_index - 3;
		for (int i = 0; i < GetDocument()->GetUndoImage(indexNiblack)->GetWidth(); i++)
		{
			for (int j = 0; j < GetDocument()->GetUndoImage(indexNiblack)->GetHeight(); j++)
			{
				int v1, v2, newvalue;
				v1 = (int) GetRValue(GetDocument()->GetUndoImage(indexThres40)->GetRGBColor(i,j));
				v2 = (int) GetRValue(GetDocument()->GetUndoImage(indexNiblack)->GetRGBColor(i,j));
				if (v1 != v2)
				{ 
					newvalue = AddValuesCompensationMean(v1, v2);
				}
				else 
					newvalue = v1;
				
				if (newvalue < 0) GetDocument()->GetUndoImage(indexcompMean)->SetRGBColor(i,j,RGB(128,128,128));
				GetDocument()->GetUndoImage(indexcompMean)->SetRGBColor(i,j,RGB(newvalue,newvalue,newvalue));
			}
		}
		
		if (IDOK == dlg.DoModal())
		{
			GetActiveImage()->SetDirty(); 
			GetDocument()->UpdateAllViews(this,0L,NULL);

			Invalidate(FALSE);
		}

		LocateCharacters3(50,3);
		ClassifyCharacters2();
		GetDocument()->m_ShowInBox = true;
		CharacterAnalysis();
	
		ExtractCharacterFeatures();
	

	b_isDemoSeg = true;
	b_isDemoFTR = true;
	b_isDemoRef = false;
	outputCleanImage();
	
	}
		
	//update the image
	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	Invalidate(FALSE);
		
	
}

void CDocImAnView::On34()
{
	//AB 
		//Sixth: create a new image and apply 2X Gauss + Sauvola
	
		/*CString sReplacementText = _T("Creating Niblack Image...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Creating Niblack Image... \n"));*/
	if(b_isDemoSeg)
	{
		GetDocument()->CreateNewUndoImage(0);

		//CImage* niblackImage = new CImage;
		//niblackImage->CreateFromImage(GetDocument()->GetActiveImage());
		GetDocument()->GetUndoImage(GetDocument()->m_index - 1)->CreateFromImage(GetDocument()->GetUndoImage(GetDocument()->m_index - 3));
		CRect rect;

		ApplyGaussianFilter(GetDocument()->GetUndoImage(GetDocument()->m_index - 3));

		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				rect.SetRect(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom);
				//niblackImage->Threshold_Niblack(5,rect,GetActiveImage(),2);	
				GetDocument()->GetUndoImage(GetDocument()->m_index - 3)->Threshold_Niblack(5,rect,GetActiveImage(),2);
			}
		}
		outputCleanImage();
	}
		//update the image
	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	/*sReplacementText = _T("Done!");
	((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));*/
	Invalidate(FALSE);
	

}

void CDocImAnView::On44()
{

	
	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetActiveImage(),false);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateLocatedCharImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,false);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertValuablePoints();
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(1);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(100);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(10);
			}
		}
		//m_showGreenUncertain = 1;
		m_showPinkUncertain = 1;
		//m_showGreypixels = 1;
		//m_showOrangeUncertain = 1;
		m_bShowUncertainAreas = true;
	
		GetActiveImage()->SetDirty(); 		
		GetDocument()->UpdateAllViews(this,0L,NULL);
		Invalidate(FALSE);
}

void CDocImAnView::On45()
{
	
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetActiveImage(),false);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateLocatedCharImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,false);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertValuablePoints();
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(1);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(100);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(10);
			}
		}
		m_showGreenUncertain = 1;
		//m_showPinkUncertain = 1;
		//m_showGreypixels = 1;
		//m_showOrangeUncertain = 1;
		m_bShowUncertainAreas = true;
	
		GetActiveImage()->SetDirty(); 		
		GetDocument()->UpdateAllViews(this,0L,NULL);
		Invalidate(FALSE);
}

void CDocImAnView::On46()
{

	
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetActiveImage(),false);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateLocatedCharImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,false);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertValuablePoints();
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(1);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(100);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(10);
			}
		}
		//m_showGreenUncertain = 1;
		//m_showPinkUncertain = 1;
		//m_showGreypixels = 1;
		m_showOrangeUncertain = 1;
		m_bShowUncertainAreas = true;
	
		GetActiveImage()->SetDirty(); 		
		GetDocument()->UpdateAllViews(this,0L,NULL);
		Invalidate(FALSE);}

void CDocImAnView::OnDemo5()
{
	int index = 0;
		while (GetDocument()->m_index > index)
		{
			delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
			GetDocument()->m_index--;
		}
		SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
		FTR2();
		OnCharactersRefinement();
	
}

void CDocImAnView::On36()
{
	//Find all uncertain areas
	if ((b_isDemoSeg) && (b_isDemoFTR))
	{
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetActiveImage(),false);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateLocatedCharImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,false);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertValuablePoints();
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(1);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(100);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(10);
			}
		}
		m_showGreenUncertain = 1;
		m_showPinkUncertain = 1;
		m_showGreypixels = 1;
		m_showOrangeUncertain = 1;
		m_bShowUncertainAreas = true;
	}
		GetActiveImage()->SetDirty(); 		
		GetDocument()->UpdateAllViews(this,0L,NULL);
		Invalidate(FALSE);
}




void CDocImAnView::On11()
{
	//Locate
	int	index = GetDocument()->m_index;
		
		GetDocument()->CreateNewUndoImage();
		ApplyAdaptiveHistogramMaxMin();
		//ApplyAdaptiveHistogram();
		//ThresholdHighestVals();

		CString	sReplacementText = _T("Locate Characters...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Segmentation: Locate Characters in Boxes... \n"));
		
		LocateCharacters4(128,3);
		//Insert dlg 2
		DemoLoc dlg3;
		if (IDOK == dlg3.DoModal())
		{
			GetActiveImage()->SetDirty(); 
			GetDocument()->UpdateAllViews(this,0L,NULL);

			Invalidate(FALSE);
		}
		if (GetDocument()->m_pUndoImage != NULL)
		{	
			while (GetDocument()->m_index > index)
			{
				delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
				GetDocument()->m_index--;
			}
			SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
		}
	////Insert dlg 3
	//	DemoLoc dlg3;
	//	if (IDOK == dlg3.DoModal())
	//	{
	//		GetActiveImage()->SetDirty(); 
	//		GetDocument()->UpdateAllViews(this,0L,NULL);

	//		Invalidate(FALSE);
	//	}
	//update the image
	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	sReplacementText = _T("Done!");
	((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
	Invalidate(FALSE);
}

void CDocImAnView::OnFtrdemoCompleteftr()
{
	FTR2();
	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
}

void CDocImAnView::On2Ct()
{
	//if (b_isDemoSeg = true)
	//{
	//	//CT
	//	int index = GetDocument()->m_index;
	//	GetDocument()->CreateNewUndoImage();
	//	

	//	ApplyGaussianFilter(GetActiveImage());
	//	GetDocument()->CreateNewUndoImage(0);
	//	index = GetDocument()->m_index;
	//	CDlgDIAHistograms::RANGE_VALS * ranges;
	//	ranges = new CDlgDIAHistograms::RANGE_VALS[3];

	//	ranges[0].firstVal = 0;
	//	ranges[0].lastVal = 0;
	//	ranges[0].colour = 0;

	//	ranges[1].firstVal = 1;
	//	ranges[1].lastVal =-1;
	//	ranges[1].colour = -1;
	//	

	//	CDlgDIAHistograms dlgHistogram;
	//	dlgHistogram.SetDocument(GetDocument());
	//	dlgHistogram.ApplyAdvancedThresholdToCharacters(GetDocument()->GetActiveImage(),ranges, 3);
	//
	//	/*if (GetDocument()->m_pUndoImage != NULL)
	//	{	
	//		while (GetDocument()->m_index > index)
	//		{
	//			delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
	//			GetDocument()->m_index--;
	//		}
	//		SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
	//	}*/
	//	
	////b_isDemoFTR = true;
	//SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
	//outputCleanImage();
	//	//update the image
	//GetActiveImage()->SetDirty(); 
	//GetDocument()->UpdateAllViews(this,0L,NULL);
	///*sReplacementText = _T("Done!");
	//((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));*/
	//Invalidate(FALSE);
	//}
	int index = 1;
	if (GetDocument()->m_pUndoImage != NULL)
		{	
			while (GetDocument()->m_index > index)
			{
				delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
				GetDocument()->m_index--;
			}
			SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
		}
	
		//CT
		index = GetDocument()->m_index;
		GetDocument()->CreateNewUndoImage();
		

		ApplyGaussianFilter(GetActiveImage());
		GetDocument()->CreateNewUndoImage(0);
		CDlgDIAHistograms::RANGE_VALS * ranges;
		ranges = new CDlgDIAHistograms::RANGE_VALS[3];

		ranges[0].firstVal = 0;
		ranges[0].lastVal = 0;
		ranges[0].colour = 0;

		ranges[1].firstVal = 1;
		ranges[1].lastVal =-1;
		ranges[1].colour = -1;
		

		CDlgDIAHistograms dlgHistogram;
		dlgHistogram.SetDocument(GetDocument());
		
		dlgHistogram.ApplyAdvancedThresholdToCharacters(GetDocument()->GetActiveImage(),ranges, 3);
	

	
	outputCleanImage();
	//SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
	//Insert dlg 3
		DemoCT dlg3;
		if (IDOK == dlg3.DoModal())
		{
			GetActiveImage()->SetDirty(); 
			GetDocument()->UpdateAllViews(this,0L,NULL);

			Invalidate(FALSE);
		}
		//update the image
	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	/*sReplacementText = _T("Done!");
	((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));*/
	Invalidate(FALSE);
	
}

void CDocImAnView::On2Ab()
{
	//AB 
	int index = 1;
	if (GetDocument()->m_pUndoImage != NULL)
		{	
			while (GetDocument()->m_index > index)
			{
				delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
				GetDocument()->m_index--;
			}
			SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
		}
		//Sixth: create a new image and apply 2X Gauss + Sauvola
	
		/*CString sReplacementText = _T("Creating Niblack Image...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Creating Niblack Image... \n"));*/
	
		GetDocument()->CreateNewUndoImage(0);

		//CImage* niblackImage = new CImage;
		//niblackImage->CreateFromImage(GetDocument()->GetActiveImage());
		//GetDocument()->GetUndoImage(GetDocument()->m_index - 1)->CreateFromImage(GetDocument()->GetUndoImage(GetDocument()->m_index - 3));
		CRect rect;
		SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
		ApplyGaussianFilter(GetActiveImage());
		ApplyGaussianFilter(GetActiveImage());
		//ApplyGaussianFilter(GetDocument()->GetUndoImage(GetDocument()->m_index - 3));
		//ApplyGaussianFilter(GetDocument()->GetActiveImage());
		GetDocument()->CreateNewUndoImage(0);
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				rect.SetRect(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom);
				//niblackImage->Threshold_Niblack(5,rect,GetActiveImage(),2);	
				SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
				GetDocument()->GetUndoImage(GetDocument()->m_index - 2)->Threshold_Niblack(5,rect,GetActiveImage(),2);
			}
		}
		outputCleanImage();
		SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
		//Insert dlg 3
		DemoAB dlg3;
		if (IDOK == dlg3.DoModal())
		{
			GetActiveImage()->SetDirty(); 
			GetDocument()->UpdateAllViews(this,0L,NULL);

			Invalidate(FALSE);
		}
	//	




	//	GetDocument()->CreateNewUndoImage(0);

	//	
	//	GetDocument()->GetUndoImage(GetDocument()->m_index - 1)->CreateFromImage(GetDocument()->GetUndoImage(GetDocument()->m_index - 3));
	//	CRect rect;

	//	//ApplyGaussianFilter(GetDocument()->GetUndoImage(GetDocument()->m_index - 3));

	//	for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
	//	{
	//		for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
	//		{
	//			rect.SetRect(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom);
	//			//niblackImage->Threshold_Niblack(5,rect,GetActiveImage(),2);	
	//			GetDocument()->GetUndoImage(GetDocument()->m_index - 3)->Threshold_Niblack(5,rect,GetActiveImage(),2);
	//		}
	//	}
	//	SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
	//	outputCleanImage();
	//}
		//update the image
	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	/*sReplacementText = _T("Done!");
	((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));*/
	Invalidate(FALSE);
}

void CDocImAnView::On2Combination()
{
	int index = 1;
	if (GetDocument()->m_pUndoImage != NULL)
		{	if (GetDocument()->m_index != index)
			while (GetDocument()->m_index > index)
			{
				delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
				GetDocument()->m_index--;
			}
			SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
		}
		 index = GetDocument()->m_index;
		GetDocument()->CreateNewUndoImage();
		

		ApplyGaussianFilter(GetActiveImage());


		
		GetDocument()->CreateNewUndoImage(0);
		CDlgDIAHistograms::RANGE_VALS * ranges;
		ranges = new CDlgDIAHistograms::RANGE_VALS[3];

		ranges[0].firstVal = 0;
		ranges[0].lastVal = 0;
		ranges[0].colour = 0;

		ranges[1].firstVal = 1;
		ranges[1].lastVal =-1;
		ranges[1].colour = -1;
		

		CDlgDIAHistograms dlgHistogram;
		dlgHistogram.SetDocument(GetDocument());
		dlgHistogram.ApplyAdvancedThresholdToCharacters(GetDocument()->GetActiveImage(),ranges, 3);

	
		GetDocument()->GetActiveImage()->SetDirty();

	//Sixth: create a new image and apply 2X Gauss + Sauvola
	
		

		GetDocument()->CreateNewUndoImage(0);

		//CImage* niblackImage = new CImage;
		//niblackImage->CreateFromImage(GetDocument()->GetActiveImage());
		GetDocument()->GetUndoImage(GetDocument()->m_index - 1)->CreateFromImage(GetDocument()->GetUndoImage(GetDocument()->m_index - 3));
		CRect rect;

		ApplyGaussianFilter(GetDocument()->GetUndoImage(GetDocument()->m_index - 3));

		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				rect.SetRect(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom);
				//niblackImage->Threshold_Niblack(5,rect,GetActiveImage(),2);	
				GetDocument()->GetUndoImage(GetDocument()->m_index - 3)->Threshold_Niblack(5,rect,GetActiveImage(),2);
			}
		}
		//Compensation Mean
			

		GetDocument()->CreateNewUndoImage();

		int indexcompMean = GetDocument()->m_index - 1;
		int indexNiblack = GetDocument()->m_index - 2;
		int indexThres40 = GetDocument()->m_index - 3;
		for (int i = 0; i < GetDocument()->GetUndoImage(indexNiblack)->GetWidth(); i++)
		{
			for (int j = 0; j < GetDocument()->GetUndoImage(indexNiblack)->GetHeight(); j++)
			{
				int v1, v2, newvalue;
				v1 = (int) GetRValue(GetDocument()->GetUndoImage(indexThres40)->GetRGBColor(i,j));
				v2 = (int) GetRValue(GetDocument()->GetUndoImage(indexNiblack)->GetRGBColor(i,j));
				if (v1 != v2)
				{ 
					newvalue = AddValuesCompensationMean(v1, v2);
				}
				else 
					newvalue = v1;
				
				if (newvalue < 0) GetDocument()->GetUndoImage(indexcompMean)->SetRGBColor(i,j,RGB(128,128,128));
				GetDocument()->GetUndoImage(indexcompMean)->SetRGBColor(i,j,RGB(newvalue,newvalue,newvalue));
			}
		}

	//Localize Again
	outputCleanImage();
	b_isDemoFTR = true;
	LocateCharacters3(50,3);
	//Insert dlg 3
		DemoComb dlg3;
		if (IDOK == dlg3.DoModal())
		{
			GetActiveImage()->SetDirty(); 
			GetDocument()->UpdateAllViews(this,0L,NULL);

			Invalidate(FALSE);
		}
		
	Invalidate(FALSE);

	
}

void CDocImAnView::OnFtrdemoFtrdemo()
{
	//We want to do a complete enhacement
	//TIMING - TRACING
	CString sReplacementText = _T("Enhancing Image Flexible Text Recovery");
    ((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));

	TRACE(_T("*****Enhancing Image Flexible Text Recovery*****\n"));
	//Global_Timing(GLTM_START);
	//END TIMING
	//first: segment the image

		int index = GetDocument()->m_index;
		if (!GetDocument()->m_bIsPreprocessed)
		{
			TRACE(_T("Preprocess Image... \n"));
			sReplacementText = _T("Preprocess Image...");
			((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));

			PreprocessImage();
		}

			GetActiveImage()->SetDirty(); 
			GetDocument()->UpdateAllViews(this,0L,NULL);

			Invalidate(FALSE);
	//Insert dlg 1
			DemoSegStep11 dlg;
			if (IDOK == dlg.DoModal())
			{
				GetActiveImage()->SetDirty(); 
				GetDocument()->UpdateAllViews(this,0L,NULL);

				Invalidate(FALSE);
			}

		TRACE(_T("Segmentation: Perform Line Segmentation... \n"));
		//sReplacementText = _T("Segmentation: Performing Line Segmentation...");
		//((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
			
		PerformLineSegmentation(GetActiveImage());

		GetDocument()->m_bIsLineSegmented = true;
		DIASegmentation * seg;
		seg = new DIASegmentation;
		seg->m_pdoc = GetDocument();
		//characters are created in computeFixedWidthSegmentation2//
		sReplacementText = _T("Segmentation: Performing Character Segmentation...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Segmentation: Perform Character Segmentation... \n"));

		seg->ComputeFixedWidthSegmentation2(30);

		m_bViewIndividualCharacters = true;
		GetDocument()->m_IsCharSegmented = true;
		//GetDocument()->m_ShowFix = true;
		
		delete seg;
		//delete intermediate images

		if (GetDocument()->m_pUndoImage != NULL)
		{	
			while (GetDocument()->m_index > index)
			{
				delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
				GetDocument()->m_index--;
			}
			SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
		}
			//update the image
			GetActiveImage()->SetDirty(); 
			GetDocument()->UpdateAllViews(this,0L,NULL);
			sReplacementText = _T("Done!");
			((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
			Invalidate(FALSE);
			
		//Insert dlg 2
			DemoSegStep2 dlg2;
			if (IDOK == dlg2.DoModal())
			{
				GetActiveImage()->SetDirty(); 
				GetDocument()->UpdateAllViews(this,0L,NULL);

				Invalidate(FALSE);
			}
	//second: apply adaptive histogram stretching	
		index = GetDocument()->m_index;
		GetDocument()->CreateNewUndoImage();

		sReplacementText = _T("Segmentation: Applying Local Adaptive Histogram...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Segmentation: Applying Local Adaptive Histogram... \n"));

		ApplyAdaptiveHistogramMaxMin();

	

		sReplacementText = _T("Segmentation: Locate Characters in Boxes...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Segmentation: Locate Characters in Boxes... \n"));

		LocateCharacters3(128,3);

			GetActiveImage()->SetDirty(); 
			GetDocument()->UpdateAllViews(this,0L,NULL);
			sReplacementText = _T("Done!");
			((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
			Invalidate(FALSE);
			
		

		while (GetDocument()->m_index > index)
		{
			delete GetDocument()->m_pUndoImage[GetDocument()->m_index-1];
			GetDocument()->m_index--;
		}
		SetActiveImage(GetDocument()->m_pUndoImage[GetDocument()->m_index-1]);
	//Insert dlg 3
		DemoLoc dlg3;
		if (IDOK == dlg3.DoModal())
		{
			GetActiveImage()->SetDirty(); 
			GetDocument()->UpdateAllViews(this,0L,NULL);

			Invalidate(FALSE);
		}
	//Fourth: Smooth the image 
		index = GetDocument()->m_index;
		GetDocument()->CreateNewUndoImage();
		sReplacementText = _T("Enhancement: Smoothing Image (Gaussian)...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Enhancement: Smoothing Image (Gaussian)... \n"));

		ApplyGaussianFilter(GetActiveImage());

	////Fifth: apply Threshold40
	//	sReplacementText = _T("Enhancement: Applying Threshold40...");
	//	((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
	//	TRACE(_T("Enhancement: Applying Threshold40... \n"));

	//	ThresholdHighestVals();
		
		GetDocument()->CreateNewUndoImage(0);
		CDlgDIAHistograms::RANGE_VALS * ranges;
		ranges = new CDlgDIAHistograms::RANGE_VALS[3];

		ranges[0].firstVal = 0;
		ranges[0].lastVal = 0;
		ranges[0].colour = 0;

		ranges[1].firstVal = 1;
		ranges[1].lastVal =-1;
		ranges[1].colour = -1;
		

		CDlgDIAHistograms dlgHistogram;
		dlgHistogram.SetDocument(GetDocument());
		dlgHistogram.ApplyAdvancedThresholdToCharacters(GetDocument()->GetActiveImage(),ranges, 3);

	
		GetDocument()->GetActiveImage()->SetDirty();


		//Insert dlg 4
			DemoCT dlg4;
			if (IDOK == dlg4.DoModal())
			{
				GetActiveImage()->SetDirty(); 
				GetDocument()->UpdateAllViews(this,0L,NULL);

				Invalidate(FALSE);
			}
	//Sixth: create a new image and apply 2X Gauss + Sauvola
	
		sReplacementText = _T("Creating Niblack Image...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
		TRACE(_T("Creating Niblack Image... \n"));

		GetDocument()->CreateNewUndoImage(0);

		//CImage* niblackImage = new CImage;
		//niblackImage->CreateFromImage(GetDocument()->GetActiveImage());
		GetDocument()->GetUndoImage(GetDocument()->m_index - 1)->CreateFromImage(GetDocument()->GetUndoImage(GetDocument()->m_index - 3));
		CRect rect;

		ApplyGaussianFilter(GetDocument()->GetUndoImage(GetDocument()->m_index - 3));

		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				rect.SetRect(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.left,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.top,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_X + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.right,GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_Position_Y + GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_CharLocation.bottom);
				//niblackImage->Threshold_Niblack(5,rect,GetActiveImage(),2);	
				GetDocument()->GetUndoImage(GetDocument()->m_index - 3)->Threshold_Niblack(5,rect,GetActiveImage(),2);
			}
		}
		//Insert dlg 5
			DemoAB dlg5;
			if (IDOK == dlg5.DoModal())
			{
				GetActiveImage()->SetDirty(); 
				GetDocument()->UpdateAllViews(this,0L,NULL);

				Invalidate(FALSE);
			}
		//Compensation Mean
			TRACE(_T("Adding images Compensation Mean... \n"));
			sReplacementText = _T("Adding images Compensation Mean...");
			((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));

		GetDocument()->CreateNewUndoImage();

		int indexcompMean = GetDocument()->m_index - 1;
		int indexNiblack = GetDocument()->m_index - 2;
		int indexThres40 = GetDocument()->m_index - 3;
		for (int i = 0; i < GetDocument()->GetUndoImage(indexNiblack)->GetWidth(); i++)
		{
			for (int j = 0; j < GetDocument()->GetUndoImage(indexNiblack)->GetHeight(); j++)
			{
				int v1, v2, newvalue;
				v1 = (int) GetRValue(GetDocument()->GetUndoImage(indexThres40)->GetRGBColor(i,j));
				v2 = (int) GetRValue(GetDocument()->GetUndoImage(indexNiblack)->GetRGBColor(i,j));
				if (v1 != v2)
				{ 
					newvalue = AddValuesCompensationMean(v1, v2);
				}
				else 
					newvalue = v1;
				
				if (newvalue < 0) GetDocument()->GetUndoImage(indexcompMean)->SetRGBColor(i,j,RGB(128,128,128));
				GetDocument()->GetUndoImage(indexcompMean)->SetRGBColor(i,j,RGB(newvalue,newvalue,newvalue));
			}
		}
	
	//Localize Again
	//LocateCharacters2();
		LocateCharacters3(50,3);
		ClassifyCharacters2();
		GetDocument()->m_ShowInBox = true;
		CharacterAnalysis();
	//Extract Features
		sReplacementText = _T("Extracting Features...");
		((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
	
		ExtractCharacterFeatures();
	

	//Clean the background
	sReplacementText = _T("Cleaning the background...");
	((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));

	outputCleanImage();
	//Insert dlg 6
			DemoComb dlg6;
			if (IDOK == dlg6.DoModal())
			{
				GetActiveImage()->SetDirty(); 
				GetDocument()->UpdateAllViews(this,0L,NULL);

				Invalidate(FALSE);
			}
	//update the image
	GetActiveImage()->SetDirty(); 
	GetDocument()->UpdateAllViews(this,0L,NULL);
	sReplacementText = _T("FTR Done!");
	((CMainFrame*)AfxGetMainWnd())->StatusBarMessage(sReplacementText.GetBuffer(0));
	Invalidate(FALSE);
	GetDocument()->m_bIsImageImproved = true;

}

void CDocImAnView::OnFtrdemo0()
{
	GetDocument()->OnFileImportimage();
}

void CDocImAnView::OnRefinementdemoLocationofareasofuncertainty()
{
	
	//Find all uncertain areas
	if ((b_isDemoSeg) && (b_isDemoFTR))
	{
		for (int i = 0; i < GetDocument()->m_LineHolderIndex; i++)
		{
			for (int j = 0; j < GetDocument()->m_pLineHolder[i].m_CharacterHolderIndex; j++)
			{
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateCharImage(GetActiveImage(),false);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].CreateLocatedCharImage(GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].m_pCharImage,false);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindUncertValuablePoints();
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(1);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(100);
				GetDocument()->m_pLineHolder[i].m_pCharacterHolder[j].FindGreyNeighbToUncertainAreas(10);
			}
		}
		m_showGreenUncertain = 1;
		m_showPinkUncertain = 1;
		m_showGreypixels = 1;
		m_showOrangeUncertain = 1;
		m_bShowUncertainAreas = true;
	}
		GetActiveImage()->SetDirty(); 		
		GetDocument()->UpdateAllViews(this,0L,NULL);
		Invalidate(FALSE);
}

